/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Bitmaps.h"
#include "Display.h"
#include "Files.h"
#include "HandlerElems.h"
#include "Input.h"
#include "Oberon.h"
#include "PopupElems.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct BalloonElems_ElemDesc *BalloonElems_Elem;

typedef
	struct BalloonElems_ElemDesc { /* PopupElems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		CHAR name[32];
		Texts_Text menu;
		BOOLEAN small;
		INTEGER n, default_;
		char _prvt2[4];
		SET options;
	} BalloonElems_ElemDesc;

typedef
	struct BalloonElems_NodeDesc *BalloonElems_Node;

typedef
	struct BalloonElems_NodeDesc {
		CHAR key[32];
		LONGINT pos;
		BalloonElems_Node left, right;
	} BalloonElems_NodeDesc;


static LONGINT BalloonElems_icon;
static Display_Handler BalloonElems_SuperHandle;
static Texts_Text BalloonElems_stdDict;
static BalloonElems_Node BalloonElems_tree;
static Texts_Writer BalloonElems_w;
static BOOLEAN BalloonElems_enabled;

export LONGINT *BalloonElems_ElemDesc__typ;
export LONGINT *BalloonElems_NodeDesc__typ;

static void BalloonElems_Add (CHAR *key, LONGINT key__len, LONGINT pos);
export void BalloonElems_Alloc (void);
static void BalloonElems_Balance (void);
static BOOLEAN BalloonElems_CanBeWord (Display_Frame f, INTEGER x, INTEGER y);
export void BalloonElems_FrameHandler (Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
static void BalloonElems_GetBounds (Texts_Scanner *s, LONGINT *s__typ, Texts_Text t, LONGINT *beg, LONGINT *end);
static void BalloonElems_GetDict (Texts_Text t, Texts_Text *dict);
static void BalloonElems_GetName (Texts_Text ft, LONGINT pos, CHAR *name, LONGINT name__len, CHAR *fullName, LONGINT fullName__len, Texts_Text *t);
export void BalloonElems_Handle (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ);
static void BalloonElems_InitIcon (void);
export void BalloonElems_Insert (void);
export void BalloonElems_Install (void);
static void BalloonElems_InvertRect (TextFrames_Frame f, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
export void BalloonElems_LoadDictionary (void);
static void BalloonElems_MeasureLine (Texts_Reader *r, LONGINT *r__typ, INTEGER *lw, INTEGER *lh, INTEGER *dsr);
export void BalloonElems_Popup (Texts_Text t, LONGINT beg, LONGINT end, SET *keys);
static void BalloonElems_PrefixName (CHAR *name, LONGINT name__len, TextFrames_Frame f);
static void BalloonElems_Show (CHAR *nm, LONGINT nm__len, Texts_Text dict, BOOLEAN *done);
static void BalloonElems_ShowStd (CHAR *name, LONGINT name__len, BOOLEAN *done);
static void BalloonElems_TrackMouse (INTEGER *x, INTEGER *y, SET *keys, SET *keysum);
static BOOLEAN BalloonElems_TrackWord (TextFrames_Frame f, Oberon_InputMsg *m, LONGINT *m__typ);
static LONGINT BalloonElems_WordBeg (Texts_Text t, LONGINT pos);
static LONGINT BalloonElems_WordEnd (Texts_Text t, LONGINT pos);


void BalloonElems_Handle (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ)
{
	BalloonElems_Elem e1 = NIL;
	Texts_Buffer buf = NIL;
	TextFrames_Frame f = NIL;
	Viewers_Viewer v = NIL, v0 = NIL;
	INTEGER x = 0, y = 0;
	if (__ISP(e, BalloonElems_ElemDesc, 3)) {
		if (__IS(m__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *m__ = (void*)m;
			if ((*m__).e == NIL) {
				__NEW(e1, BalloonElems_ElemDesc);
				(*m__).e = (Texts_Elem)e1;
			}
			PopupElems_Handle((void*)(*(BalloonElems_Elem*)&e), (void*)&*m__, m__typ);
		} else if (__IS(m__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *m__ = (void*)m;
			__MOVE("BalloonElems", (*m__).mod, 13);
			__MOVE("Alloc", (*m__).proc, 6);
		} else if (__IS(m__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *m__ = (void*)m;
			if ((*m__).prepare) {
				(*(BalloonElems_Elem*)&e)->W = 13 * TextFrames_Unit;
				(*(BalloonElems_Elem*)&e)->H = (LONGINT)(TextFrames_menuH - 1) * (LONGINT)TextFrames_Unit;
			} else {
				(*(BalloonElems_Elem*)&e)->name[0] = 0x00;
				PopupElems_Handle((void*)(*(BalloonElems_Elem*)&e), (void*)&*m__, m__typ);
				Display_CopyPattern(15, BalloonElems_icon, (*m__).X0 + 2, (*m__).Y0 + 2, 1);
			}
		} else if (__IS(m__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *m__ = (void*)m;
			if ((*m__).keys == 0x02) {
				Texts_Delete((*(BalloonElems_Elem*)&e)->menu, 0, (*(BalloonElems_Elem*)&e)->menu->len);
				Texts_Write(&BalloonElems_w, Texts_Writer__typ, ' ');
				Texts_Append((*(BalloonElems_Elem*)&e)->menu, BalloonElems_w.buf);
				PopupElems_MeasureMenu((void*)(*(BalloonElems_Elem*)&e));
				Oberon_AllocateUserViewer(Oberon_Mouse.X, &x, &y);
				v0 = Viewers_This(x, y - 1);
				PopupElems_Handle((void*)(*(BalloonElems_Elem*)&e), (void*)&*m__, m__typ);
				v = Viewers_This(x, y - 1);
				Texts_Recall(&buf);
				if (v != v0) {
					f = __GUARDP(v->dsc->next, TextFrames_FrameDesc, 1);
					Texts_Delete(f->text, 0, 1);
					Texts_Append(f->text, buf);
					Texts_Save(f->text, 0, f->text->len, buf);
				}
				Texts_Delete((*(BalloonElems_Elem*)&e)->menu, 0, 1);
				Texts_Append((*(BalloonElems_Elem*)&e)->menu, buf);
				(*m__).keys = 0x0;
			}
		} else {
			PopupElems_Handle((void*)(*(BalloonElems_Elem*)&e), &*m, m__typ);
		}
	} else __WITHCHK;
}

void BalloonElems_Alloc (void)
{
	BalloonElems_Elem e = NIL;
	__NEW(e, BalloonElems_ElemDesc);
	e->handle = BalloonElems_Handle;
	Texts_new = (Texts_Elem)e;
}

void BalloonElems_Insert (void)
{
	BalloonElems_Elem e = NIL;
	TextFrames_InsertElemMsg insert = {0};
	__NEW(e, BalloonElems_ElemDesc);
	e->handle = BalloonElems_Handle;
	e->name[0] = 0x00;
	e->small = 1;
	e->menu = TextFrames_Text((CHAR*)"", (LONGINT)1);
	PopupElems_MeasureMenu((void*)e);
	insert.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&insert, TextFrames_InsertElemMsg__typ);
}

static void BalloonElems_Add (CHAR *key, LONGINT key__len, LONGINT pos)
{
	BalloonElems_Node p = NIL, q = NIL, father = NIL;
	__DUP(key, key__len, CHAR);
	p = BalloonElems_tree->right;
	father = BalloonElems_tree;
	while (p != NIL) {
		father = p;
		if (__STRCMP(key, p->key) < 0) {
			p = p->left;
		} else {
			p = p->right;
		}
	}
	__NEW(q, BalloonElems_NodeDesc);
	__COPY(key, q->key, 32);
	q->pos = pos;
	if (__STRCMP(key, father->key) < 0) {
		father->left = q;
	} else {
		father->right = q;
	}
	__DEL(key);
}

static struct Balance__3 {
	struct Balance__3 *lnk;
} *Balance__3_s;

static void Compress__4 (BalloonElems_Node root, INTEGER n);

static void Compress__4 (BalloonElems_Node root, INTEGER n)
{
	BalloonElems_Node p = NIL, son = NIL;
	INTEGER i = 0, _for__6 = 0;
	p = root;
	_for__6 = n;
	i = 1;
	while (i <= _for__6) {
		son = p->right;
		p->right = son->right;
		p = p->right;
		son->right = p->left;
		p->left = son;
		i += 1;
	}
}

static void BalloonElems_Balance (void)
{
	BalloonElems_Node p = NIL, tail = NIL, rest = NIL;
	INTEGER size = 0, n = 0, i = 0;
	struct Balance__3 _s;
	_s.lnk = Balance__3_s;
	Balance__3_s = &_s;
	tail = BalloonElems_tree;
	rest = tail->right;
	size = 0;
	while (rest != NIL) {
		if (rest->left == NIL) {
			tail = rest;
			rest = rest->right;
			size += 1;
		} else {
			p = rest->left;
			rest->left = p->right;
			p->right = rest;
			rest = p;
			tail->right = p;
		}
	}
	i = 1;
	while (i <= size + 1) {
		i = i + i;
	}
	n = __ASHR(i, 1) - 1;
	Compress__4(BalloonElems_tree, size - n);
	while (n > 1) {
		n = __ASHR(n, 1);
		Compress__4(BalloonElems_tree, n);
	}
	Balance__3_s = _s.lnk;
}

static void BalloonElems_InvertRect (TextFrames_Frame f, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	if (x + w > (f->X + f->W) - f->right) {
		w = ((f->X + f->W) - f->right) - x;
	}
	if (y >= f->Y + f->bot) {
		Display_ReplConst(15, x, y, w, h, 2);
	}
}

static void BalloonElems_TrackMouse (INTEGER *x, INTEGER *y, SET *keys, SET *keysum)
{
	Input_Mouse(&*keys, &*x, &*y);
	*keysum = *keysum | *keys;
	Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, *x, *y);
}

static BOOLEAN BalloonElems_CanBeWord (Display_Frame f, INTEGER x, INTEGER y)
{
	TextFrames_Frame tf = NIL;
	Texts_Reader r = {0};
	CHAR ch = 0;
	tf = __GUARDP(f, TextFrames_FrameDesc, 1);
	Texts_OpenReader(&r, Texts_Reader__typ, tf->text, TextFrames_Pos(tf, x, y));
	Texts_Read(&r, Texts_Reader__typ, &ch);
	return r.elem == NIL && x > tf->X + tf->barW;
}

static void BalloonElems_GetDict (Texts_Text t, Texts_Text *dict)
{
	Texts_Reader r = {0};
	Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
	Texts_ReadElem(&r, Texts_Reader__typ);
	while (r.elem != NIL && !__ISP(r.elem, BalloonElems_ElemDesc, 3)) {
		Texts_ReadElem(&r, Texts_Reader__typ);
	}
	if (r.elem != NIL) {
		*dict = __GUARDP(r.elem, BalloonElems_ElemDesc, 3)->menu;
	} else {
		*dict = NIL;
	}
}

static LONGINT BalloonElems_WordBeg (Texts_Text t, LONGINT pos)
{
	Texts_Reader r = {0};
	CHAR ch = 0;
	LONGINT pos0 = 0;
	pos0 = pos;
	Texts_OpenReader(&r, Texts_Reader__typ, t, pos);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	while ((__CAP(ch) >= 'A' && __CAP(ch) <= 'Z' || ch >= '0' && ch <= '9') || ch == '.') {
		pos -= 1;
		if (pos < 0) {
			return 0;
		}
		Texts_OpenReader(&r, Texts_Reader__typ, t, pos);
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
	if (pos < pos0) {
		pos += 1;
	}
	return pos;
}

static LONGINT BalloonElems_WordEnd (Texts_Text t, LONGINT pos)
{
	Texts_Reader r = {0};
	CHAR ch = 0;
	LONGINT pos0 = 0;
	pos0 = pos;
	Texts_OpenReader(&r, Texts_Reader__typ, t, pos);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	while ((__CAP(ch) >= 'A' && __CAP(ch) <= 'Z' || ch >= '0' && ch <= '9') || ch == '.') {
		pos += 1;
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
	if (pos == pos0) {
		pos += 1;
	}
	return pos;
}

static void BalloonElems_GetName (Texts_Text ft, LONGINT pos, CHAR *name, LONGINT name__len, CHAR *fullName, LONGINT fullName__len, Texts_Text *t)
{
	Texts_Reader r = {0};
	CHAR ch = 0;
	LONGINT beg = 0, end = 0;
	INTEGER i = 0, j = 0;
	BOOLEAN imported = 0;
	Texts_Text t0 = NIL;
	CHAR mod[32];
	beg = BalloonElems_WordBeg(ft, pos);
	end = BalloonElems_WordEnd(ft, pos);
	i = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, ft, beg);
	imported = 0;
	while (beg < end) {
		Texts_Read(&r, Texts_Reader__typ, &ch);
		name[__X(i, name__len)] = ch;
		i += 1;
		beg += 1;
		if (ch == '.') {
			imported = 1;
		}
	}
	name[__X(i, name__len)] = 0x00;
	__COPY(name, fullName, fullName__len);
	*t = ft;
	if (imported) {
		i = 0;
		while (name[__X(i, name__len)] != '.') {
			mod[__X(i, 32)] = name[__X(i, name__len)];
			i += 1;
		}
		mod[__X(i, 32)] = '.';
		mod[__X(i + 1, 32)] = 'M';
		mod[__X(i + 2, 32)] = 'o';
		mod[__X(i + 3, 32)] = 'd';
		mod[__X(i + 4, 32)] = 0x00;
		__NEW(t0, Texts_TextDesc);
		Texts_Open(t0, mod, 32);
		if (t0->len > 0) {
			*t = t0;
			j = 0;
			do {
				i += 1;
				name[__X(j, name__len)] = name[__X(i, name__len)];
				j += 1;
			} while (!(name[__X(i, name__len)] == 0x00));
		}
	}
}

static void BalloonElems_PrefixName (CHAR *name, LONGINT name__len, TextFrames_Frame f)
{
	Viewers_Viewer v = NIL;
	Texts_Scanner s = {0};
	INTEGER i = 0, j = 0;
	CHAR nm[64];
	v = Viewers_This(f->X, f->Y);
	Texts_OpenScanner(&s, Texts_Scanner__typ, __GUARDP(v->dsc, TextFrames_FrameDesc, 1)->text, 0);
	Texts_Scan(&s, Texts_Scanner__typ);
	if (s.class == 1 || s.class == 2) {
		__COPY(s.s, nm, 64);
		i = s.len - 1;
	} else {
		i = -1;
	}
	while (i >= 0 && nm[__X(i, 64)] != '.') {
		i -= 1;
	}
	i += 1;
	j = 0;
	while (i < 63 && name[__X(j, name__len)] != 0x00) {
		nm[__X(i, 64)] = name[__X(j, name__len)];
		i += 1;
		j += 1;
	}
	nm[__X(i, 64)] = 0x00;
	__COPY(nm, name, name__len);
}

static void BalloonElems_MeasureLine (Texts_Reader *r, LONGINT *r__typ, INTEGER *lw, INTEGER *lh, INTEGER *dsr)
{
	CHAR ch = 0;
	INTEGER x = 0, y = 0, w = 0, h = 0, dx = 0;
	LONGINT p = 0;
	Texts_Read(&*r, r__typ, &ch);
	*lw = 0;
	*lh = 0;
	*dsr = 0;
	while (!(*r).eot && ch != 0x0d) {
		if ((*r).elem != NIL) {
			h = (int)__DIV((*r).elem->H, (LONGINT)TextFrames_Unit);
			dx = (int)__DIV((*r).elem->W, (LONGINT)TextFrames_Unit);
			y = (*r).fnt->minY;
		} else {
			Display_GetChar((*r).fnt->raster, ch, &dx, &x, &y, &w, &h, &p);
			y += __ASHR((*r).fnt->height * (int)(*r).voff, 6);
		}
		if (y < *dsr) {
			*dsr = y;
		}
		if (y + h > *lh) {
			*lh = y + h;
		}
		*lw += dx;
		Texts_Read(&*r, r__typ, &ch);
	}
	*dsr = -*dsr;
	*lh = *lh + *dsr;
	if (ch == 0x0d && *lh == 0) {
		*lh = 10;
		*dsr = 0;
		*lw = 8;
	}
}

void BalloonElems_Popup (Texts_Text t, LONGINT beg, LONGINT end, SET *keys)
{
	Texts_Reader r = {0};
	CHAR ch = 0;
	INTEGER x = 0, y = 0, w = 0, h = 0, dx = 0, bx = 0, by = 0, bw = 0, bh = 0, lw = 0, i = 0, X = 0, Y = 0;
	Bitmaps_Bitmap b = NIL;
	LONGINT p = 0;
	INTEGER lh[128], dsr[128];
	Texts_Elem e = NIL;
	TextFrames_DisplayMsg dsp = {0};
	SET keys0 = 0;
	Input_Mouse(&keys0, &x, &y);
	bw = 0;
	bh = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, t, beg);
	i = 0;
	while (Texts_Pos(&r, Texts_Reader__typ) < end) {
		BalloonElems_MeasureLine(&r, Texts_Reader__typ, &lw, &lh[__X(i, 128)], &dsr[__X(i, 128)]);
		if (lw > bw) {
			bw = lw;
		}
		bh = bh + lh[__X(i, 128)];
		i += 1;
	}
	bw += 8;
	if (bw > Display_Width) {
		bw = Display_Width;
	}
	bh += 8;
	if (bh > Display_Height) {
		bh = Display_Height;
	}
	bx = x;
	if (bx + bw > Display_Width) {
		bx = Display_Width - bw;
	}
	by = y + 10;
	if (by + bh > Display_Height) {
		by = Display_Height - bh;
	}
	b = Bitmaps_New(bw, bh);
	Bitmaps_CopyBlock(Bitmaps_Disp, b, bx, by, bw, bh, 0, 0, 0);
	Display_ReplConst(15, bx, by, bw, bh, 0);
	Display_ReplConst(13, bx + 1, by + 1, bw - 2, bh - 2, 0);
	X = bx + 4;
	Y = (((by + bh) - 4) - lh[0]) + dsr[0];
	Texts_OpenReader(&r, Texts_Reader__typ, t, beg);
	i = 0;
	while (beg < end) {
		Texts_Read(&r, Texts_Reader__typ, &ch);
		beg += 1;
		if (ch == 0x0d) {
			i += 1;
			X = bx + 4;
			Y = ((Y - dsr[__X(i - 1, 128)]) - lh[__X(i, 128)]) + dsr[__X(i, 128)];
		} else if (r.elem != NIL) {
			e = r.elem;
			y = r.fnt->minY;
			dsp.prepare = 0;
			dsp.fnt = r.fnt;
			dsp.col = r.col;
			dsp.pos = beg - 1;
			dsp.frame = NIL;
			dsp.X0 = X;
			dsp.Y0 = Y + y;
			dsp.elemFrame = NIL;
			(*e->handle)(e, (void*)&dsp, TextFrames_DisplayMsg__typ);
			X += (int)__DIV(e->W, (LONGINT)TextFrames_Unit);
		} else {
			Display_GetChar(r.fnt->raster, ch, &dx, &x, &y, &w, &h, &p);
			y += __ASHR(r.fnt->height * (int)r.voff, 6);
			Display_CopyPattern(15, p, X + x, Y + y, 1);
			X = X + dx;
		}
	}
	*keys = 0x0;
	do {
		Input_Mouse(&keys0, &x, &y);
		*keys = *keys | keys0;
	} while (!(keys0 == 0x0));
	Bitmaps_CopyBlock(b, Bitmaps_Disp, 0, 0, bw, bh, bx, by, 0);
}

static void BalloonElems_GetBounds (Texts_Scanner *s, LONGINT *s__typ, Texts_Text t, LONGINT *beg, LONGINT *end)
{
	CHAR ch = 0;
	if (!(*s).eot) {
		*beg = Texts_Pos((void*)&*s, s__typ);
		Texts_Read((void*)&*s, s__typ, &ch);
		while ((!(*s).eot && ch <= ' ') && ch != 0x1c) {
			*beg += 1;
			Texts_Read((void*)&*s, s__typ, &ch);
		}
		*end = *beg;
		while (!(*s).eot && ch != '\"') {
			*end += 1;
			Texts_Read((void*)&*s, s__typ, &ch);
		}
		do {
			*end -= 1;
			Texts_OpenReader((void*)&*s, s__typ, t, *end);
			Texts_Read((void*)&*s, s__typ, &ch);
		} while (!(ch > ' ' || ch == 0x1c));
		*end += 1;
		if (*beg >= *end) {
			*beg = -1;
		}
	} else {
		*beg = -1;
	}
}

static void BalloonElems_Show (CHAR *nm, LONGINT nm__len, Texts_Text dict, BOOLEAN *done)
{
	Texts_Scanner s = {0};
	CHAR name[64];
	LONGINT beg = 0, end = 0;
	SET keys = 0;
	__DUP(nm, nm__len, CHAR);
	__COPY(nm, name, 64);
	Texts_OpenScanner(&s, Texts_Scanner__typ, dict, 0);
	do {
		Texts_Scan(&s, Texts_Scanner__typ);
	} while (!(s.eot || s.class == 2 && __STRCMP(s.s, name) == 0));
	BalloonElems_GetBounds(&s, Texts_Scanner__typ, dict, &beg, &end);
	if (beg >= 0) {
		BalloonElems_Popup(dict, beg, end, &keys);
	}
	*done = beg >= 0;
	__DEL(nm);
}

static void BalloonElems_ShowStd (CHAR *name, LONGINT name__len, BOOLEAN *done)
{
	BalloonElems_Node p = NIL;
	Texts_Scanner s = {0};
	LONGINT beg = 0, end = 0;
	SET keys = 0;
	__DUP(name, name__len, CHAR);
	if (BalloonElems_tree == NIL) {
		BalloonElems_LoadDictionary();
	}
	p = BalloonElems_tree->right;
	while (p != NIL && __STRCMP(p->key, name) != 0) {
		if (__STRCMP(name, p->key) < 0) {
			p = p->left;
		} else {
			p = p->right;
		}
	}
	if (p != NIL) {
		Texts_OpenScanner(&s, Texts_Scanner__typ, BalloonElems_stdDict, p->pos);
		BalloonElems_GetBounds(&s, Texts_Scanner__typ, BalloonElems_stdDict, &beg, &end);
		BalloonElems_Popup(BalloonElems_stdDict, beg, end, &keys);
	}
	*done = p != NIL;
	__DEL(name);
}

static BOOLEAN BalloonElems_TrackWord (TextFrames_Frame f, Oberon_InputMsg *m, LONGINT *m__typ)
{
	SET keys = 0;
	TextFrames_Location new = {0}, old = {0};
	Texts_Text dict = NIL, t = NIL;
	CHAR name[64], fullName[64];
	INTEGER x = 0, y = 0;
	BOOLEAN done = 0;
	TextFrames_LocateWord(f, x, y, &old, TextFrames_Location__typ);
	BalloonElems_InvertRect(f, old.x, old.y, old.dx, 2);
	(*m).keys = 0x0;
	done = 0;
	BalloonElems_TrackMouse(&x, &y, &keys, &(*m).keys);
	while ((keys != 0x0 && !__IN(2, keys)) && (*m).keys != 0x07) {
		TextFrames_LocateWord(f, x, y, &new, TextFrames_Location__typ);
		if (new.pos != old.pos) {
			BalloonElems_InvertRect(f, old.x, old.y, old.dx, 2);
			BalloonElems_InvertRect(f, new.x, new.y, new.dx, 2);
			old = new;
		}
		if (keys == 0x03) {
			BalloonElems_GetName(f->text, TextFrames_Pos(f, x, y), (void*)name, 64, (void*)fullName, 64, &t);
			BalloonElems_GetDict(t, &dict);
			done = 0;
			if (dict != NIL) {
				BalloonElems_Show(name, 64, dict, &done);
			}
			if (!done) {
				BalloonElems_ShowStd(fullName, 64, &done);
			}
			if (!done) {
				BalloonElems_PrefixName((void*)fullName, 64, f);
				BalloonElems_ShowStd(fullName, 64, &done);
			}
			(*m).keys = 0x07;
		}
		BalloonElems_TrackMouse(&x, &y, &keys, &(*m).keys);
	}
	BalloonElems_InvertRect(f, old.x, old.y, old.dx, 2);
	if ((*m).keys != 0x07) {
		(*m).keys &= ~__SETOF(2);
	}
	return done;
}

void BalloonElems_FrameHandler (Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ)
{
	BOOLEAN showed = 0;
	Oberon_InputMsg open = {0};
	SET oldKeys = 0;
	if (!BalloonElems_enabled) {
		(*BalloonElems_SuperHandle)(f, &*m, m__typ);
	} else {
		if (__ISP(f, TextFrames_FrameDesc, 1)) {
			if (__IS(m__typ, Oberon_InputMsg, 1)) {
				Oberon_InputMsg *m__ = (void*)m;
				if (((*m__).id == 1 && __IN(1, (*m__).keys)) && BalloonElems_CanBeWord((void*)(*(TextFrames_Frame*)&f), (*m__).X, (*m__).Y)) {
					oldKeys = (*m__).keys;
					showed = BalloonElems_TrackWord((*(TextFrames_Frame*)&f), &*m__, m__typ);
					if (!showed) {
						open.id = 1;
						open.keys = 0x02;
						open.X = (*m__).X;
						open.Y = (*m__).Y;
						open.keys = oldKeys;
						(*BalloonElems_SuperHandle)((void*)(*(TextFrames_Frame*)&f), (void*)&open, Oberon_InputMsg__typ);
					}
				} else {
					(*BalloonElems_SuperHandle)((void*)(*(TextFrames_Frame*)&f), (void*)&*m__, m__typ);
				}
			} else {
				(*BalloonElems_SuperHandle)((void*)(*(TextFrames_Frame*)&f), &*m, m__typ);
			}
		} else __WITHCHK;
	}
}

void BalloonElems_LoadDictionary (void)
{
	Texts_Scanner s = {0};
	__NEW(BalloonElems_tree, BalloonElems_NodeDesc);
	BalloonElems_tree->key[0] = 0x00;
	if (Files_Old((CHAR*)"Balloon.Text", (LONGINT)13) != NIL) {
		__NEW(BalloonElems_stdDict, Texts_TextDesc);
		Texts_Open(BalloonElems_stdDict, (CHAR*)"Balloon.Text", (LONGINT)13);
		Texts_OpenScanner(&s, Texts_Scanner__typ, BalloonElems_stdDict, 0);
		Texts_Scan(&s, Texts_Scanner__typ);
		while (!s.eot) {
			if (s.class == 2) {
				BalloonElems_Add(s.s, 256, Texts_Pos((void*)&s, Texts_Scanner__typ));
			}
			Texts_Scan(&s, Texts_Scanner__typ);
		}
		BalloonElems_Balance();
	}
	BalloonElems_enabled = 1;
}

void BalloonElems_Install (void)
{
	BalloonElems_LoadDictionary();
}

static void BalloonElems_InitIcon (void)
{
	SET line[9];
	line[8] = 0x0;
	line[7] = 0x7e;
	line[6] = 0x81;
	line[5] = 0x81;
	line[4] = 0x81;
	line[3] = 0x5e;
	line[2] = 0x60;
	line[1] = 0xc0;
	BalloonElems_icon = Display_NewPattern((void*)line, 9, 8, 8);
}

static void EnumPtrs(void (*P)(void*))
{
	P(BalloonElems_stdDict);
	P(BalloonElems_tree);
	__ENUMR(&BalloonElems_w, Texts_Writer__typ, 36, 1, P);
}

__TDESC(BalloonElems_ElemDesc, 1, 5) = {__TDFLDS("ElemDesc", 88), {0, 4, 12, 32, 68, -24}};
__TDESC(BalloonElems_NodeDesc, 1, 2) = {__TDFLDS("NodeDesc", 44), {36, 40, -12}};

export void *BalloonElems__init(void)
{
	__DEFMOD;
	__IMPORT(Bitmaps);
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(HandlerElems);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(PopupElems);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(BalloonElems, EnumPtrs);
	__REGCMD("Alloc", BalloonElems_Alloc);
	__REGCMD("Insert", BalloonElems_Insert);
	__REGCMD("Install", BalloonElems_Install);
	__REGCMD("LoadDictionary", BalloonElems_LoadDictionary);
	__INITYP(BalloonElems_ElemDesc, PopupElems_ElemDesc, 3);
	__INITYP(BalloonElems_NodeDesc, BalloonElems_NodeDesc, 0);
/* BEGIN */
	BalloonElems_InitIcon();
	BalloonElems_enabled = 0;
	HandlerElems_SetHandler((CHAR*)"BalloonElems.FrameHandler", (LONGINT)26, BalloonElems_FrameHandler, &BalloonElems_SuperHandle);
	Texts_OpenWriter(&BalloonElems_w, Texts_Writer__typ);
	__ENDMOD;
}
