/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "MenuViewers.h"
#include "OfrontOPM.h"
#include "OfrontOPS.h"
#include "OfrontOPT.h"
#include "OfrontOPV.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"


static Texts_Writer Browser_W;
static CHAR Browser_option;


static void Browser_Append (CHAR *d, LONGINT d__len, CHAR *s, LONGINT s__len);
static void Browser_GetArgs (Texts_Scanner *S, LONGINT *S__typ);
static void Browser_Ident (CHAR *name, LONGINT name__len, CHAR *first, LONGINT first__len);
static void Browser_Indent (INTEGER i);
static void Browser_Objects (OfrontOPT_Object obj, SET mode);
static void Browser_Option (Texts_Scanner *S, LONGINT *S__typ);
export void Browser_ShowDef (void);
static void Browser_WModule (OfrontOPS_Name name, Texts_Text T);
static void Browser_Wch (CHAR ch);
static void Browser_Wi (LONGINT i);
static void Browser_Wln (void);
static void Browser_Wmthd (OfrontOPT_Object obj);
static void Browser_Ws (CHAR *s, LONGINT s__len);
static void Browser_Wsign (OfrontOPT_Struct result, OfrontOPT_Object par);
static void Browser_Wstruct (OfrontOPT_Struct typ);
static void Browser_Wtype (OfrontOPT_Struct typ);


static void Browser_Ws (CHAR *s, LONGINT s__len)
{
	__DUP(s, s__len, CHAR);
	Texts_WriteString(&Browser_W, Texts_Writer__typ, s, s__len);
	__DEL(s);
}

static void Browser_Wch (CHAR ch)
{
	Texts_Write(&Browser_W, Texts_Writer__typ, ch);
}

static void Browser_Wi (LONGINT i)
{
	Texts_WriteInt(&Browser_W, Texts_Writer__typ, i, 0);
}

static void Browser_Wln (void)
{
	Texts_WriteLn(&Browser_W, Texts_Writer__typ);
}

static void Browser_Indent (INTEGER i)
{
	while (i > 0) {
		Browser_Wch(' ');
		Browser_Wch(' ');
		i -= 1;
	}
}

static void Browser_Wsign (OfrontOPT_Struct result, OfrontOPT_Object par)
{
	BOOLEAN paren = 0, res = 0, first = 0;
	first = 1;
	res = result != NIL && result != OfrontOPT_notyp;
	paren = res || par != NIL;
	if (paren) {
		Browser_Wch('(');
	}
	while (par != NIL) {
		if (!first) {
			Browser_Ws((CHAR*)"; ", (LONGINT)3);
		} else {
			first = 0;
		}
		if (Browser_option == 'x') {
			Browser_Wi(par->adr);
			Browser_Wch(' ');
		}
		if (par->mode == 2) {
			Browser_Ws((CHAR*)"VAR ", (LONGINT)5);
		}
		Browser_Ws(par->name, 32);
		Browser_Ws((CHAR*)": ", (LONGINT)3);
		Browser_Wtype(par->typ);
		par = par->link;
	}
	if (paren) {
		Browser_Wch(')');
	}
	if (res) {
		Browser_Ws((CHAR*)": ", (LONGINT)3);
		Browser_Wtype(result);
	}
}

static void Browser_Objects (OfrontOPT_Object obj, SET mode)
{
	LONGINT i = 0;
	INTEGER m = 0;
	SET s = 0;
	OfrontOPT_ConstExt ext = NIL;
	if (obj != NIL) {
		Browser_Objects(obj->left, mode);
		if (__IN(obj->mode, mode)) {
			switch (obj->mode) {
				case 3: 
					Browser_Indent(2);
					Browser_Ws(obj->name, 32);
					Browser_Ws((CHAR*)" = ", (LONGINT)4);
					switch (obj->typ->form) {
						case 2: 
							if (obj->conval->intval == 1) {
								Browser_Ws((CHAR*)"TRUE", (LONGINT)5);
							} else {
								Browser_Ws((CHAR*)"FALSE", (LONGINT)6);
							}
							break;
						case 3: 
							if (obj->conval->intval >= 32 && obj->conval->intval <= 126) {
								Browser_Wch('\"');
								Browser_Wch((CHAR)obj->conval->intval);
								Browser_Wch('\"');
							} else {
								i = __ASHR(obj->conval->intval, 4);
								if (i > 9) {
									Browser_Wch((CHAR)(55 + i));
								} else {
									Browser_Wch((CHAR)(48 + i));
								}
								i = __MASK(obj->conval->intval, -16);
								if (i > 9) {
									Browser_Wch((CHAR)(55 + i));
								} else {
									Browser_Wch((CHAR)(48 + i));
								}
								Browser_Wch('X');
							}
							break;
						case 4: case 5: case 6: 
							Browser_Wi(obj->conval->intval);
							break;
						case 9: 
							Browser_Wch('{');
							i = 0;
							s = obj->conval->setval;
							while (i <= 31) {
								if (__IN(i, s)) {
									Browser_Wi(i);
									s &= ~__SETOF(i);
									if (s != 0x0) {
										Browser_Ws((CHAR*)", ", (LONGINT)3);
									}
								}
								i += 1;
							}
							Browser_Wch('}');
							break;
						case 7: 
							Texts_WriteReal(&Browser_W, Texts_Writer__typ, obj->conval->realval, 16);
							break;
						case 8: 
							Texts_WriteLongReal(&Browser_W, Texts_Writer__typ, obj->conval->realval, 23);
							break;
						case 10: 
							Browser_Ws(*obj->conval->ext, 256);
							break;
						case 11: 
							Browser_Ws((CHAR*)"NIL", (LONGINT)4);
							break;
						default: __CASECHK;
					}
					Browser_Wch(';');
					Browser_Wln();
					break;
				case 5: 
					if (obj->name[0] != 0x00) {
						Browser_Indent(2);
						if (obj->typ->strobj == obj) {
							Browser_Wtype(obj->typ);
							Browser_Ws((CHAR*)" = ", (LONGINT)4);
							Browser_Wstruct(obj->typ);
						} else {
							Browser_Ws(obj->name, 32);
							Browser_Ws((CHAR*)" = ", (LONGINT)4);
							Browser_Wtype(obj->typ);
						}
						Browser_Wch(';');
						Browser_Wln();
					}
					break;
				case 1: 
					Browser_Indent(2);
					Browser_Ws(obj->name, 32);
					if (obj->vis == 2) {
						Browser_Ws((CHAR*)"-: ", (LONGINT)4);
					} else {
						Browser_Ws((CHAR*)": ", (LONGINT)3);
					}
					Browser_Wtype(obj->typ);
					Browser_Wch(';');
					Browser_Wln();
					break;
				case 7: case 9: case 10: 
					Browser_Indent(1);
					Browser_Ws((CHAR*)"PROCEDURE ", (LONGINT)11);
					if (obj->mode == 10) {
						Browser_Wch('+');
					} else if (obj->mode == 9) {
						Browser_Wch('-');
					}
					Browser_Ws(obj->name, 32);
					Browser_Wsign(obj->typ, obj->link);
					if (obj->mode == 9) {
						ext = obj->conval->ext;
						m = (int)(*ext)[0];
						i = 1;
						Browser_Ws((CHAR*)"  \"", (LONGINT)4);
						while (i <= (LONGINT)m) {
							Browser_Wch((*ext)[__X(i, 256)]);
							i += 1;
						}
						Browser_Wch('\"');
					}
					Browser_Wch(';');
					Browser_Wln();
					break;
				default: __CASECHK;
			}
		}
		Browser_Objects(obj->right, mode);
	}
}

static void Browser_Wmthd (OfrontOPT_Object obj)
{
	if (obj != NIL) {
		Browser_Wmthd(obj->left);
		if (obj->mode == 13 && (__STRCMP(obj->name, "@tproc") != 0 || Browser_option == 'x')) {
			Browser_Indent(3);
			Browser_Ws((CHAR*)"PROCEDURE (", (LONGINT)12);
			if (__STRCMP(obj->name, "@tproc") != 0) {
				if (obj->link->mode == 2) {
					Browser_Ws((CHAR*)"VAR ", (LONGINT)5);
				}
				Browser_Ws(obj->link->name, 32);
				Browser_Ws((CHAR*)": ", (LONGINT)3);
				Browser_Wtype(obj->link->typ);
			}
			Browser_Ws((CHAR*)") ", (LONGINT)3);
			Browser_Ws(obj->name, 32);
			Browser_Wsign(obj->typ, obj->link->link);
			Browser_Wch(';');
			if (Browser_option == 'x') {
				Browser_Indent(1);
				Browser_Ws((CHAR*)"(* methno: ", (LONGINT)12);
				Browser_Wi(__ASHR(obj->adr, 16));
				Browser_Ws((CHAR*)" *)", (LONGINT)4);
			}
			Browser_Wln();
		}
		Browser_Wmthd(obj->right);
	}
}

static struct Wstruct__19 {
	OfrontOPT_Struct *typ;
	struct Wstruct__19 *lnk;
} *Wstruct__19_s;

static void SysFlag__20 (void);

static void SysFlag__20 (void)
{
	if ((*Wstruct__19_s->typ)->sysflag != 0) {
		Browser_Wch('[');
		Browser_Wi((*Wstruct__19_s->typ)->sysflag);
		Browser_Ws((CHAR*)"] ", (LONGINT)3);
	}
}

static void Browser_Wstruct (OfrontOPT_Struct typ)
{
	OfrontOPT_Object fld = NIL;
	struct Wstruct__19 _s;
	_s.typ = &typ;
	_s.lnk = Wstruct__19_s;
	Wstruct__19_s = &_s;
	switch (typ->form) {
		case 0: 
			Browser_Ws((CHAR*)"Undef", (LONGINT)6);
			break;
		case 13: 
			Browser_Ws((CHAR*)"POINTER ", (LONGINT)9);
			SysFlag__20();
			Browser_Ws((CHAR*)"TO ", (LONGINT)4);
			Browser_Wtype(typ->BaseTyp);
			break;
		case 14: 
			Browser_Ws((CHAR*)"PROCEDURE ", (LONGINT)11);
			SysFlag__20();
			Browser_Wsign(typ->BaseTyp, typ->link);
			break;
		case 15: 
			switch (typ->comp) {
				case 2: 
					Browser_Ws((CHAR*)"ARRAY ", (LONGINT)7);
					SysFlag__20();
					Browser_Wi(typ->n);
					Browser_Ws((CHAR*)" OF ", (LONGINT)5);
					Browser_Wtype(typ->BaseTyp);
					break;
				case 3: 
					Browser_Ws((CHAR*)"ARRAY ", (LONGINT)7);
					SysFlag__20();
					Browser_Ws((CHAR*)"OF ", (LONGINT)4);
					Browser_Wtype(typ->BaseTyp);
					break;
				case 4: 
					Browser_Ws((CHAR*)"RECORD ", (LONGINT)8);
					SysFlag__20();
					if (typ->BaseTyp != NIL) {
						Browser_Wch('(');
						Browser_Wtype(typ->BaseTyp);
						Browser_Wch(')');
					}
					Browser_Wln();
					fld = typ->link;
					while (fld != NIL && fld->mode == 4) {
						if (Browser_option == 'x' || fld->name[0] != '@') {
							Browser_Indent(3);
							if (Browser_option == 'x') {
								Browser_Wi(fld->adr);
								Browser_Wch(' ');
							}
							Browser_Ws(fld->name, 32);
							if (fld->vis == 2) {
								Browser_Wch('-');
							}
							Browser_Ws((CHAR*)": ", (LONGINT)3);
							Browser_Wtype(fld->typ);
							Browser_Wch(';');
							Browser_Wln();
						}
						fld = fld->link;
					}
					Browser_Wmthd(typ->link);
					Browser_Indent(2);
					Browser_Ws((CHAR*)"END ", (LONGINT)5);
					if (Browser_option == 'x') {
						Browser_Indent(1);
						Browser_Ws((CHAR*)"(* size: ", (LONGINT)10);
						Browser_Wi(typ->size);
						Browser_Ws((CHAR*)" align: ", (LONGINT)9);
						Browser_Wi(typ->align);
						Browser_Ws((CHAR*)" nofm: ", (LONGINT)8);
						Browser_Wi(typ->n);
						Browser_Ws((CHAR*)" *)", (LONGINT)4);
					}
					break;
				default: __CASECHK;
			}
			break;
		default: __CASECHK;
	}
	Wstruct__19_s = _s.lnk;
}

static void Browser_Wtype (OfrontOPT_Struct typ)
{
	OfrontOPT_Object obj = NIL;
	obj = typ->strobj;
	if (obj->name[0] != 0x00) {
		if (typ->mno != 0) {
			Browser_Ws(OfrontOPT_GlbMod[__X(typ->mno, 64)]->name, 32);
			Browser_Wch('.');
		} else if (typ == OfrontOPT_bytetyp || typ == OfrontOPT_sysptrtyp) {
			Browser_Ws((CHAR*)"SYSTEM.", (LONGINT)8);
		} else if (obj->vis == 0) {
			Browser_Wch('#');
		}
		Browser_Ws(obj->name, 32);
	} else {
		if (Browser_option == 'x' && typ->ref > 255) {
			Browser_Wch('#');
			Browser_Wi(typ->ref - 255);
			Browser_Wch(' ');
		}
		Browser_Wstruct(typ);
	}
}

static struct WModule__8 {
	Texts_Text *T;
	LONGINT *beg, *end;
	struct WModule__8 *lnk;
} *WModule__8_s;

static void CheckHeader__9 (void);
static void Header__11 (CHAR *s, LONGINT s__len);

static void Header__11 (CHAR *s, LONGINT s__len)
{
	__DUP(s, s__len, CHAR);
	*WModule__8_s->beg = Browser_W.buf->len;
	Browser_Indent(1);
	Browser_Ws(s, s__len);
	Browser_Wln();
	*WModule__8_s->end = Browser_W.buf->len;
	__DEL(s);
}

static void CheckHeader__9 (void)
{
	LONGINT len = 0;
	len = (*WModule__8_s->T)->len;
	if (*WModule__8_s->end == Browser_W.buf->len) {
		Texts_Append(*WModule__8_s->T, Browser_W.buf);
		Texts_Delete(*WModule__8_s->T, len + *WModule__8_s->beg, len + *WModule__8_s->end);
	} else {
		Browser_Wln();
	}
}

static void Browser_WModule (OfrontOPS_Name name, Texts_Text T)
{
	INTEGER i = 0;
	LONGINT beg = 0, end = 0;
	BOOLEAN first = 0, done = 0;
	struct WModule__8 _s;
	OfrontOPS_Name name__copy;
	__DUPARR(name, OfrontOPS_Name);
	_s.T = &T;
	_s.beg = &beg;
	_s.end = &end;
	_s.lnk = WModule__8_s;
	WModule__8_s = &_s;
	OfrontOPT_Import((CHAR*)"@notself", name, &done);
	if (done) {
		Browser_Ws((CHAR*)"DEFINITION ", (LONGINT)12);
		Browser_Ws(name, 32);
		Browser_Wch(';');
		Browser_Wln();
		Browser_Wln();
		Header__11((CHAR*)"IMPORT", (LONGINT)7);
		i = 1;
		first = 1;
		while (i < (int)OfrontOPT_nofGmod) {
			if (first) {
				first = 0;
				Browser_Indent(2);
			} else {
				Browser_Ws((CHAR*)", ", (LONGINT)3);
			}
			Browser_Ws(OfrontOPT_GlbMod[__X(i, 64)]->name, 32);
			i += 1;
		}
		if (!first) {
			Browser_Wch(';');
			Browser_Wln();
		}
		CheckHeader__9();
		Header__11((CHAR*)"CONST", (LONGINT)6);
		Browser_Objects(OfrontOPT_GlbMod[0]->right, 0x08);
		CheckHeader__9();
		Header__11((CHAR*)"TYPE", (LONGINT)5);
		Browser_Objects(OfrontOPT_GlbMod[0]->right, 0x20);
		CheckHeader__9();
		Header__11((CHAR*)"VAR", (LONGINT)4);
		Browser_Objects(OfrontOPT_GlbMod[0]->right, 0x02);
		CheckHeader__9();
		Browser_Objects(OfrontOPT_GlbMod[0]->right, 0x0680);
		Browser_Wln();
		Browser_Ws((CHAR*)"END ", (LONGINT)5);
		Browser_Ws(name, 32);
		Browser_Wch('.');
		Browser_Wln();
		Texts_Append(T, Browser_W.buf);
	} else {
		Texts_WriteString(&Browser_W, Texts_Writer__typ, name, 32);
		Texts_WriteString(&Browser_W, Texts_Writer__typ, (CHAR*)" -- symbol file not found", (LONGINT)26);
		Texts_WriteLn(&Browser_W, Texts_Writer__typ);
		Texts_Append(Oberon_Log, Browser_W.buf);
	}
	WModule__8_s = _s.lnk;
}

static void Browser_GetArgs (Texts_Scanner *S, LONGINT *S__typ)
{
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_OpenScanner(&*S, S__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&*S, S__typ);
	if ((*S).line != 0 || (*S).class != 1) {
		Oberon_GetSelection(&text, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&*S, S__typ, text, beg);
			Texts_Scan(&*S, S__typ);
		}
	}
}

static void Browser_Option (Texts_Scanner *S, LONGINT *S__typ)
{
	Browser_option = 0x00;
	Texts_Scan(&*S, S__typ);
	if ((*S).class == 6 && (*S).c == '\\') {
		Texts_Scan(&*S, S__typ);
		if ((*S).class == 1) {
			Browser_option = (*S).s[0];
			Texts_Scan(&*S, S__typ);
		}
	}
}

static void Browser_Ident (CHAR *name, LONGINT name__len, CHAR *first, LONGINT first__len)
{
	INTEGER i = 0, j = 0;
	CHAR ch = 0;
	i = 0;
	while (name[__X(i, name__len)] != 0x00) {
		i += 1;
	}
	while (i >= 0 && name[__X(i, name__len)] != '/') {
		i -= 1;
	}
	i += 1;
	j = 0;
	ch = name[__X(i, name__len)];
	while (ch != '.' && ch != 0x00) {
		first[__X(j, first__len)] = ch;
		i += 1;
		j += 1;
		ch = name[__X(i, name__len)];
	}
	first[__X(j, first__len)] = 0x00;
}

static void Browser_Append (CHAR *d, LONGINT d__len, CHAR *s, LONGINT s__len)
{
	INTEGER i = 0, j = 0;
	CHAR ch = 0;
	__DUP(s, s__len, CHAR);
	i = 0;
	while (d[__X(i, d__len)] != 0x00) {
		i += 1;
	}
	j = 0;
	do {
		ch = s[__X(j, s__len)];
		d[__X(i, d__len)] = ch;
		i += 1;
		j += 1;
	} while (!(ch == 0x00));
	__DEL(s);
}

void Browser_ShowDef (void)
{
	Texts_Scanner S = {0};
	Texts_Reader dummyR = {0};
	Texts_Text T = NIL, dummyT = NIL;
	OfrontOPS_Name vname, name;
	MenuViewers_Viewer mV = NIL;
	INTEGER x = 0, y = 0;
	Browser_GetArgs(&S, Texts_Scanner__typ);
	if (S.class == 1) {
		Browser_Ident((void*)S.s, 256, (void*)name, 32);
		__COPY(name, vname, 32);
		Browser_Option(&S, Texts_Scanner__typ);
		Browser_Append((void*)vname, 32, (CHAR*)".Def", (LONGINT)5);
		T = TextFrames_Text((CHAR*)"", (LONGINT)1);
		Oberon_AllocateUserViewer(Oberon_Mouse.X, &x, &y);
		mV = MenuViewers_New((void*)TextFrames_NewMenu(vname, 32, (CHAR*)"System.Close  System.Copy  System.Grow  Edit.Search Edit.Store", (LONGINT)63), (void*)TextFrames_NewText(T, 0), TextFrames_menuH, x, y);
		__NEW(dummyT, Texts_TextDesc);
		Texts_Open(dummyT, (CHAR*)"", (LONGINT)1);
		Texts_OpenReader(&dummyR, Texts_Reader__typ, dummyT, 0);
		OfrontOPT_Init(name, 0x0);
		__MOVE("AvoidErr154", OfrontOPT_SelfName, 12);
		Browser_WModule(name, T);
		OfrontOPT_Close();
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&Browser_W, Texts_Writer__typ, 36, 1, P);
}


export void *Browser__init(void)
{
	__DEFMOD;
	__IMPORT(MenuViewers);
	__IMPORT(OfrontOPM);
	__IMPORT(OfrontOPS);
	__IMPORT(OfrontOPT);
	__IMPORT(OfrontOPV);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__REGMOD(Browser, EnumPtrs);
	__REGCMD("ShowDef", Browser_ShowDef);
/* BEGIN */
	OfrontOPT_typSize = OfrontOPV_TypSize;
	Texts_OpenWriter(&Browser_W, Texts_Writer__typ);
	__ENDMOD;
}
