/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Elems.h"
#include "Files.h"
#include "Fonts.h"
#include "GUtils.h"
#include "Input.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct ButtonElems_ElemDesc *ButtonElems_Elem;

typedef
	struct ButtonElems_ElemDesc { /* Elems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[8];
		BOOLEAN locked;
		CHAR caption[64];
	} ButtonElems_ElemDesc;



export LONGINT *ButtonElems_ElemDesc__typ;

static void ButtonElems_Draw (ButtonElems_Elem e, INTEGER x, INTEGER y, INTEGER color, Fonts_Font fnt, Display_Frame f, BOOLEAN pressed);
export void ButtonElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void ButtonElems_HandleAttrMsg (ButtonElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ);
export void ButtonElems_Init (ButtonElems_Elem e);
export void ButtonElems_Insert (void);
export void ButtonElems_New (void);
static void ButtonElems_Track (ButtonElems_Elem e, TextFrames_TrackMsg msg);


static void ButtonElems_Draw (ButtonElems_Elem e, INTEGER x, INTEGER y, INTEGER color, Fonts_Font fnt, Display_Frame f, BOOLEAN pressed)
{
	INTEGER h = 0, w = 0, diy = 0, dix = 0;
	h = GUtils_Unit(e->H, 1);
	w = GUtils_Unit(e->W, 1);
	GUtils_Area(f, 13, 0, x, y, w, h, GUtils_Unit(1, 0), 1, pressed);
	if (pressed) {
		diy = -1;
		dix = 1;
	} else {
		diy = 0;
		dix = 0;
	}
	if (h > GUtils_Unit(fnt->maxY - fnt->minY, 0)) {
		diy = (__ASHR(h, 1) - __ASHR(GUtils_Unit(fnt->minY + fnt->maxY, 0), 1)) + diy;
		GUtils_String(f, e->caption, 64, x + dix, y + diy, w - dix, fnt, color, 1, 1);
	}
}

static void ButtonElems_Track (ButtonElems_Elem e, TextFrames_TrackMsg msg)
{
	INTEGER X = 0, Y = 0, w = 0, h = 0;
	SET keysum = 0;
	Elems_ExecMsg exec = {0};
	BOOLEAN pressed = 0;
	Input_Mouse(&msg.keys, &X, &Y);
	if (msg.keys == 0x0) {
		pressed = 1;
	} else {
		pressed = 0;
		keysum = msg.keys;
		w = (int)__DIV(e->W, (LONGINT)TextFrames_Unit);
		h = (int)__DIV(e->H, (LONGINT)TextFrames_Unit);
		do {
			Input_Mouse(&msg.keys, &X, &Y);
			keysum = keysum | msg.keys;
			Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, X, Y);
			if (((X < msg.X0 || X > msg.X0 + w) || Y < msg.Y0) || Y > msg.Y0 + h) {
				if (pressed) {
					pressed = 0;
					ButtonElems_Draw(e, msg.X0, msg.Y0, msg.col, msg.fnt, msg.frame, 0);
				}
			} else if (!pressed) {
				pressed = 1;
				ButtonElems_Draw(e, msg.X0, msg.Y0, msg.col, msg.fnt, msg.frame, 1);
			}
		} while (!(msg.keys == 0x0));
		ButtonElems_Draw(e, msg.X0, msg.Y0, msg.col, msg.fnt, msg.frame, 0);
	}
	if (pressed && !__IN(0, keysum)) {
		exec.e = (Elems_Elem)e;
		exec.x = msg.X0;
		exec.y = msg.Y0;
		exec.f = msg.frame;
		exec.unload = __IN(2, keysum);
		(*e->handle)((void*)e, (void*)&exec, Elems_ExecMsg__typ);
	}
}

static void ButtonElems_HandleAttrMsg (ButtonElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ)
{
	Elems_Done = 1;
	if ((*msg).id == 1) {
		if (__STRCMP((*msg).name, "Caption") == 0) {
			(*msg).class = 2;
			__COPY(e->caption, (*msg).s, 256);
		} else {
			Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 2) {
		if (__STRCMP((*msg).name, "Caption") == 0) {
			if ((*msg).class == 2) {
				__COPY((*msg).s, e->caption, 64);
			}
		} else {
			Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 3) {
		Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		(*(*msg).enum_)((CHAR*)"Caption", (LONGINT)8, 2);
	} else {
		Elems_Handle((void*)e, (void*)&*msg, msg__typ);
	}
}

void ButtonElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	CHAR ch = 0;
	ButtonElems_Elem copy = NIL;
	if (__ISP(e, ButtonElems_ElemDesc, 3)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(2);
				ButtonElems_Draw((*(ButtonElems_Elem*)&e), (*msg__).X0, (*msg__).Y0, (*msg__).col, (*msg__).fnt, (*msg__).frame, 0);
			}
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			TextPrinter_PrintMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(1);
				ButtonElems_Draw((*(ButtonElems_Elem*)&e), (*msg__).X0, (*msg__).Y0, (*msg__).col, (*msg__).fnt, NIL, 0);
				GUtils_SetDevice(2);
			}
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *msg__ = (void*)msg;
			if ((*msg__).e == NIL) {
				__NEW(copy, ButtonElems_ElemDesc);
				(*msg__).e = (Texts_Elem)copy;
			} else {
				copy = __GUARDP((*msg__).e, ButtonElems_ElemDesc, 3);
			}
			Elems_CopyElem((void*)(*(ButtonElems_Elem*)&e), (void*)copy);
			__COPY((*(ButtonElems_Elem*)&e)->caption, copy->caption, 64);
			(*msg__).e = (Texts_Elem)copy;
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *msg__ = (void*)msg;
			__MOVE("ButtonElems", (*msg__).mod, 12);
			__MOVE("New", (*msg__).proc, 4);
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *msg__ = (void*)msg;
			Elems_Handle((void*)(*(ButtonElems_Elem*)&e), (void*)&*msg__, msg__typ);
			if ((*msg__).keys == 0x02) {
				ButtonElems_Track((*(ButtonElems_Elem*)&e), *msg__);
			}
		} else if (__IS(msg__typ, Elems_AttrMsg, 1)) {
			Elems_AttrMsg *msg__ = (void*)msg;
			ButtonElems_HandleAttrMsg((*(ButtonElems_Elem*)&e), &*msg__, msg__typ);
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *msg__ = (void*)msg;
			Elems_Handle((void*)(*(ButtonElems_Elem*)&e), (void*)&*msg__, msg__typ);
			if ((*msg__).id == 0) {
				Files_Read(&(*msg__).r, Files_Rider__typ, (void*)&ch);
				Files_ReadString(&(*msg__).r, Files_Rider__typ, (void*)(*(ButtonElems_Elem*)&e)->caption, 64);
			} else if ((*msg__).id == 1) {
				Files_Write(&(*msg__).r, Files_Rider__typ, 0x00);
				Files_WriteString(&(*msg__).r, Files_Rider__typ, (*(ButtonElems_Elem*)&e)->caption, 64);
			}
		} else {
			Elems_Handle((void*)(*(ButtonElems_Elem*)&e), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

void ButtonElems_Init (ButtonElems_Elem e)
{
	Elems_Init((void*)e);
	e->handle = ButtonElems_Handle;
	__MOVE("Button", e->caption, 7);
	e->W = 50 * TextFrames_Unit;
	e->H = (LONGINT)((Fonts_Default->maxY - Fonts_Default->minY) + 5) * (LONGINT)TextFrames_Unit;
}

void ButtonElems_New (void)
{
	ButtonElems_Elem e = NIL;
	__NEW(e, ButtonElems_ElemDesc);
	ButtonElems_Init(e);
	Texts_new = (Texts_Elem)e;
}

void ButtonElems_Insert (void)
{
	ButtonElems_Elem e = NIL;
	TextFrames_InsertElemMsg m = {0};
	Texts_Scanner s = {0};
	__NEW(e, ButtonElems_ElemDesc);
	ButtonElems_Init(e);
	Elems_GetPar((void*)e, &s, Texts_Scanner__typ);
	if (!s.eot && __IN(s.class, 0x06)) {
		__COPY(s.s, e->caption, 64);
	}
	m.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&m, TextFrames_InsertElemMsg__typ);
}

__TDESC(ButtonElems_ElemDesc, 1, 5) = {__TDFLDS("ElemDesc", 108), {0, 4, 12, 32, 36, -24}};

export void *ButtonElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Elems);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(GUtils);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(ButtonElems, 0);
	__REGCMD("Insert", ButtonElems_Insert);
	__REGCMD("New", ButtonElems_New);
	__INITYP(ButtonElems_ElemDesc, Elems_ElemDesc, 3);
/* BEGIN */
	__ENDMOD;
}
