/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Elems.h"
#include "Files.h"
#include "Fonts.h"
#include "GUtils.h"
#include "Input.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct CheckBoxElems_ElemDesc *CheckBoxElems_Elem;

typedef
	struct CheckBoxElems_ElemDesc { /* Elems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[8];
		BOOLEAN locked;
		BOOLEAN value;
	} CheckBoxElems_ElemDesc;



export LONGINT *CheckBoxElems_ElemDesc__typ;

static void CheckBoxElems_Draw (CheckBoxElems_Elem e, INTEGER x, INTEGER y, INTEGER color, Display_Frame f);
export void CheckBoxElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void CheckBoxElems_HandleAttrMsg (CheckBoxElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ);
export void CheckBoxElems_Init (CheckBoxElems_Elem e);
export void CheckBoxElems_Insert (void);
export void CheckBoxElems_New (void);
static void CheckBoxElems_Track (CheckBoxElems_Elem e, TextFrames_TrackMsg msg);


static void CheckBoxElems_Draw (CheckBoxElems_Elem e, INTEGER x, INTEGER y, INTEGER color, Display_Frame f)
{
	INTEGER h = 0, w = 0, i = 0, one = 0;
	h = GUtils_Unit(e->H, 1);
	w = GUtils_Unit(e->W, 1);
	one = GUtils_Unit(1, 0);
	GUtils_Area(f, 13, 0, x, y, w, h, GUtils_Unit(1, 0), 1, 1);
	if (e->value) {
		i = 1;
		while (i <= 2) {
			GUtils_Line(f, color, (x + i) + one, y + __ASHL(one, 1), (x + w) - 3 * one, ((y + h) - __ASHL(one, 1)) - i, 1);
			GUtils_Line(f, color, x + __ASHL(one, 1), (y + i) + one, ((x + w) - __ASHL(one, 1)) - i, (y + h) - 3 * one, 1);
			GUtils_Line(f, color, x + __ASHL(one, 1), ((y + h) - __ASHL(one, 1)) - i, ((x + w) - __ASHL(one, 1)) - i, y + __ASHL(one, 1), 1);
			GUtils_Line(f, color, (x + i) + one, (y + h) - 3 * one, (x + w) - 3 * one, (y + i) + one, 1);
			i += 1;
		}
	}
}

static void CheckBoxElems_HandleAttrMsg (CheckBoxElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ)
{
	Elems_Done = 1;
	if ((*msg).id == 1) {
		if (__STRCMP((*msg).name, "Value") == 0) {
			(*msg).class = 7;
			(*msg).b = e->value;
		} else {
			Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 2) {
		if (__STRCMP((*msg).name, "Value") == 0) {
			if ((*msg).class == 7) {
				e->value = (*msg).b;
			} else if ((*msg).class == 2) {
				if (__CAP((*msg).s[0]) == 'Y' || __CAP((*msg).s[0]) == 'T') {
					e->value = 1;
				} else if (__CAP((*msg).s[0]) == 'N' || __CAP((*msg).s[0]) == 'F') {
					e->value = 0;
				} else if (__CAP((*msg).s[0]) == 'S') {
					e->value = !e->value;
				}
			}
		} else {
			Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 3) {
		Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		(*(*msg).enum_)((CHAR*)"Value", (LONGINT)6, 7);
	} else {
		Elems_Handle((void*)e, (void*)&*msg, msg__typ);
	}
}

static void CheckBoxElems_Track (CheckBoxElems_Elem e, TextFrames_TrackMsg msg)
{
	INTEGER X = 0, Y = 0, w = 0, h = 0;
	SET keysum = 0;
	BOOLEAN isin = 0;
	Elems_ExecMsg exec = {0};
	keysum = 0x0;
	w = (int)__DIV(e->W, (LONGINT)TextFrames_Unit);
	h = (int)__DIV(e->H, (LONGINT)TextFrames_Unit);
	isin = 1;
	do {
		Input_Mouse(&msg.keys, &X, &Y);
		keysum = keysum | msg.keys;
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, X, Y);
		isin = ((X >= msg.X0 && X <= msg.X0 + w) && Y >= msg.Y0) && Y <= msg.Y0 + h;
	} while (!(msg.keys == 0x0 || __IN(0, msg.keys)));
	if (isin && msg.keys == 0x0) {
		e->value = !e->value;
		Elems_UpdateElem((void*)e);
		exec.e = (Elems_Elem)e;
		exec.x = msg.X0;
		exec.y = msg.Y0;
		exec.f = msg.frame;
		exec.unload = __IN(2, keysum);
		(*e->handle)((void*)e, (void*)&exec, Elems_ExecMsg__typ);
	}
}

void CheckBoxElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	CheckBoxElems_Elem copy = NIL;
	CHAR ch = 0;
	if (__ISP(E, CheckBoxElems_ElemDesc, 3)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(2);
				CheckBoxElems_Draw((*(CheckBoxElems_Elem*)&E), (*msg__).X0, (*msg__).Y0, (*msg__).col, (*msg__).frame);
			}
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			TextPrinter_PrintMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(1);
				CheckBoxElems_Draw((*(CheckBoxElems_Elem*)&E), (*msg__).X0, (*msg__).Y0, (*msg__).col, NIL);
				GUtils_SetDevice(2);
			}
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *msg__ = (void*)msg;
			if ((*msg__).e == NIL) {
				__NEW(copy, CheckBoxElems_ElemDesc);
				(*msg__).e = (Texts_Elem)copy;
			} else {
				copy = __GUARDP((*msg__).e, CheckBoxElems_ElemDesc, 3);
			}
			Elems_CopyElem((void*)(*(CheckBoxElems_Elem*)&E), (void*)copy);
			copy->value = (*(CheckBoxElems_Elem*)&E)->value;
			(*msg__).e = (Texts_Elem)copy;
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *msg__ = (void*)msg;
			__MOVE("CheckBoxElems", (*msg__).mod, 14);
			__MOVE("New", (*msg__).proc, 4);
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *msg__ = (void*)msg;
			Elems_Handle((void*)(*(CheckBoxElems_Elem*)&E), (void*)&*msg__, msg__typ);
			if ((*msg__).id == 0) {
				Files_Read(&(*msg__).r, Files_Rider__typ, (void*)&ch);
				Files_ReadBool(&(*msg__).r, Files_Rider__typ, &(*(CheckBoxElems_Elem*)&E)->value);
			} else if ((*msg__).id == 1) {
				Files_Write(&(*msg__).r, Files_Rider__typ, 0x00);
				Files_WriteBool(&(*msg__).r, Files_Rider__typ, (*(CheckBoxElems_Elem*)&E)->value);
			}
		} else if (__IS(msg__typ, Elems_AttrMsg, 1)) {
			Elems_AttrMsg *msg__ = (void*)msg;
			CheckBoxElems_HandleAttrMsg((*(CheckBoxElems_Elem*)&E), &*msg__, msg__typ);
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *msg__ = (void*)msg;
			Elems_Handle((void*)(*(CheckBoxElems_Elem*)&E), (void*)&*msg__, msg__typ);
			if ((*msg__).keys == 0x02) {
				CheckBoxElems_Track((*(CheckBoxElems_Elem*)&E), *msg__);
			}
		} else {
			Elems_Handle((void*)(*(CheckBoxElems_Elem*)&E), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

void CheckBoxElems_Init (CheckBoxElems_Elem e)
{
	Elems_Init((void*)e);
	e->handle = CheckBoxElems_Handle;
	e->H = (LONGINT)(Fonts_Default->maxY - Fonts_Default->minY) * (LONGINT)TextFrames_Unit;
	e->W = e->H;
}

void CheckBoxElems_New (void)
{
	CheckBoxElems_Elem e = NIL;
	__NEW(e, CheckBoxElems_ElemDesc);
	CheckBoxElems_Init(e);
	Texts_new = (Texts_Elem)e;
}

void CheckBoxElems_Insert (void)
{
	CheckBoxElems_Elem e = NIL;
	TextFrames_InsertElemMsg m = {0};
	Texts_Scanner s = {0};
	__NEW(e, CheckBoxElems_ElemDesc);
	CheckBoxElems_Init(e);
	Elems_GetPar((void*)e, &s, Texts_Scanner__typ);
	if (!s.eot && __IN(s.class, 0x06)) {
		e->value = __CAP(s.s[0]) == 'Y';
	}
	m.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&m, TextFrames_InsertElemMsg__typ);
}

__TDESC(CheckBoxElems_ElemDesc, 1, 5) = {__TDFLDS("ElemDesc", 44), {0, 4, 12, 32, 36, -24}};

export void *CheckBoxElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Elems);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(GUtils);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(CheckBoxElems, 0);
	__REGCMD("Insert", CheckBoxElems_Insert);
	__REGCMD("New", CheckBoxElems_New);
	__INITYP(CheckBoxElems_ElemDesc, Elems_ElemDesc, 3);
/* BEGIN */
	__ENDMOD;
}
