/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Bitmaps.h"
#include "Display.h"
#include "Elems.h"
#include "Files.h"
#include "GUtils.h"
#include "Input.h"
#include "Math.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct ColorElems_ElemDesc *ColorElems_Elem;

typedef
	struct ColorElems_ElemDesc { /* Elems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[8];
		BOOLEAN locked;
		INTEGER value, nrOfCols;
	} ColorElems_ElemDesc;


static INTEGER ColorElems_lines, ColorElems_table;

export LONGINT *ColorElems_ElemDesc__typ;

static void ColorElems_DrawColors (INTEGER x, INTEGER y);
static void ColorElems_DrawElem (ColorElems_Elem e, INTEGER x, INTEGER y, Display_Frame f, BOOLEAN pressed);
static void ColorElems_DrawElemColor (ColorElems_Elem e, INTEGER col, INTEGER x, INTEGER y, Display_Frame f);
static void ColorElems_DrawTable (INTEGER x, INTEGER y);
export void ColorElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void ColorElems_HandleAttrMsg (ColorElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ);
export void ColorElems_Init (ColorElems_Elem e);
export void ColorElems_Insert (void);
static void ColorElems_Invert (INTEGER x, INTEGER y, INTEGER w);
export void ColorElems_New (void);
static void ColorElems_Track (ColorElems_Elem e, TextFrames_TrackMsg msg);
static void ColorElems_TrackColors (ColorElems_Elem e, INTEGER *col, TextFrames_TrackMsg *msg, LONGINT *msg__typ);


static void ColorElems_DrawColors (INTEGER x, INTEGER y)
{
	INTEGER i = 0, j = 0, w = 0, _for__3 = 0, _for__2 = 0;
	w = __DIV(ColorElems_table, ColorElems_lines);
	_for__3 = ColorElems_lines - 1;
	i = 0;
	while (i <= _for__3) {
		_for__2 = ColorElems_lines - 1;
		j = 0;
		while (j <= _for__2) {
			GUtils_ReplConst(NIL, i * ColorElems_lines + j, x + j * w, y + ((ColorElems_lines - i) - 1) * w, w, w, 1);
			j += 1;
		}
		i += 1;
	}
}

static void ColorElems_DrawTable (INTEGER x, INTEGER y)
{
	GUtils_ReplConst(NIL, 13, (x - 4) + 1, (y - 4) + 1, ColorElems_table + 6, ColorElems_table + 6, 0);
	GUtils_Frame(NIL, 15, x - 4, y - 4, ColorElems_table + 8, ColorElems_table + 8, 1, 0);
	ColorElems_DrawColors(x, y);
}

static void ColorElems_DrawElemColor (ColorElems_Elem e, INTEGER col, INTEGER x, INTEGER y, Display_Frame f)
{
	INTEGER w = 0, h = 0, b = 0;
	b = GUtils_Unit(3, 0);
	w = GUtils_Unit(e->W, 1);
	h = GUtils_Unit(e->H, 1);
	GUtils_ReplConst(f, col, x + b, y + b, w - __ASHL(b, 1), h - __ASHL(b, 1), 1);
}

static void ColorElems_DrawElem (ColorElems_Elem e, INTEGER x, INTEGER y, Display_Frame f, BOOLEAN pressed)
{
	INTEGER w = 0, h = 0;
	w = GUtils_Unit(e->W, 1);
	h = GUtils_Unit(e->H, 1);
	GUtils_Area(f, 13, 0, x, y, w, h, GUtils_Unit(1, 0), 1, pressed);
	ColorElems_DrawElemColor(e, e->value, x, y, f);
}

static void ColorElems_Invert (INTEGER x, INTEGER y, INTEGER w)
{
	GUtils_Frame(NIL, 0, x, y, w, w, 2, 2);
}

static void ColorElems_TrackColors (ColorElems_Elem e, INTEGER *col, TextFrames_TrackMsg *msg, LONGINT *msg__typ)
{
	INTEGER ew = 0, eh = 0, mx = 0, my = 0, w = 0, cx = 0, cy = 0, ox = 0, oy = 0;
	BOOLEAN wasout = 0;
	SET keysum = 0;
	ew = (int)__DIV(e->W, (LONGINT)TextFrames_Unit);
	eh = (int)__DIV(e->H, (LONGINT)TextFrames_Unit);
	w = __DIV(ColorElems_table, ColorElems_lines);
	wasout = 1;
	keysum = 0x0;
	ox = -1;
	oy = -1;
	do {
		Input_Mouse(&(*msg).keys, &mx, &my);
		keysum = keysum | (*msg).keys;
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, mx, my);
		if (((mx >= (*msg).X && mx < (*msg).X + ColorElems_table) && my >= (*msg).Y) && my < (*msg).Y + ColorElems_table) {
			cx = __DIV(mx - (*msg).X, w) * w + (*msg).X;
			cy = __DIV(my - (*msg).Y, w) * w + (*msg).Y;
			if ((cx != ox || cy != oy) || wasout) {
				if (!wasout) {
					ColorElems_Invert(ox, oy, w);
				}
				wasout = 0;
				ox = cx;
				oy = cy;
				ColorElems_Invert(ox, oy, w);
				ColorElems_DrawElemColor(e, __DIV(mx - (*msg).X, w) + ((ColorElems_lines - __DIV(my - (*msg).Y, w)) - 1) * ColorElems_lines, (*msg).X0, (*msg).Y0, (*msg).frame);
			}
		} else if (!wasout) {
			ColorElems_DrawElemColor(e, e->value, (*msg).X0, (*msg).Y0, (*msg).frame);
			ColorElems_Invert(ox, oy, w);
			wasout = 1;
		}
	} while (!((*msg).keys == 0x0));
	if (!wasout) {
		if (!__IN(0, keysum)) {
			cx = __DIV(mx - (*msg).X, w);
			cy = __DIV(my - (*msg).Y, w);
			*col = cx + ((ColorElems_lines - cy) - 1) * ColorElems_lines;
		}
		(*msg).keys = keysum;
	} else if (((mx >= (*msg).X0 && mx <= (*msg).X0 + ew) && my >= (*msg).Y0) && my <= (*msg).Y0 + eh) {
		(*msg).keys = keysum;
		*col = e->value;
	} else {
		(*msg).keys = 0x07;
	}
}

static void ColorElems_Track (ColorElems_Elem e, TextFrames_TrackMsg msg)
{
	Bitmaps_Bitmap b = NIL;
	INTEGER w = 0, h = 0, color = 0;
	Elems_ExecMsg exec = {0};
	ColorElems_lines = (int)__ENTIER(Math_sqrt(e->nrOfCols));
	ColorElems_table = (10 + __ASHL(__MASK(ColorElems_lines, -16), 1)) * ColorElems_lines;
	w = (int)__DIV(e->W, (LONGINT)TextFrames_Unit);
	h = (int)__DIV(e->H, (LONGINT)TextFrames_Unit);
	msg.X = msg.X0 + 4;
	msg.Y = (msg.Y0 + h) + 4;
	if ((msg.X + ColorElems_table) + 8 > Display_Width) {
		msg.X = ((msg.X0 - ColorElems_table) - 4) + w;
	}
	if (((msg.Y0 + h) + ColorElems_table) + 8 > Display_Height) {
		msg.Y = ((msg.Y - ColorElems_table) - 8) - h;
	}
	b = Bitmaps_New(ColorElems_table + 8, ColorElems_table + 8);
	Bitmaps_CopyBlock(Bitmaps_Disp, b, msg.X - 4, msg.Y - 4, ColorElems_table + 8, ColorElems_table + 8, 0, 0, 0);
	ColorElems_DrawElem(e, msg.X0, msg.Y0, msg.frame, 1);
	ColorElems_DrawTable(msg.X, msg.Y);
	ColorElems_TrackColors(e, &color, &msg, TextFrames_TrackMsg__typ);
	Bitmaps_CopyBlock(b, Bitmaps_Disp, 0, 0, ColorElems_table + 8, ColorElems_table + 8, msg.X - 4, msg.Y - 4, 0);
	if (!__IN(0, msg.keys)) {
		e->value = color;
		ColorElems_DrawElem(e, msg.X0, msg.Y0, msg.frame, 0);
		exec.e = (Elems_Elem)e;
		exec.x = msg.X0;
		exec.y = msg.Y0;
		exec.unload = __IN(2, msg.keys);
		exec.f = msg.frame;
		(*e->handle)((void*)e, (void*)&exec, Elems_ExecMsg__typ);
	} else {
		ColorElems_DrawElem(e, msg.X0, msg.Y0, msg.frame, 0);
	}
}

static void ColorElems_HandleAttrMsg (ColorElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ)
{
	Elems_Done = 1;
	if ((*msg).id == 1) {
		if (__STRCMP((*msg).name, "Value") == 0) {
			(*msg).class = 3;
			(*msg).i = e->value;
		} else if (__STRCMP((*msg).name, "NrOfColors") == 0) {
			(*msg).class = 2;
			if (e->nrOfCols == 16) {
				__MOVE("16", (*msg).s, 3);
			} else {
				__MOVE("256", (*msg).s, 4);
			}
			(*msg).hasProps = 1;
		} else {
			Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 2) {
		if (__STRCMP((*msg).name, "Value") == 0) {
			if ((*msg).class == 3) {
				e->value = (int)(*msg).i;
			}
			if (e->value < 0 || e->value > 256) {
				e->value = 15;
			}
		} else if (__STRCMP((*msg).name, "NrOfColors") == 0) {
			if ((*msg).class == 3) {
				e->nrOfCols = (int)(*msg).i;
			} else if ((*msg).class == 2) {
				if ((*msg).s[0] == '1') {
					e->nrOfCols = 16;
				} else {
					e->nrOfCols = 256;
				}
			}
			if (e->nrOfCols != 16 && e->nrOfCols != 256) {
				e->nrOfCols = 16;
			}
		} else {
			Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 3) {
		Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		(*(*msg).enum_)((CHAR*)"Value", (LONGINT)6, 3);
		(*(*msg).enum_)((CHAR*)"NrOfColors", (LONGINT)11, 3);
	} else if ((*msg).id == 4) {
		if (__STRCMP((*msg).name, "NrOfColors") == 0) {
			(*(*msg).enum_)((CHAR*)"16", (LONGINT)3, 2);
			(*(*msg).enum_)((CHAR*)"256", (LONGINT)4, 2);
		}
	} else {
		Elems_Handle((void*)e, (void*)&*msg, msg__typ);
	}
}

void ColorElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	CHAR ch = 0;
	ColorElems_Elem copy = NIL;
	if (__ISP(e, ColorElems_ElemDesc, 3)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(2);
				ColorElems_DrawElem((*(ColorElems_Elem*)&e), (*msg__).X0, (*msg__).Y0, (*msg__).frame, 0);
			}
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			TextPrinter_PrintMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(1);
				ColorElems_DrawElem((*(ColorElems_Elem*)&e), (*msg__).X0, (*msg__).Y0, NIL, 0);
				GUtils_SetDevice(2);
			}
		} else if (__IS(msg__typ, Elems_AttrMsg, 1)) {
			Elems_AttrMsg *msg__ = (void*)msg;
			ColorElems_HandleAttrMsg((*(ColorElems_Elem*)&e), &*msg__, msg__typ);
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *msg__ = (void*)msg;
			if ((*msg__).e == NIL) {
				__NEW(copy, ColorElems_ElemDesc);
				(*msg__).e = (Texts_Elem)copy;
			} else {
				copy = __GUARDP((*msg__).e, ColorElems_ElemDesc, 3);
			}
			Elems_CopyElem((void*)(*(ColorElems_Elem*)&e), (void*)copy);
			copy->value = (*(ColorElems_Elem*)&e)->value;
			copy->nrOfCols = (*(ColorElems_Elem*)&e)->nrOfCols;
			(*msg__).e = (Texts_Elem)copy;
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *msg__ = (void*)msg;
			__MOVE("ColorElems", (*msg__).mod, 11);
			__MOVE("New", (*msg__).proc, 4);
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *msg__ = (void*)msg;
			Elems_Handle((void*)(*(ColorElems_Elem*)&e), (void*)&*msg__, msg__typ);
			if ((*msg__).id == 0) {
				Files_Read(&(*msg__).r, Files_Rider__typ, (void*)&ch);
				Files_ReadInt(&(*msg__).r, Files_Rider__typ, &(*(ColorElems_Elem*)&e)->value);
				Files_ReadInt(&(*msg__).r, Files_Rider__typ, &(*(ColorElems_Elem*)&e)->nrOfCols);
			} else if ((*msg__).id == 1) {
				Files_Write(&(*msg__).r, Files_Rider__typ, 0x00);
				Files_WriteInt(&(*msg__).r, Files_Rider__typ, (*(ColorElems_Elem*)&e)->value);
				Files_WriteInt(&(*msg__).r, Files_Rider__typ, (*(ColorElems_Elem*)&e)->nrOfCols);
			}
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *msg__ = (void*)msg;
			Elems_Handle((void*)(*(ColorElems_Elem*)&e), (void*)&*msg__, msg__typ);
			if ((*msg__).keys == 0x02) {
				ColorElems_Track((*(ColorElems_Elem*)&e), *msg__);
			}
		} else {
			Elems_Handle((void*)(*(ColorElems_Elem*)&e), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

void ColorElems_Init (ColorElems_Elem e)
{
	Elems_Init((void*)e);
	e->handle = ColorElems_Handle;
	e->value = 15;
	e->nrOfCols = 16;
	e->W = 20 * TextFrames_Unit;
	e->H = e->W;
}

void ColorElems_New (void)
{
	ColorElems_Elem e = NIL;
	__NEW(e, ColorElems_ElemDesc);
	ColorElems_Init(e);
	Texts_new = (Texts_Elem)e;
}

void ColorElems_Insert (void)
{
	ColorElems_Elem e = NIL;
	TextFrames_InsertElemMsg m = {0};
	Texts_Scanner s = {0};
	__NEW(e, ColorElems_ElemDesc);
	ColorElems_Init(e);
	Elems_GetPar((void*)e, &s, Texts_Scanner__typ);
	if (!s.eot && s.class == 3) {
		e->value = (int)s.i;
		Texts_Scan(&s, Texts_Scanner__typ);
		if (!s.eot && s.class == 3) {
			e->nrOfCols = (int)s.i;
		}
	}
	m.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&m, TextFrames_InsertElemMsg__typ);
}

__TDESC(ColorElems_ElemDesc, 1, 5) = {__TDFLDS("ElemDesc", 48), {0, 4, 12, 32, 36, -24}};

export void *ColorElems__init(void)
{
	__DEFMOD;
	__IMPORT(Bitmaps);
	__IMPORT(Display);
	__IMPORT(Elems);
	__IMPORT(Files);
	__IMPORT(GUtils);
	__IMPORT(Input);
	__IMPORT(Math);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(ColorElems, 0);
	__REGCMD("Insert", ColorElems_Insert);
	__REGCMD("New", ColorElems_New);
	__INITYP(ColorElems_ElemDesc, Elems_ElemDesc, 3);
/* BEGIN */
	__ENDMOD;
}
