/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Input.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	REAL Colors_Components[3];

typedef
	struct Colors_Color {
		Colors_Components rgb, hls;
		INTEGER nr;
	} Colors_Color;

typedef
	struct Colors_EditFrameDesc *Colors_EditFrame;

typedef
	struct Colors_EditFrameDesc { /* Display_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		INTEGER beg[4];
		Colors_Color col;
		BOOLEAN rgb;
	} Colors_EditFrameDesc;

typedef
	struct Colors_FrameDesc *Colors_Frame;

typedef
	struct Colors_FrameDesc { /* Display_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		INTEGER beg[256];
		INTEGER n;
	} Colors_FrameDesc;

typedef
	struct Colors_Msg { /* Display_FrameMsg */
		char _prvt0[1];
	} Colors_Msg;


static Texts_Writer Colors_w;
static Oberon_Task Colors_task;
static LONGINT Colors_grey[3];

export LONGINT *Colors_FrameDesc__typ;
export LONGINT *Colors_Color__typ;
export LONGINT *Colors_EditFrameDesc__typ;
export LONGINT *Colors_Msg__typ;

static void Colors_Activate (void);
static BOOLEAN Colors_Change (Colors_Color *col, LONGINT *col__typ);
static void Colors_Edit (Colors_Frame f, INTEGER x, INTEGER y, SET keys);
static void Colors_EditColor (INTEGER colNr, BOOLEAN rgb);
static void Colors_EditHLS (Colors_EditFrame f, INTEGER x, INTEGER y, SET keys);
static void Colors_EditRGB (Colors_EditFrame f, INTEGER x, INTEGER y, SET keys);
export void Colors_Get (void);
static void Colors_HandleEdit (Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
static void Colors_Handler (Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
static INTEGER Colors_Int (REAL v);
export void Colors_Load (void);
export void Colors_Open (void);
export void Colors_OpenHLS (void);
export void Colors_OpenRGB (void);
static void Colors_Scan (Texts_Scanner *s, LONGINT *s__typ);
export void Colors_Set (void);
static void Colors_Show (Colors_Frame f);
static void Colors_ShowHLS (Colors_EditFrame f);
static void Colors_ShowRGB (Colors_EditFrame f);
export void Colors_Store (void);
static void Colors_UpdateDisp (Colors_Color *col, LONGINT *col__typ);
static void Colors_UpdateHLS (Colors_Color *col, LONGINT *col__typ);
static void Colors_UpdateRGB (Colors_Color *col, LONGINT *col__typ);


static void Colors_UpdateRGB (Colors_Color *col, LONGINT *col__typ)
{
	REAL c = 0;
	INTEGER i = 0;
	i = 0;
	do {
		c = (*col).hls[0] + (i + 2) / (REAL)(REAL)3;
		while (c > (REAL)1) {
			c = c - (REAL)1;
		}
		if (c <   3.3333334e-001) {
			(*col).rgb[__X(i, 3)] = ((REAL)1 - (*col).hls[2]) * (*col).hls[1];
		} else if (c <=   5.0000000e-001) {
			(*col).rgb[__X(i, 3)] = (((REAL)1 - (*col).hls[2]) + ((c -   3.3333334e-001) * (REAL)6) * (*col).hls[2]) * (*col).hls[1];
		} else if (c <=   8.3333331e-001) {
			(*col).rgb[__X(i, 3)] = (*col).hls[1];
		} else {
			(*col).rgb[__X(i, 3)] = (((REAL)1 - (*col).hls[2]) + (((REAL)1 - c) * (REAL)6) * (*col).hls[2]) * (*col).hls[1];
		}
		i += 1;
	} while (!(i == 3));
}

static struct UpdateHLS__22 {
	struct UpdateHLS__22 *lnk;
} *UpdateHLS__22_s;

static REAL Max__23 (REAL x, REAL y);

static REAL Max__23 (REAL x, REAL y)
{
	if (x > y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static void Colors_UpdateHLS (Colors_Color *col, LONGINT *col__typ)
{
	REAL max = 0, min = 0;
	struct UpdateHLS__22 _s;
	_s.lnk = UpdateHLS__22_s;
	UpdateHLS__22_s = &_s;
	max = Max__23((*col).rgb[0], Max__23((*col).rgb[1], (*col).rgb[2]));
	min = -Max__23(-(*col).rgb[0], Max__23(-(*col).rgb[1], -(*col).rgb[2]));
	(*col).hls[0] = (REAL)0;
	(*col).hls[1] = max;
	(*col).hls[2] = (REAL)0;
	if (max > (REAL)0) {
		(*col).hls[2] = (max - min) / max;
		if ((*col).hls[2] > (REAL)0) {
			(*col).hls[0] = ((((max - (REAL)2 * min) + (*col).rgb[2]) - (*col).rgb[0]) + (*col).rgb[1]) / (REAL)((REAL)6 * (max - min));
			if ((*col).rgb[1] == max || (*col).rgb[2] == min) {
				(*col).hls[0] = (REAL)1 - (*col).hls[0];
			}
		}
	}
	UpdateHLS__22_s = _s.lnk;
}

static INTEGER Colors_Int (REAL v)
{
	return (int)__ENTIER((REAL)255 * v);
}

static void Colors_UpdateDisp (Colors_Color *col, LONGINT *col__typ)
{
	Display_SetColor((*col).nr, Colors_Int((*col).rgb[0]), Colors_Int((*col).rgb[1]), Colors_Int((*col).rgb[2]));
}

static BOOLEAN Colors_Change (Colors_Color *col, LONGINT *col__typ)
{
	INTEGER d[3];
	REAL v = 0;
	INTEGER i = 0;
	BOOLEAN change = 0;
	Display_GetColor((*col).nr, &d[0], &d[1], &d[2]);
	i = 0;
	change = 0;
	while (i < 3) {
		v = Colors_Int((*col).rgb[__X(i, 3)]);
		if (v != d[__X(i, 3)]) {
			change = 1;
			(*col).rgb[__X(i, 3)] = d[__X(i, 3)] / (REAL)(REAL)255;
		}
		i += 1;
	}
	if (change) {
		Colors_UpdateHLS(&*col, col__typ);
	}
	return change;
}

static void Colors_ShowRGB (Colors_EditFrame f)
{
	INTEGER x = 0, w = 0, r = 0, i = 0, h = 0;
	w = __ASHR(f->W, 2) + 1;
	r = f->W - __ASHL(w, 2);
	i = 0;
	x = 0;
	f->beg[__X(i, 4)] = x;
	Oberon_RemoveMarks(f->X, f->Y, f->W, f->H);
	while (i < 3) {
		h = (int)__ENTIER(f->H * f->col.rgb[__X(i, 3)]);
		r -= 1;
		if (r == 0) {
			w -= 1;
		}
		Display_ReplConst(i + 1, f->X + x, f->Y, w, h, 0);
		Display_ReplConst(0, f->X + x, f->Y + h, w, f->H - h, 0);
		x += w;
		i += 1;
		f->beg[__X(i, 4)] = x;
	}
	Display_ReplConst(f->col.nr, f->X + x, f->Y, f->W - x, f->H, 0);
}

static void Colors_ShowHLS (Colors_EditFrame f)
{
	INTEGER x = 0, w = 0, r = 0, i = 0, h = 0;
	w = __ASHR(f->W, 2);
	r = f->W - __ASHL(w, 2);
	i = 0;
	x = 0;
	w += 1;
	f->beg[__X(i, 4)] = x;
	Oberon_RemoveMarks(f->X, f->Y, f->W, f->H);
	while (i < 3) {
		h = (int)__ENTIER(f->H * f->col.hls[__X(i, 3)]);
		if (r == 0) {
			w -= 1;
		}
		Display_ReplPattern(15, Colors_grey[__X(__ASHL(__MASK(i, -2), 1), 3)], f->X + x, f->Y, w, h, 0);
		Display_ReplConst(0, f->X + x, f->Y + h, w, f->H - h, 0);
		x += w;
		i += 1;
		f->beg[__X(i, 4)] = x;
		r -= 1;
	}
	Display_ReplConst(f->col.nr, f->X + x, f->Y, f->W - x, f->H, 0);
}

static void Colors_EditRGB (Colors_EditFrame f, INTEGER x, INTEGER y, SET keys)
{
	Colors_Color backUp = {0};
	Colors_Msg m = {0};
	SET keySum = 0;
	REAL last = 0;
	INTEGER i = 0;
	keySum = keys;
	x = x - f->X;
	i = 1;
	backUp = f->col;
	while (i <= 3 && f->beg[__X(i, 4)] < x) {
		i += 1;
	}
	if (i <= 3) {
		i -= 1;
		last = (REAL)-1;
		do {
			Input_Mouse(&keys, &x, &y);
			keySum = keySum | keys;
			Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Mouse.marker, Oberon_Marker__typ, x, y);
			y = y - f->Y;
			if (y < 0) {
				y = 0;
			} else if (y > f->H) {
				y = f->H;
			}
			f->col.rgb[__X(i, 3)] = y / (REAL)f->H;
			if (f->col.rgb[__X(i, 3)] != last) {
				Colors_UpdateHLS(&f->col, Colors_Color__typ);
				Colors_UpdateDisp(&f->col, Colors_Color__typ);
				last = f->col.rgb[__X(i, 3)];
				Oberon_RemoveMarks(f->X, f->Y, f->W, f->H);
				Display_ReplConst(i + 1, f->X + f->beg[__X(i, 4)], f->Y, f->beg[__X(i + 1, 4)] - f->beg[__X(i, 4)], y, 0);
				Display_ReplConst(0, f->X + f->beg[__X(i, 4)], f->Y + y, f->beg[__X(i + 1, 4)] - f->beg[__X(i, 4)], f->H - y, 0);
				Viewers_Broadcast((void*)&m, Colors_Msg__typ);
			}
		} while (!(keys == 0x0));
		if (keySum != 0x04 || f->col.nr > 0 && f->col.nr < 4) {
			f->col = backUp;
			Colors_UpdateDisp(&backUp, Colors_Color__typ);
			Colors_ShowRGB(f);
		}
	}
}

static void Colors_EditHLS (Colors_EditFrame f, INTEGER x, INTEGER y, SET keys)
{
	Colors_Color backUp = {0};
	Colors_Msg m = {0};
	SET keySum = 0;
	REAL last = 0;
	INTEGER i = 0;
	keySum = keys;
	x = x - f->X;
	i = 1;
	backUp = f->col;
	while (i <= 3 && f->beg[__X(i, 4)] < x) {
		i += 1;
	}
	if (i <= 3) {
		i -= 1;
		last = (REAL)-1;
		do {
			Input_Mouse(&keys, &x, &y);
			keySum = keySum | keys;
			Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Mouse.marker, Oberon_Marker__typ, x, y);
			y = y - f->Y;
			if (y < 0) {
				y = 0;
			} else if (y > f->H) {
				y = f->H;
			}
			f->col.hls[__X(i, 3)] = y / (REAL)f->H;
			if (f->col.hls[__X(i, 3)] != last) {
				Colors_UpdateRGB(&f->col, Colors_Color__typ);
				Colors_UpdateDisp(&f->col, Colors_Color__typ);
				last = f->col.hls[__X(i, 3)];
				Oberon_RemoveMarks(f->X, f->Y, f->W, f->H);
				Display_ReplPattern(15, Colors_grey[__X(__ASHL(__MASK(i, -2), 1), 3)], f->X + f->beg[__X(i, 4)], f->Y, f->beg[__X(i + 1, 4)] - f->beg[__X(i, 4)], y, 0);
				Display_ReplConst(0, f->X + f->beg[__X(i, 4)], f->Y + y, f->beg[__X(i + 1, 4)] - f->beg[__X(i, 4)], f->H - y, 0);
				Viewers_Broadcast((void*)&m, Colors_Msg__typ);
			}
		} while (!(keys == 0x0));
		if (keySum != 0x04 || f->col.nr > 0 && f->col.nr < 4) {
			f->col = backUp;
			Colors_UpdateDisp(&backUp, Colors_Color__typ);
			Colors_ShowHLS(f);
		}
	}
}

static void Colors_HandleEdit (Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ)
{
	Colors_EditFrame frame = NIL;
	Colors_Components v;
	if (__ISP(f, Colors_EditFrameDesc, 1)) {
		if (__IS(m__typ, Oberon_InputMsg, 1)) {
			if (__IS(m__typ, Oberon_InputMsg, 1)) {
				Oberon_InputMsg *m__ = (void*)m;
				if ((*m__).id == 1) {
					if ((*m__).keys == 0x0) {
						Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Mouse.marker, Oberon_Marker__typ, (*m__).X, (*m__).Y);
					} else if ((*(Colors_EditFrame*)&f)->rgb) {
						Colors_EditRGB((*(Colors_EditFrame*)&f), (*m__).X, (*m__).Y, (*m__).keys);
					} else {
						Colors_EditHLS((*(Colors_EditFrame*)&f), (*m__).X, (*m__).Y, (*m__).keys);
					}
				}
			} else __WITHCHK;
		} else if (__IS(m__typ, Colors_Msg, 1) && Colors_Change(&(*(Colors_EditFrame*)&f)->col, Colors_Color__typ)) {
			if ((*(Colors_EditFrame*)&f)->rgb) {
				Colors_ShowRGB((*(Colors_EditFrame*)&f));
			} else {
				Colors_ShowHLS((*(Colors_EditFrame*)&f));
			}
		} else if (__IS(m__typ, Oberon_CopyMsg, 1)) {
			__NEW(frame, Colors_EditFrameDesc);
			__GUARDEQP(frame, Colors_EditFrameDesc) = *(*(Colors_EditFrame*)&f);
			__GUARDR(m, Oberon_CopyMsg, 1).F = (Display_Frame)frame;
		} else if (__IS(m__typ, MenuViewers_ModifyMsg, 1)) {
			if (__IS(m__typ, MenuViewers_ModifyMsg, 1)) {
				MenuViewers_ModifyMsg *m__ = (void*)m;
				(*(Colors_EditFrame*)&f)->Y = (*m__).Y;
				(*(Colors_EditFrame*)&f)->H = (*m__).H;
				if ((*(Colors_EditFrame*)&f)->rgb) {
					Colors_ShowRGB((*(Colors_EditFrame*)&f));
				} else {
					Colors_ShowHLS((*(Colors_EditFrame*)&f));
				}
			} else __WITHCHK;
		}
	} else __WITHCHK;
}

static void Colors_EditColor (INTEGER colNr, BOOLEAN rgb)
{
	Colors_EditFrame f = NIL;
	Viewers_Viewer v = NIL;
	Colors_Color col = {0};
	INTEGER x = 0, y = 0;
	BOOLEAN dummy = 0;
	col.nr = colNr;
	dummy = Colors_Change(&col, Colors_Color__typ);
	__NEW(f, Colors_EditFrameDesc);
	f->col = col;
	f->handle = Colors_HandleEdit;
	f->rgb = rgb;
	Oberon_AllocateSystemViewer(Oberon_Mouse.X, &x, &y);
	v = (Viewers_Viewer)MenuViewers_New((void*)TextFrames_NewMenu((CHAR*)"Color", (LONGINT)6, (CHAR*)"System.Close  System.Copy  System.Grow", (LONGINT)39), (void*)f, TextFrames_menuH, x, y);
	Texts_Write(&Colors_w, Texts_Writer__typ, ' ');
	Texts_WriteInt(&Colors_w, Texts_Writer__typ, colNr, 0);
	Texts_Insert(__GUARDP(v->dsc, TextFrames_FrameDesc, 1)->text, 5, Colors_w.buf);
}

static void Colors_Show (Colors_Frame f)
{
	INTEGER i = 0, r = 0, n = 0, w = 0, x = 0;
	n = f->n;
	w = __DIV(f->W, n);
	r = f->W - w * n;
	i = 0;
	x = 0;
	w += 1;
	while (i < n) {
		f->beg[__X(i, 256)] = x;
		if (r == 0) {
			w -= 1;
		}
		Display_ReplConst(i, f->X + x, f->Y, w, f->H, 0);
		x += w;
		i += 1;
		r -= 1;
	}
}

static void Colors_Edit (Colors_Frame f, INTEGER x, INTEGER y, SET keys)
{
	SET keySum = 0;
	INTEGER i = 0;
	keySum = keys;
	do {
		Input_Mouse(&keys, &x, &y);
		keySum = keySum | keys;
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Mouse.marker, Oberon_Marker__typ, x, y);
	} while (!(keys == 0x0));
	if (keySum == 0x04 || keySum == 0x01) {
		i = 1;
		x = x - f->X;
		while (i < f->n && f->beg[__X(i, 256)] < x) {
			i += 1;
		}
		Colors_EditColor(i - 1, keySum == 0x04);
	}
}

static void Colors_Handler (Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ)
{
	Colors_Frame frame = NIL;
	if (__ISP(f, Colors_FrameDesc, 1)) {
		if (__IS(m__typ, Oberon_InputMsg, 1)) {
			if (__IS(m__typ, Oberon_InputMsg, 1)) {
				Oberon_InputMsg *m__ = (void*)m;
				if ((*m__).id == 1) {
					if ((*m__).keys == 0x0) {
						Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Mouse.marker, Oberon_Marker__typ, (*m__).X, (*m__).Y);
					} else {
						Colors_Edit((*(Colors_Frame*)&f), (*m__).X, (*m__).Y, (*m__).keys);
					}
				}
			} else __WITHCHK;
		} else if (__IS(m__typ, Oberon_CopyMsg, 1)) {
			__NEW(frame, Colors_FrameDesc);
			__GUARDEQP(frame, Colors_FrameDesc) = *(*(Colors_Frame*)&f);
			__GUARDR(m, Oberon_CopyMsg, 1).F = (Display_Frame)frame;
		} else if (__IS(m__typ, MenuViewers_ModifyMsg, 1)) {
			if (__IS(m__typ, MenuViewers_ModifyMsg, 1)) {
				MenuViewers_ModifyMsg *m__ = (void*)m;
				(*(Colors_Frame*)&f)->Y = (*m__).Y;
				(*(Colors_Frame*)&f)->H = (*m__).H;
				Colors_Show((*(Colors_Frame*)&f));
			} else __WITHCHK;
		}
	} else __WITHCHK;
}

void Colors_Open (void)
{
	Texts_Scanner s = {0};
	Colors_Frame f = NIL;
	Viewers_Viewer v = NIL;
	INTEGER x = 0, y = 0, n = 0;
	Texts_OpenScanner(&s, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&s, Texts_Scanner__typ);
	if (s.class == 3) {
		n = (int)s.i;
	} else {
		n = 16;
	}
	Oberon_AllocateSystemViewer(Oberon_Mouse.X, &x, &y);
	__NEW(f, Colors_FrameDesc);
	f->handle = Colors_Handler;
	f->n = n;
	v = (Viewers_Viewer)MenuViewers_New((void*)TextFrames_NewMenu((CHAR*)"Colors", (LONGINT)7, (CHAR*)"System.Close  System.Copy  System.Grow", (LONGINT)39), (void*)f, TextFrames_menuH, x, y);
}

void Colors_OpenRGB (void)
{
	Texts_Scanner s = {0};
	Texts_OpenScanner(&s, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&s, Texts_Scanner__typ);
	if (s.class == 3) {
		Colors_EditColor((int)s.i, 1);
	}
}

void Colors_OpenHLS (void)
{
	Texts_Scanner s = {0};
	Texts_OpenScanner(&s, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&s, Texts_Scanner__typ);
	if (s.class == 3) {
		Colors_EditColor((int)s.i, 0);
	}
}

static void Colors_Scan (Texts_Scanner *s, LONGINT *s__typ)
{
	Texts_Text T = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_OpenScanner(&*s, s__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&*s, s__typ);
	if ((*s).class == 6 && (*s).c == '^' || (*s).line != 0) {
		Oberon_GetSelection(&T, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&*s, s__typ, T, beg);
			Texts_Scan(&*s, s__typ);
		}
	}
}

void Colors_Set (void)
{
	Texts_Scanner s = {0};
	INTEGER v[4];
	INTEGER i = 0;
	Colors_Scan(&s, Texts_Scanner__typ);
	i = 0;
	while (s.class == 3 && i < 4) {
		v[__X(i, 4)] = (int)s.i;
		Texts_Scan(&s, Texts_Scanner__typ);
		i += 1;
	}
	if (i == 4) {
		Display_SetColor(v[0], v[1], v[2], v[3]);
	}
}

void Colors_Get (void)
{
	Texts_Scanner s = {0};
	INTEGER v[4];
	INTEGER i = 0;
	Colors_Scan(&s, Texts_Scanner__typ);
	if (s.class == 3) {
		v[0] = (int)s.i;
		Display_GetColor(v[0], &v[1], &v[2], &v[3]);
		i = 0;
		while (i < 4) {
			Texts_WriteInt(&Colors_w, Texts_Writer__typ, v[__X(i, 4)], 5);
			i += 1;
		}
		Texts_WriteLn(&Colors_w, Texts_Writer__typ);
		Texts_Append(Oberon_Log, Colors_w.buf);
	}
}

void Colors_Load (void)
{
	Oberon_ParList par = NIL;
	Texts_Scanner S = {0};
	Files_File f = NIL;
	Files_Rider R = {0};
	SHORTINT col = 0;
	CHAR red = 0, green = 0, blue = 0;
	Texts_WriteString(&Colors_w, Texts_Writer__typ, (CHAR*)"Colors.Load ", (LONGINT)13);
	par = Oberon_Par;
	Texts_OpenScanner(&S, Texts_Scanner__typ, par->text, par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 1) {
		Texts_WriteString(&Colors_w, Texts_Writer__typ, S.s, 256);
		f = Files_Old(S.s, 256);
		if (f != NIL) {
			Files_Set(&R, Files_Rider__typ, f, 0);
			col = -1;
			do {
				Files_Read(&R, Files_Rider__typ, (void*)&red);
				Files_Read(&R, Files_Rider__typ, (void*)&green);
				Files_Read(&R, Files_Rider__typ, (void*)&blue);
				Display_SetColor(col, (int)red, (int)green, (int)blue);
				col += 1;
			} while (!(col == 16));
		} else {
			Texts_WriteString(&Colors_w, Texts_Writer__typ, (CHAR*)" not found", (LONGINT)11);
		}
	} else {
		Texts_WriteString(&Colors_w, Texts_Writer__typ, (CHAR*)" no name", (LONGINT)9);
	}
	Texts_WriteLn(&Colors_w, Texts_Writer__typ);
	Texts_Append(Oberon_Log, Colors_w.buf);
}

void Colors_Store (void)
{
	Oberon_ParList par = NIL;
	Texts_Scanner S = {0};
	Files_File f = NIL;
	Files_Rider R = {0};
	INTEGER col = 0, red = 0, green = 0, blue = 0;
	Texts_WriteString(&Colors_w, Texts_Writer__typ, (CHAR*)"Colors.Store ", (LONGINT)14);
	par = Oberon_Par;
	Texts_OpenScanner(&S, Texts_Scanner__typ, par->text, par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 1) {
		Texts_WriteString(&Colors_w, Texts_Writer__typ, S.s, 256);
		f = Files_New(S.s, 256);
		Files_Set(&R, Files_Rider__typ, f, 0);
		if (f != NIL) {
			col = -1;
			do {
				Display_GetColor(col, &red, &green, &blue);
				Files_Write(&R, Files_Rider__typ, (CHAR)red);
				Files_Write(&R, Files_Rider__typ, (CHAR)green);
				Files_Write(&R, Files_Rider__typ, (CHAR)blue);
				col += 1;
			} while (!(col == 16));
			Files_Register(f);
		} else {
			Texts_WriteString(&Colors_w, Texts_Writer__typ, (CHAR*)" no space", (LONGINT)10);
		}
	} else {
		Texts_WriteString(&Colors_w, Texts_Writer__typ, (CHAR*)" no name", (LONGINT)9);
	}
	Texts_WriteLn(&Colors_w, Texts_Writer__typ);
	Texts_Append(Oberon_Log, Colors_w.buf);
}

static void Colors_Activate (void)
{
	Colors_Msg m = {0};
	Viewers_Broadcast((void*)&m, Colors_Msg__typ);
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&Colors_w, Texts_Writer__typ, 36, 1, P);
	P(Colors_task);
}

__TDESC(Colors_FrameDesc, 1, 2) = {__TDFLDS("FrameDesc", 536), {0, 4, -12}};
__TDESC(Colors_Color, 1, 0) = {__TDFLDS("Color", 28), {-4}};
__TDESC(Colors_EditFrameDesc, 1, 2) = {__TDFLDS("EditFrameDesc", 60), {0, 4, -12}};
__TDESC(Colors_Msg, 1, 0) = {__TDFLDS("Msg", 1), {-4}};

export void *Colors__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Input);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(Colors, EnumPtrs);
	__REGCMD("Get", Colors_Get);
	__REGCMD("Load", Colors_Load);
	__REGCMD("Open", Colors_Open);
	__REGCMD("OpenHLS", Colors_OpenHLS);
	__REGCMD("OpenRGB", Colors_OpenRGB);
	__REGCMD("Set", Colors_Set);
	__REGCMD("Store", Colors_Store);
	__INITYP(Colors_FrameDesc, Display_FrameDesc, 1);
	__INITYP(Colors_Color, Colors_Color, 0);
	__INITYP(Colors_EditFrameDesc, Display_FrameDesc, 1);
	__INITYP(Colors_Msg, Display_FrameMsg, 1);
/* BEGIN */
	Texts_OpenWriter(&Colors_w, Texts_Writer__typ);
	__NEW(Colors_task, Oberon_TaskDesc);
	Colors_task->handle = Colors_Activate;
	Colors_task->safe = 0;
	Colors_task->time = -1;
	Oberon_Install(Colors_task);
	Colors_grey[0] = Display_grey0;
	Colors_grey[1] = Display_grey1;
	Colors_grey[2] = Display_grey2;
	__ENDMOD;
}
