/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Kernel.h"
#include "Modules.h"
#include "Oberon.h"
#include "OfrontOPB.h"
#include "OfrontOPC.h"
#include "OfrontOPM.h"
#include "OfrontOPP.h"
#include "OfrontOPT.h"
#include "OfrontOPV.h"
#include "Out.h"
#include "Texts.h"


export CHAR Compiler_cl[128];


static void Compiler_Append (CHAR *s, LONGINT s__len, INTEGER *len, CHAR *x, LONGINT x__len);
export void Compiler_Compile (void);
static void Compiler_GetClCmd (BOOLEAN main, CHAR *clCmd, LONGINT clCmd__len);
static void Compiler_LinkImports (OfrontOPT_Object obj, CHAR *clCmd, LONGINT clCmd__len, INTEGER *len);
export void Compiler_Module (BOOLEAN *done);
export void Compiler_SetCL (void);
export void Compiler_ShowCL (void);


static void Compiler_Append (CHAR *s, LONGINT s__len, INTEGER *len, CHAR *x, LONGINT x__len)
{
	INTEGER i = 0;
	__DUP(x, x__len, CHAR);
	i = 0;
	while (x[__X(i, x__len)] != 0x00) {
		s[__X(*len, s__len)] = x[__X(i, x__len)];
		*len += 1;
		i += 1;
	}
	s[__X(*len, s__len)] = 0x00;
	__DEL(x);
}

static void Compiler_LinkImports (OfrontOPT_Object obj, CHAR *clCmd, LONGINT clCmd__len, INTEGER *len)
{
	if (obj != NIL) {
		Compiler_LinkImports(obj->left, clCmd, clCmd__len, &*len);
		if (obj->mode == 11 && obj->mnolev != 0) {
			Compiler_Append((void*)clCmd, clCmd__len, &*len, (CHAR*)" -l", (LONGINT)4);
			Compiler_Append((void*)clCmd, clCmd__len, &*len, Modules_libPrefix, 20);
			Compiler_Append((void*)clCmd, clCmd__len, &*len, OfrontOPT_GlbMod[__X(-obj->mnolev, 64)]->name, 32);
		}
		Compiler_LinkImports(obj->right, clCmd, clCmd__len, &*len);
	}
}

static void Compiler_GetClCmd (BOOLEAN main, CHAR *clCmd, LONGINT clCmd__len)
{
	INTEGER len = 0;
	OfrontOPT_Object import_ = NIL;
	clCmd[0] = 0x00;
	len = 0;
	Compiler_Append((void*)clCmd, clCmd__len, &len, Compiler_cl, 128);
	Compiler_Append((void*)clCmd, clCmd__len, &len, (CHAR*)" ", (LONGINT)2);
	Compiler_Append((void*)clCmd, clCmd__len, &len, OfrontOPT_SelfName, 32);
	Compiler_Append((void*)clCmd, clCmd__len, &len, (CHAR*)" ", (LONGINT)2);
	if (!main) {
		Compiler_Append((void*)clCmd, clCmd__len, &len, Modules_libPrefix, 20);
	}
	Compiler_Append((void*)clCmd, clCmd__len, &len, OfrontOPT_SelfName, 32);
	Compiler_Append((void*)clCmd, clCmd__len, &len, (CHAR*)" -", (LONGINT)3);
	if (main) {
		Compiler_Append((void*)clCmd, clCmd__len, &len, (CHAR*)"m", (LONGINT)2);
	}
	if (__IN(15, OfrontOPM_opt)) {
		Compiler_Append((void*)clCmd, clCmd__len, &len, (CHAR*)"V", (LONGINT)2);
	}
	if (__IN(13, OfrontOPM_opt)) {
		Compiler_Append((void*)clCmd, clCmd__len, &len, (CHAR*)"G", (LONGINT)2);
	}
	if (__IN(14, OfrontOPM_opt)) {
		Compiler_Append((void*)clCmd, clCmd__len, &len, (CHAR*)"O", (LONGINT)2);
	}
	Compiler_Append((void*)clCmd, clCmd__len, &len, (CHAR*)" \"", (LONGINT)3);
	if (__STRCMP(OfrontOPT_SelfName, "SYSTEM") != 0) {
		Compiler_Append((void*)clCmd, clCmd__len, &len, (CHAR*)"-l", (LONGINT)3);
		Compiler_Append((void*)clCmd, clCmd__len, &len, Modules_libPrefix, 20);
		Compiler_Append((void*)clCmd, clCmd__len, &len, (CHAR*)"SYSTEM", (LONGINT)7);
	}
	Compiler_LinkImports(OfrontOPT_topScope->right, (void*)clCmd, clCmd__len, &len);
	Compiler_Append((void*)clCmd, clCmd__len, &len, (CHAR*)" ", (LONGINT)2);
	Compiler_Append((void*)clCmd, clCmd__len, &len, OfrontOPM_clOpts, 256);
	Compiler_Append((void*)clCmd, clCmd__len, &len, (CHAR*)"\"", (LONGINT)2);
}

void Compiler_Module (BOOLEAN *done)
{
	BOOLEAN ext = 0, new = 0, verbose = 0;
	OfrontOPT_Node p = NIL;
	CHAR (*clCmd)[4000] = NIL;
	LONGINT status = 0;
	Texts_Buffer out = NIL;
	INTEGER res = 0;
	clCmd = NIL;
	OfrontOPP_Module(&p, OfrontOPM_opt);
	if (OfrontOPM_noerr) {
		OfrontOPV_Init();
		OfrontOPV_AdrAndSize(OfrontOPT_topScope);
		OfrontOPT_Export(&ext, &new);
		if (OfrontOPM_noerr) {
			clCmd = __NEWARR(NIL, 1, 1, 1, 0, 4000);
			OfrontOPM_OpenFiles((void*)OfrontOPT_SelfName, 32);
			OfrontOPC_Init();
			OfrontOPV_Module(p);
			if (OfrontOPM_noerr) {
				if (__IN(10, OfrontOPM_opt) && __STRCMP(OfrontOPM_modName, "SYSTEM") != 0) {
					OfrontOPM_DeleteNewSym();
					OfrontOPM_LogWStr((CHAR*)"  main program", (LONGINT)15);
					Compiler_GetClCmd(1, (void*)*clCmd, 4000);
				} else {
					if (new) {
						OfrontOPM_LogWStr((CHAR*)"  new symbol file", (LONGINT)18);
						OfrontOPM_RegisterNewSym();
					} else if (ext) {
						OfrontOPM_LogWStr((CHAR*)"  extended symbol file", (LONGINT)23);
						OfrontOPM_RegisterNewSym();
					}
					Compiler_GetClCmd(0, (void*)*clCmd, 4000);
				}
			} else {
				OfrontOPM_DeleteNewSym();
			}
		}
	}
	verbose = __IN(15, OfrontOPM_opt);
	OfrontOPM_CloseFiles();
	OfrontOPT_Close();
	OfrontOPM_LogWLn();
	if (clCmd != NIL) {
		Oberon_ExecShell(*clCmd, 4000, &status, &out);
		if (verbose) {
			Out_String(*clCmd, 4000);
			Out_Ln();
		}
		if (status != 0 || verbose) {
			Texts_Append(Oberon_Log, out);
		}
	}
	*done = OfrontOPM_noerr && status == 0;
	Oberon_Call((CHAR*)"oberon.PinLog", (LONGINT)14, Oberon_Par, 0, &res);
}

void Compiler_Compile (void)
{
	BOOLEAN done = 0;
	OfrontOPM_OpenPar();
	OfrontOPT_bytetyp->size = OfrontOPM_ByteSize;
	OfrontOPT_sysptrtyp->size = OfrontOPM_PointerSize;
	OfrontOPT_chartyp->size = OfrontOPM_CharSize;
	OfrontOPT_settyp->size = OfrontOPM_SetSize;
	OfrontOPT_realtyp->size = OfrontOPM_RealSize;
	OfrontOPT_inttyp->size = OfrontOPM_IntSize;
	OfrontOPT_linttyp->size = OfrontOPM_LIntSize;
	OfrontOPT_lrltyp->size = OfrontOPM_LRealSize;
	OfrontOPT_sinttyp->size = OfrontOPM_SIntSize;
	OfrontOPT_booltyp->size = OfrontOPM_BoolSize;
	for (;;) {
		OfrontOPM_Init((CHAR*)"compiling", (LONGINT)10, &done);
		if (!done) {
			break;
		}
		OfrontOPM_InitOptions();
		Compiler_Module(&done);
		Kernel_GC(1);
		if (!done) {
			break;
		}
	}
}

void Compiler_SetCL (void)
{
	Texts_Scanner S = {0};
	Texts_Text T = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 6 && S.c == '^' || S.line != 0) {
		Oberon_GetSelection(&T, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&S, Texts_Scanner__typ, T, beg);
			Texts_Scan(&S, Texts_Scanner__typ);
		}
	}
	if (__IN(S.class, 0x06)) {
		__COPY(S.s, Compiler_cl, 128);
	}
}

void Compiler_ShowCL (void)
{
	Out_String(Compiler_cl, 128);
	Out_Ln();
}


export void *Compiler__init(void)
{
	__DEFMOD;
	__IMPORT(Kernel);
	__IMPORT(Modules);
	__IMPORT(Oberon);
	__IMPORT(OfrontOPB);
	__IMPORT(OfrontOPC);
	__IMPORT(OfrontOPM);
	__IMPORT(OfrontOPP);
	__IMPORT(OfrontOPT);
	__IMPORT(OfrontOPV);
	__IMPORT(Out);
	__IMPORT(Texts);
	__REGMOD(Compiler, 0);
	__REGCMD("Compile", Compiler_Compile);
	__REGCMD("SetCL", Compiler_SetCL);
	__REGCMD("ShowCL", Compiler_ShowCL);
/* BEGIN */
	__MOVE("cl.bash", Compiler_cl, 8);
	OfrontOPB_typSize = OfrontOPV_TypSize;
	OfrontOPT_typSize = OfrontOPV_TypSize;
	__ENDMOD;
}
