/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Args.h"
#include "Kernel.h"
#include "OfrontOPB.h"
#include "OfrontOPC.h"
#include "OfrontOPM.h"
#include "OfrontOPP.h"
#include "OfrontOPT.h"
#include "OfrontOPV.h"
#include "Unix.h"


static CHAR CompilerCmd_cl[64];
static CHAR CompilerCmd_libPrefix[20];


static void CompilerCmd_Append (CHAR *s, LONGINT s__len, INTEGER *len, CHAR *x, LONGINT x__len);
export void CompilerCmd_Compile (void);
static void CompilerCmd_GetClCmd (BOOLEAN main, CHAR *clCmd, LONGINT clCmd__len);
static void CompilerCmd_LinkImports (OfrontOPT_Object obj, CHAR *clCmd, LONGINT clCmd__len, INTEGER *len);
export void CompilerCmd_Module (BOOLEAN *done);
static void CompilerCmd_Trap (LONGINT sig, LONGINT siginfo, LONGINT sigctx);

#define CompilerCmd_fin()	SYSTEM_FINALL()
#define CompilerCmd_halt()	SYSTEM_halt
#define CompilerCmd_system(cmd, cmd__len)	(LONGINT)system(cmd)

static void CompilerCmd_Trap (LONGINT sig, LONGINT siginfo, LONGINT sigctx)
{
	CompilerCmd_fin();
	if (sig == 3) {
		Unix_Exit(1);
	} else {
		if (sig == 4 && CompilerCmd_halt() == -15) {
			OfrontOPM_LogWStr((CHAR*)" --- ofront: internal error", (LONGINT)28);
			OfrontOPM_LogWLn();
		}
		Unix_Exit(2);
	}
}

static void CompilerCmd_Append (CHAR *s, LONGINT s__len, INTEGER *len, CHAR *x, LONGINT x__len)
{
	INTEGER i = 0;
	i = 0;
	while (x[__X(i, x__len)] != 0x00) {
		s[__X(*len, s__len)] = x[__X(i, x__len)];
		*len += 1;
		i += 1;
	}
	s[__X(*len, s__len)] = 0x00;
}

static void CompilerCmd_LinkImports (OfrontOPT_Object obj, CHAR *clCmd, LONGINT clCmd__len, INTEGER *len)
{
	if (obj != NIL) {
		CompilerCmd_LinkImports(obj->left, clCmd, clCmd__len, &*len);
		if (obj->mode == 11 && obj->mnolev != 0) {
			CompilerCmd_Append((void*)clCmd, clCmd__len, &*len, (CHAR*)" -l", (LONGINT)4);
			CompilerCmd_Append((void*)clCmd, clCmd__len, &*len, CompilerCmd_libPrefix, 20);
			CompilerCmd_Append((void*)clCmd, clCmd__len, &*len, OfrontOPT_GlbMod[__X(-obj->mnolev, 64)]->name, 32);
		}
		CompilerCmd_LinkImports(obj->right, clCmd, clCmd__len, &*len);
	}
}

static void CompilerCmd_GetClCmd (BOOLEAN main, CHAR *clCmd, LONGINT clCmd__len)
{
	INTEGER len = 0;
	OfrontOPT_Object import_ = NIL;
	clCmd[0] = 0x00;
	len = 0;
	CompilerCmd_Append((void*)clCmd, clCmd__len, &len, CompilerCmd_cl, 64);
	CompilerCmd_Append((void*)clCmd, clCmd__len, &len, (CHAR*)" ", (LONGINT)2);
	CompilerCmd_Append((void*)clCmd, clCmd__len, &len, OfrontOPT_SelfName, 32);
	CompilerCmd_Append((void*)clCmd, clCmd__len, &len, (CHAR*)" ", (LONGINT)2);
	if (!main) {
		CompilerCmd_Append((void*)clCmd, clCmd__len, &len, CompilerCmd_libPrefix, 20);
	}
	CompilerCmd_Append((void*)clCmd, clCmd__len, &len, OfrontOPT_SelfName, 32);
	CompilerCmd_Append((void*)clCmd, clCmd__len, &len, (CHAR*)" -", (LONGINT)3);
	if (main) {
		CompilerCmd_Append((void*)clCmd, clCmd__len, &len, (CHAR*)"m", (LONGINT)2);
	}
	if (__IN(15, OfrontOPM_opt)) {
		CompilerCmd_Append((void*)clCmd, clCmd__len, &len, (CHAR*)"V", (LONGINT)2);
	}
	if (__IN(13, OfrontOPM_opt)) {
		CompilerCmd_Append((void*)clCmd, clCmd__len, &len, (CHAR*)"G", (LONGINT)2);
	}
	if (__IN(14, OfrontOPM_opt)) {
		CompilerCmd_Append((void*)clCmd, clCmd__len, &len, (CHAR*)"O", (LONGINT)2);
	}
	CompilerCmd_Append((void*)clCmd, clCmd__len, &len, (CHAR*)" \"", (LONGINT)3);
	if (__STRCMP(OfrontOPT_SelfName, "SYSTEM") != 0) {
		CompilerCmd_Append((void*)clCmd, clCmd__len, &len, (CHAR*)"-l", (LONGINT)3);
		CompilerCmd_Append((void*)clCmd, clCmd__len, &len, CompilerCmd_libPrefix, 20);
		CompilerCmd_Append((void*)clCmd, clCmd__len, &len, (CHAR*)"SYSTEM", (LONGINT)7);
	}
	CompilerCmd_LinkImports(OfrontOPT_topScope->right, (void*)clCmd, clCmd__len, &len);
	CompilerCmd_Append((void*)clCmd, clCmd__len, &len, (CHAR*)" ", (LONGINT)2);
	CompilerCmd_Append((void*)clCmd, clCmd__len, &len, OfrontOPM_clOpts, 256);
	CompilerCmd_Append((void*)clCmd, clCmd__len, &len, (CHAR*)"\"", (LONGINT)2);
}

void CompilerCmd_Module (BOOLEAN *done)
{
	BOOLEAN ext = 0, new = 0, verbose = 0;
	OfrontOPT_Node p = NIL;
	CHAR (*clCmd)[4000] = NIL;
	LONGINT status = 0;
	INTEGER res = 0;
	clCmd = NIL;
	OfrontOPP_Module(&p, OfrontOPM_opt);
	if (OfrontOPM_noerr) {
		OfrontOPV_Init();
		OfrontOPV_AdrAndSize(OfrontOPT_topScope);
		OfrontOPT_Export(&ext, &new);
		if (OfrontOPM_noerr) {
			clCmd = __NEWARR(NIL, 1, 1, 1, 0, 4000);
			OfrontOPM_OpenFiles((void*)OfrontOPT_SelfName, 32);
			OfrontOPC_Init();
			OfrontOPV_Module(p);
			if (OfrontOPM_noerr) {
				if (__IN(10, OfrontOPM_opt) && __STRCMP(OfrontOPM_modName, "SYSTEM") != 0) {
					OfrontOPM_DeleteNewSym();
					OfrontOPM_LogWStr((CHAR*)"  main program", (LONGINT)15);
					CompilerCmd_GetClCmd(1, (void*)*clCmd, 4000);
				} else {
					if (new) {
						OfrontOPM_LogWStr((CHAR*)"  new symbol file", (LONGINT)18);
						OfrontOPM_RegisterNewSym();
					} else if (ext) {
						OfrontOPM_LogWStr((CHAR*)"  extended symbol file", (LONGINT)23);
						OfrontOPM_RegisterNewSym();
					}
					CompilerCmd_GetClCmd(0, (void*)*clCmd, 4000);
				}
			} else {
				OfrontOPM_DeleteNewSym();
			}
		}
	}
	verbose = __IN(15, OfrontOPM_opt);
	OfrontOPM_CloseFiles();
	OfrontOPT_Close();
	OfrontOPM_LogWLn();
	if (clCmd != NIL) {
		if (verbose) {
			OfrontOPM_LogWStr(*clCmd, 4000);
			OfrontOPM_LogWLn();
		}
		status = CompilerCmd_system(*clCmd, 4000);
	}
	*done = OfrontOPM_noerr && status == 0;
}

void CompilerCmd_Compile (void)
{
	BOOLEAN done = 0;
	OfrontOPM_OpenPar((CHAR*)"Ofront (TM) - Oberon-2 Compiler V1.4", (LONGINT)37, (CHAR*)"ocl", (LONGINT)4);
	OfrontOPT_bytetyp->size = OfrontOPM_ByteSize;
	OfrontOPT_sysptrtyp->size = OfrontOPM_PointerSize;
	OfrontOPT_chartyp->size = OfrontOPM_CharSize;
	OfrontOPT_settyp->size = OfrontOPM_SetSize;
	OfrontOPT_realtyp->size = OfrontOPM_RealSize;
	OfrontOPT_inttyp->size = OfrontOPM_IntSize;
	OfrontOPT_linttyp->size = OfrontOPM_LIntSize;
	OfrontOPT_lrltyp->size = OfrontOPM_LRealSize;
	OfrontOPT_sinttyp->size = OfrontOPM_SIntSize;
	OfrontOPT_booltyp->size = OfrontOPM_BoolSize;
	for (;;) {
		OfrontOPM_Init((CHAR*)"compiling", (LONGINT)10, &done);
		if (!done) {
			if (!OfrontOPM_noerr) {
				CompilerCmd_fin();
				Unix_Exit(1);
			}
			break;
		}
		OfrontOPM_InitOptions();
		CompilerCmd_Module(&done);
		Kernel_GC(1);
		if (!done) {
			CompilerCmd_fin();
			Unix_Exit(1);
		}
	}
}


int main(int argc, char **argv)
{
	__INIT(argc, argv);
	__IMPORT(Args);
	__IMPORT(Kernel);
	__IMPORT(OfrontOPB);
	__IMPORT(OfrontOPC);
	__IMPORT(OfrontOPM);
	__IMPORT(OfrontOPP);
	__IMPORT(OfrontOPT);
	__IMPORT(OfrontOPV);
	__IMPORT(Unix);
	__REGMAIN(CompilerCmd, 0);
	__REGCMD("Compile", CompilerCmd_Compile);
/* BEGIN */
	__MOVE("_V4_", CompilerCmd_libPrefix, 5);
	Args_GetEnv((CHAR*)"OBERON_LIBPREFIX", (LONGINT)17, (void*)CompilerCmd_libPrefix, 20);
	__MOVE("cl.bash", CompilerCmd_cl, 8);
	OfrontOPB_typSize = OfrontOPV_TypSize;
	OfrontOPT_typSize = OfrontOPV_TypSize;
	Unix_SigSetHandler(2, CompilerCmd_Trap);
	Unix_SigSetHandler(3, CompilerCmd_Trap);
	Unix_SigSetHandler(4, CompilerCmd_Trap);
	CompilerCmd_Compile();
	__FINI;
}
