/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Elems.h"
#include "Files.h"
#include "Fonts.h"
#include "GUtils.h"
#include "Input.h"
#include "MenuViewers.h"
#include "Modules.h"
#include "Oberon.h"
#include "Out.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct ContainerElems_CaseDesc *ContainerElems_Case;

typedef
	struct ContainerElems_CaseDesc {
		INTEGER x, y;
		SET state;
		Texts_Elem e;
		ContainerElems_Case next;
	} ContainerElems_CaseDesc;

typedef
	struct ContainerElems_ContainerDesc *ContainerElems_Container;

typedef
	struct ContainerElems_SelectionDesc *ContainerElems_Selection;

typedef
	struct ContainerElems_TextDesc *ContainerElems_Text;

typedef
	struct ContainerElems_ContainerDesc { /* Elems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[8];
		BOOLEAN locked;
		ContainerElems_Case contents;
		BOOLEAN lockedc;
		INTEGER x, y;
		ContainerElems_Selection sel, last;
		ContainerElems_Text dummyText;
	} ContainerElems_ContainerDesc;

typedef
	struct ContainerElems_CopyOverMsg { /* Oberon_CopyOverMsg */
		Texts_Text text;
		LONGINT beg, end;
		ContainerElems_Container p;
		ContainerElems_Selection sel;
	} ContainerElems_CopyOverMsg;

typedef
	struct ContainerElems_FrameDesc *ContainerElems_Frame;

typedef
	struct ContainerElems_FrameDesc { /* Display_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		ContainerElems_Container container;
		BOOLEAN hasCar;
		INTEGER oldY, x, y;
		LONGINT selTime;
	} ContainerElems_FrameDesc;

typedef
	struct ContainerElems_NotifyMsg { /* Display_FrameMsg */
		ContainerElems_Container c;
		SET id;
		ContainerElems_Case case_;
		Texts_Elem elem;
		INTEGER x, y, w, h;
	} ContainerElems_NotifyMsg;

typedef
	struct ContainerElems_SelElemDesc *ContainerElems_SelElem;

typedef
	struct ContainerElems_SelElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		Texts_Elem e;
	} ContainerElems_SelElemDesc;

typedef
	struct ContainerElems_SelectionDesc {
		ContainerElems_Case c;
		ContainerElems_Selection next;
	} ContainerElems_SelectionDesc;

typedef
	struct ContainerElems_SelectionMsg { /* Oberon_SelectionMsg */
		LONGINT time;
		Texts_Text text;
		LONGINT beg, end;
		ContainerElems_Container p;
		ContainerElems_Selection sel;
	} ContainerElems_SelectionMsg;

typedef
	struct ContainerElems_TextDesc { /* Texts_TextDesc */
		LONGINT len;
		Texts_Notifier notify;
		char _prvt0[12];
		ContainerElems_Container base;
	} ContainerElems_TextDesc;


static Texts_Writer ContainerElems_W;
static TextFrames_Frame ContainerElems_dummyTextFrame;
static INTEGER ContainerElems_clp;

export LONGINT *ContainerElems_CaseDesc__typ;
export LONGINT *ContainerElems_SelectionDesc__typ;
export LONGINT *ContainerElems_FrameDesc__typ;
export LONGINT *ContainerElems_TextDesc__typ;
export LONGINT *ContainerElems_ContainerDesc__typ;
export LONGINT *ContainerElems_SelElemDesc__typ;
export LONGINT *ContainerElems_SelectionMsg__typ;
export LONGINT *ContainerElems_CopyOverMsg__typ;
export LONGINT *ContainerElems_NotifyMsg__typ;

export void ContainerElems_AdjustSubFrame (Display_Frame f, Display_Frame sub);
export void ContainerElems_AppendToSelection (ContainerElems_Container p, ContainerElems_Case c);
static void ContainerElems_ChangePos (ContainerElems_Frame f, ContainerElems_Case c, INTEGER dx, INTEGER dy);
static void ContainerElems_ClearArea (ContainerElems_Frame f, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
export void ContainerElems_CopyContainer (ContainerElems_Container from, ContainerElems_Container to);
static void ContainerElems_CopyInto (ContainerElems_Container p);
static void ContainerElems_CopyOver (ContainerElems_Container p, Oberon_CopyOverMsg *msg, LONGINT *msg__typ);
export void ContainerElems_DeleteCase (ContainerElems_Container p, ContainerElems_Case c);
static void ContainerElems_DeleteElem (ContainerElems_Container p, Texts_Elem e);
export void ContainerElems_DeleteSelection (ContainerElems_Frame f);
export void ContainerElems_DrawContents (ContainerElems_Container p, Display_Frame f, INTEGER x0, INTEGER y0);
export void ContainerElems_DrawTextElem (ContainerElems_Container p, Texts_Elem e, Display_Frame f, INTEGER x0, INTEGER y0);
export void ContainerElems_FrameHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
static BOOLEAN ContainerElems_FullyVisible (Display_Frame f, ContainerElems_Case c, INTEGER w, INTEGER h);
export void ContainerElems_Handle (Texts_Elem p, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void ContainerElems_HandleAttrMsg (ContainerElems_Container p, Elems_AttrMsg *msg, LONGINT *msg__typ);
static void ContainerElems_HandleFileMsg (ContainerElems_Container *p, Texts_FileMsg *msg, LONGINT *msg__typ);
static void ContainerElems_HandleInput (ContainerElems_Frame f, Oberon_InputMsg *msg, LONGINT *msg__typ);
static BOOLEAN ContainerElems_InArea (INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER ex, INTEGER ey, INTEGER ew, INTEGER eh);
export BOOLEAN ContainerElems_InBorder (INTEGER mX, INTEGER mY, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
export void ContainerElems_Init (ContainerElems_Container p);
export void ContainerElems_InsertElem (ContainerElems_Container p, Texts_Elem new, Fonts_Font fnt, SHORTINT col);
static void ContainerElems_InvertCaret (ContainerElems_Frame f);
static void ContainerElems_InvertMoving (ContainerElems_Frame f, ContainerElems_Case c, INTEGER dx, INTEGER dy);
static void ContainerElems_InvertSelected (ContainerElems_Frame f, ContainerElems_Case c);
export void ContainerElems_LoadCase (Texts_FileMsg *msg, LONGINT *msg__typ, ContainerElems_Case *c, Fonts_Font *fnt, SHORTINT *col);
static void ContainerElems_Move (ContainerElems_Frame f, ContainerElems_Case c);
export ContainerElems_Case ContainerElems_MyCase (ContainerElems_Container p, Texts_Elem e);
export ContainerElems_Selection ContainerElems_NextSel (ContainerElems_Selection s);
static void ContainerElems_NoNotify (Texts_Text t, INTEGER op, LONGINT beg, LONGINT end);
static void ContainerElems_Notify (Texts_Text T, INTEGER op, LONGINT beg, LONGINT end);
static void ContainerElems_NotifySubFrames (ContainerElems_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
static BOOLEAN ContainerElems_OverlapsArea (INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER ex, INTEGER ey, INTEGER ew, INTEGER eh);
export void ContainerElems_PrintContents (ContainerElems_Container p, INTEGER x0, INTEGER y0);
static void ContainerElems_PrintTextElem (ContainerElems_Container p, ContainerElems_Case c, INTEGER x0, INTEGER y0);
static void ContainerElems_RefreshArea (ContainerElems_Frame f, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h);
export void ContainerElems_RemoveCaret (ContainerElems_Frame f);
export void ContainerElems_RemoveFromSelection (ContainerElems_Container p, ContainerElems_Case c);
export void ContainerElems_RemoveSelection (ContainerElems_Frame f);
static void ContainerElems_RemoveSubFrames (ContainerElems_Frame f, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static void ContainerElems_SelElemHandle (Texts_Elem s, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void ContainerElems_SelTextNotifier (Texts_Text t, INTEGER op, LONGINT beg, LONGINT end);
static void ContainerElems_SelToPanel (ContainerElems_Container p, ContainerElems_Selection sel);
static Texts_Text ContainerElems_SelectionToText (ContainerElems_Frame f);
static void ContainerElems_SendSelection (ContainerElems_Frame f);
export void ContainerElems_SetCaret (ContainerElems_Frame f, INTEGER X, INTEGER Y);
static void ContainerElems_ShowSubFrames (Display_Frame f);
export void ContainerElems_StoreCase (Texts_FileMsg *msg, LONGINT *msg__typ, ContainerElems_Case c);
static void ContainerElems_TextSelToPanel (ContainerElems_Container p, Texts_Text t, LONGINT beg, LONGINT end);
export ContainerElems_Case ContainerElems_ThisCase (ContainerElems_Container p, INTEGER x, INTEGER y, INTEGER x0, INTEGER y0);
static Display_Frame ContainerElems_ThisSubFrame (ContainerElems_Frame f, INTEGER x, INTEGER y);
static void ContainerElems_ToBottom (ContainerElems_Container p, ContainerElems_Case c);
static void ContainerElems_ToTop (ContainerElems_Container p, ContainerElems_Case c);
static void ContainerElems_TrackRubberBand (ContainerElems_Frame f, INTEGER ix, INTEGER iy, SET keys);
export void ContainerElems_UpdateArea (ContainerElems_Container c, INTEGER x, INTEGER y, INTEGER w, INTEGER h, SET id);


static void ContainerElems_NoNotify (Texts_Text t, INTEGER op, LONGINT beg, LONGINT end)
{
}

static BOOLEAN ContainerElems_InArea (INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER ex, INTEGER ey, INTEGER ew, INTEGER eh)
{
	return ((ey <= y && ey - eh >= y - h) && ex >= x) && ex + ew <= x + w;
}

static BOOLEAN ContainerElems_OverlapsArea (INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER ex, INTEGER ey, INTEGER ew, INTEGER eh)
{
	return ((ex >= x && ex <= (x + w) - 1 || (ex + ew) - 1 >= x && ex + ew <= x + w) || ex <= x && ex + ew >= x + w) && ((ey <= y && ey >= (y - h) + 1 || (ey - eh) + 1 <= y && ey - eh >= y - h) || ey >= y && ey - eh < y - h);
}

void ContainerElems_AdjustSubFrame (Display_Frame f, Display_Frame sub)
{
	if (__ISP(sub, ContainerElems_FrameDesc, 1)) {
		(*(ContainerElems_Frame*)&sub)->x = (*(ContainerElems_Frame*)&sub)->X;
		(*(ContainerElems_Frame*)&sub)->y = (*(ContainerElems_Frame*)&sub)->Y;
		Elems_AdjustSubFrame(f, (void*)(*(ContainerElems_Frame*)&sub));
	} else __WITHCHK;
}

BOOLEAN ContainerElems_InBorder (INTEGER mX, INTEGER mY, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	return ((mX < x + ContainerElems_clp || mX > (x + w) - ContainerElems_clp) || mY < y + ContainerElems_clp) || mY > (y + h) - ContainerElems_clp;
}

void ContainerElems_InsertElem (ContainerElems_Container p, Texts_Elem new, Fonts_Font fnt, SHORTINT col)
{
	ContainerElems_Case c = NIL;
	Elems_AttrMsg attr = {0};
	Texts_Notifier notifier = NIL;
	__NEW(c, ContainerElems_CaseDesc);
	c->state = 0x0;
	c->next = p->contents;
	p->contents = c;
	Elems_GetSet(new, (CHAR*)"!#cstate", (LONGINT)9, &c->state);
	c->e = new;
	c->x = p->x;
	c->y = p->y;
	notifier = p->dummyText->notify;
	p->dummyText->notify = ContainerElems_NoNotify;
	Texts_SetFont(&ContainerElems_W, Texts_Writer__typ, fnt);
	Texts_SetColor(&ContainerElems_W, Texts_Writer__typ, col);
	Texts_WriteElem(&ContainerElems_W, Texts_Writer__typ, new);
	Texts_Append((void*)p->dummyText, ContainerElems_W.buf);
	p->dummyText->notify = notifier;
	p->x = (p->x + (int)__DIV(new->W, (LONGINT)TextFrames_Unit)) + 2;
}

static void ContainerElems_NotifySubFrames (ContainerElems_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	Display_Frame sub = NIL;
	sub = f->dsc;
	while (sub != NIL) {
		(*sub->handle)(sub, &*msg, msg__typ);
		sub = sub->next;
	}
}

static Display_Frame ContainerElems_ThisSubFrame (ContainerElems_Frame f, INTEGER x, INTEGER y)
{
	Display_Frame sub = NIL;
	BOOLEAN done = 0;
	sub = f->dsc;
	done = 0;
	while (sub != NIL && !done) {
		if (((sub->X <= x && sub->X + sub->W >= x) && sub->Y <= y) && sub->Y + sub->H >= y) {
			done = 1;
		} else {
			sub = sub->next;
		}
	}
	return sub;
}

static void ContainerElems_RemoveSubFrames (ContainerElems_Frame f, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	Display_Frame p = NIL, s = NIL;
	MenuViewers_ModifyMsg msg = {0};
	s = f->dsc;
	if (s != NIL) {
		p = s;
		s = p->next;
	}
	while (s != NIL) {
		if (ContainerElems_OverlapsArea(x, y, w, h, s->X, s->Y, s->W, s->H)) {
			p->next = s->next;
			msg.id = 1;
			msg.dY = 0;
			msg.Y = f->Y;
			msg.H = 0;
			(*s->handle)(s, (void*)&msg, MenuViewers_ModifyMsg__typ);
		} else {
			p = s;
		}
		s = p->next;
	}
	s = f->dsc;
	if (s != NIL && ContainerElems_OverlapsArea(x, y, w, h, s->X, s->Y, s->W, s->H)) {
		f->dsc = f->dsc->next;
		msg.id = 1;
		msg.dY = 0;
		msg.Y = f->Y;
		msg.H = 0;
		(*s->handle)(s, (void*)&msg, MenuViewers_ModifyMsg__typ);
	}
}

static void ContainerElems_ToBottom (ContainerElems_Container p, ContainerElems_Case c)
{
	ContainerElems_Case cc = NIL;
	if (p->contents->next == NIL || c->next == NIL) {
		return;
	}
	if (p->contents == c && p->contents->next != NIL) {
		p->contents = p->contents->next;
		cc = p->contents;
	} else {
		cc = p->contents;
		while (cc->next != c) {
			cc = cc->next;
		}
		cc->next = c->next;
	}
	while (cc->next != NIL) {
		cc = cc->next;
	}
	cc->next = c;
	c->next = NIL;
}

static void ContainerElems_ToTop (ContainerElems_Container p, ContainerElems_Case c)
{
	ContainerElems_Case cc = NIL;
	if (__IN(2, c->state)) {
		ContainerElems_ToBottom(p, c);
	} else {
		if (p->contents == c) {
			return;
		}
		cc = p->contents;
		while (cc->next != c) {
			cc = cc->next;
		}
		cc->next = c->next;
		c->next = p->contents;
		p->contents = c;
	}
}

static void ContainerElems_DeleteElem (ContainerElems_Container p, Texts_Elem e)
{
	LONGINT pos = 0;
	Texts_Notifier notifier = NIL;
	notifier = p->dummyText->notify;
	p->dummyText->notify = ContainerElems_NoNotify;
	pos = Texts_ElemPos(e);
	Texts_Delete((void*)p->dummyText, pos, pos + 1);
	p->dummyText->notify = notifier;
}

void ContainerElems_DeleteCase (ContainerElems_Container p, ContainerElems_Case c)
{
	ContainerElems_Case help = NIL;
	if (p->contents == c) {
		p->contents = p->contents->next;
		ContainerElems_DeleteElem(p, c->e);
		return;
	}
	help = p->contents;
	while (help != NIL && help->next != c) {
		help = help->next;
	}
	if (help != NIL) {
		help->next = c->next;
		ContainerElems_DeleteElem(p, c->e);
	}
}

ContainerElems_Case ContainerElems_MyCase (ContainerElems_Container p, Texts_Elem e)
{
	ContainerElems_Case c = NIL;
	c = p->contents;
	while (c != NIL) {
		if (c->e == e) {
			return c;
		}
		c = c->next;
	}
	return NIL;
}

ContainerElems_Case ContainerElems_ThisCase (ContainerElems_Container p, INTEGER x, INTEGER y, INTEGER x0, INTEGER y0)
{
	ContainerElems_Case c = NIL;
	INTEGER rx = 0, ry = 0, h = 0;
	h = (int)__DIV(p->H, (LONGINT)TextFrames_Unit);
	rx = x - x0;
	ry = (y0 + h) - y;
	c = p->contents;
	while (c != NIL) {
		if ((rx >= c->x && rx <= c->x + (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit)) && (ry >= c->y - (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit) && ry <= c->y)) {
			return c;
		}
		c = c->next;
	}
	return NIL;
}

void ContainerElems_StoreCase (Texts_FileMsg *msg, LONGINT *msg__typ, ContainerElems_Case c)
{
	Texts_IdentifyMsg identify = {0};
	Fonts_Font fnt = NIL;
	SHORTINT col = 0;
	Files_WriteInt(&(*msg).r, Files_Rider__typ, c->x);
	Files_WriteInt(&(*msg).r, Files_Rider__typ, c->y);
	Files_WriteSet(&(*msg).r, Files_Rider__typ, c->state);
	Elems_GetLook(c->e, &fnt, &col);
	Files_WriteString(&(*msg).r, Files_Rider__typ, fnt->name, 32);
	Files_WriteInt(&(*msg).r, Files_Rider__typ, col);
	Files_WriteLInt(&(*msg).r, Files_Rider__typ, c->e->W);
	Files_WriteLInt(&(*msg).r, Files_Rider__typ, c->e->H);
	(*c->e->handle)(c->e, (void*)&identify, Texts_IdentifyMsg__typ);
	Files_WriteString(&(*msg).r, Files_Rider__typ, identify.mod, 32);
	Files_WriteString(&(*msg).r, Files_Rider__typ, identify.proc, 32);
	(*c->e->handle)(c->e, (void*)&*msg, msg__typ);
}

void ContainerElems_LoadCase (Texts_FileMsg *msg, LONGINT *msg__typ, ContainerElems_Case *c, Fonts_Font *fnt, SHORTINT *col)
{
	CHAR mod[32], proc[32];
	Modules_Module M = NIL;
	Modules_Command cmd = NIL;
	CHAR fntName[64];
	INTEGER i = 0;
	LONGINT w = 0, h = 0;
	Files_ReadInt(&(*msg).r, Files_Rider__typ, &(*c)->x);
	Files_ReadInt(&(*msg).r, Files_Rider__typ, &(*c)->y);
	Files_ReadSet(&(*msg).r, Files_Rider__typ, &(*c)->state);
	(*c)->state &= ~__SETOF(1);
	Files_ReadString(&(*msg).r, Files_Rider__typ, (void*)fntName, 64);
	*fnt = Fonts_This(fntName, 64);
	Files_ReadInt(&(*msg).r, Files_Rider__typ, &i);
	*col = (int)i;
	Files_ReadLInt(&(*msg).r, Files_Rider__typ, &w);
	Files_ReadLInt(&(*msg).r, Files_Rider__typ, &h);
	Files_ReadString(&(*msg).r, Files_Rider__typ, (void*)mod, 32);
	Files_ReadString(&(*msg).r, Files_Rider__typ, (void*)proc, 32);
	M = Modules_ThisMod(mod, 32);
	if (M != NIL) {
		cmd = Modules_ThisCommand(M, proc, 32);
	} else {
		Out_String((CHAR*)"-- unknown module: ", (LONGINT)20);
		Out_String(mod, 32);
		Out_Ln();
	}
	if (cmd != NIL) {
		(*cmd)();
	} else {
		Out_String((CHAR*)"-- unknown command : ", (LONGINT)22);
		Out_String(mod, 32);
		Out_Char('.');
		Out_String(proc, 32);
		Out_Ln();
	}
	__ASSERT(cmd != NIL && M != NIL, 0);
	(*c)->e = Texts_new;
	(*c)->e->W = w;
	(*c)->e->H = h;
	(*(*c)->e->handle)((*c)->e, (void*)&*msg, msg__typ);
}

static void ContainerElems_InvertSelected (ContainerElems_Frame f, ContainerElems_Case c)
{
	INTEGER w = 0, h = 0;
	w = (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit);
	h = (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit);
	GUtils_ReplConst((void*)f, 0, f->X + c->x, (f->Y + f->H) - c->y, w, h, 2);
}

void ContainerElems_AppendToSelection (ContainerElems_Container p, ContainerElems_Case c)
{
	ContainerElems_Selection s = NIL;
	__NEW(s, ContainerElems_SelectionDesc);
	s->c = c;
	s->next = NIL;
	if (p->sel == NIL) {
		p->sel = s;
	} else {
		p->last->next = s;
	}
	p->last = s;
}

void ContainerElems_RemoveFromSelection (ContainerElems_Container p, ContainerElems_Case c)
{
	ContainerElems_Selection s = NIL;
	if (p->sel == NIL) {
		return;
	}
	if (p->sel->c == c) {
		p->sel = p->sel->next;
		if (p->sel == NIL) {
			p->last = NIL;
		}
	} else {
		s = p->sel;
		while (s->next != NIL && s->next->c != c) {
			s = s->next;
		}
		if (s->next != NIL) {
			s->next = s->next->next;
			if (s->next == NIL) {
				p->last = s;
			}
		}
	}
}

void ContainerElems_RemoveSelection (ContainerElems_Frame f)
{
	ContainerElems_Selection s = NIL;
	s = f->container->sel;
	while (s != NIL) {
		s->c->state &= ~__SETOF(1);
		Elems_UpdateElem(s->c->e);
		s = s->next;
	}
	f->container->sel = NIL;
	f->container->last = NIL;
}

void ContainerElems_DeleteSelection (ContainerElems_Frame f)
{
	ContainerElems_Selection s = NIL;
	INTEGER ew = 0, eh = 0;
	s = f->container->sel;
	while (s != NIL) {
		ContainerElems_DeleteCase(f->container, s->c);
		ew = (int)__DIV(s->c->e->W, (LONGINT)TextFrames_Unit);
		eh = (int)__DIV(s->c->e->H, (LONGINT)TextFrames_Unit);
		ContainerElems_UpdateArea(f->container, s->c->x, s->c->y, ew, eh, 0x0c);
		s = s->next;
	}
	f->container->sel = NIL;
	f->container->last = NIL;
}

static void ContainerElems_SelElemHandle (Texts_Elem s, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	(*__GUARDP(s, ContainerElems_SelElemDesc, 2)->e->handle)(__GUARDP(s, ContainerElems_SelElemDesc, 2)->e, &*msg, msg__typ);
}

static void ContainerElems_SelTextNotifier (Texts_Text t, INTEGER op, LONGINT beg, LONGINT end)
{
	Texts_Reader r = {0};
	Texts_Text txt = NIL;
	Texts_Elem e = NIL;
	LONGINT pos = 0;
	if (op != 0) {
		return;
	}
	Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
	Texts_ReadElem(&r, Texts_Reader__typ);
	txt = Texts_ElemBase(__GUARDP(r.elem, ContainerElems_SelElemDesc, 2)->e);
	while (!r.eot) {
		e = __GUARDP(r.elem, ContainerElems_SelElemDesc, 2)->e;
		pos = Texts_ElemPos(e);
		Texts_ChangeLooks(txt, pos, pos + 1, 0x07, r.fnt, r.col, r.voff);
		Texts_ReadElem(&r, Texts_Reader__typ);
	}
}

static Texts_Text ContainerElems_SelectionToText (ContainerElems_Frame f)
{
	ContainerElems_Selection s = NIL;
	ContainerElems_SelElem sel = NIL;
	SHORTINT col = 0;
	Fonts_Font fnt = NIL;
	Texts_Text t = NIL;
	t = TextFrames_Text((CHAR*)"", (LONGINT)1);
	t->notify = ContainerElems_SelTextNotifier;
	s = f->container->sel;
	while (s != NIL) {
		__NEW(sel, ContainerElems_SelElemDesc);
		sel->handle = ContainerElems_SelElemHandle;
		sel->e = s->c->e;
		Elems_GetLook(sel->e, &fnt, &col);
		Texts_SetFont(&ContainerElems_W, Texts_Writer__typ, fnt);
		Texts_SetColor(&ContainerElems_W, Texts_Writer__typ, col);
		Texts_WriteElem(&ContainerElems_W, Texts_Writer__typ, (void*)sel);
		Texts_Append(t, ContainerElems_W.buf);
		s = s->next;
	}
	return t;
}

ContainerElems_Selection ContainerElems_NextSel (ContainerElems_Selection s)
{
	return s->next;
}

static void ContainerElems_SendSelection (ContainerElems_Frame f)
{
	ContainerElems_CopyOverMsg msg = {0};
	if (f->container->sel != NIL) {
		msg.text = ContainerElems_SelectionToText(f);
		msg.beg = 0;
		msg.end = msg.text->len;
		msg.p = f->container;
		msg.sel = f->container->sel;
		Viewers_Broadcast((void*)&msg, ContainerElems_CopyOverMsg__typ);
	}
}

static void ContainerElems_SelToPanel (ContainerElems_Container p, ContainerElems_Selection sel)
{
	ContainerElems_Selection s = NIL;
	Texts_CopyMsg copy = {0};
	Fonts_Font fnt = NIL;
	SHORTINT col = 0;
	INTEGER sx = 0, sy = 0, px = 0, py = 0;
	ContainerElems_Case c = NIL;
	sx = 32767;
	sy = -32768;
	s = sel;
	while (s != NIL) {
		if (s->c->x < sx) {
			sx = s->c->x;
		}
		if (s->c->y > sy) {
			sy = s->c->y;
		}
		s = s->next;
	}
	px = p->x;
	py = p->y;
	s = sel;
	while (s != NIL) {
		Elems_GetLook(s->c->e, &fnt, &col);
		copy.e = NIL;
		(*s->c->e->handle)(s->c->e, (void*)&copy, Texts_CopyMsg__typ);
		p->x = px + (s->c->x - sx);
		p->y = py - (sy - s->c->y);
		ContainerElems_InsertElem(p, copy.e, fnt, col);
		Elems_UpdateElem(copy.e);
		c = ContainerElems_MyCase(p, copy.e);
		c->state = s->c->state;
		c->state &= ~__SETOF(1);
		s = s->next;
	}
}

static void ContainerElems_TextSelToPanel (ContainerElems_Container p, Texts_Text t, LONGINT beg, LONGINT end)
{
	Texts_Reader r = {0};
	Texts_CopyMsg copy = {0};
	Fonts_Font fnt = NIL;
	SHORTINT col = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, t, beg);
	Texts_ReadElem(&r, Texts_Reader__typ);
	while (Texts_Pos(&r, Texts_Reader__typ) <= end && r.elem != NIL) {
		Elems_GetLook(r.elem, &fnt, &col);
		copy.e = NIL;
		(*r.elem->handle)(r.elem, (void*)&copy, Texts_CopyMsg__typ);
		ContainerElems_InsertElem(p, copy.e, fnt, col);
		Elems_UpdateElem(copy.e);
		Texts_ReadElem(&r, Texts_Reader__typ);
	}
}

static void ContainerElems_CopyOver (ContainerElems_Container p, Oberon_CopyOverMsg *msg, LONGINT *msg__typ)
{
	if (__IS(msg__typ, ContainerElems_CopyOverMsg, 2)) {
		ContainerElems_SelToPanel(p, __GUARDR(msg, ContainerElems_CopyOverMsg, 2).sel);
	} else {
		ContainerElems_TextSelToPanel(p, (*msg).text, (*msg).beg, (*msg).end);
	}
}

static void ContainerElems_CopyInto (ContainerElems_Container p)
{
	ContainerElems_SelectionMsg msg = {0};
	msg.p = NIL;
	msg.sel = NIL;
	msg.text = NIL;
	msg.time = 0;
	Viewers_Broadcast((void*)&msg, ContainerElems_SelectionMsg__typ);
	if (msg.sel == NIL && msg.text != NIL) {
		ContainerElems_TextSelToPanel(p, msg.text, msg.beg, msg.end);
	} else if (msg.sel != NIL) {
		ContainerElems_SelToPanel(p, msg.sel);
	}
}

static BOOLEAN ContainerElems_FullyVisible (Display_Frame f, ContainerElems_Case c, INTEGER w, INTEGER h)
{
	return (c->x + w < f->W && c->y < f->H) && h <= c->y;
}

void ContainerElems_DrawTextElem (ContainerElems_Container p, Texts_Elem e, Display_Frame f, INTEGER x0, INTEGER y0)
{
	TextFrames_DisplayMsg msg = {0};
	INTEGER w = 0, h = 0, wp = 0, hp = 0;
	ContainerElems_Case c = NIL;
	c = ContainerElems_MyCase(p, e);
	if (__IN(4, c->state)) {
		return;
	}
	wp = (int)__DIV(p->W, (LONGINT)TextFrames_Unit);
	hp = (int)__DIV(p->H, (LONGINT)TextFrames_Unit);
	w = (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit);
	h = (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit);
	if (c->x > f->W || c->y - h > f->H) {
		return;
	}
	Elems_GetLook(c->e, &msg.fnt, &msg.col);
	msg.X0 = c->x + x0;
	msg.Y0 = 0;
	if (__ISP(c->e, Elems_ElemDesc, 2)) {
		msg.frame = f;
	} else {
		msg.frame = (Display_Frame)ContainerElems_dummyTextFrame;
		msg.frame->X = x0;
		msg.frame->Y = y0;
		msg.frame->W = wp;
		msg.frame->H = hp;
	}
	msg.prepare = 1;
	(*c->e->handle)(c->e, (void*)&msg, TextFrames_DisplayMsg__typ);
	w = (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit);
	h = (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit);
	if (!__ISP(c->e, Elems_ElemDesc, 2) && !ContainerElems_FullyVisible(f, c, w, h)) {
		GUtils_ReplPattern(f, 2, Display_grey1, x0 + c->x, (y0 + hp) - c->y, w, h, 0, 0, 1);
		return;
	}
	msg.prepare = 0;
	msg.elemFrame = NIL;
	msg.Y0 = (y0 + hp) - c->y;
	(*c->e->handle)(c->e, (void*)&msg, TextFrames_DisplayMsg__typ);
	if (__IN(1, c->state)) {
		ContainerElems_InvertSelected(__GUARDP(f, ContainerElems_FrameDesc, 1), c);
	}
	if (msg.elemFrame != NIL) {
		msg.elemFrame->next = f->dsc;
		f->dsc = msg.elemFrame;
	}
}

static struct DrawContents__11 {
	ContainerElems_Container *p;
	Display_Frame *f;
	INTEGER *x0, *y0;
	struct DrawContents__11 *lnk;
} *DrawContents__11_s;

static void Dr__12 (ContainerElems_Case c);

static void Dr__12 (ContainerElems_Case c)
{
	if (c != NIL) {
		c->state &= ~__SETOF(1);
		Dr__12(c->next);
		ContainerElems_DrawTextElem(*DrawContents__11_s->p, c->e, *DrawContents__11_s->f, *DrawContents__11_s->x0, *DrawContents__11_s->y0);
	}
}

void ContainerElems_DrawContents (ContainerElems_Container p, Display_Frame f, INTEGER x0, INTEGER y0)
{
	struct DrawContents__11 _s;
	_s.p = &p;
	_s.f = &f;
	_s.x0 = &x0;
	_s.y0 = &y0;
	_s.lnk = DrawContents__11_s;
	DrawContents__11_s = &_s;
	Dr__12(p->contents);
	DrawContents__11_s = _s.lnk;
}

static void ContainerElems_PrintTextElem (ContainerElems_Container p, ContainerElems_Case c, INTEGER x0, INTEGER y0)
{
	TextPrinter_PrintMsg msg = {0};
	INTEGER w = 0, h = 0, wp = 0, hp = 0;
	wp = (int)__DIV(p->W, 3048);
	hp = (int)__DIV(p->H, 3048);
	w = (int)__DIV(c->e->W, 3048);
	h = (int)__DIV(c->e->H, 3048);
	if (c->x > wp || c->y - h > hp) {
		return;
	}
	Elems_GetLook(c->e, &msg.fnt, &msg.col);
	msg.X0 = (int)__DIV((LONGINT)c->x * (LONGINT)TextFrames_Unit, 3048) + x0;
	msg.Y0 = 0;
	msg.prepare = 1;
	(*c->e->handle)(c->e, (void*)&msg, TextPrinter_PrintMsg__typ);
	w = (int)__DIV(c->e->W, 3048);
	h = (int)__DIV(c->e->H, 3048);
	if (!__ISP(c->e, Elems_ElemDesc, 2)) {
	}
	msg.prepare = 0;
	msg.Y0 = (y0 + hp) - (int)__DIV((LONGINT)c->y * (LONGINT)TextFrames_Unit, 3048);
	(*c->e->handle)(c->e, (void*)&msg, TextPrinter_PrintMsg__typ);
}

void ContainerElems_PrintContents (ContainerElems_Container p, INTEGER x0, INTEGER y0)
{
	ContainerElems_Case c = NIL;
	c = p->contents;
	while (c != NIL) {
		ContainerElems_PrintTextElem(p, c, x0, y0);
		c = c->next;
	}
}

static struct RefreshArea__38 {
	ContainerElems_Frame *f;
	INTEGER *x, *y, *w, *h;
	INTEGER *ew, *eh;
	struct RefreshArea__38 *lnk;
} *RefreshArea__38_s;

static void ReDraw__39 (ContainerElems_Case c);

static void ReDraw__39 (ContainerElems_Case c)
{
	if (c != NIL) {
		ReDraw__39(c->next);
		*RefreshArea__38_s->ew = (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit);
		*RefreshArea__38_s->eh = (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit);
		if (ContainerElems_InArea(*RefreshArea__38_s->x, *RefreshArea__38_s->y, *RefreshArea__38_s->w, *RefreshArea__38_s->h, c->x, c->y, *RefreshArea__38_s->ew, *RefreshArea__38_s->eh)) {
			ContainerElems_DrawTextElem((*RefreshArea__38_s->f)->container, c->e, (void*)*RefreshArea__38_s->f, (*RefreshArea__38_s->f)->x, (*RefreshArea__38_s->f)->y);
		}
	}
}

static void ContainerElems_RefreshArea (ContainerElems_Frame f, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h)
{
	ContainerElems_Case c = NIL;
	BOOLEAN done = 0;
	INTEGER ew = 0, eh = 0;
	struct RefreshArea__38 _s;
	_s.f = &f;
	_s.x = x;
	_s.y = y;
	_s.w = w;
	_s.h = h;
	_s.ew = &ew;
	_s.eh = &eh;
	_s.lnk = RefreshArea__38_s;
	RefreshArea__38_s = &_s;
	done = 0;
	while (!done) {
		done = 1;
		c = f->container->contents;
		while (c != NIL && done) {
			ew = (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit);
			eh = (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit);
			if (!ContainerElems_InArea(*x, *y, *w, *h, c->x, c->y, ew, eh) && ContainerElems_OverlapsArea(*x, *y, *w, *h, c->x, c->y, ew, eh)) {
				done = 0;
				if (c->x < *x) {
					*w = (*w + *x) - c->x;
					*x = c->x;
				}
				if (c->x + ew > *x + *w) {
					*w = ((*w + c->x) + ew) - (*x + *w);
				}
				if (c->y > *y) {
					*h = (*h + c->y) - *y;
					*y = c->y;
				}
				if (c->y - eh < *y - *h) {
					*h = *h + ((*y - *h) - (c->y - eh));
				}
			}
			c = c->next;
		}
	}
	Oberon_RemoveMarks(f->x + *x, (f->Y + f->H) - *y, *w, *h);
	ContainerElems_RemoveSubFrames(f, f->x + *x, (f->Y + f->H) - *y, *w, *h);
	ReDraw__39(f->container->contents);
	RefreshArea__38_s = _s.lnk;
}

static void ContainerElems_ClearArea (ContainerElems_Frame f, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	Fonts_Font fnt = NIL;
	SHORTINT color = 0;
	Oberon_RemoveMarks(f->x + x, (f->Y + f->H) - y, w, h);
	Elems_GetLook((void*)f->container, &fnt, &color);
	GUtils_ReplConst((void*)f, color, x + f->x, (f->Y + f->H) - y, w, h, 1);
}

void ContainerElems_UpdateArea (ContainerElems_Container c, INTEGER x, INTEGER y, INTEGER w, INTEGER h, SET id)
{
	ContainerElems_NotifyMsg u = {0};
	u.id = id;
	u.c = c;
	u.x = x;
	u.y = y;
	u.w = w;
	u.h = h;
	Viewers_Broadcast((void*)&u, ContainerElems_NotifyMsg__typ);
}

static void ContainerElems_ChangePos (ContainerElems_Frame f, ContainerElems_Case c, INTEGER dx, INTEGER dy)
{
	ContainerElems_Selection s = NIL;
	INTEGER x = 0, y = 0, h = 0, w = 0;
	if (c == NIL) {
		s = f->container->sel;
		while (s != NIL) {
			ContainerElems_ChangePos(f, s->c, dx, dy);
			s = s->next;
		}
	} else {
		h = (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit);
		w = (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit);
		x = c->x;
		y = c->y;
		ContainerElems_ToTop(f->container, c);
		c->x = c->x + dx;
		c->y = c->y + dy;
		if (c->x < 0) {
			c->x = 0;
		}
		if (c->y - h < 0) {
			c->y = h;
		}
		ContainerElems_UpdateArea(f->container, x, y, w, h, 0x0c);
		if (!ContainerElems_OverlapsArea(x, y, w, h, c->x, c->y, w, h)) {
			Elems_UpdateElem(c->e);
		}
	}
}

static void ContainerElems_InvertMoving (ContainerElems_Frame f, ContainerElems_Case c, INTEGER dx, INTEGER dy)
{
	ContainerElems_Selection s = NIL;
	if (c == NIL) {
		s = f->container->sel;
		while (s != NIL) {
			ContainerElems_InvertMoving(f, s->c, dx, dy);
			s = s->next;
		}
	} else {
		GUtils_Frame(NIL, 15, (f->X + c->x) + dx, ((f->Y + f->H) - c->y) - dy, (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit), (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit), 1, 2);
	}
}

static void ContainerElems_Move (ContainerElems_Frame f, ContainerElems_Case c)
{
	SET keys = 0, keysum = 0;
	INTEGER begX = 0, begY = 0, dx = 0, dy = 0, X = 0, Y = 0, ox = 0, oy = 0;
	ContainerElems_NotifyMsg notify = {0};
	Input_Mouse(&keys, &begX, &begY);
	keysum = 0x0;
	dx = 0;
	dy = 0;
	ox = -1;
	oy = -1;
	notify.c = f->container;
	notify.case_ = c;
	notify.id = 0x10;
	notify.x = dx;
	notify.y = dy;
	Viewers_Broadcast((void*)&notify, ContainerElems_NotifyMsg__typ);
	do {
		Input_Mouse(&keys, &X, &Y);
		keysum = keysum | keys;
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, X, Y);
		if (ox != X || oy != Y) {
			Viewers_Broadcast((void*)&notify, ContainerElems_NotifyMsg__typ);
			dx = X - begX;
			dy = begY - Y;
			ox = X;
			oy = Y;
			notify.x = dx;
			notify.y = dy;
			Viewers_Broadcast((void*)&notify, ContainerElems_NotifyMsg__typ);
		}
	} while (!(keys == 0x0 || __IN(0, keysum)));
	Viewers_Broadcast((void*)&notify, ContainerElems_NotifyMsg__typ);
	if (!__IN(0, keysum)) {
		ContainerElems_ChangePos(f, c, dx, dy);
	}
}

static void ContainerElems_Notify (Texts_Text T, INTEGER op, LONGINT beg, LONGINT end)
{
	ContainerElems_Case c = NIL;
	Texts_Reader r = {0};
	INTEGER w = 0, h = 0;
	if (__ISP(T, ContainerElems_TextDesc, 1)) {
		Texts_OpenReader(&r, Texts_Reader__typ, (void*)(*(ContainerElems_Text*)&T), beg);
		Texts_ReadElem(&r, Texts_Reader__typ);
		c = ContainerElems_MyCase((*(ContainerElems_Text*)&T)->base, r.elem);
		w = (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit);
		h = (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit);
		ContainerElems_UpdateArea((*(ContainerElems_Text*)&T)->base, c->x, c->y, w, h, 0x0c);
	} else __WITHCHK;
}

void ContainerElems_Init (ContainerElems_Container p)
{
	Elems_Init((void*)p);
	p->contents = NIL;
	p->lockedc = 0;
	__NEW(p->dummyText, ContainerElems_TextDesc);
	Texts_Open((void*)p->dummyText, (CHAR*)"", (LONGINT)1);
	p->dummyText->notify = ContainerElems_Notify;
	p->dummyText->base = p;
}

static void ContainerElems_InvertCaret (ContainerElems_Frame f)
{
	INTEGER x = 0, y = 0;
	x = f->container->x + f->X;
	y = (f->Y + f->H) - f->container->y;
	GUtils_ReplConst((void*)f, 15, x - 5, y, 11, 1, 2);
	GUtils_ReplConst((void*)f, 15, x, y - 5, 1, 11, 2);
}

void ContainerElems_SetCaret (ContainerElems_Frame f, INTEGER X, INTEGER Y)
{
	Oberon_PassFocus(Viewers_This(f->X, f->Y));
	f->container->x = X;
	f->container->y = Y;
	f->hasCar = 1;
	ContainerElems_InvertCaret(f);
}

void ContainerElems_RemoveCaret (ContainerElems_Frame f)
{
	if (f->hasCar) {
		ContainerElems_InvertCaret(f);
		f->hasCar = 0;
	}
}

void ContainerElems_CopyContainer (ContainerElems_Container from, ContainerElems_Container to)
{
	ContainerElems_Case c = NIL;
	Texts_CopyMsg copy = {0};
	Fonts_Font fnt = NIL;
	SHORTINT col = 0;
	Texts_Notifier notifier = NIL;
	Elems_CopyElem((void*)from, (void*)to);
	ContainerElems_Init(to);
	to->lockedc = from->lockedc;
	notifier = to->dummyText->notify;
	to->dummyText->notify = ContainerElems_NoNotify;
	c = from->contents;
	while (c != NIL) {
		to->x = c->x;
		to->y = c->y;
		copy.e = NIL;
		(*c->e->handle)(c->e, (void*)&copy, Texts_CopyMsg__typ);
		Elems_GetLook(c->e, &fnt, &col);
		ContainerElems_InsertElem(to, copy.e, fnt, col);
		c = c->next;
	}
	to->dummyText->notify = notifier;
}

static void ContainerElems_ShowSubFrames (Display_Frame f)
{
	Display_Frame s = NIL;
	INTEGER i = 0, x = 0, y = 0;
	SET k = 0;
	i = 0;
	s = f->dsc;
	while (s != NIL) {
		Display_ReplConst(1, s->X, s->Y, s->W, s->H, 0);
		s = s->next;
		i += 1;
	}
	Out_Int(i, 0);
	Out_Ln();
}

static struct TrackRubberBand__58 {
	ContainerElems_Frame *f;
	INTEGER *x, *y, *w, *h;
	ContainerElems_Case *c;
	struct TrackRubberBand__58 *lnk;
} *TrackRubberBand__58_s;

static void CheckSelection__59 (void);
static void CorrectCoords__61 (INTEGER *coord, INTEGER *exp);

static void CorrectCoords__61 (INTEGER *coord, INTEGER *exp)
{
	if (*exp < 0) {
		*coord += *exp;
		*exp = __ABS(*exp);
	}
}

static void CheckSelection__59 (void)
{
	CorrectCoords__61(&*TrackRubberBand__58_s->x, &*TrackRubberBand__58_s->w);
	CorrectCoords__61(&*TrackRubberBand__58_s->y, &*TrackRubberBand__58_s->h);
	*TrackRubberBand__58_s->c = (*TrackRubberBand__58_s->f)->container->contents;
	while (*TrackRubberBand__58_s->c != NIL) {
		if (ContainerElems_InArea(*TrackRubberBand__58_s->x - (*TrackRubberBand__58_s->f)->X, ((*TrackRubberBand__58_s->f)->Y + (*TrackRubberBand__58_s->f)->H) - *TrackRubberBand__58_s->y, *TrackRubberBand__58_s->w, *TrackRubberBand__58_s->h, (*TrackRubberBand__58_s->c)->x, (*TrackRubberBand__58_s->c)->y, (int)__DIV((*TrackRubberBand__58_s->c)->e->W, (LONGINT)TextFrames_Unit), (int)__DIV((*TrackRubberBand__58_s->c)->e->H, (LONGINT)TextFrames_Unit))) {
			if (!__IN(1, (*TrackRubberBand__58_s->c)->state)) {
				(*TrackRubberBand__58_s->c)->state |= __SETOF(1);
				ContainerElems_AppendToSelection((*TrackRubberBand__58_s->f)->container, *TrackRubberBand__58_s->c);
				ContainerElems_InvertSelected(*TrackRubberBand__58_s->f, *TrackRubberBand__58_s->c);
			}
		} else {
			if (__IN(1, (*TrackRubberBand__58_s->c)->state)) {
				(*TrackRubberBand__58_s->c)->state &= ~__SETOF(1);
				ContainerElems_RemoveFromSelection((*TrackRubberBand__58_s->f)->container, *TrackRubberBand__58_s->c);
				ContainerElems_InvertSelected(*TrackRubberBand__58_s->f, *TrackRubberBand__58_s->c);
			}
		}
		*TrackRubberBand__58_s->c = (*TrackRubberBand__58_s->c)->next;
	}
}

static void ContainerElems_TrackRubberBand (ContainerElems_Frame f, INTEGER ix, INTEGER iy, SET keys)
{
	INTEGER x = 0, y = 0, w = 0, h = 0, ox = 0, oy = 0, mx = 0, my = 0;
	SET keysum = 0;
	ContainerElems_Case c = NIL;
	struct TrackRubberBand__58 _s;
	_s.f = &f;
	_s.x = &x;
	_s.y = &y;
	_s.w = &w;
	_s.h = &h;
	_s.c = &c;
	_s.lnk = TrackRubberBand__58_s;
	TrackRubberBand__58_s = &_s;
	keysum = keys;
	ox = -1;
	oy = -1;
	do {
		Input_Mouse(&keys, &mx, &my);
		keysum = keysum | keys;
		if (ox != mx || oy != my) {
			GUtils_Frame((void*)f, 0, x, y, w, h, 1, 2);
			x = ix;
			y = iy;
			w = mx - ix;
			h = my - iy;
			ox = mx;
			oy = my;
			CheckSelection__59();
			GUtils_Frame((void*)f, 0, x, y, w, h, 1, 2);
		}
	} while (!(keys == 0x0));
	GUtils_Frame((void*)f, 0, x, y, w, h, 1, 2);
	if (keysum == 0x05) {
		ContainerElems_DeleteSelection(f);
	} else if (keysum == 0x03) {
		ContainerElems_SendSelection(f);
	} else if (keysum == 0x07) {
		ContainerElems_RemoveSelection(f);
	}
	TrackRubberBand__58_s = _s.lnk;
}

static void ContainerElems_HandleInput (ContainerElems_Frame f, Oberon_InputMsg *msg, LONGINT *msg__typ)
{
	INTEGER X = 0, Y = 0, x = 0, y = 0, w = 0, h = 0;
	TextFrames_TrackMsg track = {0};
	SET keysum = 0;
	ContainerElems_Case c = NIL;
	BOOLEAN done = 0;
	Display_Frame sub = NIL;
	Texts_Notifier notifier = NIL;
	keysum = (*msg).keys;
	if ((*msg).id == 1) {
		if ((*msg).keys == 0x04) {
			sub = ContainerElems_ThisSubFrame(f, (*msg).X, (*msg).Y);
			if (sub != NIL) {
				(*sub->handle)(sub, (void*)&*msg, msg__typ);
			} else if (!f->container->lockedc) {
				ContainerElems_SetCaret(f, (*msg).X - f->X, (f->Y + f->H) - (*msg).Y);
				do {
					Input_Mouse(&(*msg).keys, &(*msg).X, &(*msg).Y);
					keysum = keysum | (*msg).keys;
					Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, (*msg).X, (*msg).Y);
				} while (!((*msg).keys == 0x0));
				if (keysum == 0x06) {
					ContainerElems_InvertCaret(f);
					ContainerElems_CopyInto(f->container);
					ContainerElems_InvertCaret(f);
				}
			}
		} else if ((*msg).keys == 0x01) {
			f->selTime = Oberon_Time();
			sub = ContainerElems_ThisSubFrame(f, (*msg).X, (*msg).Y);
			c = ContainerElems_ThisCase(f->container, (*msg).X, (*msg).Y, f->X, f->Y);
			if (c == NIL && !f->container->lockedc) {
				ContainerElems_RemoveSelection(f);
				ContainerElems_TrackRubberBand(f, (*msg).X, (*msg).Y, (*msg).keys);
			} else if (!f->container->lockedc && (sub == NIL || ContainerElems_InBorder((*msg).X, (*msg).Y, sub->X, sub->Y, sub->W, sub->H))) {
				if (__IN(1, c->state)) {
					c->state &= ~__SETOF(1);
				} else {
					c->state |= __SETOF(1);
				}
				Elems_UpdateElem(c->e);
				if (__IN(1, c->state)) {
					ContainerElems_AppendToSelection(f->container, c);
				} else {
					ContainerElems_RemoveFromSelection(f->container, c);
				}
				do {
					Input_Mouse(&(*msg).keys, &X, &Y);
					keysum = keysum | (*msg).keys;
					Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, X, Y);
				} while (!((*msg).keys == 0x0));
				if (keysum == 0x05) {
					ContainerElems_DeleteSelection(f);
				} else if (keysum == 0x03) {
					ContainerElems_SendSelection(f);
				}
			} else if (sub != NIL) {
				(*sub->handle)(sub, (void*)&*msg, msg__typ);
			}
		} else if ((*msg).keys == 0x02) {
			track.X0 = f->X;
			track.Y0 = f->Y;
			track.X = (*msg).X;
			track.Y = (*msg).Y;
			track.keys = (*msg).keys;
			track.frame = (Display_Frame)f;
			done = 0;
			if (!f->container->lockedc) {
				Elems_Track((void*)f->container, (void*)&track, TextFrames_TrackMsg__typ, &done);
				if (done) {
					Elems_UpdateElem((void*)f->container);
				}
			}
			if (!done) {
				c = ContainerElems_ThisCase(f->container, (*msg).X, (*msg).Y, f->x, f->y);
				sub = ContainerElems_ThisSubFrame(f, (*msg).X, (*msg).Y);
				if (sub != NIL && !ContainerElems_InBorder((*msg).X, (*msg).Y, sub->X, sub->Y, sub->W, sub->H)) {
					(*sub->handle)(sub, (void*)&*msg, msg__typ);
				} else {
					ContainerElems_RemoveCaret(f);
					if (c == NIL && f->container->sel != NIL || c != NIL && __IN(1, c->state)) {
						if (f->container->sel != NIL) {
							c = NIL;
						}
						ContainerElems_Move(f, c);
					} else if (c != NIL) {
						w = (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit);
						h = (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit);
						if ((!f->container->locked && ContainerElems_InBorder((*msg).X, (*msg).Y, f->x + c->x, (f->y - c->y) + f->H, w, h)) && !Elems_InCorner((*msg).X, (*msg).Y, f->x + c->x, (f->y - c->y) + f->H, w, c->e)) {
							ContainerElems_Move(f, c);
						} else {
							Elems_GetLook(c->e, &track.fnt, &track.col);
							track.X0 = c->x + f->x;
							track.Y0 = (f->y + f->H) - c->y;
							if (__ISP(c->e, Elems_ElemDesc, 2)) {
								track.frame = (Display_Frame)f;
							} else {
								track.frame = (Display_Frame)ContainerElems_dummyTextFrame;
							}
							done = 0;
							if (Elems_InCorner((*msg).X, (*msg).Y, f->x + c->x, ((f->y + f->H) - c->y) + 1, w, c->e)) {
								if (!f->container->locked) {
									ContainerElems_ToTop(f->container, c);
									x = c->x;
									y = c->y;
									w = (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit);
									h = (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit);
									notifier = f->container->dummyText->notify;
									f->container->dummyText->notify = ContainerElems_NoNotify;
									Elems_Track(c->e, (void*)&track, TextFrames_TrackMsg__typ, &done);
									f->container->dummyText->notify = notifier;
									if (done) {
										ContainerElems_UpdateArea(f->container, x, y, w, h, 0x08);
										c->y = y + ((int)__DIV(c->e->H, (LONGINT)TextFrames_Unit) - h);
										if (c->y < 0) {
											c->y = 0;
										}
										ContainerElems_UpdateArea(f->container, x, y, w, h, 0x04);
									}
								} else {
									done = 1;
								}
							}
							if (!done) {
								if (__ISP(c->e, Elems_ElemDesc, 2) || ContainerElems_FullyVisible((void*)f, c, w, h)) {
									ContainerElems_ToTop(f->container, c);
									(*c->e->handle)(c->e, (void*)&track, TextFrames_TrackMsg__typ);
								}
							}
						}
					}
				}
			}
		}
	} else if ((*msg).id == 0 && f->hasCar) {
		if ((*msg).ch == 0xc4) {
			ContainerElems_ChangePos(f, NIL, -1, 0);
		} else if ((*msg).ch == 0xc3) {
			ContainerElems_ChangePos(f, NIL, 1, 0);
		} else if ((*msg).ch == 0xc2) {
			ContainerElems_ChangePos(f, NIL, 0, 1);
		} else if ((*msg).ch == 0xc1) {
			ContainerElems_ChangePos(f, NIL, 0, -1);
		}
	} else {
		ContainerElems_NotifySubFrames(f, (void*)&*msg, msg__typ);
	}
}

void ContainerElems_FrameHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	Display_Frame sub = NIL;
	if (__ISP(f, ContainerElems_FrameDesc, 1)) {
		if (__IS(msg__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *msg__ = (void*)msg;
			ContainerElems_HandleInput((*(ContainerElems_Frame*)&f), &*msg__, msg__typ);
		} else if (__IS(msg__typ, Oberon_ControlMsg, 1)) {
			Oberon_ControlMsg *msg__ = (void*)msg;
			ContainerElems_NotifySubFrames((*(ContainerElems_Frame*)&f), (void*)&*msg__, msg__typ);
			if ((*(ContainerElems_Frame*)&f)->hasCar && __IN((*msg__).id, 0x03)) {
				ContainerElems_RemoveCaret((*(ContainerElems_Frame*)&f));
			}
			if ((*msg__).id == 1) {
				ContainerElems_RemoveSelection((*(ContainerElems_Frame*)&f));
			}
		} else if (__IS(msg__typ, TextFrames_InsertElemMsg, 1)) {
			TextFrames_InsertElemMsg *msg__ = (void*)msg;
			if ((*(ContainerElems_Frame*)&f)->hasCar) {
				ContainerElems_InvertCaret((*(ContainerElems_Frame*)&f));
				ContainerElems_InsertElem((*(ContainerElems_Frame*)&f)->container, (*msg__).e, Fonts_Default, 15);
				Elems_UpdateElem((*msg__).e);
				ContainerElems_InvertCaret((*(ContainerElems_Frame*)&f));
			} else {
				ContainerElems_NotifySubFrames((*(ContainerElems_Frame*)&f), (void*)&*msg__, msg__typ);
			}
		} else if (__IS(msg__typ, Oberon_CopyOverMsg, 1)) {
			Oberon_CopyOverMsg *msg__ = (void*)msg;
			if ((*(ContainerElems_Frame*)&f)->hasCar) {
				ContainerElems_InvertCaret((*(ContainerElems_Frame*)&f));
				ContainerElems_CopyOver((*(ContainerElems_Frame*)&f)->container, &*msg__, msg__typ);
				ContainerElems_InvertCaret((*(ContainerElems_Frame*)&f));
			} else {
				ContainerElems_NotifySubFrames((*(ContainerElems_Frame*)&f), (void*)&*msg__, msg__typ);
			}
		} else if (__IS(msg__typ, Oberon_SelectionMsg, 1)) {
			Oberon_SelectionMsg *msg__ = (void*)msg;
			ContainerElems_NotifySubFrames((*(ContainerElems_Frame*)&f), (void*)&*msg__, msg__typ);
			if ((*(ContainerElems_Frame*)&f)->container->sel != NIL && (*(ContainerElems_Frame*)&f)->selTime > (*msg__).time) {
				if (__IS(msg__typ, ContainerElems_SelectionMsg, 2)) {
					__GUARDR(msg, ContainerElems_SelectionMsg, 2).p = (*(ContainerElems_Frame*)&f)->container;
					__GUARDR(msg, ContainerElems_SelectionMsg, 2).sel = (*(ContainerElems_Frame*)&f)->container->sel;
				} else {
					(*msg__).text = ContainerElems_SelectionToText((*(ContainerElems_Frame*)&f));
					(*msg__).beg = 0;
					(*msg__).end = (*msg__).text->len;
				}
				(*msg__).time = (*(ContainerElems_Frame*)&f)->selTime;
			}
		} else if (__IS(msg__typ, MenuViewers_ModifyMsg, 1)) {
			MenuViewers_ModifyMsg *msg__ = (void*)msg;
			if ((*(ContainerElems_Frame*)&f)->oldY != (*(ContainerElems_Frame*)&f)->Y && (*msg__).H != 0) {
				sub = (*(ContainerElems_Frame*)&f)->dsc;
				while (sub != NIL) {
					sub->Y += (*(ContainerElems_Frame*)&f)->Y - (*(ContainerElems_Frame*)&f)->oldY;
					(*msg__).Y = sub->Y;
					(*msg__).H = sub->H;
					(*sub->handle)(sub, (void*)&*msg__, msg__typ);
					sub = sub->next;
				}
				(*(ContainerElems_Frame*)&f)->y += (*(ContainerElems_Frame*)&f)->Y - (*(ContainerElems_Frame*)&f)->oldY;
				(*(ContainerElems_Frame*)&f)->oldY = (*(ContainerElems_Frame*)&f)->Y;
			}
		} else if (__IS(msg__typ, Elems_GetContextMsg, 1)) {
			Elems_GetContextMsg *msg__ = (void*)msg;
			if ((*msg__).p == (void *) (*(ContainerElems_Frame*)&f)->container && ((*msg__).fx == (*(ContainerElems_Frame*)&f)->X && (*msg__).fy == (*(ContainerElems_Frame*)&f)->Y || (*msg__).fx < 0 && (*msg__).fy < 0)) {
				(*msg__).context = (Display_Frame)(*(ContainerElems_Frame*)&f);
				(*msg__).p = NIL;
			} else {
				ContainerElems_NotifySubFrames((*(ContainerElems_Frame*)&f), (void*)&*msg__, msg__typ);
			}
		} else if (__IS(msg__typ, ContainerElems_NotifyMsg, 1)) {
			ContainerElems_NotifyMsg *msg__ = (void*)msg;
			if ((*msg__).c == (*(ContainerElems_Frame*)&f)->container) {
				if ((*msg__).id == 0x02) {
					ContainerElems_ToTop((*(ContainerElems_Frame*)&f)->container, ContainerElems_MyCase((*(ContainerElems_Frame*)&f)->container, (*msg__).elem));
					ContainerElems_DrawTextElem((*(ContainerElems_Frame*)&f)->container, (*msg__).elem, (void*)(*(ContainerElems_Frame*)&f), (*(ContainerElems_Frame*)&f)->X, (*(ContainerElems_Frame*)&f)->Y);
				} else if ((*msg__).id == 0x10) {
					ContainerElems_InvertMoving((*(ContainerElems_Frame*)&f), (*msg__).case_, (*msg__).x, (*msg__).y);
				} else {
					if (__IN(3, (*msg__).id)) {
						ContainerElems_ClearArea((*(ContainerElems_Frame*)&f), (*msg__).x, (*msg__).y, (*msg__).w, (*msg__).h);
					}
					if (__IN(2, (*msg__).id)) {
						ContainerElems_RefreshArea((*(ContainerElems_Frame*)&f), &(*msg__).x, &(*msg__).y, &(*msg__).w, &(*msg__).h);
					}
				}
			} else {
				ContainerElems_NotifySubFrames((*(ContainerElems_Frame*)&f), (void*)&*msg__, msg__typ);
			}
		} else {
			ContainerElems_NotifySubFrames((*(ContainerElems_Frame*)&f), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

static void ContainerElems_HandleAttrMsg (ContainerElems_Container p, Elems_AttrMsg *msg, LONGINT *msg__typ)
{
	if ((*msg).id == 1) {
		if (__STRCMP((*msg).name, "Locked") == 0) {
			(*msg).b = p->locked;
			(*msg).class = 7;
		} else {
			Elems_Handle((void*)p, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 2) {
		if (__STRCMP((*msg).name, "Locked") == 0) {
			if ((*msg).class == 7) {
				p->locked = (*msg).b;
			}
		} else {
			Elems_Handle((void*)p, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 3) {
		Elems_Handle((void*)p, (void*)&*msg, msg__typ);
		(*(*msg).enum_)((CHAR*)"Locked", (LONGINT)7, 7);
	} else {
		Elems_Handle((void*)p, (void*)&*msg, msg__typ);
	}
}

static void ContainerElems_HandleFileMsg (ContainerElems_Container *p, Texts_FileMsg *msg, LONGINT *msg__typ)
{
	ContainerElems_Case c = NIL, last = NIL;
	Fonts_Font fnt = NIL;
	SHORTINT col = 0;
	BOOLEAN eof = 0;
	CHAR ch = 0;
	Texts_Notifier notifier = NIL;
	if ((*msg).id == 0) {
		notifier = (*p)->dummyText->notify;
		(*p)->dummyText->notify = ContainerElems_NoNotify;
		Files_Read(&(*msg).r, Files_Rider__typ, (void*)&ch);
		Files_ReadBool(&(*msg).r, Files_Rider__typ, &(*p)->locked);
		Files_ReadBool(&(*msg).r, Files_Rider__typ, &eof);
		(*p)->contents = NIL;
		last = NIL;
		while (!eof) {
			__NEW(c, ContainerElems_CaseDesc);
			ContainerElems_LoadCase(&*msg, msg__typ, &c, &fnt, &col);
			c->next = NIL;
			if ((*p)->contents == NIL) {
				(*p)->contents = c;
			} else {
				last->next = c;
			}
			last = c;
			Texts_SetFont(&ContainerElems_W, Texts_Writer__typ, fnt);
			Texts_SetColor(&ContainerElems_W, Texts_Writer__typ, col);
			Texts_WriteElem(&ContainerElems_W, Texts_Writer__typ, c->e);
			Texts_Append((void*)(*p)->dummyText, ContainerElems_W.buf);
			Files_ReadBool(&(*msg).r, Files_Rider__typ, &eof);
		}
		(*p)->dummyText->notify = notifier;
	} else if ((*msg).id == 1) {
		Files_Write(&(*msg).r, Files_Rider__typ, 0x00);
		Files_WriteBool(&(*msg).r, Files_Rider__typ, (*p)->locked);
		Files_WriteBool(&(*msg).r, Files_Rider__typ, (*p)->contents == NIL);
		c = (*p)->contents;
		while (c != NIL) {
			ContainerElems_StoreCase(&*msg, msg__typ, c);
			Files_WriteBool(&(*msg).r, Files_Rider__typ, c->next == NIL);
			c = c->next;
		}
	}
}

void ContainerElems_Handle (Texts_Elem p, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	if (__ISP(p, ContainerElems_ContainerDesc, 3)) {
		if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *msg__ = (void*)msg;
			Elems_ToFrame((void*)(*(ContainerElems_Container*)&p), *msg__);
		} else if (__IS(msg__typ, Elems_AttrMsg, 1)) {
			Elems_AttrMsg *msg__ = (void*)msg;
			ContainerElems_HandleAttrMsg((*(ContainerElems_Container*)&p), &*msg__, msg__typ);
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *msg__ = (void*)msg;
			Elems_Handle((void*)(*(ContainerElems_Container*)&p), (void*)&*msg__, msg__typ);
			ContainerElems_HandleFileMsg(&(*(ContainerElems_Container*)&p), &*msg__, msg__typ);
		} else if (__IS(msg__typ, TextFrames_FocusMsg, 1)) {
			TextFrames_FocusMsg *msg__ = (void*)msg;
			Elems_Focusing(*msg__);
		} else if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *msg__ = (void*)msg;
			__HALT(99);
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *msg__ = (void*)msg;
			__HALT(99);
		} else {
			Elems_Handle((void*)(*(ContainerElems_Container*)&p), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&ContainerElems_W, Texts_Writer__typ, 36, 1, P);
	P(ContainerElems_dummyTextFrame);
}

__TDESC(ContainerElems_CaseDesc, 1, 2) = {__TDFLDS("CaseDesc", 16), {8, 12, -12}};
__TDESC(ContainerElems_SelectionDesc, 1, 2) = {__TDFLDS("SelectionDesc", 8), {0, 4, -12}};
__TDESC(ContainerElems_FrameDesc, 1, 3) = {__TDFLDS("FrameDesc", 36), {0, 4, 20, -16}};
__TDESC(ContainerElems_TextDesc, 1, 3) = {__TDFLDS("TextDesc", 24), {8, 12, 20, -16}};
__TDESC(ContainerElems_ContainerDesc, 1, 9) = {__TDFLDS("ContainerDesc", 68), {0, 4, 12, 32, 36, 44, 56, 60, 64, -40}};
__TDESC(ContainerElems_SelElemDesc, 1, 5) = {__TDFLDS("SelElemDesc", 40), {0, 4, 12, 32, 36, -24}};
__TDESC(ContainerElems_SelectionMsg, 1, 3) = {__TDFLDS("SelectionMsg", 24), {4, 16, 20, -16}};
__TDESC(ContainerElems_CopyOverMsg, 1, 3) = {__TDFLDS("CopyOverMsg", 20), {0, 12, 16, -16}};
__TDESC(ContainerElems_NotifyMsg, 1, 3) = {__TDFLDS("NotifyMsg", 24), {0, 8, 12, -16}};

export void *ContainerElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Elems);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(GUtils);
	__IMPORT(Input);
	__IMPORT(MenuViewers);
	__IMPORT(Modules);
	__IMPORT(Oberon);
	__IMPORT(Out);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(ContainerElems, EnumPtrs);
	__INITYP(ContainerElems_CaseDesc, ContainerElems_CaseDesc, 0);
	__INITYP(ContainerElems_SelectionDesc, ContainerElems_SelectionDesc, 0);
	__INITYP(ContainerElems_FrameDesc, Display_FrameDesc, 1);
	__INITYP(ContainerElems_TextDesc, Texts_TextDesc, 1);
	__INITYP(ContainerElems_ContainerDesc, Elems_ElemDesc, 3);
	__INITYP(ContainerElems_SelElemDesc, Texts_ElemDesc, 2);
	__INITYP(ContainerElems_SelectionMsg, Oberon_SelectionMsg, 2);
	__INITYP(ContainerElems_CopyOverMsg, Oberon_CopyOverMsg, 2);
	__INITYP(ContainerElems_NotifyMsg, Display_FrameMsg, 1);
/* BEGIN */
	ContainerElems_clp = Elems_clp;
	Texts_OpenWriter(&ContainerElems_W, Texts_Writer__typ);
	__NEW(ContainerElems_dummyTextFrame, TextFrames_FrameDesc);
	ContainerElems_dummyTextFrame->text = TextFrames_Text((CHAR*)"", (LONGINT)1);
	__ENDMOD;
}
