/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "GraphicFrames.h"
#include "Graphics.h"
#include "Oberon.h"
#include "Printer.h"

typedef
	struct Curves_CurveDesc *Curves_Curve;

typedef
	struct Curves_CurveDesc { /* Graphics_ObjectDesc */
		INTEGER x, y, w, h, col;
		BOOLEAN selected, marked;
		Graphics_Method do_;
		char _prvt0[8];
		INTEGER kind, lw;
	} Curves_CurveDesc;


export Graphics_Method Curves_method;

export LONGINT *Curves_CurveDesc__typ;

static void Curves_Copy (Graphics_Object src, Graphics_Object dst);
static void Curves_Draw (Graphics_Object obj, Graphics_Msg *M, LONGINT *M__typ);
static void Curves_Handle (Graphics_Object obj, Graphics_Msg *M, LONGINT *M__typ);
export void Curves_MakeCircle (void);
export void Curves_MakeEllipse (void);
export void Curves_MakeLine (void);
export void Curves_New (void);
static void Curves_Print (Graphics_Object obj, INTEGER x, INTEGER y);
static void Curves_Read (Graphics_Object obj, Files_Rider *R, LONGINT *R__typ, Graphics_Context *C, LONGINT *C__typ);
static BOOLEAN Curves_Selectable (Graphics_Object obj, INTEGER x, INTEGER y);
static void Curves_Write (Graphics_Object obj, SHORTINT cno, Files_Rider *W, LONGINT *W__typ, Graphics_Context *C, LONGINT *C__typ);
static void Curves_circle (GraphicFrames_Frame f, INTEGER col, LONGINT x0, LONGINT y0, LONGINT r);
static void Curves_ellipse (GraphicFrames_Frame f, INTEGER col, LONGINT x0, LONGINT y0, LONGINT a, LONGINT b);
static void Curves_line (GraphicFrames_Frame f, INTEGER col, LONGINT x, LONGINT y, LONGINT w, LONGINT h, LONGINT d);
static void Curves_mark (GraphicFrames_Frame f, INTEGER col, INTEGER x, INTEGER y);


static void Curves_mark (GraphicFrames_Frame f, INTEGER col, INTEGER x, INTEGER y)
{
	Display_ReplConstC((void*)f, col, x, y, 4, 4, 0);
}

static void Curves_line (GraphicFrames_Frame f, INTEGER col, LONGINT x, LONGINT y, LONGINT w, LONGINT h, LONGINT d)
{
	LONGINT x1 = 0, y1 = 0, u = 0;
	if (h < w) {
		x1 = x + w;
		u = __ASHR(h - w, 1);
		if (d == -1) {
			y += h;
		}
		while (x < x1) {
			Display_DotC((void*)f, col, (int)x, (int)y, 0);
			x += 1;
			if (u < 0) {
				u += h;
			} else {
				u += h - w;
				y += d;
			}
		}
	} else {
		y1 = y + h;
		u = __ASHR(w - h, 1);
		if (d == -1) {
			x += w;
		}
		while (y < y1) {
			Display_DotC((void*)f, col, (int)x, (int)y, 0);
			y += 1;
			if (u < 0) {
				u += w;
			} else {
				u += w - h;
				x += d;
			}
		}
	}
}

static void Curves_circle (GraphicFrames_Frame f, INTEGER col, LONGINT x0, LONGINT y0, LONGINT r)
{
	LONGINT x = 0, y = 0, u = 0;
	u = 1 - r;
	x = r;
	y = 0;
	while (y <= x) {
		Display_DotC((void*)f, col, (int)(x0 + x), (int)(y0 + y), 0);
		Display_DotC((void*)f, col, (int)(x0 + y), (int)(y0 + x), 0);
		Display_DotC((void*)f, col, (int)(x0 - y), (int)(y0 + x), 0);
		Display_DotC((void*)f, col, (int)(x0 - x), (int)(y0 + y), 0);
		Display_DotC((void*)f, col, (int)(x0 - x), (int)(y0 - y), 0);
		Display_DotC((void*)f, col, (int)(x0 - y), (int)(y0 - x), 0);
		Display_DotC((void*)f, col, (int)(x0 + y), (int)(y0 - x), 0);
		Display_DotC((void*)f, col, (int)(x0 + x), (int)(y0 - y), 0);
		if (u < 0) {
			u += __ASHL(y, 1) + 3;
		} else {
			u += __ASHL(y - x, 1) + 5;
			x -= 1;
		}
		y += 1;
	}
}

static void Curves_ellipse (GraphicFrames_Frame f, INTEGER col, LONGINT x0, LONGINT y0, LONGINT a, LONGINT b)
{
	LONGINT x = 0, y = 0, y1 = 0, aa = 0, bb = 0, d = 0, g = 0, h = 0;
	aa = a * a;
	bb = b * b;
	h = (__ASHR(aa, 2) - b * aa) + bb;
	g = (__ASHR(9 * aa, 2) - (3 * b) * aa) + bb;
	x = 0;
	y = b;
	while (g < 0) {
		Display_DotC((void*)f, col, (int)(x0 + x), (int)(y0 + y), 0);
		Display_DotC((void*)f, col, (int)(x0 - x), (int)(y0 + y), 0);
		Display_DotC((void*)f, col, (int)(x0 - x), (int)(y0 - y), 0);
		Display_DotC((void*)f, col, (int)(x0 + x), (int)(y0 - y), 0);
		if (h < 0) {
			d = (__ASHL(x, 1) + 3) * bb;
			g += d;
		} else {
			d = (__ASHL(x, 1) + 3) * bb - __ASHL(y - 1, 1) * aa;
			g += d + __ASHL(aa, 1);
			y -= 1;
		}
		h += d;
		x += 1;
	}
	y1 = y;
	h = (__ASHR(bb, 2) - a * bb) + aa;
	x = a;
	y = 0;
	while (y <= y1) {
		Display_DotC((void*)f, col, (int)(x0 + x), (int)(y0 + y), 0);
		Display_DotC((void*)f, col, (int)(x0 - x), (int)(y0 + y), 0);
		Display_DotC((void*)f, col, (int)(x0 - x), (int)(y0 - y), 0);
		Display_DotC((void*)f, col, (int)(x0 + x), (int)(y0 - y), 0);
		if (h < 0) {
			h += (__ASHL(y, 1) + 3) * aa;
		} else {
			h += (__ASHL(y, 1) + 3) * aa - __ASHL(x - 1, 1) * bb;
			x -= 1;
		}
		y += 1;
	}
}

void Curves_New (void)
{
	Curves_Curve c = NIL;
	__NEW(c, Curves_CurveDesc);
	c->do_ = Curves_method;
	Graphics_new = (Graphics_Object)c;
}

static void Curves_Copy (Graphics_Object src, Graphics_Object dst)
{
	dst->x = src->x;
	dst->y = src->y;
	dst->w = src->w;
	dst->h = src->h;
	dst->col = src->col;
	__GUARDP(dst, Curves_CurveDesc, 1)->kind = __GUARDP(src, Curves_CurveDesc, 1)->kind;
	__GUARDP(dst, Curves_CurveDesc, 1)->lw = __GUARDP(src, Curves_CurveDesc, 1)->lw;
}

static void Curves_Draw (Graphics_Object obj, Graphics_Msg *M, LONGINT *M__typ)
{
	INTEGER x = 0, y = 0, w = 0, h = 0, col = 0;
	GraphicFrames_Frame f = NIL;
	if (__IS(M__typ, GraphicFrames_DrawMsg, 1)) {
		GraphicFrames_DrawMsg *M__ = (void*)M;
		x = obj->x + (*M__).x;
		y = obj->y + (*M__).y;
		w = obj->w;
		h = obj->h;
		f = (*M__).f;
		if ((*M__).col == 0) {
			col = obj->col;
		} else {
			col = (*M__).col;
		}
		if (((x < f->X1 && f->X <= x + w) && y < f->Y1) && f->Y <= y + h) {
			if (__GUARDP(obj, Curves_CurveDesc, 1)->kind == 0) {
				if ((*M__).mode == 0) {
					if (obj->selected) {
						Curves_mark(f, 15, x, y);
					}
					Curves_line(f, col, x, y, w, h, 1);
				} else if ((*M__).mode == 1) {
					Curves_mark(f, 15, x, y);
				} else if ((*M__).mode == 2) {
					Curves_mark(f, f->col, x, y);
				} else {
					Curves_mark(f, f->col, x, y);
					Curves_line(f, f->col, x, y, w, h, 1);
				}
			} else if (__GUARDP(obj, Curves_CurveDesc, 1)->kind == 1) {
				if ((*M__).mode == 0) {
					if (obj->selected) {
						Curves_mark(f, 15, x, y + h);
					}
					Curves_line(f, col, x, y, w, h, -1);
				} else if ((*M__).mode == 1) {
					Curves_mark(f, 15, x, y + h);
				} else if ((*M__).mode == 2) {
					Curves_mark(f, f->col, x, y + h);
				} else {
					Curves_mark(f, f->col, x, y + h);
					Curves_line(f, f->col, x, y, w, h, -1);
				}
			} else if (__GUARDP(obj, Curves_CurveDesc, 1)->kind == 2) {
				w = __ASHR(w, 1);
				if ((*M__).mode == 0) {
					if (obj->selected) {
						Curves_mark(f, 15, x + w, y - 4);
					}
					Curves_circle(f, col, x + w, y + w, w);
				} else if ((*M__).mode == 1) {
					Curves_mark(f, 15, x + w, y - 4);
				} else if ((*M__).mode == 2) {
					Curves_mark(f, f->col, x + w, y - 4);
				} else {
					Curves_mark(f, f->col, x + w, y - 4);
					Curves_circle(f, f->col, x + w, y + w, w);
				}
			} else if (__GUARDP(obj, Curves_CurveDesc, 1)->kind == 3) {
				w = __ASHR(w, 1);
				h = __ASHR(h, 1);
				if ((*M__).mode == 0) {
					if (obj->selected) {
						Curves_mark(f, 15, x + w, y - 4);
					}
					Curves_ellipse(f, col, x + w, y + h, w, h);
				} else if ((*M__).mode == 1) {
					Curves_mark(f, 15, x + w, y - 4);
				} else if ((*M__).mode == 2) {
					Curves_mark(f, f->col, x + w, y - 4);
				} else {
					Curves_mark(f, f->col, x + w, y - 4);
					Curves_ellipse(f, f->col, x + w, y + h, w, h);
				}
			}
		}
	} else __WITHCHK;
}

static BOOLEAN Curves_Selectable (Graphics_Object obj, INTEGER x, INTEGER y)
{
	INTEGER xm = 0, y0 = 0, w = 0, h = 0;
	if (__GUARDP(obj, Curves_CurveDesc, 1)->kind <= 1) {
		w = obj->w;
		h = obj->h;
		if (__GUARDP(obj, Curves_CurveDesc, 1)->kind == 1) {
			y0 = obj->y + h;
			h = -h;
		} else {
			y0 = obj->y;
		}
		return (obj->x <= x && x < obj->x + w) && __ABS((LONGINT)(y - y0) * (LONGINT)w - (LONGINT)(x - obj->x) * (LONGINT)h) < (LONGINT)__ASHL(w, 2);
	} else {
		xm = __ASHR(obj->w, 1) + obj->x;
		return ((xm - 4 <= x && x <= xm + 4) && obj->y - 4 <= y) && y <= obj->y + 4;
	}
	__RETCHK;
}

static void Curves_Handle (Graphics_Object obj, Graphics_Msg *M, LONGINT *M__typ)
{
	if (__IS(M__typ, Graphics_ColorMsg, 1)) {
		obj->col = __GUARDR(M, Graphics_ColorMsg, 1).col;
	}
}

static void Curves_Read (Graphics_Object obj, Files_Rider *R, LONGINT *R__typ, Graphics_Context *C, LONGINT *C__typ)
{
	INTEGER len = 0;
	Files_ReadInt(&*R, R__typ, &len);
	Files_ReadInt(&*R, R__typ, &__GUARDP(obj, Curves_CurveDesc, 1)->kind);
	Files_ReadInt(&*R, R__typ, &__GUARDP(obj, Curves_CurveDesc, 1)->lw);
}

static void Curves_Write (Graphics_Object obj, SHORTINT cno, Files_Rider *W, LONGINT *W__typ, Graphics_Context *C, LONGINT *C__typ)
{
	Graphics_WriteObj(&*W, W__typ, cno, obj);
	Files_WriteInt(&*W, W__typ, 4);
	Files_WriteInt(&*W, W__typ, __GUARDP(obj, Curves_CurveDesc, 1)->kind);
	Files_WriteInt(&*W, W__typ, __GUARDP(obj, Curves_CurveDesc, 1)->lw);
}

static void Curves_Print (Graphics_Object obj, INTEGER x, INTEGER y)
{
	INTEGER x0 = 0, y0 = 0;
	if (__GUARDP(obj, Curves_CurveDesc, 1)->kind == 0) {
		x0 = __ASHL(obj->x, 2) + x;
		y0 = __ASHL(obj->y, 2) + y;
		Printer_Line(x0, y0, __ASHL(obj->w, 2) + x0, __ASHL(obj->h, 2) + y0);
	} else if (__GUARDP(obj, Curves_CurveDesc, 1)->kind == 1) {
		x0 = __ASHL(obj->x, 2) + x;
		y0 = __ASHL(obj->y, 2) + y;
		Printer_Line(x0, __ASHL(obj->h, 2) + y0, __ASHL(obj->w, 2) + x0, y0);
	} else if (__GUARDP(obj, Curves_CurveDesc, 1)->kind == 2) {
		Printer_Circle(__ASHL(__ASHL(obj->x, 1) + obj->w, 1) + x, __ASHL(__ASHL(obj->y, 1) + obj->h, 1) + y, __ASHL(obj->w, 1));
	} else {
		Printer_Ellipse(__ASHL(__ASHL(obj->x, 1) + obj->w, 1) + x, __ASHL(__ASHL(obj->y, 1) + obj->h, 1) + y, __ASHL(obj->w, 1), __ASHL(obj->h, 1));
	}
}

void Curves_MakeLine (void)
{
	INTEGER x0 = 0, x1 = 0, y0 = 0, y1 = 0;
	Curves_Curve c = NIL;
	GraphicFrames_Frame G = NIL;
	G = GraphicFrames_Focus();
	if (G != NIL && G->mark.next != NIL) {
		GraphicFrames_Deselect(G);
		x0 = G->mark.x;
		y0 = G->mark.y;
		x1 = G->mark.next->x;
		y1 = G->mark.next->y;
		__NEW(c, Curves_CurveDesc);
		c->col = Oberon_CurCol;
		c->w = __ABS(x1 - x0);
		c->h = __ABS(y1 - y0);
		c->lw = Graphics_width;
		if (x0 <= x1) {
			c->x = x0;
			if (y0 <= y1) {
				c->kind = 0;
				c->y = y0;
			} else {
				c->kind = 1;
				c->y = y1;
			}
		} else {
			c->x = x1;
			if (y1 < y0) {
				c->kind = 0;
				c->y = y1;
			} else {
				c->kind = 1;
				c->y = y0;
			}
		}
		c->x -= G->x;
		c->y -= G->y;
		c->do_ = Curves_method;
		Graphics_Add(G->graph, (void*)c);
		GraphicFrames_Defocus(G);
		GraphicFrames_DrawObj(G, (void*)c);
	}
}

void Curves_MakeCircle (void)
{
	INTEGER x0 = 0, y0 = 0, r = 0;
	Curves_Curve c = NIL;
	GraphicFrames_Frame G = NIL;
	G = GraphicFrames_Focus();
	if (G != NIL && G->mark.next != NIL) {
		GraphicFrames_Deselect(G);
		x0 = G->mark.x;
		y0 = G->mark.y;
		r = __ABS(G->mark.next->x - x0);
		if (r > 4) {
			__NEW(c, Curves_CurveDesc);
			c->x = (x0 - r) - G->x;
			c->y = (y0 - r) - G->y;
			c->w = __ASHL(r, 1) + 1;
			c->h = c->w;
			c->kind = 2;
			c->col = Oberon_CurCol;
			c->lw = Graphics_width;
			c->do_ = Curves_method;
			Graphics_Add(G->graph, (void*)c);
			GraphicFrames_Defocus(G);
			GraphicFrames_DrawObj(G, (void*)c);
		}
	}
}

void Curves_MakeEllipse (void)
{
	INTEGER x0 = 0, y0 = 0, a = 0, b = 0;
	Curves_Curve c = NIL;
	GraphicFrames_Frame G = NIL;
	G = GraphicFrames_Focus();
	if ((G != NIL && G->mark.next != NIL) && G->mark.next->next != NIL) {
		GraphicFrames_Deselect(G);
		x0 = G->mark.x;
		y0 = G->mark.y;
		a = __ABS(G->mark.next->x - x0);
		b = __ABS(G->mark.next->next->y - y0);
		if (a > 4 && b > 4) {
			__NEW(c, Curves_CurveDesc);
			c->x = (x0 - a) - G->x;
			c->y = (y0 - b) - G->y;
			c->w = __ASHL(a, 1) + 1;
			c->h = __ASHL(b, 1) + 1;
			c->kind = 3;
			c->col = Oberon_CurCol;
			c->lw = Graphics_width;
			c->do_ = Curves_method;
			Graphics_Add(G->graph, (void*)c);
			GraphicFrames_Defocus(G);
			GraphicFrames_DrawObj(G, (void*)c);
		}
	}
}

static void EnumPtrs(void (*P)(void*))
{
	P(Curves_method);
}

__TDESC(Curves_CurveDesc, 1, 3) = {__TDFLDS("CurveDesc", 28), {12, 16, 20, -16}};

export void *Curves__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(GraphicFrames);
	__IMPORT(Graphics);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__REGMOD(Curves, EnumPtrs);
	__REGCMD("MakeCircle", Curves_MakeCircle);
	__REGCMD("MakeEllipse", Curves_MakeEllipse);
	__REGCMD("MakeLine", Curves_MakeLine);
	__REGCMD("New", Curves_New);
	__INITYP(Curves_CurveDesc, Graphics_ObjectDesc, 1);
/* BEGIN */
	__NEW(Curves_method, Graphics_MethodDesc);
	__MOVE("Curves", Curves_method->module, 7);
	__MOVE("New", Curves_method->allocator, 4);
	Curves_method->new = Curves_New;
	Curves_method->copy = Curves_Copy;
	Curves_method->draw = Curves_Draw;
	Curves_method->selectable = Curves_Selectable;
	Curves_method->handle = Curves_Handle;
	Curves_method->read = Curves_Read;
	Curves_method->write = Curves_Write;
	Curves_method->print = Curves_Print;
	__ENDMOD;
}
