/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "DialogFrames.h"
#include "Dialogs.h"
#include "Display.h"
#include "Display1.h"
#include "Files.h"
#include "In.h"
#include "Input.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "Printer.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"


export Oberon_Marker Dialog_reticule;
static Texts_Writer Dialog_w0;
static INTEGER Dialog_DW, Dialog_DH, Dialog_CL, Dialog_nx, Dialog_ny, Dialog_X1, Dialog_X0, Dialog_Y1, Dialog_Y0, Dialog_editObjectX, Dialog_editObjectY;


export void Dialog_AlignSelected (void);
static void Dialog_DisplaySelRect (DialogFrames_Frame f, SHORTINT col, INTEGER x0, INTEGER y0, INTEGER x, INTEGER y, INTEGER *xdif, INTEGER *ydif);
export void Dialog_Do (void);
static void Dialog_DrawReticule (INTEGER x, INTEGER y);
export void Dialog_Edit (void);
static void Dialog_EnumCopy (Dialogs_Object o, BOOLEAN *done);
export void Dialog_GetCmd (void);
export void Dialog_GetDim (void);
export void Dialog_GetInitCmd (void);
export void Dialog_GetName (void);
export void Dialog_GetPar (void);
export void Dialog_Handle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
static INTEGER Dialog_Min (INTEGER x, INTEGER y);
export void Dialog_Open (void);
export void Dialog_Print (void);
export void Dialog_RegulateDistance (void);
export void Dialog_SetCmd (void);
export void Dialog_SetDim (void);
export void Dialog_SetGrid (void);
export void Dialog_SetInitCmd (void);
export void Dialog_SetName (void);
export void Dialog_SetPar (void);
export void Dialog_Store (void);
static void Dialog_Track (DialogFrames_Frame f, SET keys, INTEGER x0, INTEGER y0, Dialogs_Object o);
static void Dialog_box (Dialogs_Object o, BOOLEAN *done);


static INTEGER Dialog_Min (INTEGER x, INTEGER y)
{
	if (x < y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

void Dialog_Open (void)
{
	INTEGER x = 0, y = 0, res = 0;
	Dialogs_Panel p = NIL;
	CHAR name[64];
	In_Open();
	In_Name((void*)name, 64);
	if (!In_Done) {
		In_String((void*)name, 64);
	}
	if (In_Done) {
		Oberon_AllocateSystemViewer(Oberon_Mouse.X, &x, &y);
		DialogFrames_OpenPanel(name, 64, x, y, &p);
	}
}

void Dialog_SetInitCmd (void)
{
	INTEGER x = 0, y = 0;
	Dialogs_Panel p = NIL;
	CHAR cmd[64];
	In_Open();
	In_Name((void*)cmd, 64);
	if (In_Done) {
		Dialogs_res = 0;
	} else {
		Dialogs_res = 4;
	}
	if (Dialogs_res == 0) {
		DialogFrames_GetCaretPosition(&p, &x, &y);
		if (p != NIL) {
			__Dialogs_Panel_SetCmd(p, cmd, 64);
		} else {
			Dialogs_res = 5;
		}
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"Dialog", (LONGINT)7);
	}
}

void Dialog_SetName (void)
{
	Dialogs_Object o = NIL;
	Dialogs_Panel p = NIL;
	CHAR name[16];
	In_Open();
	In_Name((void*)name, 16);
	if (In_Done) {
		Dialogs_res = 0;
	} else {
		In_Open();
		In_String((void*)name, 16);
		if (In_Done) {
			Dialogs_res = 0;
		} else {
			Dialogs_res = 4;
		}
	}
	if (Dialogs_res == 0) {
		DialogFrames_FindObject(&o, &p);
		if (Dialogs_res == 0) {
			__Dialogs_Object_SetName(o, name, 16);
		}
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"Dialog", (LONGINT)7);
	}
}

void Dialog_SetCmd (void)
{
	Dialogs_Object o = NIL;
	Dialogs_Panel p = NIL;
	CHAR cmd[32];
	In_Open();
	In_Name((void*)cmd, 32);
	if (In_Done) {
		Dialogs_res = 0;
	} else {
		Dialogs_res = 4;
	}
	if (Dialogs_res == 0) {
		DialogFrames_FindObject(&o, &p);
		if (Dialogs_res == 0) {
			__Dialogs_Object_SetCmd(o, cmd, 32);
		}
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"Dialog", (LONGINT)7);
	}
}

void Dialog_SetPar (void)
{
	Dialogs_Object o = NIL;
	Dialogs_Panel p = NIL;
	CHAR par[32];
	CHAR ch = 0;
	INTEGER i = 0;
	In_Open();
	In_Char(&ch);
	i = 0;
	while (In_Done && ch == ' ') {
		In_Char(&ch);
	}
	if (!In_Done) {
		Dialogs_res = 4;
	} else {
		Dialogs_res = 0;
		while (((In_Done && ch != 0x0d) && ch != '~') && i < 31) {
			par[__X(i, 32)] = ch;
			i += 1;
			In_Char(&ch);
		}
		par[__X(i, 32)] = 0x00;
	}
	if (Dialogs_res == 0) {
		DialogFrames_FindObject(&o, &p);
		if (Dialogs_res == 0) {
			__Dialogs_Object_SetPar(o, par, 32);
		}
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"Dialog", (LONGINT)7);
	}
}

void Dialog_SetDim (void)
{
	INTEGER x = 0, y = 0, w = 0, h = 0, x1 = 0, y1 = 0;
	Dialogs_Object o = NIL;
	Dialogs_Panel p = NIL;
	Viewers_Viewer v = NIL;
	In_Open();
	In_Int(&x);
	Dialogs_res = 0;
	if (!In_Done) {
		Dialogs_res = 4;
	}
	In_Int(&y);
	if (!In_Done) {
		Dialogs_res = 4;
	}
	In_Int(&w);
	if (!In_Done) {
		Dialogs_res = 4;
	}
	In_Int(&h);
	if (!In_Done) {
		Dialogs_res = 4;
	}
	DialogFrames_GetCaretPosition(&p, &x1, &y1);
	v = Viewers_This(x1, y1);
	if ((v == NIL || x > v->W) || __ABS(y) > v->H) {
		Dialogs_res = 4;
	}
	if (Dialogs_res == 0) {
		DialogFrames_FindObject(&o, &p);
		if (Dialogs_res == 0) {
			__Dialogs_Object_SetDim(o, x, y, w, h, 0);
		}
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"Dialog", (LONGINT)7);
	}
}

void Dialog_AlignSelected (void)
{
	CHAR dir = 0;
	INTEGER x = 0, y = 0;
	Dialogs_Panel p = NIL;
	CHAR name[64];
	In_Open();
	In_Name((void*)name, 64);
	Dialogs_res = 0;
	if (In_Done) {
		dir = name[0];
	}
	if (((dir != 'R' && dir != 'L') && dir != 'U') && dir != 'D') {
		Dialogs_res = 4;
	} else {
		DialogFrames_GetCaretPosition(&p, &x, &y);
		if (p != NIL) {
			__Dialogs_Panel_AlignSelected(p, dir);
		} else {
			Dialogs_res = 5;
		}
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"Dialog", (LONGINT)7);
	}
}

void Dialog_RegulateDistance (void)
{
	CHAR dir = 0;
	INTEGER i = 0, j = 0;
	Dialogs_Panel p = NIL;
	CHAR name[64];
	In_Open();
	In_Name((void*)name, 64);
	Dialogs_res = 0;
	if (In_Done) {
		dir = name[0];
	}
	if (((dir != 'R' && dir != 'L') && dir != 'U') && dir != 'D') {
		Dialogs_res = 4;
	} else {
		DialogFrames_GetCaretPosition(&p, &i, &j);
		if (p != NIL) {
			__Dialogs_Panel_RegulateDistance(p, dir);
		} else {
			Dialogs_res = 5;
		}
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"Dialog", (LONGINT)7);
	}
}

void Dialog_GetDim (void)
{
	INTEGER x = 0, y = 0, w = 0, h = 0;
	Dialogs_Object o = NIL;
	Dialogs_Panel p = NIL;
	DialogFrames_FindObject(&o, &p);
	if (Dialogs_res == 0) {
		__Dialogs_Object_GetDim(o, &x, &y, &w, &h);
		Texts_WriteString(&Dialog_w0, Texts_Writer__typ, (CHAR*)"Coor: ", (LONGINT)7);
		Texts_WriteInt(&Dialog_w0, Texts_Writer__typ, x, 5);
		Texts_WriteInt(&Dialog_w0, Texts_Writer__typ, y, 5);
		Texts_WriteLn(&Dialog_w0, Texts_Writer__typ);
		Texts_WriteString(&Dialog_w0, Texts_Writer__typ, (CHAR*)"Wide and Height: ", (LONGINT)18);
		Texts_WriteInt(&Dialog_w0, Texts_Writer__typ, w, 5);
		Texts_WriteInt(&Dialog_w0, Texts_Writer__typ, h, 5);
		Texts_WriteLn(&Dialog_w0, Texts_Writer__typ);
		Texts_Append(Oberon_Log, Dialog_w0.buf);
	} else {
		Dialogs_Error((CHAR*)"Dialog", (LONGINT)7);
	}
}

void Dialog_GetName (void)
{
	Dialogs_Object o = NIL;
	Dialogs_Panel p = NIL;
	CHAR name[32];
	DialogFrames_FindObject(&o, &p);
	if (Dialogs_res == 0) {
		__COPY(o->name, name, 32);
		Texts_WriteString(&Dialog_w0, Texts_Writer__typ, (CHAR*)"Name: ", (LONGINT)7);
		Texts_WriteString(&Dialog_w0, Texts_Writer__typ, name, 32);
		Texts_WriteLn(&Dialog_w0, Texts_Writer__typ);
		Texts_Append(Oberon_Log, Dialog_w0.buf);
	} else {
		Dialogs_Error((CHAR*)"Dialog", (LONGINT)7);
	}
}

void Dialog_GetCmd (void)
{
	Dialogs_Object o = NIL;
	Dialogs_Panel p = NIL;
	CHAR cmd[64];
	DialogFrames_FindObject(&o, &p);
	if (Dialogs_res == 0) {
		__COPY(o->cmd, cmd, 64);
		Texts_WriteString(&Dialog_w0, Texts_Writer__typ, (CHAR*)"Command: ", (LONGINT)10);
		Texts_WriteString(&Dialog_w0, Texts_Writer__typ, cmd, 64);
		Texts_WriteLn(&Dialog_w0, Texts_Writer__typ);
		Texts_Append(Oberon_Log, Dialog_w0.buf);
	} else {
		Dialogs_Error((CHAR*)"Dialog", (LONGINT)7);
	}
}

void Dialog_GetInitCmd (void)
{
	INTEGER x = 0, y = 0;
	Dialogs_Panel p = NIL;
	CHAR cmd[64];
	DialogFrames_GetCaretPosition(&p, &x, &y);
	Dialogs_res = 0;
	if (p != NIL) {
		__COPY(p->cmd, cmd, 64);
		Texts_WriteString(&Dialog_w0, Texts_Writer__typ, (CHAR*)"Command: ", (LONGINT)10);
		Texts_WriteString(&Dialog_w0, Texts_Writer__typ, cmd, 64);
		Texts_WriteLn(&Dialog_w0, Texts_Writer__typ);
		Texts_Append(Oberon_Log, Dialog_w0.buf);
	} else {
		Dialogs_res = 5;
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"Dialog", (LONGINT)7);
	}
}

void Dialog_GetPar (void)
{
	Dialogs_Object o = NIL;
	Dialogs_Panel p = NIL;
	CHAR par[64];
	DialogFrames_FindObject(&o, &p);
	if (Dialogs_res == 0) {
		__COPY(o->par, par, 64);
		Texts_WriteString(&Dialog_w0, Texts_Writer__typ, (CHAR*)"Parameter: ", (LONGINT)12);
		Texts_WriteString(&Dialog_w0, Texts_Writer__typ, par, 64);
		Texts_WriteLn(&Dialog_w0, Texts_Writer__typ);
		Texts_Append(Oberon_Log, Dialog_w0.buf);
	} else {
		Dialogs_Error((CHAR*)"Dialog", (LONGINT)7);
	}
}

void Dialog_SetGrid (void)
{
	INTEGER i = 0;
	DialogFrames_Frame f = NIL;
	Viewers_Viewer v = NIL;
	v = Oberon_MarkedViewer();
	if (__ISP(v->dsc->next, DialogFrames_FrameDesc, 1)) {
		f = __GUARDP(v->dsc->next, DialogFrames_FrameDesc, 1);
		In_Open();
		In_Int(&i);
		if ((In_Done && i <= 100) && i >= 1) {
			f->grid = i;
			Dialogs_res = 0;
		} else {
			Dialogs_res = 4;
			Dialogs_Error((CHAR*)"Dialog", (LONGINT)7);
		}
	}
}

static void Dialog_box (Dialogs_Object o, BOOLEAN *done)
{
	INTEGER x = 0, y = 0, w = 0, h = 0;
	if (!o->selected) {
		return;
	}
	__Dialogs_Object_GetDim(o, &x, &y, &w, &h);
	y = __ABS(y);
	if (x < Dialog_X0) {
		Dialog_X0 = x;
	}
	if (Dialog_X1 < x + w) {
		Dialog_X1 = x + w;
	}
	if (y - h < Dialog_Y0) {
		Dialog_Y0 = y - h;
	}
	if (Dialog_Y1 < y) {
		Dialog_Y1 = y;
	}
}

static void Dialog_EnumCopy (Dialogs_Object o, BOOLEAN *done)
{
	INTEGER x = 0, y = 0, w = 0, h = 0;
	Dialogs_Object new = NIL;
	if (!o->selected) {
		return;
	}
	new = NIL;
	__Dialogs_Object_Copy(o, &new);
	__Dialogs_Object_SetName(new, (CHAR*)"", (LONGINT)1);
	__Dialogs_Object_GetDim(o, &x, &y, &w, &h);
	__Dialogs_Object_SetDim(new, x + Dialog_nx, y + Dialog_ny, w, h, new->overlapping);
	__Dialogs_Panel_Insert(o->panel, new, new->overlapping);
}

void Dialog_Do (void)
{
	Dialogs_Object o = NIL;
	Viewers_Viewer v = NIL;
	Texts_Text t = NIL;
	Texts_Reader r = {0};
	CHAR ch = 0;
	o = Dialogs_editObject;
	v = Oberon_Par->vwr;
	if (o != NIL) {
		__Dialogs_Object_Update(o, Dialogs_cmdPanel);
	}
	t = __GUARDP(v->dsc, TextFrames_FrameDesc, 1)->text;
	Texts_OpenReader(&r, Texts_Reader__typ, t, t->len - 1);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	if ((ch == '!' && Dialogs_res == 0) && o != NIL) {
		Texts_Delete(t, t->len - 1, t->len);
	}
}

static struct DisplaySelRect__2 {
	DialogFrames_Frame *f;
	SHORTINT *col;
	struct DisplaySelRect__2 *lnk;
} *DisplaySelRect__2_s;

static void DrawLines__3 (INTEGER x0, INTEGER y0, INTEGER x1, INTEGER y1);

static void DrawLines__3 (INTEGER x0, INTEGER y0, INTEGER x1, INTEGER y1)
{
	Display1_Line((void*)*DisplaySelRect__2_s->f, *DisplaySelRect__2_s->col, x0, y0, x0, y1, 2);
	Display1_Line((void*)*DisplaySelRect__2_s->f, *DisplaySelRect__2_s->col, x0, y0, x1, y0, 2);
	Display1_Line((void*)*DisplaySelRect__2_s->f, *DisplaySelRect__2_s->col, x0, y1, x1, y1, 2);
	Display1_Line((void*)*DisplaySelRect__2_s->f, *DisplaySelRect__2_s->col, x1, y0, x1, y1, 2);
}

static void Dialog_DisplaySelRect (DialogFrames_Frame f, SHORTINT col, INTEGER x0, INTEGER y0, INTEGER x, INTEGER y, INTEGER *xdif, INTEGER *ydif)
{
	struct DisplaySelRect__2 _s;
	_s.f = &f;
	_s.col = &col;
	_s.lnk = DisplaySelRect__2_s;
	DisplaySelRect__2_s = &_s;
	DrawLines__3(x0, y0, *xdif, *ydif);
	*xdif = x;
	*ydif = y;
	__Dialogs_Panel_Select(f->panel, Dialog_Min(x0 - f->X, *xdif - f->X), Dialog_Min((y0 - f->Y) - f->H, (*ydif - f->Y) - f->H), __ABS(x0 - *xdif), __ABS(y0 - *ydif));
	DrawLines__3(x0, y0, *xdif, *ydif);
	DisplaySelRect__2_s = _s.lnk;
}

static void Dialog_Track (DialogFrames_Frame f, SET keys, INTEGER x0, INTEGER y0, Dialogs_Object o)
{
	SET keys0 = 0, keysum = 0;
	Dialogs_Object new = NIL;
	BOOLEAN ch1 = 0, ch2 = 0, ch3 = 0;
	INTEGER x = 0, y = 0, xh = 0, yh = 0, wh = 0, hh = 0, xdif = 0, ydif = 0, ox = 0, oy = 0, ow = 0, oh = 0;
	CHAR ch = 0;
	SHORTINT col = 0;
	DialogFrames_GetFrameMsg gfmsg = {0};
	Viewers_Viewer v = NIL;
	Texts_Text t = NIL;
	Texts_Reader r = {0};
	col = 15;
	keys0 = keys;
	keysum = keys;
	ch1 = 0;
	ch2 = 0;
	ch3 = 0;
	xdif = x0;
	ydif = y0;
	if (o != NIL) {
		__Dialogs_Object_GetDim(o, &xh, &yh, &wh, &hh);
	} else {
		xh = x0;
		yh = y0;
	}
	if (keys0 == 0x01 && o != NIL) {
		if (o->selected) {
			__Dialogs_Object_UnSelect(o);
		} else {
			__Dialogs_Object_Select(o);
		}
	}
	do {
		Input_Mouse(&keys, &x, &y);
		keysum = keysum | keys;
		xdif = __DIV(xdif, f->grid);
		xdif = xdif * f->grid;
		ydif = __DIV(ydif, f->grid);
		ydif = ydif * f->grid;
		x = __DIV(x, f->grid);
		x = x * f->grid;
		y = __DIV(y, f->grid);
		y = y * f->grid;
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
		if (xdif != x || ydif != y) {
			if (keys0 == 0x02) {
				if (keysum == 0x02) {
					if (o != NIL && (!o->selected || __Dialogs_Panel_NofSelObjects(o->panel) <= 1)) {
						__Dialogs_Object_GetDim(o, &ox, &oy, &ow, &oh);
						__Dialogs_Object_SetDim(o, (ox - xdif) + x, (oy - ydif) + y, ow, oh, 0);
						if (Dialogs_res == 0) {
							ch1 = 1;
							xdif = x;
							ydif = y;
						}
					} else {
						__Dialogs_Panel_MoveSelected(f->panel, x - xdif, y - ydif);
						if (Dialogs_res == 0) {
							ch3 = 1;
							xdif = x;
							ydif = y;
							xh = x0;
							yh = y0;
						}
					}
				} else if ((keysum == 0x06 && o != NIL) && !ch3) {
					__Dialogs_Object_GetDim(o, &ox, &oy, &ow, &oh);
					__Dialogs_Object_SetDim(o, ox, oy, (ow - xdif) + x, (oh - ydif) + y, 0);
					if (Dialogs_res == 0) {
						xdif = x;
						ydif = y;
						ch2 = 1;
					}
				}
			} else if (keys0 == 0x01 && o == NIL) {
				Dialog_DisplaySelRect(f, col, x0, y0, x, y, &xdif, &ydif);
			}
		}
	} while (!(keys == 0x0));
	if (keys0 == 0x04 && keysum == 0x04) {
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
		Oberon_DrawCursor(&Oberon_Pointer, Oberon_Cursor__typ, &Dialog_reticule, Oberon_Marker__typ, x, y);
		Oberon_PassFocus(Viewers_This(x, y));
	} else if (keys0 == 0x04 && keysum == 0x06) {
		Dialog_X0 = 32767;
		Dialog_X1 = -32768;
		Dialog_Y0 = 32767;
		Dialog_Y1 = -32768;
		__Dialogs_Panel_Enumerate(f->panel, Dialog_box);
		Dialog_nx = (x - f->X) - Dialog_X0;
		Dialog_ny = ((y - f->Y) - f->H) + Dialog_Y0;
		__Dialogs_Panel_Enumerate(f->panel, Dialog_EnumCopy);
	} else if ((keys0 == 0x01 && keysum == 0x05) && o != NIL) {
		__Dialogs_Panel_Remove(f->panel, o);
		__Dialogs_Panel_RemoveSelections(f->panel);
	} else if ((keys0 == 0x01 && keysum == 0x03) && o != NIL) {
		__Dialogs_Object_UnSelect(o);
		new = NIL;
		__Dialogs_Object_Copy(o, &new);
		__Dialogs_Object_GetDim(o, &ox, &oy, &ow, &oh);
		__Dialogs_Object_SetName(new, (CHAR*)"", (LONGINT)1);
		__Dialogs_Object_SetDim(new, (ox - x0) + x, (oy - y0) + y, ow, oh, 0);
		__Dialogs_Panel_Insert(f->panel, new, new->overlapping);
	} else if (keys0 == 0x01 && o == NIL) {
		Display1_Line((void*)f, col, x0, y0, x0, ydif, 2);
		Display1_Line((void*)f, col, x0, y0, xdif, y0, 2);
		Display1_Line((void*)f, col, x0, ydif, xdif, ydif, 2);
		Display1_Line((void*)f, col, xdif, y0, xdif, ydif, 2);
		if (keysum == 0x05) {
			__Dialogs_Panel_RemoveObjects(f->panel, Dialog_Min(x0 - f->X, xdif - f->X), Dialog_Min((y0 - f->Y) - f->H, (ydif - f->Y) - f->H), __ABS(x0 - xdif), __ABS(y0 - ydif));
		}
	} else if ((keys0 == 0x02 && keysum == 0x03) && o != NIL) {
		if (ch1) {
			__Dialogs_Object_GetDim(o, &ox, &oy, &ow, &oh);
			__Dialogs_Object_SetDim(o, xh, yh, ow, oh, 0);
		} else if (ch3) {
			__Dialogs_Panel_MoveSelected(f->panel, xh - xdif, yh - ydif);
		}
		ch1 = 0;
		ch3 = 0;
		Dialog_editObjectX = x;
		Dialog_editObjectY = y;
		__Dialogs_Object_Edit(o);
		gfmsg.p = Dialogs_editPanel;
		Viewers_Broadcast((void*)&gfmsg, DialogFrames_GetFrameMsg__typ);
		if (gfmsg.f != NIL) {
			v = Viewers_This(gfmsg.f->X, gfmsg.f->Y);
			if ((v != NIL && __ISP(v, MenuViewers_ViewerDesc, 2)) && __ISP(v->dsc, TextFrames_FrameDesc, 1)) {
				t = __GUARDP(v->dsc, TextFrames_FrameDesc, 1)->text;
				Texts_OpenReader(&r, Texts_Reader__typ, t, t->len - 1);
				Texts_Read(&r, Texts_Reader__typ, &ch);
				if (ch == '!') {
					Texts_Delete(t, t->len - 1, t->len);
				}
			}
		}
	}
	if (((ch1 && keysum != 0x02) && keysum != 0x06) && o != NIL) {
		__Dialogs_Object_GetDim(o, &ox, &oy, &ow, &oh);
		__Dialogs_Object_SetDim(o, xh, yh, ow, oh, 0);
	}
	if ((ch3 && keysum != 0x02) && keysum != 0x06) {
		__Dialogs_Panel_MoveSelected(f->panel, xh - xdif, yh - ydif);
	}
	if ((ch2 && keysum != 0x06) && o != NIL) {
		__Dialogs_Object_GetDim(o, &xh, &yh, &ow, &oh);
		__Dialogs_Object_SetDim(o, xh, yh, wh, hh, 0);
	}
}

void Dialog_Handle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	DialogFrames_Frame self = NIL;
	Dialogs_Object o = NIL;
	self = __GUARDP(f, DialogFrames_FrameDesc, 1);
	if (__IS(msg__typ, Oberon_InputMsg, 1)) {
		Oberon_InputMsg *msg__ = (void*)msg;
		if ((*msg__).id == 0) {
			if ((*msg__).ch == 0xc4) {
				__Dialogs_Panel_MoveSelected(self->panel, -self->grid, 0);
			} else if ((*msg__).ch == 0xc3) {
				__Dialogs_Panel_MoveSelected(self->panel, self->grid, 0);
			} else if ((*msg__).ch == 0xc2) {
				__Dialogs_Panel_MoveSelected(self->panel, 0, -self->grid);
			} else if ((*msg__).ch == 0xc1) {
				__Dialogs_Panel_MoveSelected(self->panel, 0, self->grid);
			}
		} else if ((*msg__).id == 1 && (*msg__).keys != 0x0) {
			o = __Dialogs_Panel_ThisObject(self->panel, (*msg__).X - self->X, ((*msg__).Y - self->Y) - f->H);
			Dialog_Track(self, (*msg__).keys, (*msg__).X, (*msg__).Y, o);
		} else {
			DialogFrames_Handle(f, (void*)&*msg__, msg__typ);
		}
	} else if (__IS(msg__typ, Oberon_ControlMsg, 1)) {
		Oberon_ControlMsg *msg__ = (void*)msg;
		if ((*msg__).id == 1) {
			__Dialogs_Panel_RemoveSelections(self->panel);
		}
		DialogFrames_Handle(f, (void*)&*msg__, msg__typ);
	} else {
		DialogFrames_Handle(f, &*msg, msg__typ);
	}
}

void Dialog_Edit (void)
{
	CHAR name[32];
	DialogFrames_Frame df = NIL;
	Viewers_Viewer v = NIL;
	INTEGER x = 0, y = 0;
	Dialogs_Panel panel = NIL;
	Files_File file = NIL;
	Files_Rider r = {0};
	TextFrames_Frame m = NIL;
	Texts_Text t = NIL;
	Texts_Buffer buf = NIL;
	In_Open();
	In_Name((void*)name, 32);
	panel = NIL;
	if (!In_Done) {
		In_Open();
		In_String((void*)name, 32);
	}
	if (In_Done) {
		__NEW(panel, Dialogs_PanelDesc);
		file = Files_Old(name, 32);
		if (file != NIL) {
			Files_Set(&r, Files_Rider__typ, file, 0);
			__Dialogs_Panel_Load(panel, &r, Files_Rider__typ);
		}
	}
	if (panel != NIL) {
		__NEW(df, DialogFrames_FrameDesc);
		__DialogFrames_Frame_Open(df, Dialog_Handle, panel);
		df->col = 11;
		Oberon_AllocateUserViewer(Oberon_Mouse.X, &x, &y);
		m = TextFrames_NewMenu(name, 32, (CHAR*)"^DialogEdit.Menu.Text", (LONGINT)22);
		v = (Viewers_Viewer)MenuViewers_New((void*)m, (void*)df, TextFrames_menuH, x, y);
	}
}

void Dialog_Store (void)
{
	Viewers_Viewer v = NIL;
	Files_File f = NIL;
	Files_Rider r = {0};
	Texts_Scanner s = {0};
	CHAR name[64];
	Texts_Text t = NIL;
	Texts_Reader r2 = {0};
	CHAR ch = 0;
	v = Oberon_Par->vwr;
	name[0] = 0x00;
	if (((v->dsc != Oberon_Par->frame || v->dsc == NIL) || v->dsc->next == NIL) || !__ISP(v->dsc->next, DialogFrames_FrameDesc, 1)) {
		v = Oberon_MarkedViewer();
		Texts_OpenScanner(&s, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
		Texts_Scan(&s, Texts_Scanner__typ);
		if (s.line == 0 && (s.class == 1 || s.class == 2)) {
			__COPY(s.s, name, 64);
		}
	}
	if ((v->dsc != NIL && v->dsc->next != NIL) && __ISP(v->dsc->next, DialogFrames_FrameDesc, 1)) {
		if (name[0] == 0x00 && __ISP(v->dsc, TextFrames_FrameDesc, 1)) {
			Texts_OpenScanner(&s, Texts_Scanner__typ, __GUARDP(v->dsc, TextFrames_FrameDesc, 1)->text, 0);
			Texts_Scan(&s, Texts_Scanner__typ);
			if (s.line == 0 && (s.class == 1 || s.class == 2)) {
				__COPY(s.s, name, 64);
			}
		}
		if (name[0] != 0x00) {
			f = Files_New(name, 64);
			Files_Set(&r, Files_Rider__typ, f, 0);
			__Dialogs_Panel_Store(__GUARDP(v->dsc->next, DialogFrames_FrameDesc, 1)->panel, &r, Files_Rider__typ);
			Files_Register(f);
			Texts_WriteString(&Dialog_w0, Texts_Writer__typ, (CHAR*)"Dialog.Store ", (LONGINT)14);
			Texts_WriteString(&Dialog_w0, Texts_Writer__typ, name, 64);
			Texts_WriteLn(&Dialog_w0, Texts_Writer__typ);
			Texts_Append(Oberon_Log, Dialog_w0.buf);
		}
		t = __GUARDP(v->dsc, TextFrames_FrameDesc, 1)->text;
		Texts_OpenReader(&r2, Texts_Reader__typ, t, t->len - 1);
		Texts_Read(&r2, Texts_Reader__typ, &ch);
		if (ch == '!') {
			Texts_Delete(t, t->len - 1, t->len);
		}
	}
}

static struct Print__17 {
	struct Print__17 *lnk;
} *Print__17_s;

static void PrintError__18 (INTEGER res);
static void PrintGetMainArg__20 (Texts_Scanner *s, LONGINT *s__typ);

static void PrintGetMainArg__20 (Texts_Scanner *s, LONGINT *s__typ)
{
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_Scan(&*s, s__typ);
	if ((*s).class == 6 && (*s).c == '^') {
		Oberon_GetSelection(&text, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&*s, s__typ, text, beg);
			Texts_Scan(&*s, s__typ);
		}
	}
	if ((*s).line != 0) {
		(*s).class = 0;
	}
}

static void PrintError__18 (INTEGER res)
{
	if (res == 1) {
		Texts_WriteString(&Dialog_w0, Texts_Writer__typ, (CHAR*)"Dialog Print Error 1: No connection", (LONGINT)36);
	} else if (res == 2) {
		Texts_WriteString(&Dialog_w0, Texts_Writer__typ, (CHAR*)"Dialog Print Error 2: No link", (LONGINT)30);
	} else if (res == 3) {
		Texts_WriteString(&Dialog_w0, Texts_Writer__typ, (CHAR*)"Dialog Print Error 3: Bad response", (LONGINT)35);
	} else if (res == 4) {
		Texts_WriteString(&Dialog_w0, Texts_Writer__typ, (CHAR*)"Dialog Print Error 4: Wrong input", (LONGINT)34);
	} else if (res == 5) {
		Texts_WriteString(&Dialog_w0, Texts_Writer__typ, (CHAR*)"Dialog Print Error 5: No panel selected", (LONGINT)40);
	}
	Texts_WriteLn(&Dialog_w0, Texts_Writer__typ);
	Texts_Append(Oberon_Log, Dialog_w0.buf);
}

void Dialog_Print (void)
{
	Texts_Scanner s = {0};
	Dialogs_Panel p = NIL;
	INTEGER x = 0, y = 0, res = 0;
	Files_Rider r = {0};
	Files_File file = NIL;
	CHAR name[32];
	struct Print__17 _s;
	_s.lnk = Print__17_s;
	Print__17_s = &_s;
	Texts_OpenScanner(&s, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&s, Texts_Scanner__typ);
	if ((s.class == 1 || s.class == 2) && s.line == 0) {
		__COPY(s.s, name, 32);
		PrintGetMainArg__20(&s, Texts_Scanner__typ);
		res = 0;
		if (s.class == 6 && s.c == '*') {
			DialogFrames_GetCaretPosition(&p, &x, &y);
		} else if (s.class == 1) {
			file = Files_Old(s.s, 256);
			if (file != NIL) {
				__NEW(p, Dialogs_PanelDesc);
				Files_Set(&r, Files_Rider__typ, file, 0);
				__Dialogs_Panel_Load(p, &r, Files_Rider__typ);
			} else {
				res = 4;
			}
		} else if ((Oberon_Par->vwr != NIL && __ISP(Oberon_Par->vwr, MenuViewers_ViewerDesc, 2)) && __ISP(Oberon_Par->vwr->dsc->next, DialogFrames_FrameDesc, 1)) {
			p = __GUARDP(Oberon_Par->vwr->dsc->next, DialogFrames_FrameDesc, 1)->panel;
		} else {
			res = 4;
		}
		if (p != NIL && res == 0) {
			Printer_Open((void*)name, 32, (void*)Oberon_User, 12, Oberon_Password);
			res = Printer_res;
			if (res == 0) {
				__Dialogs_Panel_Print(p, 0, Printer_PageHeight);
				Printer_Page(1);
				Printer_Close();
			}
		} else {
			if (res != 4) {
				res = 5;
			}
		}
	} else {
		res = 4;
	}
	if (res != 0) {
		PrintError__18(res);
	}
	Print__17_s = _s.lnk;
}

static void Dialog_DrawReticule (INTEGER x, INTEGER y)
{
	if (x < Dialog_CL) {
		if (x < 5) {
			x = 5;
		} else if (x > Dialog_DW) {
			x = Dialog_DW - 5;
		}
	} else {
		if (x < Dialog_CL + 5) {
			x = Dialog_CL + 5;
		} else if (x > Dialog_CL + Dialog_DW) {
			x = (Dialog_CL + Dialog_DW) - 5;
		}
	}
	if (y < 5) {
		y = 5;
	} else if (y > Dialog_DH) {
		y = Dialog_DH - 5;
	}
	Display_CopyPattern(15, Display_cross, x - 5, y - 5, 2);
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&Dialog_w0, Texts_Writer__typ, 36, 1, P);
}


export void *Dialog__init(void)
{
	__DEFMOD;
	__IMPORT(DialogFrames);
	__IMPORT(Dialogs);
	__IMPORT(Display);
	__IMPORT(Display1);
	__IMPORT(Files);
	__IMPORT(In);
	__IMPORT(Input);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(Dialog, EnumPtrs);
	__REGCMD("AlignSelected", Dialog_AlignSelected);
	__REGCMD("Do", Dialog_Do);
	__REGCMD("Edit", Dialog_Edit);
	__REGCMD("GetCmd", Dialog_GetCmd);
	__REGCMD("GetDim", Dialog_GetDim);
	__REGCMD("GetInitCmd", Dialog_GetInitCmd);
	__REGCMD("GetName", Dialog_GetName);
	__REGCMD("GetPar", Dialog_GetPar);
	__REGCMD("Open", Dialog_Open);
	__REGCMD("Print", Dialog_Print);
	__REGCMD("RegulateDistance", Dialog_RegulateDistance);
	__REGCMD("SetCmd", Dialog_SetCmd);
	__REGCMD("SetDim", Dialog_SetDim);
	__REGCMD("SetGrid", Dialog_SetGrid);
	__REGCMD("SetInitCmd", Dialog_SetInitCmd);
	__REGCMD("SetName", Dialog_SetName);
	__REGCMD("SetPar", Dialog_SetPar);
	__REGCMD("Store", Dialog_Store);
/* BEGIN */
	Dialog_DW = Display_Width - 8;
	Dialog_DH = Display_Height - 8;
	Dialog_CL = Display_ColLeft;
	Texts_OpenWriter(&Dialog_w0, Texts_Writer__typ);
	Dialog_reticule.Draw = Dialog_DrawReticule;
	Dialog_reticule.Fade = Dialog_DrawReticule;
	__ENDMOD;
}
