/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "DialogFrames.h"
#include "DialogStaticTexts.h"
#include "DialogTexts.h"
#include "Dialogs.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "GraphicUtils.h"
#include "In.h"
#include "Input.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct DialogButtons_ItemDesc *DialogButtons_Item;

typedef
	struct DialogButtons_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[4];
		Fonts_Font fnt;
	} DialogButtons_ItemDesc;

export void DialogButtons_Item_Copy (DialogButtons_Item b, Dialogs_Object *dup);
export void DialogButtons_Item_Draw (DialogButtons_Item b, INTEGER x, INTEGER y, Display_Frame f);
static void DialogButtons_Item_Draw1 (DialogButtons_Item b, INTEGER x, INTEGER y, BOOLEAN pressed, Display_Frame f);
export void DialogButtons_Item_Edit (DialogButtons_Item b);
export void DialogButtons_Item_Handle (DialogButtons_Item b, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
export void DialogButtons_Item_Load (DialogButtons_Item b, Files_Rider *r, LONGINT *r__typ);
export void DialogButtons_Item_Print (DialogButtons_Item b, INTEGER x, INTEGER y);
export void DialogButtons_Item_SetFont (DialogButtons_Item b, Fonts_Font fnt);
export void DialogButtons_Item_Store (DialogButtons_Item b, Files_Rider *r, LONGINT *r__typ);
static void DialogButtons_Item_Track (DialogButtons_Item b, INTEGER x, INTEGER y, SET keys, Display_Frame f, Dialogs_Panel p, INTEGER x0, INTEGER y0);
export void DialogButtons_Item_Update (DialogButtons_Item b, Dialogs_Panel p);
#define __DialogButtons_Item_Draw1(b, x, y, pressed, f) __SEND(__TYPEOF(b), 24, void(*)(DialogButtons_Item, INTEGER, INTEGER, BOOLEAN, Display_Frame), (b, x, y, pressed, f))
#define __DialogButtons_Item_SetFont(b, fnt) __SEND(__TYPEOF(b), 25, void(*)(DialogButtons_Item, Fonts_Font), (b, fnt))
#define __DialogButtons_Item_Track(b, x, y, keys, f, p, x0, y0) __SEND(__TYPEOF(b), 26, void(*)(DialogButtons_Item, INTEGER, INTEGER, SET, Display_Frame, Dialogs_Panel, INTEGER, INTEGER), (b, x, y, keys, f, p, x0, y0))


static Texts_Writer DialogButtons_w0;

export LONGINT *DialogButtons_ItemDesc__typ;

export void DialogButtons_Insert (void);
static void DialogButtons_WriteToObjectStr (DialogTexts_Item o, Dialogs_Panel *p, CHAR *n, LONGINT n__len);


void DialogButtons_Item_Copy (DialogButtons_Item b, Dialogs_Object *dup)
{
	DialogButtons_Item x = NIL;
	if (*dup == NIL) {
		__NEW(x, DialogButtons_ItemDesc);
		*dup = (Dialogs_Object)x;
	} else {
		x = __GUARDP(*dup, DialogButtons_ItemDesc, 1);
	}
	Dialogs_Object_Copy((void*)b, &*dup);
	x->fnt = b->fnt;
}

static void DialogButtons_Item_Draw1 (DialogButtons_Item b, INTEGER x, INTEGER y, BOOLEAN pressed, Display_Frame f)
{
	INTEGER mode = 0, w = 0, h = 0, yh = 0, ox = 0, oy = 0, cx = 0;
	__Dialogs_Object_GetDim((void*)b, &ox, &oy, &w, &h);
	if (b->selected) {
		mode = 2;
	} else {
		mode = 1;
	}
	GraphicUtils_DrawBox(f, pressed, x, y, w, h, mode);
	yh = (y + __ASHR(h, 1)) - __ASHR(b->fnt->minY + b->fnt->maxY, 1);
	if (h - (yh - y) > b->fnt->maxY) {
		GraphicUtils_DrawString(f, b->name, 16, x + 3, yh, w - 4, b->fnt, mode, 1, &cx);
	}
}

void DialogButtons_Item_Draw (DialogButtons_Item b, INTEGER x, INTEGER y, Display_Frame f)
{
	__DialogButtons_Item_Draw1(b, x, y, 0, f);
}

void DialogButtons_Item_Print (DialogButtons_Item b, INTEGER x, INTEGER y)
{
	INTEGER w = 0, h = 0, ox = 0, oy = 0, yh = 0, cx = 0;
	LONGINT fnth = 0;
	__Dialogs_Object_GetPDim((void*)b, &ox, &oy, &w, &h);
	GraphicUtils_PrintBox(x, y, w, h);
	fnth = __ASHR(__DIV((LONGINT)(b->fnt->maxY - b->fnt->minY) * Dialogs_dUnit, Dialogs_pUnit), 1);
	yh = (y + __ASHR(h, 1)) - (int)fnth;
	if ((LONGINT)(h - (yh - y)) > __DIV((LONGINT)(b->fnt->maxY * (int)Dialogs_dUnit), Dialogs_pUnit)) {
		GraphicUtils_PrintString(b->name, 16, x + 3, yh, w - 4, b->fnt, 1, &cx);
	}
}

static void DialogButtons_Item_Track (DialogButtons_Item b, INTEGER x, INTEGER y, SET keys, Display_Frame f, Dialogs_Panel p, INTEGER x0, INTEGER y0)
{
	INTEGER bx = 0, by = 0, bw = 0, bh = 0;
	SET keysum = 0;
	Texts_Text t = NIL;
	BOOLEAN fPressed = 0;
	fPressed = 1;
	__Dialogs_Object_GetDim((void*)b, &bx, &by, &bw, &bh);
	if ((keys == 0x01 || keys == 0x02) || keys == 0x04) {
		Oberon_RemoveMarks(x0 + bx, y0 + by, bw, bh);
		__DialogButtons_Item_Draw1(b, x0 + bx, y0 + by, 1, f);
		keysum = keys;
		do {
			Input_Mouse(&keys, &x, &y);
			keysum = keysum | keys;
			if (((x < x0 + bx || x > (x0 + bx) + bw) || y < y0 + by) || y > (y0 + by) + bh) {
				if (fPressed) {
					fPressed = 0;
					__DialogButtons_Item_Draw1(b, x0 + bx, y0 + by, fPressed, f);
				}
			} else {
				if (!fPressed) {
					fPressed = 1;
					__DialogButtons_Item_Draw1(b, x0 + bx, y0 + by, fPressed, f);
				}
			}
			Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
		} while (!(keys == 0x0));
		Oberon_RemoveMarks(x0 + bx, y0 + by, bw, bh);
		__DialogButtons_Item_Draw1(b, x0 + bx, y0 + by, 0, f);
		if (((keysum == 0x01 || keysum == 0x02) || keysum == 0x04) && fPressed) {
			if (b->cmd[0] != 0x00) {
				(*DialogTexts_GetParText)(b->par, 32, p, &t);
				__Dialogs_Object_CallCmd((void*)b, f, Viewers_This(x, y), t);
			}
		}
	} else {
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
	}
}

void DialogButtons_Item_Handle (DialogButtons_Item b, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ)
{
	Dialogs_Object_Handle((void*)b, f, &*m, m__typ);
	if (__ISP(f, DialogFrames_FrameDesc, 1)) {
		if (__IS(m__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *m__ = (void*)m;
			if ((*m__).id == 1) {
				__DialogButtons_Item_Track(b, (*m__).X, (*m__).Y, (*m__).keys, (void*)(*(DialogFrames_Frame*)&f), (*(DialogFrames_Frame*)&f)->panel, (*(DialogFrames_Frame*)&f)->X, (*(DialogFrames_Frame*)&f)->Y + (*(DialogFrames_Frame*)&f)->H);
			}
		}
	}
}

void DialogButtons_Item_Load (DialogButtons_Item b, Files_Rider *r, LONGINT *r__typ)
{
	CHAR fntname[32];
	Dialogs_Object_Load((void*)b, &*r, r__typ);
	Files_ReadString(&*r, r__typ, (void*)fntname, 32);
	b->fnt = Fonts_This(fntname, 32);
}

void DialogButtons_Item_Store (DialogButtons_Item b, Files_Rider *r, LONGINT *r__typ)
{
	Dialogs_Object_Store((void*)b, &*r, r__typ);
	Files_WriteString(&*r, r__typ, b->fnt->name, 32);
}

void DialogButtons_Item_SetFont (DialogButtons_Item b, Fonts_Font fnt)
{
	b->fnt = fnt;
	__Dialogs_Object_Restore((void*)b);
	if (b->panel != NIL) {
		__Dialogs_Panel_MarkMenu(b->panel);
	}
}

static void DialogButtons_WriteToObjectStr (DialogTexts_Item o, Dialogs_Panel *p, CHAR *n, LONGINT n__len)
{
	Texts_Text t = NIL;
	__DUP(n, n__len, CHAR);
	t = __DialogTexts_Item_GetText(o);
	Texts_WriteString(&DialogButtons_w0, Texts_Writer__typ, n, n__len);
	Texts_Append(t, DialogButtons_w0.buf);
	__DEL(n);
}

void DialogButtons_Item_Edit (DialogButtons_Item b)
{
	Dialogs_Object on = NIL;
	Texts_Text t = NIL;
	Fonts_Font fnt = NIL;
	Dialogs_Object_Edit((void*)b);
	on = __Dialogs_Panel_NamedObject(Dialogs_editPanel, (CHAR*)"name", (LONGINT)5);
	t = __DialogTexts_Item_GetText(__GUARDP(on, DialogTexts_ItemDesc, 1));
	Texts_ChangeLooks(t, 0, t->len, 0x01, b->fnt, 0, 0);
}

void DialogButtons_Item_Update (DialogButtons_Item b, Dialogs_Panel p)
{
	Dialogs_Object o = NIL;
	Texts_Text t = NIL;
	Texts_Reader r = {0};
	CHAR ch = 0;
	o = __Dialogs_Panel_NamedObject(p, (CHAR*)"name", (LONGINT)5);
	t = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
	Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	if (r.fnt != NIL && r.fnt != b->fnt) {
		__DialogButtons_Item_SetFont(b, r.fnt);
	}
	Dialogs_Object_Update((void*)b, p);
}

void DialogButtons_Insert (void)
{
	INTEGER x = 0, y = 0, x1 = 0, y1 = 0, w = 0, h = 0;
	DialogButtons_Item b = NIL;
	Dialogs_Panel p = NIL;
	CHAR name[64];
	Texts_Reader r = {0};
	CHAR ch = 0;
	__NEW(b, DialogButtons_ItemDesc);
	DialogFrames_GetCaretPosition(&p, &x, &y);
	if (p != NIL) {
		__Dialogs_Object_Init((void*)b);
		b->fnt = Fonts_This((CHAR*)"Syntax10.Scn.Fnt", (LONGINT)17);
		In_Open();
		Texts_OpenReader(&r, Texts_Reader__typ, Oberon_Par->text, 0);
		Texts_Read(&r, Texts_Reader__typ, &ch);
		In_Name((void*)name, 64);
		if (!In_Done) {
			In_Open();
			In_String((void*)name, 64);
			if (!In_Done) {
				__COPY("", name, 64);
				In_Open();
			} else {
				b->fnt = r.fnt;
			}
		} else {
			b->fnt = r.fnt;
		}
		__Dialogs_Object_SetName((void*)b, name, 64);
		In_Int(&x1);
		In_Int(&y1);
		In_Int(&w);
		In_Int(&h);
		if (!In_Done) {
			x1 = x;
			y1 = y;
			w = 30;
			h = 20;
		} else {
			if (w < 0) {
				w = 30;
			}
			if (h < 0) {
				h = 20;
			}
		}
		y = GraphicUtils_GetStringLength(name, 64, b->fnt) + 9;
		if (y > w) {
			x = w;
			w = y;
		}
		__Dialogs_Object_SetDim((void*)b, x1, y1, w, h, 0);
		__Dialogs_Panel_Insert(p, (void*)b, 0);
		if (Dialogs_res == 6) {
			__Dialogs_Object_SetDim((void*)b, x1, y1, y, h, 0);
			__Dialogs_Panel_Insert(p, (void*)b, 0);
		}
	} else {
		Dialogs_res = 5;
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogButtons", (LONGINT)14);
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&DialogButtons_w0, Texts_Writer__typ, 36, 1, P);
}

__TDESC(DialogButtons_ItemDesc, 28, 3) = {__TDFLDS("ItemDesc", 116), {0, 104, 112, -16}};

export void *DialogButtons__init(void)
{
	__DEFMOD;
	__IMPORT(DialogFrames);
	__IMPORT(DialogStaticTexts);
	__IMPORT(DialogTexts);
	__IMPORT(Dialogs);
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(GraphicUtils);
	__IMPORT(In);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(DialogButtons, EnumPtrs);
	__REGCMD("Insert", DialogButtons_Insert);
	__INITYP(DialogButtons_ItemDesc, Dialogs_ObjectDesc, 1);
	__INITBP(DialogButtons_ItemDesc, DialogButtons_Item_Copy, 1);
	__INITBP(DialogButtons_ItemDesc, DialogButtons_Item_Draw, 2);
	__INITBP(DialogButtons_ItemDesc, DialogButtons_Item_Draw1, 24);
	__INITBP(DialogButtons_ItemDesc, DialogButtons_Item_Edit, 3);
	__INITBP(DialogButtons_ItemDesc, DialogButtons_Item_Handle, 6);
	__INITBP(DialogButtons_ItemDesc, DialogButtons_Item_Load, 12);
	__INITBP(DialogButtons_ItemDesc, DialogButtons_Item_Print, 14);
	__INITBP(DialogButtons_ItemDesc, DialogButtons_Item_SetFont, 25);
	__INITBP(DialogButtons_ItemDesc, DialogButtons_Item_Store, 21);
	__INITBP(DialogButtons_ItemDesc, DialogButtons_Item_Track, 26);
	__INITBP(DialogButtons_ItemDesc, DialogButtons_Item_Update, 23);
/* BEGIN */
	Texts_OpenWriter(&DialogButtons_w0, Texts_Writer__typ);
	__ENDMOD;
}
