/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "DialogFrames.h"
#include "DialogTexts.h"
#include "Dialogs.h"
#include "Display.h"
#include "Display1.h"
#include "In.h"
#include "Input.h"
#include "Oberon.h"
#include "Printer.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct DialogCircles_ItemDesc *DialogCircles_Item;

typedef
	struct DialogCircles_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[1];
	} DialogCircles_ItemDesc;

export void DialogCircles_Item_Copy (DialogCircles_Item c, Dialogs_Object *dup);
export void DialogCircles_Item_Draw (DialogCircles_Item c, INTEGER x, INTEGER y, Display_Frame f);
export void DialogCircles_Item_Handle (DialogCircles_Item c, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
export void DialogCircles_Item_Print (DialogCircles_Item l, INTEGER x, INTEGER y);
static void DialogCircles_Item_Track (DialogCircles_Item c, INTEGER x, INTEGER y, SET keys, Display_Frame f, Dialogs_Panel p);
#define __DialogCircles_Item_Track(c, x, y, keys, f, p) __SEND(__TYPEOF(c), 24, void(*)(DialogCircles_Item, INTEGER, INTEGER, SET, Display_Frame, Dialogs_Panel), (c, x, y, keys, f, p))



export LONGINT *DialogCircles_ItemDesc__typ;

export void DialogCircles_Insert (void);
static INTEGER DialogCircles_Min (INTEGER x, INTEGER y);


static INTEGER DialogCircles_Min (INTEGER x, INTEGER y)
{
	if (x < y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

void DialogCircles_Item_Draw (DialogCircles_Item c, INTEGER x, INTEGER y, Display_Frame f)
{
	INTEGER mode = 0, w = 0, h = 0, bx = 0, by = 0;
	__Dialogs_Object_GetDim((void*)c, &bx, &by, &w, &h);
	w = DialogCircles_Min(w, h);
	if (c->selected) {
		mode = 2;
	} else {
		mode = 0;
	}
	x += __ASHR(w, 1);
	y += __ASHR(w, 1);
	Display1_Circle(f, 15, x, y, __ASHR(w, 1) - 1, mode);
	if (__ASHR(w, 1) - 1 <= 0) {
		Display_DotC(f, 15, x, y, mode);
	}
}

void DialogCircles_Item_Print (DialogCircles_Item l, INTEGER x, INTEGER y)
{
	INTEGER w = 0, h = 0, bx = 0, by = 0;
	__Dialogs_Object_GetPDim((void*)l, &bx, &by, &w, &h);
	w = DialogCircles_Min(w, h);
	x += __ASHR(w, 1);
	y += __ASHR(w, 1);
	Printer_Circle(x, y, __ASHR(w, 1) - 1);
}

void DialogCircles_Item_Copy (DialogCircles_Item c, Dialogs_Object *dup)
{
	DialogCircles_Item x = NIL;
	if (*dup == NIL) {
		__NEW(x, DialogCircles_ItemDesc);
		*dup = (Dialogs_Object)x;
	} else {
		x = __GUARDP(*dup, DialogCircles_ItemDesc, 1);
	}
	Dialogs_Object_Copy((void*)c, &*dup);
}

static void DialogCircles_Item_Track (DialogCircles_Item c, INTEGER x, INTEGER y, SET keys, Display_Frame f, Dialogs_Panel p)
{
	SET keysum = 0;
	Texts_Text t = NIL;
	if (keys == 0x02) {
		keysum = keys;
		do {
			Input_Mouse(&keys, &x, &y);
			keysum = keysum | keys;
			Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
		} while (!(keys == 0x0));
		if (keysum == 0x02) {
			if (c->cmd[0] != 0x00) {
				(*DialogTexts_GetParText)(c->par, 32, c->panel, &t);
				__Dialogs_Object_CallCmd((void*)c, f, Viewers_This(x, y), t);
			}
		}
	} else {
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
	}
}

void DialogCircles_Item_Handle (DialogCircles_Item c, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ)
{
	Dialogs_Object_Handle((void*)c, f, &*m, m__typ);
	if (__ISP(f, DialogFrames_FrameDesc, 1)) {
		if (__IS(m__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *m__ = (void*)m;
			if ((*m__).id == 1) {
				__DialogCircles_Item_Track(c, (*m__).X, (*m__).Y, (*m__).keys, (void*)(*(DialogFrames_Frame*)&f), (*(DialogFrames_Frame*)&f)->panel);
			}
		}
	}
}

void DialogCircles_Insert (void)
{
	INTEGER x = 0, y = 0, x1 = 0, y1 = 0, w = 0, h = 0;
	DialogCircles_Item l = NIL;
	Dialogs_Panel p = NIL;
	CHAR name[64];
	__NEW(l, DialogCircles_ItemDesc);
	DialogFrames_GetCaretPosition(&p, &x, &y);
	if (p != NIL) {
		__Dialogs_Object_Init((void*)l);
		In_Open();
		In_Name((void*)name, 64);
		if (!In_Done) {
			__COPY("", name, 64);
			In_Open();
		}
		__Dialogs_Object_SetName((void*)l, name, 64);
		In_Int(&x1);
		In_Int(&y1);
		In_Int(&w);
		In_Int(&h);
		if (!In_Done) {
			x1 = x;
			y1 = y;
			w = 30;
			h = 30;
		} else {
			if (w < 0) {
				w = 30;
			}
			if (h < 0) {
				h = 30;
			}
		}
		__Dialogs_Object_SetDim((void*)l, x1, y1, w, h, 0);
		__Dialogs_Panel_Insert(p, (void*)l, 1);
	} else {
		Dialogs_res = 5;
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogCircles", (LONGINT)14);
	}
}

__TDESC(DialogCircles_ItemDesc, 26, 2) = {__TDFLDS("ItemDesc", 112), {0, 104, -12}};

export void *DialogCircles__init(void)
{
	__DEFMOD;
	__IMPORT(DialogFrames);
	__IMPORT(DialogTexts);
	__IMPORT(Dialogs);
	__IMPORT(Display);
	__IMPORT(Display1);
	__IMPORT(In);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(DialogCircles, 0);
	__REGCMD("Insert", DialogCircles_Insert);
	__INITYP(DialogCircles_ItemDesc, Dialogs_ObjectDesc, 1);
	__INITBP(DialogCircles_ItemDesc, DialogCircles_Item_Copy, 1);
	__INITBP(DialogCircles_ItemDesc, DialogCircles_Item_Draw, 2);
	__INITBP(DialogCircles_ItemDesc, DialogCircles_Item_Handle, 6);
	__INITBP(DialogCircles_ItemDesc, DialogCircles_Item_Print, 14);
	__INITBP(DialogCircles_ItemDesc, DialogCircles_Item_Track, 24);
/* BEGIN */
	__ENDMOD;
}
