/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "DialogFrames.h"
#include "DialogTexts.h"
#include "Dialogs.h"
#include "Display.h"
#include "Fonts.h"
#include "GraphicUtils.h"
#include "In.h"
#include "Input.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct DialogClocks_ItemDesc *DialogClocks_Item;

typedef
	struct DialogClocks_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[1];
	} DialogClocks_ItemDesc;

export void DialogClocks_Item_Copy (DialogClocks_Item c, Dialogs_Object *dup);
export void DialogClocks_Item_Draw (DialogClocks_Item c, INTEGER x, INTEGER y, Display_Frame f);
export void DialogClocks_Item_Handle (DialogClocks_Item c, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
export void DialogClocks_Item_Print (DialogClocks_Item c, INTEGER x, INTEGER y);
typedef
	struct DialogClocks_Time {
		LONGINT timeStamp, dateStamp;
	} DialogClocks_Time;

export void DialogClocks_Item_Redraw (DialogClocks_Item c, Display_Frame f, INTEGER x, INTEGER y, DialogClocks_Time old, DialogClocks_Time new);
static void DialogClocks_Item_Track (DialogClocks_Item c, INTEGER x, INTEGER y, SET keys, Display_Frame f, Dialogs_Panel p);
#define __DialogClocks_Item_Redraw(c, f, x, y, old, new) __SEND(__TYPEOF(c), 24, void(*)(DialogClocks_Item, Display_Frame, INTEGER, INTEGER, DialogClocks_Time, DialogClocks_Time), (c, f, x, y, old, new))
#define __DialogClocks_Item_Track(c, x, y, keys, f, p) __SEND(__TYPEOF(c), 25, void(*)(DialogClocks_Item, INTEGER, INTEGER, SET, Display_Frame, Dialogs_Panel), (c, x, y, keys, f, p))

typedef
	struct DialogClocks_NotifyMsg { /* Display_FrameMsg */
		DialogClocks_Time new;
	} DialogClocks_NotifyMsg;


export DialogClocks_Time DialogClocks_old;
static LONGINT DialogClocks_wakeUp;
static Fonts_Font DialogClocks_fnt;
static Oberon_Task DialogClocks_Task;

export LONGINT *DialogClocks_ItemDesc__typ;
export LONGINT *DialogClocks_Time__typ;
export LONGINT *DialogClocks_NotifyMsg__typ;

static void DialogClocks_Clock (void);
static void DialogClocks_Format (LONGINT time, CHAR *s, LONGINT s__len);
export void DialogClocks_Insert (void);


static struct Format__8 {
	CHAR *s;
	LONGINT s__len;
	INTEGER *i;
	struct Format__8 *lnk;
} *Format__8_s;

static void Pair__9 (LONGINT x);

static void Pair__9 (LONGINT x)
{
	Format__8_s->s[__X(*Format__8_s->i, Format__8_s->s__len)] = (CHAR)(__DIV(x, 10) + 48);
	*Format__8_s->i += 1;
	Format__8_s->s[__X(*Format__8_s->i, Format__8_s->s__len)] = (CHAR)(__MOD(x, 10) + 48);
	*Format__8_s->i += 1;
}

static void DialogClocks_Format (LONGINT time, CHAR *s, LONGINT s__len)
{
	INTEGER i = 0;
	struct Format__8 _s;
	_s.s = (void*)s; _s.s__len = s__len;
	_s.i = &i;
	_s.lnk = Format__8_s;
	Format__8_s = &_s;
	i = 0;
	Pair__9(__MASK(__ASHR(time, 12), -32));
	s[__X(i, s__len)] = ':';
	i += 1;
	Pair__9(__MASK(__ASHR(time, 6), -64));
	s[__X(i, s__len)] = ':';
	i += 1;
	Pair__9(__MASK(time, -64));
	s[__X(i, s__len)] = 0x00;
	Format__8_s = _s.lnk;
}

void DialogClocks_Item_Draw (DialogClocks_Item c, INTEGER x, INTEGER y, Display_Frame f)
{
	INTEGER mode = 0, w = 0, h = 0, ox = 0, oy = 0, cx = 0, yh = 0;
	CHAR str[12];
	__Dialogs_Object_GetDim((void*)c, &ox, &oy, &w, &h);
	if (c->selected) {
		mode = 2;
	} else {
		mode = 1;
	}
	yh = (y + __ASHR(h, 1)) - __ASHR(DialogClocks_fnt->minY + DialogClocks_fnt->maxY, 1);
	DialogClocks_Format(DialogClocks_old.timeStamp, (void*)str, 12);
	if (h - (yh - y) > DialogClocks_fnt->maxY) {
		GraphicUtils_DrawString(f, str, 12, x + 3, yh, w - 4, DialogClocks_fnt, mode, 1, &cx);
	}
}

void DialogClocks_Item_Print (DialogClocks_Item c, INTEGER x, INTEGER y)
{
	INTEGER w = 0, h = 0, ox = 0, oy = 0, cx = 0, yh = 0;
	CHAR str[12];
	DialogClocks_Time time = {0};
	LONGINT fnth = 0;
	__Dialogs_Object_GetPDim((void*)c, &ox, &oy, &w, &h);
	fnth = __ASHR(__DIV((LONGINT)(DialogClocks_fnt->maxY - DialogClocks_fnt->minY) * Dialogs_dUnit, Dialogs_pUnit), 1);
	yh = (y + __ASHR(h, 1)) - (int)fnth;
	Oberon_GetClock(&time.timeStamp, &time.dateStamp);
	DialogClocks_Format(time.timeStamp, (void*)str, 12);
	if (h - (yh - y) > (int)__DIV((LONGINT)DialogClocks_fnt->maxY * Dialogs_dUnit, Dialogs_pUnit)) {
		GraphicUtils_PrintString(str, 12, x + 3, yh, w - 4, DialogClocks_fnt, 1, &cx);
	}
}

void DialogClocks_Item_Copy (DialogClocks_Item c, Dialogs_Object *dup)
{
	DialogClocks_Item x = NIL;
	if (*dup == NIL) {
		__NEW(x, DialogClocks_ItemDesc);
		*dup = (Dialogs_Object)x;
	} else {
		x = __GUARDP(*dup, DialogClocks_ItemDesc, 1);
	}
	Dialogs_Object_Copy((void*)c, &*dup);
}

static void DialogClocks_Item_Track (DialogClocks_Item c, INTEGER x, INTEGER y, SET keys, Display_Frame f, Dialogs_Panel p)
{
	SET keysum = 0;
	Texts_Text t = NIL;
	if (keys == 0x02) {
		keysum = keys;
		do {
			Input_Mouse(&keys, &x, &y);
			keysum = keysum | keys;
			Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
		} while (!(keys == 0x0));
		if (keysum == 0x02 && c->cmd[0] != 0x00) {
			(*DialogTexts_GetParText)(c->par, 32, c->panel, &t);
			__Dialogs_Object_CallCmd((void*)c, f, Viewers_This(x, y), t);
		}
	} else {
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
	}
}

void DialogClocks_Item_Redraw (DialogClocks_Item c, Display_Frame f, INTEGER x, INTEGER y, DialogClocks_Time old, DialogClocks_Time new)
{
	if (c->selected) {
		return;
	}
	__Dialogs_Object_Hide((void*)c);
	__Dialogs_Object_Restore((void*)c);
}

void DialogClocks_Item_Handle (DialogClocks_Item c, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ)
{
	INTEGER x = 0, y = 0, w = 0, h = 0;
	Dialogs_Object_Handle((void*)c, f, &*m, m__typ);
	if (__ISP(f, DialogFrames_FrameDesc, 1)) {
		if (__IS(m__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *m__ = (void*)m;
			if ((*m__).id == 1) {
				__DialogClocks_Item_Track(c, (*m__).X, (*m__).Y, (*m__).keys, (void*)(*(DialogFrames_Frame*)&f), (*(DialogFrames_Frame*)&f)->panel);
			}
		} else if (__IS(m__typ, DialogClocks_NotifyMsg, 1)) {
			DialogClocks_NotifyMsg *m__ = (void*)m;
			__Dialogs_Object_GetDim((void*)c, &x, &y, &w, &h);
			x = x + (*(DialogFrames_Frame*)&f)->X;
			y = (y + (*(DialogFrames_Frame*)&f)->Y) + (*(DialogFrames_Frame*)&f)->H;
			__DialogClocks_Item_Redraw(c, (void*)(*(DialogFrames_Frame*)&f), x, y, DialogClocks_old, (*m__).new);
		}
	}
}

static void DialogClocks_Clock (void)
{
	DialogClocks_NotifyMsg msg = {0};
	if (Oberon_Time() >= DialogClocks_wakeUp) {
		Oberon_GetClock(&msg.new.timeStamp, &msg.new.dateStamp);
		if (msg.new.timeStamp != DialogClocks_old.timeStamp) {
			DialogClocks_wakeUp = Oberon_Time() + 281;
			Viewers_Broadcast((void*)&msg, DialogClocks_NotifyMsg__typ);
			DialogClocks_old = msg.new;
		} else {
			DialogClocks_wakeUp = Oberon_Time() + 18;
		}
	}
}

void DialogClocks_Insert (void)
{
	INTEGER x = 0, y = 0, x1 = 0, y1 = 0, w = 0, h = 0;
	DialogClocks_Item c = NIL;
	Dialogs_Panel p = NIL;
	CHAR name[64];
	__NEW(c, DialogClocks_ItemDesc);
	DialogFrames_GetCaretPosition(&p, &x, &y);
	if (p != NIL) {
		__Dialogs_Object_Init((void*)c);
		In_Open();
		In_Name((void*)name, 64);
		if (!In_Done) {
			__COPY("", name, 64);
			In_Open();
		}
		__Dialogs_Object_SetName((void*)c, name, 64);
		In_Int(&x1);
		In_Int(&y1);
		In_Int(&w);
		In_Int(&h);
		if (!In_Done) {
			x1 = x;
			y1 = y;
			w = 60;
			h = 20;
		} else {
			if (w < 0) {
				w = 60;
			}
			if (h < 0) {
				h = 20;
			}
		}
		__Dialogs_Object_SetDim((void*)c, x1, y1, w, h, 0);
		__Dialogs_Panel_Insert(p, (void*)c, 0);
	} else {
		Dialogs_res = 5;
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogClocks", (LONGINT)13);
	}
}

static void EnumPtrs(void (*P)(void*))
{
	P(DialogClocks_fnt);
	P(DialogClocks_Task);
}

__TDESC(DialogClocks_ItemDesc, 27, 2) = {__TDFLDS("ItemDesc", 112), {0, 104, -12}};
__TDESC(DialogClocks_Time, 1, 0) = {__TDFLDS("Time", 8), {-4}};
__TDESC(DialogClocks_NotifyMsg, 1, 0) = {__TDFLDS("NotifyMsg", 8), {-4}};

export void *DialogClocks__init(void)
{
	__DEFMOD;
	__IMPORT(DialogFrames);
	__IMPORT(DialogTexts);
	__IMPORT(Dialogs);
	__IMPORT(Display);
	__IMPORT(Fonts);
	__IMPORT(GraphicUtils);
	__IMPORT(In);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(DialogClocks, EnumPtrs);
	__REGCMD("Insert", DialogClocks_Insert);
	__INITYP(DialogClocks_ItemDesc, Dialogs_ObjectDesc, 1);
	__INITBP(DialogClocks_ItemDesc, DialogClocks_Item_Copy, 1);
	__INITBP(DialogClocks_ItemDesc, DialogClocks_Item_Draw, 2);
	__INITBP(DialogClocks_ItemDesc, DialogClocks_Item_Handle, 6);
	__INITBP(DialogClocks_ItemDesc, DialogClocks_Item_Print, 14);
	__INITBP(DialogClocks_ItemDesc, DialogClocks_Item_Redraw, 24);
	__INITBP(DialogClocks_ItemDesc, DialogClocks_Item_Track, 25);
	__INITYP(DialogClocks_Time, DialogClocks_Time, 0);
	__INITYP(DialogClocks_NotifyMsg, Display_FrameMsg, 1);
/* BEGIN */
	Oberon_GetClock(&DialogClocks_old.timeStamp, &DialogClocks_old.dateStamp);
	DialogClocks_fnt = Fonts_This((CHAR*)"Syntax10.Scn.Fnt", (LONGINT)17);
	__NEW(DialogClocks_Task, Oberon_TaskDesc);
	DialogClocks_Task->safe = 0;
	DialogClocks_Task->handle = DialogClocks_Clock;
	Oberon_Install(DialogClocks_Task);
	__ENDMOD;
}
