/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Bitmaps.h"
#include "DialogCheckBoxes.h"
#include "DialogFrames.h"
#include "DialogListBoxes.h"
#include "DialogSliders.h"
#include "DialogStaticTexts.h"
#include "DialogTexts.h"
#include "Dialogs.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "GraphicUtils.h"
#include "In.h"
#include "Input.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "Printer.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct DialogComboBoxes_ChangeMsg { /* Display_FrameMsg */
		LONGINT x, y;
	} DialogComboBoxes_ChangeMsg;

typedef
	struct DialogComboBoxes_ItemDesc *DialogComboBoxes_Item;

typedef
	struct DialogComboBoxes_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[4];
		Texts_Text menu;
		BOOLEAN readonly;
		INTEGER selline, lbHeight, n;
		TextFrames_Frame f;
	} DialogComboBoxes_ItemDesc;

export void DialogComboBoxes_Item_Copy (DialogComboBoxes_Item b, Dialogs_Object *dup);
export void DialogComboBoxes_Item_Draw (DialogComboBoxes_Item b, INTEGER x, INTEGER y, Display_Frame f);
export void DialogComboBoxes_Item_Edit (DialogComboBoxes_Item b);
export Texts_Text DialogComboBoxes_Item_GetTitle (DialogComboBoxes_Item b);
export void DialogComboBoxes_Item_Handle (DialogComboBoxes_Item b, Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
export void DialogComboBoxes_Item_Init (DialogComboBoxes_Item b);
export void DialogComboBoxes_Item_Load (DialogComboBoxes_Item b, Files_Rider *r, LONGINT *r__typ);
static void DialogComboBoxes_Item_Popup (DialogComboBoxes_Item b, INTEGER x, INTEGER y, INTEGER w, INTEGER h, Display_Frame f);
export void DialogComboBoxes_Item_Print (DialogComboBoxes_Item b, INTEGER x, INTEGER y);
export void DialogComboBoxes_Item_SetTitle (DialogComboBoxes_Item b, Texts_Text t);
export void DialogComboBoxes_Item_Store (DialogComboBoxes_Item b, Files_Rider *r, LONGINT *r__typ);
export void DialogComboBoxes_Item_Update (DialogComboBoxes_Item b, Dialogs_Panel p);
#define __DialogComboBoxes_Item_GetTitle(b) __SEND(__TYPEOF(b), 24, Texts_Text(*)(DialogComboBoxes_Item), (b))
#define __DialogComboBoxes_Item_Popup(b, x, y, w, h, f) __SEND(__TYPEOF(b), 25, void(*)(DialogComboBoxes_Item, INTEGER, INTEGER, INTEGER, INTEGER, Display_Frame), (b, x, y, w, h, f))
#define __DialogComboBoxes_Item_SetTitle(b, t) __SEND(__TYPEOF(b), 26, void(*)(DialogComboBoxes_Item, Texts_Text), (b, t))


static Texts_Writer DialogComboBoxes_w0;

export LONGINT *DialogComboBoxes_ItemDesc__typ;
export LONGINT *DialogComboBoxes_ChangeMsg__typ;

static void DialogComboBoxes_Adjust (TextFrames_Frame f, INTEGER id, INTEGER dY, INTEGER y, INTEGER h);
static void DialogComboBoxes_DrawFrame (Display_Frame f1, Display_Frame f, BOOLEAN m);
export void DialogComboBoxes_Insert (void);
static INTEGER DialogComboBoxes_Max (INTEGER x, INTEGER y);
static void DialogComboBoxes_NilNotifier (Texts_Text T, INTEGER op, LONGINT beg, LONGINT end);
static void DialogComboBoxes_ParText (CHAR *n, LONGINT n__len, Dialogs_Panel p, Texts_Text *t);
static void DialogComboBoxes_WriteToObjectInt (DialogTexts_Item o, INTEGER n);


static INTEGER DialogComboBoxes_Max (INTEGER x, INTEGER y)
{
	if (x > y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

void DialogComboBoxes_Item_Copy (DialogComboBoxes_Item b, Dialogs_Object *dup)
{
	DialogComboBoxes_Item x = NIL;
	if (*dup == NIL) {
		__NEW(x, DialogComboBoxes_ItemDesc);
		*dup = (Dialogs_Object)x;
	} else {
		x = __GUARDP(*dup, DialogComboBoxes_ItemDesc, 1);
	}
	Dialogs_Object_Copy((void*)b, &*dup);
	x->menu = TextFrames_Text((CHAR*)"", (LONGINT)1);
	x->selline = b->selline;
	x->readonly = b->readonly;
	x->lbHeight = b->lbHeight;
	x->f = TextFrames_NewText(TextFrames_Text((CHAR*)"", (LONGINT)1), 0);
}

void DialogComboBoxes_Item_Load (DialogComboBoxes_Item b, Files_Rider *r, LONGINT *r__typ)
{
	Dialogs_Object_Load((void*)b, &*r, r__typ);
	Files_ReadBool(&*r, r__typ, &b->readonly);
	Files_ReadInt(&*r, r__typ, &b->lbHeight);
}

void DialogComboBoxes_Item_Store (DialogComboBoxes_Item b, Files_Rider *r, LONGINT *r__typ)
{
	Dialogs_Object_Store((void*)b, &*r, r__typ);
	Files_WriteBool(&*r, r__typ, b->readonly);
	Files_WriteInt(&*r, r__typ, b->lbHeight);
}

void DialogComboBoxes_Item_Print (DialogComboBoxes_Item b, INTEGER x, INTEGER y)
{
	INTEGER h = 0, w = 0, ox = 0, oy = 0, i = 0, p = 0;
	__Dialogs_Object_GetPDim((void*)b, &ox, &oy, &w, &h);
	if (w > h) {
		p = h;
		w -= h;
	} else {
		p = 0;
	}
	GraphicUtils_PrintBox(x, y, w, h);
	if (p > (int)(__DIV(9, Dialogs_dUnit) * Dialogs_pUnit)) {
		i = __ASHR(p - (int)(__DIV(9, Dialogs_dUnit) * Dialogs_pUnit), 1);
		GraphicUtils_PrintPatternBox(DialogSliders_downArrow, (x + w) + 1, y, p, p, i, i);
	}
}

static void DialogComboBoxes_DrawFrame (Display_Frame f1, Display_Frame f, BOOLEAN m)
{
	INTEGER mode = 0;
	if (m) {
		mode = 2;
	} else {
		mode = 0;
	}
	Display_ReplConstC(f1, 15, f->X - 1, f->Y, 1, f->H + 1, mode);
	Display_ReplConstC(f1, 0, f->X + f->W, f->Y, 1, f->H + 1, mode);
	Display_ReplConstC(f1, 0, f->X, f->Y, f->W - 1, 1, mode);
	Display_ReplConstC(f1, 15, f->X, f->Y + f->H, f->W - 1, 1, mode);
}

static void DialogComboBoxes_Adjust (TextFrames_Frame f, INTEGER id, INTEGER dY, INTEGER y, INTEGER h)
{
	MenuViewers_ModifyMsg m = {0};
	m.id = id;
	m.dY = dY;
	m.Y = y;
	m.H = 0;
	(*f->handle)((void*)f, (void*)&m, MenuViewers_ModifyMsg__typ);
	m.id = id;
	m.dY = dY;
	m.Y = y;
	m.H = h;
	(*f->handle)((void*)f, (void*)&m, MenuViewers_ModifyMsg__typ);
}

void DialogComboBoxes_Item_Draw (DialogComboBoxes_Item b, INTEGER x, INTEGER y, Display_Frame f)
{
	INTEGER ox = 0, oy = 0, w = 0, h = 0, w1 = 0, h1 = 0, p = 0, i = 0;
	LONGINT pat = 0;
	x += 1;
	__Dialogs_Object_GetDim((void*)b, &ox, &oy, &w, &h);
	w -= 2;
	h -= 1;
	if (((y + h <= f->Y || y >= f->Y + f->H) || x + w <= f->X) || x >= f->X + f->W) {
		return;
	}
	if (x < f->X && x + w > f->X) {
		w = w - (f->X - x);
		x = f->X;
	}
	if (y < f->Y && y + h > f->Y) {
		h = h - (f->Y - y);
		y = f->Y;
	}
	w1 = f->W - (x - f->X);
	h1 = f->H - (y - f->Y);
	if (w1 < b->f->left) {
		return;
	}
	if (w > w1) {
		w = w1;
	}
	if (h > h1) {
		h = h1;
	}
	if (w < 0) {
		w = 0;
	}
	if (h < 0) {
		h = 0;
	}
	if (w > h) {
		p = h;
		w -= h;
	} else {
		p = 0;
	}
	b->f->X = x;
	b->f->Y = y;
	b->f->W = w;
	b->f->H = h;
	Oberon_RemoveMarks(f->X, f->Y, f->W, f->H);
	DialogComboBoxes_DrawFrame(f, (void*)b->f, b->selected);
	b->f->barW = 0;
	b->f->left = 3;
	b->f->right = 3;
	b->f->bot = 1;
	b->f->top = 2;
	DialogComboBoxes_Adjust(b->f, 0, 0, b->f->Y + 1, b->f->H - 1);
	if (p > 9) {
		i = __ASHR(p - 9, 1);
		GraphicUtils_DrawPatternBox(f, 0, DialogSliders_downArrow, (x + w) + 1, y, p, p, i, i, 1);
	}
}

static void DialogComboBoxes_NilNotifier (Texts_Text T, INTEGER op, LONGINT beg, LONGINT end)
{
}

static void DialogComboBoxes_Item_Popup (DialogComboBoxes_Item b, INTEGER x, INTEGER y, INTEGER w, INTEGER h, Display_Frame f)
{
	INTEGER menuX = 0, menuY = 0, menuW = 0, menuH = 0, p = 0, i = 0, lsp = 0, dsc = 0, sc = 0, pos1 = 0, pos2 = 0;
	Texts_Text t1 = NIL;
	Texts_Reader r = {0};
	SET keys = 0;
	CHAR ch = 0;
	Bitmaps_Bitmap bit = NIL;
	if (w > h) {
		p = h;
	} else {
		p = 0;
	}
	if (p > 9) {
		i = __ASHR(p - 9, 1);
		GraphicUtils_DrawPatternBox(f, 1, DialogSliders_downArrow, ((x + w) - p) + 1, y, p, p, i, i, 1);
	}
	menuW = w + 10;
	menuH = DialogComboBoxes_Max(b->lbHeight, 40);
	if (y - menuH >= 0) {
		menuY = y - menuH;
	} else if ((y + h) + menuH <= Display_Height) {
		menuY = y + h;
	} else {
		menuY = 0;
	}
	if (x + menuW <= Display_Width) {
		menuX = x;
	} else {
		menuX = DialogComboBoxes_Max((x + w) - menuW, 0);
	}
	Oberon_RemoveMarks(menuX, menuY, menuW, menuH);
	Oberon_FadeCursor(&Oberon_Mouse, Oberon_Cursor__typ);
	bit = Bitmaps_New(menuW, menuH);
	Bitmaps_CopyBlock(Bitmaps_Disp, bit, menuX, menuY, menuW, menuH, 0, 0, 0);
	sc = b->selline;
	GraphicUtils_DrawMenu(NIL, b->menu, sc, b->selline, menuX, menuY, menuW, menuH, 0, &b->n, &lsp, &dsc);
	GraphicUtils_TrackMenu(NIL, b->menu, menuX, menuY, menuW, menuH, b->n, lsp, dsc, &sc, &b->selline);
	Oberon_FadeCursor(&Oberon_Mouse, Oberon_Cursor__typ);
	Bitmaps_CopyBlock(bit, Bitmaps_Disp, 0, 0, menuW, menuH, menuX, menuY, 0);
	if (p > 9) {
		i = __ASHR(p - 9, 1);
		GraphicUtils_DrawPatternBox(f, 0, DialogSliders_downArrow, ((x + w) - p) + 1, y, p, p, i, i, 1);
	}
	if (b->selline > -1) {
		(*DialogTexts_GetParText)(b->par, 32, b->panel, &t1);
		GraphicUtils_Set(&r, Texts_Reader__typ, b->menu, &b->selline);
		pos1 = (int)Texts_Pos(&r, Texts_Reader__typ);
		while (!r.eot && ch != 0x0d) {
			Texts_Read(&r, Texts_Reader__typ, &ch);
		}
		pos2 = (int)Texts_Pos(&r, Texts_Reader__typ);
		Texts_Save(b->menu, pos1, pos2, DialogComboBoxes_w0.buf);
		b->f->text->notify = DialogComboBoxes_NilNotifier;
		Texts_Delete(b->f->text, 0, b->f->text->len);
		b->f->text->notify = TextFrames_NotifyDisplay;
		Texts_Append(b->f->text, DialogComboBoxes_w0.buf);
	}
}

void DialogComboBoxes_Item_SetTitle (DialogComboBoxes_Item b, Texts_Text t)
{
	b->f->text = t;
	__Dialogs_Object_Restore((void*)b);
}

Texts_Text DialogComboBoxes_Item_GetTitle (DialogComboBoxes_Item b)
{
	return b->f->text;
}

void DialogComboBoxes_Item_Handle (DialogComboBoxes_Item b, Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	INTEGER x = 0, y = 0, w = 0, h = 0, p = 0, xh = 0, yh = 0, h1 = 0;
	Viewers_Viewer v = NIL;
	Oberon_CopyMsg msg1 = {0};
	Display_Frame f1 = NIL;
	BOOLEAN cond = 0;
	DialogComboBoxes_ChangeMsg msg2 = {0};
	Texts_Text t1 = NIL;
	Dialogs_Object_Handle((void*)b, f, &*msg, msg__typ);
	__Dialogs_Object_GetDim((void*)b, &x, &y, &w, &h);
	if (w > h) {
		p = h;
	} else {
		p = 0;
	}
	if (__ISP(f, DialogFrames_FrameDesc, 1)) {
		yh = ((*(DialogFrames_Frame*)&f)->Y + (*(DialogFrames_Frame*)&f)->H) + y;
		xh = (*(DialogFrames_Frame*)&f)->X + x;
		if (__IS(msg__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *msg__ = (void*)msg;
			Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, (*msg__).X, (*msg__).Y);
			if (((((((*msg__).id == 1 && p > 0) && (*msg__).X >= (xh + w) - p) && (*msg__).X <= xh + w) && (*msg__).Y >= yh) && (*msg__).Y <= yh + h) && (*msg__).keys != 0x0) {
				__DialogComboBoxes_Item_Popup(b, xh, yh, w, h, (void*)(*(DialogFrames_Frame*)&f));
				return;
			}
		}
		if (yh < (*(DialogFrames_Frame*)&f)->Y) {
			h1 = (h - (*(DialogFrames_Frame*)&f)->Y) + yh;
		} else {
			h1 = h;
		}
		if ((((yh + h <= (*(DialogFrames_Frame*)&f)->Y || yh >= (*(DialogFrames_Frame*)&f)->Y + (*(DialogFrames_Frame*)&f)->H) || xh + w <= (*(DialogFrames_Frame*)&f)->X) || xh >= (*(DialogFrames_Frame*)&f)->X + (*(DialogFrames_Frame*)&f)->W) || h1 < 20) {
			return;
		}
		if (b->readonly && __IS(msg__typ, Oberon_InputMsg, 1)) {
			return;
		}
		if ((((*(DialogFrames_Frame*)&f)->X <= b->f->X && (*(DialogFrames_Frame*)&f)->X + (*(DialogFrames_Frame*)&f)->W >= b->f->X) && (*(DialogFrames_Frame*)&f)->Y <= b->f->Y) && (*(DialogFrames_Frame*)&f)->Y + (*(DialogFrames_Frame*)&f)->H >= b->f->Y) {
			if (__IS(msg__typ, TextFrames_UpdateMsg, 1)) {
				if (__GUARDR(msg, TextFrames_UpdateMsg, 1).text == b->f->text) {
					(*b->f->handle)((void*)b->f, &*msg, msg__typ);
					msg2.x = (*(DialogFrames_Frame*)&f)->X;
					msg2.y = (*(DialogFrames_Frame*)&f)->Y;
					Viewers_Broadcast((void*)&msg2, DialogComboBoxes_ChangeMsg__typ);
					if ((((*(DialogFrames_Frame*)&f)->X > b->f->X || (*(DialogFrames_Frame*)&f)->X + (*(DialogFrames_Frame*)&f)->W < b->f->X) || (*(DialogFrames_Frame*)&f)->Y > b->f->Y) || (*(DialogFrames_Frame*)&f)->Y + (*(DialogFrames_Frame*)&f)->H < b->f->Y) {
						__Dialogs_Object_Draw((void*)b, (*(DialogFrames_Frame*)&f)->X + x, ((*(DialogFrames_Frame*)&f)->Y + (*(DialogFrames_Frame*)&f)->H) + y, (void*)(*(DialogFrames_Frame*)&f));
					}
					if (b->cmd[0] != 0x00) {
						(*DialogTexts_GetParText)(b->par, 32, b->panel, &t1);
						__Dialogs_Object_CallCmd((void*)b, (void*)(*(DialogFrames_Frame*)&f), Viewers_This(xh, yh), t1);
					}
				}
			} else if (__IS(msg__typ, MenuViewers_ModifyMsg, 1)) {
				if (__GUARDR(msg, MenuViewers_ModifyMsg, 1).id == 1) {
					__Dialogs_Object_Restore((void*)b);
				}
			} else {
				(*b->f->handle)((void*)b->f, &*msg, msg__typ);
			}
		} else {
			cond = 0;
			if (__IS(msg__typ, Oberon_InputMsg, 1)) {
				Oberon_InputMsg *msg__ = (void*)msg;
				if ((((((*msg__).id == 1 && (*msg__).X >= xh) && (*msg__).X <= xh + w) && (*msg__).Y >= yh) && (*msg__).Y <= yh + h) && (*msg__).keys != 0x0) {
					cond = 1;
				}
				if ((*msg__).id == 0) {
					cond = 1;
				}
			} else if (__IS(msg__typ, DialogComboBoxes_ChangeMsg, 1)) {
				DialogComboBoxes_ChangeMsg *msg__ = (void*)msg;
				__Dialogs_Object_Draw((void*)b, (*(DialogFrames_Frame*)&f)->X + x, ((*(DialogFrames_Frame*)&f)->Y + (*(DialogFrames_Frame*)&f)->H) + y, (void*)(*(DialogFrames_Frame*)&f));
			}
			if (cond) {
				TextFrames_RemoveCaret(b->f);
				__Dialogs_Object_Draw((void*)b, (*(DialogFrames_Frame*)&f)->X + x, ((*(DialogFrames_Frame*)&f)->Y + (*(DialogFrames_Frame*)&f)->H) + y, (void*)(*(DialogFrames_Frame*)&f));
				(*b->f->handle)((void*)b->f, &*msg, msg__typ);
			}
		}
	}
}

void DialogComboBoxes_Item_Init (DialogComboBoxes_Item b)
{
	Dialogs_Object_Init((void*)b);
	b->menu = TextFrames_Text((CHAR*)"", (LONGINT)1);
	b->f = TextFrames_NewText(TextFrames_Text((CHAR*)"", (LONGINT)1), 0);
	b->lbHeight = 100;
}

static void DialogComboBoxes_WriteToObjectInt (DialogTexts_Item o, INTEGER n)
{
	Texts_Text t = NIL;
	t = __DialogTexts_Item_GetText(o);
	Texts_WriteInt(&DialogComboBoxes_w0, Texts_Writer__typ, n, 0);
	Texts_Append(t, DialogComboBoxes_w0.buf);
}

void DialogComboBoxes_Item_Edit (DialogComboBoxes_Item b)
{
	Dialogs_Object on = NIL;
	DialogTexts_Item os = NIL, t = NIL;
	DialogStaticTexts_Item s = NIL;
	DialogCheckBoxes_Item c = NIL;
	Texts_Text t1 = NIL;
	Fonts_Font fnt = NIL;
	Dialogs_Object_Edit((void*)b);
	__NEW(s, DialogStaticTexts_ItemDesc);
	__Dialogs_Object_Init((void*)s);
	__Dialogs_Object_SetDim((void*)s, 2, -176, 35, 20, 0);
	__DialogStaticTexts_Item_SetString(s, (CHAR*)"lbHeight", (LONGINT)9);
	fnt = Fonts_This((CHAR*)"Syntax10.Scn.Fnt", (LONGINT)17);
	__DialogStaticTexts_Item_SetFont(s, fnt);
	__Dialogs_Panel_Insert(Dialogs_editPanel, (void*)s, 0);
	__ASSERT(Dialogs_res == 0, 0);
	__NEW(t, DialogTexts_ItemDesc);
	__Dialogs_Object_Init((void*)t);
	__Dialogs_Object_SetDim((void*)t, 38, -176, 40, 19, 0);
	__Dialogs_Object_SetName((void*)t, (CHAR*)"LBh", (LONGINT)4);
	__Dialogs_Panel_Insert(Dialogs_editPanel, (void*)t, 0);
	__ASSERT(Dialogs_res == 0, 0);
	DialogComboBoxes_WriteToObjectInt(t, b->lbHeight);
	__NEW(c, DialogCheckBoxes_ItemDesc);
	__Dialogs_Object_Init((void*)c);
	__Dialogs_Object_SetDim((void*)c, 195, -30, 20, 19, 0);
	__Dialogs_Object_SetName((void*)c, (CHAR*)"RO", (LONGINT)3);
	__Dialogs_Panel_Insert(Dialogs_editPanel, (void*)c, 0);
	__ASSERT(Dialogs_res == 0, 0);
	__DialogCheckBoxes_Item_ChangeValue(c, b->readonly);
	__NEW(s, DialogStaticTexts_ItemDesc);
	__Dialogs_Object_Init((void*)s);
	__Dialogs_Object_SetDim((void*)s, 215, -30, 60, 22, 0);
	__DialogStaticTexts_Item_SetString(s, (CHAR*)"readonly", (LONGINT)9);
	fnt = Fonts_This((CHAR*)"Syntax10.Scn.Fnt", (LONGINT)17);
	__DialogStaticTexts_Item_SetFont(s, fnt);
	__Dialogs_Panel_Insert(Dialogs_editPanel, (void*)s, 0);
	__ASSERT(Dialogs_res == 0, 0);
}

void DialogComboBoxes_Item_Update (DialogComboBoxes_Item b, Dialogs_Panel p)
{
	Dialogs_Object o = NIL;
	Texts_Text t1 = NIL;
	Texts_Scanner s = {0};
	CHAR ch = 0;
	CHAR str[64];
	INTEGER i = 0;
	BOOLEAN cond = 0;
	Dialogs_Object_Update((void*)b, p);
	o = __Dialogs_Panel_NamedObject(p, (CHAR*)"LBh", (LONGINT)4);
	t1 = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
	Texts_OpenScanner(&s, Texts_Scanner__typ, t1, 0);
	Texts_Scan(&s, Texts_Scanner__typ);
	i = b->lbHeight;
	if (s.class == 3 && s.i != (LONGINT)i) {
		b->lbHeight = (int)s.i;
		__Dialogs_Panel_MarkMenu(b->panel);
	}
	o = __Dialogs_Panel_NamedObject(p, (CHAR*)"RO", (LONGINT)3);
	cond = __GUARDP(o, DialogCheckBoxes_ItemDesc, 1)->on;
	if (cond != b->readonly) {
		b->readonly = cond;
		__Dialogs_Panel_MarkMenu(b->panel);
	}
}

static void DialogComboBoxes_ParText (CHAR *n, LONGINT n__len, Dialogs_Panel p, Texts_Text *t)
{
	Texts_Text t0 = NIL, t1 = NIL;
	Texts_Scanner s = {0};
	Dialogs_Object o = NIL;
	__DUP(n, n__len, CHAR);
	*t = TextFrames_Text((CHAR*)"", (LONGINT)1);
	t0 = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_WriteString(&DialogComboBoxes_w0, Texts_Writer__typ, n, n__len);
	Texts_Append(t0, DialogComboBoxes_w0.buf);
	Texts_OpenScanner(&s, Texts_Scanner__typ, t0, 0);
	Texts_Scan(&s, Texts_Scanner__typ);
	while (s.class != 6 || s.c != 0x00) {
		if (s.class == 1) {
			o = __Dialogs_Panel_NamedObject(p, s.s, 256);
			if (o != NIL && __ISP(o, DialogTexts_ItemDesc, 1)) {
				t1 = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
				Texts_Save(t1, 0, t1->len, DialogComboBoxes_w0.buf);
				Texts_WriteString(&DialogComboBoxes_w0, Texts_Writer__typ, (CHAR*)" ", (LONGINT)2);
				Texts_Append(*t, DialogComboBoxes_w0.buf);
			} else if (o != NIL && __ISP(o, DialogComboBoxes_ItemDesc, 1)) {
				t1 = __DialogComboBoxes_Item_GetTitle(__GUARDP(o, DialogComboBoxes_ItemDesc, 1));
				Texts_Save(t1, 0, t1->len, DialogComboBoxes_w0.buf);
				Texts_WriteString(&DialogComboBoxes_w0, Texts_Writer__typ, (CHAR*)" ", (LONGINT)2);
				Texts_Append(*t, DialogComboBoxes_w0.buf);
			}
		} else if (s.class == 2) {
			Texts_WriteString(&DialogComboBoxes_w0, Texts_Writer__typ, s.s, 256);
			Texts_Append(*t, DialogComboBoxes_w0.buf);
		}
		Texts_Scan(&s, Texts_Scanner__typ);
	}
	__DEL(n);
}

void DialogComboBoxes_Insert (void)
{
	INTEGER x = 0, y = 0, x1 = 0, y1 = 0, w = 0, h = 0;
	DialogComboBoxes_Item b = NIL;
	Dialogs_Panel p = NIL;
	CHAR name[64];
	__NEW(b, DialogComboBoxes_ItemDesc);
	DialogFrames_GetCaretPosition(&p, &x, &y);
	if (p != NIL) {
		__Dialogs_Object_Init((void*)b);
		In_Open();
		In_Name((void*)name, 64);
		if (!In_Done) {
			__COPY("", name, 64);
			In_Open();
		}
		__Dialogs_Object_SetName((void*)b, name, 64);
		In_Int(&x1);
		In_Int(&y1);
		In_Int(&w);
		In_Int(&h);
		if (!In_Done) {
			x1 = x;
			y1 = y;
			w = 60;
			h = 22;
		} else {
			if (w < 0) {
				w = 60;
			}
			if (h < 0) {
				h = 22;
			}
		}
		__Dialogs_Object_SetDim((void*)b, x1, y1, w, h, 0);
		__Dialogs_Panel_Insert(p, (void*)b, 0);
	} else {
		Dialogs_res = 5;
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogComboBoxes", (LONGINT)17);
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&DialogComboBoxes_w0, Texts_Writer__typ, 36, 1, P);
}

__TDESC(DialogComboBoxes_ItemDesc, 28, 4) = {__TDFLDS("ItemDesc", 128), {0, 104, 112, 124, -20}};
__TDESC(DialogComboBoxes_ChangeMsg, 1, 0) = {__TDFLDS("ChangeMsg", 8), {-4}};

export void *DialogComboBoxes__init(void)
{
	__DEFMOD;
	__IMPORT(Bitmaps);
	__IMPORT(DialogCheckBoxes);
	__IMPORT(DialogFrames);
	__IMPORT(DialogListBoxes);
	__IMPORT(DialogSliders);
	__IMPORT(DialogStaticTexts);
	__IMPORT(DialogTexts);
	__IMPORT(Dialogs);
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(GraphicUtils);
	__IMPORT(In);
	__IMPORT(Input);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(DialogComboBoxes, EnumPtrs);
	__REGCMD("Insert", DialogComboBoxes_Insert);
	__INITYP(DialogComboBoxes_ItemDesc, Dialogs_ObjectDesc, 1);
	__INITBP(DialogComboBoxes_ItemDesc, DialogComboBoxes_Item_Copy, 1);
	__INITBP(DialogComboBoxes_ItemDesc, DialogComboBoxes_Item_Draw, 2);
	__INITBP(DialogComboBoxes_ItemDesc, DialogComboBoxes_Item_Edit, 3);
	__INITBP(DialogComboBoxes_ItemDesc, DialogComboBoxes_Item_GetTitle, 24);
	__INITBP(DialogComboBoxes_ItemDesc, DialogComboBoxes_Item_Handle, 6);
	__INITBP(DialogComboBoxes_ItemDesc, DialogComboBoxes_Item_Init, 8);
	__INITBP(DialogComboBoxes_ItemDesc, DialogComboBoxes_Item_Load, 12);
	__INITBP(DialogComboBoxes_ItemDesc, DialogComboBoxes_Item_Popup, 25);
	__INITBP(DialogComboBoxes_ItemDesc, DialogComboBoxes_Item_Print, 14);
	__INITBP(DialogComboBoxes_ItemDesc, DialogComboBoxes_Item_SetTitle, 26);
	__INITBP(DialogComboBoxes_ItemDesc, DialogComboBoxes_Item_Store, 21);
	__INITBP(DialogComboBoxes_ItemDesc, DialogComboBoxes_Item_Update, 23);
	__INITYP(DialogComboBoxes_ChangeMsg, Display_FrameMsg, 1);
/* BEGIN */
	Texts_OpenWriter(&DialogComboBoxes_w0, Texts_Writer__typ);
	DialogTexts_GetParText = DialogComboBoxes_ParText;
	__ENDMOD;
}
