/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "DialogFrames.h"
#include "DialogTexts.h"
#include "Dialogs.h"
#include "Display.h"
#include "Display1.h"
#include "Files.h"
#include "GraphicUtils.h"
#include "In.h"
#include "Input.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct DialogListBoxes_ItemDesc *DialogListBoxes_Item;

typedef
	struct DialogListBoxes_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[4];
		Texts_Text menu;
		INTEGER n, lsp, dsc, selline, startcmd;
	} DialogListBoxes_ItemDesc;

export void DialogListBoxes_Item_Copy (DialogListBoxes_Item b, Dialogs_Object *dup);
export void DialogListBoxes_Item_Draw (DialogListBoxes_Item b, INTEGER x, INTEGER y, Display_Frame f);
export void DialogListBoxes_Item_Handle (DialogListBoxes_Item b, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
export void DialogListBoxes_Item_Init (DialogListBoxes_Item b);
export void DialogListBoxes_Item_Print (DialogListBoxes_Item b, INTEGER x, INTEGER y);
export void DialogListBoxes_Item_SetMenu (DialogListBoxes_Item b, Texts_Text t);
static void DialogListBoxes_Item_Track (DialogListBoxes_Item b, INTEGER x, INTEGER y, SET keys, Display_Frame f, Dialogs_Panel p);
#define __DialogListBoxes_Item_SetMenu(b, t) __SEND(__TYPEOF(b), 24, void(*)(DialogListBoxes_Item, Texts_Text), (b, t))
#define __DialogListBoxes_Item_Track(b, x, y, keys, f, p) __SEND(__TYPEOF(b), 25, void(*)(DialogListBoxes_Item, INTEGER, INTEGER, SET, Display_Frame, Dialogs_Panel), (b, x, y, keys, f, p))



export LONGINT *DialogListBoxes_ItemDesc__typ;

export void DialogListBoxes_Insert (void);
static INTEGER DialogListBoxes_Max (INTEGER x, INTEGER y);
static INTEGER DialogListBoxes_Min (INTEGER x, INTEGER y);


static INTEGER DialogListBoxes_Max (INTEGER x, INTEGER y)
{
	if (x > y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static INTEGER DialogListBoxes_Min (INTEGER x, INTEGER y)
{
	if (x < y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

void DialogListBoxes_Item_Draw (DialogListBoxes_Item b, INTEGER x, INTEGER y, Display_Frame f)
{
	INTEGER bx = 0, by = 0, w = 0, h = 0, mode = 0;
	__Dialogs_Object_GetDim((void*)b, &bx, &by, &w, &h);
	if (b->selected) {
		mode = 2;
	} else {
		mode = 0;
	}
	GraphicUtils_DrawMenu(f, b->menu, b->startcmd, b->selline, x, y, w, h, mode, &b->n, &b->lsp, &b->dsc);
	if (b->n < b->selline) {
		b->selline = b->n - 1;
	}
}

void DialogListBoxes_Item_Print (DialogListBoxes_Item b, INTEGER x, INTEGER y)
{
	INTEGER ox = 0, oy = 0, ow = 0, oh = 0;
	__Dialogs_Object_GetPDim((void*)b, &ox, &oy, &ow, &oh);
	GraphicUtils_PrintBox(x, y, ow, oh);
}

void DialogListBoxes_Item_Init (DialogListBoxes_Item b)
{
	Dialogs_Object_Init((void*)b);
	b->menu = TextFrames_Text((CHAR*)"", (LONGINT)1);
	b->selline = 0;
	b->startcmd = 0;
}

void DialogListBoxes_Item_SetMenu (DialogListBoxes_Item b, Texts_Text t)
{
	b->selline = 0;
	b->menu = t;
	__Dialogs_Object_Restore((void*)b);
}

static void DialogListBoxes_Item_Track (DialogListBoxes_Item b, INTEGER x, INTEGER y, SET keys, Display_Frame f, Dialogs_Panel p)
{
	SET keysum = 0;
	CHAR dummy[6];
	INTEGER bx = 0, by = 0, w = 0, h = 0;
	Texts_Text t = NIL;
	if ((keys == 0x02 || keys == 0x04) || keys == 0x01) {
		__Dialogs_Object_GetDim((void*)b, &bx, &by, &w, &h);
		bx = f->X + bx;
		by = (f->Y + f->H) + by;
		GraphicUtils_TrackMenu(f, b->menu, bx, by, w, h, b->n, b->lsp, b->dsc, &b->startcmd, &b->selline);
		if (b->selline >= 0) {
			__Dialogs_Object_Restore((void*)b);
			if (b->cmd[0] != 0x00) {
				(*DialogTexts_GetParText)(b->par, 32, b->panel, &t);
				__Dialogs_Object_CallCmd((void*)b, f, Viewers_This(x, y), t);
			}
		}
	} else {
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
	}
}

void DialogListBoxes_Item_Handle (DialogListBoxes_Item b, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ)
{
	Dialogs_Object_Handle((void*)b, f, &*m, m__typ);
	if (__ISP(f, DialogFrames_FrameDesc, 1)) {
		if (__IS(m__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *m__ = (void*)m;
			if ((*m__).id == 1) {
				__DialogListBoxes_Item_Track(b, (*m__).X, (*m__).Y, (*m__).keys, (void*)(*(DialogFrames_Frame*)&f), (*(DialogFrames_Frame*)&f)->panel);
			}
		} else if (__IS(m__typ, TextFrames_UpdateMsg, 1)) {
			TextFrames_UpdateMsg *m__ = (void*)m;
			if ((*m__).text == b->menu) {
				__Dialogs_Object_Restore((void*)b);
			}
		}
	}
}

void DialogListBoxes_Item_Copy (DialogListBoxes_Item b, Dialogs_Object *dup)
{
	DialogListBoxes_Item x = NIL;
	if (*dup == NIL) {
		__NEW(x, DialogListBoxes_ItemDesc);
		*dup = (Dialogs_Object)x;
	} else {
		x = __GUARDP(*dup, DialogListBoxes_ItemDesc, 1);
	}
	Dialogs_Object_Copy((void*)b, &*dup);
	x->menu = TextFrames_Text((CHAR*)"", (LONGINT)1);
	x->selline = b->selline;
	x->startcmd = b->startcmd;
}

void DialogListBoxes_Insert (void)
{
	INTEGER x = 0, y = 0, x1 = 0, y1 = 0, w = 0, h = 0;
	DialogListBoxes_Item l = NIL;
	Dialogs_Panel p = NIL;
	CHAR name[64];
	__NEW(l, DialogListBoxes_ItemDesc);
	In_Open();
	In_Name((void*)name, 64);
	DialogFrames_GetCaretPosition(&p, &x, &y);
	if (p != NIL) {
		__Dialogs_Object_Init((void*)l);
		In_Open();
		In_Name((void*)name, 64);
		if (!In_Done) {
			__COPY("", name, 64);
			In_Open();
		}
		__Dialogs_Object_SetName((void*)l, name, 64);
		In_Int(&x1);
		In_Int(&y1);
		In_Int(&w);
		In_Int(&h);
		if (!In_Done) {
			x1 = x;
			y1 = y;
			w = 50;
			h = 70;
		} else {
			if (w < 0) {
				w = 50;
			}
			if (h < 0) {
				h = 70;
			}
		}
		__Dialogs_Object_SetDim((void*)l, x1, y1, w, h, 0);
		__Dialogs_Panel_Insert(p, (void*)l, 0);
	} else {
		Dialogs_res = 5;
	}
	if (Dialogs_res != 0) {
		Dialogs_Error((CHAR*)"DialogListBoxes", (LONGINT)16);
	}
}

__TDESC(DialogListBoxes_ItemDesc, 27, 3) = {__TDFLDS("ItemDesc", 128), {0, 104, 112, -16}};

export void *DialogListBoxes__init(void)
{
	__DEFMOD;
	__IMPORT(DialogFrames);
	__IMPORT(DialogTexts);
	__IMPORT(Dialogs);
	__IMPORT(Display);
	__IMPORT(Display1);
	__IMPORT(Files);
	__IMPORT(GraphicUtils);
	__IMPORT(In);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(DialogListBoxes, 0);
	__REGCMD("Insert", DialogListBoxes_Insert);
	__INITYP(DialogListBoxes_ItemDesc, Dialogs_ObjectDesc, 1);
	__INITBP(DialogListBoxes_ItemDesc, DialogListBoxes_Item_Copy, 1);
	__INITBP(DialogListBoxes_ItemDesc, DialogListBoxes_Item_Draw, 2);
	__INITBP(DialogListBoxes_ItemDesc, DialogListBoxes_Item_Handle, 6);
	__INITBP(DialogListBoxes_ItemDesc, DialogListBoxes_Item_Init, 8);
	__INITBP(DialogListBoxes_ItemDesc, DialogListBoxes_Item_Print, 14);
	__INITBP(DialogListBoxes_ItemDesc, DialogListBoxes_Item_SetMenu, 24);
	__INITBP(DialogListBoxes_ItemDesc, DialogListBoxes_Item_Track, 25);
/* BEGIN */
	__ENDMOD;
}
