/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "DialogButtons.h"
#include "DialogFrames.h"
#include "DialogStaticTexts.h"
#include "DialogTexts.h"
#include "Dialogs.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"


export Dialogs_Panel DialogUtils_msgbox, DialogUtils_prompt;
static INTEGER DialogUtils_left, DialogUtils_right, DialogUtils_top, DialogUtils_bot;


static void DialogUtils_Align1 (Dialogs_Panel p, CHAR *msg, LONGINT msg__len, INTEGER *w);
static void DialogUtils_AlignMsgBox (Dialogs_Panel p, CHAR *msg, LONGINT msg__len, CHAR *cmd, LONGINT cmd__len);
static void DialogUtils_AlignPanel (Dialogs_Panel p, CHAR *msg, LONGINT msg__len, CHAR *cmd, LONGINT cmd__len);
static void DialogUtils_Init (void);
export void DialogUtils_MessageBox (INTEGER x, INTEGER y, CHAR *msg, LONGINT msg__len, CHAR *cmd, LONGINT cmd__len);
static INTEGER DialogUtils_Min (INTEGER x, INTEGER y);
export void DialogUtils_Open (Dialogs_Panel p, INTEGER x, INTEGER y);
export void DialogUtils_Prompt (INTEGER x, INTEGER y, CHAR *msg, LONGINT msg__len, CHAR *cmd, LONGINT cmd__len);
static void DialogUtils_box (Dialogs_Object obj, BOOLEAN *done);


static INTEGER DialogUtils_Min (INTEGER x, INTEGER y)
{
	if (x < y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static void DialogUtils_Init (void)
{
	DialogStaticTexts_Item s = NIL;
	DialogButtons_Item b = NIL;
	DialogTexts_Item t = NIL;
	__NEW(DialogUtils_prompt, Dialogs_PanelDesc);
	__NEW(s, DialogStaticTexts_ItemDesc);
	__Dialogs_Object_Init((void*)s);
	__Dialogs_Object_SetDim((void*)s, 18, -36, 200, 20, 0);
	__Dialogs_Object_SetName((void*)s, (CHAR*)"s", (LONGINT)2);
	__DialogStaticTexts_Item_SetFont(s, Fonts_This((CHAR*)"Syntax12b.Scn.Fnt", (LONGINT)18));
	__Dialogs_Panel_Insert(DialogUtils_prompt, (void*)s, 0);
	__NEW(t, DialogTexts_ItemDesc);
	__Dialogs_Object_Init((void*)t);
	__Dialogs_Object_SetDim((void*)t, 25, -70, 100, 25, 0);
	__Dialogs_Object_SetName((void*)t, (CHAR*)"t", (LONGINT)2);
	__Dialogs_Panel_Insert(DialogUtils_prompt, (void*)t, 0);
	__NEW(b, DialogButtons_ItemDesc);
	__Dialogs_Object_Init((void*)b);
	__Dialogs_Object_SetDim((void*)b, 165, -70, 40, 25, 0);
	__DialogButtons_Item_SetFont(b, Fonts_This((CHAR*)"Syntax12b.Scn.Fnt", (LONGINT)18));
	__Dialogs_Object_SetName((void*)b, (CHAR*)"OK", (LONGINT)3);
	__Dialogs_Panel_Insert(DialogUtils_prompt, (void*)b, 0);
	__NEW(DialogUtils_msgbox, Dialogs_PanelDesc);
	__NEW(s, DialogStaticTexts_ItemDesc);
	__Dialogs_Object_Init((void*)s);
	__Dialogs_Object_SetDim((void*)s, 18, -36, 200, 20, 0);
	__Dialogs_Object_SetName((void*)s, (CHAR*)"s", (LONGINT)2);
	__DialogStaticTexts_Item_SetFont(s, Fonts_This((CHAR*)"Syntax12b.Scn.Fnt", (LONGINT)18));
	__Dialogs_Panel_Insert(DialogUtils_msgbox, (void*)s, 0);
	__NEW(b, DialogButtons_ItemDesc);
	__Dialogs_Object_Init((void*)b);
	__Dialogs_Object_SetDim((void*)b, 18, -70, 40, 25, 0);
	__DialogButtons_Item_SetFont(b, Fonts_This((CHAR*)"Syntax12b.Scn.Fnt", (LONGINT)18));
	__Dialogs_Object_SetName((void*)b, (CHAR*)"OK", (LONGINT)3);
	__Dialogs_Panel_Insert(DialogUtils_msgbox, (void*)b, 0);
}

static void DialogUtils_box (Dialogs_Object obj, BOOLEAN *done)
{
	INTEGER x = 0, y = 0, w = 0, h = 0;
	__Dialogs_Object_GetDim(obj, &x, &y, &w, &h);
	if (x < DialogUtils_left) {
		DialogUtils_left = x;
	}
	if (y < DialogUtils_bot) {
		DialogUtils_bot = y;
	}
	if (x + w > DialogUtils_right) {
		DialogUtils_right = x + w;
	}
	if (y + h > DialogUtils_top) {
		DialogUtils_top = y + h;
	}
}

void DialogUtils_Open (Dialogs_Panel p, INTEGER x, INTEGER y)
{
	DialogFrames_Frame df = NIL;
	Viewers_Viewer v = NIL, vmax = NIL;
	INTEGER h = 0, res = 0;
	TextFrames_Frame m = NIL;
	Texts_Text t = NIL;
	Texts_Buffer buf = NIL;
	__NEW(df, DialogFrames_FrameDesc);
	__DialogFrames_Frame_Open(df, DialogFrames_Handle, p);
	v = Viewers_This(x, 0);
	vmax = NIL;
	h = 0;
	while (v->state > 1) {
		if (v->H > h) {
			vmax = v;
			h = v->H;
		}
		v = Viewers_Next(v);
	}
	if (vmax != NIL) {
		DialogUtils_left = 32767;
		DialogUtils_right = -32768;
		DialogUtils_bot = 32767;
		DialogUtils_top = -32768;
		__Dialogs_Panel_Enumerate(p, DialogUtils_box);
		y = DialogUtils_Min(((vmax->Y + __ABS(DialogUtils_bot)) + 10) + TextFrames_menuH, ((vmax->Y + vmax->H) - TextFrames_menuH) - 2);
	}
	m = TextFrames_NewMenu((CHAR*)"Msgbox.Dlg", (LONGINT)11, (CHAR*)"^Dialog.Menu.Text", (LONGINT)18);
	v = (Viewers_Viewer)MenuViewers_New((void*)m, (void*)df, TextFrames_menuH, x, y);
	if (p->cmd[0] != 0x00) {
		Dialogs_cmdPanel = p;
		Oberon_Call(p->cmd, 64, Oberon_Par, 0, &res);
	}
}

static void DialogUtils_Align1 (Dialogs_Panel p, CHAR *msg, LONGINT msg__len, INTEGER *w)
{
	Dialogs_Object o = NIL;
	DialogStaticTexts_Item s = NIL;
	INTEGER cx = 0, cy = 0, cw = 0, ch = 0, i = 0, dx = 0;
	LONGINT pat = 0;
	__DUP(msg, msg__len, CHAR);
	o = __Dialogs_Panel_NamedObject(p, (CHAR*)"s", (LONGINT)2);
	s = __GUARDP(o, DialogStaticTexts_ItemDesc, 1);
	__DialogStaticTexts_Item_SetString(s, msg, msg__len);
	i = 0;
	*w = 0;
	while (s->s[__X(i, 64)] != 0x00) {
		Display_GetChar(s->fnt->raster, s->s[__X(i, 64)], &dx, &cx, &cy, &cw, &ch, &pat);
		*w += dx;
		i += 1;
	}
	*w += dx;
	__Dialogs_Object_GetDim((void*)s, &cx, &cy, &cw, &ch);
	__Dialogs_Object_SetDim((void*)s, cx, cy, *w, ch, 0);
	__DEL(msg);
}

static void DialogUtils_AlignMsgBox (Dialogs_Panel p, CHAR *msg, LONGINT msg__len, CHAR *cmd, LONGINT cmd__len)
{
	Dialogs_Object o = NIL;
	DialogButtons_Item b = NIL;
	INTEGER w = 0, cx = 0, cy = 0, cw = 0, ch = 0;
	__DUP(msg, msg__len, CHAR);
	__DUP(cmd, cmd__len, CHAR);
	DialogUtils_Align1(p, msg, msg__len, &w);
	o = __Dialogs_Panel_NamedObject(p, (CHAR*)"OK", (LONGINT)3);
	b = __GUARDP(o, DialogButtons_ItemDesc, 1);
	__Dialogs_Object_SetCmd((void*)b, cmd, cmd__len);
	__Dialogs_Object_GetDim((void*)b, &cx, &cy, &cw, &ch);
	cx = cx + __ASHR(__ABS(w - cw), 1);
	__Dialogs_Object_SetDim((void*)b, cx, cy, cw, ch, 0);
	__DEL(msg);
	__DEL(cmd);
}

static void DialogUtils_AlignPanel (Dialogs_Panel p, CHAR *msg, LONGINT msg__len, CHAR *cmd, LONGINT cmd__len)
{
	Dialogs_Object o = NIL;
	DialogButtons_Item b = NIL;
	INTEGER w = 0;
	__DUP(msg, msg__len, CHAR);
	__DUP(cmd, cmd__len, CHAR);
	DialogUtils_Align1(p, msg, msg__len, &w);
	o = __Dialogs_Panel_NamedObject(p, (CHAR*)"OK", (LONGINT)3);
	b = __GUARDP(o, DialogButtons_ItemDesc, 1);
	__Dialogs_Object_SetCmd((void*)b, cmd, cmd__len);
	__DEL(msg);
	__DEL(cmd);
}

void DialogUtils_MessageBox (INTEGER x, INTEGER y, CHAR *msg, LONGINT msg__len, CHAR *cmd, LONGINT cmd__len)
{
	Dialogs_Panel p = NIL;
	__DUP(msg, msg__len, CHAR);
	__DUP(cmd, cmd__len, CHAR);
	p = __Dialogs_Panel_Copy(DialogUtils_msgbox);
	DialogUtils_AlignMsgBox(p, msg, msg__len, cmd, cmd__len);
	DialogUtils_Open(p, x, y);
	__DEL(msg);
	__DEL(cmd);
}

void DialogUtils_Prompt (INTEGER x, INTEGER y, CHAR *msg, LONGINT msg__len, CHAR *cmd, LONGINT cmd__len)
{
	Dialogs_Panel p = NIL;
	__DUP(msg, msg__len, CHAR);
	__DUP(cmd, cmd__len, CHAR);
	p = __Dialogs_Panel_Copy(DialogUtils_prompt);
	DialogUtils_AlignPanel(p, msg, msg__len, cmd, cmd__len);
	DialogUtils_Open(p, x, y);
	__DEL(msg);
	__DEL(cmd);
}

static void EnumPtrs(void (*P)(void*))
{
	P(DialogUtils_msgbox);
	P(DialogUtils_prompt);
}


export void *DialogUtils__init(void)
{
	__DEFMOD;
	__IMPORT(DialogButtons);
	__IMPORT(DialogFrames);
	__IMPORT(DialogStaticTexts);
	__IMPORT(DialogTexts);
	__IMPORT(Dialogs);
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(DialogUtils, EnumPtrs);
/* BEGIN */
	DialogUtils_Init();
	__ENDMOD;
}
