/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Modules.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Types.h"
#include "Viewers.h"

typedef
	struct Dialogs_ObjectDesc *Dialogs_Object;

typedef
	struct Dialogs_PanelDesc *Dialogs_Panel;

typedef
	struct Dialogs_NotifyMsg { /* Display_FrameMsg */
		INTEGER id;
		Dialogs_Object obj;
		Dialogs_Panel p;
	} Dialogs_NotifyMsg;

typedef
	struct Dialogs_ObjectDesc {
		Dialogs_Object next;
		LONGINT x, y, w, h;
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		BOOLEAN visible;
	} Dialogs_ObjectDesc;

export void Dialogs_Object_CallCmd (Dialogs_Object o, Display_Frame f, Viewers_Viewer v, Texts_Text t);
export void Dialogs_Object_Copy (Dialogs_Object o, Dialogs_Object *dup);
export void Dialogs_Object_Draw (Dialogs_Object o, INTEGER x, INTEGER y, Display_Frame f);
export void Dialogs_Object_Edit (Dialogs_Object o);
export void Dialogs_Object_GetDim (Dialogs_Object o, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h);
export void Dialogs_Object_GetPDim (Dialogs_Object o, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h);
export void Dialogs_Object_Handle (Dialogs_Object o, Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
export void Dialogs_Object_Hide (Dialogs_Object o);
export void Dialogs_Object_Init (Dialogs_Object o);
static BOOLEAN Dialogs_Object_IsIn (Dialogs_Object o, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static BOOLEAN Dialogs_Object_IsOverlapped (Dialogs_Object o, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static BOOLEAN Dialogs_Object_IsOverlapping (Dialogs_Object o, Dialogs_Panel p, LONGINT x, LONGINT y, LONGINT w, LONGINT h, BOOLEAN sel);
export void Dialogs_Object_Load (Dialogs_Object o, Files_Rider *r, LONGINT *r__typ);
export Dialogs_Object Dialogs_Object_OverlappingObject (Dialogs_Object o);
export void Dialogs_Object_Print (Dialogs_Object o, INTEGER x, INTEGER y);
export void Dialogs_Object_Restore (Dialogs_Object o);
export void Dialogs_Object_Select (Dialogs_Object o);
export void Dialogs_Object_SetCmd (Dialogs_Object o, CHAR *cmd, LONGINT cmd__len);
export void Dialogs_Object_SetDim (Dialogs_Object o, INTEGER x, INTEGER y, INTEGER w, INTEGER h, BOOLEAN cond);
export void Dialogs_Object_SetName (Dialogs_Object o, CHAR *name, LONGINT name__len);
export void Dialogs_Object_SetPar (Dialogs_Object o, CHAR *par, LONGINT par__len);
export void Dialogs_Object_Store (Dialogs_Object o, Files_Rider *r, LONGINT *r__typ);
export void Dialogs_Object_UnSelect (Dialogs_Object o);
export void Dialogs_Object_Update (Dialogs_Object o, Dialogs_Panel p);
#define __Dialogs_Object_CallCmd(o, f, v, t) __SEND(__TYPEOF(o), 0, void(*)(Dialogs_Object, Display_Frame, Viewers_Viewer, Texts_Text), (o, f, v, t))
#define __Dialogs_Object_Copy(o, dup) __SEND(__TYPEOF(o), 1, void(*)(Dialogs_Object, Dialogs_Object*), (o, dup))
#define __Dialogs_Object_Draw(o, x, y, f) __SEND(__TYPEOF(o), 2, void(*)(Dialogs_Object, INTEGER, INTEGER, Display_Frame), (o, x, y, f))
#define __Dialogs_Object_Edit(o) __SEND(__TYPEOF(o), 3, void(*)(Dialogs_Object), (o))
#define __Dialogs_Object_GetDim(o, x, y, w, h) __SEND(__TYPEOF(o), 4, void(*)(Dialogs_Object, INTEGER*, INTEGER*, INTEGER*, INTEGER*), (o, x, y, w, h))
#define __Dialogs_Object_GetPDim(o, x, y, w, h) __SEND(__TYPEOF(o), 5, void(*)(Dialogs_Object, INTEGER*, INTEGER*, INTEGER*, INTEGER*), (o, x, y, w, h))
#define __Dialogs_Object_Handle(o, f, msg, msg__typ) __SEND(__TYPEOF(o), 6, void(*)(Dialogs_Object, Display_Frame, Display_FrameMsg*, LONGINT *), (o, f, msg, msg__typ))
#define __Dialogs_Object_Hide(o) __SEND(__TYPEOF(o), 7, void(*)(Dialogs_Object), (o))
#define __Dialogs_Object_Init(o) __SEND(__TYPEOF(o), 8, void(*)(Dialogs_Object), (o))
#define __Dialogs_Object_IsIn(o, x, y, w, h) __SEND(__TYPEOF(o), 9, BOOLEAN(*)(Dialogs_Object, INTEGER, INTEGER, INTEGER, INTEGER), (o, x, y, w, h))
#define __Dialogs_Object_IsOverlapped(o, x, y, w, h) __SEND(__TYPEOF(o), 10, BOOLEAN(*)(Dialogs_Object, INTEGER, INTEGER, INTEGER, INTEGER), (o, x, y, w, h))
#define __Dialogs_Object_IsOverlapping(o, p, x, y, w, h, sel) __SEND(__TYPEOF(o), 11, BOOLEAN(*)(Dialogs_Object, Dialogs_Panel, LONGINT, LONGINT, LONGINT, LONGINT, BOOLEAN), (o, p, x, y, w, h, sel))
#define __Dialogs_Object_Load(o, r, r__typ) __SEND(__TYPEOF(o), 12, void(*)(Dialogs_Object, Files_Rider*, LONGINT *), (o, r, r__typ))
#define __Dialogs_Object_OverlappingObject(o) __SEND(__TYPEOF(o), 13, Dialogs_Object(*)(Dialogs_Object), (o))
#define __Dialogs_Object_Print(o, x, y) __SEND(__TYPEOF(o), 14, void(*)(Dialogs_Object, INTEGER, INTEGER), (o, x, y))
#define __Dialogs_Object_Restore(o) __SEND(__TYPEOF(o), 15, void(*)(Dialogs_Object), (o))
#define __Dialogs_Object_Select(o) __SEND(__TYPEOF(o), 16, void(*)(Dialogs_Object), (o))
#define __Dialogs_Object_SetCmd(o, cmd, cmd__len) __SEND(__TYPEOF(o), 17, void(*)(Dialogs_Object, CHAR*, LONGINT ), (o, cmd, cmd__len))
#define __Dialogs_Object_SetDim(o, x, y, w, h, cond) __SEND(__TYPEOF(o), 18, void(*)(Dialogs_Object, INTEGER, INTEGER, INTEGER, INTEGER, BOOLEAN), (o, x, y, w, h, cond))
#define __Dialogs_Object_SetName(o, name, name__len) __SEND(__TYPEOF(o), 19, void(*)(Dialogs_Object, CHAR*, LONGINT ), (o, name, name__len))
#define __Dialogs_Object_SetPar(o, par, par__len) __SEND(__TYPEOF(o), 20, void(*)(Dialogs_Object, CHAR*, LONGINT ), (o, par, par__len))
#define __Dialogs_Object_Store(o, r, r__typ) __SEND(__TYPEOF(o), 21, void(*)(Dialogs_Object, Files_Rider*, LONGINT *), (o, r, r__typ))
#define __Dialogs_Object_UnSelect(o) __SEND(__TYPEOF(o), 22, void(*)(Dialogs_Object), (o))
#define __Dialogs_Object_Update(o, p) __SEND(__TYPEOF(o), 23, void(*)(Dialogs_Object, Dialogs_Panel), (o, p))

typedef
	struct Dialogs_PanelDesc {
		CHAR cmd[64];
		Dialogs_Object contents;
	} Dialogs_PanelDesc;

export void Dialogs_Panel_AlignSelected (Dialogs_Panel p, CHAR dir);
static BOOLEAN Dialogs_Panel_AlignTest (Dialogs_Panel p, CHAR dir, LONGINT x);
export void Dialogs_Panel_Broadcast (Dialogs_Panel p, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
static void Dialogs_Panel_ChangeDistance (Dialogs_Panel p, CHAR dir);
export BOOLEAN Dialogs_Panel_Contains (Dialogs_Panel p, Dialogs_Object o);
export Dialogs_Panel Dialogs_Panel_Copy (Dialogs_Panel p);
export void Dialogs_Panel_Draw (Dialogs_Panel p, INTEGER x, INTEGER y, Display_Frame f);
export void Dialogs_Panel_Enumerate (Dialogs_Panel p, void (*handle)(Dialogs_Object, BOOLEAN*));
export void Dialogs_Panel_GetObjects (Dialogs_Panel p, INTEGER x, INTEGER y, INTEGER w, INTEGER h, Dialogs_Object *obArray, LONGINT obArray__len, INTEGER *nofelems);
export void Dialogs_Panel_Insert (Dialogs_Panel p, Dialogs_Object o, BOOLEAN ov);
export void Dialogs_Panel_Load (Dialogs_Panel p, Files_Rider *r, LONGINT *r__typ);
export void Dialogs_Panel_MarkMenu (Dialogs_Panel p);
export void Dialogs_Panel_MoveSelected (Dialogs_Panel p, INTEGER dx, INTEGER dy);
export Dialogs_Object Dialogs_Panel_NamedObject (Dialogs_Panel p, CHAR *name, LONGINT name__len);
export INTEGER Dialogs_Panel_NofSelObjects (Dialogs_Panel p);
export void Dialogs_Panel_Print (Dialogs_Panel p, INTEGER x, INTEGER y);
export void Dialogs_Panel_RegulateDistance (Dialogs_Panel p, CHAR dir);
static BOOLEAN Dialogs_Panel_RegulateDistanceTest (Dialogs_Panel p, CHAR dir);
export void Dialogs_Panel_Remove (Dialogs_Panel p, Dialogs_Object o);
export void Dialogs_Panel_RemoveObjects (Dialogs_Panel p, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
export void Dialogs_Panel_RemoveSelections (Dialogs_Panel p);
export void Dialogs_Panel_Restore (Dialogs_Panel p);
static void Dialogs_Panel_RestoreOverlapped (Dialogs_Panel p, INTEGER x, INTEGER y, INTEGER w, INTEGER h, Dialogs_Object o);
export void Dialogs_Panel_Select (Dialogs_Panel p, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
export void Dialogs_Panel_SetCmd (Dialogs_Panel p, CHAR *cmd, LONGINT cmd__len);
export void Dialogs_Panel_Store (Dialogs_Panel p, Files_Rider *r, LONGINT *r__typ);
export Dialogs_Object Dialogs_Panel_ThisObject (Dialogs_Panel p, INTEGER x, INTEGER y);
#define __Dialogs_Panel_AlignSelected(p, dir) __SEND(__TYPEOF(p), 0, void(*)(Dialogs_Panel, CHAR), (p, dir))
#define __Dialogs_Panel_AlignTest(p, dir, x) __SEND(__TYPEOF(p), 1, BOOLEAN(*)(Dialogs_Panel, CHAR, LONGINT), (p, dir, x))
#define __Dialogs_Panel_Broadcast(p, f, m, m__typ) __SEND(__TYPEOF(p), 2, void(*)(Dialogs_Panel, Display_Frame, Display_FrameMsg*, LONGINT *), (p, f, m, m__typ))
#define __Dialogs_Panel_ChangeDistance(p, dir) __SEND(__TYPEOF(p), 3, void(*)(Dialogs_Panel, CHAR), (p, dir))
#define __Dialogs_Panel_Contains(p, o) __SEND(__TYPEOF(p), 4, BOOLEAN(*)(Dialogs_Panel, Dialogs_Object), (p, o))
#define __Dialogs_Panel_Copy(p) __SEND(__TYPEOF(p), 5, Dialogs_Panel(*)(Dialogs_Panel), (p))
#define __Dialogs_Panel_Draw(p, x, y, f) __SEND(__TYPEOF(p), 6, void(*)(Dialogs_Panel, INTEGER, INTEGER, Display_Frame), (p, x, y, f))
#define __Dialogs_Panel_Enumerate(p, handle) __SEND(__TYPEOF(p), 7, void(*)(Dialogs_Panel, void(*)(Dialogs_Object, BOOLEAN*)), (p, handle))
#define __Dialogs_Panel_GetObjects(p, x, y, w, h, obArray, obArray__len, nofelems) __SEND(__TYPEOF(p), 8, void(*)(Dialogs_Panel, INTEGER, INTEGER, INTEGER, INTEGER, Dialogs_Object*, LONGINT , INTEGER*), (p, x, y, w, h, obArray, obArray__len, nofelems))
#define __Dialogs_Panel_Insert(p, o, ov) __SEND(__TYPEOF(p), 9, void(*)(Dialogs_Panel, Dialogs_Object, BOOLEAN), (p, o, ov))
#define __Dialogs_Panel_Load(p, r, r__typ) __SEND(__TYPEOF(p), 10, void(*)(Dialogs_Panel, Files_Rider*, LONGINT *), (p, r, r__typ))
#define __Dialogs_Panel_MarkMenu(p) __SEND(__TYPEOF(p), 11, void(*)(Dialogs_Panel), (p))
#define __Dialogs_Panel_MoveSelected(p, dx, dy) __SEND(__TYPEOF(p), 12, void(*)(Dialogs_Panel, INTEGER, INTEGER), (p, dx, dy))
#define __Dialogs_Panel_NamedObject(p, name, name__len) __SEND(__TYPEOF(p), 13, Dialogs_Object(*)(Dialogs_Panel, CHAR*, LONGINT ), (p, name, name__len))
#define __Dialogs_Panel_NofSelObjects(p) __SEND(__TYPEOF(p), 14, INTEGER(*)(Dialogs_Panel), (p))
#define __Dialogs_Panel_Print(p, x, y) __SEND(__TYPEOF(p), 15, void(*)(Dialogs_Panel, INTEGER, INTEGER), (p, x, y))
#define __Dialogs_Panel_RegulateDistance(p, dir) __SEND(__TYPEOF(p), 16, void(*)(Dialogs_Panel, CHAR), (p, dir))
#define __Dialogs_Panel_RegulateDistanceTest(p, dir) __SEND(__TYPEOF(p), 17, BOOLEAN(*)(Dialogs_Panel, CHAR), (p, dir))
#define __Dialogs_Panel_Remove(p, o) __SEND(__TYPEOF(p), 18, void(*)(Dialogs_Panel, Dialogs_Object), (p, o))
#define __Dialogs_Panel_RemoveObjects(p, x, y, w, h) __SEND(__TYPEOF(p), 19, void(*)(Dialogs_Panel, INTEGER, INTEGER, INTEGER, INTEGER), (p, x, y, w, h))
#define __Dialogs_Panel_RemoveSelections(p) __SEND(__TYPEOF(p), 20, void(*)(Dialogs_Panel), (p))
#define __Dialogs_Panel_Restore(p) __SEND(__TYPEOF(p), 21, void(*)(Dialogs_Panel), (p))
#define __Dialogs_Panel_RestoreOverlapped(p, x, y, w, h, o) __SEND(__TYPEOF(p), 22, void(*)(Dialogs_Panel, INTEGER, INTEGER, INTEGER, INTEGER, Dialogs_Object), (p, x, y, w, h, o))
#define __Dialogs_Panel_Select(p, x, y, w, h) __SEND(__TYPEOF(p), 23, void(*)(Dialogs_Panel, INTEGER, INTEGER, INTEGER, INTEGER), (p, x, y, w, h))
#define __Dialogs_Panel_SetCmd(p, cmd, cmd__len) __SEND(__TYPEOF(p), 24, void(*)(Dialogs_Panel, CHAR*, LONGINT ), (p, cmd, cmd__len))
#define __Dialogs_Panel_Store(p, r, r__typ) __SEND(__TYPEOF(p), 25, void(*)(Dialogs_Panel, Files_Rider*, LONGINT *), (p, r, r__typ))
#define __Dialogs_Panel_ThisObject(p, x, y) __SEND(__TYPEOF(p), 26, Dialogs_Object(*)(Dialogs_Panel, INTEGER, INTEGER), (p, x, y))


export LONGINT Dialogs_dUnit, Dialogs_pUnit;
export INTEGER Dialogs_res;
export void (*Dialogs_Edit)(Dialogs_Object);
export void (*Dialogs_Update)(Dialogs_Object, Dialogs_Panel);
export Dialogs_Panel Dialogs_cmdPanel, Dialogs_editPanel;
export Dialogs_Object Dialogs_editObject, Dialogs_lastin;
static Texts_Writer Dialogs_w0;

export LONGINT *Dialogs_ObjectDesc__typ;
export LONGINT *Dialogs_PanelDesc__typ;
export LONGINT *Dialogs_NotifyMsg__typ;

export void Dialogs_Error (CHAR *name, LONGINT name__len);


void Dialogs_Object_Draw (Dialogs_Object o, INTEGER x, INTEGER y, Display_Frame f)
{
}

void Dialogs_Object_Copy (Dialogs_Object o, Dialogs_Object *dup)
{
	if (*dup == NIL) {
		__NEW(*dup, Dialogs_ObjectDesc);
	}
	(*dup)->x = o->x;
	(*dup)->y = o->y;
	(*dup)->w = o->w;
	(*dup)->h = o->h;
	__MOVE(o->name, (*dup)->name, 16);
	(*dup)->next = NIL;
	__MOVE(o->cmd, (*dup)->cmd, 32);
	__MOVE(o->par, (*dup)->par, 32);
	(*dup)->selected = 0;
	(*dup)->overlapping = o->overlapping;
	(*dup)->panel = NIL;
}

void Dialogs_Object_Print (Dialogs_Object o, INTEGER x, INTEGER y)
{
}

void Dialogs_Object_Handle (Dialogs_Object o, Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
}

void Dialogs_Object_Edit (Dialogs_Object o)
{
	if (Dialogs_Edit != NIL) {
		(*Dialogs_Edit)(o);
	}
}

void Dialogs_Object_Update (Dialogs_Object o, Dialogs_Panel p)
{
	if (Dialogs_Update != NIL) {
		(*Dialogs_Update)(o, p);
	}
}

void Dialogs_Object_Init (Dialogs_Object o)
{
	o->selected = 0;
	o->panel = NIL;
	o->cmd[0] = 0x00;
	o->par[0] = 0x00;
	o->visible = 1;
}

void Dialogs_Object_GetDim (Dialogs_Object o, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h)
{
	*x = (int)__DIV(o->x, Dialogs_dUnit);
	*y = (int)__DIV(o->y, Dialogs_dUnit);
	*w = (int)__DIV(o->w, Dialogs_dUnit);
	*h = (int)__DIV(o->h, Dialogs_dUnit);
}

void Dialogs_Object_GetPDim (Dialogs_Object o, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h)
{
	*x = (int)__DIV(o->x, Dialogs_pUnit);
	*y = (int)__DIV(o->y, Dialogs_pUnit);
	*w = (int)__DIV(o->w, Dialogs_pUnit);
	*h = (int)__DIV(o->h, Dialogs_pUnit);
}

void Dialogs_Object_Load (Dialogs_Object o, Files_Rider *r, LONGINT *r__typ)
{
	CHAR name1[64];
	CHAR cmd1[64], par1[64];
	__Dialogs_Object_Init(o);
	Files_ReadString(&*r, r__typ, (void*)name1, 64);
	__COPY(name1, o->name, 16);
	Files_ReadString(&*r, r__typ, (void*)cmd1, 64);
	__COPY(cmd1, o->cmd, 32);
	Files_ReadString(&*r, r__typ, (void*)par1, 64);
	__COPY(par1, o->par, 32);
	Files_ReadLInt(&*r, r__typ, &o->x);
	Files_ReadLInt(&*r, r__typ, &o->y);
	Files_ReadLInt(&*r, r__typ, &o->w);
	Files_ReadLInt(&*r, r__typ, &o->h);
	Files_ReadBool(&*r, r__typ, &o->overlapping);
}

void Dialogs_Object_Store (Dialogs_Object o, Files_Rider *r, LONGINT *r__typ)
{
	Files_WriteString(&*r, r__typ, o->name, 16);
	Files_WriteString(&*r, r__typ, o->cmd, 32);
	Files_WriteString(&*r, r__typ, o->par, 32);
	Files_WriteLInt(&*r, r__typ, o->x);
	Files_WriteLInt(&*r, r__typ, o->y);
	Files_WriteLInt(&*r, r__typ, o->w);
	Files_WriteLInt(&*r, r__typ, o->h);
	Files_WriteBool(&*r, r__typ, o->overlapping);
}

void Dialogs_Object_CallCmd (Dialogs_Object o, Display_Frame f, Viewers_Viewer v, Texts_Text t)
{
	INTEGER callres = 0;
	if (o->cmd[0] != 0x00) {
		Oberon_Par->frame = f;
		Oberon_Par->vwr = v;
		Oberon_Par->text = t;
		Oberon_Par->pos = 0;
		Dialogs_cmdPanel = o->panel;
		Oberon_Call(o->cmd, 32, Oberon_Par, 0, &callres);
		if (callres != 0) {
			__HALT(99);
		}
	}
}

void Dialogs_Object_SetCmd (Dialogs_Object o, CHAR *cmd, LONGINT cmd__len)
{
	__DUP(cmd, cmd__len, CHAR);
	if (__STRCMP(cmd, o->cmd) != 0) {
		__COPY(cmd, o->cmd, 32);
		if (o->panel != NIL) {
			__Dialogs_Panel_MarkMenu(o->panel);
		}
	}
	__DEL(cmd);
}

void Dialogs_Object_SetPar (Dialogs_Object o, CHAR *par, LONGINT par__len)
{
	__DUP(par, par__len, CHAR);
	if (__STRCMP(par, o->par) != 0) {
		__COPY(par, o->par, 32);
		if (o->panel != NIL) {
			__Dialogs_Panel_MarkMenu(o->panel);
		}
	}
	__DEL(par);
}

void Dialogs_Object_Restore (Dialogs_Object o)
{
	Dialogs_NotifyMsg msg = {0};
	msg.id = 0;
	msg.obj = o;
	Viewers_Broadcast((void*)&msg, Dialogs_NotifyMsg__typ);
	o->visible = 1;
}

void Dialogs_Object_SetName (Dialogs_Object o, CHAR *name, LONGINT name__len)
{
	__DUP(name, name__len, CHAR);
	if (((o->panel == NIL || name[0] == 0x00) || __Dialogs_Panel_NamedObject(o->panel, name, name__len) == NIL) || __Dialogs_Panel_NamedObject(o->panel, name, name__len) == o) {
		if (__STRCMP(o->name, name) != 0) {
			__COPY(name, o->name, 16);
			Dialogs_res = 0;
			if (o->panel != NIL) {
				__Dialogs_Panel_MarkMenu(o->panel);
				__Dialogs_Object_Restore(o);
			}
		}
	} else {
		Dialogs_res = 2;
	}
	__DEL(name);
}

void Dialogs_Object_Hide (Dialogs_Object o)
{
	Dialogs_NotifyMsg msg = {0};
	INTEGER ox = 0, oy = 0, ow = 0, oh = 0, nofelems = 0, i = 0;
	Dialogs_Object obArray[50];
	if (o->panel == NIL) {
		return;
	}
	msg.id = 1;
	msg.obj = o;
	Viewers_Broadcast((void*)&msg, Dialogs_NotifyMsg__typ);
	o->visible = 0;
	if (o->overlapping) {
		__Dialogs_Object_GetDim(o, &ox, &oy, &ow, &oh);
		__Dialogs_Panel_RestoreOverlapped(o->panel, ox, oy, ow, oh, o);
	}
}

void Dialogs_Object_Select (Dialogs_Object o)
{
	INTEGER x = 0, y = 0, w = 0, h = 0;
	if (!o->selected) {
		o->selected = 1;
		__Dialogs_Object_Hide(o);
		__Dialogs_Object_Restore(o);
	}
}

void Dialogs_Object_UnSelect (Dialogs_Object o)
{
	INTEGER x = 0, y = 0, w = 0, h = 0;
	if (o->selected) {
		o->selected = 0;
		__Dialogs_Object_Hide(o);
		__Dialogs_Object_Restore(o);
	}
}

static BOOLEAN Dialogs_Object_IsIn (Dialogs_Object o, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	LONGINT x0 = 0, y0 = 0, w0 = 0, h0 = 0;
	x0 = (LONGINT)x * Dialogs_dUnit;
	y0 = (LONGINT)y * Dialogs_dUnit;
	w0 = (LONGINT)w * Dialogs_dUnit;
	h0 = (LONGINT)h * Dialogs_dUnit;
	if (!(y0 + h0 < o->y)) {
		if ((y0 + h0 >= o->y && y0 + h0 <= o->y + o->h) && !(x0 < o->x && x0 + w0 < o->x || x0 > o->x + o->w)) {
			return 1;
		}
		if ((y0 + h0 > o->y + o->h && y0 <= o->y + o->h) && !(x0 < o->x && x0 + w0 < o->x || x0 > o->x + o->w)) {
			return 1;
		}
	}
	return 0;
}

static BOOLEAN Dialogs_Object_IsOverlapped (Dialogs_Object o, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	LONGINT x0 = 0, y0 = 0, w0 = 0, h0 = 0;
	x0 = (LONGINT)x * Dialogs_dUnit;
	y0 = (LONGINT)y * Dialogs_dUnit;
	w0 = (LONGINT)w * Dialogs_dUnit;
	h0 = (LONGINT)h * Dialogs_dUnit;
	return ((o->x >= x0 && o->y >= y0) && o->x + o->w <= x0 + w0) && o->y + o->h <= y0 + h0;
}

static BOOLEAN Dialogs_Object_IsOverlapping (Dialogs_Object o, Dialogs_Panel p, LONGINT x, LONGINT y, LONGINT w, LONGINT h, BOOLEAN sel)
{
	Dialogs_Object o1 = NIL;
	BOOLEAN b = 0;
	LONGINT hx = 0, hy = 0, hw = 0, hh = 0;
	if (o->overlapping) {
		return 0;
	}
	o1 = p->contents;
	while (o1 != NIL) {
		if ((o1 != o && !o1->overlapping) && !(o1->selected && sel)) {
			if (((o1->y < y + h && o1->y + o1->h > y) && o1->x < x + w) && o1->x + o1->w > x) {
				return 1;
			}
		}
		o1 = o1->next;
	}
	return 0;
}

void Dialogs_Object_SetDim (Dialogs_Object o, INTEGER x, INTEGER y, INTEGER w, INTEGER h, BOOLEAN cond)
{
	LONGINT ox = 0, oy = 0, ow = 0, oh = 0;
	INTEGER ax = 0, ay = 0, aw = 0, ah = 0;
	__Dialogs_Object_GetDim(o, &ax, &ay, &aw, &ah);
	ox = (LONGINT)x * Dialogs_dUnit;
	oy = (LONGINT)y * Dialogs_dUnit;
	ow = (LONGINT)w * Dialogs_dUnit;
	oh = (LONGINT)h * Dialogs_dUnit;
	if (ow < Dialogs_dUnit) {
		ow = Dialogs_dUnit;
	}
	if (oh < Dialogs_dUnit) {
		oh = Dialogs_dUnit;
	}
	if (o->panel == NIL) {
		o->x = ox;
		o->y = oy;
		o->w = ow;
		o->h = oh;
		Dialogs_res = 0;
	} else if (!__Dialogs_Object_IsOverlapping(o, o->panel, ox, oy, ow, oh, cond)) {
		if (!o->selected) {
			__Dialogs_Panel_RemoveSelections(o->panel);
		}
		__Dialogs_Object_Hide(o);
		o->x = ox;
		o->y = oy;
		o->w = ow;
		o->h = oh;
		__Dialogs_Object_Restore(o);
		__Dialogs_Panel_MarkMenu(o->panel);
		__Dialogs_Panel_RestoreOverlapped(o->panel, ax, ay, aw, ah, o);
		Dialogs_res = 0;
	} else {
		Dialogs_res = 6;
	}
}

Dialogs_Object Dialogs_Object_OverlappingObject (Dialogs_Object o)
{
	Dialogs_Object o1 = NIL, ret = NIL;
	INTEGER x = 0, y = 0, w = 0, h = 0, w1 = 0, h1 = 0;
	if (o->panel == NIL) {
		return NIL;
	}
	o1 = o->panel->contents;
	ret = NIL;
	while (o1 != NIL) {
		if (o != o1 && o1->overlapping) {
			__Dialogs_Object_GetDim(o1, &x, &y, &w, &h);
			if (__Dialogs_Object_IsIn(o, x, y, w, h)) {
				if (ret == NIL) {
					ret = o1;
					w1 = w;
					h1 = h;
				} else {
					if (w1 * h1 > w * h) {
						ret = o1;
						w1 = w;
						h1 = h;
					}
				}
			}
		}
		o1 = o1->next;
	}
	return ret;
}

static struct RestoreOverlapped__55 {
	Dialogs_Object *o1;
	struct RestoreOverlapped__55 *lnk;
} *RestoreOverlapped__55_s;

static void Redraw__56 (void);

static void Redraw__56 (void)
{
	if ((*RestoreOverlapped__55_s->o1)->selected) {
		if ((*RestoreOverlapped__55_s->o1)->visible) {
			__Dialogs_Object_Hide(*RestoreOverlapped__55_s->o1);
		}
		__Dialogs_Object_Restore(*RestoreOverlapped__55_s->o1);
	} else {
		__Dialogs_Object_Restore(*RestoreOverlapped__55_s->o1);
	}
}

static void Dialogs_Panel_RestoreOverlapped (Dialogs_Panel p, INTEGER x, INTEGER y, INTEGER w, INTEGER h, Dialogs_Object o)
{
	Dialogs_Object o1 = NIL;
	struct RestoreOverlapped__55 _s;
	_s.o1 = &o1;
	_s.lnk = RestoreOverlapped__55_s;
	RestoreOverlapped__55_s = &_s;
	o1 = p->contents;
	while (o1 != NIL) {
		if (((o1 != o && o1->overlapping) && o1->visible) && __Dialogs_Object_IsIn(o1, x, y, w, h)) {
			Redraw__56();
		}
		o1 = o1->next;
	}
	if (o->overlapping) {
		o1 = p->contents;
		while (o1 != NIL) {
			if (((o1 != o && !o1->overlapping) && o1->visible) && __Dialogs_Object_IsIn(o1, x, y, w, h)) {
				Redraw__56();
			}
			o1 = o1->next;
		}
	}
	RestoreOverlapped__55_s = _s.lnk;
}

void Dialogs_Panel_SetCmd (Dialogs_Panel p, CHAR *cmd, LONGINT cmd__len)
{
	__DUP(cmd, cmd__len, CHAR);
	if (__STRCMP(cmd, p->cmd) != 0) {
		__COPY(cmd, p->cmd, 64);
		__Dialogs_Panel_MarkMenu(p);
	}
	__DEL(cmd);
}

Dialogs_Object Dialogs_Panel_NamedObject (Dialogs_Panel p, CHAR *name, LONGINT name__len)
{
	Dialogs_Object o = NIL;
	__DUP(name, name__len, CHAR);
	if (name[0] == 0x00) {
		__DEL(name);
		return NIL;
	}
	o = p->contents;
	while (o != NIL && __STRCMP(o->name, name) != 0) {
		o = o->next;
	}
	__DEL(name);
	return o;
}

void Dialogs_Panel_Select (Dialogs_Panel p, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	Dialogs_Object o = NIL;
	o = p->contents;
	while (o != NIL) {
		if (__Dialogs_Object_IsIn(o, x, y, w, h)) {
			__Dialogs_Object_Select(o);
		} else {
			__Dialogs_Object_UnSelect(o);
		}
		o = o->next;
	}
}

void Dialogs_Panel_GetObjects (Dialogs_Panel p, INTEGER x, INTEGER y, INTEGER w, INTEGER h, Dialogs_Object *obArray, LONGINT obArray__len, INTEGER *nofelems)
{
	Dialogs_Object o = NIL;
	*nofelems = 0;
	o = p->contents;
	while (o != NIL && (LONGINT)*nofelems < obArray__len) {
		if (__Dialogs_Object_IsIn(o, x, y, w, h)) {
			obArray[__X(*nofelems, obArray__len)] = o;
			*nofelems += 1;
		}
		o = o->next;
	}
}

void Dialogs_Panel_MarkMenu (Dialogs_Panel p)
{
	Dialogs_NotifyMsg msg = {0};
	msg.id = 2;
	msg.p = p;
	Viewers_Broadcast((void*)&msg, Dialogs_NotifyMsg__typ);
}

void Dialogs_Panel_Restore (Dialogs_Panel p)
{
	Dialogs_NotifyMsg msg = {0};
	msg.id = 3;
	msg.p = p;
	Viewers_Broadcast((void*)&msg, Dialogs_NotifyMsg__typ);
}

void Dialogs_Panel_Remove (Dialogs_Panel p, Dialogs_Object o)
{
	Dialogs_Object q = NIL, prev = NIL;
	q = p->contents;
	while (q != NIL && q != o) {
		prev = q;
		q = q->next;
	}
	if (q != NIL) {
		__Dialogs_Object_Hide(q);
		if (q == p->contents) {
			p->contents = q->next;
		} else {
			prev->next = q->next;
		}
		q->next = NIL;
		Dialogs_res = 0;
		__Dialogs_Panel_MarkMenu(p);
	} else {
		Dialogs_res = 3;
	}
}

void Dialogs_Panel_RemoveObjects (Dialogs_Panel p, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	Dialogs_Object o = NIL, next = NIL;
	o = p->contents;
	while (o != NIL) {
		next = o->next;
		if (__Dialogs_Object_IsIn(o, x, y, w, h)) {
			__Dialogs_Panel_Remove(p, o);
		}
		o = next;
	}
}

void Dialogs_Panel_Enumerate (Dialogs_Panel p, void (*handle)(Dialogs_Object, BOOLEAN*))
{
	Dialogs_Object obj = NIL;
	BOOLEAN done = 0;
	done = 0;
	obj = p->contents;
	while (obj != NIL && !done) {
		(*handle)(obj, &done);
		obj = obj->next;
	}
}

void Dialogs_Panel_RemoveSelections (Dialogs_Panel p)
{
	Dialogs_Object o = NIL;
	o = p->contents;
	while (o != NIL) {
		__Dialogs_Object_UnSelect(o);
		o = o->next;
	}
}

void Dialogs_Panel_Insert (Dialogs_Panel p, Dialogs_Object o, BOOLEAN ov)
{
	INTEGER i = 0, x0 = 0, j = 0;
	CHAR a[15], b[15];
	o->overlapping = ov;
	if (!__Dialogs_Object_IsOverlapping(o, p, o->x, o->y, o->w, o->h, 0)) {
		if (__Dialogs_Panel_NamedObject(p, o->name, 16) == NIL) {
			o->panel = p;
			o->next = p->contents;
			p->contents = o;
			__Dialogs_Object_Restore(o);
			__Dialogs_Panel_MarkMenu(o->panel);
			Dialogs_lastin = o;
		} else {
			Dialogs_res = 2;
		}
	} else {
		Dialogs_res = 6;
	}
}

Dialogs_Panel Dialogs_Panel_Copy (Dialogs_Panel p)
{
	Dialogs_Panel copy = NIL;
	Dialogs_Object o = NIL, o1 = NIL;
	__NEW(copy, Dialogs_PanelDesc);
	o = p->contents;
	__MOVE(p->cmd, copy->cmd, 64);
	while (o != NIL) {
		o1 = NIL;
		__Dialogs_Object_Copy(o, &o1);
		__Dialogs_Panel_Insert(copy, o1, o->overlapping);
		o = o->next;
	}
	return copy;
}

INTEGER Dialogs_Panel_NofSelObjects (Dialogs_Panel p)
{
	Dialogs_Object o = NIL;
	INTEGER count = 0;
	o = p->contents;
	count = 0;
	while (o != NIL) {
		if (o->selected) {
			count += 1;
		}
		o = o->next;
	}
	return count;
}

Dialogs_Object Dialogs_Panel_ThisObject (Dialogs_Panel p, INTEGER x, INTEGER y)
{
	Dialogs_Object o1 = NIL, o = NIL;
	LONGINT x0 = 0, y0 = 0;
	o = p->contents;
	o1 = NIL;
	x0 = (LONGINT)x * Dialogs_dUnit;
	y0 = (LONGINT)y * Dialogs_dUnit;
	while (o != NIL) {
		if (((x0 >= o->x && x0 < o->x + o->w) && y0 >= o->y) && y0 < o->y + o->h) {
			if (o1 == NIL || !o->overlapping) {
				o1 = o;
			}
		}
		o = o->next;
	}
	return o1;
}

void Dialogs_Panel_Draw (Dialogs_Panel p, INTEGER x, INTEGER y, Display_Frame f)
{
	Dialogs_Object o = NIL;
	INTEGER ox = 0, oy = 0, ow = 0, oh = 0;
	o = p->contents;
	while (o != NIL) {
		if (o->overlapping) {
			__Dialogs_Object_GetDim(o, &ox, &oy, &ow, &oh);
			__Dialogs_Object_Draw(o, x + ox, y + oy, f);
		}
		o = o->next;
	}
	o = p->contents;
	while (o != NIL) {
		if (!o->overlapping) {
			__Dialogs_Object_GetDim(o, &ox, &oy, &ow, &oh);
			__Dialogs_Object_Draw(o, x + ox, y + oy, f);
		}
		o = o->next;
	}
}

void Dialogs_Panel_Print (Dialogs_Panel p, INTEGER x, INTEGER y)
{
	Dialogs_Object o = NIL;
	INTEGER ox = 0, oy = 0, ow = 0, oh = 0;
	o = p->contents;
	while (o != NIL) {
		__Dialogs_Object_GetPDim(o, &ox, &oy, &ow, &oh);
		__Dialogs_Object_Print(o, x + ox, y + oy);
		o = o->next;
	}
}

void Dialogs_Panel_Load (Dialogs_Panel p, Files_Rider *r, LONGINT *r__typ)
{
	INTEGER cnt = 0, end1 = 0, end2 = 0, h = 0;
	Dialogs_Object o = NIL, prev = NIL;
	Modules_ModuleName module;
	CHAR name[32];
	Modules_ModuleName tab1[64];
	CHAR tab2[64][32];
	LONGINT pos = 0;
	p->contents = NIL;
	prev = NIL;
	Files_ReadInt(&*r, r__typ, &cnt);
	__COPY("", p->cmd, 64);
	end1 = 0;
	end2 = 0;
	while (cnt != 0) {
		cnt -= 1;
		pos = Files_Pos(&*r, r__typ);
		Files_ReadInt(&*r, r__typ, &h);
		if (h < end1) {
			__MOVE(tab1[__X(h, 64)], module, 20);
		} else {
			Files_Set(&*r, r__typ, Files_Base(&*r, r__typ), pos);
			Files_ReadString(&*r, r__typ, (void*)module, 20);
			__MOVE(module, tab1[__X(end1, 64)], 20);
			end1 += 1;
		}
		pos = Files_Pos(&*r, r__typ);
		Files_ReadInt(&*r, r__typ, &h);
		if (h < end2) {
			__COPY(tab2[__X(h, 64)], name, 32);
		} else {
			Files_Set(&*r, r__typ, Files_Base(&*r, r__typ), pos);
			Files_ReadString(&*r, r__typ, (void*)name, 32);
			__COPY(name, tab2[__X(end2, 64)], 32);
			end2 += 1;
		}
		Types_NewObj((void*)&o, Types_This(Modules_ThisMod(module, 20), name, 32));
		__ASSERT(o != NIL, 0);
		__Dialogs_Object_Load(o, &*r, r__typ);
		o->panel = p;
		if (prev != NIL) {
			prev->next = o;
		} else {
			p->contents = o;
		}
		prev = o;
	}
	Files_ReadString(&*r, r__typ, (void*)p->cmd, 64);
	__Dialogs_Panel_Restore(p);
}

void Dialogs_Panel_Store (Dialogs_Panel p, Files_Rider *r, LONGINT *r__typ)
{
	INTEGER cnt = 0, end1 = 0, end2 = 0, i = 0;
	Dialogs_Object o = NIL;
	Types_Type type = NIL;
	BOOLEAN cond = 0;
	CHAR tab1[64][32], tab2[64][32];
	INTEGER _for__62 = 0, _for__61 = 0;
	o = p->contents;
	cnt = 0;
	end1 = 0;
	end2 = 0;
	while (o != NIL) {
		cnt += 1;
		o = o->next;
	}
	Files_WriteInt(&*r, r__typ, cnt);
	o = p->contents;
	while (o != NIL) {
		type = Types_TypeOf((void*)o);
		cond = 0;
		_for__62 = end1 - 1;
		i = 0;
		while (i <= _for__62) {
			if (__STRCMP(tab1[__X(i, 64)], type->module->name) == 0) {
				Files_WriteInt(&*r, r__typ, i);
				cond = 1;
			}
			i += 1;
		}
		if (!cond) {
			Files_WriteString(&*r, r__typ, type->module->name, 20);
			__COPY(type->module->name, tab1[__X(end1, 64)], 32);
			end1 += 1;
		}
		cond = 0;
		_for__61 = end2 - 1;
		i = 0;
		while (i <= _for__61) {
			if (__STRCMP(tab2[__X(i, 64)], type->name) == 0) {
				Files_WriteInt(&*r, r__typ, i);
				cond = 1;
			}
			i += 1;
		}
		if (!cond) {
			Files_WriteString(&*r, r__typ, type->name, 24);
			__COPY(type->name, tab2[__X(end2, 64)], 32);
			end2 += 1;
		}
		__Dialogs_Object_Store(o, &*r, r__typ);
		o = o->next;
	}
	Files_WriteString(&*r, r__typ, p->cmd, 64);
}

BOOLEAN Dialogs_Panel_Contains (Dialogs_Panel p, Dialogs_Object o)
{
	Dialogs_Object o1 = NIL;
	o1 = p->contents;
	while (o1 != NIL) {
		if (o1 == o) {
			return 1;
		}
		o1 = o1->next;
	}
	return 0;
}

void Dialogs_Panel_MoveSelected (Dialogs_Panel p, INTEGER dx, INTEGER dy)
{
	Dialogs_Object o = NIL;
	BOOLEAN ov = 0;
	Dialogs_NotifyMsg msg = {0};
	INTEGER ox = 0, oy = 0, ow = 0, oh = 0, i = 0, nofelems = 0;
	LONGINT dx0 = 0, dy0 = 0;
	Dialogs_Object obArray[50];
	if (__Dialogs_Panel_NofSelObjects(p) == 0) {
		Dialogs_res = 0;
		return;
	}
	o = p->contents;
	ov = 0;
	dx0 = (LONGINT)dx * Dialogs_dUnit;
	dy0 = (LONGINT)dy * Dialogs_dUnit;
	while (o != NIL && !ov) {
		if (o->selected) {
			ov = __Dialogs_Object_IsOverlapping(o, p, o->x + dx0, o->y + dy0, o->w, o->h, 1);
		}
		o = o->next;
	}
	o = p->contents;
	if (!ov) {
		while (o != NIL) {
			if (o->selected) {
				msg.id = 1;
				msg.obj = o;
				Viewers_Broadcast((void*)&msg, Dialogs_NotifyMsg__typ);
				__Dialogs_Object_GetDim(o, &ox, &oy, &ow, &oh);
				__Dialogs_Panel_GetObjects(p, ox, oy, ow, oh, (void*)obArray, 50, &nofelems);
				i = 0;
				while (i < nofelems) {
					if (!obArray[__X(i, 50)]->selected) {
						__Dialogs_Object_Restore(obArray[__X(i, 50)]);
					}
					i += 1;
				}
			}
			o = o->next;
		}
		o = p->contents;
		while (o != NIL) {
			if (o->selected) {
				o->x = o->x + dx0;
				o->y = o->y + dy0;
			}
			o = o->next;
		}
		o = p->contents;
		while (o != NIL) {
			if (o->selected && o->overlapping) {
				__Dialogs_Object_Restore(o);
			}
			o = o->next;
		}
		o = p->contents;
		while (o != NIL) {
			if (o->selected && !o->overlapping) {
				__Dialogs_Object_Restore(o);
			}
			o = o->next;
		}
		Dialogs_res = 0;
		__Dialogs_Panel_MarkMenu(p);
	} else {
		Dialogs_res = 6;
	}
}

static struct ChangeDistance__30 {
	CHAR *dir;
	struct ChangeDistance__30 *lnk;
} *ChangeDistance__30_s;

static BOOLEAN Greater__35 (Dialogs_Object o1, Dialogs_Object o2);

static BOOLEAN Greater__35 (Dialogs_Object o1, Dialogs_Object o2)
{
	if (*ChangeDistance__30_s->dir == 'R' || *ChangeDistance__30_s->dir == 'L') {
		return o1->x > o2->x;
	} else {
		return o1->y > o2->y;
	}
	__RETCHK;
}

static void Dialogs_Panel_ChangeDistance (Dialogs_Panel p, CHAR dir)
{
	Dialogs_Object sort[50];
	INTEGER n = 0, i = 0;
	Dialogs_Object o = NIL;
	LONGINT d = 0;
	INTEGER _for__34 = 0, _for__33 = 0, _for__32 = 0, _for__31 = 0;
	struct ChangeDistance__30 _s;
	_s.dir = &dir;
	_s.lnk = ChangeDistance__30_s;
	ChangeDistance__30_s = &_s;
	o = p->contents;
	n = 0;
	while (o != NIL) {
		if (o->selected) {
			i = n - 1;
			while (i >= 0 && Greater__35(sort[__X(i, 50)], o)) {
				sort[__X(i + 1, 50)] = sort[__X(i, 50)];
				i -= 1;
			}
			sort[__X(i + 1, 50)] = o;
			n += 1;
		}
		o = o->next;
	}
	d = 0;
	if (dir == 'R' || dir == 'L') {
		_for__34 = n - 2;
		i = 0;
		while (i <= _for__34) {
			d = ((d + sort[__X(i, 50)]->x) - sort[__X(i + 1, 50)]->x) - sort[__X(i + 1, 50)]->w;
			i += 1;
		}
	} else {
		_for__33 = n - 2;
		i = 0;
		while (i <= _for__33) {
			d = ((d + sort[__X(i, 50)]->y) - sort[__X(i + 1, 50)]->y) - sort[__X(i + 1, 50)]->h;
			i += 1;
		}
	}
	d = __DIV(d, (LONGINT)(n - 1));
	if (dir == 'R' || dir == 'L') {
		_for__32 = n - 2;
		i = 0;
		while (i <= _for__32) {
			sort[__X(i + 1, 50)]->x = (sort[__X(i, 50)]->x - sort[__X(i + 1, 50)]->w) - d;
			i += 1;
		}
	} else if (dir == 'U' || dir == 'D') {
		_for__31 = n - 2;
		i = 0;
		while (i <= _for__31) {
			sort[__X(i + 1, 50)]->y = (sort[__X(i, 50)]->y - sort[__X(i + 1, 50)]->h) - d;
			i += 1;
		}
	}
	ChangeDistance__30_s = _s.lnk;
}

static BOOLEAN Dialogs_Panel_AlignTest (Dialogs_Panel p, CHAR dir, LONGINT x)
{
	Dialogs_Panel p2 = NIL;
	Dialogs_Object o = NIL;
	p2 = __Dialogs_Panel_Copy(p);
	o = p2->contents;
	while (o != NIL) {
		if (o->selected) {
			if (dir == 'R') {
				o->x = x - o->w;
			} else if (dir == 'L') {
				o->x = x;
			} else if (dir == 'U') {
				o->y = x - o->h;
			} else if (dir == 'D') {
				o->y = x;
			}
		}
		o = o->next;
	}
	o = p2->contents;
	while (o != NIL) {
		if (__Dialogs_Object_IsOverlapping(o, p2, o->x, o->y, o->w, o->h, 0)) {
			return 1;
		}
		o = o->next;
	}
	return 0;
}

static BOOLEAN Dialogs_Panel_RegulateDistanceTest (Dialogs_Panel p, CHAR dir)
{
	Dialogs_Panel p2 = NIL;
	Dialogs_Object o = NIL;
	p2 = __Dialogs_Panel_Copy(p);
	__Dialogs_Panel_ChangeDistance(p2, dir);
	o = p2->contents;
	while (o != NIL) {
		if (__Dialogs_Object_IsOverlapping(o, p2, o->x, o->y, o->w, o->h, 0)) {
			return 1;
		}
		o = o->next;
	}
	return 0;
}

static struct AlignSelected__25 {
	CHAR *dir;
	Dialogs_Object *o;
	LONGINT *x;
	struct AlignSelected__25 *lnk;
} *AlignSelected__25_s;

static void Max__26 (void);

static void Max__26 (void)
{
	if (*AlignSelected__25_s->dir == 'R') {
		if ((*AlignSelected__25_s->o)->x + (*AlignSelected__25_s->o)->w > *AlignSelected__25_s->x) {
			*AlignSelected__25_s->x = (*AlignSelected__25_s->o)->x + (*AlignSelected__25_s->o)->w;
		}
	} else if (*AlignSelected__25_s->dir == 'L') {
		if ((*AlignSelected__25_s->o)->x < *AlignSelected__25_s->x) {
			*AlignSelected__25_s->x = (*AlignSelected__25_s->o)->x;
		}
	} else if (*AlignSelected__25_s->dir == 'U') {
		if ((*AlignSelected__25_s->o)->y + (*AlignSelected__25_s->o)->h > *AlignSelected__25_s->x) {
			*AlignSelected__25_s->x = (*AlignSelected__25_s->o)->y + (*AlignSelected__25_s->o)->h;
		}
	} else if (*AlignSelected__25_s->dir == 'D') {
		if ((*AlignSelected__25_s->o)->y < *AlignSelected__25_s->x) {
			*AlignSelected__25_s->x = (*AlignSelected__25_s->o)->y;
		}
	}
}

void Dialogs_Panel_AlignSelected (Dialogs_Panel p, CHAR dir)
{
	Dialogs_Object o = NIL;
	LONGINT x = 0;
	struct AlignSelected__25 _s;
	_s.dir = &dir;
	_s.o = &o;
	_s.x = &x;
	_s.lnk = AlignSelected__25_s;
	AlignSelected__25_s = &_s;
	if (((dir != 'R' && dir != 'L') && dir != 'U') && dir != 'D') {
		Dialogs_res = 4;
		AlignSelected__25_s = _s.lnk;
		return;
	}
	if (__Dialogs_Panel_NofSelObjects(p) == 0) {
		Dialogs_res = 0;
		AlignSelected__25_s = _s.lnk;
		return;
	}
	o = p->contents;
	if (dir == 'R' || dir == 'D') {
		x = 0;
	} else if (dir == 'L') {
		x = 2147483647;
	} else {
		x = (-2147483647-1);
	}
	while (o != NIL) {
		if (o->selected) {
			Max__26();
		}
		o = o->next;
	}
	if (!__Dialogs_Panel_AlignTest(p, dir, x)) {
		o = p->contents;
		while (o != NIL) {
			if (o->selected) {
				if (dir == 'R') {
					o->x = x - o->w;
				} else if (dir == 'L') {
					o->x = x;
				} else if (dir == 'U') {
					o->y = x - o->h;
				} else if (dir == 'D') {
					o->y = x;
				}
			}
			o = o->next;
		}
		__Dialogs_Panel_Restore(p);
		Dialogs_res = 0;
		__Dialogs_Panel_MarkMenu(p);
	} else {
		Dialogs_res = 6;
	}
	AlignSelected__25_s = _s.lnk;
}

void Dialogs_Panel_RegulateDistance (Dialogs_Panel p, CHAR dir)
{
	if (((dir != 'R' && dir != 'L') && dir != 'U') && dir != 'D') {
		Dialogs_res = 4;
		return;
	}
	if (__Dialogs_Panel_NofSelObjects(p) > 50) {
		Dialogs_res = 7;
		return;
	}
	if (__Dialogs_Panel_NofSelObjects(p) < 3) {
		Dialogs_res = 0;
		return;
	}
	if (!__Dialogs_Panel_RegulateDistanceTest(p, dir)) {
		__Dialogs_Panel_ChangeDistance(p, dir);
		__Dialogs_Panel_Restore(p);
		Dialogs_res = 0;
		__Dialogs_Panel_MarkMenu(p);
	} else {
		Dialogs_res = 6;
	}
}

void Dialogs_Panel_Broadcast (Dialogs_Panel p, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ)
{
	Dialogs_Object o = NIL, o1 = NIL;
	o = p->contents;
	while (o != NIL) {
		__Dialogs_Object_Handle(o, f, &*m, m__typ);
		o = o->next;
	}
}

void Dialogs_Error (CHAR *name, LONGINT name__len)
{
	__DUP(name, name__len, CHAR);
	Texts_WriteString(&Dialogs_w0, Texts_Writer__typ, name, name__len);
	if (Dialogs_res == 1) {
		Texts_WriteString(&Dialogs_w0, Texts_Writer__typ, (CHAR*)" Error 1: Object is already in Panel", (LONGINT)37);
	} else if (Dialogs_res == 2) {
		Texts_WriteString(&Dialogs_w0, Texts_Writer__typ, (CHAR*)" Error 2: Name exists", (LONGINT)22);
	} else if (Dialogs_res == 3) {
		Texts_WriteString(&Dialogs_w0, Texts_Writer__typ, (CHAR*)" Error 3: Object not found", (LONGINT)27);
	} else if (Dialogs_res == 4) {
		Texts_WriteString(&Dialogs_w0, Texts_Writer__typ, (CHAR*)" Error 4: Wrong input", (LONGINT)22);
	} else if (Dialogs_res == 5) {
		Texts_WriteString(&Dialogs_w0, Texts_Writer__typ, (CHAR*)"Error 5: No panel selected", (LONGINT)27);
	} else if (Dialogs_res == 6) {
		Texts_WriteString(&Dialogs_w0, Texts_Writer__typ, (CHAR*)" Error 6: Object would overlap another object", (LONGINT)46);
	} else if (Dialogs_res == 7) {
		Texts_WriteString(&Dialogs_w0, Texts_Writer__typ, (CHAR*)" Error 7: Too many objects selected", (LONGINT)36);
	} else {
		Texts_WriteInt(&Dialogs_w0, Texts_Writer__typ, Dialogs_res, 5);
	}
	Texts_WriteLn(&Dialogs_w0, Texts_Writer__typ);
	Texts_Append(Oberon_Log, Dialogs_w0.buf);
	__DEL(name);
}

static void EnumPtrs(void (*P)(void*))
{
	P(Dialogs_cmdPanel);
	P(Dialogs_editPanel);
	P(Dialogs_editObject);
	P(Dialogs_lastin);
	__ENUMR(&Dialogs_w0, Texts_Writer__typ, 36, 1, P);
}

__TDESC(Dialogs_ObjectDesc, 25, 2) = {__TDFLDS("ObjectDesc", 112), {0, 104, -12}};
__TDESC(Dialogs_PanelDesc, 28, 1) = {__TDFLDS("PanelDesc", 68), {64, -8}};
__TDESC(Dialogs_NotifyMsg, 1, 2) = {__TDFLDS("NotifyMsg", 12), {4, 8, -12}};

export void *Dialogs__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Modules);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Types);
	__IMPORT(Viewers);
	__REGMOD(Dialogs, EnumPtrs);
	__INITYP(Dialogs_ObjectDesc, Dialogs_ObjectDesc, 0);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_CallCmd, 0);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_Copy, 1);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_Draw, 2);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_Edit, 3);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_GetDim, 4);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_GetPDim, 5);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_Handle, 6);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_Hide, 7);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_Init, 8);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_IsIn, 9);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_IsOverlapped, 10);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_IsOverlapping, 11);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_Load, 12);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_OverlappingObject, 13);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_Print, 14);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_Restore, 15);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_Select, 16);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_SetCmd, 17);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_SetDim, 18);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_SetName, 19);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_SetPar, 20);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_Store, 21);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_UnSelect, 22);
	__INITBP(Dialogs_ObjectDesc, Dialogs_Object_Update, 23);
	__INITYP(Dialogs_PanelDesc, Dialogs_PanelDesc, 0);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_AlignSelected, 0);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_AlignTest, 1);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_Broadcast, 2);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_ChangeDistance, 3);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_Contains, 4);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_Copy, 5);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_Draw, 6);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_Enumerate, 7);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_GetObjects, 8);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_Insert, 9);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_Load, 10);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_MarkMenu, 11);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_MoveSelected, 12);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_NamedObject, 13);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_NofSelObjects, 14);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_Print, 15);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_RegulateDistance, 16);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_RegulateDistanceTest, 17);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_Remove, 18);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_RemoveObjects, 19);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_RemoveSelections, 20);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_Restore, 21);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_RestoreOverlapped, 22);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_Select, 23);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_SetCmd, 24);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_Store, 25);
	__INITBP(Dialogs_PanelDesc, Dialogs_Panel_ThisObject, 26);
	__INITYP(Dialogs_NotifyMsg, Display_FrameMsg, 1);
/* BEGIN */
	Dialogs_dUnit = TextFrames_Unit;
	Dialogs_pUnit = 3048;
	Dialogs_Edit = NIL;
	Dialogs_Update = NIL;
	Dialogs_res = 0;
	Dialogs_editPanel = NIL;
	Dialogs_cmdPanel = NIL;
	Dialogs_editObject = NIL;
	Dialogs_lastin = NIL;
	Texts_OpenWriter(&Dialogs_w0, Texts_Writer__typ);
	__ENDMOD;
}
