/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Console.h"
#include "Kernel.h"
#include "X11.h"

typedef
	struct Display_Bytes {
		char _prvt0[1];
	} Display_Bytes;

typedef
	Display_Bytes *Display_Font;

typedef
	struct Display_FrameDesc *Display_Frame;

typedef
	struct Display_FrameMsg {
		char _prvt0[1];
	} Display_FrameMsg;

typedef
	void (*Display_Handler)(Display_Frame, Display_FrameMsg*, LONGINT *);

typedef
	struct Display_FrameDesc {
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
	} Display_FrameDesc;


export INTEGER Display_Bottom, Display_Left, Display_Width, Display_Height, Display_ColLeft, Display_UBottom;
export LONGINT Display_Unit, Display_primary, Display_secondary, Display_arrow, Display_cross, Display_star, Display_hook, Display_downArrow, Display_grey0, Display_grey1, Display_grey2, Display_ticks;
static LONGINT Display_Gc;
static INTEGER Display_lastcol, Display_lastmode;
static LONGINT Display_GcC, Display_Window;
static INTEGER Display_lastcolC, Display_lastmodeC, Display_lastx, Display_lasty, Display_lastw, Display_lasth;

export LONGINT *Display_FrameMsg__typ;
export LONGINT *Display_FrameDesc__typ;
export LONGINT *Display_Bytes__typ;

export void Display_CopyBlock (INTEGER SX, INTEGER SY, INTEGER W, INTEGER H, INTEGER DX, INTEGER DY, INTEGER mode);
export void Display_CopyPattern (INTEGER col, LONGINT pat, INTEGER X, INTEGER Y, INTEGER mode);
export void Display_CopyPatternC (Display_Frame F, INTEGER col, LONGINT pat, INTEGER X, INTEGER Y, INTEGER mode);
static void Display_CreateGcs (void);
static void Display_CreatePatterns (void);
export void Display_Dot (INTEGER col, INTEGER X, INTEGER Y, INTEGER mode);
export void Display_DotC (Display_Frame F, INTEGER col, INTEGER X, INTEGER Y, INTEGER mode);
export void Display_GetChar (Display_Font f, CHAR ch, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h, LONGINT *p);
export void Display_GetColor (INTEGER col, INTEGER *red, INTEGER *green, INTEGER *blue);
export LONGINT Display_Map (INTEGER X, INTEGER Y);
export LONGINT Display_NewPattern (SET *image, LONGINT image__len, INTEGER w, INTEGER h);
export void Display_ReplConst (INTEGER col, INTEGER X, INTEGER Y, INTEGER W, INTEGER H, INTEGER mode);
export void Display_ReplConstC (Display_Frame F, INTEGER col, INTEGER X, INTEGER Y, INTEGER W, INTEGER H, INTEGER mode);
export void Display_ReplPattern (INTEGER col, LONGINT pat, INTEGER X, INTEGER Y, INTEGER W, INTEGER H, INTEGER mode);
export void Display_ReplPatternC (Display_Frame F, INTEGER col, LONGINT pat, INTEGER X, INTEGER Y, INTEGER W, INTEGER H, INTEGER X0, INTEGER Y0, INTEGER mode);
static BOOLEAN Display_Secondary (Display_Frame F, INTEGER col, INTEGER mode);
export void Display_SetColor (INTEGER col, INTEGER red, INTEGER green, INTEGER blue);
export void Display_SetMode (INTEGER X, SET s);


LONGINT Display_NewPattern (SET *image, LONGINT image__len, INTEGER w, INTEGER h)
{
	return X11_NewPattern((void*)image, image__len, 2, w, h);
}

static BOOLEAN Display_Secondary (Display_Frame F, INTEGER col, INTEGER mode)
{
	X11_Rectangle cliprect = {0};
	if (X11_lclen > 0) {
		X11_FlushLCache();
	}
	Kernel_Lock();
	if (((F->X != Display_lastx || F->Y != Display_lasty) || F->W != Display_lastw) || F->H != Display_lasth) {
		Display_lastx = F->X;
		Display_lasty = F->Y;
		Display_lastw = F->W;
		Display_lasth = F->H;
		cliprect.x = Display_lastx;
		cliprect.y = (X11_Height - Display_lasty) - Display_lasth;
		cliprect.w = Display_lastw;
		cliprect.h = Display_lasth;
		if (Display_lasty >= 0) {
			Display_Window = X11_primary;
		} else {
			Display_Window = X11_secondary;
			cliprect.y += X11_UBottom;
		}
		if (((cliprect.x <= 0 && cliprect.y <= 0) && cliprect.w >= X11_Width) && cliprect.h >= X11_Height) {
			X11_SetClipMask(X11_display, Display_GcC, 0);
		} else {
			X11_SetClipRectangles(X11_display, Display_GcC, 0, 0, (LONGINT)&cliprect, 1, 3);
		}
	}
	if (mode == 1) {
		mode = 0;
	}
	if (mode != Display_lastmodeC) {
		X11_SetFunction(X11_display, Display_GcC, X11_function[__X(mode, 3)]);
		Display_lastmodeC = mode;
	}
	if (col != Display_lastcolC) {
		X11_SetForeground(X11_display, Display_GcC, X11_pixelValues[__X(col, 256)]);
		Display_lastcolC = col;
	}
	Kernel_Unlock();
	return Display_Window == X11_secondary;
}

LONGINT Display_Map (INTEGER X, INTEGER Y)
{
	return 0;
}

void Display_SetColor (INTEGER col, INTEGER red, INTEGER green, INTEGER blue)
{
	X11_SetColor(col, red, green, blue);
}

void Display_GetColor (INTEGER col, INTEGER *red, INTEGER *green, INTEGER *blue)
{
	X11_GetColor(col, &*red, &*green, &*blue);
}

void Display_SetMode (INTEGER X, SET s)
{
}

void Display_GetChar (Display_Font f, CHAR ch, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h, LONGINT *p)
{
	LONGINT m = 0;
	INTEGER h1 = 0;
	LONGINT h2 = 0;
	X11_ccf = (X11_Font)f;
	X11_ccch = ch;
	m = (LONGINT)f + (LONGINT)((int)ch * 24);
	h2 = m + 8;
	*p = h2;
	X11_ccp = h2;
	__GET(m, h1, INTEGER);
	*dx = h1;
	X11_ccdx = h1;
	m += 2;
	__GET(m, h1, INTEGER);
	*x = h1;
	X11_ccx = h1;
	m += 2;
	__GET(m, h1, INTEGER);
	*y = h1;
	X11_ccy = h1;
	m += 12;
	__GET(m, *w, INTEGER);
	m += 2;
	__GET(m, *h, INTEGER);
}

void Display_CopyBlock (INTEGER SX, INTEGER SY, INTEGER W, INTEGER H, INTEGER DX, INTEGER DY, INTEGER mode)
{
	LONGINT gc = 0, src = 0, dst = 0;
	Kernel_Lock();
	if (X11_lclen > 0) {
		X11_FlushLCache();
	}
	gc = Display_Gc;
	if (mode == 1) {
		mode = 0;
	}
	if (mode != Display_lastmode) {
		X11_SetFunction(X11_display, gc, X11_function[__X(mode, 3)]);
		Display_lastmode = mode;
	}
	if (SY >= 0) {
		src = X11_primary;
	} else {
		src = X11_secondary;
		SY -= X11_UBottom;
	}
	if (DY >= 0) {
		dst = X11_primary;
	} else {
		dst = X11_secondary;
		DY -= X11_UBottom;
	}
	X11_CopyArea(X11_display, src, dst, gc, SX, (Display_Height - SY) - H, W, H, DX, (Display_Height - DY) - H);
	Kernel_Unlock();
}

void Display_CopyPattern (INTEGER col, LONGINT pat, INTEGER X, INTEGER Y, INTEGER mode)
{
	X11_PatternPtr p = NIL;
	LONGINT gc = 0, window = 0, colPixel = 0;
	INTEGER spacedx = 0;
	if (pat == X11_ccp && X11_ccf->xid != 0) {
		if (X11_lclen == 0) {
			X11_lcache[0] = X11_ccch;
			X11_lclen = 1;
			X11_lcf = X11_ccf;
			X11_lcx0 = X - X11_ccx;
			X11_lcy0 = Y - X11_ccy;
			X11_lccol = col;
			X11_lcmode = mode;
			X11_lcx = X11_lcx0 + X11_ccdx;
		} else if (((((X11_ccf != X11_lcf || X - X11_ccx != X11_lcx) || Y - X11_ccy != X11_lcy0) || col != X11_lccol) || mode != X11_lcmode) || X11_lclen == 256) {
			spacedx = X11_lcf->metrics[32].dx;
			if (((((X11_ccf == X11_lcf && (X - X11_ccx) - spacedx == X11_lcx) && Y - X11_ccy == X11_lcy0) && col == X11_lccol) && mode == X11_lcmode) && X11_lclen != 256) {
				X11_lcache[__X(X11_lclen, 256)] = ' ';
				X11_lcache[__X(X11_lclen + 1, 256)] = X11_ccch;
				X11_lclen += 2;
				X11_lcx += X11_ccdx + spacedx;
			} else {
				X11_FlushLCache();
				X11_lcache[0] = X11_ccch;
				X11_lclen = 1;
				X11_lcf = X11_ccf;
				X11_lcx0 = X - X11_ccx;
				X11_lcy0 = Y - X11_ccy;
				X11_lccol = col;
				X11_lcmode = mode;
				X11_lcx = X11_lcx0 + X11_ccdx;
			}
		} else {
			X11_lcache[__X(X11_lclen, 256)] = X11_ccch;
			X11_lclen += 1;
			X11_lcx += X11_ccdx;
		}
	} else {
		if (X11_lclen > 0) {
			X11_FlushLCache();
		}
		p = (X11_PatternPtr)pat;
		gc = Display_Gc;
		if (Y >= 0) {
			window = X11_primary;
		} else {
			window = X11_secondary;
			Y -= X11_UBottom;
		}
		Kernel_Lock();
		if (mode == 1) {
			colPixel = X11_pixelValues[__X(col, 256)];
			if (colPixel != X11_basePixel + X11_planesMask) {
				X11_SetFunction(X11_display, gc, 1);
				X11_SetBackground(X11_display, gc, X11_basePixel + X11_planesMask);
				X11_SetForeground(X11_display, gc, X11_basePixel);
				X11_CopyPlane(X11_display, p->pixmap, window, gc, p->x, p->y, p->w, p->h, X, (Display_Height - Y) - p->h, 1);
			}
			if (colPixel != X11_basePixel) {
				X11_SetFunction(X11_display, gc, 7);
				X11_SetBackground(X11_display, gc, X11_basePixel);
				X11_SetForeground(X11_display, gc, colPixel);
				X11_CopyPlane(X11_display, p->pixmap, window, gc, p->x, p->y, p->w, p->h, X, (Display_Height - Y) - p->h, 1);
			}
			X11_SetBackground(X11_display, gc, X11_background);
			Display_lastcol = -1;
			Display_lastmode = -1;
		} else {
			if (mode != Display_lastmode) {
				X11_SetFunction(X11_display, gc, X11_function[__X(mode, 3)]);
				Display_lastmode = mode;
			}
			if (col != Display_lastcol) {
				X11_SetForeground(X11_display, gc, X11_pixelValues[__X(col, 256)]);
				Display_lastcol = col;
			}
			X11_CopyPlane(X11_display, p->pixmap, window, gc, p->x, p->y, p->w, p->h, X, (Display_Height - Y) - p->h, 1);
		}
		Kernel_Unlock();
	}
}

void Display_ReplPattern (INTEGER col, LONGINT pat, INTEGER X, INTEGER Y, INTEGER W, INTEGER H, INTEGER mode)
{
	LONGINT gc = 0;
	X11_PatternPtr p = NIL;
	LONGINT window = 0, colPixel = 0;
	if (X11_lclen > 0) {
		X11_FlushLCache();
	}
	if (H > 0 && W > 0) {
		p = (X11_PatternPtr)pat;
		gc = Display_Gc;
		if (Y >= 0) {
			window = X11_primary;
		} else {
			window = X11_secondary;
			Y -= X11_UBottom;
		}
		Kernel_Lock();
		X11_SetStipple(X11_display, gc, p->pixmap);
		X11_SetTSOrigin(X11_display, gc, 0, Display_Height);
		X11_SetFillStyle(X11_display, gc, 3);
		if (mode == 1) {
			colPixel = X11_pixelValues[__X(col, 256)];
			if (colPixel != X11_basePixel + X11_planesMask) {
				X11_SetFunction(X11_display, gc, 1);
				X11_SetBackground(X11_display, gc, X11_basePixel + X11_planesMask);
				X11_SetForeground(X11_display, gc, X11_basePixel);
				X11_FillRectangle(X11_display, window, gc, X, (Display_Height - Y) - H, W, H);
			}
			if (colPixel != X11_basePixel) {
				X11_SetFunction(X11_display, gc, 7);
				X11_SetBackground(X11_display, gc, X11_basePixel);
				X11_SetForeground(X11_display, gc, colPixel);
				X11_FillRectangle(X11_display, window, gc, X, (Display_Height - Y) - H, W, H);
			}
			X11_SetBackground(X11_display, gc, X11_background);
			Display_lastcol = -1;
			Display_lastmode = -1;
		} else {
			if (mode != Display_lastmode) {
				X11_SetFunction(X11_display, gc, X11_function[__X(mode, 3)]);
				Display_lastmode = mode;
			}
			if (col != Display_lastcol) {
				X11_SetForeground(X11_display, gc, X11_pixelValues[__X(col, 256)]);
				Display_lastcol = col;
			}
			X11_FillRectangle(X11_display, window, gc, X, (Display_Height - Y) - H, W, H);
		}
		X11_SetFillStyle(X11_display, gc, 0);
		Kernel_Unlock();
	}
}

void Display_ReplConst (INTEGER col, INTEGER X, INTEGER Y, INTEGER W, INTEGER H, INTEGER mode)
{
	LONGINT gc = 0, window = 0;
	if (X11_lclen > 0) {
		X11_FlushLCache();
	}
	if (H > 0 && W > 0) {
		gc = Display_Gc;
		if (mode == 1) {
			mode = 0;
		}
		Kernel_Lock();
		if (mode != Display_lastmode) {
			X11_SetFunction(X11_display, gc, X11_function[__X(mode, 3)]);
			Display_lastmode = mode;
		}
		if (col != Display_lastcol) {
			X11_SetForeground(X11_display, gc, X11_pixelValues[__X(col, 256)]);
			Display_lastcol = col;
		}
		if (Y >= 0) {
			window = X11_primary;
		} else {
			window = X11_secondary;
			Y -= X11_UBottom;
		}
		X11_FillRectangle(X11_display, window, gc, X, (Display_Height - Y) - H, W, H);
		Kernel_Unlock();
	}
}

void Display_Dot (INTEGER col, INTEGER X, INTEGER Y, INTEGER mode)
{
	LONGINT gc = 0, window = 0;
	if (X11_lclen > 0) {
		X11_FlushLCache();
	}
	gc = Display_Gc;
	if (mode == 1) {
		mode = 0;
	}
	Kernel_Lock();
	if (mode != Display_lastmode) {
		X11_SetFunction(X11_display, gc, X11_function[__X(mode, 3)]);
		Display_lastmode = mode;
	}
	if (col != Display_lastcol) {
		X11_SetForeground(X11_display, gc, X11_pixelValues[__X(col, 256)]);
		Display_lastcol = col;
	}
	if (Y >= 0) {
		window = X11_primary;
	} else {
		window = X11_secondary;
		Y -= X11_UBottom;
	}
	X11_DrawPoint(X11_display, window, gc, X, (Display_Height - Y) - 1);
	Kernel_Unlock();
}

void Display_DotC (Display_Frame F, INTEGER col, INTEGER X, INTEGER Y, INTEGER mode)
{
	if (F->W <= 0 || F->H <= 0) {
		return;
	}
	if (Display_Secondary(F, col, mode)) {
		Y -= X11_UBottom;
	}
	Kernel_Lock();
	X11_DrawPoint(X11_display, Display_Window, Display_GcC, X, (Display_Height - Y) - 1);
	Kernel_Unlock();
}

void Display_ReplConstC (Display_Frame F, INTEGER col, INTEGER X, INTEGER Y, INTEGER W, INTEGER H, INTEGER mode)
{
	if (H > 0 && W > 0) {
		if (F->W <= 0 || F->H <= 0) {
			return;
		}
		if (Display_Secondary(F, col, mode)) {
			Y -= X11_UBottom;
		}
		Kernel_Lock();
		X11_FillRectangle(X11_display, Display_Window, Display_GcC, X, (X11_Height - Y) - H, W, H);
		Kernel_Unlock();
	}
}

void Display_ReplPatternC (Display_Frame F, INTEGER col, LONGINT pat, INTEGER X, INTEGER Y, INTEGER W, INTEGER H, INTEGER X0, INTEGER Y0, INTEGER mode)
{
	LONGINT gc = 0;
	X11_PatternPtr p = NIL;
	LONGINT colPixel = 0;
	if (H > 0 && W > 0) {
		if (F->W <= 0 || F->H <= 0) {
			return;
		}
		p = (X11_PatternPtr)pat;
		gc = Display_GcC;
		if (Display_Secondary(F, col, mode)) {
			Y -= X11_UBottom;
			Y0 -= X11_UBottom;
		}
		Kernel_Lock();
		X11_SetStipple(X11_display, gc, p->pixmap);
		X11_SetTSOrigin(X11_display, gc, X0, X11_Height - Y0);
		X11_SetFillStyle(X11_display, gc, 3);
		if (mode == 1) {
			colPixel = X11_pixelValues[__X(col, 256)];
			if (colPixel != X11_basePixel + X11_planesMask) {
				X11_SetFunction(X11_display, gc, 1);
				X11_SetBackground(X11_display, gc, X11_basePixel + X11_planesMask);
				X11_SetForeground(X11_display, gc, X11_basePixel);
				X11_FillRectangle(X11_display, Display_Window, gc, X, (X11_Height - Y) - H, W, H);
			}
			if (colPixel != X11_basePixel) {
				X11_SetFunction(X11_display, gc, 7);
				X11_SetBackground(X11_display, gc, X11_basePixel);
				X11_SetForeground(X11_display, gc, colPixel);
				X11_FillRectangle(X11_display, Display_Window, gc, X, (X11_Height - Y) - H, W, H);
			}
			X11_SetBackground(X11_display, gc, X11_background);
			Display_lastcolC = -1;
			Display_lastmodeC = -1;
		} else {
			X11_FillRectangle(X11_display, Display_Window, gc, X, (X11_Height - Y) - H, W, H);
		}
		X11_SetFillStyle(X11_display, gc, 0);
		Kernel_Unlock();
	}
}

void Display_CopyPatternC (Display_Frame F, INTEGER col, LONGINT pat, INTEGER X, INTEGER Y, INTEGER mode)
{
	LONGINT gc = 0;
	X11_PatternPtr p = NIL;
	LONGINT colPixel = 0;
	p = (X11_PatternPtr)pat;
	if (((X >= F->X && X + p->w <= F->X + F->W) && Y >= F->Y) && Y + p->h <= F->Y + F->H) {
		Display_CopyPattern(col, pat, X, Y, mode);
	} else {
		gc = Display_GcC;
		if (Display_Secondary(F, col, mode)) {
			Y -= X11_UBottom;
		}
		Kernel_Lock();
		if (mode == 1) {
			colPixel = X11_pixelValues[__X(col, 256)];
			if (colPixel != X11_basePixel + X11_planesMask) {
				X11_SetFunction(X11_display, gc, 1);
				X11_SetBackground(X11_display, gc, X11_basePixel + X11_planesMask);
				X11_SetForeground(X11_display, gc, X11_basePixel);
				X11_CopyPlane(X11_display, p->pixmap, Display_Window, gc, p->x, p->y, p->w, p->h, X, (X11_Height - Y) - p->h, 1);
			}
			if (colPixel != X11_basePixel) {
				X11_SetFunction(X11_display, gc, 7);
				X11_SetBackground(X11_display, gc, X11_basePixel);
				X11_SetForeground(X11_display, gc, colPixel);
				X11_CopyPlane(X11_display, p->pixmap, Display_Window, gc, p->x, p->y, p->w, p->h, X, (X11_Height - Y) - p->h, 1);
			}
			X11_SetBackground(X11_display, gc, X11_background);
			Display_lastcolC = -1;
			Display_lastmodeC = -1;
		} else {
			X11_CopyPlane(X11_display, p->pixmap, Display_Window, gc, p->x, p->y, p->w, p->h, X, (X11_Height - Y) - p->h, 1);
		}
		Kernel_Unlock();
	}
}

static void Display_CreateGcs (void)
{
	Kernel_Lock();
	Display_Gc = X11_CreateGC(X11_display, X11_primary, 0, 0);
	if (Display_Gc == 0) {
		Console_String((CHAR*)"Cannot create X graphic context", (LONGINT)32);
		Console_Ln();
		Kernel_Exit(1);
	}
	X11_SetPlaneMask(X11_display, Display_Gc, X11_planesMask);
	X11_SetGraphicsExposures(X11_display, Display_Gc, 1);
	X11_SetBackground(X11_display, Display_Gc, X11_background);
	Display_lastcol = -1;
	Display_lastmode = -1;
	Display_GcC = X11_CreateGC(X11_display, X11_primary, 0, 0);
	if (Display_GcC == 0) {
		Console_String((CHAR*)"Cannot create X graphic context", (LONGINT)32);
		Console_Ln();
		Kernel_Exit(1);
	}
	X11_SetPlaneMask(X11_display, Display_GcC, X11_planesMask);
	X11_SetGraphicsExposures(X11_display, Display_GcC, 1);
	X11_SetBackground(X11_display, Display_GcC, X11_background);
	Display_lastcolC = -1;
	Display_lastmodeC = -1;
	Display_lastx = -1;
	Display_lasty = -1;
	Display_lastw = -1;
	Display_lasth = -1;
	Display_Window = X11_secondary;
	Kernel_Unlock();
}

static void Display_CreatePatterns (void)
{
	SET image[17];
	image[1] = 0x2000;
	image[2] = 0x7000;
	image[3] = 0x3800;
	image[4] = 0x1c00;
	image[5] = 0x0e00;
	image[6] = 0x0700;
	image[7] = 0x0380;
	image[8] = 0x01c1;
	image[9] = 0xe3;
	image[10] = 0x77;
	image[11] = 0x3f;
	image[12] = 0x1f;
	image[13] = 0x3f;
	image[14] = 0x7f;
	image[15] = 0xff;
	Display_arrow = X11_NewPattern((void*)image, 17, 2, 15, 15);
	image[1] = 0x0401;
	image[2] = 0x0202;
	image[3] = 0x0104;
	image[4] = 0x88;
	image[5] = 0x50;
	image[6] = 0x0;
	image[7] = 0x50;
	image[8] = 0x88;
	image[9] = 0x0104;
	image[10] = 0x0202;
	image[11] = 0x0401;
	Display_cross = X11_NewPattern((void*)image, 17, 2, 11, 11);
	image[1] = 0x40;
	image[2] = 0xe0;
	image[3] = 0x01f0;
	image[4] = 0x03f8;
	image[5] = 0x07fc;
	image[6] = 0xe0;
	image[7] = 0xe0;
	image[8] = 0xe0;
	image[9] = 0xe0;
	image[10] = 0xe0;
	image[11] = 0xe0;
	image[12] = 0xe0;
	image[13] = 0xe0;
	image[14] = 0xe0;
	image[15] = 0x0;
	Display_downArrow = X11_NewPattern((void*)image, 17, 2, 15, 15);
	image[1] = 0x1111;
	image[2] = 0x0;
	image[3] = 0x4444;
	image[4] = 0x0;
	image[5] = 0x1111;
	image[6] = 0x0;
	image[7] = 0x4444;
	image[8] = 0x0;
	image[9] = 0x1111;
	image[10] = 0x0;
	image[11] = 0x4444;
	image[12] = 0x0;
	image[13] = 0x1111;
	image[14] = 0x0;
	image[15] = 0x4444;
	image[16] = 0x0;
	Display_grey0 = X11_NewPattern((void*)image, 17, 2, 16, 16);
	image[1] = 0x5555;
	image[2] = 0xaaaa;
	image[3] = 0x5555;
	image[4] = 0xaaaa;
	image[5] = 0x5555;
	image[6] = 0xaaaa;
	image[7] = 0x5555;
	image[8] = 0xaaaa;
	image[9] = 0x5555;
	image[10] = 0xaaaa;
	image[11] = 0x5555;
	image[12] = 0xaaaa;
	image[13] = 0x5555;
	image[14] = 0xaaaa;
	image[15] = 0x5555;
	image[16] = 0xaaaa;
	Display_grey1 = X11_NewPattern((void*)image, 17, 2, 16, 16);
	image[1] = 0x3333;
	image[2] = 0x3333;
	image[3] = 0xcccc;
	image[4] = 0xcccc;
	image[5] = 0x3333;
	image[6] = 0x3333;
	image[7] = 0xcccc;
	image[8] = 0xcccc;
	image[9] = 0x3333;
	image[10] = 0x3333;
	image[11] = 0xcccc;
	image[12] = 0xcccc;
	image[13] = 0x3333;
	image[14] = 0x3333;
	image[15] = 0xcccc;
	image[16] = 0xcccc;
	Display_grey2 = X11_NewPattern((void*)image, 17, 2, 16, 16);
	image[1] = 0xff;
	image[2] = 0x7f;
	image[3] = 0x3f;
	image[4] = 0x1f;
	image[5] = 0x0f;
	image[6] = 0x07;
	image[7] = 0x03;
	image[8] = 0x01;
	Display_hook = Display_NewPattern((void*)image, 17, 8, 8);
	image[1] = 0x80;
	image[2] = 0x80;
	image[3] = 0x1084;
	image[4] = 0x0888;
	image[5] = 0x0490;
	image[6] = 0x02a0;
	image[7] = 0x01c0;
	image[8] = 0x7f7f;
	image[9] = 0x01c0;
	image[10] = 0x02a0;
	image[11] = 0x0490;
	image[12] = 0x0888;
	image[13] = 0x1084;
	image[14] = 0x80;
	image[15] = 0x80;
	Display_star = X11_NewPattern((void*)image, 17, 2, 15, 15);
	image[1] = 0x01;
	image[2] = 0x0;
	image[3] = 0x0;
	image[4] = 0x0;
	image[5] = 0x0;
	image[6] = 0x0;
	image[7] = 0x0;
	image[8] = 0x0;
	image[9] = 0x0;
	image[10] = 0x0;
	image[11] = 0x0;
	image[12] = 0x0;
	image[13] = 0x0;
	image[14] = 0x0;
	image[15] = 0x0;
	image[16] = 0x0;
	Display_ticks = X11_NewPattern((void*)image, 17, 2, 16, 16);
}

__TDESC(Display_FrameMsg, 1, 0) = {__TDFLDS("FrameMsg", 1), {-4}};
__TDESC(Display_FrameDesc, 1, 2) = {__TDFLDS("FrameDesc", 20), {0, 4, -12}};
__TDESC(Display_Bytes, 1, 0) = {__TDFLDS("Bytes", 1), {-4}};

export void *Display__init(void)
{
	__DEFMOD;
	__IMPORT(Console);
	__IMPORT(Kernel);
	__IMPORT(X11);
	__REGMOD(Display, 0);
	__INITYP(Display_FrameMsg, Display_FrameMsg, 0);
	__INITYP(Display_FrameDesc, Display_FrameDesc, 0);
	__INITYP(Display_Bytes, Display_Bytes, 0);
/* BEGIN */
	Display_Unit = __DIV(36000 * X11_screenhmm + __ASHR(X11_screenh, 1), X11_screenh);
	Display_Left = 0;
	Display_ColLeft = X11_ColLeft;
	Display_Bottom = X11_Bottom;
	Display_UBottom = X11_UBottom;
	Display_Width = X11_Width;
	Display_Height = X11_Height;
	Display_primary = X11_primary;
	Display_secondary = X11_secondary;
	Display_CreateGcs();
	Display_CreatePatterns();
	__ENDMOD;
}
