/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "MenuViewers.h"
#include "Modules.h"
#include "Oberon.h"
#include "ParcElems.h"
#include "Printer.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

struct Edit__1 {
	LONGINT time, len;
	CHAR buf[128];
};

struct Edit__2 {
	LONGINT time;
	Texts_Buffer buf;
};


static Texts_Reader Edit_R;
static Texts_Writer Edit_W;
static CHAR Edit_mnam[37];
static struct Edit__1 Edit_find;
static struct Edit__2 Edit_repl;

export LONGINT *Edit__1__typ;
export LONGINT *Edit__2__typ;

static void Edit_AppendDate (CHAR *s, LONGINT s__len);
static void Edit_AppendNum (CHAR *s, LONGINT s__len, INTEGER *i, LONGINT n);
static void Edit_Ch (CHAR ch);
static void Edit_Change (SET sel);
export void Edit_ChangeBackgroundColor (void);
export void Edit_ChangeColor (void);
export void Edit_ChangeFont (void);
export void Edit_ChangeOffset (void);
static BOOLEAN Edit_Check (Texts_Text T, LONGINT beg);
export void Edit_ClearReplaceBuffer (void);
static void Edit_Find (Texts_Text T, LONGINT beg, LONGINT *end);
static TextFrames_Frame Edit_FocusFrame (void);
export void Edit_Get (void);
static void Edit_GetArg (Texts_Scanner *S, LONGINT *S__typ);
static void Edit_GetMainArg (Texts_Scanner *S, LONGINT *S__typ, LONGINT *end);
export void Edit_InsertParc (void);
static void Edit_Int (LONGINT n);
static void Edit_Ln (void);
export void Edit_Locate (void);
static TextFrames_Frame Edit_MarkedFrame (void);
static LONGINT Edit_Min (LONGINT x, LONGINT y);
static TextFrames_Frame Edit_NewView (CHAR *name, LONGINT name__len, INTEGER class, Texts_Text T, LONGINT org);
export void Edit_Open (void);
export void Edit_Parcs (void);
export void Edit_Print (void);
export void Edit_Recall (void);
export void Edit_Replace (void);
export void Edit_ReplaceAll (void);
export void Edit_Search (void);
export void Edit_Set (void);
static void Edit_SetCaret (TextFrames_Frame F, LONGINT pos);
static void Edit_SetReplBuf (void);
export void Edit_Show (void);
static void Edit_ShowAliens (Texts_Text t);
static void Edit_ShowPos (TextFrames_Frame F, LONGINT pos);
export void Edit_Store (void);
static void Edit_Str (CHAR *s, LONGINT s__len);
static void Edit_Subst (Texts_Text T, LONGINT beg, LONGINT *end);
static TextFrames_Frame Edit_TargetFrame (void);


static void Edit_Ch (CHAR ch)
{
	Texts_Write(&Edit_W, Texts_Writer__typ, ch);
	Texts_Append(Oberon_Log, Edit_W.buf);
}

static void Edit_Str (CHAR *s, LONGINT s__len)
{
	__DUP(s, s__len, CHAR);
	Texts_WriteString(&Edit_W, Texts_Writer__typ, s, s__len);
	Texts_Append(Oberon_Log, Edit_W.buf);
	__DEL(s);
}

static void Edit_Int (LONGINT n)
{
	Texts_Write(&Edit_W, Texts_Writer__typ, ' ');
	Texts_WriteInt(&Edit_W, Texts_Writer__typ, n, 0);
	Texts_Append(Oberon_Log, Edit_W.buf);
}

static void Edit_Ln (void)
{
	Texts_WriteLn(&Edit_W, Texts_Writer__typ);
	Texts_Append(Oberon_Log, Edit_W.buf);
}

static LONGINT Edit_Min (LONGINT x, LONGINT y)
{
	if (x < y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static void Edit_AppendNum (CHAR *s, LONGINT s__len, INTEGER *i, LONGINT n)
{
	INTEGER j = 0;
	CHAR digits[16];
	j = 0;
	do {
		digits[__X(j, 16)] = (CHAR)(__MOD(n, 10) + 48);
		j += 1;
		n = __DIV(n, 10);
	} while (!(n == 0));
	do {
		j -= 1;
		s[__X(*i, s__len)] = digits[__X(j, 16)];
		*i += 1;
	} while (!(j == 0));
	s[__X(*i, s__len)] = 0x00;
}

static void Edit_AppendDate (CHAR *s, LONGINT s__len)
{
	LONGINT time = 0, date = 0;
	INTEGER i = 0, j = 0, k = 0, m = 0;
	Oberon_GetClock(&time, &date);
	i = 0;
	while (s[__X(i, s__len)] != 0x00) {
		i += 1;
	}
	s[__X(i, s__len)] = ' ';
	s[__X(i + 1, s__len)] = ' ';
	s[__X(i + 2, s__len)] = ' ';
	s[__X(i + 3, s__len)] = '(';
	i += 4;
	Edit_AppendNum((void*)s, s__len, &i, __MASK(date, -32));
	s[__X(i, s__len)] = ' ';
	i += 1;
	m = (int)__MASK(__ASHR(date, 5), -16);
	k = m * 3;
	j = k - 3;
	do {
		s[__X(i, s__len)] = Edit_mnam[__X(j, 37)];
		i += 1;
		j += 1;
	} while (!(j == k));
	s[__X(i, s__len)] = ' ';
	i += 1;
	Edit_AppendNum((void*)s, s__len, &i, __MOD(__ASHR(date, 9), 100));
	s[__X(i, s__len)] = ')';
	s[__X(i + 1, s__len)] = 0x00;
}

static void Edit_ShowAliens (Texts_Text t)
{
	Texts_Reader R = {0};
	Texts_IdentifyMsg identify = {0};
	Texts_OpenReader(&R, Texts_Reader__typ, t, 0);
	Texts_ReadElem(&R, Texts_Reader__typ);
	while (!R.eot) {
		identify.mod[31] = 0x00;
		(*R.elem->handle)(R.elem, (void*)&identify, Texts_IdentifyMsg__typ);
		if (identify.mod[31] == 0x01) {
			Edit_Ln();
			Edit_Str((CHAR*)"pos", (LONGINT)4);
			Edit_Int(Texts_Pos(&R, Texts_Reader__typ) - 1);
			Edit_Str((CHAR*)"  unknown element allocator: ", (LONGINT)30);
			Edit_Str(identify.mod, 32);
			Edit_Ch('.');
			Edit_Str(identify.proc, 32);
		}
		Texts_ReadElem(&R, Texts_Reader__typ);
	}
	if (Edit_W.buf->len > 0) {
		Edit_Ln();
		Texts_Append(Oberon_Log, Edit_W.buf);
	}
}

static void Edit_ShowPos (TextFrames_Frame F, LONGINT pos)
{
	LONGINT beg = 0, end = 0, delta = 0;
	delta = 200;
	for (;;) {
		beg = F->org;
		end = TextFrames_Pos(F, F->X + F->W, F->Y);
		if (beg <= pos && pos < end || delta == 0) {
			break;
		}
		TextFrames_Show(F, pos - delta);
		delta = __ASHR(delta, 1);
	}
}

static void Edit_SetCaret (TextFrames_Frame F, LONGINT pos)
{
	Oberon_PassFocus(Viewers_This(F->X, F->Y));
	TextFrames_SetCaret(F, pos);
}

static TextFrames_Frame Edit_NewView (CHAR *name, LONGINT name__len, INTEGER class, Texts_Text T, LONGINT org)
{
	MenuViewers_Viewer V = NIL;
	TextFrames_Frame F = NIL, M = NIL;
	INTEGER i = 0, x = 0, y = 0;
	__DUP(name, name__len, CHAR);
	if (class == 2) {
		i = 0;
		while (name[__X(i, name__len)] != 0x00) {
			i += 1;
		}
		name[__X(i, name__len)] = '\"';
		i += 1;
		name[__X(i, name__len)] = 0x00;
		while (i >= 0) {
			name[__X(i + 1, name__len)] = name[__X(i, name__len)];
			i -= 1;
		}
		name[0] = '\"';
	}
	F = TextFrames_NewText(T, org);
	Oberon_AllocateUserViewer(Oberon_Mouse.X, &x, &y);
	M = TextFrames_NewMenu(name, name__len, (CHAR*)"^Edit.Menu.Text", (LONGINT)16);
	V = MenuViewers_New((void*)M, (void*)F, TextFrames_menuH, x, y);
	Edit_ShowPos(F, org);
	__DEL(name);
	return F;
}

static void Edit_Find (Texts_Text T, LONGINT beg, LONGINT *end)
{
	INTEGER i = 0, j = 0, b = 0, e = 0;
	CHAR ch = 0;
	CHAR ref[128];
	Texts_OpenReader(&Edit_R, Texts_Reader__typ, T, beg);
	Texts_Read(&Edit_R, Texts_Reader__typ, &ch);
	i = 0;
	ref[0] = ch;
	j = 0;
	b = 0;
	e = 1;
	while (!Edit_R.eot && (LONGINT)i < Edit_find.len) {
		if (Edit_find.buf[__X(i, 128)] == ch || Edit_find.buf[__X(i, 128)] == 0xff && (((ch < '0' || ch > '9' && ch < 'A') || ch > 'Z' && ch < 'a') || ch > 'z')) {
			i += 1;
			j = __MASK(j + 1, -128);
		} else {
			i = 0;
			b = __MASK(b + 1, -128);
			j = b;
		}
		if (j != e) {
			ch = ref[__X(j, 128)];
		} else {
			Texts_Read(&Edit_R, Texts_Reader__typ, &ch);
			ref[__X(j, 128)] = ch;
			e = __MASK(e + 1, -128);
			beg += 1;
		}
	}
	if ((LONGINT)i == Edit_find.len) {
		*end = beg;
	} else {
		*end = -1;
	}
}

static BOOLEAN Edit_Check (Texts_Text T, LONGINT beg)
{
	CHAR ch = 0;
	INTEGER i = 0;
	i = 0;
	if (beg >= 0 && Edit_find.len > 0) {
		Texts_OpenReader(&Edit_R, Texts_Reader__typ, T, beg);
		Texts_Read(&Edit_R, Texts_Reader__typ, &ch);
		while ((!Edit_R.eot && (LONGINT)i < Edit_find.len) && ch == Edit_find.buf[__X(i, 128)]) {
			Texts_Read(&Edit_R, Texts_Reader__typ, &ch);
			i += 1;
		}
	}
	return (LONGINT)i == Edit_find.len;
}

static void Edit_SetReplBuf (void)
{
	Texts_Text T = NIL;
	Texts_Buffer B = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Oberon_GetSelection(&T, &beg, &end, &time);
	if (time > Edit_repl.time) {
		Edit_repl.time = time;
		Texts_OpenBuf(Edit_repl.buf);
		Texts_Save(T, beg, end, Edit_repl.buf);
	}
}

static void Edit_Subst (Texts_Text T, LONGINT beg, LONGINT *end)
{
	Texts_Delete(T, beg, beg + Edit_find.len);
	*end = beg + Edit_repl.buf->len;
	if (Edit_repl.buf->len > 0) {
		Texts_Insert(T, beg, Edit_repl.buf);
		Texts_Save(T, beg, *end, Edit_repl.buf);
	}
}

static TextFrames_Frame Edit_MarkedFrame (void)
{
	Viewers_Viewer V = NIL;
	V = Oberon_MarkedViewer();
	if ((V != NIL && __ISP(V, MenuViewers_ViewerDesc, 2)) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
		return __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1);
	} else {
		return NIL;
	}
	__RETCHK;
}

static TextFrames_Frame Edit_FocusFrame (void)
{
	Viewers_Viewer V = NIL;
	Display_Frame f = NIL;
	V = Oberon_FocusViewer;
	if ((V != NIL && __ISP(V, MenuViewers_ViewerDesc, 2)) && V->dsc != NIL) {
		f = V->dsc->next;
		if (f != NIL && __ISP(f, TextFrames_FrameDesc, 1)) {
			return __GUARDP(f, TextFrames_FrameDesc, 1);
		} else {
			return NIL;
		}
	} else {
		return NIL;
	}
	__RETCHK;
}

static TextFrames_Frame Edit_TargetFrame (void)
{
	Display_Frame f = NIL;
	if (Oberon_Par->vwr->dsc == Oberon_Par->frame) {
		f = Oberon_Par->frame->next;
		if (f != NIL && __ISP(f, TextFrames_FrameDesc, 1)) {
			return __GUARDP(f, TextFrames_FrameDesc, 1);
		} else {
			return NIL;
		}
	} else {
		return Edit_FocusFrame();
	}
	__RETCHK;
}

static void Edit_GetMainArg (Texts_Scanner *S, LONGINT *S__typ, LONGINT *end)
{
	Texts_Text text = NIL;
	LONGINT beg = 0, time = 0;
	Texts_Scan(&*S, S__typ);
	*end = 2147483647;
	if ((*S).class == 6 && (*S).c == '^') {
		Oberon_GetSelection(&text, &beg, &*end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&*S, S__typ, text, beg);
			Texts_Scan(&*S, S__typ);
		}
	}
	if ((*S).line != 0) {
		(*S).class = 0;
	}
}

static void Edit_GetArg (Texts_Scanner *S, LONGINT *S__typ)
{
	TextFrames_Frame F = NIL;
	Texts_OpenScanner(&*S, S__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&*S, S__typ);
	if ((*S).class == 6 && (*S).c == '^') {
		F = __GUARDP(Oberon_Par->frame, TextFrames_FrameDesc, 1);
		if (F->hasSel) {
			Texts_OpenScanner(&*S, S__typ, F->text, F->selbeg.pos);
			Texts_Scan(&*S, S__typ);
			F->time = 0;
		}
	}
}

static void Edit_Change (SET sel)
{
	Texts_Scanner S = {0};
	Fonts_Font fnt = NIL;
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	SHORTINT col = 0, off = 0;
	Edit_GetArg(&S, Texts_Scanner__typ);
	Oberon_GetSelection(&text, &beg, &end, &time);
	if (time >= 0) {
		if (sel == 0x01 && S.class == 1) {
			fnt = Fonts_This(S.s, 256);
		} else if (((sel == 0x02 && S.class == 3) && 0 <= S.i) && S.i < 16) {
			col = (int)S.i;
		} else if (((sel == 0x04 && S.class == 3) && -128 <= S.i) && S.i < 128) {
			off = (int)S.i;
		} else {
			sel = 0x0;
		}
		if (sel != 0x0) {
			Texts_ChangeLooks(text, beg, end, sel, fnt, col, off);
		}
	}
}

void Edit_Locate (void)
{
	Texts_Scanner S = {0};
	TextFrames_Frame F = NIL;
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	F = Edit_MarkedFrame();
	Oberon_GetSelection(&text, &beg, &end, &time);
	if (time > 0) {
		Texts_OpenScanner(&S, Texts_Scanner__typ, text, beg);
		Texts_Scan(&S, Texts_Scanner__typ);
		while ((S.class != 3 && S.line == 0) && !S.eot) {
			Texts_Scan(&S, Texts_Scanner__typ);
		}
		if ((F != NIL && S.class == 3) && S.line == 0) {
			Edit_ShowPos(F, S.i);
			Edit_SetCaret(F, S.i);
		}
	}
}

void Edit_Search (void)
{
	TextFrames_Frame F = NIL;
	Texts_Text T = NIL;
	LONGINT i = 0, beg = 0, end = 0, time = 0;
	CHAR ch = 0;
	Oberon_GetSelection(&T, &beg, &end, &time);
	F = Edit_TargetFrame();
	if (time > Edit_find.time) {
		Edit_find.time = time;
		Edit_find.len = Edit_Min(end - beg, 128);
		Texts_OpenReader(&Edit_R, Texts_Reader__typ, T, beg);
		i = 0;
		do {
			Texts_Read(&Edit_R, Texts_Reader__typ, &Edit_find.buf[__X(i, 128)]);
			i += 1;
		} while (!(i == Edit_find.len));
	}
	if (F != NIL) {
		if (F->hasCar) {
			beg = F->carloc.pos;
		} else {
			beg = 0;
		}
		Edit_Find(F->text, beg, &end);
		if (end >= 0) {
			Edit_ShowPos(F, end);
			Edit_SetCaret(F, end);
		} else {
			TextFrames_RemoveCaret(F);
		}
		TextFrames_RemoveSelection(F);
	}
}

void Edit_Show (void)
{
	Texts_Scanner S = {0};
	Texts_Reader R = {0};
	TextFrames_Frame F = NIL;
	Texts_Text text = NIL;
	LONGINT i = 0, j = 0, beg = 0, end = 0, time = 0;
	CHAR ch = 0;
	CHAR name[24];
	text = Oberon_Par->text;
	beg = Oberon_Par->pos;
	end = Oberon_Par->text->len;
	time = Oberon_Time();
	Texts_OpenScanner(&S, Texts_Scanner__typ, text, beg);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 6 && S.c == '^' || S.line > 0) {
		Oberon_GetSelection(&text, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&S, Texts_Scanner__typ, text, beg);
			Texts_Scan(&S, Texts_Scanner__typ);
		}
	}
	if (time >= 0 && S.class == 1) {
		i = 0;
		while (S.s[__X(i, 256)] != 0x00 && S.s[__X(i, 256)] != '.') {
			name[__X(i, 24)] = S.s[__X(i, 256)];
			i += 1;
		}
		if (i < 20) {
			name[__X(i, 24)] = '.';
			name[__X(i + 1, 24)] = 'M';
			name[__X(i + 2, 24)] = 'o';
			name[__X(i + 3, 24)] = 'd';
			name[__X(i + 4, 24)] = 0x00;
			Edit_find.len = 0;
			j = i + 1;
			while (S.s[__X(j, 256)] != 0x00) {
				Edit_find.buf[__X(Edit_find.len, 128)] = S.s[__X(j, 256)];
				Edit_find.len += 1;
				j += 1;
			}
			Edit_find.buf[__X(Edit_find.len, 128)] = 0xff;
			Edit_find.len += 1;
			Edit_find.time = time;
			text = TextFrames_Text(name, 24);
			Edit_Find(text, 0, &end);
			if (end < 0) {
				end = 0;
			}
			F = Edit_NewView(name, 24, 1, text, end);
			if (end > 0) {
				Edit_SetCaret(F, end);
			}
		}
	}
}

void Edit_Recall (void)
{
	Texts_Buffer B = NIL;
	Oberon_CopyOverMsg copyover = {0};
	Texts_Recall(&B);
	if (B != NIL) {
		copyover.beg = 0;
		copyover.end = B->len;
		copyover.text = TextFrames_Text((CHAR*)"", (LONGINT)1);
		Texts_Append(copyover.text, B);
		(*Oberon_FocusViewer->handle)((void*)Oberon_FocusViewer, (void*)&copyover, Oberon_CopyOverMsg__typ);
	}
}

void Edit_ClearReplaceBuffer (void)
{
	Texts_OpenBuf(Edit_repl.buf);
}

void Edit_Replace (void)
{
	TextFrames_Frame F = NIL;
	Texts_Text T = NIL;
	LONGINT beg = 0, end = 0;
	F = Edit_TargetFrame();
	Edit_SetReplBuf();
	if (F != NIL && F->hasCar) {
		T = F->text;
		end = F->carloc.pos;
		beg = end - Edit_find.len;
		TextFrames_RemoveSelection(F);
		if (Edit_Check(T, beg)) {
			Edit_Subst(T, beg, &end);
		}
		Edit_Find(T, end, &beg);
		if (beg >= 0) {
			Edit_ShowPos(F, beg);
			Edit_SetCaret(F, beg);
		} else {
			TextFrames_RemoveCaret(F);
		}
	}
}

void Edit_ReplaceAll (void)
{
	TextFrames_Frame F = NIL;
	Texts_Text T = NIL;
	LONGINT beg = 0, end = 0;
	F = Edit_TargetFrame();
	Edit_SetReplBuf();
	if (F != NIL && F->hasCar) {
		T = F->text;
		end = F->carloc.pos;
		beg = end - Edit_find.len;
		TextFrames_RemoveSelection(F);
		if (Edit_Check(T, beg)) {
			Edit_Subst(T, beg, &end);
		}
		for (;;) {
			Edit_Find(T, end, &beg);
			if (beg < 0) {
				break;
			}
			Edit_Subst(T, beg - Edit_find.len, &end);
		}
	}
}

void Edit_ChangeFont (void)
{
	Edit_Change(0x01);
}

void Edit_ChangeColor (void)
{
	Edit_Change(0x02);
}

void Edit_ChangeOffset (void)
{
	Edit_Change(0x04);
}

void Edit_ChangeBackgroundColor (void)
{
	TextFrames_Frame F = NIL;
	MenuViewers_ModifyMsg m = {0};
	Texts_Scanner S = {0};
	INTEGER H = 0;
	F = Edit_MarkedFrame();
	if (F != NIL) {
		Edit_GetArg(&S, Texts_Scanner__typ);
		if (S.class == 3) {
			F->col = (int)S.i;
			m.id = 0;
			m.Y = F->Y;
			H = F->H;
			m.H = 0;
			(*F->handle)((void*)F, (void*)&m, MenuViewers_ModifyMsg__typ);
			m.H = H;
			(*F->handle)((void*)F, (void*)&m, MenuViewers_ModifyMsg__typ);
		}
	}
}

void Edit_InsertParc (void)
{
	Texts_CopyMsg copy = {0};
	TextFrames_InsertElemMsg insert = {0};
	(*TextFrames_defParc->handle)((void*)TextFrames_defParc, (void*)&copy, Texts_CopyMsg__typ);
	insert.e = copy.e;
	(*Oberon_FocusViewer->handle)((void*)Oberon_FocusViewer, (void*)&insert, TextFrames_InsertElemMsg__typ);
}

void Edit_Parcs (void)
{
	Texts_Scanner S = {0};
	Viewers_Viewer V = NIL;
	TextFrames_Frame F = NIL;
	TextFrames_UpdateMsg um = {0};
	LONGINT end = 0;
	Texts_Reader R = {0};
	if (Oberon_Par->frame != Oberon_Par->vwr->dsc) {
		Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
		Texts_Scan(&S, Texts_Scanner__typ);
		if ((S.class == 6 && S.line == 0) && S.c == '*') {
			V = Oberon_MarkedViewer();
		} else {
			V = NIL;
		}
	} else {
		V = Oberon_Par->vwr;
	}
	if ((V != NIL && __ISP(V, MenuViewers_ViewerDesc, 2)) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
		F = __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1);
		F->showsParcs = !F->showsParcs;
		Texts_OpenReader(&R, Texts_Reader__typ, F->text, F->org);
		Texts_ReadElem(&R, Texts_Reader__typ);
		end = TextFrames_Pos(F, F->X + F->W, F->Y);
		while ((Texts_Pos(&R, Texts_Reader__typ) <= end && R.elem != NIL) && !__ISP(R.elem, TextFrames_ParcDesc, 2)) {
			Texts_ReadElem(&R, Texts_Reader__typ);
		}
		if ((R.elem != NIL && __ISP(R.elem, TextFrames_ParcDesc, 2)) && Texts_Pos(&R, Texts_Reader__typ) <= end) {
			um.id = 0;
			um.text = F->text;
			um.end = end;
			um.beg = Texts_Pos(&R, Texts_Reader__typ) - 1;
			(*F->handle)((void*)F, (void*)&um, TextFrames_UpdateMsg__typ);
		}
	}
}

void Edit_Open (void)
{
	Texts_Scanner S = {0};
	TextFrames_Frame F = NIL;
	LONGINT end = 0;
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Edit_GetMainArg(&S, Texts_Scanner__typ, &end);
	if (S.class == 1 || S.class == 2) {
		F = Edit_NewView(S.s, 256, S.class, TextFrames_Text(S.s, 256), 0);
		Edit_ShowAliens(F->text);
	}
}

void Edit_Store (void)
{
	Texts_Scanner S = {0};
	Texts_Reader R = {0};
	Viewers_Viewer V = NIL;
	Texts_Text T = NIL;
	CHAR ch = 0;
	V = NIL;
	if (Oberon_Par->frame == Oberon_Par->vwr->dsc) {
		V = Oberon_Par->vwr;
	} else if (Oberon_Pointer.on) {
		V = Oberon_MarkedViewer();
	}
	if (((V != NIL && __ISP(V, MenuViewers_ViewerDesc, 2)) && __ISP(V->dsc, TextFrames_FrameDesc, 1)) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
		Texts_OpenScanner(&S, Texts_Scanner__typ, __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text, 0);
		Texts_Scan(&S, Texts_Scanner__typ);
		if (S.class == 1 || S.class == 2) {
			Edit_Str((CHAR*)"Edit.Store ", (LONGINT)12);
			Edit_Str(S.s, 256);
			T = __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1)->text;
			Texts_Close(T, S.s, 256);
			Edit_Int(T->len);
			Edit_Ln();
			T = __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text;
			Texts_OpenReader(&R, Texts_Reader__typ, T, T->len - 1);
			Texts_Read(&R, Texts_Reader__typ, &ch);
			if (ch == '!') {
				Texts_Delete(T, T->len - 1, T->len);
			}
		}
	}
}

void Edit_Set (void)
{
	Texts_Scanner S = {0};
	Texts_Reader R = {0};
	Texts_Text text = NIL;
	TextFrames_Parc P = NIL;
	ParcElems_StateMsg msg = {0};
	LONGINT pos = 0, beg = 0, end = 0, time = 0;
	Edit_GetArg(&S, Texts_Scanner__typ);
	Oberon_GetSelection(&text, &beg, &end, &time);
	if (time >= 0) {
		Texts_OpenReader(&R, Texts_Reader__typ, text, beg);
		do {
			Texts_ReadElem(&R, Texts_Reader__typ);
			pos = Texts_Pos(&R, Texts_Reader__typ);
			if ((!R.eot && pos <= end) && __ISP(R.elem, TextFrames_ParcDesc, 2)) {
				msg.id = 0;
				msg.pos = pos - 1;
				msg.frame = NIL;
				msg.par = S;
				msg.log = Oberon_Log;
				P = __GUARDP(R.elem, TextFrames_ParcDesc, 2);
				(*P->handle)((void*)P, (void*)&msg, ParcElems_StateMsg__typ);
			}
		} while (!(R.eot || pos > end));
	} else {
		Edit_Str((CHAR*)"Edit.Set failed (no parc selected)", (LONGINT)35);
		Edit_Ln();
	}
}

void Edit_Get (void)
{
	Texts_Scanner S = {0};
	Texts_Reader R = {0};
	Texts_Text text = NIL;
	TextFrames_Parc P = NIL;
	LONGINT pos = 0, beg = 0, end = 0, time = 0;
	ParcElems_StateMsg msg = {0};
	Edit_GetArg(&S, Texts_Scanner__typ);
	Oberon_GetSelection(&text, &beg, &end, &time);
	if (time >= 0) {
		Texts_OpenReader(&R, Texts_Reader__typ, text, beg);
		Texts_ReadElem(&R, Texts_Reader__typ);
		pos = Texts_Pos(&R, Texts_Reader__typ);
		if ((!R.eot && pos <= end) && __ISP(R.elem, TextFrames_ParcDesc, 2)) {
			Edit_Str((CHAR*)"Edit.Set ^ ", (LONGINT)12);
			msg.id = 1;
			msg.pos = pos - 1;
			msg.frame = NIL;
			msg.par = S;
			msg.log = Oberon_Log;
			P = __GUARDP(R.elem, TextFrames_ParcDesc, 2);
			(*P->handle)((void*)P, (void*)&msg, ParcElems_StateMsg__typ);
		} else {
			Edit_Str((CHAR*)"Edit.Get failed (no parc selected)", (LONGINT)35);
		}
	} else {
		Edit_Str((CHAR*)"Edit.Get failed (no parc selected)", (LONGINT)35);
	}
	Edit_Ln();
}

static struct Print__25 {
	struct Print__25 *lnk;
} *Print__25_s;

static void PrintText__26 (Texts_Scanner *S, LONGINT *S__typ, Texts_Text T, CHAR *name, LONGINT name__len, BOOLEAN draft);

static void PrintText__26 (Texts_Scanner *S, LONGINT *S__typ, Texts_Text T, CHAR *name, LONGINT name__len, BOOLEAN draft)
{
	LONGINT pos = 0, len = 0;
	CHAR ch = 0;
	INTEGER hx = 0, hy = 0, hw = 0, bx = 0, by = 0, bw = 0, bh = 0, i = 0, k = 0, nofcopies = 0, pno = 0, first = 0, last = 0, arab = 0, intervall = 0;
	Fonts_Font fnt = NIL;
	BOOLEAN label = 0, labelfirst = 0, alt = 0, intvl = 0;
	CHAR header[128];
	__DUP(name, name__len, CHAR);
	hx = 236;
	hw = 1948;
	hy = (int)__DIV((LONGINT)Printer_PageHeight * 3048 - 360000, 3048);
	bx = 236;
	by = 236;
	bw = 1948;
	bh = (int)__DIV((LONGINT)Printer_PageHeight * 3048 - 1332000, 3048);
	nofcopies = 1;
	pno = 0;
	first = 0;
	last = 10000;
	arab = 1;
	label = 1;
	labelfirst = 1;
	alt = 0;
	header[0] = 0x00;
	fnt = Fonts_Default;
	intervall = 0;
	Texts_Scan(&*S, S__typ);
	while ((*S).class == 6 && (*S).c == '\\') {
		Texts_Scan(&*S, S__typ);
		if ((*S).class == 1) {
			ch = __CAP((*S).s[0]);
			if (ch != 'H') {
				Texts_Scan(&*S, S__typ);
			}
			if (ch == 'A') {
				alt = 1;
			} else if (((ch == 'C' && (*S).class == 3) && 1 <= (*S).i) && (*S).i < 10) {
				nofcopies = (int)(*S).i;
				Texts_Scan(&*S, S__typ);
			} else if (ch == 'F' && (*S).class == 1) {
				fnt = Fonts_This((*S).s, 256);
				Texts_Scan(&*S, S__typ);
			} else if (ch == 'H') {
				do {
					Texts_Read((void*)&*S, S__typ, &ch);
				} while (!(ch > ' ' || (*S).eot));
				if (ch == '\"') {
					i = 0;
					do {
						Texts_Read((void*)&*S, S__typ, &ch);
						header[__X(i, 128)] = ch;
						i += 1;
					} while (!(ch == '\"' || ch == 0x0d));
					header[__X(i - 1, 128)] = 0x00;
					Texts_Read((void*)&*S, S__typ, &ch);
				} else {
					__COPY(name, header, 128);
					Edit_AppendDate((void*)header, 128);
				}
				(*S).nextCh = ch;
				Texts_Scan(&*S, S__typ);
			} else if (ch == 'I') {
				if ((*S).class == 3) {
					intervall = (int)(*S).i;
					Texts_Scan(&*S, S__typ);
				}
			} else if (ch == 'M') {
				if ((*S).class == 1) {
					ch = __CAP((*S).s[0]);
					Texts_Scan(&*S, S__typ);
					i = 0;
					while ((*S).class == 3 && 0 <= (*S).i) {
						k = (int)__DIV((*S).i * 3600, 3048);
						i += 1;
						Texts_Scan(&*S, S__typ);
						if (ch == 'H') {
							if (i == 1) {
								hx = k;
							} else if (i == 2) {
								hy = k;
							} else if (i == 3) {
								hw = k;
							}
						} else if (ch == 'B') {
							if (i == 1) {
								bx = k;
							} else if (i == 2) {
								by = k;
							} else if (i == 3) {
								bw = k;
							} else if (i == 4) {
								bh = k;
							}
						}
					}
				}
			} else if (ch == 'P') {
				if ((*S).class == 3) {
					pno = (int)(*S).i;
					first = pno;
					Texts_Scan(&*S, S__typ);
				} else if ((*S).class == 1) {
					ch = __CAP((*S).s[0]);
					Texts_Scan(&*S, S__typ);
					if (ch == 'F') {
						labelfirst = 0;
					} else if (ch == 'N') {
						label = 0;
					} else if (ch == 'R') {
						arab = -1;
						if (first == 0) {
							pno = 1;
							first = 1;
						}
					}
				}
			} else if ((ch == 'S' && (*S).class == 3) && 0 <= (*S).i) {
				first = (int)(*S).i;
				Texts_Scan(&*S, S__typ);
				if ((*S).class == 3 && 0 <= (*S).i) {
					last = (int)(*S).i;
					Texts_Scan(&*S, S__typ);
				} else {
					last = first;
				}
			}
		}
	}
	Edit_Ch(' ');
	Edit_Str(name, name__len);
	Edit_Int(nofcopies);
	Edit_Ch(' ');
	if (draft) {
		TextPrinter_PrintDraft(T, name, name__len, nofcopies);
	} else {
		pos = 0;
		len = T->len;
		while ((pos < len && pno <= last) && Printer_res == 0) {
			intvl = (intervall == 0 || intervall == 1 && __IN(__MASK(pno, -4), 0x03)) || intervall == 2 && __IN(__MASK(pno, -4), 0x0c);
			if (((first <= pno && label) && labelfirst) && intvl) {
				TextPrinter_PlaceHeader(hx, hy, hw, arab * pno, fnt, (void*)header, 128, alt);
			}
			TextPrinter_PlaceBody(bx, by, bw, bh, T, &pos, pno, (first <= pno && pno <= last) && intvl);
			if (first <= pno && intvl) {
				Printer_Page(nofcopies);
				Edit_Ch('.');
			} else {
				Edit_Ch('\'');
			}
			pno += 1;
			labelfirst = 1;
		}
	}
	Edit_Ln();
	__DEL(name);
}

void Edit_Print (void)
{
	Texts_Scanner S = {0}, S1 = {0};
	Viewers_Viewer V = NIL;
	TextFrames_Frame F = NIL;
	LONGINT end = 0;
	BOOLEAN draft = 0;
	struct Print__25 _s;
	_s.lnk = Print__25_s;
	Print__25_s = &_s;
	Edit_Str((CHAR*)"Edit.Print ", (LONGINT)12);
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if ((S.class == 1 || S.class == 2) && S.line == 0) {
		Edit_Str(S.s, 256);
		Printer_Open((void*)S.s, 256, (void*)Oberon_User, 12, Oberon_Password);
		TextPrinter_InitFonts();
		if (Printer_res == 0) {
			Edit_GetMainArg(&S, Texts_Scanner__typ, &end);
			if (S.class == 6 && S.c == '%') {
				draft = 1;
				Texts_Scan(&S, Texts_Scanner__typ);
			} else {
				draft = 0;
			}
			if (Oberon_Par->frame == Oberon_Par->vwr->dsc) {
				F = __GUARDP(Oberon_Par->frame, TextFrames_FrameDesc, 1);
				if (F->next != NIL && __ISP(F->next, TextFrames_FrameDesc, 1)) {
					Texts_OpenScanner(&S1, Texts_Scanner__typ, F->text, 0);
					Texts_Scan(&S1, Texts_Scanner__typ);
					PrintText__26(&S, Texts_Scanner__typ, __GUARDP(F->next, TextFrames_FrameDesc, 1)->text, S1.s, 256, draft);
				}
			} else if (S.class == 6 && S.c == '*') {
				V = Oberon_MarkedViewer();
				if (__ISP(V, MenuViewers_ViewerDesc, 2) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
					Texts_OpenScanner(&S1, Texts_Scanner__typ, __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text, 0);
					Texts_Scan(&S1, Texts_Scanner__typ);
					if (S1.class != 1) {
						S1.s[0] = '*';
						S1.s[1] = 0x00;
					}
					PrintText__26(&S, Texts_Scanner__typ, __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1)->text, S1.s, 256, draft);
				} else {
					Edit_Str((CHAR*)" failed (bad * marker)", (LONGINT)23);
					Edit_Ln();
				}
			} else if (S.class == 1) {
				do {
					PrintText__26(&S, Texts_Scanner__typ, TextFrames_Text(S.s, 256), S.s, 256, draft);
				} while (!((S.eot || S.class != 1) || Texts_Pos((void*)&S, Texts_Scanner__typ) > end));
			} else {
				Edit_Ln();
			}
			Printer_Close();
		} else {
			Edit_Str((CHAR*)" failed (", (LONGINT)10);
			if (Printer_res == 1) {
				Edit_Str((CHAR*)"no such printer)", (LONGINT)17);
			} else if (Printer_res == 2) {
				Edit_Str((CHAR*)"no link)", (LONGINT)9);
			} else if (Printer_res == 3) {
				Edit_Str((CHAR*)"printer not ready)", (LONGINT)19);
			} else if (Printer_res == 4) {
				Edit_Str((CHAR*)"no permission)", (LONGINT)15);
			} else {
				Edit_Str((CHAR*)"res =", (LONGINT)6);
				Edit_Int(Printer_res);
				Edit_Str((CHAR*)" \?)", (LONGINT)4);
			}
			Edit_Ln();
		}
	} else {
		Edit_Str((CHAR*)"failed (no printer specified)", (LONGINT)30);
		Edit_Ln();
	}
	Print__25_s = _s.lnk;
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&Edit_R, Texts_Reader__typ, 48, 1, P);
	__ENUMR(&Edit_W, Texts_Writer__typ, 36, 1, P);
	__ENUMR(&Edit_repl, Edit__2__typ, 8, 1, P);
}

__TDESC(Edit__1, 1, 0) = {__TDFLDS("", 136), {-4}};
__TDESC(Edit__2, 1, 1) = {__TDFLDS("", 8), {4, -8}};

export void *Edit__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(MenuViewers);
	__IMPORT(Modules);
	__IMPORT(Oberon);
	__IMPORT(ParcElems);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(Edit, EnumPtrs);
	__REGCMD("ChangeBackgroundColor", Edit_ChangeBackgroundColor);
	__REGCMD("ChangeColor", Edit_ChangeColor);
	__REGCMD("ChangeFont", Edit_ChangeFont);
	__REGCMD("ChangeOffset", Edit_ChangeOffset);
	__REGCMD("ClearReplaceBuffer", Edit_ClearReplaceBuffer);
	__REGCMD("Get", Edit_Get);
	__REGCMD("InsertParc", Edit_InsertParc);
	__REGCMD("Locate", Edit_Locate);
	__REGCMD("Open", Edit_Open);
	__REGCMD("Parcs", Edit_Parcs);
	__REGCMD("Print", Edit_Print);
	__REGCMD("Recall", Edit_Recall);
	__REGCMD("Replace", Edit_Replace);
	__REGCMD("ReplaceAll", Edit_ReplaceAll);
	__REGCMD("Search", Edit_Search);
	__REGCMD("Set", Edit_Set);
	__REGCMD("Show", Edit_Show);
	__REGCMD("Store", Edit_Store);
	__INITYP(Edit__1, Edit__1, 0);
	__INITYP(Edit__2, Edit__2, 0);
/* BEGIN */
	Texts_OpenWriter(&Edit_W, Texts_Writer__typ);
	__MOVE("JanFebMarAprMayJunJulAugSepOctNovDec", Edit_mnam, 37);
	Edit_find.time = -1;
	Edit_find.len = 0;
	Edit_repl.time = -1;
	__NEW(Edit_repl.buf, Texts_BufDesc);
	Texts_OpenBuf(Edit_repl.buf);
	__ENDMOD;
}
