/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "HandlerElems.h"
#include "Input.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

struct EditKeys__1 {
	SET set;
	LONGINT pos, caret;
	TextFrames_Frame frame;
	Fonts_Font def, fnt;
	SHORTINT voff;
};

typedef
	struct EditKeys_DefinitionDesc *EditKeys_Definition;

typedef
	CHAR EditKeys_Ident[32];

typedef
	struct EditKeys_SequenceDesc *EditKeys_Sequence;

typedef
	struct EditKeys_DefinitionDesc {
		EditKeys_Definition left, right;
		BOOLEAN in;
		EditKeys_Ident trig;
		EditKeys_Sequence seq;
	} EditKeys_DefinitionDesc;

typedef
	struct EditKeys_SequenceDesc {
		EditKeys_Sequence next;
		INTEGER sym;
		CHAR cmd;
		EditKeys_Definition def;
		Texts_Buffer stretch;
	} EditKeys_SequenceDesc;


static EditKeys_Definition EditKeys_defs, EditKeys_dmy;
static CHAR EditKeys_ch, EditKeys_cmd, EditKeys_hotKey;
static INTEGER EditKeys_sym, EditKeys_errs;
static LONGINT EditKeys_errpos;
static EditKeys_Ident EditKeys_name, EditKeys_trig;
static Texts_Buffer EditKeys_stretch, EditKeys_buf, EditKeys_indent;
static Texts_Text EditKeys_T;
static Texts_Reader EditKeys_R;
static Texts_Writer EditKeys_W, EditKeys_WB, EditKeys_WL;
static CHAR EditKeys_map[17];
static struct EditKeys__1 EditKeys_preset;
static Display_Handler EditKeys_SuperHandler;

export LONGINT *EditKeys_DefinitionDesc__typ;
export LONGINT *EditKeys_SequenceDesc__typ;
export LONGINT *EditKeys__1__typ;

static void EditKeys_Append (Texts_Buffer SB, Texts_Buffer DB);
static void EditKeys_Ch (CHAR ch);
static void EditKeys_Char (CHAR ch);
static void EditKeys_CharCode (void);
static void EditKeys_Comment (void);
export void EditKeys_Definitions (void);
static void EditKeys_Delete (TextFrames_Frame frame, LONGINT beg, LONGINT end);
static void EditKeys_Err (EditKeys_Definition def, CHAR *s, LONGINT s__len);
static void EditKeys_Expand (EditKeys_Definition def, EditKeys_Sequence *stack, EditKeys_Sequence *args, EditKeys_Sequence *params);
static EditKeys_Definition EditKeys_Find (EditKeys_Ident name, EditKeys_Ident trig, BOOLEAN insert);
static void EditKeys_Flip (CHAR *src, LONGINT src__len, CHAR *dst, LONGINT dst__len);
static void EditKeys_FlipStr (CHAR *s, LONGINT s__len);
static void EditKeys_Gap (void);
static void EditKeys_GetArguments (Texts_Text text, LONGINT pos, LONGINT *pin, EditKeys_Sequence *args);
static void EditKeys_GetCh (void);
export void EditKeys_GetKeyCode (void);
static void EditKeys_GetSym (void);
export void EditKeys_Handle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
static void EditKeys_InitialExec (EditKeys_Ident name);
static void EditKeys_Insert (TextFrames_Frame frame, Texts_Buffer buf);
export void EditKeys_Install (void);
static void EditKeys_Key (TextFrames_Frame frame, CHAR ch, BOOLEAN *handled);
static void EditKeys_Ln (void);
static void EditKeys_Mark (CHAR *err, LONGINT err__len);
static void EditKeys_Name (void);
static void EditKeys_ParseText (void);
static void EditKeys_PopArg (EditKeys_Definition def, SHORTINT class, Texts_Scanner *S, LONGINT *S__typ, EditKeys_Sequence *stack);
static void EditKeys_Process (TextFrames_Frame frame, LONGINT *del);
static void EditKeys_PushArg (Texts_Buffer buf, EditKeys_Sequence *stack);
export void EditKeys_Read (void);
static void EditKeys_ReadText (CHAR *name, LONGINT name__len, LONGINT beg);
export void EditKeys_Reset (void);
static void EditKeys_ResetDefs (void);
static void EditKeys_Save (Texts_Text text, LONGINT beg, LONGINT end, Texts_Buffer buf);
static void EditKeys_Str (CHAR *s, LONGINT s__len);
static void EditKeys_Stretch (void);
static EditKeys_Sequence EditKeys_ThisArg (LONGINT n, EditKeys_Sequence args);
static EditKeys_Definition EditKeys_Trigger (EditKeys_Ident trig);
static void EditKeys_WLog (void);


static void EditKeys_Flip (CHAR *src, LONGINT src__len, CHAR *dst, LONGINT dst__len)
{
	INTEGER i = 0, j = 0;
	i = -1;
	j = 0;
	do {
		i += 1;
	} while (!(src[__X(i, src__len)] == 0x00));
	while (i > 0) {
		i -= 1;
		dst[__X(j, dst__len)] = src[__X(i, src__len)];
		j += 1;
	}
	dst[__X(j, dst__len)] = 0x00;
}

static void EditKeys_WLog (void)
{
	Texts_Append(Oberon_Log, EditKeys_W.buf);
}

static void EditKeys_Ch (CHAR ch)
{
	Texts_Write(&EditKeys_W, Texts_Writer__typ, ch);
}

static void EditKeys_Str (CHAR *s, LONGINT s__len)
{
	__DUP(s, s__len, CHAR);
	Texts_WriteString(&EditKeys_W, Texts_Writer__typ, s, s__len);
	__DEL(s);
}

static void EditKeys_FlipStr (CHAR *s, LONGINT s__len)
{
	EditKeys_Ident n;
	__DUP(s, s__len, CHAR);
	EditKeys_Flip((void*)s, s__len, (void*)n, 32);
	EditKeys_Str(n, 32);
	__DEL(s);
}

static void EditKeys_Gap (void)
{
	EditKeys_Str((CHAR*)"  ", (LONGINT)3);
}

static void EditKeys_Ln (void)
{
	Texts_WriteLn(&EditKeys_W, Texts_Writer__typ);
}

static void EditKeys_Char (CHAR ch)
{
	LONGINT pat = 0;
	INTEGER i = 0, n = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	CHAR d[3];
	Display_GetChar(EditKeys_W.fnt->raster, ch, &dx, &x, &y, &w, &h, &pat);
	if (h > 0) {
		EditKeys_Ch(ch);
		EditKeys_Str((CHAR*)" (* ", (LONGINT)5);
	}
	EditKeys_Ch('#');
	i = 0;
	n = (int)ch;
	do {
		d[__X(i, 3)] = EditKeys_map[__X((int)__MOD(n, 10), 17)];
		n = __DIV(n, 10);
		i += 1;
	} while (!(n == 0));
	while (i > 0) {
		i -= 1;
		EditKeys_Ch(d[__X(i, 3)]);
	}
	if (h == 0) {
		EditKeys_Str((CHAR*)" (* ", (LONGINT)5);
	} else {
		EditKeys_Str((CHAR*)", ", (LONGINT)3);
	}
	EditKeys_Ch('0');
	i = 0;
	n = (int)ch;
	do {
		d[__X(i, 3)] = EditKeys_map[__X(__MASK(n, -16), 17)];
		n = __ASHR(n, 4);
		i += 1;
	} while (!(n == 0));
	while (i > 0) {
		i -= 1;
		EditKeys_Ch(d[__X(i, 3)]);
	}
	EditKeys_Str((CHAR*)"X *)", (LONGINT)5);
}

static void EditKeys_Append (Texts_Buffer SB, Texts_Buffer DB)
{
	Texts_Copy(SB, DB);
	Texts_OpenBuf(SB);
}

static EditKeys_Definition EditKeys_Find (EditKeys_Ident name, EditKeys_Ident trig, BOOLEAN insert)
{
	EditKeys_Definition p = NIL, q = NIL, d = NIL, x = NIL;
	INTEGER i = 0;
	EditKeys_Flip((void*)name, 32, (void*)trig, 32);
	p = EditKeys_defs;
	d = p->right;
	q = NIL;
	x = NIL;
	while (d != NIL) {
		i = 0;
		while (trig[__X(i, 32)] != 0x00 && trig[__X(i, 32)] == d->trig[__X(i, 32)]) {
			i += 1;
		}
		if (trig[__X(i, 32)] == d->trig[__X(i, 32)]) {
			x = d;
			d = NIL;
		} else if (trig[__X(i, 32)] == 0x00) {
			q = d;
			d = NIL;
		} else if (trig[__X(i, 32)] < d->trig[__X(i, 32)]) {
			p = d;
			d = d->left;
		} else {
			p = d;
			d = d->right;
		}
	}
	if (insert && x != NIL) {
		EditKeys_Str(name, 32);
		EditKeys_Str((CHAR*)" already defined", (LONGINT)17);
		EditKeys_Ln();
		EditKeys_WLog();
	}
	if (insert && x == NIL) {
		__NEW(x, EditKeys_DefinitionDesc);
		x->right = q;
		x->in = 0;
		__MOVE(trig, x->trig, 32);
		if (__STRCMP(trig, p->trig) < 0) {
			p->left = x;
		} else {
			p->right = x;
		}
		if (q != NIL) {
			EditKeys_dmy->right = NIL;
			p = EditKeys_dmy;
			while (q->left != NIL) {
				while (q->left != NIL && __STRCMP(q->left->trig, trig) > 0) {
					q = q->left;
				}
				while (q->left != NIL && __STRCMP(q->left->trig, trig) < 0) {
					p->right = q->left;
					p = p->right;
					q->left = p->right;
					p->right = NIL;
				}
			}
			x->left = EditKeys_dmy->right;
		}
	}
	return x;
}

static void EditKeys_ResetDefs (void)
{
	EditKeys_Definition def = NIL;
	EditKeys_Sequence seq = NIL;
	EditKeys_defs->right = NIL;
	EditKeys_defs->trig[0] = 0x00;
	EditKeys_hotKey = '\\';
	__MOVE("OTHERWISE", EditKeys_name, 10);
	def = EditKeys_Find(EditKeys_name, EditKeys_trig, 1);
	__NEW(def->seq, EditKeys_SequenceDesc);
	seq = def->seq;
	seq->sym = 0;
	seq->cmd = '6';
	__NEW(seq->next, EditKeys_SequenceDesc);
	seq = seq->next;
	Texts_OpenBuf(EditKeys_WB.buf);
	Texts_Write(&EditKeys_WB, Texts_Writer__typ, '\\');
	seq->sym = 2;
	seq->stretch = EditKeys_WB.buf;
	__NEW(EditKeys_WB.buf, Texts_BufDesc);
	Texts_OpenBuf(EditKeys_WB.buf);
	__NEW(seq->next, EditKeys_SequenceDesc);
	seq = seq->next;
	seq->sym = 0;
	seq->cmd = '0';
}

static EditKeys_Definition EditKeys_Trigger (EditKeys_Ident trig)
{
	EditKeys_Definition d = NIL, x = NIL;
	INTEGER i = 0;
	d = EditKeys_defs->right;
	x = NIL;
	while (d != NIL) {
		i = 0;
		while (trig[__X(i, 32)] != 0x00 && trig[__X(i, 32)] == d->trig[__X(i, 32)]) {
			i += 1;
		}
		if (trig[__X(i, 32)] == d->trig[__X(i, 32)]) {
			return d;
		}
		if (d->trig[__X(i, 32)] == 0x00) {
			x = d;
		}
		if (trig[__X(i, 32)] < d->trig[__X(i, 32)]) {
			d = d->left;
		} else {
			d = d->right;
		}
	}
	return x;
}

static void EditKeys_Mark (CHAR *err, LONGINT err__len)
{
	__DUP(err, err__len, CHAR);
	EditKeys_errs += 1;
	if (Texts_Pos(&EditKeys_R, Texts_Reader__typ) - EditKeys_errpos > 9) {
		EditKeys_errpos = Texts_Pos(&EditKeys_R, Texts_Reader__typ);
		EditKeys_Ln();
		EditKeys_Str((CHAR*)"  pos  ", (LONGINT)8);
		Texts_WriteInt(&EditKeys_W, Texts_Writer__typ, EditKeys_errpos, 0);
		EditKeys_Gap();
		EditKeys_Str(err, err__len);
		EditKeys_WLog();
	}
	__DEL(err);
}

static void EditKeys_GetCh (void)
{
	Texts_Read(&EditKeys_R, Texts_Reader__typ, &EditKeys_ch);
}

static void EditKeys_CharCode (void)
{
	INTEGER c = 0;
	c = 0;
	while ('0' <= EditKeys_ch && EditKeys_ch <= '9') {
		c = c * 10 + (int)((int)((int)EditKeys_ch - 48));
		EditKeys_GetCh();
	}
	EditKeys_name[0] = (CHAR)c;
	EditKeys_name[1] = 0x00;
}

static void EditKeys_Name (void)
{
	INTEGER i = 0;
	i = 0;
	do {
		EditKeys_name[__X(i, 32)] = EditKeys_ch;
		i += 1;
		EditKeys_GetCh();
	} while (!((((EditKeys_ch <= ' ' || EditKeys_ch == '(') || EditKeys_ch == ')') || EditKeys_R.eot) || i == 31));
	if (!(((EditKeys_ch <= ' ' || EditKeys_ch == '(') || EditKeys_ch == ')') || EditKeys_R.eot)) {
		EditKeys_Mark((CHAR*)"name too long", (LONGINT)14);
	}
	EditKeys_name[__X(i, 32)] = 0x00;
}

static void EditKeys_Save (Texts_Text text, LONGINT beg, LONGINT end, Texts_Buffer buf)
{
	if (end > beg) {
		Texts_Save(text, beg, end, buf);
	}
}

static void EditKeys_Stretch (void)
{
	LONGINT beg = 0, end = 0;
	beg = Texts_Pos(&EditKeys_R, Texts_Reader__typ);
	end = beg;
	EditKeys_GetCh();
	while (!EditKeys_R.eot && EditKeys_ch != '\"') {
		end += 1;
		EditKeys_GetCh();
	}
	if (EditKeys_ch == '\"') {
		EditKeys_GetCh();
		if (end > beg) {
			__NEW(EditKeys_stretch, Texts_BufDesc);
			Texts_OpenBuf(EditKeys_stretch);
			EditKeys_Save(EditKeys_T, beg, end, EditKeys_stretch);
		} else {
			EditKeys_Mark((CHAR*)"empty stretch", (LONGINT)14);
		}
	} else {
		EditKeys_Mark((CHAR*)"Closing quote expected", (LONGINT)23);
	}
}

static void EditKeys_Comment (void)
{
	for (;;) {
		if (EditKeys_ch == '(') {
			EditKeys_GetCh();
			if (EditKeys_ch == '*') {
				EditKeys_GetCh();
				EditKeys_Comment();
			}
		} else if (EditKeys_ch == '*') {
			EditKeys_GetCh();
			if (EditKeys_ch == ')') {
				EditKeys_GetCh();
				break;
			}
		} else {
			EditKeys_GetCh();
		}
	}
}

static void EditKeys_GetSym (void)
{
	EditKeys_sym = 6;
	do {
		if (0x00 <= EditKeys_ch && EditKeys_ch <= ' ') {
			EditKeys_GetCh();
		} else if (EditKeys_ch == '\"') {
			EditKeys_sym = 2;
			EditKeys_Stretch();
		} else if (EditKeys_ch == '#') {
			EditKeys_sym = 1;
			EditKeys_GetCh();
			EditKeys_CharCode();
		} else if (EditKeys_ch == '(') {
			EditKeys_GetCh();
			if (EditKeys_ch == '*') {
				EditKeys_GetCh();
				EditKeys_Comment();
			} else {
				EditKeys_sym = 3;
			}
		} else if (EditKeys_ch == ')') {
			EditKeys_sym = 4;
			EditKeys_GetCh();
		} else if (EditKeys_ch == '\\') {
			EditKeys_sym = 5;
			EditKeys_GetCh();
		} else if (EditKeys_ch == '^') {
			EditKeys_sym = 0;
			EditKeys_GetCh();
			EditKeys_cmd = EditKeys_ch;
			EditKeys_GetCh();
		} else {
			EditKeys_sym = 1;
			EditKeys_Name();
		}
	} while (!(EditKeys_sym != 6 || EditKeys_R.eot));
}

static void EditKeys_ParseText (void)
{
	EditKeys_Definition def = NIL;
	EditKeys_Sequence beg = NIL, seq = NIL;
	EditKeys_GetSym();
	if (EditKeys_sym == 5) {
		EditKeys_GetSym();
		if (EditKeys_sym == 1) {
			EditKeys_hotKey = EditKeys_name[0];
			EditKeys_GetSym();
		} else {
			EditKeys_Mark((CHAR*)"hot-key code expected", (LONGINT)22);
		}
	}
	while (EditKeys_sym == 1) {
		EditKeys_GetSym();
		def = EditKeys_Find(EditKeys_name, EditKeys_trig, 1);
		if (EditKeys_sym == 3) {
			EditKeys_GetSym();
			__NEW(beg, EditKeys_SequenceDesc);
			seq = beg;
			beg->next = NIL;
			while (__IN(EditKeys_sym, 0x07)) {
				__NEW(seq->next, EditKeys_SequenceDesc);
				seq = seq->next;
				seq->sym = EditKeys_sym;
				if (EditKeys_sym == 0) {
					seq->cmd = EditKeys_cmd;
				} else if (EditKeys_sym == 1) {
					seq->def = EditKeys_Find(EditKeys_name, EditKeys_trig, 0);
					if (seq->def == NIL) {
						EditKeys_Mark((CHAR*)"illegal forward reference", (LONGINT)26);
					}
				} else {
					seq->stretch = EditKeys_stretch;
				}
				EditKeys_GetSym();
			}
			def->seq = beg->next;
			if (EditKeys_sym == 4) {
				EditKeys_GetSym();
			} else {
				EditKeys_Mark((CHAR*)") expected", (LONGINT)11);
			}
		} else {
			EditKeys_Mark((CHAR*)"( expected", (LONGINT)11);
		}
	}
	if (EditKeys_sym != 6) {
		EditKeys_GetSym();
		if (EditKeys_sym != 6) {
			EditKeys_Mark((CHAR*)"unexpected trailing char.s", (LONGINT)27);
		}
	}
	EditKeys_stretch = NIL;
}

static void EditKeys_ReadText (CHAR *name, LONGINT name__len, LONGINT beg)
{
	__DUP(name, name__len, CHAR);
	Texts_OpenReader(&EditKeys_R, Texts_Reader__typ, EditKeys_T, beg);
	EditKeys_GetCh();
	if (!EditKeys_R.eot) {
		EditKeys_Str((CHAR*)"  reading ", (LONGINT)11);
		EditKeys_Str(name, name__len);
		EditKeys_WLog();
		EditKeys_errs = 0;
		EditKeys_errpos = -10;
		EditKeys_ParseText();
		if (EditKeys_errs == 0) {
			EditKeys_Str((CHAR*)" done", (LONGINT)6);
		} else {
			EditKeys_ResetDefs();
		}
		EditKeys_Ln();
		EditKeys_WLog();
	}
	__DEL(name);
}

static void EditKeys_Insert (TextFrames_Frame frame, Texts_Buffer buf)
{
	LONGINT pos = 0, len = 0;
	pos = frame->carloc.pos;
	len = buf->len;
	Texts_Insert(frame->text, pos, buf);
	TextFrames_SetCaret(frame, pos + len);
}

static void EditKeys_Delete (TextFrames_Frame frame, LONGINT beg, LONGINT end)
{
	Texts_Delete(frame->text, beg, end);
	TextFrames_SetCaret(frame, beg);
}

static void EditKeys_Err (EditKeys_Definition def, CHAR *s, LONGINT s__len)
{
	__DUP(s, s__len, CHAR);
	EditKeys_errs += 1;
	EditKeys_Gap();
	EditKeys_Str(s, s__len);
	EditKeys_Str((CHAR*)" in ", (LONGINT)5);
	EditKeys_FlipStr(def->trig, 32);
	EditKeys_Ln();
	EditKeys_WLog();
	__DEL(s);
}

static void EditKeys_PopArg (EditKeys_Definition def, SHORTINT class, Texts_Scanner *S, LONGINT *S__typ, EditKeys_Sequence *stack)
{
	Texts_Buffer B = NIL;
	if (*stack != NIL) {
		EditKeys_T = TextFrames_Text((CHAR*)"", (LONGINT)1);
		__NEW(B, Texts_BufDesc);
		Texts_OpenBuf(B);
		Texts_Copy((*stack)->stretch, B);
		Texts_Append(EditKeys_T, B);
		Texts_OpenScanner(&*S, S__typ, EditKeys_T, 0);
		Texts_Scan(&*S, S__typ);
		*stack = (*stack)->next;
		if (class >= 0 && (*S).class != (int)class) {
			EditKeys_Err(def, (CHAR*)"illegal param type", (LONGINT)19);
		}
	} else {
		EditKeys_Err(def, (CHAR*)"missing param", (LONGINT)14);
	}
}

static void EditKeys_PushArg (Texts_Buffer buf, EditKeys_Sequence *stack)
{
	EditKeys_Sequence u = NIL;
	__NEW(u, EditKeys_SequenceDesc);
	u->next = *stack;
	*stack = u;
	u->stretch = buf;
}

static EditKeys_Sequence EditKeys_ThisArg (LONGINT n, EditKeys_Sequence args)
{
	while (n > 0 && args != NIL) {
		n -= 1;
		args = args->next;
	}
	return args;
}

static void EditKeys_GetArguments (Texts_Text text, LONGINT pos, LONGINT *pin, EditKeys_Sequence *args)
{
	Texts_Buffer B = NIL;
	Texts_Reader R = {0};
	CHAR ch = 0;
	*pin = pos;
	pos -= 1;
	Texts_OpenReader(&R, Texts_Reader__typ, text, pos);
	Texts_Read(&R, Texts_Reader__typ, &ch);
	if (ch == ':') {
		*pin = pos;
		while (pos > 0) {
			pos -= 1;
			Texts_OpenReader(&R, Texts_Reader__typ, text, pos);
			Texts_Read(&R, Texts_Reader__typ, &ch);
			if (ch <= ' ') {
				__NEW(B, Texts_BufDesc);
				Texts_OpenBuf(B);
				EditKeys_Save(text, pos + 1, *pin, B);
				EditKeys_PushArg(B, &*args);
				*pin = pos + 1;
				return;
			} else if (ch == ':') {
				__NEW(B, Texts_BufDesc);
				Texts_OpenBuf(B);
				EditKeys_Save(text, pos + 1, *pin, B);
				EditKeys_PushArg(B, &*args);
				*pin = pos;
			} else if (ch == '\"' && pos == *pin - 1) {
				ch = 0x00;
				while (pos > 0 && ch != '\"') {
					pos -= 1;
					Texts_OpenReader(&R, Texts_Reader__typ, text, pos);
					Texts_Read(&R, Texts_Reader__typ, &ch);
				}
				if (ch == '\"') {
					__NEW(B, Texts_BufDesc);
					Texts_OpenBuf(B);
					EditKeys_Save(text, pos + 1, *pin - 1, B);
					EditKeys_PushArg(B, &*args);
					*pin = pos;
					pos -= 1;
					Texts_OpenReader(&R, Texts_Reader__typ, text, pos);
					Texts_Read(&R, Texts_Reader__typ, &ch);
					if (ch == ':') {
						*pin = pos;
					}
					if (ch <= ' ') {
						return;
					}
				} else {
					return;
				}
			}
		}
		__NEW(B, Texts_BufDesc);
		Texts_OpenBuf(B);
		EditKeys_Save(text, pos, *pin, B);
		EditKeys_PushArg(B, &*args);
		*pin = pos;
	}
}

static void EditKeys_Expand (EditKeys_Definition def, EditKeys_Sequence *stack, EditKeys_Sequence *args, EditKeys_Sequence *params)
{
	EditKeys_Definition d = NIL;
	EditKeys_Sequence seq = NIL, u = NIL;
	Texts_Buffer B = NIL;
	Texts_Scanner S = {0};
	Oberon_ParList par = NIL;
	INTEGER res = 0;
	if (!def->in) {
		def->in = 1;
		seq = def->seq;
		while (EditKeys_errs == 0 && seq != NIL) {
			if (seq->sym == 0) {
				if (seq->cmd == '0') {
					if (*stack != NIL) {
						EditKeys_Append((*stack)->stretch, EditKeys_buf);
						*stack = (*stack)->next;
					} else {
						EditKeys_Err(def, (CHAR*)"missing param", (LONGINT)14);
					}
				} else if (seq->cmd == '1') {
					EditKeys_PopArg(def, 3, &S, Texts_Scanner__typ, &*stack);
					Texts_Write(&EditKeys_WB, Texts_Writer__typ, (CHAR)S.i);
					EditKeys_Append(EditKeys_WB.buf, EditKeys_buf);
				} else if (seq->cmd == '2') {
					EditKeys_PopArg(def, 1, &S, Texts_Scanner__typ, &*stack);
					EditKeys_preset.set |= __SETOF(0);
					EditKeys_preset.fnt = Fonts_This(S.s, 256);
				} else if (seq->cmd == '3') {
					EditKeys_PopArg(def, 3, &S, Texts_Scanner__typ, &*stack);
					EditKeys_preset.set |= __SETOF(2);
					EditKeys_preset.voff = (int)S.i;
				} else if (seq->cmd == '4') {
					EditKeys_PopArg(def, 1, &S, Texts_Scanner__typ, &*stack);
					if (EditKeys_errs == 0) {
						__NEW(par, Oberon_ParRec);
						par->vwr = Oberon_FocusViewer;
						par->frame = par->vwr->dsc->next;
						if (*params != NIL) {
							par->text = TextFrames_Text((CHAR*)"", (LONGINT)1);
							while (*params != NIL) {
								Texts_Insert(par->text, 0, (*params)->stretch);
								*params = (*params)->next;
							}
							__NEW(B, Texts_BufDesc);
							Texts_OpenBuf(B);
							Texts_Save(EditKeys_T, Texts_Pos((void*)&S, Texts_Scanner__typ) - 1, EditKeys_T->len, B);
							Texts_Append(par->text, B);
							par->pos = 0;
						} else {
							par->text = EditKeys_T;
							par->pos = Texts_Pos((void*)&S, Texts_Scanner__typ);
						}
						Oberon_Call(S.s, 256, par, 0, &res);
						if (res != 0) {
							Texts_WriteInt(&EditKeys_W, Texts_Writer__typ, res, 3);
							EditKeys_Err(def, (CHAR*)"call error ", (LONGINT)12);
						}
					}
				} else if (seq->cmd == 'A') {
					EditKeys_PopArg(def, 3, &S, Texts_Scanner__typ, &*stack);
					if (EditKeys_errs == 0) {
						u = EditKeys_ThisArg(S.i, *args);
						if (u != NIL) {
							__NEW(B, Texts_BufDesc);
							Texts_OpenBuf(B);
							Texts_Copy(u->stretch, B);
							EditKeys_PushArg(B, &*stack);
						} else {
							EditKeys_Err(def, (CHAR*)"missing argument", (LONGINT)17);
						}
					}
				} else if (seq->cmd == 'B') {
					EditKeys_PopArg(def, 1, &S, Texts_Scanner__typ, &*stack);
					if (EditKeys_errs == 0) {
						__COPY(S.s, EditKeys_name, 32);
						d = EditKeys_Find(EditKeys_name, EditKeys_trig, 0);
						if (d != NIL) {
							EditKeys_Expand(d, &*stack, &*args, &*params);
						} else {
							EditKeys_Err(def, (CHAR*)"exec of undefined macro", (LONGINT)24);
						}
					}
				} else if (seq->cmd == 'C') {
					if (*stack != NIL) {
						u = *stack;
						*stack = (*stack)->next;
						u->next = *params;
						*params = u;
					} else {
						EditKeys_Err(def, (CHAR*)"missing param", (LONGINT)14);
					}
				} else if (seq->cmd == '5') {
					EditKeys_preset.set |= __SETOF(0);
					EditKeys_preset.fnt = EditKeys_preset.def;
				} else if (seq->cmd == '6') {
					EditKeys_preset.set |= __SETOF(1);
				} else if (seq->cmd == '7') {
					EditKeys_preset.set |= __SETOF(3);
					EditKeys_preset.caret = EditKeys_buf->len;
				} else if (seq->cmd == '8') {
					if (EditKeys_indent->len > 0) {
						Texts_Copy(EditKeys_indent, EditKeys_buf);
					}
				} else if (seq->cmd == '9') {
					EditKeys_preset.set |= __SETOF(4);
				} else {
					EditKeys_Err(def, (CHAR*)"illegal built-in", (LONGINT)17);
				}
			} else if (seq->sym == 1) {
				EditKeys_Expand(seq->def, &*stack, &*args, &*params);
			} else {
				__NEW(B, Texts_BufDesc);
				Texts_OpenBuf(B);
				Texts_Copy(seq->stretch, B);
				EditKeys_PushArg(B, &*stack);
			}
			seq = seq->next;
		}
		def->in = 0;
	} else {
		EditKeys_Err(def, (CHAR*)"cyclic expansion", (LONGINT)17);
	}
}

static void EditKeys_InitialExec (EditKeys_Ident name)
{
	EditKeys_Definition def = NIL;
	EditKeys_Sequence stack = NIL, args = NIL, params = NIL;
	EditKeys_Ident trig;
	EditKeys_Ident name__copy;
	__DUPARR(name, EditKeys_Ident);
	def = EditKeys_Find(name, trig, 0);
	if (def != NIL) {
		EditKeys_preset.set = 0x0;
		stack = NIL;
		args = NIL;
		params = NIL;
		EditKeys_errs = 0;
		EditKeys_Expand(def, &stack, &args, &params);
		if (stack != NIL) {
			EditKeys_Err(def, (CHAR*)"superfluous param", (LONGINT)18);
		}
	}
}

static void EditKeys_Process (TextFrames_Frame frame, LONGINT *del)
{
	EditKeys_Definition def = NIL;
	LONGINT org = 0, pos = 0, i = 0, tlen = 0, pin = 0;
	EditKeys_Sequence stack = NIL, args = NIL, params = NIL;
	BOOLEAN default_ = 0;
	Texts_Reader dmy = {0};
	EditKeys_errs = 0;
	*del = 0;
	Texts_OpenBuf(EditKeys_buf);
	org = frame->carloc.pos;
	pos = org - 31;
	if (pos >= 0) {
		i = 31;
	} else {
		pos = 0;
		i = org;
	}
	EditKeys_trig[__X(i, 32)] = 0x00;
	Texts_OpenReader(&EditKeys_R, Texts_Reader__typ, frame->text, pos);
	while (i > 0) {
		i -= 1;
		Texts_Read(&EditKeys_R, Texts_Reader__typ, &EditKeys_trig[__X(i, 32)]);
	}
	def = EditKeys_Trigger(EditKeys_trig);
	if (def != NIL) {
		default_ = 0;
		tlen = 0;
		while (def->trig[__X(tlen, 32)] != 0x00) {
			tlen += 1;
		}
	} else {
		default_ = 1;
		__MOVE("OTHERWISE", EditKeys_name, 10);
		def = EditKeys_Find(EditKeys_name, EditKeys_trig, 0);
		tlen = 0;
	}
	if (def != NIL) {
		EditKeys_preset.set = 0x0;
		stack = NIL;
		args = NIL;
		params = NIL;
		EditKeys_GetArguments(frame->text, org - tlen, &pin, &args);
		Texts_OpenReader(&dmy, Texts_Reader__typ, frame->text, 0);
		EditKeys_Expand(def, &stack, &args, &params);
		if (stack != NIL) {
			EditKeys_Err(def, (CHAR*)"superfluous param", (LONGINT)18);
		}
		if (EditKeys_errs == 0) {
			if (!default_) {
				*del = org - pin;
			}
			EditKeys_preset.frame = frame;
			EditKeys_preset.pos = frame->carloc.pos - *del;
			if (__IN(3, EditKeys_preset.set)) {
				EditKeys_preset.pos += EditKeys_preset.caret;
			} else {
				EditKeys_preset.pos += EditKeys_buf->len;
			}
		}
	}
}

static void EditKeys_Key (TextFrames_Frame frame, CHAR ch, BOOLEAN *handled)
{
	LONGINT del = 0, pos = 0, beg = 0;
	SHORTINT voff = 0;
	Fonts_Font fnt = NIL;
	CHAR ch1 = 0;
	*handled = 1;
	pos = frame->carloc.pos;
	if (frame->text->len > 0) {
		if (pos < frame->text->len) {
			Texts_OpenReader(&EditKeys_R, Texts_Reader__typ, frame->text, pos);
			Texts_Read(&EditKeys_R, Texts_Reader__typ, &ch1);
		}
		if (pos > 0 && (pos == frame->text->len || ch1 <= ' ')) {
			Texts_OpenReader(&EditKeys_R, Texts_Reader__typ, frame->text, pos - 1);
			Texts_Read(&EditKeys_R, Texts_Reader__typ, &ch1);
		}
		EditKeys_preset.def = EditKeys_R.fnt;
		Texts_SetColor(&EditKeys_WL, Texts_Writer__typ, EditKeys_R.col);
		if ((ch == 0x0d || ch == 0x09) || ch == 0x0a) {
			Texts_SetOffset(&EditKeys_WL, Texts_Writer__typ, Oberon_CurOff);
		} else {
			Texts_SetOffset(&EditKeys_WL, Texts_Writer__typ, EditKeys_R.voff);
		}
	} else {
		EditKeys_preset.def = Oberon_CurFnt;
		Texts_SetColor(&EditKeys_WL, Texts_Writer__typ, Oberon_CurCol);
		Texts_SetOffset(&EditKeys_WL, Texts_Writer__typ, Oberon_CurOff);
	}
	fnt = EditKeys_preset.def;
	voff = EditKeys_WL.voff;
	if (EditKeys_preset.frame == frame && EditKeys_preset.pos == pos) {
		if (__IN(0, EditKeys_preset.set)) {
			fnt = EditKeys_preset.fnt;
		}
		if (__IN(2, EditKeys_preset.set)) {
			voff = EditKeys_preset.voff;
		}
	}
	EditKeys_preset.set = 0x0;
	EditKeys_preset.frame = NIL;
	if (EditKeys_WL.fnt != fnt) {
		Texts_SetFont(&EditKeys_WL, Texts_Writer__typ, fnt);
	}
	if (EditKeys_WL.voff != voff) {
		Texts_SetOffset(&EditKeys_WL, Texts_Writer__typ, voff);
	}
	if (ch == EditKeys_hotKey) {
		beg = frame->carloc.org;
		Texts_OpenReader(&EditKeys_R, Texts_Reader__typ, frame->text, beg);
		Texts_Read(&EditKeys_R, Texts_Reader__typ, &ch1);
		while (Texts_Pos(&EditKeys_R, Texts_Reader__typ) <= pos && ch1 <= ' ') {
			Texts_Read(&EditKeys_R, Texts_Reader__typ, &ch1);
		}
		Texts_OpenBuf(EditKeys_indent);
		EditKeys_Save(frame->text, beg, Texts_Pos(&EditKeys_R, Texts_Reader__typ) - 1, EditKeys_indent);
		EditKeys_Process(frame, &del);
		if (!__IN(4, EditKeys_preset.set) && EditKeys_errs == 0) {
			if (frame->hasCar && frame->carloc.pos != pos) {
				EditKeys_preset.pos = frame->carloc.pos - del;
			}
			TextFrames_SetCaret(frame, pos);
			if (del > 0) {
				EditKeys_Delete(frame, pos - del, pos);
			}
			if (__IN(1, EditKeys_preset.set)) {
				EditKeys_T = TextFrames_Text((CHAR*)"", (LONGINT)1);
				Texts_Append(EditKeys_T, EditKeys_buf);
				Texts_ChangeLooks(EditKeys_T, 0, EditKeys_T->len, 0x01, EditKeys_preset.def, 0, 0);
				EditKeys_Save(EditKeys_T, 0, EditKeys_T->len, EditKeys_buf);
			}
			EditKeys_Insert(frame, EditKeys_buf);
		} else {
			TextFrames_RemoveCaret(frame);
			EditKeys_preset.pos = frame->carloc.pos;
		}
		if (0 <= EditKeys_preset.pos && EditKeys_preset.pos <= frame->text->len) {
			TextFrames_SetCaret(frame, EditKeys_preset.pos);
		}
	} else {
		*handled = 0;
	}
	if (EditKeys_WL.buf->len > 0 && frame->hasCar) {
		EditKeys_Insert(frame, EditKeys_WL.buf);
	}
}

void EditKeys_Handle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	TextFrames_Frame frame = NIL;
	BOOLEAN handled = 0;
	if (__IS(msg__typ, Oberon_InputMsg, 1)) {
		if (__IS(msg__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *msg__ = (void*)msg;
			frame = __GUARDP(f, TextFrames_FrameDesc, 1);
			if ((*msg__).id == 0 && frame->hasCar) {
				EditKeys_Key(frame, (*msg__).ch, &handled);
				if (handled) {
					(*msg__).id = -1;
				}
			} else if ((*msg__).id == 1 && (*msg__).keys != 0x0) {
				EditKeys_preset.set = 0x0;
			}
		} else __WITHCHK;
	}
	(*EditKeys_SuperHandler)(f, &*msg, msg__typ);
}

void EditKeys_Reset (void)
{
	EditKeys_ResetDefs();
}

void EditKeys_Read (void)
{
	Texts_Scanner S = {0};
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if ((S.class == 6 && S.c == '@') && S.line == 0) {
		Oberon_GetSelection(&text, &beg, &end, &time);
		if (time > 0) {
			EditKeys_T = text;
			EditKeys_ReadText((CHAR*)" @ ", (LONGINT)4, beg);
		}
	} else if (((S.class == 6 && S.c == ':') && S.nextCh == '=') && S.line == 0) {
		Texts_Scan(&S, Texts_Scanner__typ);
		EditKeys_T = Oberon_Par->text;
		EditKeys_ReadText((CHAR*)" := ", (LONGINT)5, Texts_Pos((void*)&S, Texts_Scanner__typ) - 1);
	} else {
		if ((S.class == 6 && S.c == '^') && S.line == 0) {
			Oberon_GetSelection(&text, &beg, &end, &time);
			if (time > 0) {
				Texts_OpenScanner(&S, Texts_Scanner__typ, text, beg);
				Texts_Scan(&S, Texts_Scanner__typ);
			}
		}
		while (S.class == 1) {
			EditKeys_T = TextFrames_Text(S.s, 256);
			EditKeys_ReadText(S.s, 256, 0);
			Texts_Scan(&S, Texts_Scanner__typ);
		}
	}
	EditKeys_T = NIL;
}

static struct Definitions__6 {
	struct Definitions__6 *lnk;
} *Definitions__6_s;

static void Sort__7 (EditKeys_Definition *d, CHAR *pat, LONGINT pat__len, EditKeys_Definition *tree);
static void Write__11 (EditKeys_Definition tree);

static struct Sort__7__8 {
	struct Sort__7__8 *lnk;
} *Sort__7__8_s;

static void Ins__9 (EditKeys_Definition *tree, EditKeys_Definition t, EditKeys_Ident n);

static void Ins__9 (EditKeys_Definition *tree, EditKeys_Definition t, EditKeys_Ident n)
{
	EditKeys_Ident m;
	if (*tree == NIL) {
		*tree = t;
	} else {
		EditKeys_Flip((void*)(*tree)->trig, 32, (void*)m, 32);
		if (__STRCMP(n, m) < 0) {
			Ins__9(&(*tree)->left, t, n);
		} else {
			Ins__9(&(*tree)->right, t, n);
		}
	}
}

static void Sort__7 (EditKeys_Definition *d, CHAR *pat, LONGINT pat__len, EditKeys_Definition *tree)
{
	INTEGER i = 0;
	EditKeys_Definition t = NIL;
	EditKeys_Ident n;
	struct Sort__7__8 _s;
	_s.lnk = Sort__7__8_s;
	Sort__7__8_s = &_s;
	if (*d != NIL) {
		EditKeys_Flip((void*)(*d)->trig, 32, (void*)n, 32);
		i = 0;
		while (pat[__X(i, pat__len)] != 0x00 && n[__X(i, 32)] == pat[__X(i, pat__len)]) {
			i += 1;
		}
		if (pat[__X(i, pat__len)] == 0x00) {
			__NEW(t, EditKeys_DefinitionDesc);
			__GUARDEQP(t, EditKeys_DefinitionDesc) = **d;
			t->left = NIL;
			t->right = NIL;
			Ins__9(&*tree, t, n);
		}
		Sort__7(&(*d)->left, pat, pat__len, &*tree);
		Sort__7(&(*d)->right, pat, pat__len, &*tree);
	}
	Sort__7__8_s = _s.lnk;
}

static struct Write__11__12 {
	struct Write__11__12 *lnk;
} *Write__11__12_s;

static void Seq__13 (EditKeys_Sequence seq);

static void Seq__13 (EditKeys_Sequence seq)
{
	Texts_Buffer b = NIL;
	while (seq != NIL) {
		if (seq->sym == 0) {
			EditKeys_Ch('^');
			EditKeys_Ch(seq->cmd);
		} else if (seq->sym == 1) {
			if (EditKeys_name[1] == 0x00 && (EditKeys_name[0] < ' ' || EditKeys_name[0] > '~')) {
				EditKeys_Char(EditKeys_name[0]);
			} else {
				EditKeys_FlipStr(seq->def->trig, 32);
			}
		} else {
			EditKeys_Ch('\"');
			EditKeys_Append(EditKeys_W.buf, EditKeys_buf);
			__NEW(b, Texts_BufDesc);
			Texts_OpenBuf(b);
			Texts_Copy(seq->stretch, b);
			EditKeys_Append(b, EditKeys_buf);
			EditKeys_Ch('\"');
		}
		seq = seq->next;
		if (seq != NIL) {
			EditKeys_Ch(' ');
		}
	}
}

static void Write__11 (EditKeys_Definition tree)
{
	struct Write__11__12 _s;
	_s.lnk = Write__11__12_s;
	Write__11__12_s = &_s;
	if (tree != NIL) {
		Write__11(tree->left);
		EditKeys_Gap();
		EditKeys_FlipStr(tree->trig, 32);
		EditKeys_Gap();
		EditKeys_Ch('(');
		Seq__13(tree->seq);
		EditKeys_Ch(')');
		EditKeys_Ln();
		Write__11(tree->right);
	}
	Write__11__12_s = _s.lnk;
}

void EditKeys_Definitions (void)
{
	Texts_Scanner S = {0};
	MenuViewers_Viewer V = NIL;
	Texts_Text T = NIL, text = NIL;
	EditKeys_Definition tree = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	INTEGER x = 0, y = 0;
	struct Definitions__6 _s;
	_s.lnk = Definitions__6_s;
	Definitions__6_s = &_s;
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.line != 0 || S.class != 2 && S.class != 1) {
		Oberon_GetSelection(&text, &beg, &end, &time);
		if (time > 0) {
			Texts_OpenScanner(&S, Texts_Scanner__typ, text, beg);
			Texts_Scan(&S, Texts_Scanner__typ);
		}
	}
	if (S.line != 0 || S.class != 2 && S.class != 1) {
		S.s[0] = 0x00;
	}
	EditKeys_Str((CHAR*)"(hotkey is ", (LONGINT)12);
	EditKeys_Char(EditKeys_hotKey);
	EditKeys_Ch(')');
	EditKeys_Ln();
	tree = NIL;
	Sort__7(&EditKeys_defs->right, (void*)S.s, 256, &tree);
	Texts_OpenBuf(EditKeys_buf);
	Write__11(tree);
	EditKeys_Append(EditKeys_W.buf, EditKeys_buf);
	Oberon_AllocateSystemViewer(Oberon_Mouse.X, &x, &y);
	T = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_Append(T, EditKeys_buf);
	V = MenuViewers_New((void*)TextFrames_NewMenu((CHAR*)"EditKeys.Definitions", (LONGINT)21, (CHAR*)"System.Close  System.Copy  System.Grow  Edit.Search  Edit.Replace  Edit.Parcs  Edit.Store ", (LONGINT)91), (void*)TextFrames_NewText(T, 0), TextFrames_menuH, x, y);
	Definitions__6_s = _s.lnk;
}

void EditKeys_GetKeyCode (void)
{
	EditKeys_Str((CHAR*)"EditKeys.GetKeyCode  (\'q\' to quit)", (LONGINT)35);
	EditKeys_WLog();
	do {
		Input_Read(&EditKeys_ch);
		EditKeys_Ln();
		EditKeys_Gap();
		EditKeys_Char(EditKeys_ch);
		EditKeys_WLog();
	} while (!(EditKeys_ch == 'q'));
	EditKeys_Ln();
	EditKeys_WLog();
}

void EditKeys_Install (void)
{
	HandlerElems_SetHandler((CHAR*)"EditKeys.Handle", (LONGINT)16, EditKeys_Handle, &EditKeys_SuperHandler);
}

static void EnumPtrs(void (*P)(void*))
{
	P(EditKeys_defs);
	P(EditKeys_dmy);
	P(EditKeys_stretch);
	P(EditKeys_buf);
	P(EditKeys_indent);
	P(EditKeys_T);
	__ENUMR(&EditKeys_R, Texts_Reader__typ, 48, 1, P);
	__ENUMR(&EditKeys_W, Texts_Writer__typ, 36, 1, P);
	__ENUMR(&EditKeys_WB, Texts_Writer__typ, 36, 1, P);
	__ENUMR(&EditKeys_WL, Texts_Writer__typ, 36, 1, P);
	__ENUMR(&EditKeys_preset, EditKeys__1__typ, 28, 1, P);
}

__TDESC(EditKeys_DefinitionDesc, 1, 3) = {__TDFLDS("DefinitionDesc", 48), {0, 4, 44, -16}};
__TDESC(EditKeys_SequenceDesc, 1, 3) = {__TDFLDS("SequenceDesc", 16), {0, 8, 12, -16}};
__TDESC(EditKeys__1, 1, 3) = {__TDFLDS("", 28), {12, 16, 20, -16}};

export void *EditKeys__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(HandlerElems);
	__IMPORT(Input);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(EditKeys, EnumPtrs);
	__REGCMD("Definitions", EditKeys_Definitions);
	__REGCMD("GetKeyCode", EditKeys_GetKeyCode);
	__REGCMD("Install", EditKeys_Install);
	__REGCMD("Read", EditKeys_Read);
	__REGCMD("Reset", EditKeys_Reset);
	__INITYP(EditKeys_DefinitionDesc, EditKeys_DefinitionDesc, 0);
	__INITYP(EditKeys_SequenceDesc, EditKeys_SequenceDesc, 0);
	__INITYP(EditKeys__1, EditKeys__1, 0);
/* BEGIN */
	Texts_OpenWriter(&EditKeys_W, Texts_Writer__typ);
	Texts_OpenWriter(&EditKeys_WB, Texts_Writer__typ);
	Texts_OpenWriter(&EditKeys_WL, Texts_Writer__typ);
	__NEW(EditKeys_defs, EditKeys_DefinitionDesc);
	__NEW(EditKeys_dmy, EditKeys_DefinitionDesc);
	__NEW(EditKeys_buf, Texts_BufDesc);
	__NEW(EditKeys_indent, Texts_BufDesc);
	__MOVE("0123456789ABCDEF", EditKeys_map, 17);
	EditKeys_ResetDefs();
	EditKeys_T = TextFrames_Text((CHAR*)"EditKeys.Text", (LONGINT)14);
	EditKeys_ReadText((CHAR*)"EditKeys.Text", (LONGINT)14, 0);
	EditKeys_T = NIL;
	EditKeys_InitialExec((CHAR*)"INSTALL");
	__ENDMOD;
}
