/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "MenuViewers.h"
#include "Modules.h"
#include "Oberon.h"
#include "ParcElems.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct EditTools_NodeDesc *EditTools_Node;

struct EditTools__1 {
	SET set;
	EditTools_Node node;
};

typedef
	struct EditTools_NodeDesc {
		EditTools_Node l, r;
		CHAR mod[32];
		Fonts_Font fnt;
		SHORTINT col, voff;
	} EditTools_NodeDesc;


static Texts_Writer EditTools_W, EditTools_WR;
static LONGINT EditTools_lastTime;
static struct EditTools__1 EditTools_search;

export LONGINT *EditTools_NodeDesc__typ;
export LONGINT *EditTools__1__typ;

static void EditTools_Ch (CHAR ch);
export void EditTools_Change (void);
export void EditTools_ChangeFamily (void);
export void EditTools_ChangeFont (Texts_Text T, LONGINT beg, LONGINT end, CHAR *old, LONGINT old__len, CHAR *new, LONGINT new__len);
export void EditTools_ChangeFontFamily (Texts_Text T, LONGINT beg, LONGINT end, CHAR *old, LONGINT old__len, CHAR *new, LONGINT new__len);
export void EditTools_ChangeFontSize (Texts_Text T, LONGINT beg, LONGINT end, INTEGER old, INTEGER new);
export void EditTools_ChangeFontStyle (Texts_Text T, LONGINT beg, LONGINT end, CHAR old, CHAR new);
export void EditTools_ChangeSize (void);
export void EditTools_ChangeStyle (void);
export void EditTools_Cleanup (void);
static void EditTools_CombineFontName (CHAR *prefix, LONGINT prefix__len, CHAR *suffix, LONGINT suffix__len, INTEGER i, INTEGER j, INTEGER size, CHAR *fn, LONGINT fn__len);
export void EditTools_ConvertToAscii (Texts_Text T, LONGINT beg, LONGINT end);
export void EditTools_Count (Texts_Text T, LONGINT beg, LONGINT end, LONGINT *wc, LONGINT *pc, LONGINT *ec);
export void EditTools_DeleteElems (Texts_Text T, LONGINT beg, LONGINT end);
export void EditTools_DeleteMonsters (Texts_Text T, LONGINT monsterW, LONGINT monsterH, LONGINT *mc);
static BOOLEAN EditTools_Equal (EditTools_Node x, EditTools_Node y, SET set);
static TextFrames_Frame EditTools_FocusFrame (void);
export void EditTools_GetAttr (void);
static void EditTools_GetMainArg (Texts_Scanner *S, LONGINT *S__typ, LONGINT *beg, LONGINT *end);
static BOOLEAN EditTools_HoldsTF (Viewers_Viewer V);
export void EditTools_IncFontSize (Texts_Text T, LONGINT beg, LONGINT end, INTEGER delta);
export void EditTools_IncSize (void);
static void EditTools_Insert (EditTools_Node t, EditTools_Node x);
export void EditTools_InsertCR (void);
static void EditTools_Int (LONGINT n);
static BOOLEAN EditTools_Less (EditTools_Node x, EditTools_Node y);
static void EditTools_List (EditTools_Node t);
static void EditTools_Ln (void);
export void EditTools_LocateLine (void);
static TextFrames_Frame EditTools_MarkedFrame (void);
static void EditTools_NoNotify (Texts_Text text, INTEGER op, LONGINT beg, LONGINT end);
static void EditTools_Plural (LONGINT n, CHAR *s, LONGINT s__len);
static void EditTools_ReadName (Texts_Text t, LONGINT pos, CHAR *name, LONGINT name__len);
static void EditTools_ReadNonWhiteSp (Texts_Reader *R, LONGINT *R__typ, CHAR *ch);
export void EditTools_Refresh (void);
export void EditTools_RemoveCR (void);
export void EditTools_RemoveElems (void);
static void EditTools_Scan (Texts_Scanner *S, LONGINT *S__typ, LONGINT beg, LONGINT end, EditTools_Node n, SET *set);
static void EditTools_ScanText (Texts_Text text, LONGINT beg, LONGINT end);
export void EditTools_SearchAttr (void);
export void EditTools_SearchDiff (void);
export TextFrames_Frame EditTools_SelectedFrame (void);
static void EditTools_SetNode (EditTools_Node n, Texts_Reader *R, LONGINT *R__typ);
static void EditTools_Show (TextFrames_Frame f, LONGINT pos);
export void EditTools_ShowAliens (void);
static void EditTools_SkipArrow (Texts_Scanner *S, LONGINT *S__typ);
static void EditTools_SplitFontName (CHAR *fn, LONGINT fn__len, INTEGER *i, INTEGER *j, INTEGER *size);
export void EditTools_StoreAscii (void);
static void EditTools_Str (CHAR *s, LONGINT s__len);
export void EditTools_ToAscii (void);
static void EditTools_Unmark (TextFrames_Frame f);
export void EditTools_UnmarkMenu (Viewers_Viewer V);
export void EditTools_Words (void);


static void EditTools_Ch (CHAR ch)
{
	Texts_Write(&EditTools_W, Texts_Writer__typ, ch);
}

static void EditTools_Str (CHAR *s, LONGINT s__len)
{
	__DUP(s, s__len, CHAR);
	Texts_WriteString(&EditTools_W, Texts_Writer__typ, s, s__len);
	__DEL(s);
}

static void EditTools_Int (LONGINT n)
{
	EditTools_Ch(' ');
	Texts_WriteInt(&EditTools_W, Texts_Writer__typ, n, 0);
}

static void EditTools_Ln (void)
{
	Texts_WriteLn(&EditTools_W, Texts_Writer__typ);
	Texts_Append(Oberon_Log, EditTools_W.buf);
}

static void EditTools_Plural (LONGINT n, CHAR *s, LONGINT s__len)
{
	__DUP(s, s__len, CHAR);
	EditTools_Int(n);
	EditTools_Ch(' ');
	EditTools_Str(s, s__len);
	if (n != 1) {
		EditTools_Ch('s');
	}
	__DEL(s);
}

static void EditTools_Unmark (TextFrames_Frame f)
{
	Oberon_ControlMsg m = {0};
	Oberon_RemoveMarks(f->X, f->Y, f->W, f->H);
	m.id = 1;
	(*f->handle)((void*)f, (void*)&m, Oberon_ControlMsg__typ);
}

static void EditTools_Show (TextFrames_Frame f, LONGINT pos)
{
	TextFrames_Frame F = NIL;
	LONGINT beg = 0, end = 0, delta = 0;
	delta = 200;
	EditTools_Unmark(f);
	for (;;) {
		beg = f->org;
		end = TextFrames_Pos(f, f->X + f->W, f->Y);
		if (beg <= pos && pos < end || delta == 0) {
			break;
		}
		TextFrames_Show(f, pos - delta);
		delta = __ASHR(delta, 1);
	}
}

static BOOLEAN EditTools_HoldsTF (Viewers_Viewer V)
{
	return __ISP(V, MenuViewers_ViewerDesc, 2) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1);
}

static TextFrames_Frame EditTools_MarkedFrame (void)
{
	Viewers_Viewer V = NIL;
	V = Oberon_MarkedViewer();
	if (EditTools_HoldsTF(V)) {
		return __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1);
	} else {
		return NIL;
	}
	__RETCHK;
}

static TextFrames_Frame EditTools_FocusFrame (void)
{
	Viewers_Viewer V = NIL;
	V = Oberon_FocusViewer;
	if (EditTools_HoldsTF(V)) {
		return __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1);
	} else {
		return NIL;
	}
	__RETCHK;
}

static void EditTools_GetMainArg (Texts_Scanner *S, LONGINT *S__typ, LONGINT *beg, LONGINT *end)
{
	Texts_Text text = NIL;
	LONGINT sbeg = 0, send = 0, time = 0;
	*beg = Oberon_Par->pos;
	*end = Oberon_Par->text->len;
	Texts_OpenScanner(&*S, S__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&*S, S__typ);
	if (((*S).class == 6 && (*S).line == 0) && (*S).c == '^') {
		Oberon_GetSelection(&text, &sbeg, &send, &time);
		if (time >= 0) {
			*beg = sbeg;
			*end = send;
			Texts_OpenScanner(&*S, S__typ, text, *beg);
			Texts_Scan(&*S, S__typ);
		}
	}
}

static void EditTools_SkipArrow (Texts_Scanner *S, LONGINT *S__typ)
{
	Texts_Scan(&*S, S__typ);
	if ((*S).class == 6 && (*S).c == '=') {
		Texts_Scan(&*S, S__typ);
		if ((*S).class == 6 && (*S).c == '>') {
			Texts_Scan(&*S, S__typ);
		} else {
			(*S).class = 0;
		}
	} else {
		(*S).class = 0;
	}
}

static void EditTools_SplitFontName (CHAR *fn, LONGINT fn__len, INTEGER *i, INTEGER *j, INTEGER *size)
{
	INTEGER k = 0;
	__DUP(fn, fn__len, CHAR);
	*i = 0;
	*size = 0;
	while (fn[__X(*i, fn__len)] != 0x00 && (fn[__X(*i, fn__len)] < '0' || '9' < fn[__X(*i, fn__len)])) {
		*i += 1;
	}
	*j = *i;
	while ('0' <= fn[__X(*j, fn__len)] && fn[__X(*j, fn__len)] <= '9') {
		*j += 1;
	}
	k = *i;
	while (k < *j) {
		*size = (*size * 10 + (int)fn[__X(k, fn__len)]) - 48;
		k += 1;
	}
	__DEL(fn);
}

static void EditTools_CombineFontName (CHAR *prefix, LONGINT prefix__len, CHAR *suffix, LONGINT suffix__len, INTEGER i, INTEGER j, INTEGER size, CHAR *fn, LONGINT fn__len)
{
	INTEGER k = 0;
	CHAR ch = 0;
	CHAR dig[10];
	__DUP(prefix, prefix__len, CHAR);
	__DUP(suffix, suffix__len, CHAR);
	__COPY(prefix, fn, fn__len);
	k = 0;
	do {
		dig[__X(k, 10)] = (CHAR)((int)__MOD(size, 10) + 48);
		size = __DIV(size, 10);
		k += 1;
	} while (!(size == 0));
	do {
		k -= 1;
		fn[__X(i, fn__len)] = dig[__X(k, 10)];
		i += 1;
	} while (!(k == 0));
	do {
		ch = suffix[__X(j, suffix__len)];
		fn[__X(i, fn__len)] = ch;
		i += 1;
		j += 1;
	} while (!(ch == 0x00));
	__DEL(prefix);
	__DEL(suffix);
}

static void EditTools_ReadName (Texts_Text t, LONGINT pos, CHAR *name, LONGINT name__len)
{
	INTEGER i = 0;
	Texts_Reader r = {0};
	CHAR ch = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, t, pos);
	i = 0;
	do {
		Texts_Read(&r, Texts_Reader__typ, &ch);
	} while (!((ch > ' ' || ch == 0x0a) || ch == 0x0d));
	if (!r.eot && ch == '\"') {
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
	while (!r.eot && ch > ' ') {
		name[__X(i, name__len)] = ch;
		Texts_Read(&r, Texts_Reader__typ, &ch);
		i += 1;
	}
	if (i > 0 && name[__X(i - 1, name__len)] == '\"') {
		i -= 1;
	}
	name[__X(i, name__len)] = 0x00;
}

static void EditTools_SetNode (EditTools_Node n, Texts_Reader *R, LONGINT *R__typ)
{
	Texts_IdentifyMsg msg = {0};
	n->fnt = (*R).fnt;
	n->col = (*R).col;
	n->voff = (*R).voff;
	if ((*R).elem != NIL) {
		(*(*R).elem->handle)((*R).elem, (void*)&msg, Texts_IdentifyMsg__typ);
		__COPY(msg.mod, n->mod, 32);
	} else {
		n->mod[0] = 0x00;
	}
}

static BOOLEAN EditTools_Less (EditTools_Node x, EditTools_Node y)
{
	if (__STRCMP(x->mod, y->mod) < 0) {
		return 1;
	} else if (__STRCMP(x->mod, y->mod) == 0) {
		if (__STRCMP(x->fnt->name, y->fnt->name) < 0) {
			return 1;
		} else if (__STRCMP(x->fnt->name, y->fnt->name) == 0) {
			if (x->col < y->col) {
				return 1;
			} else if (x->col == y->col) {
				if (x->voff < y->voff) {
					return 1;
				}
			}
		}
	}
	return 0;
}

static void EditTools_Insert (EditTools_Node t, EditTools_Node x)
{
	EditTools_Node p = NIL, c = NIL;
	p = t;
	c = NIL;
	while (t != NIL) {
		p = t;
		if (EditTools_Less(x, t)) {
			t = t->l;
		} else {
			c = t;
			t = t->r;
		}
	}
	if (c == NIL || EditTools_Less(c, x)) {
		if (EditTools_Less(x, p)) {
			__NEW(p->l, EditTools_NodeDesc);
			c = p->l;
		} else {
			__NEW(p->r, EditTools_NodeDesc);
			c = p->r;
		}
		__GUARDEQP(c, EditTools_NodeDesc) = *x;
	}
}

static void EditTools_List (EditTools_Node t)
{
	if (t != NIL) {
		EditTools_List(t->l);
		EditTools_Ln();
		if (t->mod[0] != 0x00) {
			EditTools_Str((CHAR*)"  elem ", (LONGINT)8);
			EditTools_Str(t->mod, 32);
		}
		EditTools_Str((CHAR*)"  font ", (LONGINT)8);
		EditTools_Str(t->fnt->name, 32);
		EditTools_Str((CHAR*)"  col", (LONGINT)6);
		EditTools_Int(t->col);
		EditTools_Str((CHAR*)"  off", (LONGINT)6);
		EditTools_Int(t->voff);
		EditTools_List(t->r);
	}
}

static void EditTools_ScanText (Texts_Text text, LONGINT beg, LONGINT end)
{
	EditTools_Node tree = NIL, cand = NIL;
	Texts_Reader R = {0};
	LONGINT pos = 0;
	CHAR ch0 = 0, ch = 0;
	pos = beg;
	Texts_OpenReader(&R, Texts_Reader__typ, text, beg);
	Texts_Read(&R, Texts_Reader__typ, &ch0);
	pos += 1;
	if (pos > end) {
		EditTools_Str((CHAR*)"  end of text", (LONGINT)14);
	} else {
		__NEW(tree, EditTools_NodeDesc);
		EditTools_SetNode(tree, &R, Texts_Reader__typ);
		tree->l = NIL;
		tree->r = NIL;
		if (pos == end) {
			EditTools_List(tree);
			EditTools_Str((CHAR*)" ascii", (LONGINT)7);
			EditTools_Int((int)ch0);
		} else {
			Texts_Read(&R, Texts_Reader__typ, &ch);
			pos += 1;
			__NEW(cand, EditTools_NodeDesc);
			cand->l = NIL;
			cand->r = NIL;
			while (pos <= end) {
				EditTools_SetNode(cand, &R, Texts_Reader__typ);
				EditTools_Insert(tree, cand);
				Texts_Read(&R, Texts_Reader__typ, &ch);
				pos += 1;
			}
			EditTools_List(tree);
		}
	}
	EditTools_Ln();
}

static void EditTools_Scan (Texts_Scanner *S, LONGINT *S__typ, LONGINT beg, LONGINT end, EditTools_Node n, SET *set)
{
	*set = 0x0;
	while ((beg < end && (*S).line == 0) && (*S).class == 1) {
		beg = Texts_Pos((void*)&*S, S__typ);
		if (__STRCMP((*S).s, "elem") == 0) {
			Texts_Scan(&*S, S__typ);
			if ((*S).line == 0 && (*S).class == 1) {
				*set |= __SETOF(0);
				__COPY((*S).s, n->mod, 32);
				Texts_Scan(&*S, S__typ);
			}
		} else if (__STRCMP((*S).s, "font") == 0) {
			Texts_Scan(&*S, S__typ);
			if ((*S).line == 0 && (*S).class == 1) {
				n->fnt = Fonts_This((*S).s, 256);
				if (__STRCMP(n->fnt->name, (*S).s) == 0) {
					*set |= __SETOF(1);
					Texts_Scan(&*S, S__typ);
				}
			}
		} else if (__STRCMP((*S).s, "col") == 0) {
			Texts_Scan(&*S, S__typ);
			if ((((*S).line == 0 && (*S).class == 3) && -128 <= (*S).i) && (*S).i <= 127) {
				*set |= __SETOF(2);
				n->col = (int)(*S).i;
				Texts_Scan(&*S, S__typ);
			}
		} else if (__STRCMP((*S).s, "off") == 0) {
			Texts_Scan(&*S, S__typ);
			if ((((*S).line == 0 && (*S).class == 3) && -128 <= (*S).i) && (*S).i <= 127) {
				*set |= __SETOF(3);
				n->voff = (int)(*S).i;
				Texts_Scan(&*S, S__typ);
			}
		} else {
			beg = end;
		}
	}
}

static BOOLEAN EditTools_Equal (EditTools_Node x, EditTools_Node y, SET set)
{
	if (__IN(0, set) && __STRCMP(x->mod, y->mod) != 0) {
		return 0;
	}
	if (__IN(1, set) && x->fnt != y->fnt) {
		return 0;
	}
	if (__IN(2, set) && x->col != y->col) {
		return 0;
	}
	return !__IN(3, set) || x->voff == y->voff;
}

void EditTools_IncFontSize (Texts_Text T, LONGINT beg, LONGINT end, INTEGER delta)
{
	Texts_Reader R = {0};
	Fonts_Font fnt = NIL;
	Fonts_Name fn;
	LONGINT org = 0;
	INTEGER i = 0, j = 0, size = 0;
	CHAR ch = 0;
	Texts_OpenReader(&R, Texts_Reader__typ, T, beg);
	Texts_Read(&R, Texts_Reader__typ, &ch);
	while (!R.eot && beg < end) {
		org = beg;
		fnt = R.fnt;
		while ((!R.eot && beg < end) && R.fnt == fnt) {
			beg += 1;
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		EditTools_SplitFontName(fnt->name, 32, &i, &j, &size);
		if (i < j) {
			EditTools_CombineFontName(fnt->name, 32, fnt->name, 32, i, j, size + delta, (void*)fn, 32);
			fnt = Fonts_This(fn, 32);
			if (__STRCMP(fnt->name, fn) == 0) {
				Texts_ChangeLooks(T, org, beg, 0x01, fnt, 0, 0);
			}
		}
	}
}

void EditTools_ChangeFontSize (Texts_Text T, LONGINT beg, LONGINT end, INTEGER old, INTEGER new)
{
	Texts_Reader R = {0};
	Fonts_Font fnt = NIL;
	Fonts_Name fn;
	LONGINT org = 0;
	INTEGER i = 0, j = 0, size = 0;
	CHAR ch = 0;
	Texts_OpenReader(&R, Texts_Reader__typ, T, beg);
	Texts_Read(&R, Texts_Reader__typ, &ch);
	while (!R.eot && beg < end) {
		org = beg;
		fnt = R.fnt;
		while ((!R.eot && beg < end) && R.fnt == fnt) {
			beg += 1;
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		EditTools_SplitFontName(fnt->name, 32, &i, &j, &size);
		if (i < j && (size == old || old == -1)) {
			EditTools_CombineFontName(fnt->name, 32, fnt->name, 32, i, j, new, (void*)fn, 32);
			fnt = Fonts_This(fn, 32);
			if (__STRCMP(fnt->name, fn) == 0) {
				Texts_ChangeLooks(T, org, beg, 0x01, fnt, 0, 0);
			}
		}
	}
}

void EditTools_ChangeFontFamily (Texts_Text T, LONGINT beg, LONGINT end, CHAR *old, LONGINT old__len, CHAR *new, LONGINT new__len)
{
	Texts_Reader R = {0};
	Fonts_Font fnt = NIL;
	Fonts_Name fn;
	LONGINT org = 0;
	INTEGER i = 0, i1 = 0, j = 0, j1 = 0, size = 0, size1 = 0;
	CHAR ch = 0;
	__DUP(old, old__len, CHAR);
	__DUP(new, new__len, CHAR);
	Texts_OpenReader(&R, Texts_Reader__typ, T, beg);
	Texts_Read(&R, Texts_Reader__typ, &ch);
	while (!R.eot && beg < end) {
		org = beg;
		fnt = R.fnt;
		while ((!R.eot && beg < end) && R.fnt == fnt) {
			beg += 1;
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		EditTools_SplitFontName(fnt->name, 32, &i, &j, &size);
		__COPY(fnt->name, fn, 32);
		fn[__X(i, 32)] = 0x00;
		if (i < j && (__STRCMP(fn, old) == 0 || old[0] == '\?')) {
			EditTools_SplitFontName(new, new__len, &i1, &j1, &size1);
			EditTools_CombineFontName(new, new__len, fnt->name, 32, i1, j, size, (void*)fn, 32);
			fnt = Fonts_This(fn, 32);
			if (__STRCMP(fnt->name, fn) == 0) {
				Texts_ChangeLooks(T, org, beg, 0x01, fnt, 0, 0);
			}
		}
	}
	__DEL(old);
	__DEL(new);
}

void EditTools_ChangeFontStyle (Texts_Text T, LONGINT beg, LONGINT end, CHAR old, CHAR new)
{
	Texts_Reader R = {0};
	Fonts_Font fnt = NIL;
	Fonts_Name fn;
	LONGINT org = 0;
	INTEGER i = 0, j = 0, k = 0, size = 0;
	CHAR ch = 0;
	Texts_OpenReader(&R, Texts_Reader__typ, T, beg);
	Texts_Read(&R, Texts_Reader__typ, &ch);
	while (!R.eot && beg < end) {
		org = beg;
		fnt = R.fnt;
		while ((!R.eot && beg < end) && R.fnt == fnt) {
			beg += 1;
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		EditTools_SplitFontName(fnt->name, 32, &i, &j, &size);
		if ((i < j && (fnt->name[__X(j, 32)] == old || old == '\?')) && fnt->name[__X(j, 32)] != new) {
			__COPY(fnt->name, fn, 32);
			if (fn[__X(j, 32)] == '.') {
				k = j + 1;
				while (fn[__X(k, 32)] != 0x00) {
					k += 1;
				}
				while (k >= j) {
					fn[__X(k + 1, 32)] = fn[__X(k, 32)];
					k -= 1;
				}
			} else if (new == '.') {
				k = j;
				do {
					fn[__X(k, 32)] = fn[__X(k + 1, 32)];
					k += 1;
				} while (!(fn[__X(k, 32)] == 0x00));
			}
			fn[__X(j, 32)] = new;
			fnt = Fonts_This(fn, 32);
			if (__STRCMP(fnt->name, fn) == 0) {
				Texts_ChangeLooks(T, org, beg, 0x01, fnt, 0, 0);
			}
		}
	}
}

void EditTools_ChangeFont (Texts_Text T, LONGINT beg, LONGINT end, CHAR *old, LONGINT old__len, CHAR *new, LONGINT new__len)
{
	Texts_Reader R = {0};
	Fonts_Font fnt = NIL;
	LONGINT org = 0;
	CHAR ch = 0;
	__DUP(old, old__len, CHAR);
	__DUP(new, new__len, CHAR);
	Texts_OpenReader(&R, Texts_Reader__typ, T, beg);
	Texts_Read(&R, Texts_Reader__typ, &ch);
	while (!R.eot && beg < end) {
		org = beg;
		fnt = R.fnt;
		while ((!R.eot && beg < end) && R.fnt == fnt) {
			beg += 1;
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		if (__STRCMP(fnt->name, old) == 0) {
			fnt = Fonts_This(new, new__len);
			if (__STRCMP(fnt->name, new) == 0) {
				Texts_ChangeLooks(T, org, beg, 0x01, fnt, 0, 0);
			}
		}
	}
	__DEL(old);
	__DEL(new);
}

void EditTools_Count (Texts_Text T, LONGINT beg, LONGINT end, LONGINT *wc, LONGINT *pc, LONGINT *ec)
{
	Texts_Reader R = {0};
	CHAR ch = 0;
	*wc = 0;
	*pc = 0;
	*ec = 0;
	Texts_OpenReader(&R, Texts_Reader__typ, T, beg);
	Texts_Read(&R, Texts_Reader__typ, &ch);
	beg += 1;
	while (beg <= end) {
		while (beg <= end && ch <= ' ') {
			if (R.elem != NIL) {
				*ec += 1;
			} else if (ch == 0x0d) {
				*pc += 1;
			}
			Texts_Read(&R, Texts_Reader__typ, &ch);
			beg += 1;
		}
		if (beg <= end) {
			*wc += 1;
			while (beg <= end && ch > ' ') {
				Texts_Read(&R, Texts_Reader__typ, &ch);
				beg += 1;
			}
		}
	}
}

void EditTools_DeleteMonsters (Texts_Text T, LONGINT monsterW, LONGINT monsterH, LONGINT *mc)
{
	Texts_Elem e = NIL;
	Texts_Reader R = {0};
	LONGINT pos = 0;
	TextFrames_DisplayMsg msg = {0};
	Texts_OpenReader(&R, Texts_Reader__typ, T, 0);
	Texts_ReadElem(&R, Texts_Reader__typ);
	*mc = 0;
	while (R.elem != NIL) {
		e = R.elem;
		if (!__ISP(e, TextFrames_ParcDesc, 2)) {
			pos = Texts_Pos(&R, Texts_Reader__typ) - 1;
			msg.prepare = 1;
			msg.fnt = R.fnt;
			msg.col = R.col;
			msg.pos = pos;
			msg.indent = 0;
			(*e->handle)(e, (void*)&msg, TextFrames_DisplayMsg__typ);
			if (e->W > monsterW || e->H > monsterH) {
				Texts_Delete(T, pos, pos + 1);
				*mc += 1;
				Texts_OpenReader(&R, Texts_Reader__typ, T, pos);
			}
		}
		Texts_ReadElem(&R, Texts_Reader__typ);
	}
}

void EditTools_DeleteElems (Texts_Text T, LONGINT beg, LONGINT end)
{
	Texts_Reader R = {0};
	CHAR ch = 0;
	Texts_OpenReader(&R, Texts_Reader__typ, T, beg);
	Texts_Read(&R, Texts_Reader__typ, &ch);
	while (beg < end) {
		if (R.elem != NIL) {
			Texts_Delete(T, beg, beg + 1);
			Texts_OpenReader(&R, Texts_Reader__typ, T, beg);
			end -= 1;
		} else {
			beg += 1;
		}
		Texts_Read(&R, Texts_Reader__typ, &ch);
	}
}

TextFrames_Frame EditTools_SelectedFrame (void)
{
	LONGINT time = 0;
	Viewers_Viewer v = NIL;
	INTEGER x = 0;
	TextFrames_Frame f = NIL, F = NIL;
	time = -1;
	x = 0;
	F = NIL;
	while (x < Viewers_curW) {
		v = Viewers_This(x, 0);
		while (v->state > 1) {
			if (__ISP(v->dsc->next, TextFrames_FrameDesc, 1)) {
				f = __GUARDP(v->dsc->next, TextFrames_FrameDesc, 1);
				if (f->hasSel && f->time > time) {
					F = f;
					time = f->time;
				}
			}
			v = Viewers_Next(v);
		}
		x = x + v->W;
	}
	return F;
}

static struct ConvertToAscii__12 {
	Texts_Text *T;
	LONGINT *beg, *end;
	Texts_Reader *R;
	struct ConvertToAscii__12 *lnk;
} *ConvertToAscii__12_s;

static void repl__13 (CHAR *by, LONGINT by__len);
static void replch__15 (CHAR by);

static void repl__13 (CHAR *by, LONGINT by__len)
{
	LONGINT i = 0;
	__DUP(by, by__len, CHAR);
	i = 0;
	while (by[__X(i, by__len)] != 0x00) {
		i += 1;
	}
	Texts_Delete(*ConvertToAscii__12_s->T, *ConvertToAscii__12_s->beg, *ConvertToAscii__12_s->beg + 1);
	*ConvertToAscii__12_s->end -= 1;
	if (i > 0) {
		Texts_SetFont(&EditTools_WR, Texts_Writer__typ, (*ConvertToAscii__12_s->R).fnt);
		Texts_SetColor(&EditTools_WR, Texts_Writer__typ, (*ConvertToAscii__12_s->R).col);
		Texts_SetOffset(&EditTools_WR, Texts_Writer__typ, (*ConvertToAscii__12_s->R).voff);
		Texts_WriteString(&EditTools_WR, Texts_Writer__typ, by, by__len);
		Texts_Insert(*ConvertToAscii__12_s->T, *ConvertToAscii__12_s->beg, EditTools_WR.buf);
		*ConvertToAscii__12_s->beg += i;
		*ConvertToAscii__12_s->end += i;
	}
	Texts_OpenReader(&*ConvertToAscii__12_s->R, Texts_Reader__typ, *ConvertToAscii__12_s->T, *ConvertToAscii__12_s->beg);
	__DEL(by);
}

static void replch__15 (CHAR by)
{
	Texts_Delete(*ConvertToAscii__12_s->T, *ConvertToAscii__12_s->beg, *ConvertToAscii__12_s->beg + 1);
	*ConvertToAscii__12_s->end -= 1;
	Texts_SetFont(&EditTools_WR, Texts_Writer__typ, (*ConvertToAscii__12_s->R).fnt);
	Texts_SetColor(&EditTools_WR, Texts_Writer__typ, (*ConvertToAscii__12_s->R).col);
	Texts_SetOffset(&EditTools_WR, Texts_Writer__typ, (*ConvertToAscii__12_s->R).voff);
	Texts_Write(&EditTools_WR, Texts_Writer__typ, by);
	Texts_Insert(*ConvertToAscii__12_s->T, *ConvertToAscii__12_s->beg, EditTools_WR.buf);
	*ConvertToAscii__12_s->beg += 1;
	*ConvertToAscii__12_s->end += 1;
	Texts_OpenReader(&*ConvertToAscii__12_s->R, Texts_Reader__typ, *ConvertToAscii__12_s->T, *ConvertToAscii__12_s->beg);
}

void EditTools_ConvertToAscii (Texts_Text T, LONGINT beg, LONGINT end)
{
	Texts_Reader R = {0};
	CHAR ch = 0;
	struct ConvertToAscii__12 _s;
	_s.T = &T;
	_s.beg = &beg;
	_s.end = &end;
	_s.R = &R;
	_s.lnk = ConvertToAscii__12_s;
	ConvertToAscii__12_s = &_s;
	Texts_OpenReader(&R, Texts_Reader__typ, T, beg);
	Texts_Read(&R, Texts_Reader__typ, &ch);
	while (beg < end) {
		if (ch == 0x09) {
			repl__13((CHAR*)"  ", (LONGINT)3);
		} else if (ch == 0x83) {
			repl__13((CHAR*)"ae", (LONGINT)3);
		} else if (ch == 0x84) {
			repl__13((CHAR*)"oe", (LONGINT)3);
		} else if (ch == 0x85) {
			repl__13((CHAR*)"ue", (LONGINT)3);
		} else if (ch == 0x80) {
			repl__13((CHAR*)"Ae", (LONGINT)3);
		} else if (ch == 0x81) {
			repl__13((CHAR*)"Oe", (LONGINT)3);
		} else if (ch == 0x82) {
			repl__13((CHAR*)"Ue", (LONGINT)3);
		} else if (ch == 0xab) {
			repl__13((CHAR*)"ss", (LONGINT)3);
		} else if ((ch == 0x94 || ch == 0x8b) || ch == 0x86) {
			replch__15('a');
		} else if (((ch == 0x90 || ch == 0x8c) || ch == 0x87) || ch == 0x91) {
			replch__15('e');
		} else if ((ch == 0x8d || ch == 0x88) || ch == 0x92) {
			replch__15('i');
		} else if (ch == 0x8e || ch == 0x89) {
			replch__15('o');
		} else if (ch == 0x8f || ch == 0x8a) {
			replch__15('u');
		} else if (ch == 0x93) {
			replch__15('c');
		} else if (ch == 0x95) {
			replch__15('n');
		} else {
			beg += 1;
		}
		Texts_Read(&R, Texts_Reader__typ, &ch);
	}
	ConvertToAscii__12_s = _s.lnk;
}

void EditTools_UnmarkMenu (Viewers_Viewer V)
{
	Texts_Reader R = {0};
	Texts_Text text = NIL;
	CHAR ch = 0;
	if (__ISP(V, MenuViewers_ViewerDesc, 2) && __ISP(V->dsc, TextFrames_FrameDesc, 1)) {
		text = __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text;
		if (text->len > 0) {
			Texts_OpenReader(&R, Texts_Reader__typ, text, text->len - 1);
			Texts_Read(&R, Texts_Reader__typ, &ch);
			if (ch == '!') {
				Texts_Delete(text, text->len - 1, text->len);
			}
		}
	}
}

static void EditTools_ReadNonWhiteSp (Texts_Reader *R, LONGINT *R__typ, CHAR *ch)
{
	do {
		Texts_Read(&*R, R__typ, &*ch);
	} while (!(*ch > ' ' || (*R).eot));
}

void EditTools_SearchDiff (void)
{
	TextFrames_Frame f0 = NIL, f1 = NIL;
	Texts_Reader R0 = {0}, R1 = {0};
	CHAR ch0 = 0, ch1 = 0;
	LONGINT pos = 0;
	Texts_Scanner S = {0};
	BOOLEAN whiteSp = 0;
	whiteSp = 1;
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if ((S.line == 0 && S.class == 6) && S.c == '\\') {
		Texts_Scan(&S, Texts_Scanner__typ);
		if (S.class == 1 && __CAP(S.s[0]) == 'W') {
			whiteSp = 0;
		}
	}
	f0 = EditTools_SelectedFrame();
	if (f0 != NIL) {
		TextFrames_RemoveSelection(f0);
	}
	f1 = EditTools_SelectedFrame();
	if (f1 != NIL) {
		Texts_OpenReader(&R0, Texts_Reader__typ, f0->text, f0->selbeg.pos);
		Texts_OpenReader(&R1, Texts_Reader__typ, f1->text, f1->selbeg.pos);
		if (whiteSp) {
			do {
				Texts_Read(&R0, Texts_Reader__typ, &ch0);
				Texts_Read(&R1, Texts_Reader__typ, &ch1);
			} while (!(ch0 != ch1 || ch0 == 0x00));
		} else {
			do {
				EditTools_ReadNonWhiteSp(&R0, Texts_Reader__typ, &ch0);
				EditTools_ReadNonWhiteSp(&R1, Texts_Reader__typ, &ch1);
			} while (!(ch0 != ch1 || ch0 == 0x00));
		}
		pos = Texts_Pos(&R0, Texts_Reader__typ) - 1;
		EditTools_Show(f0, pos);
		TextFrames_SetSelection(f0, pos, pos + 1);
		pos = Texts_Pos(&R1, Texts_Reader__typ) - 1;
		EditTools_Show(f1, pos);
		TextFrames_SetSelection(f1, pos, pos + 1);
	}
}

void EditTools_GetAttr (void)
{
	TextFrames_Frame F = NIL;
	Texts_Scanner S = {0};
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 6 && S.line == 0) {
		EditTools_Str((CHAR*)"EditTools.GetAttr", (LONGINT)18);
		F = EditTools_MarkedFrame();
		Oberon_GetSelection(&text, &beg, &end, &time);
		if (S.c == '*' && F != NIL) {
			EditTools_ScanText(F->text, 0, F->text->len);
		} else if (S.c == '@' && time >= 0) {
			EditTools_ScanText(text, beg, end);
		}
	}
}

void EditTools_SearchAttr (void)
{
	TextFrames_Frame f = NIL;
	Texts_Scanner S = {0};
	Texts_Reader R = {0};
	LONGINT org = 0, beg = 0, end = 0;
	CHAR ch = 0;
	EditTools_Node x = NIL, n = NIL;
	SET set = 0;
	f = EditTools_FocusFrame();
	if (f != NIL) {
		EditTools_GetMainArg(&S, Texts_Scanner__typ, &beg, &end);
		__NEW(n, EditTools_NodeDesc);
		EditTools_Scan(&S, Texts_Scanner__typ, beg, end, n, &set);
		if (set == 0x0 && EditTools_search.set != 0x0) {
			set = EditTools_search.set;
			n = EditTools_search.node;
		}
		if (set != 0x0) {
			EditTools_search.set = set;
			EditTools_search.node = n;
			if (f->hasCar) {
				org = f->carloc.pos;
			} else {
				org = 0;
			}
			Texts_OpenReader(&R, Texts_Reader__typ, f->text, org);
			Texts_Read(&R, Texts_Reader__typ, &ch);
			__NEW(x, EditTools_NodeDesc);
			EditTools_SetNode(x, &R, Texts_Reader__typ);
			while (!R.eot && !EditTools_Equal(x, n, set)) {
				Texts_Read(&R, Texts_Reader__typ, &ch);
				EditTools_SetNode(x, &R, Texts_Reader__typ);
			}
			if (!R.eot) {
				EditTools_Show(f, Texts_Pos(&R, Texts_Reader__typ));
				TextFrames_SetCaret(f, Texts_Pos(&R, Texts_Reader__typ));
			} else {
				TextFrames_RemoveCaret(f);
			}
		}
	}
}

void EditTools_IncSize (void)
{
	Texts_Scanner S = {0};
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	Oberon_GetSelection(&text, &beg, &end, &time);
	if ((((time >= EditTools_lastTime && S.class == 3) && S.line == 0) && -1000 <= S.i) && S.i < 1000) {
		EditTools_lastTime = time;
		EditTools_IncFontSize(text, beg, end, (int)S.i);
	}
}

void EditTools_ChangeSize (void)
{
	Texts_Scanner S = {0};
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	INTEGER old = 0;
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	Oberon_GetSelection(&text, &beg, &end, &time);
	if (time >= EditTools_lastTime && S.line == 0) {
		while (!S.eot && ((S.class == 3 && -1000 <= S.i) && S.i < 1000 || S.class == 6 && S.c == '\?')) {
			if (S.class == 6 && S.c == '\?') {
				old = -1;
			} else {
				old = (int)S.i;
			}
			EditTools_SkipArrow(&S, Texts_Scanner__typ);
			if ((S.class == 3 && -1000 <= S.i) && S.i < 1000) {
				EditTools_lastTime = time;
				EditTools_ChangeFontSize(text, beg, end, old, (int)S.i);
				Texts_Scan(&S, Texts_Scanner__typ);
			}
		}
	}
}

void EditTools_ChangeStyle (void)
{
	Texts_Scanner S = {0};
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	CHAR old = 0, new = 0;
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	Oberon_GetSelection(&text, &beg, &end, &time);
	if (time >= EditTools_lastTime && S.line == 0) {
		while (!S.eot && (S.class == 1 || S.class == 6)) {
			if (S.class == 6) {
				old = S.c;
			} else {
				old = S.s[0];
			}
			EditTools_SkipArrow(&S, Texts_Scanner__typ);
			if (S.class == 1 || S.class == 6) {
				EditTools_lastTime = time;
				if (S.class == 6) {
					new = S.c;
				} else {
					new = S.s[0];
				}
				EditTools_ChangeFontStyle(text, beg, end, old, new);
				Texts_Scan(&S, Texts_Scanner__typ);
			}
		}
	}
}

void EditTools_ChangeFamily (void)
{
	Texts_Scanner S = {0};
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Fonts_Name old;
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	Oberon_GetSelection(&text, &beg, &end, &time);
	if (time >= EditTools_lastTime && S.line == 0) {
		while (!S.eot && (S.class == 1 || S.class == 6 && S.c == '\?')) {
			if (S.class == 6 && S.c == '\?') {
				old[0] = '\?';
				old[1] = 0x00;
			} else {
				__COPY(S.s, old, 32);
			}
			EditTools_SkipArrow(&S, Texts_Scanner__typ);
			if (S.class == 1) {
				EditTools_lastTime = time;
				EditTools_ChangeFontFamily(text, beg, end, old, 32, S.s, 256);
				Texts_Scan(&S, Texts_Scanner__typ);
			}
		}
	}
}

void EditTools_Change (void)
{
	Texts_Scanner S = {0};
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Fonts_Name old;
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	Oberon_GetSelection(&text, &beg, &end, &time);
	if (time >= EditTools_lastTime && S.line == 0) {
		while (S.class == 1) {
			__COPY(S.s, old, 32);
			EditTools_SkipArrow(&S, Texts_Scanner__typ);
			if (S.class == 1) {
				EditTools_lastTime = time;
				EditTools_ChangeFont(text, beg, end, old, 32, S.s, 256);
				Texts_Scan(&S, Texts_Scanner__typ);
			}
		}
	}
}

void EditTools_Words (void)
{
	Texts_Scanner S = {0};
	TextFrames_Frame frame = NIL;
	Texts_Text text = NIL;
	LONGINT cc = 0, ct = 0, wc = 0, wt = 0, pc = 0, pt = 0, ec = 0, et = 0, beg1 = 0, end1 = 0, beg = 0, end = 0, time = 0;
	EditTools_GetMainArg(&S, Texts_Scanner__typ, &beg1, &end1);
	frame = EditTools_MarkedFrame();
	Oberon_GetSelection(&text, &beg, &end, &time);
	ct = 0;
	wt = 0;
	pt = 0;
	et = 0;
	if ((S.class == 6 && S.c == '*') && frame != NIL) {
		EditTools_Str((CHAR*)"EditTools.Words  *", (LONGINT)19);
		cc = frame->text->len;
		EditTools_Count(frame->text, 0, cc, &wc, &pc, &ec);
		EditTools_Plural(pc, (CHAR*)"CR", (LONGINT)3);
		EditTools_Ch(',');
		EditTools_Plural(wc, (CHAR*)"word", (LONGINT)5);
		EditTools_Ch(',');
		EditTools_Plural(cc, (CHAR*)"char", (LONGINT)5);
		EditTools_Ch(',');
		EditTools_Plural(ec, (CHAR*)"element", (LONGINT)8);
		EditTools_Ln();
	} else if ((S.class == 6 && S.c == '@') && time >= 0) {
		EditTools_Str((CHAR*)"EditTools.Words  @", (LONGINT)19);
		cc = end - beg;
		EditTools_Count(text, beg, end, &wc, &pc, &ec);
		EditTools_Plural(pc, (CHAR*)"CR", (LONGINT)3);
		EditTools_Ch(',');
		EditTools_Plural(wc, (CHAR*)"word", (LONGINT)5);
		EditTools_Ch(',');
		EditTools_Plural(cc, (CHAR*)"char", (LONGINT)5);
		EditTools_Ch(',');
		EditTools_Plural(ec, (CHAR*)"element", (LONGINT)8);
		EditTools_Ln();
	} else if (S.class == 1) {
		EditTools_Str((CHAR*)"EditTools.Words", (LONGINT)16);
		do {
			text = TextFrames_Text(S.s, 256);
			EditTools_Str((CHAR*)"  ", (LONGINT)3);
			EditTools_Str(S.s, 256);
			cc = text->len;
			EditTools_Count(text, 0, cc, &wc, &pc, &ec);
			EditTools_Plural(pc, (CHAR*)"CR", (LONGINT)3);
			EditTools_Ch(',');
			EditTools_Plural(wc, (CHAR*)"word", (LONGINT)5);
			EditTools_Ch(',');
			EditTools_Plural(cc, (CHAR*)"char", (LONGINT)5);
			EditTools_Ch(',');
			EditTools_Plural(ec, (CHAR*)"element", (LONGINT)8);
			EditTools_Ln();
			ct += cc;
			wt += wc;
			pt += pc;
			et += ec;
			Texts_Scan(&S, Texts_Scanner__typ);
		} while (!((S.eot || S.class != 1) || Texts_Pos((void*)&S, Texts_Scanner__typ) > end1));
		EditTools_Str((CHAR*)"  total", (LONGINT)8);
		EditTools_Plural(pt, (CHAR*)"CR", (LONGINT)3);
		EditTools_Ch(',');
		EditTools_Plural(wt, (CHAR*)"word", (LONGINT)5);
		EditTools_Ch(',');
		EditTools_Plural(ct, (CHAR*)"char", (LONGINT)5);
		EditTools_Ch(',');
		EditTools_Plural(et, (CHAR*)"element", (LONGINT)8);
		EditTools_Ln();
	}
}

void EditTools_Cleanup (void)
{
	Texts_Scanner S = {0};
	TextFrames_Frame frame = NIL;
	Texts_Text text = NIL;
	LONGINT mc = 0, beg = 0, end = 0, len = 0;
	INTEGER res = 0;
	EditTools_GetMainArg(&S, Texts_Scanner__typ, &beg, &end);
	frame = EditTools_MarkedFrame();
	if ((S.class == 6 && S.c == '*') && frame != NIL) {
		EditTools_Str((CHAR*)"EditTools.Cleanup  *", (LONGINT)21);
		EditTools_DeleteMonsters(frame->text, 9000000, 7200000, &mc);
		EditTools_Ch(' ');
		EditTools_Plural(mc, (CHAR*)"elem", (LONGINT)5);
		EditTools_Str((CHAR*)" deleted", (LONGINT)9);
		EditTools_Ln();
	} else if (S.class == 1) {
		EditTools_Str((CHAR*)"EditTools.Cleanup", (LONGINT)18);
		EditTools_Ln();
		do {
			text = TextFrames_Text(S.s, 256);
			EditTools_Str((CHAR*)"  ", (LONGINT)3);
			EditTools_Str(S.s, 256);
			EditTools_DeleteMonsters(text, 9000000, 7200000, &mc);
			if (mc != 0) {
				Texts_Close(text, S.s, 256);
			} else {
				EditTools_Str((CHAR*)" not changed", (LONGINT)13);
			}
			EditTools_Ln();
			Texts_Scan(&S, Texts_Scanner__typ);
		} while (!((S.eot || S.class != 1) || Texts_Pos((void*)&S, Texts_Scanner__typ) > end));
	}
}

void EditTools_Refresh (void)
{
	TextFrames_Frame frame = NIL;
	Files_File f = NIL;
	Texts_Text text = NIL;
	Files_Rider r = {0};
	frame = EditTools_MarkedFrame();
	if (frame != NIL) {
		EditTools_Str((CHAR*)"EditTools.Refresh", (LONGINT)18);
		Texts_Append(Oberon_Log, EditTools_W.buf);
		text = frame->text;
		f = Files_New((CHAR*)"", (LONGINT)1);
		Files_Set(&r, Files_Rider__typ, f, 0);
		Texts_Store(&r, Files_Rider__typ, text);
		Files_Set(&r, Files_Rider__typ, f, 0);
		Texts_Load(&r, Files_Rider__typ, text);
		Texts_ChangeLooks(text, 0, text->len, 0x0, NIL, 0, 0);
		EditTools_Int(Files_Length(f));
		EditTools_Ln();
	}
}

void EditTools_RemoveElems (void)
{
	Texts_Scanner S = {0};
	TextFrames_Frame frame = NIL;
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.line == 0 && S.class == 6) {
		Oberon_GetSelection(&text, &beg, &end, &time);
		frame = EditTools_MarkedFrame();
		if (S.c == '*' && frame != NIL) {
			EditTools_DeleteElems(frame->text, 0, frame->text->len);
		} else if (S.c == '@' && time >= EditTools_lastTime) {
			EditTools_lastTime = time;
			EditTools_DeleteElems(text, beg, end);
		}
	}
}

void EditTools_ToAscii (void)
{
	Texts_Scanner S = {0};
	TextFrames_Frame frame = NIL;
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.line == 0 && S.class == 6) {
		Oberon_GetSelection(&text, &beg, &end, &time);
		frame = EditTools_MarkedFrame();
		if (S.c == '*' && frame != NIL) {
			EditTools_ConvertToAscii(frame->text, 0, frame->text->len);
		} else if (S.c == '@' && time >= EditTools_lastTime) {
			EditTools_lastTime = time;
			EditTools_ConvertToAscii(text, beg, end);
		}
	}
}

static void EditTools_NoNotify (Texts_Text text, INTEGER op, LONGINT beg, LONGINT end)
{
}

static struct InsertCR__28 {
	Texts_Text *text;
	struct InsertCR__28 *lnk;
} *InsertCR__28_s;

static void GetLineEnd__29 (LONGINT pos, LONGINT len, LONGINT *end, CHAR *ch);

static void GetLineEnd__29 (LONGINT pos, LONGINT len, LONGINT *end, CHAR *ch)
{
	Texts_Reader R = {0};
	LONGINT pos0 = 0;
	*end = pos;
	pos0 = pos;
	Texts_OpenReader(&R, Texts_Reader__typ, *InsertCR__28_s->text, pos);
	for (;;) {
		Texts_Read(&R, Texts_Reader__typ, &*ch);
		pos += 1;
		len -= 1;
		if (R.eot) {
			*end = (*InsertCR__28_s->text)->len;
			break;
		} else if (*ch == 0x0d) {
			*end = pos;
			break;
		} else if (*ch == ' ') {
			*end = pos;
		} else if (len <= 0) {
			if (*end == pos0) {
				*end = pos;
			} else {
				*ch = ' ';
			}
			break;
		}
	}
}

void EditTools_InsertCR (void)
{
	Texts_Scanner S = {0};
	Texts_Text text = NIL;
	Texts_Reader R = {0};
	Texts_Notifier oldNotify = NIL;
	CHAR ch = 0;
	LONGINT beg = 0, beg0 = 0, end = 0, lineEnd = 0, time = 0;
	TextFrames_Frame frame = NIL;
	struct InsertCR__28 _s;
	_s.text = &text;
	_s.lnk = InsertCR__28_s;
	InsertCR__28_s = &_s;
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 3) {
		Texts_Scan(&S, Texts_Scanner__typ);
		text = NIL;
		if (S.line == 0 && S.class == 6) {
			if (S.c == '*') {
				frame = EditTools_MarkedFrame();
				text = frame->text;
				beg = 0;
				end = text->len;
				time = 1;
			} else if (S.c == '@') {
				Oberon_GetSelection(&text, &beg, &end, &time);
			}
		}
		if (text != NIL) {
			beg0 = beg;
			ch = ' ';
			oldNotify = text->notify;
			text->notify = EditTools_NoNotify;
			while (beg > 0 && ch != 0x0d) {
				beg -= 1;
				Texts_OpenReader(&R, Texts_Reader__typ, text, beg);
				Texts_Read(&R, Texts_Reader__typ, &ch);
				if (ch == 0x0d) {
					beg += 1;
				}
			}
			for (;;) {
				GetLineEnd__29(beg, S.i, &lineEnd, &ch);
				if (lineEnd >= end) {
					break;
				} else if (ch == 0x0d) {
				} else if (ch == ' ') {
					Texts_Delete(text, lineEnd - 1, lineEnd);
					Texts_WriteLn(&EditTools_W, Texts_Writer__typ);
					Texts_Insert(text, lineEnd - 1, EditTools_W.buf);
				} else {
					Texts_WriteLn(&EditTools_W, Texts_Writer__typ);
					Texts_Insert(text, lineEnd, EditTools_W.buf);
					lineEnd += 1;
					end += 1;
				}
				beg = lineEnd;
			}
			text->notify = oldNotify;
			(*text->notify)(text, 0, beg0, end);
		}
	}
	InsertCR__28_s = _s.lnk;
}

void EditTools_RemoveCR (void)
{
	Texts_Text text = NIL;
	Texts_Reader R = {0};
	LONGINT beg = 0, beg0 = 0, end = 0, time = 0;
	CHAR ch = 0, lastCh = 0, nextCh = 0;
	Texts_Notifier oldNotify = NIL;
	TextFrames_Frame frame = NIL;
	Texts_Scanner S = {0};
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	text = NIL;
	if (S.line == 0 && S.class == 6) {
		if (S.c == '*') {
			frame = EditTools_MarkedFrame();
			text = frame->text;
			beg = 0;
			end = text->len;
			time = 1;
		} else if (S.c == '@') {
			Oberon_GetSelection(&text, &beg, &end, &time);
		}
	}
	if (text != NIL) {
		if (time >= 0) {
			beg0 = beg;
			lastCh = 0x00;
			oldNotify = text->notify;
			text->notify = EditTools_NoNotify;
			Texts_OpenReader(&R, Texts_Reader__typ, text, beg);
			while (beg < end) {
				Texts_Read(&R, Texts_Reader__typ, &ch);
				beg += 1;
				if (ch == 0x0d) {
					Texts_Read(&R, Texts_Reader__typ, &nextCh);
					if (lastCh != 0x0d && nextCh != 0x0d) {
						Texts_Delete(text, beg - 1, beg);
						Texts_Write(&EditTools_W, Texts_Writer__typ, ' ');
						Texts_Insert(text, beg - 1, EditTools_W.buf);
					}
					Texts_OpenReader(&R, Texts_Reader__typ, text, beg);
				}
				lastCh = ch;
			}
			text->notify = oldNotify;
			(*text->notify)(text, 0, beg0, end);
		}
	}
}

void EditTools_ShowAliens (void)
{
	TextFrames_Frame F = NIL;
	Texts_Reader R = {0};
	BOOLEAN none = 0;
	Texts_IdentifyMsg identify = {0};
	F = EditTools_MarkedFrame();
	if (F != NIL) {
		EditTools_Str((CHAR*)"EditTools.ShowAliens", (LONGINT)21);
		none = 1;
		Texts_OpenReader(&R, Texts_Reader__typ, F->text, 0);
		Texts_ReadElem(&R, Texts_Reader__typ);
		while (!R.eot) {
			identify.mod[31] = 0x00;
			(*R.elem->handle)(R.elem, (void*)&identify, Texts_IdentifyMsg__typ);
			if (identify.mod[31] == 0x01) {
				none = 0;
				EditTools_Ln();
				EditTools_Str((CHAR*)"pos", (LONGINT)4);
				EditTools_Int(Texts_Pos(&R, Texts_Reader__typ) - 1);
				EditTools_Str((CHAR*)"  unknown element allocator: ", (LONGINT)30);
				EditTools_Str(identify.mod, 32);
				EditTools_Ch('.');
				EditTools_Str(identify.proc, 32);
			}
			Texts_ReadElem(&R, Texts_Reader__typ);
		}
		if (none) {
			EditTools_Str((CHAR*)"  none", (LONGINT)7);
		}
		EditTools_Ln();
	}
}

void EditTools_StoreAscii (void)
{
	Texts_Reader r = {0};
	Texts_Text t = NIL;
	Files_File f = NIL;
	Files_Rider fr = {0};
	Viewers_Viewer v = NIL;
	CHAR name[64], bak[64];
	CHAR ch = 0;
	LONGINT beg = 0, end = 0, time = 0;
	INTEGER i = 0, res = 0;
	t = NIL;
	if (Oberon_Par->frame == Oberon_Par->vwr->dsc) {
		v = Oberon_Par->vwr;
		EditTools_ReadName(__GUARDP(Oberon_Par->frame, TextFrames_FrameDesc, 1)->text, 0, (void*)name, 64);
		t = __GUARDP(Oberon_Par->frame->next, TextFrames_FrameDesc, 1)->text;
	} else {
		EditTools_ReadName(Oberon_Par->text, Oberon_Par->pos, (void*)name, 64);
		v = Oberon_MarkedViewer();
		if (name[0] == '^' && name[1] == 0x00) {
			Oberon_GetSelection(&t, &beg, &end, &time);
			if (time > 0) {
				EditTools_ReadName(t, beg, (void*)name, 64);
			} else {
				name[0] = 0x00;
			}
		}
		if (name[0] == '*' && name[1] == 0x00) {
			EditTools_ReadName(__GUARDP(v->dsc, TextFrames_FrameDesc, 1)->text, 0, (void*)name, 64);
		}
		t = __GUARDP(v->dsc->next, TextFrames_FrameDesc, 1)->text;
	}
	if (t != NIL && name[0] != 0x00) {
		EditTools_UnmarkMenu(v);
		EditTools_Str((CHAR*)"EditTools.StoreAscii ", (LONGINT)22);
		EditTools_Str(name, 64);
		EditTools_Ch(' ');
		f = Files_New(name, 64);
		Files_Set(&fr, Files_Rider__typ, f, 0);
		Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
		Texts_Read(&r, Texts_Reader__typ, &ch);
		while (!r.eot) {
			if (ch == 0x0d) {
				ch = 0x0a;
			}
			if (ch != 0x1c) {
				Files_Write(&fr, Files_Rider__typ, ch);
			}
			Texts_Read(&r, Texts_Reader__typ, &ch);
		}
		__COPY(name, bak, 64);
		i = 0;
		while (bak[__X(i, 64)] != 0x00) {
			i += 1;
		}
		bak[__X(i, 64)] = '.';
		bak[__X(i + 1, 64)] = 'B';
		bak[__X(i + 2, 64)] = 'a';
		bak[__X(i + 3, 64)] = 'k';
		bak[__X(i + 4, 64)] = 0x00;
		Files_Rename(name, 64, bak, 64, &res);
		Files_Register(f);
		EditTools_Int(Files_Pos(&fr, Files_Rider__typ));
		EditTools_Ln();
	}
}

void EditTools_LocateLine (void)
{
	TextFrames_Frame f = NIL;
	Texts_Scanner S = {0};
	Texts_Reader R = {0};
	LONGINT line = 0, beg = 0, end = 0;
	CHAR ch = 0;
	f = EditTools_MarkedFrame();
	EditTools_GetMainArg(&S, Texts_Scanner__typ, &beg, &end);
	while ((!S.eot && S.class < 3) && S.line == 0) {
		Texts_Scan(&S, Texts_Scanner__typ);
	}
	if (S.class == 3 && f != NIL) {
		Texts_OpenReader(&R, Texts_Reader__typ, f->text, 0);
		line = 1;
		Texts_Read(&R, Texts_Reader__typ, &ch);
		while (!R.eot && line < S.i) {
			if (ch == 0x0d) {
				line += 1;
			}
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		EditTools_Show(f, Texts_Pos(&R, Texts_Reader__typ) - 1);
		TextFrames_SetCaret(f, Texts_Pos(&R, Texts_Reader__typ) - 1);
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&EditTools_W, Texts_Writer__typ, 36, 1, P);
	__ENUMR(&EditTools_WR, Texts_Writer__typ, 36, 1, P);
	__ENUMR(&EditTools_search, EditTools__1__typ, 8, 1, P);
}

__TDESC(EditTools_NodeDesc, 1, 3) = {__TDFLDS("NodeDesc", 48), {0, 4, 40, -16}};
__TDESC(EditTools__1, 1, 1) = {__TDFLDS("", 8), {4, -8}};

export void *EditTools__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(MenuViewers);
	__IMPORT(Modules);
	__IMPORT(Oberon);
	__IMPORT(ParcElems);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(EditTools, EnumPtrs);
	__REGCMD("Change", EditTools_Change);
	__REGCMD("ChangeFamily", EditTools_ChangeFamily);
	__REGCMD("ChangeSize", EditTools_ChangeSize);
	__REGCMD("ChangeStyle", EditTools_ChangeStyle);
	__REGCMD("Cleanup", EditTools_Cleanup);
	__REGCMD("GetAttr", EditTools_GetAttr);
	__REGCMD("IncSize", EditTools_IncSize);
	__REGCMD("InsertCR", EditTools_InsertCR);
	__REGCMD("LocateLine", EditTools_LocateLine);
	__REGCMD("Refresh", EditTools_Refresh);
	__REGCMD("RemoveCR", EditTools_RemoveCR);
	__REGCMD("RemoveElems", EditTools_RemoveElems);
	__REGCMD("SearchAttr", EditTools_SearchAttr);
	__REGCMD("SearchDiff", EditTools_SearchDiff);
	__REGCMD("ShowAliens", EditTools_ShowAliens);
	__REGCMD("StoreAscii", EditTools_StoreAscii);
	__REGCMD("ToAscii", EditTools_ToAscii);
	__REGCMD("Words", EditTools_Words);
	__INITYP(EditTools_NodeDesc, EditTools_NodeDesc, 0);
	__INITYP(EditTools__1, EditTools__1, 0);
/* BEGIN */
	Texts_OpenWriter(&EditTools_W, Texts_Writer__typ);
	Texts_OpenWriter(&EditTools_WR, Texts_Writer__typ);
	EditTools_lastTime = 0;
	EditTools_search.set = 0x0;
	__ENDMOD;
}
