/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "GUtils.h"
#include "Input.h"
#include "Oberon.h"
#include "Out.h"
#include "Strings.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct Elems_AttrDesc *Elems_Attr;

typedef
	struct {
		LONGINT len[1];
		CHAR data[1];
	} *Elems_Str;

typedef
	struct Elems_AttrDesc {
		Elems_Str name;
		Elems_Attr next;
	} Elems_AttrDesc;

typedef
	void (*Elems_EnumNames)(CHAR*, LONGINT , INTEGER);

typedef
	struct Elems_AttrMsg { /* Texts_ElemMsg */
		INTEGER id;
		BOOLEAN hasProps;
		Elems_EnumNames enum_;
		CHAR name[64];
		INTEGER class;
		CHAR s[256];
		SET set;
		BOOLEAN b;
		LONGINT i;
		REAL r;
		LONGREAL lr;
		Texts_Text t;
	} Elems_AttrMsg;

typedef
	struct Elems_BoolDesc *Elems_BoolAttr;

typedef
	struct Elems_BoolDesc {
		Elems_Str name;
		Elems_Attr next;
		BOOLEAN b;
	} Elems_BoolDesc;

typedef
	struct Elems_ElemDesc *Elems_Elem;

typedef
	struct Elems_ElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		Elems_Attr attr;
		BOOLEAN locked;
	} Elems_ElemDesc;

typedef
	struct Elems_ExecMsg { /* Texts_ElemMsg */
		Elems_Elem e;
		INTEGER x, y;
		BOOLEAN unload;
		Display_Frame f;
		Texts_Text context;
	} Elems_ExecMsg;

typedef
	struct Elems_GetContextMsg { /* Display_FrameMsg */
		INTEGER fx, fy;
		Texts_Elem p;
		Display_Frame context;
	} Elems_GetContextMsg;

typedef
	struct Elems_GetFrameMsg { /* Display_FrameMsg */
		Display_Frame f;
		Texts_Elem e;
	} Elems_GetFrameMsg;

typedef
	struct Elems_IntDesc *Elems_IntAttr;

typedef
	struct Elems_IntDesc {
		Elems_Str name;
		Elems_Attr next;
		LONGINT i;
	} Elems_IntDesc;

typedef
	struct Elems_LRealDesc *Elems_LRealAttr;

typedef
	struct Elems_LRealDesc {
		Elems_Str name;
		Elems_Attr next;
		LONGREAL lr;
	} Elems_LRealDesc;

typedef
	struct Elems_OverlapMsg { /* Texts_ElemMsg */
		INTEGER x, y, w, h, ex, ey, ew, eh;
		BOOLEAN overlaps;
	} Elems_OverlapMsg;

typedef
	struct Elems_RealDesc *Elems_RealAttr;

typedef
	struct Elems_RealDesc {
		Elems_Str name;
		Elems_Attr next;
		REAL r;
	} Elems_RealDesc;

typedef
	struct Elems_SetAttrDesc *Elems_SetAttr;

typedef
	struct Elems_SetAttrDesc {
		Elems_Str name;
		Elems_Attr next;
		SET s;
	} Elems_SetAttrDesc;

typedef
	struct Elems_StringDesc *Elems_StringAttr;

typedef
	struct Elems_StringDesc {
		Elems_Str name;
		Elems_Attr next;
		Elems_Str s;
	} Elems_StringDesc;

typedef
	struct Elems_TabStopMsg { /* Texts_ElemMsg */
		BOOLEAN accepted;
	} Elems_TabStopMsg;

typedef
	struct Elems_TaskDesc *Elems_Task;

typedef
	struct Elems_TaskDesc { /* Oberon_TaskDesc */
		LONGINT _prvt0;
		BOOLEAN safe;
		LONGINT time;
		Oberon_Handler handle;
		INTEGER x, y;
		Display_Frame f;
	} Elems_TaskDesc;

typedef
	struct Elems_TextAttrDesc *Elems_TextAttr;

typedef
	struct Elems_TextAttrDesc {
		Elems_Str name;
		Elems_Attr next;
		Texts_Text t;
	} Elems_TextAttrDesc;


export Texts_Text Elems_CmdContext;
export Display_Frame Elems_CmdFrame;
export Elems_Elem Elems_CmdElem;
export SHORTINT Elems_clp;
export BOOLEAN Elems_Done;
static Viewers_Viewer Elems_CmdContextV;
static Texts_Writer Elems_W;

export LONGINT *Elems_AttrDesc__typ;
export LONGINT *Elems_BoolDesc__typ;
export LONGINT *Elems_IntDesc__typ;
export LONGINT *Elems_RealDesc__typ;
export LONGINT *Elems_LRealDesc__typ;
export LONGINT *Elems_StringDesc__typ;
export LONGINT *Elems_SetAttrDesc__typ;
export LONGINT *Elems_TextAttrDesc__typ;
export LONGINT *Elems_ElemDesc__typ;
export LONGINT *Elems_AttrMsg__typ;
export LONGINT *Elems_GetContextMsg__typ;
export LONGINT *Elems_GetFrameMsg__typ;
export LONGINT *Elems_TabStopMsg__typ;
export LONGINT *Elems_ExecMsg__typ;
export LONGINT *Elems_OverlapMsg__typ;
export LONGINT *Elems_TaskDesc__typ;

export void Elems_AdjustSubFrame (Display_Frame f, Display_Frame sub);
export void Elems_Call (Elems_Elem e, Texts_Text context, BOOLEAN unload);
static void Elems_CopyAttributes (Elems_Attr src, Elems_Attr *dest);
export void Elems_CopyElem (Elems_Elem src, Elems_Elem dest);
static Elems_Str Elems_CopyString (CHAR *src, LONGINT src__len);
export Texts_Text Elems_CopyText (Texts_Text T);
export Elems_Elem Elems_CreateElem (CHAR *generator, LONGINT generator__len);
static void Elems_DeleteAttribute (CHAR *name, LONGINT name__len, Elems_Attr *attr);
export void Elems_DoCall (CHAR *cmd, LONGINT cmd__len, Viewers_Viewer v, Display_Frame f, Texts_Text partext, LONGINT pos, BOOLEAN free);
static void Elems_DoClick (void);
static void Elems_EnumAttributes (Elems_Attr attr, Elems_EnumNames enum_);
static void Elems_Error (INTEGER id, INTEGER pos, CHAR *n1, LONGINT n1__len);
export void Elems_Expand (Elems_Elem e, CHAR *macro, LONGINT macro__len, Texts_Text *dest);
static Elems_Attr Elems_FindAttribute (CHAR *name, LONGINT name__len, Elems_Attr attr, Elems_Attr *prev);
export void Elems_Focusing (TextFrames_FocusMsg msg);
static INTEGER Elems_GetAttrClass (Elems_Attr a);
static void Elems_GetAttribute (Elems_Attr attr, Elems_AttrMsg *msg, LONGINT *msg__typ);
export void Elems_GetBoolean (Texts_Elem e, CHAR *name, LONGINT name__len, BOOLEAN *b);
export INTEGER Elems_GetClass (Texts_Elem e, CHAR *name, LONGINT name__len);
export void Elems_GetInteger (Texts_Elem e, CHAR *name, LONGINT name__len, LONGINT *i);
export void Elems_GetLReal (Texts_Elem e, CHAR *name, LONGINT name__len, LONGREAL *lr);
export void Elems_GetLook (Texts_Elem e, Fonts_Font *fnt, SHORTINT *col);
export void Elems_GetPar (Elems_Elem e, Texts_Scanner *s, LONGINT *s__typ);
export void Elems_GetReal (Texts_Elem e, CHAR *name, LONGINT name__len, REAL *r);
export void Elems_GetSet (Texts_Elem e, CHAR *name, LONGINT name__len, SET *s);
export void Elems_GetString (Texts_Elem e, CHAR *name, LONGINT name__len, CHAR *s, LONGINT s__len);
export void Elems_GetText (Texts_Elem e, CHAR *name, LONGINT name__len, Texts_Text *t);
export void Elems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void Elems_HandleAttrMsg (Elems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ);
export BOOLEAN Elems_InCorner (INTEGER mX, INTEGER mY, INTEGER x, INTEGER y, INTEGER w, Texts_Elem e);
export void Elems_Init (Elems_Elem e);
export void Elems_IntToString (LONGINT i, CHAR *s, LONGINT s__len);
static void Elems_LeftClick (INTEGER x, INTEGER y, Display_Frame f);
static void Elems_LoadAttributes (Files_Rider *R, LONGINT *R__typ, Elems_Attr *attr);
export Elems_Elem Elems_NamedElem (CHAR *name, LONGINT name__len, Texts_Text context);
static void Elems_ParseRef (CHAR *s, LONGINT s__len, CHAR *name1, LONGINT name1__len, CHAR *name2, LONGINT name2__len, INTEGER *i);
static void Elems_Resize (Elems_Elem e, INTEGER x, INTEGER y);
export INTEGER Elems_Scale (INTEGER val);
static void Elems_SetAttribute (Elems_Attr *attr, Elems_AttrMsg *msg, LONGINT *msg__typ);
export void Elems_SetBoolean (Texts_Elem e, CHAR *name, LONGINT name__len, BOOLEAN b);
export void Elems_SetContext (INTEGER x, INTEGER y, Display_Frame f);
export void Elems_SetFont (Texts_Elem e, CHAR *name, LONGINT name__len, SET sel, Fonts_Font f, SHORTINT col, SHORTINT voff);
export void Elems_SetInteger (Texts_Elem e, CHAR *name, LONGINT name__len, LONGINT i);
export void Elems_SetLReal (Texts_Elem e, CHAR *name, LONGINT name__len, LONGREAL lr);
export void Elems_SetReal (Texts_Elem e, CHAR *name, LONGINT name__len, REAL r);
export void Elems_SetSet (Texts_Elem e, CHAR *name, LONGINT name__len, SET s);
export void Elems_SetString (Texts_Elem e, CHAR *name, LONGINT name__len, CHAR *s, LONGINT s__len);
export void Elems_SetText (Texts_Elem e, CHAR *name, LONGINT name__len, Texts_Text t);
static void Elems_StoreAttributes (Files_Rider *r, LONGINT *r__typ, Elems_Attr attr);
export INTEGER Elems_StringLength (CHAR *str, LONGINT str__len);
export void Elems_TabStop (Elems_Elem e, Display_Frame f);
export void Elems_ToFrame (Texts_Elem e, TextFrames_TrackMsg msg);
export void Elems_Track (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ, BOOLEAN *done);
export void Elems_UpdateElem (Texts_Elem e);
export void Elems_WriteAttr (Texts_Writer *W, LONGINT *W__typ, Elems_AttrMsg attr);


INTEGER Elems_Scale (INTEGER val)
{
	return (int)__DIV((LONGINT)val * 10000, (LONGINT)TextFrames_Unit);
}

Texts_Text Elems_CopyText (Texts_Text T)
{
	Texts_Text t = NIL;
	Texts_Buffer buf = NIL;
	__NEW(buf, Texts_BufDesc);
	Texts_OpenBuf(buf);
	Texts_Save(T, 0, T->len, buf);
	t = TextFrames_Text((CHAR*)"", (LONGINT)1);
	t->notify = T->notify;
	Texts_Append(t, buf);
	return t;
}

static Elems_Str Elems_CopyString (CHAR *src, LONGINT src__len)
{
	Elems_Str dest = NIL;
	__DUP(src, src__len, CHAR);
	dest = __NEWARR(NIL, 1, 1, 1, 1, (LONGINT)(Strings_Length(src, src__len) + 1));
	__COPY(src, dest->data, dest->len[0]);
	__DEL(src);
	return dest;
}

void Elems_IntToString (LONGINT i, CHAR *s, LONGINT s__len)
{
	CHAR s1[2];
	BOOLEAN neg = 0;
	if (i == 0) {
		__COPY("0", s, s__len);
		return;
	}
	__COPY("", s, s__len);
	neg = i < 0;
	if (neg) {
		i = i * -1;
	}
	while (i != 0) {
		s1[0] = (CHAR)(48 + __MOD(i, 10));
		s1[1] = 0x00;
		Strings_Insert(s1, 2, 0, (void*)s, s__len);
		i = __DIV(i, 10);
	}
	if (neg) {
		Strings_Insert((CHAR*)"-", (LONGINT)2, 0, (void*)s, s__len);
	}
}

static void Elems_LeftClick (INTEGER x, INTEGER y, Display_Frame f)
{
	Oberon_InputMsg input = {0};
	input.id = 1;
	input.keys = 0x04;
	input.X = x;
	input.Y = y;
	(*f->handle)(f, (void*)&input, Oberon_InputMsg__typ);
}

static void Elems_DoClick (void)
{
	Elems_Task T = NIL;
	T = __GUARDP(Oberon_CurTask, Elems_TaskDesc, 1);
	Elems_LeftClick(T->x, T->y, T->f);
	Oberon_Remove((void*)T);
}

void Elems_DoCall (CHAR *cmd, LONGINT cmd__len, Viewers_Viewer v, Display_Frame f, Texts_Text partext, LONGINT pos, BOOLEAN free)
{
	Oberon_ParList parList = NIL;
	INTEGER res = 0, i = 0;
	__DUP(cmd, cmd__len, CHAR);
	i = 0;
	while (cmd[__X(i, cmd__len)] != 0x00 && cmd[__X(i, cmd__len)] != ' ') {
		i += 1;
	}
	cmd[__X(i, cmd__len)] = 0x00;
	__NEW(parList, Oberon_ParRec);
	parList->pos = pos;
	if (v == NIL) {
		parList->vwr = Viewers_This(0, 0);
	} else {
		parList->vwr = v;
	}
	if (f == NIL) {
		parList->frame = (Display_Frame)Viewers_This(0, 0);
	} else {
		parList->frame = f;
	}
	if (partext == NIL) {
		parList->text = TextFrames_Text((CHAR*)"", (LONGINT)1);
	} else {
		parList->text = partext;
	}
	Oberon_Call(cmd, cmd__len, parList, free, &res);
	if (res != 0) {
		Out_String((CHAR*)"-- Call error: ", (LONGINT)16);
		Out_String(cmd, cmd__len);
		Out_String((CHAR*)" not found", (LONGINT)11);
		Out_Ln();
	}
	__DEL(cmd);
}

Elems_Elem Elems_CreateElem (CHAR *generator, LONGINT generator__len)
{
	Texts_Elem e = NIL;
	__DUP(generator, generator__len, CHAR);
	Elems_DoCall(generator, generator__len, NIL, NIL, NIL, 0, 0);
	e = Texts_new;
	Texts_new = NIL;
	__DEL(generator);
	return __GUARDP(e, Elems_ElemDesc, 2);
}

void Elems_ToFrame (Texts_Elem e, TextFrames_TrackMsg msg)
{
	Oberon_InputMsg input = {0};
	Elems_GetContextMsg getct = {0};
	input.keys = msg.keys;
	input.id = 1;
	input.X = msg.X;
	input.Y = msg.Y;
	input.fnt = msg.fnt;
	input.col = msg.col;
	getct.fx = msg.X;
	getct.fy = msg.Y;
	getct.p = e;
	getct.context = NIL;
	Viewers_Broadcast((void*)&getct, Elems_GetContextMsg__typ);
	if (getct.context != NIL) {
		(*getct.context->handle)(getct.context, (void*)&input, Oberon_InputMsg__typ);
	}
}

void Elems_Focusing (TextFrames_FocusMsg msg)
{
	Elems_Task T = NIL;
	SET keys = 0;
	if (msg.focus) {
		__NEW(T, Elems_TaskDesc);
		T->f = msg.elemFrame;
		Input_Mouse(&keys, &T->x, &T->y);
		if (((T->x < T->f->X || T->x > T->f->X + T->f->W) || T->y < T->f->Y) || T->y > T->f->Y + T->f->H) {
			T->x = T->f->X;
			T->y = T->f->Y;
		}
		T->time = 0;
		T->safe = 0;
		T->handle = Elems_DoClick;
		Oberon_Install((void*)T);
	}
}

void Elems_TabStop (Elems_Elem e, Display_Frame f)
{
	Texts_Reader r = {0};
	Elems_TabStopMsg tab = {0};
	Viewers_Viewer v = NIL;
	Elems_GetFrameMsg get = {0};
	v = Viewers_This(f->X, f->Y);
	tab.accepted = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, Texts_ElemBase((void*)e), Texts_ElemPos((void*)e) + 1);
	Texts_ReadElem(&r, Texts_Reader__typ);
	while (!tab.accepted && r.elem != (void *) e) {
		if (r.eot) {
			Texts_OpenReader(&r, Texts_Reader__typ, Texts_ElemBase((void*)e), 0);
			Texts_ReadElem(&r, Texts_Reader__typ);
		} else if (r.elem != NIL) {
			(*r.elem->handle)(r.elem, (void*)&tab, Elems_TabStopMsg__typ);
			if (tab.accepted) {
				get.e = r.elem;
				get.f = NIL;
				(*v->dsc->next->handle)(v->dsc->next, (void*)&get, Elems_GetFrameMsg__typ);
				if (get.f != NIL) {
					Elems_LeftClick(get.f->X, get.f->Y, v->dsc->next);
				} else {
					tab.accepted = 0;
					Texts_ReadElem(&r, Texts_Reader__typ);
				}
			} else {
				Texts_ReadElem(&r, Texts_Reader__typ);
			}
		}
	}
}

void Elems_AdjustSubFrame (Display_Frame f, Display_Frame sub)
{
	if (sub->Y < f->Y) {
		sub->H = sub->H - (f->Y - sub->Y);
		sub->Y = f->Y;
	}
	if (sub->X + sub->W > f->X + f->W) {
		sub->W = sub->W - ((sub->X + sub->W) - (f->X + f->W));
	}
	if ((sub->Y + sub->H) - 1 > f->Y + f->H) {
		sub->H = sub->H - ((sub->Y + sub->H) - (f->Y + f->H));
	}
	if (sub->X < f->X) {
		sub->W = sub->W - (f->X - sub->X);
		sub->X = f->X;
	}
}

INTEGER Elems_StringLength (CHAR *str, LONGINT str__len)
{
	INTEGER i = 0;
	__DUP(str, str__len, CHAR);
	i = 0;
	while (str[__X(i, str__len)] != 0x00) {
		i += 1;
	}
	__DEL(str);
	return i;
}

void Elems_GetLook (Texts_Elem e, Fonts_Font *fnt, SHORTINT *col)
{
	Texts_Text t = NIL;
	Texts_Reader r = {0};
	if (e == NIL) {
		*fnt = Fonts_Default;
		*col = 15;
		return;
	}
	t = Texts_ElemBase(e);
	Texts_OpenReader(&r, Texts_Reader__typ, t, Texts_ElemPos(e));
	Texts_ReadElem(&r, Texts_Reader__typ);
	*fnt = r.fnt;
	*col = r.col;
}

void Elems_WriteAttr (Texts_Writer *W, LONGINT *W__typ, Elems_AttrMsg attr)
{
	if (attr.class == 3) {
		Texts_WriteInt(&*W, W__typ, attr.i, 0);
	} else if (attr.class == 2) {
		Texts_WriteString(&*W, W__typ, attr.s, 256);
	} else if (attr.class == 4) {
		Texts_WriteReal(&*W, W__typ, attr.r, 0);
	} else if (attr.class == 5) {
		Texts_WriteLongReal(&*W, W__typ, attr.lr, 0);
	} else if (attr.class == 7) {
		if (attr.b) {
			Texts_Write(&*W, W__typ, 'Y');
		} else {
			Texts_Write(&*W, W__typ, 'N');
		}
	} else if (attr.class == 9) {
		Texts_Save(attr.t, 0, attr.t->len, (*W).buf);
	}
}

BOOLEAN Elems_InCorner (INTEGER mX, INTEGER mY, INTEGER x, INTEGER y, INTEGER w, Texts_Elem e)
{
	return (__ISP(e, Elems_ElemDesc, 2) && mX > (x + w) - (int)__ASHL(Elems_clp, 1)) && mY < y + (int)__ASHL(Elems_clp, 1);
}

void Elems_SetContext (INTEGER x, INTEGER y, Display_Frame f)
{
	Elems_CmdContextV = Viewers_This(x, y);
	Elems_CmdFrame = f;
}

void Elems_SetString (Texts_Elem e, CHAR *name, LONGINT name__len, CHAR *s, LONGINT s__len)
{
	Elems_AttrMsg m = {0};
	__DUP(name, name__len, CHAR);
	__DUP(s, s__len, CHAR);
	m.id = 2;
	m.class = 2;
	__COPY(name, m.name, 64);
	__COPY(s, m.s, 256);
	(*e->handle)(e, (void*)&m, Elems_AttrMsg__typ);
	__DEL(name);
	__DEL(s);
}

void Elems_SetBoolean (Texts_Elem e, CHAR *name, LONGINT name__len, BOOLEAN b)
{
	Elems_AttrMsg m = {0};
	__DUP(name, name__len, CHAR);
	m.id = 2;
	m.class = 7;
	__COPY(name, m.name, 64);
	m.b = b;
	(*e->handle)(e, (void*)&m, Elems_AttrMsg__typ);
	__DEL(name);
}

void Elems_SetInteger (Texts_Elem e, CHAR *name, LONGINT name__len, LONGINT i)
{
	Elems_AttrMsg m = {0};
	__DUP(name, name__len, CHAR);
	m.id = 2;
	m.class = 3;
	__COPY(name, m.name, 64);
	m.i = i;
	(*e->handle)(e, (void*)&m, Elems_AttrMsg__typ);
	__DEL(name);
}

void Elems_SetReal (Texts_Elem e, CHAR *name, LONGINT name__len, REAL r)
{
	Elems_AttrMsg m = {0};
	__DUP(name, name__len, CHAR);
	m.id = 2;
	m.class = 4;
	__COPY(name, m.name, 64);
	m.r = r;
	(*e->handle)(e, (void*)&m, Elems_AttrMsg__typ);
	__DEL(name);
}

void Elems_SetLReal (Texts_Elem e, CHAR *name, LONGINT name__len, LONGREAL lr)
{
	Elems_AttrMsg m = {0};
	__DUP(name, name__len, CHAR);
	m.id = 2;
	m.class = 5;
	__COPY(name, m.name, 64);
	m.lr = lr;
	(*e->handle)(e, (void*)&m, Elems_AttrMsg__typ);
	__DEL(name);
}

void Elems_SetSet (Texts_Elem e, CHAR *name, LONGINT name__len, SET s)
{
	Elems_AttrMsg m = {0};
	__DUP(name, name__len, CHAR);
	m.id = 2;
	m.class = 8;
	__COPY(name, m.name, 64);
	m.set = s;
	(*e->handle)(e, (void*)&m, Elems_AttrMsg__typ);
	__DEL(name);
}

void Elems_SetText (Texts_Elem e, CHAR *name, LONGINT name__len, Texts_Text t)
{
	Elems_AttrMsg m = {0};
	__DUP(name, name__len, CHAR);
	m.id = 2;
	m.class = 9;
	__COPY(name, m.name, 64);
	m.t = t;
	(*e->handle)(e, (void*)&m, Elems_AttrMsg__typ);
	__DEL(name);
}

void Elems_SetFont (Texts_Elem e, CHAR *name, LONGINT name__len, SET sel, Fonts_Font f, SHORTINT col, SHORTINT voff)
{
	Elems_AttrMsg m = {0};
	__DUP(name, name__len, CHAR);
	m.id = 1;
	__COPY(name, m.name, 64);
	(*e->handle)(e, (void*)&m, Elems_AttrMsg__typ);
	if (m.class == 9) {
		Texts_ChangeLooks(m.t, 0, m.t->len, sel, f, col, voff);
		if (Texts_ElemBase(e) != NIL) {
			Texts_ChangeLooks(Texts_ElemBase(e), Texts_ElemPos(e), Texts_ElemPos(e) + 1, sel, f, col, voff);
		}
	}
	__DEL(name);
}

INTEGER Elems_GetClass (Texts_Elem e, CHAR *name, LONGINT name__len)
{
	Elems_AttrMsg m = {0};
	__DUP(name, name__len, CHAR);
	m.id = 1;
	__COPY(name, m.name, 64);
	(*e->handle)(e, (void*)&m, Elems_AttrMsg__typ);
	if (Elems_Done) {
		__DEL(name);
		return m.class;
	} else {
		__DEL(name);
		return -1;
	}
	__RETCHK;
}

void Elems_GetString (Texts_Elem e, CHAR *name, LONGINT name__len, CHAR *s, LONGINT s__len)
{
	Elems_AttrMsg m = {0};
	__DUP(name, name__len, CHAR);
	m.id = 1;
	__COPY(name, m.name, 64);
	(*e->handle)(e, (void*)&m, Elems_AttrMsg__typ);
	__COPY(m.s, s, s__len);
	__DEL(name);
}

void Elems_GetBoolean (Texts_Elem e, CHAR *name, LONGINT name__len, BOOLEAN *b)
{
	Elems_AttrMsg m = {0};
	__DUP(name, name__len, CHAR);
	m.id = 1;
	__COPY(name, m.name, 64);
	(*e->handle)(e, (void*)&m, Elems_AttrMsg__typ);
	*b = m.b;
	__DEL(name);
}

void Elems_GetInteger (Texts_Elem e, CHAR *name, LONGINT name__len, LONGINT *i)
{
	Elems_AttrMsg m = {0};
	__DUP(name, name__len, CHAR);
	m.id = 1;
	__COPY(name, m.name, 64);
	(*e->handle)(e, (void*)&m, Elems_AttrMsg__typ);
	*i = m.i;
	__DEL(name);
}

void Elems_GetReal (Texts_Elem e, CHAR *name, LONGINT name__len, REAL *r)
{
	Elems_AttrMsg m = {0};
	__DUP(name, name__len, CHAR);
	m.id = 1;
	__COPY(name, m.name, 64);
	(*e->handle)(e, (void*)&m, Elems_AttrMsg__typ);
	*r = m.r;
	__DEL(name);
}

void Elems_GetLReal (Texts_Elem e, CHAR *name, LONGINT name__len, LONGREAL *lr)
{
	Elems_AttrMsg m = {0};
	__DUP(name, name__len, CHAR);
	m.id = 1;
	__COPY(name, m.name, 64);
	(*e->handle)(e, (void*)&m, Elems_AttrMsg__typ);
	*lr = m.lr;
	__DEL(name);
}

void Elems_GetSet (Texts_Elem e, CHAR *name, LONGINT name__len, SET *s)
{
	Elems_AttrMsg m = {0};
	__DUP(name, name__len, CHAR);
	m.id = 1;
	__COPY(name, m.name, 64);
	(*e->handle)(e, (void*)&m, Elems_AttrMsg__typ);
	*s = m.set;
	__DEL(name);
}

void Elems_GetText (Texts_Elem e, CHAR *name, LONGINT name__len, Texts_Text *t)
{
	Elems_AttrMsg m = {0};
	__DUP(name, name__len, CHAR);
	m.id = 1;
	__COPY(name, m.name, 64);
	(*e->handle)(e, (void*)&m, Elems_AttrMsg__typ);
	*t = m.t;
	__DEL(name);
}

static INTEGER Elems_GetAttrClass (Elems_Attr a)
{
	if (__ISP(a, Elems_BoolDesc, 1)) {
		return 7;
	} else if (__ISP(a, Elems_IntDesc, 1)) {
		return 3;
	} else if (__ISP(a, Elems_RealDesc, 1)) {
		return 4;
	} else if (__ISP(a, Elems_LRealDesc, 1)) {
		return 5;
	} else if (__ISP(a, Elems_StringDesc, 1)) {
		return 2;
	} else if (__ISP(a, Elems_SetAttrDesc, 1)) {
		return 8;
	} else if (__ISP(a, Elems_TextAttrDesc, 1)) {
		return 9;
	} else __WITHCHK;
	__RETCHK;
}

static struct StoreAttributes__55 {
	Files_Rider *r;
	LONGINT *r__typ;
	struct StoreAttributes__55 *lnk;
} *StoreAttributes__55_s;

static void WriteString__56 (Elems_Str s);

static void WriteString__56 (Elems_Str s)
{
	if (s == NIL) {
		Files_WriteString(&*StoreAttributes__55_s->r, StoreAttributes__55_s->r__typ, (CHAR*)"", (LONGINT)1);
	} else {
		Files_WriteString(&*StoreAttributes__55_s->r, StoreAttributes__55_s->r__typ, s->data, s->len[0]);
	}
}

static void Elems_StoreAttributes (Files_Rider *r, LONGINT *r__typ, Elems_Attr attr)
{
	struct StoreAttributes__55 _s;
	_s.r = r; _s.r__typ = r__typ;
	_s.lnk = StoreAttributes__55_s;
	StoreAttributes__55_s = &_s;
	Files_Write(&*r, r__typ, 0x00);
	while (attr != NIL) {
		if (__ISP(attr, Elems_BoolDesc, 1)) {
			Files_WriteInt(&*r, r__typ, 7);
			WriteString__56((*(Elems_BoolAttr*)&attr)->name);
			if ((*(Elems_BoolAttr*)&attr)->b) {
				Files_Write(&*r, r__typ, 0x01);
			} else {
				Files_Write(&*r, r__typ, 0x00);
			}
		} else if (__ISP(attr, Elems_IntDesc, 1)) {
			Files_WriteInt(&*r, r__typ, 3);
			WriteString__56((*(Elems_IntAttr*)&attr)->name);
			Files_WriteLInt(&*r, r__typ, (*(Elems_IntAttr*)&attr)->i);
		} else if (__ISP(attr, Elems_RealDesc, 1)) {
			Files_WriteInt(&*r, r__typ, 4);
			WriteString__56((*(Elems_RealAttr*)&attr)->name);
			Files_WriteReal(&*r, r__typ, (*(Elems_RealAttr*)&attr)->r);
		} else if (__ISP(attr, Elems_LRealDesc, 1)) {
			Files_WriteInt(&*r, r__typ, 5);
			WriteString__56((*(Elems_LRealAttr*)&attr)->name);
			Files_WriteLReal(&*r, r__typ, (*(Elems_LRealAttr*)&attr)->lr);
		} else if (__ISP(attr, Elems_StringDesc, 1)) {
			Files_WriteInt(&*r, r__typ, 2);
			WriteString__56((*(Elems_StringAttr*)&attr)->name);
			WriteString__56((*(Elems_StringAttr*)&attr)->s);
		} else if (__ISP(attr, Elems_SetAttrDesc, 1)) {
			Files_WriteInt(&*r, r__typ, 8);
			WriteString__56((*(Elems_SetAttr*)&attr)->name);
			Files_WriteSet(&*r, r__typ, (*(Elems_SetAttr*)&attr)->s);
		} else if (__ISP(attr, Elems_TextAttrDesc, 1)) {
			Files_WriteInt(&*r, r__typ, 9);
			WriteString__56((*(Elems_TextAttr*)&attr)->name);
			Texts_Store(&*r, r__typ, (*(Elems_TextAttr*)&attr)->t);
		} else __WITHCHK;
		attr = attr->next;
	}
	Files_WriteInt(&*r, r__typ, -1);
	StoreAttributes__55_s = _s.lnk;
}

static void Elems_LoadAttributes (Files_Rider *R, LONGINT *R__typ, Elems_Attr *attr)
{
	INTEGER class = 0;
	Elems_Attr a = NIL, last = NIL;
	Elems_IntAttr ai = NIL;
	Elems_BoolAttr ab = NIL;
	Elems_RealAttr ar = NIL;
	Elems_LRealAttr alr = NIL;
	Elems_StringAttr as = NIL;
	CHAR s[256];
	Elems_SetAttr aset = NIL;
	Elems_TextAttr at = NIL;
	CHAR name[256];
	CHAR ch = 0;
	*attr = NIL;
	Files_Read(&*R, R__typ, (void*)&ch);
	Files_ReadInt(&*R, R__typ, &class);
	while (class > -1 && !(*R).eof) {
		Files_ReadString(&*R, R__typ, (void*)name, 256);
		if (class == 7) {
			Files_Read(&*R, R__typ, (void*)&ch);
			__NEW(ab, Elems_BoolDesc);
			a = (Elems_Attr)ab;
			ab->b = ch == 0x01;
		} else if (class == 3) {
			__NEW(ai, Elems_IntDesc);
			a = (Elems_Attr)ai;
			Files_ReadLInt(&*R, R__typ, &ai->i);
		} else if (class == 4) {
			__NEW(ar, Elems_RealDesc);
			a = (Elems_Attr)ar;
			Files_ReadReal(&*R, R__typ, &ar->r);
		} else if (class == 5) {
			__NEW(alr, Elems_LRealDesc);
			a = (Elems_Attr)alr;
			Files_ReadLReal(&*R, R__typ, &alr->lr);
		} else if (class == 2) {
			Files_ReadString(&*R, R__typ, (void*)s, 256);
			__NEW(as, Elems_StringDesc);
			a = (Elems_Attr)as;
			as->s = Elems_CopyString(s, 256);
		} else if (class == 8) {
			__NEW(aset, Elems_SetAttrDesc);
			a = (Elems_Attr)aset;
			Files_ReadSet(&*R, R__typ, &aset->s);
		} else if (class == 9) {
			__NEW(at, Elems_TextAttrDesc);
			a = (Elems_Attr)at;
			at->t = TextFrames_Text((CHAR*)"", (LONGINT)1);
			Texts_Load(&*R, R__typ, at->t);
		} else {
			__HALT(99);
		}
		a->name = Elems_CopyString(name, 256);
		if (*attr == NIL) {
			*attr = a;
			last = a;
		} else {
			last->next = a;
			last = a;
		}
		Files_ReadInt(&*R, R__typ, &class);
	}
}

static void Elems_CopyAttributes (Elems_Attr src, Elems_Attr *dest)
{
	Elems_Attr attr = NIL, a = NIL, last = NIL;
	Elems_IntAttr ai = NIL;
	Elems_BoolAttr ab = NIL;
	Elems_RealAttr ar = NIL;
	Elems_LRealAttr alr = NIL;
	Elems_StringAttr as = NIL;
	Elems_SetAttr aset = NIL;
	Elems_TextAttr at = NIL;
	a = src;
	*dest = NIL;
	last = NIL;
	while (a != NIL) {
		if (__ISP(a, Elems_BoolDesc, 1)) {
			__NEW(ab, Elems_BoolDesc);
			ab->b = (*(Elems_BoolAttr*)&a)->b;
			attr = (Elems_Attr)ab;
		} else if (__ISP(a, Elems_IntDesc, 1)) {
			__NEW(ai, Elems_IntDesc);
			ai->i = (*(Elems_IntAttr*)&a)->i;
			attr = (Elems_Attr)ai;
		} else if (__ISP(a, Elems_RealDesc, 1)) {
			__NEW(ar, Elems_RealDesc);
			ar->r = (*(Elems_RealAttr*)&a)->r;
			attr = (Elems_Attr)ar;
		} else if (__ISP(a, Elems_LRealDesc, 1)) {
			__NEW(alr, Elems_LRealDesc);
			alr->lr = (*(Elems_LRealAttr*)&a)->lr;
			attr = (Elems_Attr)alr;
		} else if (__ISP(a, Elems_StringDesc, 1)) {
			__NEW(as, Elems_StringDesc);
			as->s = Elems_CopyString((*(Elems_StringAttr*)&a)->s->data, (*(Elems_StringAttr*)&a)->s->len[0]);
			attr = (Elems_Attr)as;
		} else if (__ISP(a, Elems_SetAttrDesc, 1)) {
			__NEW(aset, Elems_SetAttrDesc);
			aset->s = (*(Elems_SetAttr*)&a)->s;
			attr = (Elems_Attr)aset;
		} else if (__ISP(a, Elems_TextAttrDesc, 1)) {
			__NEW(at, Elems_TextAttrDesc);
			at->t = Elems_CopyText((*(Elems_TextAttr*)&a)->t);
			attr = (Elems_Attr)at;
		} else __WITHCHK;
		attr->name = a->name;
		if (*dest == NIL) {
			*dest = attr;
		} else {
			last->next = attr;
		}
		last = attr;
		a = a->next;
	}
}

static Elems_Attr Elems_FindAttribute (CHAR *name, LONGINT name__len, Elems_Attr attr, Elems_Attr *prev)
{
	__DUP(name, name__len, CHAR);
	*prev = attr;
	while (attr != NIL && __STRCMP(attr->name->data, name) != 0) {
		*prev = attr;
		attr = attr->next;
	}
	__DEL(name);
	return attr;
}

static void Elems_DeleteAttribute (CHAR *name, LONGINT name__len, Elems_Attr *attr)
{
	Elems_Attr a = NIL, prev = NIL;
	__DUP(name, name__len, CHAR);
	if (*attr == NIL) {
		__DEL(name);
		return;
	}
	if (__STRCMP(name, (*attr)->name->data) == 0) {
		*attr = (*attr)->next;
	} else {
		a = Elems_FindAttribute(name, name__len, *attr, &prev);
		if (a != NIL) {
			prev->next = a->next;
		} else {
			Elems_Done = 0;
		}
	}
	__DEL(name);
}

static struct SetAttribute__43 {
	Elems_AttrMsg *msg;
	LONGINT *msg__typ;
	Elems_IntAttr *ai;
	Elems_BoolAttr *ab;
	Elems_RealAttr *ar;
	Elems_LRealAttr *alr;
	Elems_StringAttr *as;
	Elems_SetAttr *aset;
	Elems_TextAttr *at;
	struct SetAttribute__43 *lnk;
} *SetAttribute__43_s;

static Elems_Attr NewAttr__44 (void);

static Elems_Attr NewAttr__44 (void)
{
	if ((*SetAttribute__43_s->msg).class == 7) {
		__NEW(*SetAttribute__43_s->ab, Elems_BoolDesc);
		(*SetAttribute__43_s->ab)->b = (*SetAttribute__43_s->msg).b;
		return (void*)(*SetAttribute__43_s->ab);
	} else if ((*SetAttribute__43_s->msg).class == 3) {
		__NEW(*SetAttribute__43_s->ai, Elems_IntDesc);
		(*SetAttribute__43_s->ai)->i = (*SetAttribute__43_s->msg).i;
		return (void*)(*SetAttribute__43_s->ai);
	} else if ((*SetAttribute__43_s->msg).class == 4) {
		__NEW(*SetAttribute__43_s->ar, Elems_RealDesc);
		(*SetAttribute__43_s->ar)->r = (*SetAttribute__43_s->msg).r;
		return (void*)(*SetAttribute__43_s->ar);
	} else if ((*SetAttribute__43_s->msg).class == 5) {
		__NEW(*SetAttribute__43_s->alr, Elems_LRealDesc);
		(*SetAttribute__43_s->alr)->lr = (*SetAttribute__43_s->msg).lr;
		return (void*)(*SetAttribute__43_s->alr);
	} else if ((*SetAttribute__43_s->msg).class == 2) {
		__NEW(*SetAttribute__43_s->as, Elems_StringDesc);
		(*SetAttribute__43_s->as)->s = Elems_CopyString((*SetAttribute__43_s->msg).s, 256);
		return (void*)(*SetAttribute__43_s->as);
	} else if ((*SetAttribute__43_s->msg).class == 8) {
		__NEW(*SetAttribute__43_s->aset, Elems_SetAttrDesc);
		(*SetAttribute__43_s->aset)->s = (*SetAttribute__43_s->msg).set;
		return (void*)(*SetAttribute__43_s->aset);
	} else if ((*SetAttribute__43_s->msg).class == 9) {
		__NEW(*SetAttribute__43_s->at, Elems_TextAttrDesc);
		(*SetAttribute__43_s->at)->t = (*SetAttribute__43_s->msg).t;
		return (void*)(*SetAttribute__43_s->at);
	} else {
		__HALT(98);
	}
	__RETCHK;
}

static void Elems_SetAttribute (Elems_Attr *attr, Elems_AttrMsg *msg, LONGINT *msg__typ)
{
	Elems_Attr a = NIL, prev = NIL;
	Elems_IntAttr ai = NIL;
	Elems_BoolAttr ab = NIL;
	Elems_RealAttr ar = NIL;
	Elems_LRealAttr alr = NIL;
	Elems_StringAttr as = NIL;
	Elems_SetAttr aset = NIL;
	Elems_TextAttr at = NIL;
	struct SetAttribute__43 _s;
	_s.msg = msg; _s.msg__typ = msg__typ;
	_s.ai = &ai;
	_s.ab = &ab;
	_s.ar = &ar;
	_s.alr = &alr;
	_s.as = &as;
	_s.aset = &aset;
	_s.at = &at;
	_s.lnk = SetAttribute__43_s;
	SetAttribute__43_s = &_s;
	if ((*msg).name[0] == 0x00) {
		SetAttribute__43_s = _s.lnk;
		return;
	}
	if (*attr == NIL) {
		*attr = NewAttr__44();
		(*attr)->name = Elems_CopyString((*msg).name, 64);
	} else {
		a = Elems_FindAttribute((*msg).name, 64, *attr, &prev);
		if (a == NIL) {
			a = NewAttr__44();
			a->name = Elems_CopyString((*msg).name, 64);
			prev->next = a;
			a->next = NIL;
		} else {
			if (Elems_GetAttrClass(a) == (*msg).class) {
				if (__ISP(a, Elems_BoolDesc, 1)) {
					(*(Elems_BoolAttr*)&a)->b = (*msg).b;
				} else if (__ISP(a, Elems_IntDesc, 1)) {
					(*(Elems_IntAttr*)&a)->i = (*msg).i;
				} else if (__ISP(a, Elems_RealDesc, 1)) {
					(*(Elems_RealAttr*)&a)->r = (*msg).r;
				} else if (__ISP(a, Elems_LRealDesc, 1)) {
					(*(Elems_LRealAttr*)&a)->lr = (*msg).lr;
				} else if (__ISP(a, Elems_StringDesc, 1)) {
					(*(Elems_StringAttr*)&a)->s = Elems_CopyString((*msg).s, 256);
				} else if (__ISP(a, Elems_SetAttrDesc, 1)) {
					(*(Elems_SetAttr*)&a)->s = (*msg).set;
				} else if (__ISP(a, Elems_TextAttrDesc, 1)) {
					(*(Elems_TextAttr*)&a)->t = (*msg).t;
				} else __WITHCHK;
			} else {
				Elems_Done = 0;
			}
		}
	}
	SetAttribute__43_s = _s.lnk;
}

static void Elems_GetAttribute (Elems_Attr attr, Elems_AttrMsg *msg, LONGINT *msg__typ)
{
	Elems_Attr a = NIL, prev = NIL;
	a = Elems_FindAttribute((*msg).name, 64, attr, &prev);
	if (a == NIL) {
		Elems_Done = 0;
		(*msg).class = 2;
		(*msg).s[0] = 0x00;
		(*msg).hasProps = 0;
		(*msg).set = 0x0;
		(*msg).b = 0;
		(*msg).i = 0;
		(*msg).r = (REAL)0;
		(*msg).lr = (LONGREAL)0;
		(*msg).t = NIL;
	} else {
		if (__ISP(a, Elems_BoolDesc, 1)) {
			(*msg).class = 7;
			(*msg).b = (*(Elems_BoolAttr*)&a)->b;
		} else if (__ISP(a, Elems_IntDesc, 1)) {
			(*msg).class = 3;
			(*msg).i = (*(Elems_IntAttr*)&a)->i;
		} else if (__ISP(a, Elems_RealDesc, 1)) {
			(*msg).class = 4;
			(*msg).r = (*(Elems_RealAttr*)&a)->r;
		} else if (__ISP(a, Elems_LRealDesc, 1)) {
			(*msg).class = 5;
			(*msg).lr = (*(Elems_LRealAttr*)&a)->lr;
		} else if (__ISP(a, Elems_StringDesc, 1)) {
			(*msg).class = 2;
			__COPY((*(Elems_StringAttr*)&a)->s->data, (*msg).s, 256);
		} else if (__ISP(a, Elems_SetAttrDesc, 1)) {
			(*msg).class = 8;
			(*msg).set = (*(Elems_SetAttr*)&a)->s;
		} else if (__ISP(a, Elems_TextAttrDesc, 1)) {
			(*msg).class = 9;
			(*msg).t = (*(Elems_TextAttr*)&a)->t;
		} else __WITHCHK;
	}
}

static void Elems_EnumAttributes (Elems_Attr attr, Elems_EnumNames enum_)
{
	while (attr != NIL) {
		if ((__STRCMP(attr->name->data, "Name") != 0 && __STRCMP(attr->name->data, "Cmd") != 0) && __STRCMP(attr->name->data, "Par") != 0) {
			(*enum_)(attr->name->data, attr->name->len[0], Elems_GetAttrClass(attr));
		}
		attr = attr->next;
	}
}

void Elems_CopyElem (Elems_Elem src, Elems_Elem dest)
{
	Texts_CopyElem((void*)src, (void*)dest);
	Elems_CopyAttributes(src->attr, &dest->attr);
	dest->locked = src->locked;
}

Elems_Elem Elems_NamedElem (CHAR *name, LONGINT name__len, Texts_Text context)
{
	Texts_Reader r = {0};
	BOOLEAN done = 0;
	CHAR ename[256];
	__DUP(name, name__len, CHAR);
	done = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, context, 0);
	Texts_ReadElem(&r, Texts_Reader__typ);
	do {
		if (r.elem != NIL) {
			if (__ISP(r.elem, Elems_ElemDesc, 2)) {
				Elems_GetString(r.elem, (CHAR*)"Name", (LONGINT)5, (void*)ename, 256);
				done = __STRCMP(name, ename) == 0;
			}
		}
		if (!done) {
			Texts_ReadElem(&r, Texts_Reader__typ);
		}
	} while (!(r.eot || done));
	if (!done) {
		__DEL(name);
		return NIL;
	} else {
		__DEL(name);
		return __GUARDP(r.elem, Elems_ElemDesc, 2);
	}
	__RETCHK;
}

void Elems_UpdateElem (Texts_Elem e)
{
	Texts_Text t = NIL;
	LONGINT pos = 0;
	t = Texts_ElemBase(e);
	if (t != NIL) {
		pos = Texts_ElemPos(e);
		(*t->notify)(t, 0, pos, pos + 1);
	}
}

static struct Resize__39 {
	INTEGER *x, *y;
	INTEGER *dx, *dy, *ox, *oy, *h;
	struct Resize__39 *lnk;
} *Resize__39_s;

static void InvertFrame__40 (void);

static void InvertFrame__40 (void)
{
	if ((*Resize__39_s->ox - *Resize__39_s->x) + *Resize__39_s->dx > 0 && ((*Resize__39_s->y - *Resize__39_s->oy) + *Resize__39_s->h) + *Resize__39_s->dy > 0) {
		GUtils_Frame(NIL, 15, *Resize__39_s->x, *Resize__39_s->oy - *Resize__39_s->dy, (*Resize__39_s->ox - *Resize__39_s->x) + *Resize__39_s->dx, ((*Resize__39_s->y - *Resize__39_s->oy) + *Resize__39_s->h) + *Resize__39_s->dy, 1, 2);
	}
}

static void Elems_Resize (Elems_Elem e, INTEGER x, INTEGER y)
{
	SET keys = 0, keysum = 0;
	INTEGER dx = 0, dy = 0, X = 0, Y = 0, ox = 0, oy = 0, h = 0, w = 0;
	struct Resize__39 _s;
	_s.x = &x;
	_s.y = &y;
	_s.dx = &dx;
	_s.dy = &dy;
	_s.ox = &ox;
	_s.oy = &oy;
	_s.h = &h;
	_s.lnk = Resize__39_s;
	Resize__39_s = &_s;
	h = (int)__DIV(e->H, (LONGINT)TextFrames_Unit);
	w = (int)__DIV(e->W, (LONGINT)TextFrames_Unit);
	Input_Mouse(&keys, &X, &Y);
	GUtils_Frame(NIL, 15, x, y, w, h, 1, 2);
	dx = (x + w) - X;
	dy = Y - y;
	ox = X;
	oy = Y;
	keysum = 0x0;
	keys = 0x0;
	do {
		Input_Mouse(&keys, &X, &Y);
		keysum = keysum | keys;
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, X, Y);
		if (ox != X || oy != Y) {
			InvertFrame__40();
			ox = X;
			oy = Y;
			InvertFrame__40();
		}
	} while (!(keys == 0x0 || __IN(0, keysum)));
	InvertFrame__40();
	if (keysum == 0x02) {
		e->W = (ox - x) + dx;
		if (e->W < 1) {
			e->W = 1;
		}
		e->W = e->W * (LONGINT)TextFrames_Unit;
		e->H = ((y - oy) + h) + dy;
		if (e->H < 1) {
			e->H = 1;
		}
		e->H = e->H * (LONGINT)TextFrames_Unit;
	}
	do {
		Input_Mouse(&keys, &X, &Y);
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, X, Y);
	} while (!(keys == 0x0));
	Resize__39_s = _s.lnk;
}

void Elems_Track (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ, BOOLEAN *done)
{
	INTEGER X = 0, Y = 0;
	SET keys = 0;
	*done = 0;
	if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
		TextFrames_TrackMsg *msg__ = (void*)msg;
		if (__ISP(e, Elems_ElemDesc, 2)) {
			if ((*msg__).keys == 0x02) {
				Input_Mouse(&keys, &X, &Y);
				if (!(*(Elems_Elem*)&e)->locked && Elems_InCorner(X, Y, (*msg__).X0, (*msg__).Y0, (int)__DIV((*(Elems_Elem*)&e)->W, (LONGINT)TextFrames_Unit), (void*)(*(Elems_Elem*)&e))) {
					Elems_Resize((*(Elems_Elem*)&e), (*msg__).X0, (*msg__).Y0);
					*done = 1;
				}
			}
		}
	} else __WITHCHK;
}

static void Elems_HandleAttrMsg (Elems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ)
{
	Elems_Done = 1;
	if ((*msg).id == 1) {
		if (__STRCMP((*msg).name, "W") == 0) {
			(*msg).class = 3;
			(*msg).i = (int)__DIV(e->W, (LONGINT)TextFrames_Unit);
		} else if (__STRCMP((*msg).name, "H") == 0) {
			(*msg).class = 3;
			(*msg).i = (int)__DIV(e->H, (LONGINT)TextFrames_Unit);
		} else if (__STRCMP((*msg).name, "Locked") == 0) {
			(*msg).class = 7;
			(*msg).b = e->locked;
		} else if (__STRCMP((*msg).name, "!#cstate") == 0) {
			(*msg).class = 2;
			(*msg).set = 0x0;
		} else {
			Elems_GetAttribute(e->attr, &*msg, msg__typ);
		}
	} else if ((*msg).id == 2) {
		if (__STRCMP((*msg).name, "W") == 0 && (*msg).class == 3) {
			e->W = (*msg).i * (LONGINT)TextFrames_Unit;
		} else if (__STRCMP((*msg).name, "H") == 0 && (*msg).class == 3) {
			e->H = (*msg).i * (LONGINT)TextFrames_Unit;
		} else if (__STRCMP((*msg).name, "Locked") == 0 && (*msg).class == 7) {
			e->locked = (*msg).b;
		} else {
			Elems_SetAttribute(&e->attr, &*msg, msg__typ);
		}
	} else if ((*msg).id == 5) {
		Elems_DeleteAttribute((*msg).name, 64, &e->attr);
	} else if ((*msg).id == 3) {
		(*(*msg).enum_)((CHAR*)"Name", (LONGINT)5, 2);
		(*(*msg).enum_)((CHAR*)"Cmd", (LONGINT)4, 2);
		(*(*msg).enum_)((CHAR*)"Par", (LONGINT)4, 2);
		(*(*msg).enum_)((CHAR*)"W", (LONGINT)2, 3);
		(*(*msg).enum_)((CHAR*)"H", (LONGINT)2, 3);
		(*(*msg).enum_)((CHAR*)"Locked", (LONGINT)7, 7);
		Elems_EnumAttributes(e->attr, (*msg).enum_);
	}
}

void Elems_Init (Elems_Elem e)
{
	e->attr = NIL;
	e->locked = 0;
}

void Elems_GetPar (Elems_Elem e, Texts_Scanner *s, LONGINT *s__typ)
{
	INTEGER ct = 0;
	BOOLEAN ready = 0;
	ct = 0;
	ready = 0;
	Texts_OpenScanner(&*s, s__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&*s, s__typ);
	while ((!ready && ct < 5) && !(*s).eot) {
		if (ct == 0 && __IN((*s).class, 0x06)) {
			Elems_SetString((void*)e, (CHAR*)"Name", (LONGINT)5, (*s).s, 256);
			ct += 1;
		} else if (ct == 1 && __IN((*s).class, 0x06)) {
			Elems_SetString((void*)e, (CHAR*)"Cmd", (LONGINT)4, (*s).s, 256);
			ct += 1;
		} else if (ct == 2 && __IN((*s).class, 0x06)) {
			Elems_SetString((void*)e, (CHAR*)"Par", (LONGINT)4, (*s).s, 256);
			ct += 1;
		} else if (ct == 3 && (*s).class == 3) {
			if ((*s).i > 0) {
				e->W = (*s).i * (LONGINT)TextFrames_Unit;
			}
			ct += 1;
		} else if (ct == 4 && (*s).class == 3) {
			if ((*s).i > 0) {
				e->H = (*s).i * (LONGINT)TextFrames_Unit;
			}
			ct += 1;
		} else {
			ready = 1;
		}
		if (!ready) {
			Texts_Scan(&*s, s__typ);
		}
	}
}

static struct ParseRef__36 {
	CHAR *s;
	LONGINT s__len;
	INTEGER *i;
	struct ParseRef__36 *lnk;
} *ParseRef__36_s;

static void Name__37 (CHAR *n, LONGINT n__len);

static void Name__37 (CHAR *n, LONGINT n__len)
{
	INTEGER j = 0;
	LONGINT len = 0;
	len = n__len;
	j = 0;
	while (((((((LONGINT)j < len && (ParseRef__36_s->s)[__X(*ParseRef__36_s->i, ParseRef__36_s->s__len)] != 0x00) && (ParseRef__36_s->s)[__X(*ParseRef__36_s->i, ParseRef__36_s->s__len)] != '.') && (ParseRef__36_s->s)[__X(*ParseRef__36_s->i, ParseRef__36_s->s__len)] != ' ') && (ParseRef__36_s->s)[__X(*ParseRef__36_s->i, ParseRef__36_s->s__len)] != '\'') && (ParseRef__36_s->s)[__X(*ParseRef__36_s->i, ParseRef__36_s->s__len)] != '%') && (ParseRef__36_s->s)[__X(*ParseRef__36_s->i, ParseRef__36_s->s__len)] != '#') {
		n[__X(j, n__len)] = (ParseRef__36_s->s)[__X(*ParseRef__36_s->i, ParseRef__36_s->s__len)];
		*ParseRef__36_s->i += 1;
		j += 1;
	}
	n[__X(j, n__len)] = 0x00;
}

static void Elems_ParseRef (CHAR *s, LONGINT s__len, CHAR *name1, LONGINT name1__len, CHAR *name2, LONGINT name2__len, INTEGER *i)
{
	struct ParseRef__36 _s;
	__DUP(s, s__len, CHAR);
	_s.s = (void*)s; _s.s__len = s__len;
	_s.i = i;
	_s.lnk = ParseRef__36_s;
	ParseRef__36_s = &_s;
	Name__37((void*)name1, name1__len);
	name2[0] = 0x00;
	if (s[__X(*i, s__len)] == '.') {
		*i += 1;
		Name__37((void*)name2, name2__len);
	}
	ParseRef__36_s = _s.lnk;
	__DEL(s);
}

static void Elems_Error (INTEGER id, INTEGER pos, CHAR *n1, LONGINT n1__len)
{
	__DUP(n1, n1__len, CHAR);
	if (id == 1) {
		Out_String((CHAR*)"-- attrName of ", (LONGINT)16);
		Out_String(n1, n1__len);
		Out_String((CHAR*)" missing : pos ", (LONGINT)16);
		Out_Int(pos, 1);
	} else if (id == 2) {
		Out_String((CHAR*)"-- ", (LONGINT)4);
		Out_String((CHAR*)"Elem <", (LONGINT)7);
		Out_String(n1, n1__len);
		Out_String((CHAR*)"> not found", (LONGINT)12);
	}
	Out_Ln();
	__DEL(n1);
}

void Elems_Expand (Elems_Elem e, CHAR *macro, LONGINT macro__len, Texts_Text *dest)
{
	INTEGER i = 0;
	Elems_Elem refE = NIL;
	CHAR name1[64], name2[64];
	Elems_AttrMsg msg = {0};
	BOOLEAN wasBlank = 0;
	LONGINT selBeg = 0, selEnd = 0, selTime = 0;
	Texts_Text selText = NIL;
	__DUP(macro, macro__len, CHAR);
	*dest = TextFrames_Text((CHAR*)"", (LONGINT)1);
	msg.id = 1;
	i = 0;
	wasBlank = 0;
	while (macro[__X(i, macro__len)] != 0x00) {
		if (macro[__X(i, macro__len)] == '%') {
			i += 1;
			wasBlank = 0;
			Elems_ParseRef(macro, macro__len, (void*)name1, 64, (void*)name2, 64, &i);
			if (name2[0] == 0x00) {
				Elems_Error(1, i, name1, 64);
				__DEL(macro);
				return;
			}
			refE = Elems_NamedElem(name1, 64, Elems_CmdContext);
			if (refE == NIL) {
				Elems_Error(2, 0, name1, 64);
			} else {
				__COPY(name2, msg.name, 64);
				(*refE->handle)((void*)refE, (void*)&msg, Elems_AttrMsg__typ);
				Elems_WriteAttr(&Elems_W, Texts_Writer__typ, msg);
			}
		} else if (macro[__X(i, macro__len)] == '#') {
			i += 1;
			wasBlank = 0;
			Elems_ParseRef(macro, macro__len, (void*)name1, 64, (void*)name2, 64, &i);
			__COPY(name1, msg.name, 64);
			(*e->handle)((void*)e, (void*)&msg, Elems_AttrMsg__typ);
			Elems_WriteAttr(&Elems_W, Texts_Writer__typ, msg);
		} else if (macro[__X(i, macro__len)] == '\\') {
			i += 1;
			wasBlank = 0;
			if (__CAP(macro[__X(i, macro__len)]) == 'S') {
				selTime = 0;
				Oberon_GetSelection(&selText, &selBeg, &selEnd, &selTime);
				if (selText != NIL && selTime >= 0) {
					Texts_Save(selText, selBeg, selEnd, Elems_W.buf);
				}
			} else if (__CAP(macro[__X(i, macro__len)]) == 'N') {
				Texts_WriteLn(&Elems_W, Texts_Writer__typ);
			} else if (__CAP(macro[__X(i, macro__len)]) == 'T') {
				Texts_Write(&Elems_W, Texts_Writer__typ, 0x09);
			} else {
				wasBlank = macro[__X(i, macro__len)] == ' ';
				Texts_Write(&Elems_W, Texts_Writer__typ, macro[__X(i, macro__len)]);
			}
			i += 1;
		} else {
			if (macro[__X(i, macro__len)] == '\'') {
				Texts_Write(&Elems_W, Texts_Writer__typ, '\"');
			} else {
				if (wasBlank || macro[__X(i, macro__len)] != ' ') {
					Texts_Write(&Elems_W, Texts_Writer__typ, macro[__X(i, macro__len)]);
				}
				wasBlank = macro[__X(i, macro__len)] == ' ';
			}
			i += 1;
		}
	}
	Texts_Append(*dest, Elems_W.buf);
	__DEL(macro);
}

void Elems_Call (Elems_Elem e, Texts_Text context, BOOLEAN unload)
{
	Texts_Text ct = NIL, text = NIL;
	CHAR cmd[256], par[256];
	Texts_Reader r = {0};
	INTEGER i = 0;
	CHAR ch = 0;
	Elems_CmdElem = e;
	if (context == NIL) {
		Elems_CmdContext = Texts_ElemBase((void*)e);
	} else {
		Elems_CmdContext = context;
	}
	Elems_GetString((void*)e, (CHAR*)"Cmd", (LONGINT)4, (void*)cmd, 256);
	Elems_Expand(e, cmd, 256, &ct);
	Texts_OpenReader(&r, Texts_Reader__typ, ct, 0);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	i = 0;
	while (!r.eot) {
		if (ch != 0x1c) {
			cmd[__X(i, 256)] = ch;
			i += 1;
		}
		Texts_Read(&r, Texts_Reader__typ, &ch);
	}
	cmd[__X(i, 256)] = 0x00;
	if (cmd[0] == 0x00) {
		return;
	}
	Elems_GetString((void*)e, (CHAR*)"Par", (LONGINT)4, (void*)par, 256);
	Elems_Expand(e, par, 256, &text);
	Elems_DoCall(cmd, 256, Elems_CmdContextV, Elems_CmdFrame, text, 0, unload);
}

void Elems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	BOOLEAN done = 0;
	if (__ISP(e, Elems_ElemDesc, 2)) {
		if (__IS(msg__typ, Elems_AttrMsg, 1)) {
			Elems_AttrMsg *msg__ = (void*)msg;
			Elems_HandleAttrMsg((*(Elems_Elem*)&e), &*msg__, msg__typ);
		} else if (__IS(msg__typ, Elems_TabStopMsg, 1)) {
			Elems_TabStopMsg *msg__ = (void*)msg;
			(*msg__).accepted = 0;
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *msg__ = (void*)msg;
			if ((*msg__).id == 0) {
				Elems_LoadAttributes(&(*msg__).r, Files_Rider__typ, &(*(Elems_Elem*)&e)->attr);
				Files_ReadBool(&(*msg__).r, Files_Rider__typ, &(*(Elems_Elem*)&e)->locked);
			} else if ((*msg__).id == 1) {
				Elems_StoreAttributes(&(*msg__).r, Files_Rider__typ, (*(Elems_Elem*)&e)->attr);
				Files_WriteBool(&(*msg__).r, Files_Rider__typ, (*(Elems_Elem*)&e)->locked);
			}
		} else if (__IS(msg__typ, Elems_ExecMsg, 1)) {
			Elems_ExecMsg *msg__ = (void*)msg;
			Elems_SetContext((*msg__).x, (*msg__).y, (*msg__).f);
			Elems_Call((*(Elems_Elem*)&e), (*msg__).context, (*msg__).unload);
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *msg__ = (void*)msg;
			Elems_Track((void*)(*(Elems_Elem*)&e), (void*)&*msg__, msg__typ, &done);
			if (done) {
				Elems_UpdateElem((void*)(*(Elems_Elem*)&e));
				(*msg__).keys = 0x0;
			}
		}
	} else __WITHCHK;
}

static void EnumPtrs(void (*P)(void*))
{
	P(Elems_CmdContext);
	P(Elems_CmdFrame);
	P(Elems_CmdElem);
	P(Elems_CmdContextV);
	__ENUMR(&Elems_W, Texts_Writer__typ, 36, 1, P);
}

__TDESC(Elems_AttrDesc, 1, 2) = {__TDFLDS("AttrDesc", 8), {0, 4, -12}};
__TDESC(Elems_BoolDesc, 1, 2) = {__TDFLDS("BoolDesc", 12), {0, 4, -12}};
__TDESC(Elems_IntDesc, 1, 2) = {__TDFLDS("IntDesc", 12), {0, 4, -12}};
__TDESC(Elems_RealDesc, 1, 2) = {__TDFLDS("RealDesc", 12), {0, 4, -12}};
__TDESC(Elems_LRealDesc, 1, 2) = {__TDFLDS("LRealDesc", 16), {0, 4, -12}};
__TDESC(Elems_StringDesc, 1, 3) = {__TDFLDS("StringDesc", 12), {0, 4, 8, -16}};
__TDESC(Elems_SetAttrDesc, 1, 2) = {__TDFLDS("SetAttrDesc", 12), {0, 4, -12}};
__TDESC(Elems_TextAttrDesc, 1, 3) = {__TDFLDS("TextAttrDesc", 12), {0, 4, 8, -16}};
__TDESC(Elems_ElemDesc, 1, 5) = {__TDFLDS("ElemDesc", 44), {0, 4, 12, 32, 36, -24}};
__TDESC(Elems_AttrMsg, 1, 1) = {__TDFLDS("AttrMsg", 368), {360, -8}};
__TDESC(Elems_GetContextMsg, 1, 2) = {__TDFLDS("GetContextMsg", 12), {4, 8, -12}};
__TDESC(Elems_GetFrameMsg, 1, 2) = {__TDFLDS("GetFrameMsg", 8), {0, 4, -12}};
__TDESC(Elems_TabStopMsg, 1, 0) = {__TDFLDS("TabStopMsg", 1), {-4}};
__TDESC(Elems_ExecMsg, 1, 3) = {__TDFLDS("ExecMsg", 20), {0, 12, 16, -16}};
__TDESC(Elems_OverlapMsg, 1, 0) = {__TDFLDS("OverlapMsg", 18), {-4}};
__TDESC(Elems_TaskDesc, 1, 2) = {__TDFLDS("TaskDesc", 24), {0, 20, -12}};

export void *Elems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(GUtils);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(Out);
	__IMPORT(Strings);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(Elems, EnumPtrs);
	__INITYP(Elems_AttrDesc, Elems_AttrDesc, 0);
	__INITYP(Elems_BoolDesc, Elems_AttrDesc, 1);
	__INITYP(Elems_IntDesc, Elems_AttrDesc, 1);
	__INITYP(Elems_RealDesc, Elems_AttrDesc, 1);
	__INITYP(Elems_LRealDesc, Elems_AttrDesc, 1);
	__INITYP(Elems_StringDesc, Elems_AttrDesc, 1);
	__INITYP(Elems_SetAttrDesc, Elems_AttrDesc, 1);
	__INITYP(Elems_TextAttrDesc, Elems_AttrDesc, 1);
	__INITYP(Elems_ElemDesc, Texts_ElemDesc, 2);
	__INITYP(Elems_AttrMsg, Texts_ElemMsg, 1);
	__INITYP(Elems_GetContextMsg, Display_FrameMsg, 1);
	__INITYP(Elems_GetFrameMsg, Display_FrameMsg, 1);
	__INITYP(Elems_TabStopMsg, Texts_ElemMsg, 1);
	__INITYP(Elems_ExecMsg, Texts_ElemMsg, 1);
	__INITYP(Elems_OverlapMsg, Texts_ElemMsg, 1);
	__INITYP(Elems_TaskDesc, Oberon_TaskDesc, 1);
/* BEGIN */
	Texts_OpenWriter(&Elems_W, Texts_Writer__typ);
	Elems_clp = 3;
	__ENDMOD;
}
