/* Ofront 1.4 -xtspkaG */

#ifndef Elems__h
#define Elems__h

#include "SYSTEM.h"
#include "Display.h"
#include "Fonts.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	void (*Elems_EnumNames)(CHAR*, LONGINT , INTEGER);

typedef
	struct Elems_AttrMsg { /* Texts_ElemMsg */
		INTEGER id;
		BOOLEAN hasProps;
		Elems_EnumNames enum_;
		CHAR name[64];
		INTEGER class;
		CHAR s[256];
		SET set;
		BOOLEAN b;
		LONGINT i;
		REAL r;
		LONGREAL lr;
		Texts_Text t;
	} Elems_AttrMsg;

typedef
	struct Elems_ElemDesc *Elems_Elem;

typedef
	struct Elems_ElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[8];
		BOOLEAN locked;
	} Elems_ElemDesc;

typedef
	struct Elems_ExecMsg { /* Texts_ElemMsg */
		Elems_Elem e;
		INTEGER x, y;
		BOOLEAN unload;
		Display_Frame f;
		Texts_Text context;
	} Elems_ExecMsg;

typedef
	struct Elems_GetContextMsg { /* Display_FrameMsg */
		INTEGER fx, fy;
		Texts_Elem p;
		Display_Frame context;
	} Elems_GetContextMsg;

typedef
	struct Elems_GetFrameMsg { /* Display_FrameMsg */
		Display_Frame f;
		Texts_Elem e;
	} Elems_GetFrameMsg;

typedef
	struct Elems_OverlapMsg { /* Texts_ElemMsg */
		INTEGER x, y, w, h, ex, ey, ew, eh;
		BOOLEAN overlaps;
	} Elems_OverlapMsg;

typedef
	struct Elems_TabStopMsg { /* Texts_ElemMsg */
		BOOLEAN accepted;
	} Elems_TabStopMsg;


import Texts_Text Elems_CmdContext;
import Display_Frame Elems_CmdFrame;
import Elems_Elem Elems_CmdElem;
import SHORTINT Elems_clp;
import BOOLEAN Elems_Done;

import LONGINT *Elems_ElemDesc__typ;
import LONGINT *Elems_AttrMsg__typ;
import LONGINT *Elems_GetContextMsg__typ;
import LONGINT *Elems_GetFrameMsg__typ;
import LONGINT *Elems_TabStopMsg__typ;
import LONGINT *Elems_ExecMsg__typ;
import LONGINT *Elems_OverlapMsg__typ;

import void Elems_AdjustSubFrame (Display_Frame f, Display_Frame sub);
import void Elems_Call (Elems_Elem e, Texts_Text context, BOOLEAN unload);
import void Elems_CopyElem (Elems_Elem src, Elems_Elem dest);
import Texts_Text Elems_CopyText (Texts_Text T);
import Elems_Elem Elems_CreateElem (CHAR *generator, LONGINT generator__len);
import void Elems_DoCall (CHAR *cmd, LONGINT cmd__len, Viewers_Viewer v, Display_Frame f, Texts_Text partext, LONGINT pos, BOOLEAN free);
import void Elems_Expand (Elems_Elem e, CHAR *macro, LONGINT macro__len, Texts_Text *dest);
import void Elems_Focusing (TextFrames_FocusMsg msg);
import void Elems_GetBoolean (Texts_Elem e, CHAR *name, LONGINT name__len, BOOLEAN *b);
import INTEGER Elems_GetClass (Texts_Elem e, CHAR *name, LONGINT name__len);
import void Elems_GetInteger (Texts_Elem e, CHAR *name, LONGINT name__len, LONGINT *i);
import void Elems_GetLReal (Texts_Elem e, CHAR *name, LONGINT name__len, LONGREAL *lr);
import void Elems_GetLook (Texts_Elem e, Fonts_Font *fnt, SHORTINT *col);
import void Elems_GetPar (Elems_Elem e, Texts_Scanner *s, LONGINT *s__typ);
import void Elems_GetReal (Texts_Elem e, CHAR *name, LONGINT name__len, REAL *r);
import void Elems_GetSet (Texts_Elem e, CHAR *name, LONGINT name__len, SET *s);
import void Elems_GetString (Texts_Elem e, CHAR *name, LONGINT name__len, CHAR *s, LONGINT s__len);
import void Elems_GetText (Texts_Elem e, CHAR *name, LONGINT name__len, Texts_Text *t);
import void Elems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
import BOOLEAN Elems_InCorner (INTEGER mX, INTEGER mY, INTEGER x, INTEGER y, INTEGER w, Texts_Elem e);
import void Elems_Init (Elems_Elem e);
import void Elems_IntToString (LONGINT i, CHAR *s, LONGINT s__len);
import Elems_Elem Elems_NamedElem (CHAR *name, LONGINT name__len, Texts_Text context);
import INTEGER Elems_Scale (INTEGER val);
import void Elems_SetBoolean (Texts_Elem e, CHAR *name, LONGINT name__len, BOOLEAN b);
import void Elems_SetContext (INTEGER x, INTEGER y, Display_Frame f);
import void Elems_SetFont (Texts_Elem e, CHAR *name, LONGINT name__len, SET sel, Fonts_Font f, SHORTINT col, SHORTINT voff);
import void Elems_SetInteger (Texts_Elem e, CHAR *name, LONGINT name__len, LONGINT i);
import void Elems_SetLReal (Texts_Elem e, CHAR *name, LONGINT name__len, LONGREAL lr);
import void Elems_SetReal (Texts_Elem e, CHAR *name, LONGINT name__len, REAL r);
import void Elems_SetSet (Texts_Elem e, CHAR *name, LONGINT name__len, SET s);
import void Elems_SetString (Texts_Elem e, CHAR *name, LONGINT name__len, CHAR *s, LONGINT s__len);
import void Elems_SetText (Texts_Elem e, CHAR *name, LONGINT name__len, Texts_Text t);
import INTEGER Elems_StringLength (CHAR *str, LONGINT str__len);
import void Elems_TabStop (Elems_Elem e, Display_Frame f);
import void Elems_ToFrame (Texts_Elem e, TextFrames_TrackMsg msg);
import void Elems_Track (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ, BOOLEAN *done);
import void Elems_UpdateElem (Texts_Elem e);
import void Elems_WriteAttr (Texts_Writer *W, LONGINT *W__typ, Elems_AttrMsg attr);
import void *Elems__init(void);


#endif
