/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Dates.h"
#include "Directories.h"
#include "Display.h"
#include "Documents.h"
#include "Elems.h"
#include "Fonts.h"
#include "In.h"
#include "Kernel.h"
#include "MathL.h"
#include "MathLX.h"
#include "Oberon.h"
#include "Out.h"
#include "Panel.h"
#include "PanelElems.h"
#include "ParcElems.h"
#include "Strings.h"
#include "StyleElems.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Types.h"
#include "Viewers.h"
#include "XIn.h"

typedef
	struct ElemsUI_StyleElemDesc *ElemsUI_StyleElem;

typedef
	struct ElemsUI_StyleElemDesc {
		StyleElems_Parc styleElem;
		ElemsUI_StyleElem next;
	} ElemsUI_StyleElemDesc;


static Texts_Text ElemsUI_t;
static Viewers_Viewer ElemsUI_vwr;
static LONGINT ElemsUI_selbeg, ElemsUI_selend;
static Texts_Text ElemsUI_ct, ElemsUI_parText;
static Oberon_ParList ElemsUI_par;
static Texts_Text ElemsUI_orgLog, ElemsUI_newLog;
static Texts_Writer ElemsUI_W, ElemsUI_W1;
static ElemsUI_StyleElem ElemsUI_styleElems;
static CHAR ElemsUI_pattern[10];
static LONGINT (*ElemsUI_GetLogicalDriveStrings)(LONGINT, LONGINT);
static SET ElemsUI_enumMode;
static Oberon_ParList ElemsUI_filesPar;
static BOOLEAN ElemsUI_invert, ElemsUI_rad;
static INTEGER ElemsUI_base, ElemsUI_err;
static LONGREAL ElemsUI_value;
static CHAR ElemsUI_errmsg[30];
static CHAR ElemsUI_res[64];
static Elems_Elem ElemsUI_e;

export LONGINT *ElemsUI_StyleElemDesc__typ;

export void ElemsUI_ApplyFont (void);
export void ElemsUI_ApplyParc (void);
static LONGREAL ElemsUI_Atom (Texts_Reader *r, LONGINT *r__typ, CHAR *ch);
export void ElemsUI_CalcIn (void);
static void ElemsUI_Call (CHAR *cmd, LONGINT cmd__len);
static void ElemsUI_ChangeTo (CHAR *path, LONGINT path__len);
static void ElemsUI_Comp (CHAR *command, LONGINT command__len);
static void ElemsUI_CreateDriveList (void);
static void ElemsUI_CreateFileList (CHAR *path, LONGINT path__len, SET mode);
static void ElemsUI_CreatePatternList (void);
static void ElemsUI_EnumFiles (Directories_Directory d, CHAR *name, LONGINT name__len, BOOLEAN isDir, BOOLEAN *continue_);
static LONGREAL ElemsUI_EvalFunc (CHAR *f, LONGINT f__len, LONGREAL v);
static LONGREAL ElemsUI_Expr (Texts_Reader *r, LONGINT *r__typ, CHAR *ch);
static LONGREAL ElemsUI_Factor (Texts_Reader *r, LONGINT *r__typ, CHAR *ch);
export void ElemsUI_FoldsCompile (void);
static LONGREAL ElemsUI_FuncOrConst (Texts_Reader *r, LONGINT *r__typ, CHAR *ch);
static void ElemsUI_GenPrintParams (void);
static void ElemsUI_GetCalcSettings (void);
static void ElemsUI_GetStyles (BOOLEAN all);
export void ElemsUI_HelpSearch (void);
export void ElemsUI_InitCalcPanel (void);
export void ElemsUI_InitFilesPanel (void);
export void ElemsUI_InitParcPanel (void);
export void ElemsUI_InspectCharacter (void);
export void ElemsUI_InspectParc (void);
static BOOLEAN ElemsUI_IsChar (CHAR ch);
static BOOLEAN ElemsUI_IsCharacter (CHAR ch);
static BOOLEAN ElemsUI_IsDigit (CHAR ch);
static BOOLEAN ElemsUI_IsHex (CHAR ch);
static BOOLEAN ElemsUI_IsNumber (CHAR ch);
static void ElemsUI_N (Texts_Reader *r, LONGINT *r__typ, CHAR *ch);
static void ElemsUI_NoNotify (Texts_Text t, INTEGER op, LONGINT beg, LONGINT end);
static LONGREAL ElemsUI_Number (Texts_Reader *r, LONGINT *r__typ, CHAR *ch);
static BOOLEAN ElemsUI_On (CHAR *s, LONGINT s__len);
export void ElemsUI_OpenFilesPanel (void);
static void ElemsUI_Opt (CHAR *s, LONGINT s__len);
export void ElemsUI_Print (void);
static void ElemsUI_RestoreSelection (void);
static void ElemsUI_Scan (Texts_Scanner *s, LONGINT *s__typ, CHAR *st, LONGINT st__len);
export void ElemsUI_SearchPattern (void);
export void ElemsUI_SetCalcType (void);
static void ElemsUI_SetCheckBox (CHAR *s, LONGINT s__len, BOOLEAN on, BOOLEAN update);
static void ElemsUI_SetPathValue (CHAR *path, LONGINT path__len);
static void ElemsUI_SetRadio (CHAR *name, LONGINT name__len, CHAR *val, LONGINT val__len);
export void ElemsUI_ShowPrintString (void);
export void ElemsUI_ShowResult (void);
static void ElemsUI_StoreLog (void);
static void ElemsUI_StoreSelection (void);
export void ElemsUI_Style (void);
static LONGREAL ElemsUI_Term (Texts_Reader *r, LONGINT *r__typ, CHAR *ch);
static StyleElems_Parc ElemsUI_ThisStyleElem (CHAR *n, LONGINT n__len);
export void ElemsUI_UpdateCalender (void);
export void ElemsUI_UpdatePath (void);
export void ElemsUI_UpdateWorkPath (void);
static void ElemsUI_WriteString (CHAR *name, LONGINT name__len, CHAR *opt, LONGINT opt__len);
static void ElemsUI_WriteStyles (void);


static void ElemsUI_NoNotify (Texts_Text t, INTEGER op, LONGINT beg, LONGINT end)
{
}

static void ElemsUI_Call (CHAR *cmd, LONGINT cmd__len)
{
	__DUP(cmd, cmd__len, CHAR);
	Texts_Delete(ElemsUI_parText, 0, ElemsUI_parText->len);
	Texts_Append(ElemsUI_parText, ElemsUI_W.buf);
	Elems_DoCall(cmd, cmd__len, Oberon_Par->vwr, Oberon_Par->frame, ElemsUI_parText, 0, 0);
	__DEL(cmd);
}

static void ElemsUI_StoreLog (void)
{
	ElemsUI_newLog = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Oberon_Log = ElemsUI_newLog;
}

static void ElemsUI_Opt (CHAR *s, LONGINT s__len)
{
	__DUP(s, s__len, CHAR);
	if (s[0] != 0x00) {
		Texts_Write(&ElemsUI_W, Texts_Writer__typ, '\\');
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, s, s__len);
	}
	__DEL(s);
}

static void ElemsUI_WriteString (CHAR *name, LONGINT name__len, CHAR *opt, LONGINT opt__len)
{
	Elems_Elem e = NIL;
	CHAR s[256];
	__DUP(name, name__len, CHAR);
	__DUP(opt, opt__len, CHAR);
	e = Elems_NamedElem(name, name__len, ElemsUI_ct);
	Elems_GetString((void*)e, (CHAR*)"Value", (LONGINT)6, (void*)s, 256);
	if (s[0] != 0x00) {
		ElemsUI_Opt(opt, opt__len);
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, s, 256);
		Texts_Write(&ElemsUI_W, Texts_Writer__typ, ' ');
	}
	__DEL(name);
	__DEL(opt);
}

static BOOLEAN ElemsUI_On (CHAR *s, LONGINT s__len)
{
	BOOLEAN b = 0;
	__DUP(s, s__len, CHAR);
	Elems_GetBoolean((void*)Elems_NamedElem(s, s__len, ElemsUI_ct), (CHAR*)"Value", (LONGINT)6, &b);
	__DEL(s);
	return b;
}

static void ElemsUI_SetCheckBox (CHAR *s, LONGINT s__len, BOOLEAN on, BOOLEAN update)
{
	Elems_Elem e = NIL;
	__DUP(s, s__len, CHAR);
	e = Elems_NamedElem(s, s__len, ElemsUI_ct);
	Elems_SetBoolean((void*)e, (CHAR*)"Value", (LONGINT)6, on);
	if (update) {
		Elems_UpdateElem((void*)e);
	}
	__DEL(s);
}

static void ElemsUI_SetRadio (CHAR *name, LONGINT name__len, CHAR *val, LONGINT val__len)
{
	Elems_Elem e = NIL;
	__DUP(name, name__len, CHAR);
	__DUP(val, val__len, CHAR);
	e = Elems_NamedElem(name, name__len, ElemsUI_ct);
	Elems_SetString((void*)e, (CHAR*)"Value", (LONGINT)6, val, val__len);
	__DEL(name);
	__DEL(val);
}

static void ElemsUI_Scan (Texts_Scanner *s, LONGINT *s__typ, CHAR *st, LONGINT st__len)
{
	__DUP(st, st__len, CHAR);
	Texts_OpenScanner(&*s, s__typ, ElemsUI_newLog, 0);
	Texts_Scan(&*s, s__typ);
	if (__STRCMP(st, "int") == 0) {
		(*s).i = 0;
		while (!(*s).eot && (*s).class != 3) {
			Texts_Scan(&*s, s__typ);
		}
	} else {
		(*s).s[0] = 0x00;
		while (!(*s).eot && __STRCMP((*s).s, st) != 0) {
			Texts_Scan(&*s, s__typ);
		}
		Texts_Scan(&*s, s__typ);
	}
	__DEL(st);
}

static BOOLEAN ElemsUI_IsCharacter (CHAR ch)
{
	return __CAP(ch) >= 'A' && __CAP(ch) <= 'Z';
}

static BOOLEAN ElemsUI_IsDigit (CHAR ch)
{
	return ch >= '0' && ch <= '9';
}

static struct Comp__9 {
	Texts_Text *t;
	CHAR (*opt)[20];
	LONGINT *beg, *end;
	INTEGER *i, *j;
	struct Comp__9 *lnk;
} *Comp__9_s;

static void Do__10 (void);

static void Do__10 (void)
{
	CHAR ch = 0;
	BOOLEAN error = 0;
	Texts_Scanner scanner = {0};
	INTEGER line = 0;
	error = 0;
	Texts_OpenScanner(&scanner, Texts_Scanner__typ, *Comp__9_s->t, *Comp__9_s->beg);
	Texts_Scan(&scanner, Texts_Scanner__typ);
	while ((__IN(scanner.class, 0x06) && Texts_Pos((void*)&scanner, Texts_Scanner__typ) - (LONGINT)scanner.len <= *Comp__9_s->end) && !error) {
		Texts_OpenWriter(&ElemsUI_W, Texts_Writer__typ);
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, scanner.s, 256);
		line = scanner.line;
		(*Comp__9_s->opt)[__X(*Comp__9_s->j, 20)] = 0x00;
		*Comp__9_s->i = *Comp__9_s->j;
		Texts_Scan(&scanner, Texts_Scanner__typ);
		if ((scanner.line == line && scanner.class == 6) && scanner.c == '\\') {
			ch = scanner.nextCh;
			while ((ch >= '0' && ch <= '9' || ch >= 'a' && ch <= 'z') && *Comp__9_s->i < 19) {
				(*Comp__9_s->opt)[__X(*Comp__9_s->i, 20)] = ch;
				*Comp__9_s->i += 1;
				Texts_Read((void*)&scanner, Texts_Scanner__typ, &ch);
			}
			scanner.nextCh = ch;
			Texts_Scan(&scanner, Texts_Scanner__typ);
		}
		(*Comp__9_s->opt)[__X(*Comp__9_s->i, 20)] = 0x00;
	}
}

static void ElemsUI_Comp (CHAR *command, LONGINT command__len)
{
	Texts_Text t = NIL;
	CHAR opt[20], s[20];
	INTEGER res = 0;
	LONGINT beg = 0, end = 0, time = 0;
	INTEGER i = 0, j = 0;
	struct Comp__9 _s;
	__DUP(command, command__len, CHAR);
	_s.t = &t;
	_s.opt = (void*)opt;
	_s.beg = &beg;
	_s.end = &end;
	_s.i = &i;
	_s.j = &j;
	_s.lnk = Comp__9_s;
	Comp__9_s = &_s;
	ElemsUI_ct = Elems_CmdContext;
	__NEW(ElemsUI_par, Oberon_ParRec);
	ElemsUI_par->text = TextFrames_Text((CHAR*)"", (LONGINT)1);
	i = 0;
	if (ElemsUI_On((CHAR*)"idx", (LONGINT)4)) {
		opt[__X(i, 20)] = 'x';
		i += 1;
	}
	if (ElemsUI_On((CHAR*)"type", (LONGINT)5)) {
		opt[__X(i, 20)] = 't';
		i += 1;
	}
	if (ElemsUI_On((CHAR*)"nil", (LONGINT)4)) {
		opt[__X(i, 20)] = 'n';
		i += 1;
	}
	if (ElemsUI_On((CHAR*)"init", (LONGINT)5)) {
		opt[__X(i, 20)] = 'p';
		i += 1;
	}
	if (ElemsUI_On((CHAR*)"assert", (LONGINT)7)) {
		opt[__X(i, 20)] = 's';
		i += 1;
	}
	if (ElemsUI_On((CHAR*)"pc", (LONGINT)3)) {
		opt[__X(i, 20)] = 'f';
		i += 1;
	}
	opt[__X(i, 20)] = 0x00;
	j = i;
	Elems_GetString((void*)Elems_NamedElem((CHAR*)"source", (LONGINT)7, ElemsUI_ct), (CHAR*)"Value", (LONGINT)6, (void*)s, 20);
	if (__STRCMP(s, "sel") == 0) {
		Oberon_GetSelection(&t, &beg, &end, &time);
		if (time >= 0) {
			Do__10();
		}
	} else if (__STRCMP(s, "viewer") == 0) {
		Texts_Write(&ElemsUI_W, Texts_Writer__typ, '*');
		Texts_Write(&ElemsUI_W, Texts_Writer__typ, '\\');
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, opt, 20);
		Texts_Append(ElemsUI_par->text, ElemsUI_W.buf);
		ElemsUI_par->vwr = Oberon_MarkedViewer();
		if ((ElemsUI_par->vwr != NIL && ElemsUI_par->vwr->dsc != NIL) && __ISP(ElemsUI_par->vwr->dsc->next, TextFrames_FrameDesc, 1)) {
			ElemsUI_par->frame = (Display_Frame)__GUARDP(ElemsUI_par->vwr->dsc->next, TextFrames_FrameDesc, 1);
		} else {
			ElemsUI_par->frame = NIL;
		}
		Oberon_Call(command, command__len, ElemsUI_par, 0, &res);
		ElemsUI_Call((CHAR*)"Folds.ShowError", (LONGINT)16);
	} else if (__STRCMP(s, "list") == 0) {
		Elems_GetText((void*)Elems_NamedElem((CHAR*)"files", (LONGINT)6, ElemsUI_ct), (CHAR*)"ValueT", (LONGINT)7, &t);
		if (t->len > 0) {
			beg = 0;
			end = t->len;
			Do__10();
		}
	}
	Comp__9_s = _s.lnk;
	__DEL(command);
}

void ElemsUI_FoldsCompile (void)
{
	ElemsUI_Comp((CHAR*)"Folds.Compile", (LONGINT)14);
}

static void ElemsUI_StoreSelection (void)
{
	LONGINT beg = 0, end = 0, time = 0;
	XIn_GetSelectionViewer(&ElemsUI_vwr, &ElemsUI_t, &time, &beg, &end);
	if (((ElemsUI_t != NIL && ElemsUI_vwr->dsc != NIL) && ElemsUI_vwr->dsc->next != NIL) && __ISP(ElemsUI_vwr->dsc->next, TextFrames_FrameDesc, 1)) {
		ElemsUI_selbeg = beg;
		ElemsUI_selend = end;
	} else {
		ElemsUI_selbeg = -1;
		ElemsUI_selend = -1;
	}
}

static void ElemsUI_RestoreSelection (void)
{
	if ((ElemsUI_vwr->dsc != NIL && ElemsUI_vwr->dsc->next != NIL) && __ISP(ElemsUI_vwr->dsc->next, TextFrames_FrameDesc, 1)) {
		TextFrames_SetSelection(__GUARDP(ElemsUI_vwr->dsc->next, TextFrames_FrameDesc, 1), ElemsUI_selbeg, ElemsUI_selend);
	}
}

static StyleElems_Parc ElemsUI_ThisStyleElem (CHAR *n, LONGINT n__len)
{
	ElemsUI_StyleElem next = NIL;
	StyleElems_Parc new = NIL;
	next = ElemsUI_styleElems;
	while (next != NIL && __STRCMP(next->styleElem->name, n) != 0) {
		next = next->next;
	}
	if (next != NIL) {
		__NEW(new, StyleElems_ParcDesc);
		StyleElems_Copy(next->styleElem, new);
	}
	return new;
}

static void ElemsUI_WriteStyles (void)
{
	ElemsUI_StyleElem help = NIL;
	Texts_Text t = NIL;
	Texts_WriteLn(&ElemsUI_W, Texts_Writer__typ);
	help = ElemsUI_styleElems;
	while (help != NIL) {
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, help->styleElem->name, 32);
		Texts_WriteLn(&ElemsUI_W, Texts_Writer__typ);
		help = help->next;
	}
	Elems_GetText((void*)Elems_NamedElem((CHAR*)"styles", (LONGINT)7, ElemsUI_ct), (CHAR*)"ValueT", (LONGINT)7, &t);
	Texts_Delete(t, 0, t->len);
	Texts_Append(t, ElemsUI_W.buf);
}

static struct GetStyles__25 {
	struct GetStyles__25 *lnk;
} *GetStyles__25_s;

static void AddStyles__26 (Texts_Text t);

static void AddStyles__26 (Texts_Text t)
{
	ElemsUI_StyleElem elem = NIL, next = NIL;
	Texts_Reader r = {0};
	Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
	Texts_ReadElem(&r, Texts_Reader__typ);
	while (!r.eot) {
		if (__ISP(r.elem, StyleElems_ParcDesc, 3)) {
			next = ElemsUI_styleElems;
			while (next != NIL && __STRCMP(next->styleElem->name, __GUARDP(r.elem, StyleElems_ParcDesc, 3)->name) != 0) {
				next = next->next;
			}
			if (next == NIL) {
				__NEW(elem, ElemsUI_StyleElemDesc);
				elem->styleElem = __GUARDP(r.elem, StyleElems_ParcDesc, 3);
				elem->next = ElemsUI_styleElems;
				ElemsUI_styleElems = elem;
			}
		}
		Texts_ReadElem(&r, Texts_Reader__typ);
	}
}

static void ElemsUI_GetStyles (BOOLEAN all)
{
	Texts_Text t = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	struct GetStyles__25 _s;
	_s.lnk = GetStyles__25_s;
	GetStyles__25_s = &_s;
	if (all) {
		ElemsUI_styleElems = NIL;
		t = TextFrames_Text((CHAR*)"", (LONGINT)1);
		Texts_Open(t, (CHAR*)"Styles.Text", (LONGINT)12);
		AddStyles__26(t);
	}
	Oberon_GetSelection(&t, &beg, &end, &time);
	if (time >= 0) {
		AddStyles__26(t);
	}
	if (!all) {
		ElemsUI_WriteStyles();
	}
	GetStyles__25_s = _s.lnk;
}

static struct Style__67 {
	struct Style__67 *lnk;
} *Style__67_s;

static void Replace__68 (Texts_Text *t, Texts_Reader *r, LONGINT *r__typ, StyleElems_Parc styleElem);

static void Replace__68 (Texts_Text *t, Texts_Reader *r, LONGINT *r__typ, StyleElems_Parc styleElem)
{
	Texts_Delete(*t, Texts_Pos(&*r, r__typ) - 1, Texts_Pos(&*r, r__typ));
	Texts_WriteElem(&ElemsUI_W, Texts_Writer__typ, (void*)styleElem);
	Texts_Insert(*t, Texts_Pos(&*r, r__typ) - 1, ElemsUI_W.buf);
}

void ElemsUI_Style (void)
{
	CHAR name[64];
	Texts_Text t = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_Reader r = {0};
	Texts_Elem elem = NIL;
	StyleElems_Parc styleElem = NIL, newElem = NIL;
	TextFrames_Frame f = NIL;
	struct Style__67 _s;
	_s.lnk = Style__67_s;
	Style__67_s = &_s;
	ElemsUI_ct = Elems_CmdContext;
	Oberon_GetSelection(&t, &beg, &end, &time);
	Elems_GetString((void*)Elems_NamedElem((CHAR*)"styles", (LONGINT)7, ElemsUI_ct), (CHAR*)"Value", (LONGINT)6, (void*)name, 64);
	if (name[0] == 0x00) {
		Style__67_s = _s.lnk;
		return;
	}
	f = XIn_FocusFrame(1);
	if (f != NIL) {
		if (name[0] != 0x00) {
			styleElem = ElemsUI_ThisStyleElem((void*)name, 64);
			__NEW(newElem, StyleElems_ParcDesc);
			if (styleElem != NIL) {
				StyleElems_Copy(styleElem, newElem);
				Texts_WriteElem(&ElemsUI_W, Texts_Writer__typ, (void*)newElem);
				Texts_Insert(f->text, f->carloc.pos, ElemsUI_W.buf);
			} else {
				Out_String((CHAR*)"-- unknown style name: ", (LONGINT)24);
				Out_String(name, 64);
				Out_Ln();
			}
		} else {
			Out_String((CHAR*)"-- no stylename given", (LONGINT)22);
			Out_Ln();
		}
	} else {
		Oberon_GetSelection(&t, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenReader(&r, Texts_Reader__typ, t, beg);
			Texts_ReadElem(&r, Texts_Reader__typ);
			if (name[0] != 0x00) {
				elem = r.elem;
				if (__ISP(elem, StyleElems_ParcDesc, 3)) {
					styleElem = ElemsUI_ThisStyleElem((void*)name, 64);
					if (styleElem == NIL) {
						Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, name, 64);
						ElemsUI_Call((CHAR*)"StyleElems.Rename", (LONGINT)18);
					} else {
						Replace__68(&t, &r, Texts_Reader__typ, styleElem);
					}
				} else if (__ISP(elem, TextFrames_ParcDesc, 2)) {
					styleElem = ElemsUI_ThisStyleElem((void*)name, 64);
					if (styleElem == NIL) {
						__NEW(styleElem, StyleElems_ParcDesc);
						ParcElems_CopyParc((*(TextFrames_Parc*)&elem), (void*)styleElem);
						styleElem->handle = StyleElems_Handle;
						__COPY(name, styleElem->name, 32);
					}
					Replace__68(&t, &r, Texts_Reader__typ, styleElem);
				}
			} else {
				Out_String((CHAR*)"-- no style elem given", (LONGINT)23);
				Out_Ln();
			}
		}
	}
	Style__67_s = _s.lnk;
}

static struct InspectParc__33 {
	Texts_Scanner *s;
	struct InspectParc__33 *lnk;
} *InspectParc__33_s;

static void Set__34 (CHAR *name, LONGINT name__len);

static void Set__34 (CHAR *name, LONGINT name__len)
{
	__DUP(name, name__len, CHAR);
	ElemsUI_StoreLog();
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, name, name__len);
	ElemsUI_Call((CHAR*)"Edit.Get", (LONGINT)9);
	ElemsUI_Scan(&*InspectParc__33_s->s, Texts_Scanner__typ, (CHAR*)"int", (LONGINT)4);
	Elems_SetInteger((void*)Elems_NamedElem(name, name__len, ElemsUI_ct), (CHAR*)"Value", (LONGINT)6, (*InspectParc__33_s->s).i);
	__DEL(name);
}

void ElemsUI_InspectParc (void)
{
	Elems_Elem e = NIL;
	Texts_Scanner s = {0};
	Texts_Text t = NIL;
	struct InspectParc__33 _s;
	_s.s = &s;
	_s.lnk = InspectParc__33_s;
	InspectParc__33_s = &_s;
	ElemsUI_ct = Elems_CmdContext;
	ElemsUI_orgLog = Oberon_Log;
	ElemsUI_GetStyles(0);
	s.s[0] = 0x00;
	ElemsUI_StoreLog();
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"adjust", (LONGINT)7);
	ElemsUI_Call((CHAR*)"Edit.Get", (LONGINT)9);
	ElemsUI_Scan(&s, Texts_Scanner__typ, (CHAR*)"adjust", (LONGINT)7);
	if (s.eot) {
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"-- no parc selected", (LONGINT)20);
		Texts_WriteLn(&ElemsUI_W, Texts_Writer__typ);
		Texts_Append(ElemsUI_orgLog, ElemsUI_W.buf);
	}
	ElemsUI_SetRadio((CHAR*)"adjust", (LONGINT)7, s.s, 256);
	ElemsUI_StoreLog();
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"columns", (LONGINT)8);
	ElemsUI_Call((CHAR*)"Edit.Get", (LONGINT)9);
	ElemsUI_Scan(&s, Texts_Scanner__typ, (CHAR*)"int", (LONGINT)4);
	if (s.i == 1) {
		ElemsUI_SetRadio((CHAR*)"columns", (LONGINT)8, (CHAR*)"1", (LONGINT)2);
	} else if (s.i == 2) {
		ElemsUI_SetRadio((CHAR*)"columns", (LONGINT)8, (CHAR*)"2", (LONGINT)2);
	} else {
		ElemsUI_SetRadio((CHAR*)"columns", (LONGINT)8, (CHAR*)"noset", (LONGINT)6);
	}
	ElemsUI_StoreLog();
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"break", (LONGINT)6);
	ElemsUI_Call((CHAR*)"Edit.Get", (LONGINT)9);
	ElemsUI_Scan(&s, Texts_Scanner__typ, (CHAR*)"break", (LONGINT)6);
	e = Elems_NamedElem((CHAR*)"break", (LONGINT)6, ElemsUI_ct);
	Elems_SetBoolean((void*)e, (CHAR*)"Value", (LONGINT)6, __STRCMP(s.s, "before") == 0);
	Elems_UpdateElem((void*)e);
	ElemsUI_StoreLog();
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"grid", (LONGINT)5);
	ElemsUI_Call((CHAR*)"Edit.Get", (LONGINT)9);
	ElemsUI_Scan(&s, Texts_Scanner__typ, (CHAR*)"grid", (LONGINT)5);
	e = Elems_NamedElem((CHAR*)"grid", (LONGINT)5, ElemsUI_ct);
	Elems_SetBoolean((void*)e, (CHAR*)"Value", (LONGINT)6, __STRCMP(s.s, "on") == 0);
	Elems_UpdateElem((void*)e);
	Set__34((CHAR*)"first", (LONGINT)6);
	Set__34((CHAR*)"left", (LONGINT)5);
	Set__34((CHAR*)"width", (LONGINT)6);
	Set__34((CHAR*)"lead", (LONGINT)5);
	Set__34((CHAR*)"line", (LONGINT)5);
	ElemsUI_StoreLog();
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"tabs", (LONGINT)5);
	ElemsUI_Call((CHAR*)"Edit.Get", (LONGINT)9);
	ElemsUI_Scan(&s, Texts_Scanner__typ, (CHAR*)"tabs", (LONGINT)5);
	if (s.class == 6 && s.c == '*') {
		Texts_Scan(&s, Texts_Scanner__typ);
		ElemsUI_SetRadio((CHAR*)"tab", (LONGINT)4, (CHAR*)"every", (LONGINT)6);
		Elems_SetString((void*)Elems_NamedElem((CHAR*)"enumt", (LONGINT)6, ElemsUI_ct), (CHAR*)"Value", (LONGINT)6, (CHAR*)"", (LONGINT)1);
		Elems_SetInteger((void*)Elems_NamedElem((CHAR*)"everyt", (LONGINT)7, ElemsUI_ct), (CHAR*)"Value", (LONGINT)6, s.i);
	} else if (s.class == 3) {
		do {
			Texts_WriteInt(&ElemsUI_W, Texts_Writer__typ, s.i, 0);
			Texts_Write(&ElemsUI_W, Texts_Writer__typ, ' ');
			Texts_Scan(&s, Texts_Scanner__typ);
		} while (!(s.eot || s.class != 3));
		ElemsUI_SetRadio((CHAR*)"tab", (LONGINT)4, (CHAR*)"enum", (LONGINT)5);
		Elems_SetString((void*)Elems_NamedElem((CHAR*)"everyt", (LONGINT)7, ElemsUI_ct), (CHAR*)"Value", (LONGINT)6, (CHAR*)"", (LONGINT)1);
		Elems_GetText((void*)Elems_NamedElem((CHAR*)"enumt", (LONGINT)6, ElemsUI_ct), (CHAR*)"ValueT", (LONGINT)7, &t);
		Texts_Delete(t, 0, t->len);
		Texts_Append(t, ElemsUI_W.buf);
	} else {
		Elems_SetString((void*)Elems_NamedElem((CHAR*)"everyt", (LONGINT)7, ElemsUI_ct), (CHAR*)"Value", (LONGINT)6, (CHAR*)"", (LONGINT)1);
		Elems_SetString((void*)Elems_NamedElem((CHAR*)"enumt", (LONGINT)6, ElemsUI_ct), (CHAR*)"Value", (LONGINT)6, (CHAR*)"", (LONGINT)1);
		ElemsUI_SetRadio((CHAR*)"tab", (LONGINT)4, (CHAR*)"noset", (LONGINT)6);
	}
	Oberon_Log = ElemsUI_orgLog;
	InspectParc__33_s = _s.lnk;
}

static struct ApplyParc__2 {
	CHAR (*str)[256];
	struct ApplyParc__2 *lnk;
} *ApplyParc__2_s;

static void GetString__3 (CHAR *name, LONGINT name__len);

static void GetString__3 (CHAR *name, LONGINT name__len)
{
	__DUP(name, name__len, CHAR);
	Elems_GetString((void*)Elems_NamedElem(name, name__len, ElemsUI_ct), (CHAR*)"Value", (LONGINT)6, (void*)*ApplyParc__2_s->str, 256);
	__DEL(name);
}

void ElemsUI_ApplyParc (void)
{
	CHAR str[256];
	Texts_Notifier notifier = NIL;
	struct ApplyParc__2 _s;
	_s.str = (void*)str;
	_s.lnk = ApplyParc__2_s;
	ApplyParc__2_s = &_s;
	ElemsUI_ct = Elems_CmdContext;
	ElemsUI_orgLog = Oberon_Log;
	ElemsUI_StoreSelection();
	if (ElemsUI_selbeg == -1 && ElemsUI_selend == -1) {
		Out_String((CHAR*)"-- no parc selected", (LONGINT)20);
		Out_Ln();
		ApplyParc__2_s = _s.lnk;
		return;
	}
	notifier = ElemsUI_t->notify;
	ElemsUI_t->notify = ElemsUI_NoNotify;
	GetString__3((CHAR*)"adjust", (LONGINT)7);
	ElemsUI_StoreLog();
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"adjust ", (LONGINT)8);
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, str, 256);
	ElemsUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
	GetString__3((CHAR*)"columns", (LONGINT)8);
	ElemsUI_StoreLog();
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"columns ", (LONGINT)9);
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, str, 256);
	ElemsUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
	ElemsUI_StoreLog();
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"break ", (LONGINT)7);
	if (ElemsUI_On((CHAR*)"break", (LONGINT)6)) {
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"before", (LONGINT)7);
	} else {
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"normal", (LONGINT)7);
	}
	ElemsUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
	ElemsUI_StoreLog();
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"grid ", (LONGINT)6);
	if (ElemsUI_On((CHAR*)"grid", (LONGINT)5)) {
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"on", (LONGINT)3);
	} else {
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"off", (LONGINT)4);
	}
	ElemsUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
	GetString__3((CHAR*)"first", (LONGINT)6);
	ElemsUI_StoreLog();
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"first ", (LONGINT)7);
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, str, 256);
	ElemsUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
	GetString__3((CHAR*)"left", (LONGINT)5);
	ElemsUI_StoreLog();
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"left ", (LONGINT)6);
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, str, 256);
	ElemsUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
	GetString__3((CHAR*)"width", (LONGINT)6);
	ElemsUI_StoreLog();
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"width ", (LONGINT)7);
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, str, 256);
	ElemsUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
	GetString__3((CHAR*)"lead", (LONGINT)5);
	ElemsUI_StoreLog();
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"lead ", (LONGINT)6);
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, str, 256);
	ElemsUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
	GetString__3((CHAR*)"tab", (LONGINT)4);
	if (__STRCMP(str, "every") == 0) {
		ElemsUI_StoreLog();
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"tabs * ", (LONGINT)8);
		GetString__3((CHAR*)"everyt", (LONGINT)7);
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, str, 256);
		ElemsUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
	} else if (__STRCMP(str, "enum") == 0) {
		ElemsUI_StoreLog();
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"tabs ", (LONGINT)6);
		GetString__3((CHAR*)"enumt", (LONGINT)6);
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, str, 256);
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)" ~", (LONGINT)3);
		ElemsUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
	}
	GetString__3((CHAR*)"line", (LONGINT)5);
	ElemsUI_StoreLog();
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"line ", (LONGINT)6);
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, str, 256);
	ElemsUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
	ElemsUI_t->notify = notifier;
	(*ElemsUI_t->notify)(ElemsUI_t, 0, 0, ElemsUI_t->len);
	ElemsUI_RestoreSelection();
	Oberon_Log = ElemsUI_orgLog;
	ApplyParc__2_s = _s.lnk;
}

void ElemsUI_InitParcPanel (void)
{
	ElemsUI_ct = Elems_CmdContext;
	ElemsUI_WriteStyles();
	ElemsUI_InspectParc();
}

static void ElemsUI_GenPrintParams (void)
{
	Elems_Elem e = NIL;
	CHAR s[256];
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"QuickDraw * ", (LONGINT)13);
	if (ElemsUI_On((CHAR*)"draft", (LONGINT)6)) {
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"% ", (LONGINT)3);
	}
	if (ElemsUI_On((CHAR*)"alternate", (LONGINT)10)) {
		ElemsUI_Opt((CHAR*)"a ", (LONGINT)3);
	}
	if (ElemsUI_On((CHAR*)"nopagenr", (LONGINT)9)) {
		ElemsUI_Opt((CHAR*)"p n ", (LONGINT)5);
	}
	if (ElemsUI_On((CHAR*)"nofirstnr", (LONGINT)10)) {
		ElemsUI_Opt((CHAR*)"p f ", (LONGINT)5);
	}
	if (ElemsUI_On((CHAR*)"roman", (LONGINT)6)) {
		ElemsUI_Opt((CHAR*)"p r ", (LONGINT)5);
	}
	ElemsUI_WriteString((CHAR*)"firstpage", (LONGINT)10, (CHAR*)"p ", (LONGINT)3);
	e = Elems_NamedElem((CHAR*)"font", (LONGINT)5, ElemsUI_ct);
	Elems_GetString((void*)e, (CHAR*)"Value", (LONGINT)6, (void*)s, 256);
	if (s[0] != 0x00) {
		ElemsUI_Opt((CHAR*)"f ", (LONGINT)3);
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, s, 256);
		e = Elems_NamedElem((CHAR*)"fnts", (LONGINT)5, ElemsUI_ct);
		Elems_GetString((void*)e, (CHAR*)"Value", (LONGINT)6, (void*)s, 256);
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, s, 256);
		e = Elems_NamedElem((CHAR*)"fntt", (LONGINT)5, ElemsUI_ct);
		Elems_GetString((void*)e, (CHAR*)"Value", (LONGINT)6, (void*)s, 256);
		if (s[0] != 'p') {
			Texts_Write(&ElemsUI_W, Texts_Writer__typ, s[0]);
		}
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)".Scn.Fnt ", (LONGINT)10);
	}
	ElemsUI_WriteString((CHAR*)"copies", (LONGINT)7, (CHAR*)"c ", (LONGINT)3);
	e = Elems_NamedElem((CHAR*)"header", (LONGINT)7, ElemsUI_ct);
	Elems_GetString((void*)e, (CHAR*)"Value", (LONGINT)6, (void*)s, 256);
	if (__STRCMP(s, "default") == 0) {
		ElemsUI_Opt((CHAR*)"h ", (LONGINT)3);
	} else if (__STRCMP(s, "special") == 0) {
		ElemsUI_Opt((CHAR*)"h ", (LONGINT)3);
		Texts_Write(&ElemsUI_W, Texts_Writer__typ, '\"');
		ElemsUI_WriteString((CHAR*)"headertext", (LONGINT)11, (CHAR*)"", (LONGINT)1);
		Texts_Write(&ElemsUI_W, Texts_Writer__typ, '\"');
	}
	e = Elems_NamedElem((CHAR*)"bodypos", (LONGINT)8, ElemsUI_ct);
	Elems_GetString((void*)e, (CHAR*)"Value", (LONGINT)6, (void*)s, 256);
	if (__STRCMP(s, "custom") == 0) {
		ElemsUI_Opt((CHAR*)"m b ", (LONGINT)5);
		ElemsUI_WriteString((CHAR*)"bleft", (LONGINT)6, (CHAR*)"", (LONGINT)1);
		ElemsUI_WriteString((CHAR*)"bbot", (LONGINT)5, (CHAR*)"", (LONGINT)1);
		ElemsUI_WriteString((CHAR*)"bwidth", (LONGINT)7, (CHAR*)"", (LONGINT)1);
		ElemsUI_WriteString((CHAR*)"bheight", (LONGINT)8, (CHAR*)"", (LONGINT)1);
	}
	e = Elems_NamedElem((CHAR*)"headerpos", (LONGINT)10, ElemsUI_ct);
	Elems_GetString((void*)e, (CHAR*)"Value", (LONGINT)6, (void*)s, 256);
	if (__STRCMP(s, "custom") == 0) {
		ElemsUI_Opt((CHAR*)"m h ", (LONGINT)5);
		ElemsUI_WriteString((CHAR*)"hleft", (LONGINT)6, (CHAR*)"", (LONGINT)1);
		ElemsUI_WriteString((CHAR*)"hbot", (LONGINT)5, (CHAR*)"", (LONGINT)1);
		ElemsUI_WriteString((CHAR*)"hwidth", (LONGINT)7, (CHAR*)"", (LONGINT)1);
	}
	e = Elems_NamedElem((CHAR*)"pages", (LONGINT)6, ElemsUI_ct);
	Elems_GetString((void*)e, (CHAR*)"Value", (LONGINT)6, (void*)s, 256);
	if (__STRCMP(s, "fromto") == 0) {
		ElemsUI_Opt((CHAR*)"s ", (LONGINT)3);
		ElemsUI_WriteString((CHAR*)"from", (LONGINT)5, (CHAR*)"", (LONGINT)1);
		ElemsUI_WriteString((CHAR*)"to", (LONGINT)3, (CHAR*)"", (LONGINT)1);
	}
}

void ElemsUI_Print (void)
{
	ElemsUI_ct = Elems_CmdContext;
	ElemsUI_GenPrintParams();
	ElemsUI_Call((CHAR*)"Edit.Print", (LONGINT)11);
}

void ElemsUI_ShowPrintString (void)
{
	ElemsUI_ct = Elems_CmdContext;
	ElemsUI_GenPrintParams();
	Out_String((CHAR*)"Edit.Print ", (LONGINT)12);
	Texts_Append(Oberon_Log, ElemsUI_W.buf);
	Out_Ln();
}

static LONGREAL ElemsUI_EvalFunc (CHAR *f, LONGINT f__len, LONGREAL v)
{
	LONGREAL v2 = 0;
	__DUP(f, f__len, CHAR);
	if (ElemsUI_rad) {
		v2 = v;
	} else {
		v2 = (v *   3.14159265358979e+000) / (LONGREAL)(LONGREAL)180;
	}
	if (__STRCMP(f, "SIN") == 0) {
		if (ElemsUI_invert) {
			v = MathLX_arcsin(v);
		} else {
			v = MathL_sin(v2);
		}
	} else if (__STRCMP(f, "ASIN") == 0) {
		if (ElemsUI_invert) {
			v = MathL_sin(v2);
		} else {
			v = MathLX_arcsin(v);
		}
	} else if (__STRCMP(f, "COS") == 0) {
		if (ElemsUI_invert) {
			v = MathLX_arccos(v);
		} else {
			v = MathL_cos(v2);
		}
	} else if (__STRCMP(f, "ACOS") == 0) {
		if (ElemsUI_invert) {
			v = MathL_cos(v2);
		} else {
			v = MathLX_arccos(v);
		}
	} else if (__STRCMP(f, "TAN") == 0) {
		if (ElemsUI_invert) {
			v = MathL_arctan(v);
		} else {
			v = MathLX_tan(v2);
		}
	} else if (__STRCMP(f, "ATAN") == 0) {
		if (ElemsUI_invert) {
			v = MathLX_tan(v2);
		} else {
			v = MathL_arctan(v);
		}
	} else if (__STRCMP(f, "LN") == 0) {
		if (ElemsUI_invert) {
			v = MathL_exp(v);
		} else {
			v = MathL_ln(v);
		}
	} else if (__STRCMP(f, "EXP") == 0) {
		if (ElemsUI_invert) {
			v = MathL_ln(v);
		} else {
			v = MathL_exp(v);
		}
	} else if (__STRCMP(f, "LOG") == 0) {
		v = MathL_ln(v) / MathL_ln((LONGREAL)10);
	} else if (__STRCMP(f, "SQRT") == 0) {
		if (ElemsUI_invert) {
			v = v * v;
		} else {
			v = MathL_sqrt(v);
		}
	} else {
		ElemsUI_err = 3;
	}
	__DEL(f);
	return v;
}

static void ElemsUI_N (Texts_Reader *r, LONGINT *r__typ, CHAR *ch)
{
	Texts_Read(&*r, r__typ, &*ch);
	while (*ch == ' ' && !(*r).eot) {
		Texts_Read(&*r, r__typ, &*ch);
	}
}

static BOOLEAN ElemsUI_IsNumber (CHAR ch)
{
	return (ch >= '0' && ch <= '9' || ch == '.') || ch == ',';
}

static BOOLEAN ElemsUI_IsHex (CHAR ch)
{
	return ch >= 'A' && ch <= 'F' || ch >= 'a' && ch <= 'z';
}

static BOOLEAN ElemsUI_IsChar (CHAR ch)
{
	return ((ch >= 'a' && ch <= 'z' || ch >= 'A' && ch <= 'Z') || ch == 0x87) || ch == 0xca;
}

static LONGREAL ElemsUI_Number (Texts_Reader *r, LONGINT *r__typ, CHAR *ch)
{
	LONGREAL v = 0, c = 0;
	INTEGER val = 0;
	v = (LONGREAL)0;
	c = (LONGREAL)10;
	while (ElemsUI_IsNumber(*ch) || ElemsUI_IsHex(*ch)) {
		if (ElemsUI_IsChar(*ch)) {
			val = ((int)*ch - 65) + 10;
		} else {
			val = (int)*ch - 48;
		}
		if (*ch == '.' || *ch == ',') {
			if (c == (LONGREAL)10) {
				c = (LONGREAL)1;
			}
		} else if (c == (LONGREAL)10) {
			v = v * ElemsUI_base + val;
		} else {
			c = c / (LONGREAL)ElemsUI_base;
			v = v + val * c;
		}
		ElemsUI_N(&*r, r__typ, &*ch);
	}
	return v;
}

static struct FuncOrConst__20 {
	struct FuncOrConst__20 *lnk;
} *FuncOrConst__20_s;

static CHAR Cap__21 (CHAR *ch);

static CHAR Cap__21 (CHAR *ch)
{
	if (*ch == 0x87 || *ch == 0xca) {
		return 0xca;
	} else {
		return __CAP(*ch);
	}
	__RETCHK;
}

static LONGREAL ElemsUI_FuncOrConst (Texts_Reader *r, LONGINT *r__typ, CHAR *ch)
{
	CHAR f[5];
	INTEGER i = 0;
	LONGREAL v = 0;
	struct FuncOrConst__20 _s;
	LONGREAL __retval;
	_s.lnk = FuncOrConst__20_s;
	FuncOrConst__20_s = &_s;
	i = 0;
	while (ElemsUI_IsChar(*ch) && i < 4) {
		f[__X(i, 5)] = Cap__21(&*ch);
		i += 1;
		ElemsUI_N(&*r, r__typ, &*ch);
	}
	f[__X(i, 5)] = 0x00;
	if (*ch == '(') {
		ElemsUI_N(&*r, r__typ, &*ch);
		v = ElemsUI_Expr(&*r, r__typ, &*ch);
		if (*ch == ')') {
			ElemsUI_N(&*r, r__typ, &*ch);
			v = ElemsUI_EvalFunc(f, 5, v);
		} else {
			ElemsUI_err = 1;
		}
	} else if (__STRCMP(f, "PI") == 0) {
		v =   3.14159265358979e+000;
	} else if (__STRCMP(f, "E") == 0) {
		v =   2.71828182845904e+000;
	} else {
		ElemsUI_err = 3;
	}
	__retval = v;
	FuncOrConst__20_s = _s.lnk;
	;
	return __retval;
}

static LONGREAL ElemsUI_Atom (Texts_Reader *r, LONGINT *r__typ, CHAR *ch)
{
	LONGREAL v = 0;
	if (ElemsUI_IsNumber(*ch)) {
		v = ElemsUI_Number(&*r, r__typ, &*ch);
	} else if (*ch == '(') {
		ElemsUI_N(&*r, r__typ, &*ch);
		v = ElemsUI_Expr(&*r, r__typ, &*ch);
		if (*ch == ')') {
			ElemsUI_N(&*r, r__typ, &*ch);
		} else {
			ElemsUI_err = 1;
		}
	} else if (ElemsUI_IsChar(*ch)) {
		v = ElemsUI_FuncOrConst(&*r, r__typ, &*ch);
	} else {
		ElemsUI_err = 1;
	}
	return v;
}

static LONGREAL ElemsUI_Factor (Texts_Reader *r, LONGINT *r__typ, CHAR *ch)
{
	LONGREAL v = 0;
	v = ElemsUI_Atom(&*r, r__typ, &*ch);
	if (*ch == '^') {
		ElemsUI_N(&*r, r__typ, &*ch);
		v = MathL_exp(ElemsUI_Factor(&*r, r__typ, &*ch) * MathL_ln(v));
	}
	return v;
}

static LONGREAL ElemsUI_Term (Texts_Reader *r, LONGINT *r__typ, CHAR *ch)
{
	LONGREAL v = 0, v2 = 0;
	v = ElemsUI_Factor(&*r, r__typ, &*ch);
	while (ElemsUI_err == 0 && (*ch == '*' || *ch == '/')) {
		if (*ch == '*') {
			ElemsUI_N(&*r, r__typ, &*ch);
			v = v * ElemsUI_Factor(&*r, r__typ, &*ch);
		} else if (*ch == '/') {
			ElemsUI_N(&*r, r__typ, &*ch);
			v2 = ElemsUI_Factor(&*r, r__typ, &*ch);
			if (v2 != (LONGREAL)0) {
				v = v / v2;
			} else {
				ElemsUI_err = 2;
			}
		}
	}
	return v;
}

static LONGREAL ElemsUI_Expr (Texts_Reader *r, LONGINT *r__typ, CHAR *ch)
{
	LONGREAL v = 0;
	INTEGER sgn = 0;
	sgn = 1;
	if (*ch == '-' || *ch == '+') {
		if (*ch == '-') {
			sgn = -1;
		}
		ElemsUI_N(&*r, r__typ, &*ch);
	}
	v = sgn * ElemsUI_Term(&*r, r__typ, &*ch);
	while (ElemsUI_err == 0 && (*ch == '-' || *ch == '+')) {
		if (*ch == '+') {
			ElemsUI_N(&*r, r__typ, &*ch);
			v = v + ElemsUI_Term(&*r, r__typ, &*ch);
		} else if (*ch == '-') {
			ElemsUI_N(&*r, r__typ, &*ch);
			v = v - ElemsUI_Term(&*r, r__typ, &*ch);
		}
	}
	return v;
}

static void ElemsUI_GetCalcSettings (void)
{
	CHAR s[5];
	ElemsUI_invert = ElemsUI_On((CHAR*)"invert", (LONGINT)7);
	ElemsUI_e = Elems_NamedElem((CHAR*)"result", (LONGINT)7, ElemsUI_ct);
	ElemsUI_e = Elems_NamedElem((CHAR*)"result", (LONGINT)7, (void*)__GUARDP(ElemsUI_e, PanelElems_PanelDesc, 3)->elemTxt);
	Elems_GetString((void*)ElemsUI_e, (CHAR*)"Value", (LONGINT)6, (void*)ElemsUI_res, 64);
	Elems_GetLReal((void*)ElemsUI_e, (CHAR*)"val", (LONGINT)4, &ElemsUI_value);
	Elems_GetString((void*)ElemsUI_e, (CHAR*)"err", (LONGINT)4, (void*)ElemsUI_errmsg, 30);
	Elems_GetString((void*)Elems_NamedElem((CHAR*)"base", (LONGINT)5, ElemsUI_ct), (CHAR*)"Value", (LONGINT)6, (void*)s, 5);
	if (__STRCMP(s, "hex") == 0) {
		ElemsUI_base = 16;
	} else if (__STRCMP(s, "bin") == 0) {
		ElemsUI_base = 2;
	} else if (__STRCMP(s, "oct") == 0) {
		ElemsUI_base = 8;
	} else {
		ElemsUI_base = 10;
	}
	Elems_GetString((void*)Elems_NamedElem((CHAR*)"gm", (LONGINT)3, ElemsUI_ct), (CHAR*)"Value", (LONGINT)6, (void*)s, 5);
	ElemsUI_rad = __STRCMP(s, "rad") == 0;
}

static struct ShowResult__56 {
	struct ShowResult__56 *lnk;
} *ShowResult__56_s;

static void WrBin__57 (LONGREAL n);
static void WrDec__59 (LONGREAL n);
static void WrHex__61 (LONGREAL n);
static void WrOct__63 (LONGREAL n);

static void WrHex__61 (LONGREAL n)
{
	LONGINT x = 0, y = 0;
	INTEGER i = 0;
	CHAR a[10];
	x = __ENTIER(n +   5.00000000000000e-010);
	i = 0;
	do {
		y = __MASK(x, -16);
		if (y < 10) {
			a[__X(i, 10)] = (CHAR)(y + 48);
		} else {
			a[__X(i, 10)] = (CHAR)(y + 55);
		}
		x = __ASHR(x, 4);
		i += 1;
	} while (!(i == 8));
	do {
		i -= 1;
	} while (!(i == 0 || a[__X(i, 10)] != '0'));
	if (a[__X(i, 10)] >= 'A') {
		Texts_Write(&ElemsUI_W, Texts_Writer__typ, '0');
	}
	while (i >= 0) {
		Texts_Write(&ElemsUI_W, Texts_Writer__typ, a[__X(i, 10)]);
		i -= 1;
	}
}

static void WrBin__57 (LONGREAL n)
{
	LONGINT x = 0;
	INTEGER i = 0;
	CHAR a[30];
	x = __ENTIER(n +   5.00000000000000e-010);
	i = 0;
	do {
		a[__X(i, 30)] = (CHAR)(48 + __MASK(x, -2));
		x = __ASHR(x, 1);
		i += 1;
	} while (!(i == 28));
	do {
		i -= 1;
	} while (!(i == 0 || a[__X(i, 30)] != '0'));
	while (i >= 0) {
		Texts_Write(&ElemsUI_W, Texts_Writer__typ, a[__X(i, 30)]);
		i -= 1;
	}
}

static void WrOct__63 (LONGREAL n)
{
	LONGINT x = 0, y = 0;
	INTEGER i = 0;
	CHAR a[16];
	x = __ENTIER(n +   5.00000000000000e-010);
	i = 0;
	do {
		y = __MASK(x, -8);
		a[__X(i, 16)] = (CHAR)(y + 48);
		x = __ASHR(x, 3);
		i += 1;
	} while (!(i == 14));
	do {
		i -= 1;
	} while (!(i == 0 || a[__X(i, 16)] != '0'));
	while (i >= 0) {
		Texts_Write(&ElemsUI_W, Texts_Writer__typ, a[__X(i, 16)]);
		i -= 1;
	}
}

static void WrDec__59 (LONGREAL n)
{
	LONGREAL x = 0;
	REAL y = 0;
	if ( -2.14748364800000e+009 <= n && n <=   2.14748364700000e+009) {
		x = __ABS(n - (__ENTIER(n)));
		if (x <   1.00000000000000e-008) {
			Texts_WriteInt(&ElemsUI_W, Texts_Writer__typ, __ENTIER(n +   5.00000000000000e-010), 0);
			return;
		}
	}
	if ( -3.40282346000000e+038 <= n && n <=   3.40282346000000e+038) {
		y = x;
		x = __ABS(n - y);
		if (x <   1.00000000000000e-008) {
			if ((LONGREAL)-10000 < n && n < (LONGREAL)10000) {
				Texts_WriteRealFix(&ElemsUI_W, Texts_Writer__typ, (n +   5.00000000000000e-010), 0, 6);
			} else {
				Texts_WriteReal(&ElemsUI_W, Texts_Writer__typ, (n +   5.00000000000000e-010), 14);
			}
			return;
		}
	}
	Texts_WriteLongReal(&ElemsUI_W, Texts_Writer__typ, n, 14);
}

void ElemsUI_ShowResult (void)
{
	Texts_Reader r = {0};
	Texts_Text txt = NIL;
	INTEGER i = 0;
	CHAR str[32];
	struct ShowResult__56 _s;
	_s.lnk = ShowResult__56_s;
	ShowResult__56_s = &_s;
	ElemsUI_ct = Elems_CmdContext;
	ElemsUI_GetCalcSettings();
	if (ElemsUI_errmsg[0] != 0x00) {
		__COPY(ElemsUI_errmsg, str, 32);
	} else {
		if (ElemsUI_base == 16) {
			WrHex__61(ElemsUI_value);
		} else if (ElemsUI_base == 2) {
			WrBin__57(ElemsUI_value);
		} else if (ElemsUI_base == 8) {
			WrOct__63(ElemsUI_value);
		} else {
			WrDec__59(ElemsUI_value);
		}
		txt = TextFrames_Text((CHAR*)"", (LONGINT)1);
		Texts_Append(txt, ElemsUI_W.buf);
		Texts_OpenReader(&r, Texts_Reader__typ, txt, 0);
		i = 0;
		do {
			Texts_Read(&r, Texts_Reader__typ, &str[__X(i, 32)]);
			i += 1;
		} while (!r.eot);
		str[__X(i - 1, 32)] = 0x00;
	}
	Elems_SetString((void*)Elems_NamedElem((CHAR*)"result", (LONGINT)7, ElemsUI_ct), (CHAR*)"Value", (LONGINT)6, str, 32);
	Elems_SetString((void*)ElemsUI_e, (CHAR*)"Value", (LONGINT)6, str, 32);
	Elems_UpdateElem((void*)ElemsUI_e);
	ShowResult__56_s = _s.lnk;
}

void ElemsUI_CalcIn (void)
{
	CHAR s[64];
	Texts_Text t = NIL;
	Texts_Reader r = {0};
	CHAR ch = 0;
	BOOLEAN hasCar = 0;
	Display_Frame f = NIL;
	ElemsUI_ct = Elems_CmdContext;
	f = Elems_CmdFrame;
	if (__ISP(f, TextFrames_FrameDesc, 1)) {
		hasCar = (*(TextFrames_Frame*)&f)->hasCar;
	} else {
		hasCar = 0;
	}
	ElemsUI_GetCalcSettings();
	Elems_GetText((void*)Elems_NamedElem((CHAR*)"input", (LONGINT)6, ElemsUI_ct), (CHAR*)"ValueT", (LONGINT)7, &t);
	In_Open();
	In_String((void*)s, 64);
	if (((((__STRCMP(s, "sin") == 0 || __STRCMP(s, "cos") == 0) || __STRCMP(s, "tan") == 0) || __STRCMP(s, "exp") == 0) || __STRCMP(s, "ln") == 0) || __STRCMP(s, "log") == 0) {
		if (ElemsUI_invert) {
			if ((__STRCMP(s, "sin") == 0 || __STRCMP(s, "cos") == 0) || __STRCMP(s, "tan") == 0) {
				Texts_Write(&ElemsUI_W, Texts_Writer__typ, 'a');
			} else if (__STRCMP(s, "exp") == 0) {
				__MOVE("ln", s, 3);
			} else if (__STRCMP(s, "ln") == 0) {
				__MOVE("exp", s, 4);
			} else if (__STRCMP(s, "log") == 0) {
				__MOVE("10^", s, 4);
			}
		}
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, s, 64);
		Texts_Write(&ElemsUI_W, Texts_Writer__typ, '(');
		if (t->len == 0) {
			Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, ElemsUI_res, 64);
		} else {
			Texts_Insert(t, 0, ElemsUI_W.buf);
		}
		Texts_Write(&ElemsUI_W, Texts_Writer__typ, ')');
		Texts_Append(t, ElemsUI_W.buf);
		ElemsUI_SetCheckBox((CHAR*)"invert", (LONGINT)7, 0, 1);
	} else if (__STRCMP(s, "sqrt") == 0) {
		if (ElemsUI_invert) {
			Texts_Write(&ElemsUI_W, Texts_Writer__typ, '(');
			if (t->len == 0) {
				Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, ElemsUI_res, 64);
			} else {
				Texts_Insert(t, 0, ElemsUI_W.buf);
			}
			Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)")^2", (LONGINT)4);
			Texts_Append(t, ElemsUI_W.buf);
		} else {
			Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, s, 64);
			Texts_Write(&ElemsUI_W, Texts_Writer__typ, '(');
			if (t->len == 0) {
				Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, ElemsUI_res, 64);
			} else {
				Texts_Insert(t, 0, ElemsUI_W.buf);
			}
			Texts_Write(&ElemsUI_W, Texts_Writer__typ, ')');
			Texts_Append(t, ElemsUI_W.buf);
		}
		ElemsUI_SetCheckBox((CHAR*)"invert", (LONGINT)7, 0, 1);
	} else if ((((__STRCMP(s, "+") == 0 || __STRCMP(s, "-") == 0) || __STRCMP(s, "*") == 0) || __STRCMP(s, "/") == 0) || __STRCMP(s, "^") == 0) {
		if (t->len == 0) {
			Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, ElemsUI_res, 64);
		}
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, s, 64);
		Texts_Append(t, ElemsUI_W.buf);
	} else if (__STRCMP(s, "x") == 0) {
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"1/(", (LONGINT)4);
		if (t->len == 0) {
			Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, ElemsUI_res, 64);
		} else {
			Texts_Insert(t, 0, ElemsUI_W.buf);
		}
		Texts_Write(&ElemsUI_W, Texts_Writer__typ, ')');
		Texts_Append(t, ElemsUI_W.buf);
	} else if (__STRCMP(s, "ce") == 0) {
		if (t->len > 0) {
			Texts_Delete(t, t->len - 1, t->len);
		}
	} else if (__STRCMP(s, "cl") == 0) {
		Texts_Delete(t, 0, t->len);
	} else if (__STRCMP(s, "=") == 0) {
		if (t->len > 0) {
			ElemsUI_err = 0;
			Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
			ElemsUI_N(&r, Texts_Reader__typ, &ch);
			if ((((ch == '+' || ch == '-') || ch == '*') || ch == '/') || ch == '^') {
				Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, ElemsUI_res, 64);
				Texts_Insert(t, 0, ElemsUI_W.buf);
				Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
				ElemsUI_N(&r, Texts_Reader__typ, &ch);
			}
			ElemsUI_value = ElemsUI_Expr(&r, Texts_Reader__typ, &ch);
			if (ElemsUI_err == 0 && !r.eot) {
				ElemsUI_err = 1;
			}
			if (ElemsUI_err != 0) {
				Texts_ChangeLooks(t, Texts_Pos(&r, Texts_Reader__typ) - 1, t->len, 0x02, NIL, 1, 0);
				if (ElemsUI_err == 1) {
					__MOVE("wrong input", ElemsUI_errmsg, 12);
				} else if (ElemsUI_err == 2) {
					__MOVE("DIV0", ElemsUI_errmsg, 5);
				} else if (ElemsUI_err == 3) {
					__MOVE("unknown Function", ElemsUI_errmsg, 17);
				}
				Elems_SetString((void*)ElemsUI_e, (CHAR*)"err", (LONGINT)4, ElemsUI_errmsg, 30);
			} else {
				Elems_SetLReal((void*)ElemsUI_e, (CHAR*)"val", (LONGINT)4, ElemsUI_value);
				Elems_SetString((void*)ElemsUI_e, (CHAR*)"err", (LONGINT)4, (CHAR*)"", (LONGINT)1);
				Texts_Delete(t, 0, t->len);
			}
			ElemsUI_ShowResult();
		}
	} else {
		Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, s, 64);
		Texts_Append(t, ElemsUI_W.buf);
	}
	if (hasCar) {
		TextFrames_SetCaret(__GUARDP(f, TextFrames_FrameDesc, 1), t->len);
	}
}

void ElemsUI_SetCalcType (void)
{
	CHAR type[3];
	Elems_Elem e = NIL;
	Oberon_ControlMsg control = {0};
	control.id = 1;
	(*Elems_CmdFrame->handle)(Elems_CmdFrame, (void*)&control, Oberon_ControlMsg__typ);
	ElemsUI_ct = Elems_CmdContext;
	Elems_GetString((void*)Elems_NamedElem((CHAR*)"type", (LONGINT)5, ElemsUI_ct), (CHAR*)"Caption", (LONGINT)8, (void*)type, 3);
	e = Elems_NamedElem((CHAR*)"input", (LONGINT)6, ElemsUI_ct);
	if (__STRCMP(type, ">>") == 0) {
		__GUARDP(ElemsUI_ct, PanelElems_TextDesc, 1)->base->W = 3900000;
		e->W = 3800000;
		__MOVE("<<", type, 3);
	} else {
		__GUARDP(ElemsUI_ct, PanelElems_TextDesc, 1)->base->W = 1310000;
		e->W = 1210000;
		__MOVE(">>", type, 3);
	}
	__GUARDP(ElemsUI_ct, PanelElems_TextDesc, 1)->base->H = 1670000;
	Elems_SetString((void*)Elems_NamedElem((CHAR*)"type", (LONGINT)5, ElemsUI_ct), (CHAR*)"Caption", (LONGINT)8, type, 3);
	Elems_UpdateElem((void*)__GUARDP(ElemsUI_ct, PanelElems_TextDesc, 1)->base);
}

void ElemsUI_InitCalcPanel (void)
{
	Elems_Elem result = NIL, e = NIL;
	ElemsUI_ct = Elems_CmdContext;
	result = Elems_NamedElem((CHAR*)"result", (LONGINT)7, ElemsUI_ct);
	Elems_SetString((void*)result, (CHAR*)"Value", (LONGINT)6, (CHAR*)"0", (LONGINT)2);
	result = Elems_NamedElem((CHAR*)"result", (LONGINT)7, (void*)__GUARDP(result, PanelElems_PanelDesc, 3)->elemTxt);
	Elems_SetLReal((void*)result, (CHAR*)"val", (LONGINT)4, (LONGREAL)0);
	Elems_SetString((void*)result, (CHAR*)"Value", (LONGINT)6, (CHAR*)"0", (LONGINT)2);
	Elems_SetString((void*)result, (CHAR*)"err", (LONGINT)4, (CHAR*)"", (LONGINT)1);
	e = Elems_NamedElem((CHAR*)"input", (LONGINT)6, ElemsUI_ct);
	Elems_SetString((void*)e, (CHAR*)"Value", (LONGINT)6, (CHAR*)"", (LONGINT)1);
}

static void ElemsUI_EnumFiles (Directories_Directory d, CHAR *name, LONGINT name__len, BOOLEAN isDir, BOOLEAN *continue_)
{
	__DUP(name, name__len, CHAR);
	if (isDir || Strings_Match(name, name__len, ElemsUI_pattern, 10)) {
		if ((isDir && __IN(2, ElemsUI_enumMode)) && (name[0] != '.' || name[__X(1, name__len)] != 0x00)) {
			Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, name, name__len);
			Texts_WriteLn(&ElemsUI_W, Texts_Writer__typ);
		} else if (!isDir && __IN(1, ElemsUI_enumMode)) {
			Texts_WriteString(&ElemsUI_W1, Texts_Writer__typ, name, name__len);
			Texts_WriteLn(&ElemsUI_W1, Texts_Writer__typ);
		}
	}
	__DEL(name);
}

static void ElemsUI_CreateDriveList (void)
{
	Elems_Elem e = NIL;
	Texts_Text t = NIL;
	INTEGER ii = 0;
	Texts_Write(&ElemsUI_W, Texts_Writer__typ, '/');
	Texts_WriteLn(&ElemsUI_W, Texts_Writer__typ);
	e = Elems_NamedElem((CHAR*)"drives", (LONGINT)7, Elems_CmdContext);
	Elems_SetString((void*)e, (CHAR*)"ComboV", (LONGINT)7, (CHAR*)"", (LONGINT)1);
	Elems_GetText((void*)e, (CHAR*)"ValueT", (LONGINT)7, &t);
	Texts_Delete(t, 0, t->len);
	Texts_Append(t, ElemsUI_W.buf);
}

static void ElemsUI_CreatePatternList (void)
{
	Documents_Opener o = NIL;
	Elems_Elem e = NIL;
	Texts_Text t = NIL;
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"*", (LONGINT)2);
	Texts_WriteLn(&ElemsUI_W, Texts_Writer__typ);
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"*.Mod", (LONGINT)6);
	Texts_WriteLn(&ElemsUI_W, Texts_Writer__typ);
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"*.Text", (LONGINT)7);
	Texts_WriteLn(&ElemsUI_W, Texts_Writer__typ);
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"*.Cod", (LONGINT)6);
	Texts_WriteLn(&ElemsUI_W, Texts_Writer__typ);
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"*.Bak", (LONGINT)6);
	Texts_WriteLn(&ElemsUI_W, Texts_Writer__typ);
	o = Documents_openers;
	while (o != NIL) {
		if (o->pattern[0] == '*' && o->pattern[1] != 0x00) {
			Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, o->pattern, 32);
			Texts_WriteLn(&ElemsUI_W, Texts_Writer__typ);
		}
		o = o->next;
	}
	e = Elems_NamedElem((CHAR*)"pattern", (LONGINT)8, ElemsUI_ct);
	Elems_GetText((void*)e, (CHAR*)"ValueT", (LONGINT)7, &t);
	Texts_Delete(t, 0, t->len);
	Texts_Append(t, ElemsUI_W.buf);
	Elems_SetString((void*)e, (CHAR*)"Value", (LONGINT)6, (CHAR*)"*", (LONGINT)2);
}

static void ElemsUI_CreateFileList (CHAR *path, LONGINT path__len, SET mode)
{
	Elems_Elem e = NIL;
	Texts_Text t = NIL;
	Directories_Directory dir = NIL;
	__DUP(path, path__len, CHAR);
	if (__STRCMP(path, ".") == 0) {
		dir = Directories_Current();
	} else {
		dir = Directories_This(path, path__len);
	}
	if (dir != NIL) {
		if (Elems_NamedElem((CHAR*)"paths", (LONGINT)6, ElemsUI_ct) == NIL && Elems_NamedElem((CHAR*)"files", (LONGINT)6, ElemsUI_ct) == NIL) {
			__DEL(path);
			return;
		}
		ElemsUI_enumMode = mode;
		Directories_Enumerate(dir, ElemsUI_EnumFiles);
		if (__IN(2, mode)) {
			e = Elems_NamedElem((CHAR*)"paths", (LONGINT)6, ElemsUI_ct);
			Elems_GetText((void*)e, (CHAR*)"ValueT", (LONGINT)7, &t);
			Texts_Delete(t, 0, t->len);
			Texts_Append(t, ElemsUI_W.buf);
		}
		if (__IN(1, mode)) {
			e = Elems_NamedElem((CHAR*)"files", (LONGINT)6, ElemsUI_ct);
			Elems_GetText((void*)e, (CHAR*)"ValueT", (LONGINT)7, &t);
			Texts_Delete(t, 0, t->len);
			Texts_Append(t, ElemsUI_W1.buf);
		}
	}
	__DEL(path);
}

static void ElemsUI_SetPathValue (CHAR *path, LONGINT path__len)
{
	Directories_Directory dir = NIL;
	__DUP(path, path__len, CHAR);
	dir = Directories_This(path, path__len);
	if (dir != NIL) {
		Elems_SetString((void*)Elems_NamedElem((CHAR*)"path", (LONGINT)5, ElemsUI_ct), (CHAR*)"Value", (LONGINT)6, dir->path, 128);
	}
	__DEL(path);
}

static void ElemsUI_ChangeTo (CHAR *path, LONGINT path__len)
{
	__DUP(path, path__len, CHAR);
	if (ElemsUI_On((CHAR*)"change", (LONGINT)7)) {
		Directories_Change(path, path__len);
	}
	ElemsUI_CreateFileList(path, path__len, 0x06);
	ElemsUI_SetPathValue(path, path__len);
	__DEL(path);
}

void ElemsUI_UpdateWorkPath (void)
{
	CHAR workingDir[256];
	ElemsUI_ct = Elems_CmdContext;
	In_Open();
	In_String((void*)ElemsUI_pattern, 10);
	if (In_Done) {
		ElemsUI_ChangeTo(Kernel_CWD, 256);
	}
}

void ElemsUI_UpdatePath (void)
{
	CHAR s[256];
	ElemsUI_ct = Elems_CmdContext;
	In_Open();
	In_String((void*)s, 256);
	In_String((void*)ElemsUI_pattern, 10);
	if (In_Done) {
		ElemsUI_ChangeTo(s, 256);
	}
}

void ElemsUI_InitFilesPanel (void)
{
	Directories_Directory dir = NIL;
	Texts_Scanner s = {0};
	CHAR path[64];
	Texts_Text t = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	path[0] = 0x00;
	ElemsUI_ct = Elems_CmdContext;
	if (ElemsUI_filesPar != NIL) {
		Texts_OpenScanner(&s, Texts_Scanner__typ, ElemsUI_filesPar->text, ElemsUI_filesPar->pos);
		Texts_Scan(&s, Texts_Scanner__typ);
		ElemsUI_filesPar = NIL;
	} else {
		Oberon_GetSelection(&t, &beg, &end, &time);
		if (time >= 0) {
			Texts_OpenScanner(&s, Texts_Scanner__typ, t, beg);
			Texts_Scan(&s, Texts_Scanner__typ);
		}
	}
	if (__IN(s.class, 0x06)) {
		__COPY(s.s, path, 64);
	}
	if (path[0] == 0x00) {
		dir = Directories_Current();
		__COPY(dir->path, path, 64);
	}
	Elems_SetString((void*)Elems_NamedElem((CHAR*)"path", (LONGINT)5, ElemsUI_ct), (CHAR*)"Value", (LONGINT)6, path, 64);
	Elems_SetString((void*)Elems_NamedElem((CHAR*)"pattern", (LONGINT)8, ElemsUI_ct), (CHAR*)"ComboV", (LONGINT)7, (CHAR*)"*", (LONGINT)2);
	ElemsUI_CreatePatternList();
	ElemsUI_CreateDriveList();
	__MOVE("*", ElemsUI_pattern, 2);
	ElemsUI_CreateFileList(path, 64, 0x06);
}

void ElemsUI_OpenFilesPanel (void)
{
	PanelElems_Panel p = NIL;
	Fonts_Font fnt = NIL;
	SHORTINT col = 0;
	ElemsUI_filesPar = Oberon_Par;
	Panel_LoadPanel((CHAR*)"Files.Panel", (LONGINT)12, &p, &fnt, &col);
	Panel_OpenPanel(p, (CHAR*)"Files.Panel", (LONGINT)12, fnt, col);
}

void ElemsUI_SearchPattern (void)
{
	CHAR s[128];
	Texts_Text t = NIL;
	In_Open();
	In_String((void*)s, 128);
	Elems_GetText((void*)Elems_NamedElem((CHAR*)"files", (LONGINT)6, Elems_CmdContext), (CHAR*)"ValueT", (LONGINT)7, &t);
	Texts_Save(t, 0, t->len, ElemsUI_W.buf);
	ElemsUI_Call((CHAR*)"Find.Domain", (LONGINT)12);
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"\"", (LONGINT)2);
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, s, 128);
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, (CHAR*)"\"", (LONGINT)2);
	ElemsUI_Call((CHAR*)"Find.All", (LONGINT)9);
}

static struct UpdateCalender__72 {
	Elems_Elem *e;
	Dates_Date *today, *cal;
	INTEGER *cw, *x, *y, *day, *daysOfMonth;
	CHAR (*s)[10];
	struct UpdateCalender__72 *lnk;
} *UpdateCalender__72_s;

static void SetCW__73 (void);
static void SetDay__75 (void);

static void SetDay__75 (void)
{
	Elems_IntToString(*UpdateCalender__72_s->y * 10 + *UpdateCalender__72_s->x, (void*)*UpdateCalender__72_s->s, 10);
	*UpdateCalender__72_s->e = Elems_NamedElem(*UpdateCalender__72_s->s, 10, Elems_CmdContext);
	if (*UpdateCalender__72_s->day < 1 || *UpdateCalender__72_s->day > *UpdateCalender__72_s->daysOfMonth) {
		(*UpdateCalender__72_s->s)[0] = 0x00;
	} else {
		Elems_IntToString(*UpdateCalender__72_s->day, (void*)*UpdateCalender__72_s->s, 10);
	}
	Elems_SetString((void*)*UpdateCalender__72_s->e, (CHAR*)"Value", (LONGINT)6, *UpdateCalender__72_s->s, 10);
	if (((*UpdateCalender__72_s->cal)->year == (*UpdateCalender__72_s->today)->year && (*UpdateCalender__72_s->cal)->month == (*UpdateCalender__72_s->today)->month) && *UpdateCalender__72_s->day == (*UpdateCalender__72_s->today)->day) {
		Elems_SetBoolean((void*)*UpdateCalender__72_s->e, (CHAR*)"Border", (LONGINT)7, 1);
		Elems_SetBoolean((void*)*UpdateCalender__72_s->e, (CHAR*)"3D", (LONGINT)3, 1);
	} else {
		Elems_SetBoolean((void*)*UpdateCalender__72_s->e, (CHAR*)"Border", (LONGINT)7, 0);
	}
	Elems_UpdateElem((void*)*UpdateCalender__72_s->e);
}

static void SetCW__73 (void)
{
	Elems_IntToString(*UpdateCalender__72_s->y, (void*)*UpdateCalender__72_s->s, 10);
	Strings_Insert((CHAR*)"cw", (LONGINT)3, 0, (void*)*UpdateCalender__72_s->s, 10);
	*UpdateCalender__72_s->e = Elems_NamedElem(*UpdateCalender__72_s->s, 10, Elems_CmdContext);
	if (*UpdateCalender__72_s->day > *UpdateCalender__72_s->daysOfMonth) {
		(*UpdateCalender__72_s->s)[0] = 0x00;
	} else {
		Elems_IntToString(*UpdateCalender__72_s->cw, (void*)*UpdateCalender__72_s->s, 10);
	}
	Elems_SetString((void*)*UpdateCalender__72_s->e, (CHAR*)"Value", (LONGINT)6, *UpdateCalender__72_s->s, 10);
	Elems_UpdateElem((void*)*UpdateCalender__72_s->e);
}

void ElemsUI_UpdateCalender (void)
{
	Elems_Elem e = NIL;
	Dates_Date today = NIL, cal = NIL;
	INTEGER cw = 0, x = 0, y = 0, day = 0, year = 0, month = 0, daysOfMonth = 0;
	CHAR s[10];
	struct UpdateCalender__72 _s;
	_s.e = &e;
	_s.today = &today;
	_s.cal = &cal;
	_s.cw = &cw;
	_s.x = &x;
	_s.y = &y;
	_s.day = &day;
	_s.daysOfMonth = &daysOfMonth;
	_s.s = (void*)s;
	_s.lnk = UpdateCalender__72_s;
	UpdateCalender__72_s = &_s;
	__NEW(today, Dates_DateDesc);
	__Dates_Date_Init(today);
	__Dates_Date_SetToday(today);
	__NEW(cal, Dates_DateDesc);
	__Dates_Date_Init(cal);
	In_Open();
	In_Int(&month);
	In_Int(&year);
	if (In_Done) {
		__Dates_Date_Set(cal, 1, month, year);
	} else {
		__Dates_Date_SetToday(cal);
		__Dates_Date_AddDays(cal, -cal->day + 1);
	}
	__Dates_Date_MonthName(cal, 0, (void*)s, 10);
	Elems_SetString((void*)Elems_NamedElem((CHAR*)"month", (LONGINT)6, Elems_CmdContext), (CHAR*)"Value", (LONGINT)6, s, 10);
	Elems_UpdateElem((void*)Elems_NamedElem((CHAR*)"month", (LONGINT)6, Elems_CmdContext));
	Elems_IntToString(cal->year, (void*)s, 10);
	Elems_SetString((void*)Elems_NamedElem((CHAR*)"year", (LONGINT)5, Elems_CmdContext), (CHAR*)"ComboV", (LONGINT)7, s, 10);
	Elems_UpdateElem((void*)Elems_NamedElem((CHAR*)"year", (LONGINT)5, Elems_CmdContext));
	daysOfMonth = __Dates_Date_DaysOfMonth(cal);
	day = -(__Dates_Date_DayOfWeek(cal) - 1);
	y = 0;
	while (y <= 5) {
		cw = __Dates_Date_WeekOfYear(cal);
		SetCW__73();
		__Dates_Date_AddDays(cal, 7);
		x = 0;
		while (x <= 6) {
			SetDay__75();
			day += 1;
			x += 1;
		}
		y += 1;
	}
	UpdateCalender__72_s = _s.lnk;
}

void ElemsUI_InspectCharacter (void)
{
	Texts_Reader r = {0};
	Texts_Text ct = NIL;
	CHAR ch = 0;
	Oberon_SelectionMsg msg = {0};
	CHAR str[32];
	Elems_Elem e = NIL;
	INTEGER i = 0, j = 0;
	Types_Type type = NIL;
	ct = Elems_CmdContext;
	if (ct == NIL) {
		return;
	}
	msg.time = 0;
	msg.text = NIL;
	Viewers_Broadcast((void*)&msg, Oberon_SelectionMsg__typ);
	if (msg.text != NIL) {
		Texts_OpenReader(&r, Texts_Reader__typ, msg.text, msg.beg);
		Texts_Read(&r, Texts_Reader__typ, &ch);
		e = Elems_NamedElem((CHAR*)"ascii", (LONGINT)6, ct);
		Elems_IntToString((int)ch, (void*)str, 32);
		Elems_SetString((void*)e, (CHAR*)"Value", (LONGINT)6, str, 32);
		Elems_UpdateElem((void*)e);
		e = Elems_NamedElem((CHAR*)"col", (LONGINT)4, ct);
		Elems_SetInteger((void*)e, (CHAR*)"Value", (LONGINT)6, r.col);
		Elems_UpdateElem((void*)e);
		e = Elems_NamedElem((CHAR*)"voff", (LONGINT)5, ct);
		Elems_IntToString(r.voff, (void*)str, 32);
		Elems_SetString((void*)e, (CHAR*)"ComboV", (LONGINT)7, str, 32);
		Elems_UpdateElem((void*)e);
		i = 0;
		j = 0;
		while (r.fnt->name[__X(i, 32)] != 0x00 && ElemsUI_IsCharacter(r.fnt->name[__X(i, 32)])) {
			str[__X(j, 32)] = r.fnt->name[__X(i, 32)];
			i += 1;
			j += 1;
		}
		str[__X(j, 32)] = 0x00;
		e = Elems_NamedElem((CHAR*)"fnt", (LONGINT)4, ct);
		Elems_SetString((void*)e, (CHAR*)"ComboV", (LONGINT)7, str, 32);
		Elems_UpdateElem((void*)e);
		j = 0;
		while (r.fnt->name[__X(i, 32)] != 0x00 && ElemsUI_IsDigit(r.fnt->name[__X(i, 32)])) {
			str[__X(j, 32)] = r.fnt->name[__X(i, 32)];
			i += 1;
			j += 1;
		}
		str[__X(j, 32)] = 0x00;
		e = Elems_NamedElem((CHAR*)"h", (LONGINT)2, ct);
		Elems_SetString((void*)e, (CHAR*)"ComboV", (LONGINT)7, str, 32);
		Elems_UpdateElem((void*)e);
		if (__CAP(r.fnt->name[__X(i, 32)]) == 'B') {
			__MOVE("bold", str, 5);
		} else if (__CAP(r.fnt->name[__X(i, 32)]) == 'I') {
			__MOVE("italic", str, 7);
		} else if (__CAP(r.fnt->name[__X(i, 32)]) == 'M') {
			__MOVE("mark", str, 5);
		} else {
			__MOVE("plain", str, 6);
		}
		e = Elems_NamedElem((CHAR*)"attr", (LONGINT)5, ct);
		Elems_SetString((void*)e, (CHAR*)"Value", (LONGINT)6, str, 32);
		Elems_UpdateElem((void*)e);
		if (ch == 0x1c) {
			type = Types_TypeOf((void*)r.elem);
			__COPY(type->module->name, str, 32);
			Strings_Append((CHAR*)".", (LONGINT)2, (void*)str, 32);
			Strings_Append(type->name, 24, (void*)str, 32);
		} else {
			str[0] = 0x00;
		}
		e = Elems_NamedElem((CHAR*)"elemtype", (LONGINT)9, ct);
		Elems_SetString((void*)e, (CHAR*)"Value", (LONGINT)6, str, 32);
		Elems_UpdateElem((void*)e);
	}
}

void ElemsUI_ApplyFont (void)
{
	CHAR str[32];
	CHAR fntName[64];
	INTEGER voff = 0, col = 0;
	Fonts_Font fnt = NIL;
	Oberon_SelectionMsg msg = {0};
	if (Elems_CmdContext == NIL) {
		return;
	}
	msg.text = NIL;
	msg.time = 0;
	Viewers_Broadcast((void*)&msg, Oberon_SelectionMsg__typ);
	if (msg.text != NIL) {
		In_Open();
		In_String((void*)str, 32);
		__COPY(str, fntName, 64);
		In_String((void*)str, 32);
		Strings_Append(str, 32, (void*)fntName, 64);
		In_String((void*)str, 32);
		if (__CAP(str[0]) == 'I') {
			Strings_Append((CHAR*)"i", (LONGINT)2, (void*)fntName, 64);
		} else if (__CAP(str[0]) == 'B') {
			Strings_Append((CHAR*)"b", (LONGINT)2, (void*)fntName, 64);
		} else if (__CAP(str[0]) == 'M') {
			Strings_Append((CHAR*)"m", (LONGINT)2, (void*)fntName, 64);
		}
		Strings_Append((CHAR*)".Scn.Fnt", (LONGINT)9, (void*)fntName, 64);
		fnt = Fonts_This(fntName, 64);
		if (fnt == NIL) {
			Out_String((CHAR*)"-- font ", (LONGINT)9);
			Out_String(fntName, 64);
			Out_String((CHAR*)" not found", (LONGINT)11);
			Out_Ln();
			return;
		}
		In_Int(&voff);
		In_Int(&col);
		ElemsUI_StoreSelection();
		Texts_ChangeLooks(msg.text, msg.beg, msg.end, 0x07, fnt, (int)col, (int)voff);
		ElemsUI_RestoreSelection();
	}
}

void ElemsUI_HelpSearch (void)
{
	CHAR str[250];
	ElemsUI_ct = Elems_CmdContext;
	if ((((((!ElemsUI_On((CHAR*)"source", (LONGINT)7) || ElemsUI_On((CHAR*)"def", (LONGINT)4)) || !ElemsUI_On((CHAR*)"balloon", (LONGINT)8)) || !ElemsUI_On((CHAR*)"text", (LONGINT)5)) || !ElemsUI_On((CHAR*)"html", (LONGINT)5)) || !ElemsUI_On((CHAR*)"case", (LONGINT)5)) || !ElemsUI_On((CHAR*)"modIdx", (LONGINT)7)) {
		Texts_Write(&ElemsUI_W, Texts_Writer__typ, '\\');
		if (!ElemsUI_On((CHAR*)"source", (LONGINT)7)) {
			Texts_Write(&ElemsUI_W, Texts_Writer__typ, 'm');
		}
		if (ElemsUI_On((CHAR*)"def", (LONGINT)4)) {
			Texts_Write(&ElemsUI_W, Texts_Writer__typ, 'd');
		}
		if (!ElemsUI_On((CHAR*)"balloon", (LONGINT)8)) {
			Texts_Write(&ElemsUI_W, Texts_Writer__typ, 'b');
		}
		if (!ElemsUI_On((CHAR*)"text", (LONGINT)5)) {
			Texts_Write(&ElemsUI_W, Texts_Writer__typ, 't');
		}
		if (!ElemsUI_On((CHAR*)"html", (LONGINT)5)) {
			Texts_Write(&ElemsUI_W, Texts_Writer__typ, 'h');
		}
		if (!ElemsUI_On((CHAR*)"case", (LONGINT)5)) {
			Texts_Write(&ElemsUI_W, Texts_Writer__typ, 'c');
		}
		if (!ElemsUI_On((CHAR*)"modIdx", (LONGINT)7)) {
			Texts_Write(&ElemsUI_W, Texts_Writer__typ, 'f');
		}
		Texts_Write(&ElemsUI_W, Texts_Writer__typ, ' ');
	}
	Texts_Write(&ElemsUI_W, Texts_Writer__typ, '\"');
	Elems_GetString((void*)Elems_NamedElem((CHAR*)"pattern", (LONGINT)8, ElemsUI_ct), (CHAR*)"Value", (LONGINT)6, (void*)str, 250);
	Texts_WriteString(&ElemsUI_W, Texts_Writer__typ, str, 250);
	Texts_Write(&ElemsUI_W, Texts_Writer__typ, '\"');
	ElemsUI_Call((CHAR*)"Help.Search", (LONGINT)12);
}

static void EnumPtrs(void (*P)(void*))
{
	P(ElemsUI_t);
	P(ElemsUI_vwr);
	P(ElemsUI_ct);
	P(ElemsUI_parText);
	P(ElemsUI_par);
	P(ElemsUI_orgLog);
	P(ElemsUI_newLog);
	__ENUMR(&ElemsUI_W, Texts_Writer__typ, 36, 1, P);
	__ENUMR(&ElemsUI_W1, Texts_Writer__typ, 36, 1, P);
	P(ElemsUI_styleElems);
	P(ElemsUI_filesPar);
	P(ElemsUI_e);
}

__TDESC(ElemsUI_StyleElemDesc, 1, 2) = {__TDFLDS("StyleElemDesc", 8), {0, 4, -12}};

export void *ElemsUI__init(void)
{
	__DEFMOD;
	__IMPORT(Dates);
	__IMPORT(Directories);
	__IMPORT(Display);
	__IMPORT(Documents);
	__IMPORT(Elems);
	__IMPORT(Fonts);
	__IMPORT(In);
	__IMPORT(Kernel);
	__IMPORT(MathL);
	__IMPORT(MathLX);
	__IMPORT(Oberon);
	__IMPORT(Out);
	__IMPORT(Panel);
	__IMPORT(PanelElems);
	__IMPORT(ParcElems);
	__IMPORT(Strings);
	__IMPORT(StyleElems);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Types);
	__IMPORT(Viewers);
	__IMPORT(XIn);
	__REGMOD(ElemsUI, EnumPtrs);
	__REGCMD("ApplyFont", ElemsUI_ApplyFont);
	__REGCMD("ApplyParc", ElemsUI_ApplyParc);
	__REGCMD("CalcIn", ElemsUI_CalcIn);
	__REGCMD("FoldsCompile", ElemsUI_FoldsCompile);
	__REGCMD("HelpSearch", ElemsUI_HelpSearch);
	__REGCMD("InitCalcPanel", ElemsUI_InitCalcPanel);
	__REGCMD("InitFilesPanel", ElemsUI_InitFilesPanel);
	__REGCMD("InitParcPanel", ElemsUI_InitParcPanel);
	__REGCMD("InspectCharacter", ElemsUI_InspectCharacter);
	__REGCMD("InspectParc", ElemsUI_InspectParc);
	__REGCMD("OpenFilesPanel", ElemsUI_OpenFilesPanel);
	__REGCMD("Print", ElemsUI_Print);
	__REGCMD("SearchPattern", ElemsUI_SearchPattern);
	__REGCMD("SetCalcType", ElemsUI_SetCalcType);
	__REGCMD("ShowPrintString", ElemsUI_ShowPrintString);
	__REGCMD("ShowResult", ElemsUI_ShowResult);
	__REGCMD("Style", ElemsUI_Style);
	__REGCMD("UpdateCalender", ElemsUI_UpdateCalender);
	__REGCMD("UpdatePath", ElemsUI_UpdatePath);
	__REGCMD("UpdateWorkPath", ElemsUI_UpdateWorkPath);
	__INITYP(ElemsUI_StyleElemDesc, ElemsUI_StyleElemDesc, 0);
/* BEGIN */
	ElemsUI_parText = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_OpenWriter(&ElemsUI_W, Texts_Writer__typ);
	Texts_OpenWriter(&ElemsUI_W1, Texts_Writer__typ);
	ElemsUI_GetStyles(1);
	ElemsUI_filesPar = NIL;
	__ENDMOD;
}
