/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "FoldElems.h"
#include "Fonts.h"
#include "Input.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct Folds_ErrElemDesc *Folds_ErrElem;

typedef
	struct Folds_ErrElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		INTEGER err;
	} Folds_ErrElemDesc;

typedef
	CHAR Folds_Options[16];


static Texts_Writer Folds_w;
static Texts_Text Folds_errT;
static CHAR Folds_compName[24], Folds_errFile[24];
static Folds_Options Folds_globOpt;
static BOOLEAN Folds_showWarnings;
static INTEGER Folds_errors;

export LONGINT *Folds_ErrElemDesc__typ;

export void Folds_Compile (void);
static void Folds_DeleteErrElems (Texts_Text t);
static BOOLEAN Folds_ErrCheck (Texts_Elem e);
static void Folds_GetErrMsg (INTEGER err, CHAR *msg, LONGINT msg__len);
static void Folds_GetOptions (Texts_Scanner *s, LONGINT *s__typ, CHAR *opt, LONGINT opt__len);
static void Folds_HandleErr (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void Folds_InsertErrElems (TextFrames_Frame F, Texts_Text t, LONGINT pos);
static TextFrames_Frame Folds_MarkedFrame (void);
static void Folds_NoNotify (Texts_Text t, INTEGER op, LONGINT beg, LONGINT end);
static void Folds_OpenTempViewer (Texts_Text t, MenuViewers_Viewer *v);
export void Folds_SetProfile (void);
static void Folds_Show (TextFrames_Frame f, LONGINT pos);
export void Folds_ShowError (void);


static void Folds_NoNotify (Texts_Text t, INTEGER op, LONGINT beg, LONGINT end)
{
}

static BOOLEAN Folds_ErrCheck (Texts_Elem e)
{
	return __ISP(e, Folds_ErrElemDesc, 2);
}

static void Folds_GetOptions (Texts_Scanner *s, LONGINT *s__typ, CHAR *opt, LONGINT opt__len)
{
	INTEGER i = 0;
	i = 0;
	while ((*s).nextCh == ' ') {
		Texts_Read((void*)&*s, s__typ, &(*s).nextCh);
	}
	if ((*s).nextCh == '/' || (*s).nextCh == '\\') {
		do {
			opt[__X(i, opt__len)] = (*s).nextCh;
			i += 1;
			Texts_Read((void*)&*s, s__typ, &(*s).nextCh);
		} while (!(__CAP((*s).nextCh) < 'A' || __CAP((*s).nextCh) > 'Z'));
	}
	opt[__X(i, opt__len)] = 0x00;
}

static TextFrames_Frame Folds_MarkedFrame (void)
{
	Viewers_Viewer v = NIL;
	LONGINT x = 0;
	v = Oberon_MarkedViewer();
	if ((v != NIL && v->dsc != NIL) && __ISP(v->dsc->next, TextFrames_FrameDesc, 1)) {
		return __GUARDP(v->dsc->next, TextFrames_FrameDesc, 1);
	} else {
		return NIL;
	}
	__RETCHK;
}

static void Folds_OpenTempViewer (Texts_Text t, MenuViewers_Viewer *v)
{
	INTEGER x = 0, y = 0, h = 0;
	y = Display_Bottom;
	x = Display_Width - 1;
	h = Viewers_minH;
	Viewers_minH = 1;
	*v = MenuViewers_New((void*)TextFrames_NewMenu((CHAR*)"", (LONGINT)1, (CHAR*)"", (LONGINT)1), (void*)TextFrames_NewText(t, 0), TextFrames_menuH, x, y);
	Oberon_Pointer.X = x;
	Oberon_Pointer.Y = y;
	Viewers_minH = h;
}

static void Folds_Show (TextFrames_Frame f, LONGINT pos)
{
	LONGINT end = 0, delta = 0;
	delta = 200;
	for (;;) {
		end = TextFrames_Pos(f, f->X + f->W, f->Y);
		if (f->org <= pos && pos < end || f->org == end) {
			break;
		}
		TextFrames_Show(f, pos - delta);
		delta -= 20;
	}
}

static void Folds_HandleErr (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	Folds_ErrElem e = NIL;
	INTEGER x = 0, y = 0, w = 0, h = 0;
	SET keys = 0;
	if (__ISP(E, Folds_ErrElemDesc, 2)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				w = (int)__DIV((*(Folds_ErrElem*)&E)->W, (LONGINT)TextFrames_Unit);
				h = (int)__DIV((*(Folds_ErrElem*)&E)->H, (LONGINT)TextFrames_Unit);
				Display_ReplConst(15, (*msg__).X0 + 1, (*msg__).Y0 + 1, w - 2, h - 2, 0);
			}
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *msg__ = (void*)msg;
			if ((*msg__).keys == 0x02) {
				do {
					Input_Mouse(&keys, &x, &y);
					Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
				} while (!(keys == 0x0));
			}
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *msg__ = (void*)msg;
			__NEW(e, Folds_ErrElemDesc);
			Texts_CopyElem((void*)(*(Folds_ErrElem*)&E), (void*)e);
			e->err = (*(Folds_ErrElem*)&E)->err;
			(*msg__).e = (Texts_Elem)e;
		}
	} else __WITHCHK;
}

static void Folds_InsertErrElems (TextFrames_Frame F, Texts_Text t, LONGINT pos)
{
	Texts_Scanner S = {0};
	INTEGER err = 0;
	Folds_ErrElem e = NIL;
	Folds_errors = 0;
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Log, pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	for (;;) {
		S.line = 0;
		if (S.eot) {
			break;
		} else if (S.class == 1 && __STRCMP(S.s, "pos") == 0) {
			Texts_Scan(&S, Texts_Scanner__typ);
			if (S.class == 3) {
				pos = S.i;
			} else {
				break;
			}
			do {
				Texts_Scan(&S, Texts_Scanner__typ);
			} while (!(S.eot || S.class == 3));
			if (S.eot) {
				break;
			} else if ((Folds_showWarnings || S.i < 300) || S.i > 399) {
				__NEW(e, Folds_ErrElemDesc);
				e->W = (LONGINT)Fonts_Default->height * (LONGINT)TextFrames_Unit;
				e->H = e->W;
				e->handle = Folds_HandleErr;
				e->err = (int)S.i;
				Texts_WriteElem(&Folds_w, Texts_Writer__typ, (void*)e);
				Texts_Insert(t, pos + (LONGINT)Folds_errors, Folds_w.buf);
				Folds_errors += 1;
			}
		}
		do {
			Texts_Scan(&S, Texts_Scanner__typ);
		} while (!(S.eot || S.line != 0));
	}
}

static void Folds_DeleteErrElems (Texts_Text t)
{
	Texts_Reader r = {0};
	LONGINT pos = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
	for (;;) {
		Texts_ReadElem(&r, Texts_Reader__typ);
		if (r.elem == NIL) {
			break;
		} else if (__ISP(r.elem, Folds_ErrElemDesc, 2)) {
			pos = Texts_Pos(&r, Texts_Reader__typ);
			Texts_Delete(t, pos - 1, pos);
			Texts_OpenReader(&r, Texts_Reader__typ, t, pos - 1);
		}
	}
}

static void Folds_GetErrMsg (INTEGER err, CHAR *msg, LONGINT msg__len)
{
	Texts_Scanner s = {0};
	INTEGER n = 0;
	CHAR ch = 0;
	Texts_OpenScanner(&s, Texts_Scanner__typ, Folds_errT, 0);
	do {
		Texts_Scan(&s, Texts_Scanner__typ);
	} while (!(s.eot || s.class == 3 && s.i == 0));
	while (!s.eot && (s.class != 3 || s.i != (LONGINT)err)) {
		Texts_Scan(&s, Texts_Scanner__typ);
	}
	if (!s.eot) {
		Texts_Read((void*)&s, Texts_Scanner__typ, &ch);
		n = 0;
		while (!s.eot && ch != 0x0d) {
			msg[__X(n, msg__len)] = ch;
			n += 1;
			Texts_Read((void*)&s, Texts_Scanner__typ, &ch);
		}
		msg[__X(n, msg__len)] = 0x00;
	}
}

void Folds_SetProfile (void)
{
	Texts_Scanner s = {0};
	Texts_Text t = NIL;
	Files_File f = NIL;
	__MOVE("Compiler.Compile", Folds_compName, 17);
	__MOVE("OberonErrors.Text", Folds_errFile, 18);
	Folds_globOpt[0] = 0x00;
	Folds_showWarnings = 1;
	f = Files_Old((CHAR*)"Folds.Profile", (LONGINT)14);
	if (f != NIL) {
		__NEW(t, Texts_TextDesc);
		Texts_Open(t, (CHAR*)"Folds.Profile", (LONGINT)14);
		Texts_OpenScanner(&s, Texts_Scanner__typ, t, 0);
		Texts_Scan(&s, Texts_Scanner__typ);
		while (!s.eot) {
			if (s.class == 1) {
				if (__STRCMP(s.s, "compiler") == 0) {
					Texts_Scan(&s, Texts_Scanner__typ);
					Texts_Scan(&s, Texts_Scanner__typ);
					__COPY(s.s, Folds_compName, 24);
					Folds_GetOptions(&s, Texts_Scanner__typ, (void*)Folds_globOpt, 16);
				} else if (__STRCMP(s.s, "errorFile") == 0) {
					Texts_Scan(&s, Texts_Scanner__typ);
					Texts_Scan(&s, Texts_Scanner__typ);
					__COPY(s.s, Folds_errFile, 24);
				} else if (__STRCMP(s.s, "showWarnings") == 0) {
					Texts_Scan(&s, Texts_Scanner__typ);
					Texts_Scan(&s, Texts_Scanner__typ);
					Folds_showWarnings = __STRCMP(s.s, "yes") == 0;
				}
			}
			Texts_Scan(&s, Texts_Scanner__typ);
		}
	}
	Folds_errT = TextFrames_Text(Folds_errFile, 24);
}

void Folds_Compile (void)
{
	TextFrames_Frame f = NIL;
	Texts_Text t = NIL;
	INTEGER res = 0;
	Texts_Scanner s = {0};
	LONGINT beg = 0, end = 0, time = 0, pos = 0;
	MenuViewers_Viewer v = NIL;
	Texts_Notifier oldNotify = NIL;
	Oberon_ParList par = NIL;
	BOOLEAN ready = 0;
	Folds_Options opt;
	par = Oberon_Par;
	Texts_OpenScanner(&s, Texts_Scanner__typ, par->text, par->pos);
	end = par->text->len + 1;
	do {
		Texts_Scan(&s, Texts_Scanner__typ);
		t = NIL;
		f = NIL;
		ready = 0;
		if (par->vwr->dsc == par->frame) {
			f = __GUARDP(par->frame->next, TextFrames_FrameDesc, 1);
			Oberon_DrawCursor(&Oberon_Pointer, Oberon_Cursor__typ, &Oberon_Star, Oberon_Marker__typ, f->X, f->Y);
			Oberon_FadeCursor(&Oberon_Pointer, Oberon_Cursor__typ);
			t = f->text;
			__MOVE(Folds_globOpt, opt, 16);
			ready = 1;
		} else {
			if (s.class == 1 && Texts_Pos((void*)&s, Texts_Scanner__typ) <= end) {
				t = TextFrames_Text(s.s, 256);
			} else if (s.class == 6 && s.c == '*') {
				f = Folds_MarkedFrame();
				if (f != NIL) {
					t = f->text;
				}
				ready = 1;
			} else if (s.class == 6 && s.c == '^') {
				Oberon_GetSelection(&t, &beg, &end, &time);
				if (time >= 0) {
					Texts_OpenScanner(&s, Texts_Scanner__typ, t, beg);
					end = par->text->len + 1;
					Texts_Scan(&s, Texts_Scanner__typ);
					if (s.class == 1 && Texts_Pos((void*)&s, Texts_Scanner__typ) <= end) {
						t = TextFrames_Text(s.s, 256);
					}
				}
			}
			Folds_GetOptions(&s, Texts_Scanner__typ, (void*)opt, 16);
		}
		if (t != NIL) {
			Folds_DeleteErrElems(t);
			oldNotify = t->notify;
			t->notify = Folds_NoNotify;
			FoldElems_ExpandAll(t, 0, 1);
			if (f == NIL) {
				Folds_OpenTempViewer(t, &v);
			} else {
				Folds_DeleteErrElems(t);
			}
			par->text = TextFrames_Text((CHAR*)"", (LONGINT)1);
			Texts_Write(&Folds_w, Texts_Writer__typ, '*');
			Texts_WriteString(&Folds_w, Texts_Writer__typ, opt, 16);
			Texts_Append(par->text, Folds_w.buf);
			par->pos = 0;
			pos = Oberon_Log->len;
			Oberon_Call(Folds_compName, 24, par, 0, &res);
			if (res == 0 && f != NIL) {
				Folds_InsertErrElems(f, t, pos);
			}
			FoldElems_CollapseAll(t, 0x10);
			if (f == NIL) {
				Viewers_Close((void*)v);
			} else {
				t->notify = oldNotify;
				if (Folds_errors != 0) {
					(*t->notify)(t, 0, 0, t->len);
				}
			}
		}
	} while (!(t == NIL || ready));
}

void Folds_ShowError (void)
{
	Display_Frame F = NIL;
	LONGINT pos = 0;
	Texts_Elem e = NIL;
	CHAR msg[128];
	if (Oberon_Par->vwr->dsc == Oberon_Par->frame) {
		F = Oberon_Par->frame->next;
	} else {
		F = Oberon_FocusViewer->dsc->next;
	}
	if (__ISP(F, TextFrames_FrameDesc, 1)) {
		if ((*(TextFrames_Frame*)&F)->hasCar) {
			pos = (*(TextFrames_Frame*)&F)->carloc.pos;
		} else {
			pos = 0;
		}
		FoldElems_FindElem((*(TextFrames_Frame*)&F)->text, pos, Folds_ErrCheck, &e);
		if (e != NIL) {
			pos = Texts_ElemPos(e);
			Folds_Show((*(TextFrames_Frame*)&F), pos);
			Oberon_PassFocus(Viewers_This((*(TextFrames_Frame*)&F)->X, (*(TextFrames_Frame*)&F)->Y));
			TextFrames_SetCaret((*(TextFrames_Frame*)&F), pos + 1);
			Folds_GetErrMsg(__GUARDP(e, Folds_ErrElemDesc, 2)->err, (void*)msg, 128);
			Texts_WriteString(&Folds_w, Texts_Writer__typ, msg, 128);
			Texts_WriteLn(&Folds_w, Texts_Writer__typ);
			Texts_Append(Oberon_Log, Folds_w.buf);
		}
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&Folds_w, Texts_Writer__typ, 36, 1, P);
	P(Folds_errT);
}

__TDESC(Folds_ErrElemDesc, 1, 4) = {__TDFLDS("ErrElemDesc", 40), {0, 4, 12, 32, -20}};

export void *Folds__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(FoldElems);
	__IMPORT(Fonts);
	__IMPORT(Input);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(Folds, EnumPtrs);
	__REGCMD("Compile", Folds_Compile);
	__REGCMD("SetProfile", Folds_SetProfile);
	__REGCMD("ShowError", Folds_ShowError);
	__INITYP(Folds_ErrElemDesc, Texts_ElemDesc, 2);
/* BEGIN */
	Texts_OpenWriter(&Folds_w, Texts_Writer__typ);
	Folds_SetProfile();
	__ENDMOD;
}
