/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Files.h"
#include "Oberon.h"
#include "Texts.h"


static Texts_Writer FontToBDF_W;
static CHAR FontToBDF_fontname[128];
static CHAR FontToBDF_prefix[32], FontToBDF_suffix[32];
static CHAR FontToBDF_hex[16];

static LONGINT *RunRec__4__typ;
static LONGINT *BoxRec__3__typ;

export void FontToBDF_Convert (void);
static void FontToBDF_Do (Files_Rider *R, LONGINT *R__typ, Files_Rider *r, LONGINT *r__typ, INTEGER size, BOOLEAN screen);
static void FontToBDF_Write (Files_Rider *r, LONGINT *r__typ, CHAR ch);
static void FontToBDF_WriteHex (Files_Rider *r, LONGINT *r__typ, CHAR ch);
static void FontToBDF_WriteInt (Files_Rider *r, LONGINT *r__typ, LONGINT n);
static void FontToBDF_WriteLn (Files_Rider *r, LONGINT *r__typ);
static void FontToBDF_WriteStr (Files_Rider *r, LONGINT *r__typ, CHAR *str, LONGINT str__len);


static void FontToBDF_Write (Files_Rider *r, LONGINT *r__typ, CHAR ch)
{
	Files_Write(&*r, r__typ, ch);
}

static void FontToBDF_WriteStr (Files_Rider *r, LONGINT *r__typ, CHAR *str, LONGINT str__len)
{
	INTEGER i = 0;
	__DUP(str, str__len, CHAR);
	i = 0;
	while (str[__X(i, str__len)] != 0x00) {
		Files_Write(&*r, r__typ, str[__X(i, str__len)]);
		i += 1;
	}
	__DEL(str);
}

static void FontToBDF_WriteInt (Files_Rider *r, LONGINT *r__typ, LONGINT n)
{
	CHAR str[32];
	INTEGER i = 0;
	if (n == 0) {
		Files_Write(&*r, r__typ, '0');
	} else {
		if (n < 0) {
			Files_Write(&*r, r__typ, '-');
			n = -n;
		}
		i = 0;
		do {
			str[__X(i, 32)] = (CHAR)(48 + __MOD(n, 10));
			i += 1;
			n = __DIV(n, 10);
		} while (!(n == 0));
		while (i > 0) {
			i -= 1;
			Files_Write(&*r, r__typ, str[__X(i, 32)]);
		}
	}
}

static void FontToBDF_WriteHex (Files_Rider *r, LONGINT *r__typ, CHAR ch)
{
	Files_Write(&*r, r__typ, FontToBDF_hex[__X(__MASK((int)ch, -16), 16)]);
	Files_Write(&*r, r__typ, FontToBDF_hex[__X(__ASHR((int)ch, 4), 16)]);
}

static void FontToBDF_WriteLn (Files_Rider *r, LONGINT *r__typ)
{
	Files_Write(&*r, r__typ, 0x0a);
}

typedef
	struct BoxRec__3 {
		INTEGER dx, x, y, w, h;
	} BoxRec__3;

typedef
	struct RunRec__4 {
		INTEGER beg, end;
	} RunRec__4;

static void FontToBDF_Do (Files_Rider *R, LONGINT *R__typ, Files_Rider *r, LONGINT *r__typ, INTEGER size, BOOLEAN screen)
{
	CHAR ch = 0;
	INTEGER height = 0, minX = 0, maxX = 0, minY = 0, maxY = 0, NofRuns = 0, NofBoxes = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	RunRec__4 run[16];
	BoxRec__3 box[256];
	CHAR raster[256][32];
	FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"STARTFONT 2.1", (LONGINT)14);
	FontToBDF_WriteLn(&*r, r__typ);
	FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"COMMENT converted Oberon font (using FontToBDF by R.Crelier 10.1.91)", (LONGINT)69);
	FontToBDF_WriteLn(&*r, r__typ);
	FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"FONT ", (LONGINT)6);
	FontToBDF_WriteStr(&*r, r__typ, FontToBDF_fontname, 128);
	FontToBDF_WriteLn(&*r, r__typ);
	if (size <= 0) {
		size = 1;
	}
	FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"SIZE ", (LONGINT)6);
	FontToBDF_WriteInt(&*r, r__typ, size);
	FontToBDF_WriteStr(&*r, r__typ, (CHAR*)" 75 75", (LONGINT)7);
	FontToBDF_WriteLn(&*r, r__typ);
	Files_Read(&*R, R__typ, (void*)&ch);
	Files_Read(&*R, R__typ, (void*)&ch);
	Files_Read(&*R, R__typ, (void*)&ch);
	Files_ReadInt(&*R, R__typ, &height);
	Files_ReadInt(&*R, R__typ, &minX);
	Files_ReadInt(&*R, R__typ, &maxX);
	Files_ReadInt(&*R, R__typ, &minY);
	Files_ReadInt(&*R, R__typ, &maxY);
	FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"FONTBOUNDINGBOX  ", (LONGINT)18);
	FontToBDF_WriteInt(&*r, r__typ, maxX - minX);
	FontToBDF_Write(&*r, r__typ, ' ');
	FontToBDF_WriteInt(&*r, r__typ, maxY - minY);
	FontToBDF_Write(&*r, r__typ, ' ');
	FontToBDF_WriteInt(&*r, r__typ, minX);
	FontToBDF_Write(&*r, r__typ, ' ');
	FontToBDF_WriteInt(&*r, r__typ, minY);
	FontToBDF_WriteLn(&*r, r__typ);
	FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"STARTPROPERTIES 3", (LONGINT)18);
	FontToBDF_WriteLn(&*r, r__typ);
	FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"FONT_ASCENT ", (LONGINT)13);
	FontToBDF_WriteInt(&*r, r__typ, maxY);
	FontToBDF_WriteLn(&*r, r__typ);
	FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"FONT_DESCENT ", (LONGINT)14);
	FontToBDF_WriteInt(&*r, r__typ, -minY);
	FontToBDF_WriteLn(&*r, r__typ);
	FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"DEFAULT_CHAR 0", (LONGINT)15);
	FontToBDF_WriteLn(&*r, r__typ);
	FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"ENDPROPERTIES", (LONGINT)14);
	FontToBDF_WriteLn(&*r, r__typ);
	Files_ReadInt(&*R, R__typ, &NofRuns);
	NofBoxes = 0;
	k = 0;
	while (k != NofRuns) {
		Files_ReadInt(&*R, R__typ, &run[__X(k, 16)].beg);
		Files_ReadInt(&*R, R__typ, &run[__X(k, 16)].end);
		NofBoxes = (NofBoxes + run[__X(k, 16)].end) - run[__X(k, 16)].beg;
		k += 1;
	}
	l = 0;
	while (l != NofBoxes) {
		Files_ReadInt(&*R, R__typ, &box[__X(l, 256)].dx);
		Files_ReadInt(&*R, R__typ, &box[__X(l, 256)].x);
		Files_ReadInt(&*R, R__typ, &box[__X(l, 256)].y);
		Files_ReadInt(&*R, R__typ, &box[__X(l, 256)].w);
		Files_ReadInt(&*R, R__typ, &box[__X(l, 256)].h);
		l += 1;
	}
	FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"CHARS ", (LONGINT)7);
	if (run[0].beg == 0) {
		FontToBDF_WriteInt(&*r, r__typ, NofBoxes);
		FontToBDF_WriteLn(&*r, r__typ);
	} else {
		FontToBDF_WriteInt(&*r, r__typ, NofBoxes + 1);
		FontToBDF_WriteLn(&*r, r__typ);
		FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"STARTCHAR c0", (LONGINT)13);
		FontToBDF_WriteLn(&*r, r__typ);
		FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"ENCODING -1 0", (LONGINT)14);
		FontToBDF_WriteLn(&*r, r__typ);
		FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"SWIDTH 0 0", (LONGINT)11);
		FontToBDF_WriteLn(&*r, r__typ);
		FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"DWIDTH 0 0", (LONGINT)11);
		FontToBDF_WriteLn(&*r, r__typ);
		FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"BBX 0 0 0 0", (LONGINT)12);
		FontToBDF_WriteLn(&*r, r__typ);
		FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"BITMAP", (LONGINT)7);
		FontToBDF_WriteLn(&*r, r__typ);
		FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"ENDCHAR", (LONGINT)8);
		FontToBDF_WriteLn(&*r, r__typ);
	}
	k = 0;
	l = 0;
	m = 0;
	while (k < NofRuns) {
		m = run[__X(k, 16)].beg;
		while (m < run[__X(k, 16)].end) {
			FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"STARTCHAR c", (LONGINT)12);
			FontToBDF_WriteInt(&*r, r__typ, m);
			FontToBDF_WriteLn(&*r, r__typ);
			FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"ENCODING -1 ", (LONGINT)13);
			FontToBDF_WriteInt(&*r, r__typ, m);
			FontToBDF_WriteLn(&*r, r__typ);
			dx = box[__X(l, 256)].dx;
			x = box[__X(l, 256)].x;
			y = box[__X(l, 256)].y;
			w = box[__X(l, 256)].w;
			h = box[__X(l, 256)].h;
			FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"SWIDTH ", (LONGINT)8);
			FontToBDF_WriteInt(&*r, r__typ, __ASHR(dx * 129, 2));
			FontToBDF_WriteStr(&*r, r__typ, (CHAR*)" 0", (LONGINT)3);
			FontToBDF_WriteLn(&*r, r__typ);
			FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"DWIDTH ", (LONGINT)8);
			FontToBDF_WriteInt(&*r, r__typ, dx);
			FontToBDF_WriteStr(&*r, r__typ, (CHAR*)" 0", (LONGINT)3);
			FontToBDF_WriteLn(&*r, r__typ);
			if (h == 0) {
				FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"BBX 0 0 0 0", (LONGINT)12);
			} else {
				FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"BBX ", (LONGINT)5);
				FontToBDF_WriteInt(&*r, r__typ, w);
				FontToBDF_Write(&*r, r__typ, ' ');
				FontToBDF_WriteInt(&*r, r__typ, h);
				FontToBDF_Write(&*r, r__typ, ' ');
				FontToBDF_WriteInt(&*r, r__typ, x);
				FontToBDF_Write(&*r, r__typ, ' ');
				FontToBDF_WriteInt(&*r, r__typ, y);
			}
			FontToBDF_WriteLn(&*r, r__typ);
			FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"BITMAP", (LONGINT)7);
			FontToBDF_WriteLn(&*r, r__typ);
			n = __ASHR(w + 7, 3);
			i = 0;
			while (i < h) {
				j = 0;
				while (j < n) {
					Files_Read(&*R, R__typ, (void*)&raster[__X(i, 256)][__X(j, 32)]);
					j += 1;
				}
				i += 1;
			}
			while (h > 0) {
				h -= 1;
				w = 0;
				while (w < n) {
					FontToBDF_WriteHex(&*r, r__typ, raster[__X(h, 256)][__X(w, 32)]);
					w += 1;
				}
				FontToBDF_WriteLn(&*r, r__typ);
			}
			FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"ENDCHAR", (LONGINT)8);
			FontToBDF_WriteLn(&*r, r__typ);
			l += 1;
			m += 1;
		}
		k += 1;
	}
	FontToBDF_WriteStr(&*r, r__typ, (CHAR*)"ENDFONT", (LONGINT)8);
	FontToBDF_WriteLn(&*r, r__typ);
}

void FontToBDF_Convert (void)
{
	Files_File F = NIL, f = NIL;
	Files_Rider R = {0}, r = {0};
	INTEGER i = 0, j = 0, size = 0;
	CHAR ch = 0;
	BOOLEAN screen = 0;
	CHAR filename[128], bdfname[128];
	Texts_Scanner s = {0};
	Texts_OpenScanner(&s, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&s, Texts_Scanner__typ);
	for (;;) {
		if (s.class != 1) {
			break;
		}
		__COPY(s.s, filename, 128);
		i = 0;
		j = 0;
		while (s.s[__X(i, 256)] != 0x00) {
			if (s.s[__X(i, 256)] == '/') {
				j = 0;
			} else {
				FontToBDF_fontname[__X(j, 128)] = s.s[__X(i, 256)];
				j += 1;
			}
			i += 1;
		}
		FontToBDF_fontname[__X(j, 128)] = 0x00;
		Texts_WriteString(&FontToBDF_W, Texts_Writer__typ, FontToBDF_fontname, 128);
		F = Files_Old(filename, 128);
		if (F != NIL) {
			Files_Set(&R, Files_Rider__typ, F, 0);
			Files_Read(&R, Files_Rider__typ, (void*)&ch);
			if (ch == 0xdb) {
				__COPY(FontToBDF_prefix, bdfname, 128);
				j = 0;
				while (bdfname[__X(j, 128)] != 0x00) {
					j += 1;
				}
				i = 0;
				while (FontToBDF_fontname[__X(i, 128)] != 0x00) {
					bdfname[__X(j, 128)] = FontToBDF_fontname[__X(i, 128)];
					i += 1;
					j += 1;
				}
				j -= 4;
				screen = bdfname[__X(j - 3, 128)] == 'S';
				i = 0;
				while (FontToBDF_suffix[__X(i, 32)] != 0x00) {
					bdfname[__X(j, 128)] = FontToBDF_suffix[__X(i, 32)];
					i += 1;
					j += 1;
				}
				bdfname[__X(j, 128)] = 0x00;
				i = 0;
				size = 0;
				for (;;) {
					ch = FontToBDF_fontname[__X(i, 128)];
					if (ch >= '0' && ch <= '9' || ch == 0x00) {
						break;
					}
					i += 1;
				}
				if (ch != 0x00) {
					size = (int)ch - 48;
					ch = FontToBDF_fontname[__X(i + 1, 128)];
					if (ch >= '0' && ch <= '9') {
						size = (10 * size + (int)ch) - 48;
					}
				}
				f = Files_New(bdfname, 128);
				if (f != NIL) {
					Files_Set(&r, Files_Rider__typ, f, 0);
					Texts_WriteString(&FontToBDF_W, Texts_Writer__typ, (CHAR*)" converting to ", (LONGINT)16);
					Texts_WriteString(&FontToBDF_W, Texts_Writer__typ, bdfname, 128);
					Texts_WriteLn(&FontToBDF_W, Texts_Writer__typ);
					Texts_Append(Oberon_Log, FontToBDF_W.buf);
					FontToBDF_Do(&R, Files_Rider__typ, &r, Files_Rider__typ, size, screen);
					Files_Register(f);
				}
			} else {
				Texts_WriteString(&FontToBDF_W, Texts_Writer__typ, (CHAR*)" not a font", (LONGINT)12);
				Texts_WriteLn(&FontToBDF_W, Texts_Writer__typ);
				Texts_Append(Oberon_Log, FontToBDF_W.buf);
			}
			Files_Close(F);
		} else {
			Texts_WriteString(&FontToBDF_W, Texts_Writer__typ, (CHAR*)" not found", (LONGINT)11);
			Texts_WriteLn(&FontToBDF_W, Texts_Writer__typ);
			Texts_Append(Oberon_Log, FontToBDF_W.buf);
		}
		Texts_Scan(&s, Texts_Scanner__typ);
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&FontToBDF_W, Texts_Writer__typ, 36, 1, P);
}

__TDESC(RunRec__4, 1, 0) = {__TDFLDS("RunRec__4", 4), {-4}};
__TDESC(BoxRec__3, 1, 0) = {__TDFLDS("BoxRec__3", 10), {-4}};

export void *FontToBDF__init(void)
{
	__DEFMOD;
	__IMPORT(Files);
	__IMPORT(Oberon);
	__IMPORT(Texts);
	__REGMOD(FontToBDF, EnumPtrs);
	__REGCMD("Convert", FontToBDF_Convert);
	__INITYP(RunRec__4, RunRec__4, 0);
	__INITYP(BoxRec__3, BoxRec__3, 0);
/* BEGIN */
	Texts_OpenWriter(&FontToBDF_W, Texts_Writer__typ);
	__MOVE("Oberon.", FontToBDF_prefix, 8);
	__MOVE(".bdf", FontToBDF_suffix, 5);
	FontToBDF_hex[0] = '0';
	FontToBDF_hex[1] = '8';
	FontToBDF_hex[2] = '4';
	FontToBDF_hex[3] = 'C';
	FontToBDF_hex[4] = '2';
	FontToBDF_hex[5] = 'A';
	FontToBDF_hex[6] = '6';
	FontToBDF_hex[7] = 'E';
	FontToBDF_hex[8] = '1';
	FontToBDF_hex[9] = '9';
	FontToBDF_hex[10] = '5';
	FontToBDF_hex[11] = 'D';
	FontToBDF_hex[12] = '3';
	FontToBDF_hex[13] = 'B';
	FontToBDF_hex[14] = '7';
	FontToBDF_hex[15] = 'F';
	__ENDMOD;
}
