/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Args.h"
#include "Console.h"
#include "Display.h"
#include "Files.h"
#include "Kernel.h"
#include "Unix.h"
#include "X11.h"

typedef
	struct Fonts_FontDesc *Fonts_Font;

typedef
	CHAR Fonts_Name[32];

typedef
	struct Fonts_FontDesc {
		Fonts_Name name;
		INTEGER height, minX, maxX, minY, maxY;
		Display_Font raster;
		Fonts_Font next;
	} Fonts_FontDesc;


export Fonts_Font Fonts_Default;
static Fonts_Font Fonts_First;
static INTEGER Fonts_nofFonts;
static CHAR Fonts_mapFileName[64];
export INTEGER Fonts_Unit;

export LONGINT *Fonts_FontDesc__typ;
static LONGINT *RunRec__10__typ;
static LONGINT *BoxRec__3__typ;

static void Fonts_Init (void);
export Fonts_Font Fonts_This (CHAR *name, LONGINT name__len);


typedef
	struct BoxRec__3 {
		INTEGER dx, x, y, w, h;
	} BoxRec__3;

typedef
	struct RunRec__10 {
		INTEGER beg, end;
	} RunRec__10;

static struct This__2 {
	Fonts_Font *F;
	CHAR *ch;
	struct This__2 *lnk;
} *This__2_s;

static void Convert__4 (CHAR *from, LONGINT from__len, CHAR *to, LONGINT to__len);
static void DummyCh__8 (INTEGER m);

static struct Convert__4__5 {
	Files_Rider *r;
	struct Convert__4__5 *lnk;
} *Convert__4__5_s;

static void Name__6 (CHAR *s, LONGINT s__len);

static void Name__6 (CHAR *s, LONGINT s__len)
{
	CHAR ch = 0;
	INTEGER i = 0;
	Files_Read(&*Convert__4__5_s->r, Files_Rider__typ, (void*)&ch);
	while (!(*Convert__4__5_s->r).eof && ch < '#') {
		Files_Read(&*Convert__4__5_s->r, Files_Rider__typ, (void*)&ch);
	}
	i = 0;
	while (!(*Convert__4__5_s->r).eof && ch > '#') {
		s[__X(i, s__len)] = ch;
		i += 1;
		Files_Read(&*Convert__4__5_s->r, Files_Rider__typ, (void*)&ch);
	}
	s[__X(i, s__len)] = 0x00;
}

static void Convert__4 (CHAR *from, LONGINT from__len, CHAR *to, LONGINT to__len)
{
	Files_File f = NIL;
	Files_Rider r = {0};
	CHAR src[64], dst[64];
	struct Convert__4__5 _s;
	__DUP(from, from__len, CHAR);
	_s.r = &r;
	_s.lnk = Convert__4__5_s;
	Convert__4__5_s = &_s;
	f = Files_Old(Fonts_mapFileName, 64);
	if (f != NIL) {
		Files_Set(&r, Files_Rider__typ, f, 0);
		Files_Read(&r, Files_Rider__typ, (void*)&*This__2_s->ch);
		do {
			while (!r.eof && *This__2_s->ch != '#') {
				Files_Read(&r, Files_Rider__typ, (void*)&*This__2_s->ch);
			}
			Name__6((void*)src, 64);
		} while (!(r.eof || __STRCMP(src, "fontmapfile") == 0));
		Name__6((void*)src, 64);
		Name__6((void*)dst, 64);
		while (src[0] != 0x00 && __STRCMP(src, from) != 0) {
			Name__6((void*)src, 64);
			Name__6((void*)dst, 64);
		}
		if (src[0] == 0x00) {
			__COPY(from, to, to__len);
		} else {
			__COPY(dst, to, to__len);
		}
	} else {
		__COPY(from, to, to__len);
	}
	Convert__4__5_s = _s.lnk;
	__DEL(from);
}

static void DummyCh__8 (INTEGER m)
{
	X11_Font raster = NIL;
	raster = (X11_Font)(*This__2_s->F)->raster;
	raster->metrics[__X(m, 256)].dx = 0;
	raster->metrics[__X(m, 256)].x = 0;
	raster->metrics[__X(m, 256)].y = 0;
	raster->metrics[__X(m, 256)].p.x = 0;
	raster->metrics[__X(m, 256)].p.y = 0;
	raster->metrics[__X(m, 256)].p.w = 0;
	raster->metrics[__X(m, 256)].p.h = 0;
}

Fonts_Font Fonts_This (CHAR *name, LONGINT name__len)
{
	Fonts_Font F = NIL;
	X11_Font raster = NIL;
	Files_File f = NIL;
	Files_Rider R = {0};
	LONGINT pixmap = 0, pixmapX = 0, pixmapDX = 0, pixmapW = 0, pixmapH = 0, RasterBase = 0, b = 0, n = 0, a = 0;
	INTEGER NofRuns = 0, NofBoxes = 0, k = 0, l = 0, m = 0, w = 0, h = 0;
	CHAR ch = 0;
	RunRec__10 run[16];
	BoxRec__3 box[256];
	LONGINT list = 0, count = 0;
	CHAR fileName[64];
	SYSTEM_PTR rb = NIL;
	LONGINT end = 0, adr = 0;
	struct This__2 _s;
	Fonts_Font __retval;
	__DUP(name, name__len, CHAR);
	_s.F = &F;
	_s.ch = &ch;
	_s.lnk = This__2_s;
	This__2_s = &_s;
	F = Fonts_First;
	for (;;) {
		if (F == NIL) {
			break;
		}
		if (__STRCMP(name, F->name) == 0) {
			break;
		}
		F = F->next;
	}
	if (F == NIL) {
		Convert__4(name, name__len, (void*)fileName, 64);
		f = Files_Old(fileName, 64);
		if (f != NIL) {
			Files_Set(&R, Files_Rider__typ, f, 0);
			Files_Read(&R, Files_Rider__typ, (void*)&ch);
			if (ch == 0xdb) {
				Files_Read(&R, Files_Rider__typ, (void*)&ch);
				Files_Read(&R, Files_Rider__typ, (void*)&ch);
				Files_Read(&R, Files_Rider__typ, (void*)&ch);
				__NEW(F, Fonts_FontDesc);
				Files_ReadInt(&R, Files_Rider__typ, &F->height);
				Files_ReadInt(&R, Files_Rider__typ, &F->minX);
				Files_ReadInt(&R, Files_Rider__typ, &F->maxX);
				Files_ReadInt(&R, Files_Rider__typ, &F->minY);
				Files_ReadInt(&R, Files_Rider__typ, &F->maxY);
				Files_ReadInt(&R, Files_Rider__typ, &NofRuns);
				NofBoxes = 0;
				k = 0;
				while (k != NofRuns) {
					Files_ReadInt(&R, Files_Rider__typ, &run[__X(k, 16)].beg);
					Files_ReadInt(&R, Files_Rider__typ, &run[__X(k, 16)].end);
					NofBoxes = (NofBoxes + run[__X(k, 16)].end) - run[__X(k, 16)].beg;
					k += 1;
				}
				pixmapW = 0;
				l = 0;
				while (l != NofBoxes) {
					Files_ReadInt(&R, Files_Rider__typ, &box[__X(l, 256)].dx);
					Files_ReadInt(&R, Files_Rider__typ, &box[__X(l, 256)].x);
					Files_ReadInt(&R, Files_Rider__typ, &box[__X(l, 256)].y);
					Files_ReadInt(&R, Files_Rider__typ, &box[__X(l, 256)].w);
					Files_ReadInt(&R, Files_Rider__typ, &box[__X(l, 256)].h);
					pixmapW = pixmapW + (LONGINT)__ASHR(box[__X(l, 256)].w + 7, 3);
					l += 1;
				}
				pixmapH = F->maxY - F->minY;
				__NEW(raster, X11_Bytes);
				F->raster = (Display_Font)raster;
				__SYSNEW(rb, pixmapW * pixmapH);
				RasterBase = (LONGINT)rb;
				end = RasterBase + pixmapW * pixmapH;
				pixmapX = 0;
				k = 0;
				l = 0;
				m = 0;
				while (k < NofRuns) {
					while (m < run[__X(k, 16)].beg) {
						DummyCh__8(m);
						m += 1;
					}
					while (m < run[__X(k, 16)].end) {
						raster->metrics[__X(m, 256)].dx = box[__X(l, 256)].dx;
						raster->metrics[__X(m, 256)].x = box[__X(l, 256)].x;
						raster->metrics[__X(m, 256)].y = box[__X(l, 256)].y;
						raster->metrics[__X(m, 256)].p.x = pixmapX;
						raster->metrics[__X(m, 256)].p.y = 0;
						w = box[__X(l, 256)].w;
						raster->metrics[__X(m, 256)].p.w = w;
						h = box[__X(l, 256)].h;
						raster->metrics[__X(m, 256)].p.h = h;
						pixmapDX = __ASHR(w + 7, 3);
						n = pixmapDX * (LONGINT)h;
						a = RasterBase + __ASHR(pixmapX, 3);
						b = 0;
						while (b < n) {
							Files_Read(&R, Files_Rider__typ, (void*)&ch);
							adr = (a + ((LONGINT)(h - 1) - __DIV(b, pixmapDX)) * pixmapW) + __MOD(b, pixmapDX);
							if (adr >= RasterBase && adr < end) {
								__PUT(adr, ch, CHAR);
							}
							b += 1;
						}
						l += 1;
						m += 1;
						pixmapX += __ASHL(pixmapDX, 3);
					}
					k += 1;
				}
				while (m < 256) {
					DummyCh__8(m);
					m += 1;
				}
				pixmap = X11_RasterToPixmap(RasterBase, __ASHL(pixmapW, 3), pixmapH);
				m = 0;
				while (m < 256) {
					raster->metrics[__X(m, 256)].p.pixmap = pixmap;
					m += 1;
				}
				__COPY(name, F->name, 32);
				Fonts_nofFonts += 1;
				F->next = Fonts_First;
				Fonts_First = F;
				list = X11_ListFonts(X11_display, (LONGINT)fileName, 1, &count);
				if (list != 0 && count == 1) {
					raster->xid = X11_LoadFont(X11_display, (LONGINT)fileName);
					X11_FreeFontNames(list);
				} else {
					raster->xid = 0;
				}
			}
		} else {
			F = Fonts_Default;
		}
	}
	__retval = F;
	This__2_s = _s.lnk;
	__DEL(name);
	;
	return __retval;
}

static void Fonts_Init (void)
{
	LONGINT u = 0;
	Fonts_mapFileName[0] = 0x00;
	Args_Get(Args_Pos((CHAR*)"-f", (LONGINT)3) + 1, (void*)Fonts_mapFileName, 64);
	Fonts_Default = Fonts_This((CHAR*)"Syntax10.Scn.Fnt", (LONGINT)17);
	if (Fonts_Default == NIL) {
		Console_String((CHAR*)"Fonts.Init: default font not found: Syntax10.Scn.Fnt", (LONGINT)53);
		Console_Ln();
		Unix_Exit(1);
	}
	if (__STRCMP(Fonts_mapFileName, "Big.Map") == 0) {
		Fonts_Unit = 8000;
	} else if (__STRCMP(Fonts_mapFileName, "Medium.Map") == 0) {
		Fonts_Unit = 9000;
	} else {
		Fonts_Unit = 10000;
	}
	u = Fonts_Unit;
	Args_GetInt(Args_Pos((CHAR*)"-u", (LONGINT)3) + 1, &u);
	Fonts_Unit = (int)u;
	Display_Unit = Fonts_Unit;
}

static void EnumPtrs(void (*P)(void*))
{
	P(Fonts_Default);
	P(Fonts_First);
}

__TDESC(Fonts_FontDesc, 1, 2) = {__TDFLDS("FontDesc", 52), {44, 48, -12}};
__TDESC(RunRec__10, 1, 0) = {__TDFLDS("RunRec__10", 4), {-4}};
__TDESC(BoxRec__3, 1, 0) = {__TDFLDS("BoxRec__3", 10), {-4}};

export void *Fonts__init(void)
{
	__DEFMOD;
	__IMPORT(Args);
	__IMPORT(Console);
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Kernel);
	__IMPORT(Unix);
	__IMPORT(X11);
	__REGMOD(Fonts, EnumPtrs);
	__INITYP(Fonts_FontDesc, Fonts_FontDesc, 0);
	__INITYP(RunRec__10, RunRec__10, 0);
	__INITYP(BoxRec__3, BoxRec__3, 0);
/* BEGIN */
	Fonts_First = NIL;
	Fonts_Default = NIL;
	Fonts_nofFonts = 0;
	Fonts_Init();
	__ENDMOD;
}
