/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Elems.h"
#include "Files.h"
#include "GUtils.h"
#include "PanelElems.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct FrameElems_ElemDesc *FrameElems_Elem;

typedef
	struct FrameElems_ElemDesc { /* Elems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[8];
		BOOLEAN locked;
		BOOLEAN is3D;
	} FrameElems_ElemDesc;



export LONGINT *FrameElems_ElemDesc__typ;

static void FrameElems_Draw (FrameElems_Elem e, INTEGER x, INTEGER y, INTEGER color, Display_Frame f);
export void FrameElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void FrameElems_HandleAttrMsg (FrameElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ);
static void FrameElems_HandleOverlapMsg (FrameElems_Elem e, Elems_OverlapMsg *msg, LONGINT *msg__typ);
export void FrameElems_Init (FrameElems_Elem e);
export void FrameElems_Insert (void);
export void FrameElems_New (void);


static void FrameElems_Draw (FrameElems_Elem e, INTEGER x, INTEGER y, INTEGER color, Display_Frame f)
{
	INTEGER h = 0, w = 0;
	h = GUtils_Unit(e->H, 1);
	w = GUtils_Unit(e->W, 1);
	if (!e->is3D) {
		GUtils_Frame(f, color, x, y, w, h, GUtils_Unit(1, 0), 1);
	} else {
		GUtils_Frame3(f, x, y, w, h);
	}
}

static void FrameElems_HandleAttrMsg (FrameElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ)
{
	Elems_Done = 1;
	if ((*msg).id == 1) {
		if (__STRCMP((*msg).name, "3D") == 0) {
			(*msg).class = 7;
			(*msg).b = e->is3D;
		} else if (__STRCMP((*msg).name, "!#cstate") == 0) {
			(*msg).set = 0x0c;
		} else {
			Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 2) {
		if (__STRCMP((*msg).name, "3D") == 0) {
			if ((*msg).class == 7) {
				e->is3D = (*msg).b;
			}
		} else if (__STRCMP((*msg).name, "Cmd") == 0 || __STRCMP((*msg).name, "Par") == 0) {
		} else {
			Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 3) {
		Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		(*(*msg).enum_)((CHAR*)"3D", (LONGINT)3, 7);
	} else {
		Elems_Handle((void*)e, (void*)&*msg, msg__typ);
	}
}

static void FrameElems_HandleOverlapMsg (FrameElems_Elem e, Elems_OverlapMsg *msg, LONGINT *msg__typ)
{
	INTEGER d = 0;
	if (e->is3D) {
		d = 2;
	} else {
		d = 1;
	}
	(*msg).overlaps = PanelElems_OverlapsArea((*msg).ex, (*msg).ey, (*msg).ew, (*msg).eh, (*msg).x, (*msg).y, (*msg).w, (*msg).h) && !PanelElems_InArea((*msg).ex + d, (*msg).ey + d, (*msg).ew - __ASHL(d, 1), (*msg).eh - __ASHL(d, 1), (*msg).x, (*msg).y, (*msg).w, (*msg).h);
}

void FrameElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	FrameElems_Elem copy = NIL;
	CHAR ch = 0;
	if (__ISP(e, FrameElems_ElemDesc, 3)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(2);
				FrameElems_Draw((*(FrameElems_Elem*)&e), (*msg__).X0, (*msg__).Y0, (*msg__).col, (*msg__).frame);
			}
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			TextPrinter_PrintMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(1);
				FrameElems_Draw((*(FrameElems_Elem*)&e), (*msg__).X0, (*msg__).Y0, (*msg__).col, NIL);
				GUtils_SetDevice(2);
			}
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *msg__ = (void*)msg;
			if ((*msg__).e == NIL) {
				__NEW(copy, FrameElems_ElemDesc);
				(*msg__).e = (Texts_Elem)copy;
			} else {
				copy = __GUARDP((*msg__).e, FrameElems_ElemDesc, 3);
			}
			Elems_CopyElem((void*)(*(FrameElems_Elem*)&e), (void*)copy);
			copy->is3D = (*(FrameElems_Elem*)&e)->is3D;
			(*msg__).e = (Texts_Elem)copy;
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *msg__ = (void*)msg;
			__MOVE("FrameElems", (*msg__).mod, 11);
			__MOVE("New", (*msg__).proc, 4);
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *msg__ = (void*)msg;
			Elems_Handle((void*)(*(FrameElems_Elem*)&e), (void*)&*msg__, msg__typ);
			if ((*msg__).id == 0) {
				Files_Read(&(*msg__).r, Files_Rider__typ, (void*)&ch);
				Files_ReadBool(&(*msg__).r, Files_Rider__typ, &(*(FrameElems_Elem*)&e)->is3D);
			} else if ((*msg__).id == 1) {
				Files_Write(&(*msg__).r, Files_Rider__typ, 0x00);
				Files_WriteBool(&(*msg__).r, Files_Rider__typ, (*(FrameElems_Elem*)&e)->is3D);
			}
		} else if (__IS(msg__typ, Elems_AttrMsg, 1)) {
			Elems_AttrMsg *msg__ = (void*)msg;
			FrameElems_HandleAttrMsg((*(FrameElems_Elem*)&e), &*msg__, msg__typ);
		} else if (__IS(msg__typ, Elems_OverlapMsg, 1)) {
			Elems_OverlapMsg *msg__ = (void*)msg;
			FrameElems_HandleOverlapMsg((*(FrameElems_Elem*)&e), &*msg__, msg__typ);
		} else {
			Elems_Handle((void*)(*(FrameElems_Elem*)&e), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

void FrameElems_Init (FrameElems_Elem e)
{
	Elems_Init((void*)e);
	e->handle = FrameElems_Handle;
	e->is3D = 1;
	e->H = 30 * TextFrames_Unit;
	e->W = e->H;
}

void FrameElems_New (void)
{
	FrameElems_Elem e = NIL;
	__NEW(e, FrameElems_ElemDesc);
	FrameElems_Init(e);
	Texts_new = (Texts_Elem)e;
}

void FrameElems_Insert (void)
{
	FrameElems_Elem e = NIL;
	TextFrames_InsertElemMsg m = {0};
	Texts_Scanner s = {0};
	__NEW(e, FrameElems_ElemDesc);
	FrameElems_Init(e);
	Elems_GetPar((void*)e, &s, Texts_Scanner__typ);
	if (!s.eot && __IN(s.class, 0x06)) {
		e->is3D = __CAP(s.s[0]) == 'Y';
	}
	m.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&m, TextFrames_InsertElemMsg__typ);
}

__TDESC(FrameElems_ElemDesc, 1, 5) = {__TDFLDS("ElemDesc", 44), {0, 4, 12, 32, 36, -24}};

export void *FrameElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Elems);
	__IMPORT(Files);
	__IMPORT(GUtils);
	__IMPORT(PanelElems);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(FrameElems, 0);
	__REGCMD("Insert", FrameElems_Insert);
	__REGCMD("New", FrameElems_New);
	__INITYP(FrameElems_ElemDesc, Elems_ElemDesc, 3);
/* BEGIN */
	__ENDMOD;
}
