/* Ofront 1.4 -xtspkaG */

#ifndef GraphicFrames__h
#define GraphicFrames__h

#include "SYSTEM.h"
#include "Display.h"
#include "Graphics.h"

typedef
	struct GraphicFrames_FrameDesc *GraphicFrames_Frame;

typedef
	struct GraphicFrames_CtrlMsg { /* Graphics_Msg */
		GraphicFrames_Frame f;
		INTEGER res;
	} GraphicFrames_CtrlMsg;

typedef
	struct GraphicFrames_DrawMsg { /* Graphics_Msg */
		GraphicFrames_Frame f;
		INTEGER x, y, col, mode;
	} GraphicFrames_DrawMsg;

typedef
	struct GraphicFrames_LocDesc *GraphicFrames_Location;

typedef
	struct GraphicFrames_LocDesc {
		INTEGER x, y;
		GraphicFrames_Location next;
	} GraphicFrames_LocDesc;

typedef
	struct GraphicFrames_FrameDesc { /* Display_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		Graphics_Graph graph;
		INTEGER Xg, Yg, X1, Y1, x, y, col;
		BOOLEAN marked, ticked;
		GraphicFrames_LocDesc mark;
	} GraphicFrames_FrameDesc;



import LONGINT *GraphicFrames_LocDesc__typ;
import LONGINT *GraphicFrames_FrameDesc__typ;
import LONGINT *GraphicFrames_DrawMsg__typ;
import LONGINT *GraphicFrames_CtrlMsg__typ;

import void GraphicFrames_Change (GraphicFrames_Frame F, Graphics_Msg *msg, LONGINT *msg__typ);
import void GraphicFrames_Defocus (GraphicFrames_Frame F);
import void GraphicFrames_Deselect (GraphicFrames_Frame F);
import void GraphicFrames_Draw (GraphicFrames_Frame F);
import void GraphicFrames_DrawObj (GraphicFrames_Frame F, Graphics_Object obj);
import void GraphicFrames_Erase (GraphicFrames_Frame F);
import void GraphicFrames_EraseObj (GraphicFrames_Frame F, Graphics_Object obj);
import GraphicFrames_Frame GraphicFrames_Focus (void);
import void GraphicFrames_Handle (Display_Frame G, Display_FrameMsg *M, LONGINT *M__typ);
import void GraphicFrames_Macro (CHAR *Lname, LONGINT Lname__len, CHAR *Mname, LONGINT Mname__len);
import void GraphicFrames_Open (GraphicFrames_Frame G, Graphics_Graph graph, INTEGER X, INTEGER Y, INTEGER col, BOOLEAN ticked);
import void GraphicFrames_Restore (GraphicFrames_Frame F);
import GraphicFrames_Frame GraphicFrames_Selected (void);
import GraphicFrames_Frame GraphicFrames_This (INTEGER x, INTEGER y);
import void *GraphicFrames__init(void);


#endif
