/* Ofront 1.4 -xtspkaG */

#ifndef Graphics__h
#define Graphics__h

#include "SYSTEM.h"
#include "Files.h"
#include "Fonts.h"
#include "Modules.h"
#include "Texts.h"

typedef
	struct Graphics_CaptionDesc *Graphics_Caption;

typedef
	struct Graphics_MethodDesc *Graphics_Method;

typedef
	struct Graphics_ObjectDesc {
		INTEGER x, y, w, h, col;
		BOOLEAN selected, marked;
		Graphics_Method do_;
		char _prvt0[8];
	} Graphics_ObjectDesc;

typedef
	struct Graphics_CaptionDesc { /* Graphics_ObjectDesc */
		INTEGER x, y, w, h, col;
		BOOLEAN selected, marked;
		Graphics_Method do_;
		char _prvt0[8];
		INTEGER pos, len;
	} Graphics_CaptionDesc;

typedef
	struct Graphics_Msg {
		char _prvt0[1];
	} Graphics_Msg;

typedef
	struct Graphics_ColorMsg { /* Graphics_Msg */
		INTEGER col;
	} Graphics_ColorMsg;

typedef
	struct Graphics_Context {
		LONGINT _prvt0;
		char _prvt1[100];
	} Graphics_Context;

typedef
	struct Graphics_FontMsg { /* Graphics_Msg */
		Fonts_Font fnt;
	} Graphics_FontMsg;

typedef
	struct Graphics_GraphDesc *Graphics_Graph;

typedef
	Graphics_ObjectDesc *Graphics_Object;

typedef
	struct Graphics_GraphDesc {
		LONGINT time;
		Graphics_Object sel;
		char _prvt0[4];
	} Graphics_GraphDesc;

typedef
	struct Graphics_LibraryDesc *Graphics_Library;

typedef
	CHAR Graphics_Name[16];

typedef
	struct Graphics_LibraryDesc {
		Graphics_Name name;
		LONGINT _prvt0;
		char _prvt1[4];
	} Graphics_LibraryDesc;

typedef
	struct Graphics_LineDesc *Graphics_Line;

typedef
	struct Graphics_LineDesc { /* Graphics_ObjectDesc */
		INTEGER x, y, w, h, col;
		BOOLEAN selected, marked;
		Graphics_Method do_;
		char _prvt0[8];
	} Graphics_LineDesc;

typedef
	struct Graphics_MacExtDesc *Graphics_MacExt;

typedef
	struct Graphics_MacExtDesc {
		char _prvt0[1];
	} Graphics_MacExtDesc;

typedef
	struct Graphics_MacHeadDesc *Graphics_MacHead;

typedef
	struct Graphics_MacHeadDesc {
		Graphics_Name name;
		INTEGER w, h;
		Graphics_MacExt ext;
		Graphics_Library lib;
		char _prvt0[8];
	} Graphics_MacHeadDesc;

typedef
	struct Graphics_MacroDesc *Graphics_Macro;

typedef
	struct Graphics_MacroDesc { /* Graphics_ObjectDesc */
		INTEGER x, y, w, h, col;
		BOOLEAN selected, marked;
		Graphics_Method do_;
		char _prvt0[8];
		Graphics_MacHead mac;
	} Graphics_MacroDesc;

typedef
	struct Graphics_MethodDesc {
		Graphics_Name module, allocator;
		Modules_Command new;
		void (*copy)(Graphics_Object, Graphics_Object);
		void (*draw)(Graphics_Object, Graphics_Msg*, LONGINT *), (*handle)(Graphics_Object, Graphics_Msg*, LONGINT *);
		BOOLEAN (*selectable)(Graphics_Object, INTEGER, INTEGER);
		void (*read)(Graphics_Object, Files_Rider*, LONGINT *, Graphics_Context*, LONGINT *);
		void (*write)(Graphics_Object, SHORTINT, Files_Rider*, LONGINT *, Graphics_Context*, LONGINT *);
		void (*print)(Graphics_Object, INTEGER, INTEGER);
	} Graphics_MethodDesc;

typedef
	struct Graphics_WidMsg { /* Graphics_Msg */
		INTEGER w;
	} Graphics_WidMsg;


import Graphics_Object Graphics_new;
import INTEGER Graphics_width, Graphics_res;
import Texts_Text Graphics_T;
import Graphics_Method Graphics_LineMethod, Graphics_CapMethod, Graphics_MacMethod;

import LONGINT *Graphics_ObjectDesc__typ;
import LONGINT *Graphics_Msg__typ;
import LONGINT *Graphics_WidMsg__typ;
import LONGINT *Graphics_ColorMsg__typ;
import LONGINT *Graphics_FontMsg__typ;
import LONGINT *Graphics_GraphDesc__typ;
import LONGINT *Graphics_MacHeadDesc__typ;
import LONGINT *Graphics_LibraryDesc__typ;
import LONGINT *Graphics_MacExtDesc__typ;
import LONGINT *Graphics_Context__typ;
import LONGINT *Graphics_MethodDesc__typ;
import LONGINT *Graphics_LineDesc__typ;
import LONGINT *Graphics_CaptionDesc__typ;
import LONGINT *Graphics_MacroDesc__typ;

import void Graphics_Add (Graphics_Graph G, Graphics_Object obj);
import void Graphics_Copy (Graphics_Graph Gs, Graphics_Graph Gd, INTEGER dx, INTEGER dy);
import void Graphics_Delete (Graphics_Graph G);
import void Graphics_Deselect (Graphics_Graph G);
import void Graphics_Draw (Graphics_Graph G, Graphics_Msg *M, LONGINT *M__typ);
import void Graphics_DrawMac (Graphics_MacHead mh, Graphics_Msg *M, LONGINT *M__typ);
import void Graphics_DrawSel (Graphics_Graph G, Graphics_Msg *M, LONGINT *M__typ);
import void Graphics_Enumerate (Graphics_Graph G, void (*handle)(Graphics_Object, BOOLEAN*));
import Fonts_Font Graphics_Font (Files_Rider *R, LONGINT *R__typ, Graphics_Context *C, LONGINT *C__typ);
import SHORTINT Graphics_FontNo (Files_Rider *W, LONGINT *W__typ, Graphics_Context *C, LONGINT *C__typ, Fonts_Font fnt);
import void Graphics_Handle (Graphics_Graph G, Graphics_Msg *M, LONGINT *M__typ);
import void Graphics_InsertMac (Graphics_MacHead mh, Graphics_Library L, BOOLEAN *new);
import void Graphics_Load (Graphics_Graph G, Files_Rider *R, LONGINT *R__typ);
import Graphics_MacHead Graphics_MakeMac (Graphics_Graph G, INTEGER x, INTEGER y, INTEGER w, INTEGER h, CHAR *Mname, LONGINT Mname__len);
import void Graphics_Move (Graphics_Graph G, INTEGER dx, INTEGER dy);
import Graphics_Library Graphics_NewLib (CHAR *Lname, LONGINT Lname__len);
import void Graphics_Open (Graphics_Graph G, CHAR *name, LONGINT name__len);
import void Graphics_OpenMac (Graphics_MacHead mh, Graphics_Graph G, INTEGER x, INTEGER y);
import void Graphics_Print (Graphics_Graph G, INTEGER x0, INTEGER y0);
import void Graphics_RemoveLibraries (void);
import void Graphics_SelectArea (Graphics_Graph G, INTEGER x0, INTEGER y0, INTEGER x1, INTEGER y1);
import void Graphics_SelectObj (Graphics_Graph G, Graphics_Object obj);
import void Graphics_Store (Graphics_Graph G, Files_Rider *W, LONGINT *W__typ);
import void Graphics_StoreLib (Graphics_Library L, CHAR *Fname, LONGINT Fname__len);
import Modules_Command Graphics_ThisClass (CHAR *module, LONGINT module__len, CHAR *allocator, LONGINT allocator__len);
import Graphics_Library Graphics_ThisLib (CHAR *name, LONGINT name__len, BOOLEAN replace);
import Graphics_MacHead Graphics_ThisMac (Graphics_Library L, CHAR *Mname, LONGINT Mname__len);
import Graphics_Object Graphics_ThisObj (Graphics_Graph G, INTEGER x, INTEGER y);
import void Graphics_WriteFile (Graphics_Graph G, CHAR *name, LONGINT name__len);
import void Graphics_WriteObj (Files_Rider *W, LONGINT *W__typ, SHORTINT cno, Graphics_Object obj);
import void *Graphics__init(void);


#endif
