/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Oberon.h"
#include "PopupElems.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct HandlerElems_ElemDesc *HandlerElems_Elem;

typedef
	struct HandlerElems_ElemDesc { /* PopupElems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		CHAR name[32];
		Texts_Text menu;
		BOOLEAN small;
		INTEGER n, default_;
		char _prvt2[4];
		SET options;
	} HandlerElems_ElemDesc;


static Display_Handler HandlerElems_handle[8];
static CHAR HandlerElems_hName[8][32];
static INTEGER HandlerElems_cur;
static Texts_Writer HandlerElems_w;
export Display_Handler HandlerElems_curHandle;

export LONGINT *HandlerElems_ElemDesc__typ;

export void HandlerElems_Alloc (void);
export void HandlerElems_Handle (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ);
export void HandlerElems_Insert (void);
export void HandlerElems_InsertMenu (void);
export void HandlerElems_ListHandlers (void);
export void HandlerElems_ResetHandlers (void);
export void HandlerElems_SetHandler (CHAR *name, LONGINT name__len, Display_Handler new, Display_Handler *old);
static void HandlerElems_UpdateFrames (void);
static void HandlerElems_insert (CHAR *name, LONGINT name__len, SET options);


static void HandlerElems_UpdateFrames (void)
{
	INTEGER x = 0;
	Viewers_Viewer v = NIL;
	Texts_Reader r = {0};
	Display_Frame f = NIL;
	x = 0;
	while (x < Display_Width) {
		v = Viewers_This(x, 0);
		while (v->state > 1) {
			if (v->dsc != NIL && __ISP(v->dsc, TextFrames_FrameDesc, 1)) {
				Texts_OpenReader(&r, Texts_Reader__typ, __GUARDP(v->dsc, TextFrames_FrameDesc, 1)->text, 0);
				do {
					Texts_ReadElem(&r, Texts_Reader__typ);
				} while (!(r.eot || __ISP(r.elem, HandlerElems_ElemDesc, 3)));
				if (!r.eot) {
					f = v->dsc->next;
					while (f != NIL) {
						if (__ISP(f, TextFrames_FrameDesc, 1)) {
							f->handle = HandlerElems_handle[__X(HandlerElems_cur, 8)];
						}
						f = f->next;
					}
				}
			}
			v = Viewers_Next(v);
		}
		x = x + v->W;
	}
}

void HandlerElems_SetHandler (CHAR *name, LONGINT name__len, Display_Handler new, Display_Handler *old)
{
	INTEGER i = 0;
	__DUP(name, name__len, CHAR);
	i = 0;
	while (i <= HandlerElems_cur && HandlerElems_handle[__X(i, 8)] != new) {
		i += 1;
	}
	if (i > HandlerElems_cur) {
		*old = HandlerElems_handle[__X(HandlerElems_cur, 8)];
		HandlerElems_cur += 1;
		HandlerElems_handle[__X(HandlerElems_cur, 8)] = new;
		__COPY(name, HandlerElems_hName[__X(HandlerElems_cur, 8)], 32);
	} else if (i > 0) {
		HandlerElems_cur = i;
		*old = HandlerElems_handle[__X(HandlerElems_cur - 1, 8)];
	} else {
		HandlerElems_cur = 0;
		*old = TextFrames_Handle;
	}
	HandlerElems_curHandle = HandlerElems_handle[__X(HandlerElems_cur, 8)];
	HandlerElems_UpdateFrames();
	__DEL(name);
}

void HandlerElems_ResetHandlers (void)
{
	HandlerElems_curHandle = TextFrames_Handle;
	HandlerElems_handle[0] = TextFrames_Handle;
	__MOVE("TextFrames.Handle", HandlerElems_hName[0], 18);
	HandlerElems_cur = 0;
	HandlerElems_UpdateFrames();
}

void HandlerElems_ListHandlers (void)
{
	INTEGER i = 0, _for__6 = 0;
	_for__6 = HandlerElems_cur;
	i = 0;
	while (i <= _for__6) {
		Texts_WriteString(&HandlerElems_w, Texts_Writer__typ, HandlerElems_hName[__X(i, 8)], 32);
		Texts_WriteLn(&HandlerElems_w, Texts_Writer__typ);
		i += 1;
	}
	Texts_Append(Oberon_Log, HandlerElems_w.buf);
}

void HandlerElems_Handle (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ)
{
	HandlerElems_Elem e1 = NIL;
	Display_Frame f = NIL;
	if (__IS(m__typ, Texts_CopyMsg, 1)) {
		Texts_CopyMsg *m__ = (void*)m;
		if ((*m__).e == NIL) {
			__NEW(e1, HandlerElems_ElemDesc);
			(*m__).e = (Texts_Elem)e1;
		}
		PopupElems_Handle(e, (void*)&*m__, m__typ);
	} else if (__IS(m__typ, Texts_IdentifyMsg, 1)) {
		Texts_IdentifyMsg *m__ = (void*)m;
		__MOVE("HandlerElems", (*m__).mod, 13);
		__MOVE("Alloc", (*m__).proc, 6);
	} else if (__IS(m__typ, TextFrames_DisplayMsg, 1)) {
		TextFrames_DisplayMsg *m__ = (void*)m;
		PopupElems_Handle(e, (void*)&*m__, m__typ);
		if (!(*m__).prepare) {
			f = (*m__).frame->next;
			while (f != NIL) {
				if (__ISP(f, TextFrames_FrameDesc, 1)) {
					f->handle = HandlerElems_handle[__X(HandlerElems_cur, 8)];
				}
				f = f->next;
			}
		}
	} else {
		PopupElems_Handle(e, &*m, m__typ);
	}
}

void HandlerElems_Alloc (void)
{
	HandlerElems_Elem e = NIL;
	__NEW(e, HandlerElems_ElemDesc);
	e->handle = HandlerElems_Handle;
	Texts_new = (Texts_Elem)e;
}

static void HandlerElems_insert (CHAR *name, LONGINT name__len, SET options)
{
	HandlerElems_Elem e = NIL;
	TextFrames_InsertElemMsg insertMsg = {0};
	__DUP(name, name__len, CHAR);
	__NEW(e, HandlerElems_ElemDesc);
	e->handle = HandlerElems_Handle;
	__COPY(name, e->name, 32);
	e->small = 1;
	e->options = options;
	e->menu = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_WriteString(&HandlerElems_w, Texts_Writer__typ, (CHAR*)"This is a HandlerElems.Elem", (LONGINT)28);
	Texts_Append(e->menu, HandlerElems_w.buf);
	PopupElems_MeasureMenu((void*)e);
	insertMsg.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&insertMsg, TextFrames_InsertElemMsg__typ);
	__DEL(name);
}

void HandlerElems_Insert (void)
{
	HandlerElems_insert((CHAR*)"H", (LONGINT)2, 0x0);
}

void HandlerElems_InsertMenu (void)
{
	HandlerElems_insert((CHAR*)" ", (LONGINT)2, 0x01);
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&HandlerElems_w, Texts_Writer__typ, 36, 1, P);
}

__TDESC(HandlerElems_ElemDesc, 1, 5) = {__TDFLDS("ElemDesc", 88), {0, 4, 12, 32, 68, -24}};

export void *HandlerElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Oberon);
	__IMPORT(PopupElems);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(HandlerElems, EnumPtrs);
	__REGCMD("Alloc", HandlerElems_Alloc);
	__REGCMD("Insert", HandlerElems_Insert);
	__REGCMD("InsertMenu", HandlerElems_InsertMenu);
	__REGCMD("ListHandlers", HandlerElems_ListHandlers);
	__REGCMD("ResetHandlers", HandlerElems_ResetHandlers);
	__INITYP(HandlerElems_ElemDesc, PopupElems_ElemDesc, 3);
/* BEGIN */
	HandlerElems_ResetHandlers();
	Texts_OpenWriter(&HandlerElems_w, Texts_Writer__typ);
	__ENDMOD;
}
