/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Input.h"
#include "Math.h"
#include "Oberon.h"
#include "Printer.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

struct IconElems__1 {
	LONGINT addr;
	SET image[65];
};

struct IconElems__2 { /* Display_FrameDesc */
	Display_Frame dsc, next;
	INTEGER X, Y, W, H;
	Display_Handler handle;
	SHORTINT col;
};

typedef
	struct IconElems_ElemDesc *IconElems_Elem;

typedef
	struct IconElems_ElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
	} IconElems_ElemDesc;

typedef
	struct IconElems__2 *IconElems_Frame;

typedef
	struct IconElems__1 IconElems_Icon[2];

typedef
	struct IconElems_NotifyMsg { /* TextFrames_NotifyMsg */
		Display_Frame frame;
	} IconElems_NotifyMsg;


static LONGINT IconElems_N;
static Oberon_Task IconElems_Task;
static LONGINT IconElems_State;
static IconElems_Icon IconElems_Fig[64];

export LONGINT *IconElems__1__typ;
export LONGINT *IconElems_ElemDesc__typ;
export LONGINT *IconElems__2__typ;
export LONGINT *IconElems_NotifyMsg__typ;

static void IconElems_Draw (IconElems_Icon icn, INTEGER x, INTEGER y, INTEGER color);
static void IconElems_EmptyFig (void);
static void IconElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void IconElems_HandleFrame (Display_Frame F, Display_FrameMsg *M, LONGINT *M__typ);
static void IconElems_HotSpot (INTEGER X, INTEGER Y, INTEGER W, INTEGER H, INTEGER X0, INTEGER Y0);
export void IconElems_Insert (void);
static void IconElems_LoadFig (CHAR *file, LONGINT file__len);
export void IconElems_New (void);
static void IconElems_Print (IconElems_Icon icn, INTEGER x, INTEGER y);
static void IconElems_SaveScreen (INTEGER x0, INTEGER y0, SET keys, SHORTINT col);
static void IconElems_Step (void);
export void IconElems_Stop (void);


static void IconElems_EmptyFig (void)
{
	INTEGER j = 0;
	IconElems_N = 1;
	j = 1;
	while (j <= 64) {
		IconElems_Fig[0][0].image[__X(j, 65)] = 0x0;
		IconElems_Fig[0][1].image[__X(j, 65)] = 0x0;
		j += 1;
	}
	IconElems_Fig[0][0].addr = Display_NewPattern((void*)IconElems_Fig[0][0].image, 65, 32, 64);
	IconElems_Fig[0][1].addr = Display_NewPattern((void*)IconElems_Fig[0][1].image, 65, 32, 64);
}

static struct LoadFig__13 {
	Files_Rider *R;
	struct LoadFig__13 *lnk;
} *LoadFig__13_s;

static void ReadSet__14 (SET *s);

static void ReadSet__14 (SET *s)
{
	LONGINT x = 0;
	INTEGER i = 0;
	Files_ReadNum(&*LoadFig__13_s->R, Files_Rider__typ, &x);
	*s = 0x0;
	i = 0;
	while (i < 32) {
		if (__ODD(x)) {
			*s |= __SETOF(i);
		}
		x = __ASHR(x, 1);
		i += 1;
	}
}

static void IconElems_LoadFig (CHAR *file, LONGINT file__len)
{
	Files_File F = NIL;
	Files_Rider R = {0};
	INTEGER i = 0, j = 0;
	struct LoadFig__13 _s;
	__DUP(file, file__len, CHAR);
	_s.R = &R;
	_s.lnk = LoadFig__13_s;
	LoadFig__13_s = &_s;
	F = Files_Old(file, file__len);
	if (F == NIL) {
		IconElems_EmptyFig();
		LoadFig__13_s = _s.lnk;
		__DEL(file);
		return;
	}
	Files_Set(&R, Files_Rider__typ, F, 0);
	Files_ReadNum(&R, Files_Rider__typ, &IconElems_N);
	if (IconElems_N != 753) {
		IconElems_EmptyFig();
		LoadFig__13_s = _s.lnk;
		__DEL(file);
		return;
	}
	Files_ReadNum(&R, Files_Rider__typ, &IconElems_N);
	i = 0;
	while ((LONGINT)i < IconElems_N) {
		j = 1;
		while (j <= 64) {
			ReadSet__14(&IconElems_Fig[__X(i, 64)][0].image[__X(j, 65)]);
			ReadSet__14(&IconElems_Fig[__X(i, 64)][1].image[__X(j, 65)]);
			j += 1;
		}
		IconElems_Fig[__X(i, 64)][0].addr = Display_NewPattern((void*)IconElems_Fig[__X(i, 64)][0].image, 65, 32, 64);
		IconElems_Fig[__X(i, 64)][1].addr = Display_NewPattern((void*)IconElems_Fig[__X(i, 64)][1].image, 65, 32, 64);
		i += 1;
	}
	LoadFig__13_s = _s.lnk;
	__DEL(file);
}

static void IconElems_Draw (IconElems_Icon icn, INTEGER x, INTEGER y, INTEGER color)
{
	Display_CopyPattern(color, icn[0].addr, x, y, 2);
	Display_CopyPattern(color, icn[1].addr, x + 32, y, 2);
}

static struct Print__17 {
	struct Print__17 *lnk;
} *Print__17_s;

static void PrintLine__18 (INTEGER x, INTEGER y, SET line);

static void PrintLine__18 (INTEGER x, INTEGER y, SET line)
{
	INTEGER i = 0, i0 = 0;
	i = 0;
	while (i < 32) {
		if (__IN(i, line)) {
			i0 = i;
			i += 1;
			while (i < 32 && __IN(i, line)) {
				i += 1;
			}
			Printer_ReplConst(x + i0 * 3, y, (i - i0) * 3, 3);
		}
		i += 1;
	}
}

static void IconElems_Print (IconElems_Icon icn, INTEGER x, INTEGER y)
{
	INTEGER i = 0;
	struct Print__17 _s;
	_s.lnk = Print__17_s;
	Print__17_s = &_s;
	i = 0;
	while (i < 64) {
		PrintLine__18(x, y + i * 3, icn[0].image[__X(i + 1, 65)]);
		PrintLine__18(x + 96, y + i * 3, icn[1].image[__X(i + 1, 65)]);
		i += 1;
	}
	Print__17_s = _s.lnk;
}

static struct HotSpot__5 {
	INTEGER *X, *Y, *W, *H;
	struct HotSpot__5 *lnk;
} *HotSpot__5_s;

static void Block__6 (INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER col, INTEGER mode);
static void Circle__8 (INTEGER X, INTEGER Y, INTEGER R, INTEGER col, INTEGER mode);
static void Dot4__10 (INTEGER x1, INTEGER x2, INTEGER y1, INTEGER y2, INTEGER col, INTEGER mode);

static void Block__6 (INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER col, INTEGER mode)
{
	if (x < *HotSpot__5_s->X) {
		w -= *HotSpot__5_s->X - x;
		x = *HotSpot__5_s->X;
	}
	if (x + w > *HotSpot__5_s->X + *HotSpot__5_s->W) {
		w = (*HotSpot__5_s->X + *HotSpot__5_s->W) - x;
	}
	if (w <= 0) {
		return;
	}
	if (y < *HotSpot__5_s->Y) {
		h -= *HotSpot__5_s->Y - y;
		y = *HotSpot__5_s->Y;
	}
	if (y + h > *HotSpot__5_s->Y + *HotSpot__5_s->H) {
		h = (*HotSpot__5_s->Y + *HotSpot__5_s->H) - y;
	}
	if (h <= 0) {
		return;
	}
	Display_ReplConst(col, x, y, w, h, mode);
}

static void Dot4__10 (INTEGER x1, INTEGER x2, INTEGER y1, INTEGER y2, INTEGER col, INTEGER mode)
{
	Block__6(x1 - 3, y1 - 3, 7, 7, col, mode);
	Block__6(x1 - 3, y2 - 3, 7, 7, col, mode);
	Block__6(x2 - 3, y1 - 3, 7, 7, col, mode);
	Block__6(x2 - 3, y2 - 3, 7, 7, col, mode);
}

static void Circle__8 (INTEGER X, INTEGER Y, INTEGER R, INTEGER col, INTEGER mode)
{
	INTEGER x = 0, y = 0, dx = 0, dy = 0, d = 0;
	x = R;
	y = 0;
	dx = __ASHL(x - 1, 3);
	dy = __ASHL(y, 3) + 4;
	d = 1 - __ASHL(R, 2);
	while (x > y) {
		Dot4__10((X - x) - 1, X + x, (Y - y) - 1, Y + y, col, mode);
		Dot4__10((X - y) - 1, X + y, (Y - x) - 1, Y + x, col, mode);
		d += dy;
		dy += 8;
		y += 1;
		if (d >= 0) {
			d -= dx;
			dx -= 8;
			x -= 1;
		}
	}
	if (x == y) {
		Dot4__10((X - x) - 1, X + x, (Y - y) - 1, Y + y, col, mode);
	}
}

static void IconElems_HotSpot (INTEGER X, INTEGER Y, INTEGER W, INTEGER H, INTEGER X0, INTEGER Y0)
{
	LONGINT dx = 0, dy = 0;
	INTEGER r = 0;
	struct HotSpot__5 _s;
	_s.X = &X;
	_s.Y = &Y;
	_s.W = &W;
	_s.H = &H;
	_s.lnk = HotSpot__5_s;
	HotSpot__5_s = &_s;
	if (X0 - X > (X + W) - X0) {
		dx = X0 - X;
	} else {
		dx = (X + W) - X0;
	}
	if (Y0 - Y > (Y + H) - Y0) {
		dy = Y0 - Y;
	} else {
		dy = (Y + H) - Y0;
	}
	r = (int)__ENTIER(Math_sqrt(dx * dx + dy * dy));
	while (r > 0) {
		Circle__8(X0, Y0, r, 0, 0);
		r -= 6;
	}
	HotSpot__5_s = _s.lnk;
}

static void IconElems_SaveScreen (INTEGER x0, INTEGER y0, SET keys, SHORTINT col)
{
	SET sum = 0;
	INTEGER x = 0, y = 0, w = 0, h = 0;
	Viewers_ViewerMsg msg = {0};
	LONGINT wakeUp = 0;
	Display_ReplConst(15, x0, y0, 64, 64, 2);
	sum = keys;
	do {
		Input_Mouse(&keys, &x, &y);
		sum = sum | keys;
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
	} while (!(keys == 0x0));
	Display_ReplConst(15, x0, y0, 64, 64, 2);
	if (sum != 0x07) {
		x = Oberon_UserTrack(x0);
		w = Oberon_DisplayWidth(x0);
		y = Display_Bottom;
		h = Oberon_DisplayHeight(x0);
		Oberon_RemoveMarks(x, y, w, h);
		msg.id = 2;
		Viewers_Broadcast((void*)&msg, Viewers_ViewerMsg__typ);
		IconElems_HotSpot(x, y, w, h, x0 + 32, y0 + 32);
		do {
			Display_ReplConst(0, x0, y0, 64, 64, 0);
			IconElems_State += 1;
			x0 += 10;
			if (x0 + 64 > x + w) {
				x0 = x;
				y0 += 64;
				if (y0 + 64 > y + h) {
					y0 = y;
				}
			}
			IconElems_Draw(IconElems_Fig[__X(__MOD(IconElems_State, IconElems_N), 64)], x0, y0, col);
			wakeUp = Oberon_Time() + __DIV(100 * Input_TimeUnit, 1000);
			do {
			} while (!(Oberon_Time() >= wakeUp));
		} while (!(Input_Available() > 0));
		msg.id = 0;
		Viewers_Broadcast((void*)&msg, Viewers_ViewerMsg__typ);
	}
}

static void IconElems_HandleFrame (Display_Frame F, Display_FrameMsg *M, LONGINT *M__typ)
{
	INTEGER r = 0;
	if (__ISP(F, IconElems__2, 1)) {
		if (__IS(M__typ, IconElems_NotifyMsg, 2)) {
			if (__IS(M__typ, IconElems_NotifyMsg, 2)) {
				IconElems_NotifyMsg *M__ = (void*)M;
				IconElems_Draw(IconElems_Fig[__X(__MOD(IconElems_State - 1, IconElems_N), 64)], (*(IconElems_Frame*)&F)->X, (*(IconElems_Frame*)&F)->Y, (*(IconElems_Frame*)&F)->col);
				IconElems_Draw(IconElems_Fig[__X(__MOD(IconElems_State, IconElems_N), 64)], (*(IconElems_Frame*)&F)->X, (*(IconElems_Frame*)&F)->Y, (*(IconElems_Frame*)&F)->col);
			} else __WITHCHK;
		} else if (__IS(M__typ, Oberon_InputMsg, 1)) {
			if (__IS(M__typ, Oberon_InputMsg, 1)) {
				Oberon_InputMsg *M__ = (void*)M;
				if ((*M__).id == 1) {
					Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, (*M__).X, (*M__).Y);
				}
			} else __WITHCHK;
		}
	} else __WITHCHK;
}

static void IconElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	IconElems_Elem e = NIL;
	CHAR ch = 0;
	IconElems_Frame F = NIL;
	if (__ISP(E, IconElems_ElemDesc, 2)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
				TextFrames_DisplayMsg *msg__ = (void*)msg;
				if (!(*msg__).prepare) {
					IconElems_Draw(IconElems_Fig[__X(__MOD(IconElems_State, IconElems_N), 64)], (*msg__).X0, (*msg__).Y0, (*msg__).col);
					__NEW(F, IconElems__2);
					F->handle = IconElems_HandleFrame;
					F->X = (*msg__).X0;
					F->Y = (*msg__).Y0;
					F->W = 64;
					F->H = 64;
					F->col = (*msg__).col;
					(*msg__).elemFrame = (Display_Frame)F;
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
				TextPrinter_PrintMsg *msg__ = (void*)msg;
				if ((*msg__).prepare) {
					(*(IconElems_Elem*)&E)->W = 585216;
					(*(IconElems_Elem*)&E)->H = (*(IconElems_Elem*)&E)->W;
				} else {
					IconElems_Print(IconElems_Fig[__X(__MOD(IconElems_State, IconElems_N), 64)], (*msg__).X0, (*msg__).Y0);
					(*(IconElems_Elem*)&E)->W = __ASHL(TextFrames_Unit, 6);
					(*(IconElems_Elem*)&E)->H = (*(IconElems_Elem*)&E)->W;
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			__NEW(e, IconElems_ElemDesc);
			Texts_CopyElem((void*)(*(IconElems_Elem*)&E), (void*)e);
			__GUARDR(msg, Texts_CopyMsg, 1).e = (Texts_Elem)e;
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
				TextFrames_TrackMsg *msg__ = (void*)msg;
				if (__IN(1, (*msg__).keys)) {
					IconElems_SaveScreen((*msg__).X0, (*msg__).Y0, (*msg__).keys, (*msg__).col);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
				Texts_IdentifyMsg *msg__ = (void*)msg;
				__MOVE("IconElems", (*msg__).mod, 10);
				__MOVE("New", (*msg__).proc, 4);
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			if (__IS(msg__typ, Texts_FileMsg, 1)) {
				Texts_FileMsg *msg__ = (void*)msg;
				if ((*msg__).id == 0) {
					Files_Read(&(*msg__).r, Files_Rider__typ, (void*)&ch);
				} else if ((*msg__).id == 1) {
					Files_Write(&(*msg__).r, Files_Rider__typ, 0x00);
				}
			} else __WITHCHK;
		}
	} else __WITHCHK;
}

static void IconElems_Step (void)
{
	IconElems_NotifyMsg msg = {0};
	IconElems_State += 1;
	Viewers_Broadcast((void*)&msg, IconElems_NotifyMsg__typ);
	Oberon_CurTask->time = Oberon_Time() + __DIV(100 * Input_TimeUnit, 1000);
}

void IconElems_New (void)
{
	IconElems_Elem E = NIL;
	__NEW(E, IconElems_ElemDesc);
	E->handle = IconElems_Handle;
	Texts_new = (Texts_Elem)E;
	Oberon_Install(IconElems_Task);
}

void IconElems_Insert (void)
{
	IconElems_Elem E = NIL;
	TextFrames_InsertElemMsg m = {0};
	__NEW(E, IconElems_ElemDesc);
	E->W = __ASHL(TextFrames_Unit, 6);
	E->H = E->W;
	E->handle = IconElems_Handle;
	m.e = (Texts_Elem)E;
	(*Oberon_FocusViewer->handle)((void*)Oberon_FocusViewer, (void*)&m, TextFrames_InsertElemMsg__typ);
	Oberon_Install(IconElems_Task);
}

void IconElems_Stop (void)
{
	Oberon_Remove(IconElems_Task);
}

static void EnumPtrs(void (*P)(void*))
{
	P(IconElems_Task);
}

__TDESC(IconElems__1, 1, 0) = {__TDFLDS("", 264), {-4}};
__TDESC(IconElems_ElemDesc, 1, 4) = {__TDFLDS("ElemDesc", 36), {0, 4, 12, 32, -20}};
__TDESC(IconElems__2, 1, 2) = {__TDFLDS("", 24), {0, 4, -12}};
__TDESC(IconElems_NotifyMsg, 1, 1) = {__TDFLDS("NotifyMsg", 4), {0, -8}};

export void *IconElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Input);
	__IMPORT(Math);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(IconElems, EnumPtrs);
	__REGCMD("Insert", IconElems_Insert);
	__REGCMD("New", IconElems_New);
	__REGCMD("Stop", IconElems_Stop);
	__INITYP(IconElems__1, IconElems__1, 0);
	__INITYP(IconElems_ElemDesc, Texts_ElemDesc, 2);
	__INITYP(IconElems__2, Display_FrameDesc, 1);
	__INITYP(IconElems_NotifyMsg, TextFrames_NotifyMsg, 2);
/* BEGIN */
	IconElems_LoadFig((CHAR*)"IconElems.Icon", (LONGINT)15);
	IconElems_State = 0;
	__NEW(IconElems_Task, Oberon_TaskDesc);
	IconElems_Task->safe = 0;
	IconElems_Task->time = 0;
	IconElems_Task->handle = IconElems_Step;
	Oberon_Install(IconElems_Task);
	__ENDMOD;
}
