/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "Input.h"
#include "LinkElems.h"
#include "MarkElems.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "Printer.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct IndexElems_EditFrameDesc *IndexElems_EditFrame;

typedef
	struct IndexElems_ElemDesc *IndexElems_Elem;

typedef
	struct IndexElems_EditFrameDesc { /* TextFrames_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		Texts_Text text;
		LONGINT org;
		INTEGER col, left, right, top, bot, markH, barW;
		LONGINT time;
		BOOLEAN hasCar, hasSel, showsParcs;
		TextFrames_Location carloc, selbeg, selend;
		Display_Frame focus;
		char _prvt0[4];
		IndexElems_Elem elem;
	} IndexElems_EditFrameDesc;

typedef
	struct IndexElems_ElemDesc { /* MarkElems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		LONGINT key;
		Texts_Elem back;
		Texts_Text text;
		BOOLEAN visible, empty;
		INTEGER pno;
		IndexElems_Elem next;
	} IndexElems_ElemDesc;


static LONGINT IndexElems_Height, IndexElems_Width;
static Texts_Writer IndexElems_w;
static IndexElems_Elem IndexElems_elems;
static LONGINT IndexElems_icon, IndexElems_invIcon;

export LONGINT *IndexElems_ElemDesc__typ;
export LONGINT *IndexElems_EditFrameDesc__typ;

export void IndexElems_Alloc (void);
static void IndexElems_BuildText (IndexElems_Elem e, Texts_Text t, LONGINT pos);
static INTEGER IndexElems_CharDiff (CHAR c1, CHAR c2);
static INTEGER IndexElems_CompareTexts (Texts_Text t1, Texts_Text t2);
static void IndexElems_Copy (IndexElems_Elem SE, IndexElems_Elem DE);
static Texts_Text IndexElems_CopyText (Texts_Text T);
static void IndexElems_Edit (IndexElems_Elem E, INTEGER x0, INTEGER y0, INTEGER dsr, SET keysum);
static void IndexElems_GetDsr (Display_Frame f, LONGINT pos, Fonts_Font fnt, INTEGER *dsr);
export void IndexElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void IndexElems_HandleEdit (Display_Frame F, Display_FrameMsg *M, LONGINT *M__typ);
export void IndexElems_Hide (void);
export void IndexElems_Index (void);
static void IndexElems_InitIcon (void);
export void IndexElems_Insert (void);
static TextFrames_Frame IndexElems_MarkedFrame (CHAR *name, LONGINT name__len);
static void IndexElems_OpenEditor (IndexElems_Elem E);
export void IndexElems_Show (void);
static void IndexElems_Sort (void);
export void IndexElems_Update (void);


static void IndexElems_GetDsr (Display_Frame f, LONGINT pos, Fonts_Font fnt, INTEGER *dsr)
{
	TextFrames_Parc p = NIL;
	LONGINT beg = 0;
	if (f == NIL) {
		if (fnt == NIL) {
			*dsr = 0;
		} else {
			*dsr = -fnt->minY;
		}
	} else {
		TextFrames_ParcBefore(__GUARDP(f, TextFrames_FrameDesc, 1)->text, pos, &p, &beg);
		*dsr = (int)__DIV(p->dsr, (LONGINT)TextFrames_Unit);
	}
}

static Texts_Text IndexElems_CopyText (Texts_Text T)
{
	Texts_Text t = NIL;
	Texts_Buffer buf = NIL;
	__NEW(buf, Texts_BufDesc);
	Texts_OpenBuf(buf);
	Texts_Save(T, 0, T->len, buf);
	t = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_Append(t, buf);
	return t;
}

static void IndexElems_HandleEdit (Display_Frame F, Display_FrameMsg *M, LONGINT *M__typ)
{
	IndexElems_EditFrame F1 = NIL;
	TextFrames_Handle(F, &*M, M__typ);
	if (__ISP(F, IndexElems_EditFrameDesc, 2)) {
		if (__IS(M__typ, Oberon_CopyMsg, 1)) {
			__NEW(F1, IndexElems_EditFrameDesc);
			TextFrames_Open((void*)F1, (*(IndexElems_EditFrame*)&F)->text, (*(IndexElems_EditFrame*)&F)->org);
			F1->handle = (*(IndexElems_EditFrame*)&F)->handle;
			F1->elem = (*(IndexElems_EditFrame*)&F)->elem;
			__GUARDR(M, Oberon_CopyMsg, 1).F = (Display_Frame)F1;
		}
	} else __WITHCHK;
}

static void IndexElems_OpenEditor (IndexElems_Elem E)
{
	Viewers_Viewer V = NIL;
	IndexElems_EditFrame F = NIL;
	INTEGER x = 0, y = 0;
	if (E->empty) {
		E->text = TextFrames_Text((CHAR*)"", (LONGINT)1);
	}
	Oberon_AllocateUserViewer(Oberon_Mouse.X, &x, &y);
	__NEW(F, IndexElems_EditFrameDesc);
	F->elem = E;
	TextFrames_Open((void*)F, IndexElems_CopyText(E->text), 0);
	F->handle = IndexElems_HandleEdit;
	V = (Viewers_Viewer)MenuViewers_New((void*)TextFrames_NewMenu((CHAR*)"Index Entry", (LONGINT)12, (CHAR*)"System.Close  System.Copy  System.Grow  IndexElems.Update ", (LONGINT)59), (void*)F, TextFrames_menuH, x, y);
}

static TextFrames_Frame IndexElems_MarkedFrame (CHAR *name, LONGINT name__len)
{
	Viewers_Viewer V = NIL;
	Texts_Scanner S = {0};
	V = Oberon_MarkedViewer();
	if ((V != NIL && __ISP(V, MenuViewers_ViewerDesc, 2)) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
		Texts_OpenScanner(&S, Texts_Scanner__typ, __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text, 0);
		Texts_Scan(&S, Texts_Scanner__typ);
		__COPY(S.s, name, name__len);
		return __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1);
	} else {
		return NIL;
	}
	__RETCHK;
}

static void IndexElems_Copy (IndexElems_Elem SE, IndexElems_Elem DE)
{
	Texts_CopyElem((void*)SE, (void*)DE);
	DE->key = SE->key;
	DE->visible = 1;
	DE->text = IndexElems_CopyText(SE->text);
}

static void IndexElems_Edit (IndexElems_Elem E, INTEGER x0, INTEGER y0, INTEGER dsr, SET keysum)
{
	INTEGER w = 0, h = 0, x = 0, y = 0;
	SET keys = 0;
	if (keysum == 0x02) {
		w = (int)__DIV(E->W, (LONGINT)TextFrames_Unit);
		h = (int)__DIV(E->H, (LONGINT)TextFrames_Unit);
		Oberon_RemoveMarks(x0, y0, w, h);
		Display_CopyPattern(15, IndexElems_icon, x0, y0 + dsr, 2);
		Display_CopyPattern(15, IndexElems_invIcon, x0, y0 + dsr, 2);
		do {
			Input_Mouse(&keys, &x, &y);
			keysum = keysum | keys;
			Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
		} while (!(keys == 0x0));
		Display_CopyPattern(15, IndexElems_invIcon, x0, y0 + dsr, 2);
		Display_CopyPattern(15, IndexElems_icon, x0, y0 + dsr, 2);
		if (keysum == 0x02) {
			IndexElems_OpenEditor(E);
		}
	}
}

void IndexElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	IndexElems_Elem e = NIL;
	LONGINT pos = 0;
	INTEGER w = 0, h = 0, dsr = 0;
	SET keys = 0, keysum = 0;
	if (__ISP(E, IndexElems_ElemDesc, 3)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				IndexElems_GetDsr((*msg__).frame, (*msg__).pos, (*msg__).fnt, &dsr);
				if ((*(IndexElems_Elem*)&E)->visible) {
					Display_CopyPattern(15, IndexElems_icon, (*msg__).X0, (*msg__).Y0 + dsr, 1);
				}
			} else {
				IndexElems_GetDsr((*msg__).frame, (*msg__).pos, (*msg__).fnt, &(*msg__).Y0);
				(*(IndexElems_Elem*)&E)->W = IndexElems_Width;
				if ((*(IndexElems_Elem*)&E)->visible) {
					(*(IndexElems_Elem*)&E)->H = __ASHL(TextFrames_Unit, 3);
				} else {
					(*(IndexElems_Elem*)&E)->H = 0;
				}
			}
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *msg__ = (void*)msg;
			__MOVE("IndexElems", (*msg__).mod, 11);
			__MOVE("Alloc", (*msg__).proc, 6);
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *msg__ = (void*)msg;
			if ((*msg__).e == NIL) {
				__NEW(e, IndexElems_ElemDesc);
				(*msg__).e = (Texts_Elem)e;
			} else {
				e = __GUARDP((*msg__).e, IndexElems_ElemDesc, 3);
			}
			IndexElems_Copy((*(IndexElems_Elem*)&E), e);
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *msg__ = (void*)msg;
			IndexElems_GetDsr((*msg__).frame, (*msg__).pos, (*msg__).fnt, &dsr);
			IndexElems_Edit((*(IndexElems_Elem*)&E), (*msg__).X0, (*msg__).Y0, dsr, (*msg__).keys);
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *msg__ = (void*)msg;
			if ((*msg__).id == 0) {
				Files_ReadBool(&(*msg__).r, Files_Rider__typ, &(*(IndexElems_Elem*)&E)->visible);
				Files_ReadBool(&(*msg__).r, Files_Rider__typ, &(*(IndexElems_Elem*)&E)->empty);
				(*(IndexElems_Elem*)&E)->text = TextFrames_Text((CHAR*)"", (LONGINT)1);
				Texts_Load(&(*msg__).r, Files_Rider__typ, (*(IndexElems_Elem*)&E)->text);
			} else if ((*msg__).id == 1) {
				Files_WriteBool(&(*msg__).r, Files_Rider__typ, (*(IndexElems_Elem*)&E)->visible);
				Files_WriteBool(&(*msg__).r, Files_Rider__typ, (*(IndexElems_Elem*)&E)->empty);
				Texts_Store(&(*msg__).r, Files_Rider__typ, (*(IndexElems_Elem*)&E)->text);
			}
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			TextPrinter_PrintMsg *msg__ = (void*)msg;
			if ((*msg__).prepare) {
				(*(IndexElems_Elem*)&E)->pno = (*msg__).pno;
				(*(IndexElems_Elem*)&E)->W = 0;
			}
		}
	} else __WITHCHK;
}

void IndexElems_Alloc (void)
{
	IndexElems_Elem e = NIL;
	__NEW(e, IndexElems_ElemDesc);
	e->handle = IndexElems_Handle;
	Texts_new = (Texts_Elem)e;
}

void IndexElems_Insert (void)
{
	IndexElems_Elem e = NIL;
	TextFrames_InsertElemMsg insert = {0};
	Texts_Text t = NIL;
	Texts_Buffer buf = NIL;
	LONGINT start = 0, end = 0, time = 0;
	Oberon_GetSelection(&t, &start, &end, &time);
	__NEW(e, IndexElems_ElemDesc);
	e->text = TextFrames_Text((CHAR*)"", (LONGINT)1);
	e->handle = IndexElems_Handle;
	e->visible = 1;
	e->key = Oberon_Time();
	e->H = IndexElems_Height;
	e->W = IndexElems_Width;
	if (time >= 0) {
		__NEW(buf, Texts_BufDesc);
		Texts_OpenBuf(buf);
		Texts_Save(t, start, end, buf);
		Texts_Append(e->text, buf);
	} else {
		e->empty = 1;
	}
	insert.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&insert, TextFrames_InsertElemMsg__typ);
}

void IndexElems_Hide (void)
{
	TextFrames_Frame f = NIL;
	LONGINT pos = 0;
	Texts_Reader r = {0};
	CHAR name[256];
	f = IndexElems_MarkedFrame((void*)name, 256);
	Texts_OpenReader(&r, Texts_Reader__typ, f->text, 0);
	Texts_ReadElem(&r, Texts_Reader__typ);
	while (!r.eot) {
		if (__ISP(r.elem, IndexElems_ElemDesc, 3)) {
			__GUARDP(r.elem, IndexElems_ElemDesc, 3)->visible = 0;
			pos = Texts_ElemPos(r.elem);
			r.elem->W = 0;
			TextFrames_NotifyDisplay(f->text, 0, pos, pos + 1);
		}
		Texts_ReadElem(&r, Texts_Reader__typ);
	}
}

void IndexElems_Show (void)
{
	TextFrames_Frame f = NIL;
	LONGINT pos = 0;
	Texts_Reader r = {0};
	CHAR name[256];
	f = IndexElems_MarkedFrame((void*)name, 256);
	Texts_OpenReader(&r, Texts_Reader__typ, f->text, 0);
	Texts_ReadElem(&r, Texts_Reader__typ);
	while (!r.eot) {
		if (__ISP(r.elem, IndexElems_ElemDesc, 3)) {
			__GUARDP(r.elem, IndexElems_ElemDesc, 3)->visible = 1;
			pos = Texts_ElemPos(r.elem);
			r.elem->W = IndexElems_Width;
			TextFrames_NotifyDisplay(f->text, 0, pos, pos + 1);
		}
		Texts_ReadElem(&r, Texts_Reader__typ);
	}
}

void IndexElems_Update (void)
{
	IndexElems_EditFrame f = NIL;
	Texts_Scanner s = {0};
	Texts_Text menuText = NIL, text = NIL;
	IndexElems_Elem e = NIL;
	LONGINT pos = 0;
	if (Oberon_Par->frame == Oberon_Par->vwr->dsc) {
		f = __GUARDP(Oberon_Par->frame->next, IndexElems_EditFrameDesc, 2);
		e = f->elem;
		if (f->text->len != 0) {
			e->text = IndexElems_CopyText(f->text);
			e->empty = 0;
		} else {
			e->empty = 1;
		}
		menuText = __GUARDP(Oberon_Par->frame, TextFrames_FrameDesc, 1)->text;
		Texts_OpenReader((void*)&s, Texts_Scanner__typ, menuText, menuText->len - 1);
		Texts_Read((void*)&s, Texts_Scanner__typ, &s.c);
		if (s.c == '!') {
			Texts_Delete(menuText, menuText->len - 1, menuText->len);
		}
	}
}

static INTEGER IndexElems_CharDiff (CHAR c1, CHAR c2)
{
	if (c1 == 0x84 || c1 == 0x81) {
		c1 = 'o';
	}
	if (c1 == 0x85 || c1 == 0x82) {
		c1 = 'u';
	}
	if (c1 == 0x83 || c1 == 0x80) {
		c1 = 'a';
	}
	if (c2 == 0x84 || c2 == 0x81) {
		c2 = 'o';
	}
	if (c2 == 0x85 || c2 == 0x82) {
		c2 = 'u';
	}
	if (c2 == 0x83 || c2 == 0x80) {
		c2 = 'a';
	}
	return (int)__CAP(c1) - (int)__CAP(c2);
}

static INTEGER IndexElems_CompareTexts (Texts_Text t1, Texts_Text t2)
{
	Texts_Reader r1 = {0}, r2 = {0};
	CHAR ch1 = 0, ch2 = 0;
	INTEGER diff = 0;
	Texts_OpenReader(&r1, Texts_Reader__typ, t1, 0);
	Texts_OpenReader(&r2, Texts_Reader__typ, t2, 0);
	do {
		Texts_Read(&r1, Texts_Reader__typ, &ch1);
		Texts_Read(&r2, Texts_Reader__typ, &ch2);
		diff = IndexElems_CharDiff(ch1, ch2);
	} while (!((r1.eot || r2.eot) || diff != 0));
	if (r1.eot && r2.eot) {
		return 0;
	} else if (r1.eot) {
		return -1;
	} else if (r2.eot) {
		return 1;
	} else {
		return diff;
	}
	__RETCHK;
}

static void IndexElems_Sort (void)
{
	IndexElems_Elem e = NIL, sb = NIL, s = NIL, sorted = NIL;
	sorted = IndexElems_elems;
	IndexElems_elems = IndexElems_elems->next;
	sorted->next = NIL;
	while (IndexElems_elems != NIL) {
		e = IndexElems_elems;
		IndexElems_elems = IndexElems_elems->next;
		if (IndexElems_CompareTexts(sorted->text, e->text) >= 0) {
			e->next = sorted;
			sorted = e;
		} else {
			sb = sorted;
			s = sorted->next;
			while (s != NIL && IndexElems_CompareTexts(s->text, e->text) < 0) {
				sb = s;
				s = s->next;
			}
			e->next = sb->next;
			sb->next = e;
		}
	}
	IndexElems_elems = sorted;
}

static void IndexElems_BuildText (IndexElems_Elem e, Texts_Text t, LONGINT pos)
{
	Texts_Scanner s = {0};
	e->text = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_OpenScanner(&s, Texts_Scanner__typ, t, pos + 1);
	Texts_Scan(&s, Texts_Scanner__typ);
	if (s.class == 2 || s.class == 1) {
		Texts_WriteString(&IndexElems_w, Texts_Writer__typ, s.s, 256);
		Texts_Append(e->text, IndexElems_w.buf);
	}
}

void IndexElems_Index (void)
{
	Viewers_Viewer V = NIL;
	INTEGER res = 0, X = 0, Y = 0;
	Texts_Text text = NIL;
	TextFrames_Frame f = NIL;
	Texts_Reader r = {0};
	Texts_Buffer buf = NIL;
	IndexElems_Elem e = NIL, ee = NIL;
	CHAR name[256];
	f = IndexElems_MarkedFrame((void*)name, 256);
	text = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Oberon_Call((CHAR*)"Edit.Print", (LONGINT)11, Oberon_Par, 0, &res);
	Texts_OpenReader(&r, Texts_Reader__typ, f->text, 0);
	Texts_ReadElem(&r, Texts_Reader__typ);
	while (!r.eot) {
		if (__ISP(r.elem, IndexElems_ElemDesc, 3)) {
			if (__GUARDP(r.elem, IndexElems_ElemDesc, 3)->empty) {
				IndexElems_BuildText(__GUARDP(r.elem, IndexElems_ElemDesc, 3), f->text, Texts_ElemPos(r.elem));
			}
			__GUARDP(r.elem, IndexElems_ElemDesc, 3)->next = IndexElems_elems;
			IndexElems_elems = __GUARDP(r.elem, IndexElems_ElemDesc, 3);
		}
		Texts_ReadElem(&r, Texts_Reader__typ);
	}
	IndexElems_Sort();
	e = IndexElems_elems;
	while (e != NIL) {
		__NEW(buf, Texts_BufDesc);
		Texts_OpenBuf(buf);
		Texts_Save(e->text, 0, e->text->len, buf);
		Texts_Append(text, buf);
		Texts_Write(&IndexElems_w, Texts_Writer__typ, 0x09);
		Texts_WriteInt(&IndexElems_w, Texts_Writer__typ, e->pno, 0);
		Texts_WriteElem(&IndexElems_w, Texts_Writer__typ, (void*)LinkElems_New(name, 256, e->key));
		while (e->next != NIL && IndexElems_CompareTexts(e->text, e->next->text) == 0) {
			if (e->pno != e->next->pno) {
				Texts_WriteString(&IndexElems_w, Texts_Writer__typ, (CHAR*)", ", (LONGINT)3);
				Texts_WriteInt(&IndexElems_w, Texts_Writer__typ, e->next->pno, 0);
			}
			Texts_WriteElem(&IndexElems_w, Texts_Writer__typ, (void*)LinkElems_New(name, 256, e->next->key));
			e = e->next;
		}
		Texts_WriteLn(&IndexElems_w, Texts_Writer__typ);
		Texts_Append(text, IndexElems_w.buf);
		e = e->next;
	}
	e = IndexElems_elems;
	while (e != NIL) {
		ee = e->next;
		e->next = NIL;
		e = ee;
	}
	IndexElems_elems = NIL;
	Oberon_AllocateUserViewer(0, &X, &Y);
	V = (Viewers_Viewer)MenuViewers_New((void*)TextFrames_NewMenu((CHAR*)"IndexElems.Index", (LONGINT)17, (CHAR*)"^Edit.Menu.Text", (LONGINT)16), (void*)TextFrames_NewText(text, 0), TextFrames_menuH, X, Y);
}

static void IndexElems_InitIcon (void)
{
	SET line[9];
	line[1] = 0x01f0;
	line[2] = 0x0208;
	line[3] = 0x04e4;
	line[4] = 0x0444;
	line[5] = 0x0444;
	line[6] = 0x04e4;
	line[7] = 0x0208;
	line[8] = 0x01f0;
	IndexElems_icon = Display_NewPattern((void*)line, 9, 13, 8);
	line[1] = 0x01f0;
	line[2] = 0x03f8;
	line[3] = 0x071c;
	line[4] = 0x07bc;
	line[5] = 0x07bc;
	line[6] = 0x071c;
	line[7] = 0x03f8;
	line[8] = 0x01f0;
	IndexElems_invIcon = Display_NewPattern((void*)line, 9, 13, 8);
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&IndexElems_w, Texts_Writer__typ, 36, 1, P);
	P(IndexElems_elems);
}

__TDESC(IndexElems_ElemDesc, 1, 7) = {__TDFLDS("ElemDesc", 56), {0, 4, 12, 32, 40, 44, 52, -32}};
__TDESC(IndexElems_EditFrameDesc, 1, 9) = {__TDFLDS("EditFrameDesc", 124), {0, 4, 20, 68, 88, 108, 112, 116, 120, -40}};

export void *IndexElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(Input);
	__IMPORT(LinkElems);
	__IMPORT(MarkElems);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(IndexElems, EnumPtrs);
	__REGCMD("Alloc", IndexElems_Alloc);
	__REGCMD("Hide", IndexElems_Hide);
	__REGCMD("Index", IndexElems_Index);
	__REGCMD("Insert", IndexElems_Insert);
	__REGCMD("Show", IndexElems_Show);
	__REGCMD("Update", IndexElems_Update);
	__INITYP(IndexElems_ElemDesc, MarkElems_ElemDesc, 3);
	__INITYP(IndexElems_EditFrameDesc, TextFrames_FrameDesc, 2);
/* BEGIN */
	IndexElems_Height = __ASHL(TextFrames_Unit, 3);
	IndexElems_Width = 13 * TextFrames_Unit;
	Texts_OpenWriter(&IndexElems_w, Texts_Writer__typ);
	IndexElems_InitIcon();
	__ENDMOD;
}
