/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Kernel.h"
#include "Unix.h"
#include "X11.h"

struct Input__1 {
	LONGINT ptr, matched;
};

typedef
	struct Input_MouseState {
		LONGINT buttons, x, y;
	} Input_MouseState;


export LONGINT Input_TimeUnit;
static CHAR Input_keyQueue[128];
static Input_MouseState Input_mouseQueue[128];
static INTEGER Input_kin, Input_kout, Input_msin, Input_msout, Input_maxX, Input_maxY;
static X11_Event Input_event;
static LONGINT Input_lastButtons, Input_lastX, Input_lastY;
static BOOLEAN Input_firstClick;
static struct Input__1 Input_compstatus;

export LONGINT *Input_MouseState__typ;
export LONGINT *Input__1__typ;

export INTEGER Input_Available (void);
static void Input_Init (void);
export void Input_Mouse (SET *keys, INTEGER *x, INTEGER *y);
static void Input_PollXQueue (void);
export void Input_Read (CHAR *ch);
export void Input_SetMouseLimits (INTEGER w, INTEGER h);
export LONGINT Input_Time (void);


static void Input_PollXQueue (void)
{
	LONGINT eventcount = 0, keycount = 0, xr = 0, yr = 0, xw = 0, yw = 0, i = 0, rw = 0, cw = 0;
	CHAR buffer[20];
	LONGINT keysym = 0, buttons = 0;
	CHAR Xerror[32];
	if (X11_ErrorFlag) {
		X11_ErrorFlag = 0;
		__COPY(X11_ErrorText, Xerror, 32);
		__HALT(99);
	}
	eventcount = X11_EventsQueued(X11_display, 1);
	if (eventcount > 0) {
		do {
			X11_NextEvent(X11_display, (LONGINT)&Input_event);
			switch (Input_event.type) {
				case 2: 
					X11_lastEventTime = Input_event.time;
					keycount = X11_LookupString((LONGINT)&Input_event, (LONGINT)buffer, 20, &keysym, (LONGINT)&Input_compstatus);
					i = 0;
					while (i < keycount) {
						if (__MASK(Input_kin - Input_kout, -128) != 127) {
							Input_keyQueue[__X(Input_kin, 128)] = buffer[__X(i, 20)];
							Input_kin = __MASK(Input_kin + 1, -128);
						} else {
							X11_Bell(X11_display, 0);
						}
						i += 1;
					}
					break;
				case 4: 
					X11_lastEventTime = Input_event.time;
					switch (Input_event.button) {
						case 1: 
							Input_lastButtons = (LONGINT)((SET)Input_lastButtons | (SET)256);
							X11_SetInputFocus(X11_display, X11_primary, 2, Input_event.time);
							break;
						case 2: 
							Input_lastButtons = (LONGINT)((SET)Input_lastButtons | (SET)512);
							break;
						case 3: 
							Input_lastButtons = (LONGINT)((SET)Input_lastButtons | (SET)1024);
							break;
						default: 
							break;
					}
					Input_lastX = Input_event.x;
					Input_lastY = Input_event.y;
					if (__MASK(Input_msin - Input_msout, -128) != 127) {
						Input_mouseQueue[__X(Input_msin, 128)].buttons = Input_lastButtons;
						Input_mouseQueue[__X(Input_msin, 128)].x = Input_lastX;
						Input_mouseQueue[__X(Input_msin, 128)].y = Input_lastY;
						Input_msin = __MASK(Input_msin + 1, -128);
					} else {
						X11_Bell(X11_display, 0);
					}
					if (Input_firstClick) {
						Input_firstClick = 0;
						X11_StoreName(X11_display, X11_primary, (LONGINT)X11_WinName);
					}
					break;
				case 5: 
					X11_lastEventTime = Input_event.time;
					switch (Input_event.button) {
						case 1: 
							Input_lastButtons = (LONGINT)((SET)Input_lastButtons & ~(SET)256);
							break;
						case 2: 
							Input_lastButtons = (LONGINT)((SET)Input_lastButtons & ~(SET)512);
							break;
						case 3: 
							Input_lastButtons = (LONGINT)((SET)Input_lastButtons & ~(SET)1024);
							break;
						default: 
							break;
					}
					Input_lastX = Input_event.x;
					Input_lastY = Input_event.y;
					if (__MASK(Input_msin - Input_msout, -128) != 127) {
						Input_mouseQueue[__X(Input_msin, 128)].buttons = Input_lastButtons;
						Input_mouseQueue[__X(Input_msin, 128)].x = Input_lastX;
						Input_mouseQueue[__X(Input_msin, 128)].y = Input_lastY;
						Input_msin = __MASK(Input_msin + 1, -128);
					} else {
						X11_Bell(X11_display, 0);
					}
					break;
				case 6: 
					X11_QueryPointer(X11_display, Input_event.window, &rw, &cw, &xr, &yr, &Input_lastX, &Input_lastY, &buttons);
					break;
				case 12: case 13: 
					if (__MASK(Input_kin - Input_kout, -128) != 127 && Input_keyQueue[__X(Input_kout, 128)] != 0x0c || Input_kin == Input_kout) {
						Input_keyQueue[__X(Input_kin, 128)] = 0x0c;
						Input_kin = __MASK(Input_kin + 1, -128);
					}
					break;
				case 14: 
					break;
				case 34: 
					X11_RefreshKeyboardMapping((LONGINT)&Input_event);
					break;
				case 33: 
					break;
				case 18: 
					break;
				case 19: 
					break;
				case 29: 
					if (X11_ClearSelection != NIL) {
						(*X11_ClearSelection)();
					}
					break;
				case 31: 
					if (X11_ReceiveSelection != NIL) {
						(*X11_ReceiveSelection)((X11_SelectionEvent*)&Input_event, X11_Event__typ);
					}
					break;
				case 30: 
					if (X11_SendSelection != NIL) {
						(*X11_SendSelection)((X11_SelectionRequestEvent*)&Input_event, X11_Event__typ);
					}
					break;
				default: 
					break;
			}
			eventcount -= 1;
		} while (!(eventcount == 0));
	}
	X11_DoSync();
}

INTEGER Input_Available (void)
{
	Input_PollXQueue();
	return __MASK(Input_kin - Input_kout, -128);
}

void Input_Mouse (SET *keys, INTEGER *x, INTEGER *y)
{
	SET k = 0;
	LONGINT lb = 0;
	INTEGER lx = 0, ly = 0;
	Input_PollXQueue();
	if (Input_msin == Input_msout) {
		lb = Input_lastButtons;
		lx = (int)Input_lastX;
		ly = (X11_Height - 1) - (int)Input_lastY;
	} else {
		lb = Input_mouseQueue[__X(Input_msout, 128)].buttons;
		lx = (int)Input_mouseQueue[__X(Input_msout, 128)].x;
		ly = (X11_Height - 1) - (int)Input_mouseQueue[__X(Input_msout, 128)].y;
		Input_msout = __MASK(Input_msout + 1, -128);
	}
	k = 0x0;
	if (__MASK(__ASHR(lb, 8), -2) == 1) {
		k |= __SETOF(2);
	}
	if (__MASK(__ASHR(lb, 9), -2) == 1) {
		k |= __SETOF(1);
	}
	if (__MASK(__ASHR(lb, 10), -2) == 1) {
		k |= __SETOF(0);
	}
	if (lx > Input_maxX) {
		lx = Input_maxX;
	} else if (lx < 0) {
		lx = 0;
	}
	if (ly > Input_maxY) {
		ly = Input_maxY;
	} else if (ly < 0) {
		ly = 0;
	}
	*keys = k;
	*x = lx;
	*y = ly;
}

void Input_Read (CHAR *ch)
{
	while (Input_kout == Input_kin) {
		Input_PollXQueue();
	}
	*ch = Input_keyQueue[__X(Input_kout, 128)];
	Input_kout = __MASK(Input_kout + 1, -128);
}

void Input_SetMouseLimits (INTEGER w, INTEGER h)
{
	Input_maxX = w - 1;
	Input_maxY = h - 1;
}

LONGINT Input_Time (void)
{
	return Kernel_Time();
}

static void Input_Init (void)
{
	CHAR from[8], to[8];
	X11_Modlist modlist;
	LONGINT n = 0, i = 0;
	X11_SelectInput(X11_display, X11_primary, 16941261);
	Input_kin = 0;
	Input_kout = 0;
	Input_msin = 0;
	Input_msout = 0;
	X11_QueryPointer(X11_display, X11_primary, &n, &n, &n, &n, &Input_lastX, &Input_lastY, &Input_lastButtons);
	__MOVE("Caps_Lock", modlist[0], 10);
	to[0] = 0xa4;
	X11_Rebind((CHAR*)"F1", (LONGINT)3, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"F1", (LONGINT)3, modlist, 1, to, 8, 1);
	to[0] = 0x1b;
	X11_Rebind((CHAR*)"F2", (LONGINT)3, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"F2", (LONGINT)3, modlist, 1, to, 8, 1);
	to[0] = 0x7f;
	X11_Rebind((CHAR*)"BackSpace", (LONGINT)10, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"BackSpace", (LONGINT)10, modlist, 1, to, 8, 1);
	to[0] = 0xf5;
	X11_Rebind((CHAR*)"Menu", (LONGINT)5, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"Menu", (LONGINT)5, modlist, 1, to, 8, 1);
	to[0] = 0x91;
	X11_Rebind((CHAR*)"Prior", (LONGINT)6, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"Prior", (LONGINT)6, modlist, 1, to, 8, 1);
	to[0] = 0xac;
	X11_Rebind((CHAR*)"F3", (LONGINT)3, modlist, 0, to, 8, 1);
	__MOVE("Shift_L", modlist[0], 8);
	to[0] = 0xad;
	X11_Rebind((CHAR*)"F3", (LONGINT)3, modlist, 1, to, 8, 1);
	__MOVE("Control_L", modlist[0], 10);
	to[0] = 0x93;
	X11_Rebind((CHAR*)"Prior", (LONGINT)6, modlist, 1, to, 8, 1);
	__MOVE("Caps_Lock", modlist[0], 10);
	i = 4;
	__MOVE("F4", from, 3);
	while (i < 10) {
		to[0] = (CHAR)(240 + i);
		from[1] = (CHAR)(48 + i);
		X11_Rebind(from, 8, modlist, 0, to, 8, 1);
		X11_Rebind(from, 8, modlist, 1, to, 8, 1);
		i += 1;
	}
	i = 10;
	__MOVE("F10", from, 4);
	while (i < 16) {
		to[0] = (CHAR)(240 + i);
		from[2] = (CHAR)((48 + i) - 10);
		X11_Rebind(from, 8, modlist, 0, to, 8, 1);
		X11_Rebind(from, 8, modlist, 1, to, 8, 1);
		i += 1;
	}
	to[0] = 0x0a;
	X11_Rebind((CHAR*)"Select", (LONGINT)7, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"Select", (LONGINT)7, modlist, 1, to, 8, 1);
	to[0] = 0xc1;
	X11_Rebind((CHAR*)"Up", (LONGINT)3, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"Up", (LONGINT)3, modlist, 1, to, 8, 1);
	to[0] = 0xc2;
	X11_Rebind((CHAR*)"Down", (LONGINT)5, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"Down", (LONGINT)5, modlist, 1, to, 8, 1);
	to[0] = 0xc3;
	X11_Rebind((CHAR*)"Right", (LONGINT)6, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"Right", (LONGINT)6, modlist, 1, to, 8, 1);
	to[0] = 0xc4;
	X11_Rebind((CHAR*)"Left", (LONGINT)5, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"Left", (LONGINT)5, modlist, 1, to, 8, 1);
	to[0] = 0xc5;
	X11_Rebind((CHAR*)"Page_Up", (LONGINT)8, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"Page_Up", (LONGINT)8, modlist, 1, to, 8, 1);
	to[0] = 0xc6;
	X11_Rebind((CHAR*)"Page_Down", (LONGINT)10, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"Page_Down", (LONGINT)10, modlist, 1, to, 8, 1);
	to[0] = 0xc7;
	X11_Rebind((CHAR*)"End", (LONGINT)4, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"End", (LONGINT)4, modlist, 1, to, 8, 1);
	to[0] = 0xc8;
	X11_Rebind((CHAR*)"Home", (LONGINT)5, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"Home", (LONGINT)5, modlist, 1, to, 8, 1);
	to[0] = 0xa1;
	X11_Rebind((CHAR*)"Delete", (LONGINT)7, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"Delete", (LONGINT)7, modlist, 1, to, 8, 1);
	__MOVE("Control_L", modlist[0], 10);
	to[0] = 0x80;
	X11_Rebind((CHAR*)"A", (LONGINT)2, modlist, 1, to, 8, 1);
	to[0] = 0x81;
	X11_Rebind((CHAR*)"O", (LONGINT)2, modlist, 1, to, 8, 1);
	to[0] = 0x82;
	X11_Rebind((CHAR*)"U", (LONGINT)2, modlist, 1, to, 8, 1);
	to[0] = 0x83;
	X11_Rebind((CHAR*)"a", (LONGINT)2, modlist, 1, to, 8, 1);
	to[0] = 0x91;
	X11_Rebind((CHAR*)"e", (LONGINT)2, modlist, 1, to, 8, 1);
	to[0] = 0x92;
	X11_Rebind((CHAR*)"i", (LONGINT)2, modlist, 1, to, 8, 1);
	to[0] = 0x84;
	X11_Rebind((CHAR*)"o", (LONGINT)2, modlist, 1, to, 8, 1);
	to[0] = 0x85;
	X11_Rebind((CHAR*)"u", (LONGINT)2, modlist, 1, to, 8, 1);
	to[0] = 0x93;
	X11_Rebind((CHAR*)"c", (LONGINT)2, modlist, 1, to, 8, 1);
	to[0] = 0x95;
	X11_Rebind((CHAR*)"n", (LONGINT)2, modlist, 1, to, 8, 1);
	to[0] = 0xab;
	X11_Rebind((CHAR*)"s", (LONGINT)2, modlist, 1, to, 8, 1);
	__MOVE("Shift_L", modlist[0], 8);
	to[0] = 0x94;
	X11_Rebind((CHAR*)"aacute", (LONGINT)7, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"aacute", (LONGINT)7, modlist, 1, to, 8, 1);
	to[0] = 0x8b;
	X11_Rebind((CHAR*)"agrave", (LONGINT)7, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"agrave", (LONGINT)7, modlist, 1, to, 8, 1);
	to[0] = 0x83;
	X11_Rebind((CHAR*)"adiaeresis", (LONGINT)11, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"adiaeresis", (LONGINT)11, modlist, 1, to, 8, 1);
	to[0] = 0x86;
	X11_Rebind((CHAR*)"acircumflex", (LONGINT)12, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"acircumflex", (LONGINT)12, modlist, 1, to, 8, 1);
	to[0] = 0x90;
	X11_Rebind((CHAR*)"eacute", (LONGINT)7, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"eacute", (LONGINT)7, modlist, 1, to, 8, 1);
	to[0] = 0x8c;
	X11_Rebind((CHAR*)"egrave", (LONGINT)7, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"egrave", (LONGINT)7, modlist, 1, to, 8, 1);
	to[0] = 0x91;
	X11_Rebind((CHAR*)"ediaeresis", (LONGINT)11, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"ediaeresis", (LONGINT)11, modlist, 1, to, 8, 1);
	to[0] = 0x87;
	X11_Rebind((CHAR*)"ecircumflex", (LONGINT)12, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"ecircumflex", (LONGINT)12, modlist, 1, to, 8, 1);
	to[0] = 0x8d;
	X11_Rebind((CHAR*)"igrave", (LONGINT)7, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"igrave", (LONGINT)7, modlist, 1, to, 8, 1);
	to[0] = 0x92;
	X11_Rebind((CHAR*)"idiaeresis", (LONGINT)11, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"idiaeresis", (LONGINT)11, modlist, 1, to, 8, 1);
	to[0] = 0x88;
	X11_Rebind((CHAR*)"icircumflex", (LONGINT)12, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"icircumflex", (LONGINT)12, modlist, 1, to, 8, 1);
	to[0] = 0x8e;
	X11_Rebind((CHAR*)"ograve", (LONGINT)7, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"ograve", (LONGINT)7, modlist, 1, to, 8, 1);
	to[0] = 0x84;
	X11_Rebind((CHAR*)"odiaeresis", (LONGINT)11, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"odiaeresis", (LONGINT)11, modlist, 1, to, 8, 1);
	to[0] = 0x89;
	X11_Rebind((CHAR*)"ocircumflex", (LONGINT)12, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"ocircumflex", (LONGINT)12, modlist, 1, to, 8, 1);
	to[0] = 0x8f;
	X11_Rebind((CHAR*)"ugrave", (LONGINT)7, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"ugrave", (LONGINT)7, modlist, 1, to, 8, 1);
	to[0] = 0x85;
	X11_Rebind((CHAR*)"udiaeresis", (LONGINT)11, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"udiaeresis", (LONGINT)11, modlist, 1, to, 8, 1);
	to[0] = 0x8a;
	X11_Rebind((CHAR*)"ucircumflex", (LONGINT)12, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"ucircumflex", (LONGINT)12, modlist, 1, to, 8, 1);
	to[0] = 0x93;
	X11_Rebind((CHAR*)"ccedilla", (LONGINT)9, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"ccedilla", (LONGINT)9, modlist, 1, to, 8, 1);
	to[0] = 0x95;
	X11_Rebind((CHAR*)"ntilde", (LONGINT)7, modlist, 0, to, 8, 1);
	to[0] = 0xab;
	X11_Rebind((CHAR*)"ssharp", (LONGINT)7, modlist, 0, to, 8, 1);
	to[0] = 0x80;
	X11_Rebind((CHAR*)"Adiaeresis", (LONGINT)11, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"Adiaeresis", (LONGINT)11, modlist, 1, to, 8, 1);
	to[0] = 0x81;
	X11_Rebind((CHAR*)"Odiaeresis", (LONGINT)11, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"Odiaeresis", (LONGINT)11, modlist, 1, to, 8, 1);
	to[0] = 0x82;
	X11_Rebind((CHAR*)"Udiaeresis", (LONGINT)11, modlist, 0, to, 8, 1);
	X11_Rebind((CHAR*)"Udiaeresis", (LONGINT)11, modlist, 1, to, 8, 1);
}

__TDESC(Input_MouseState, 1, 0) = {__TDFLDS("MouseState", 12), {-4}};
__TDESC(Input__1, 1, 0) = {__TDFLDS("", 8), {-4}};

export void *Input__init(void)
{
	__DEFMOD;
	__IMPORT(Kernel);
	__IMPORT(Unix);
	__IMPORT(X11);
	__REGMOD(Input, 0);
	__INITYP(Input_MouseState, Input_MouseState, 0);
	__INITYP(Input__1, Input__1, 0);
/* BEGIN */
	Input_TimeUnit = Kernel_TimeUnit;
	Input_Init();
	__ENDMOD;
}
