/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Input.h"
#include "KeplerFrames.h"
#include "KeplerGraphs.h"
#include "KeplerPorts.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct KeplerElems_ElemDesc *KeplerElems_Elem;

typedef
	struct KeplerElems_ElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		KeplerGraphs_Graph G;
		INTEGER dx, dy, w, h, grid;
	} KeplerElems_ElemDesc;

typedef
	struct KeplerElems_FrameDesc *KeplerElems_Frame;

typedef
	struct KeplerElems_FrameDesc { /* KeplerFrames_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		INTEGER x0, y0, scale;
		KeplerPorts_Port ext;
		KeplerGraphs_Graph G;
		INTEGER col, grid;
		KeplerElems_Elem E;
	} KeplerElems_FrameDesc;



export LONGINT *KeplerElems_ElemDesc__typ;
export LONGINT *KeplerElems_FrameDesc__typ;

export void KeplerElems_Alloc (void);
static KeplerGraphs_Graph KeplerElems_Copy (KeplerGraphs_Graph G);
static void KeplerElems_Draw (KeplerElems_Elem E, INTEGER X, INTEGER Y, Display_Frame *DF);
static void KeplerElems_Edit (KeplerElems_Elem E);
static void KeplerElems_ElemHandle (Texts_Elem E, Texts_ElemMsg *M, LONGINT *M__typ);
static void KeplerElems_Focus (KeplerElems_Elem E, BOOLEAN focus, KeplerFrames_Frame F);
static void KeplerElems_FrameHandle (Display_Frame F, Display_FrameMsg *M, LONGINT *M__typ);
export void KeplerElems_Insert (void);
static void KeplerElems_Load (Files_Rider *R, LONGINT *R__typ, KeplerElems_Elem E);
static void KeplerElems_Print (KeplerElems_Elem E, INTEGER X, INTEGER Y);
static void KeplerElems_Store (Files_Rider *R, LONGINT *R__typ, KeplerElems_Elem E);
export void KeplerElems_Update (void);


static void KeplerElems_Draw (KeplerElems_Elem E, INTEGER X, INTEGER Y, Display_Frame *DF)
{
	KeplerFrames_Frame F = NIL;
	F = KeplerFrames_New(E->G);
	*DF = (Display_Frame)F;
	F->X = X;
	F->Y = Y;
	F->W = (int)__DIV(E->W, (LONGINT)TextFrames_Unit);
	F->H = (int)__DIV(E->H, (LONGINT)TextFrames_Unit);
	F->x0 = -E->dx;
	F->y0 = -(__ASHL(F->H, 2) + E->dy);
	F->scale = 4;
	if (E->G->cons != NIL) {
		__KeplerGraphs_Object_Draw((void*)E->G, (void*)F);
	} else {
		__KeplerPorts_Port_DrawRect((void*)F, 0, 0, 99, 99, 15, 0);
	}
}

static void KeplerElems_Print (KeplerElems_Elem E, INTEGER X, INTEGER Y)
{
	KeplerPorts_PrinterPort P = NIL;
	__NEW(P, KeplerPorts_PrinterPortDesc);
	P->X = X;
	P->Y = Y;
	P->W = (int)__DIV(E->W, 3048);
	P->H = (int)__DIV(E->H, 3048);
	P->x0 = -E->dx;
	P->y0 = -(P->H + E->dy);
	P->scale = 1;
	__KeplerGraphs_Object_Draw((void*)E->G, (void*)P);
}

static KeplerGraphs_Graph KeplerElems_Copy (KeplerGraphs_Graph G)
{
	Files_File buf = NIL;
	Files_Rider R = {0};
	KeplerGraphs_Object o = NIL;
	buf = Files_New((CHAR*)"", (LONGINT)1);
	Files_Set(&R, Files_Rider__typ, buf, 0);
	KeplerGraphs_Reset();
	KeplerGraphs_WriteObj(&R, Files_Rider__typ, (void*)G);
	Files_Set(&R, Files_Rider__typ, buf, 0);
	KeplerGraphs_Reset();
	KeplerGraphs_ReadObj(&R, Files_Rider__typ, &o);
	return __GUARDP(o, KeplerGraphs_GraphDesc, 1);
}

static void KeplerElems_FrameHandle (Display_Frame F, Display_FrameMsg *M, LONGINT *M__typ)
{
	KeplerElems_Frame F1 = NIL;
	if (__ISP(F, KeplerElems_FrameDesc, 4)) {
		if (__IS(M__typ, Oberon_CopyMsg, 1)) {
			Oberon_CopyMsg *M__ = (void*)M;
			__NEW(F1, KeplerElems_FrameDesc);
			(*M__).F = (Display_Frame)F1;
			__GUARDEQP(F1, KeplerElems_FrameDesc) = *(*(KeplerElems_Frame*)&F);
		} else {
			KeplerFrames_Handle((void*)(*(KeplerElems_Frame*)&F), &*M, M__typ);
		}
	} else __WITHCHK;
}

static void KeplerElems_Edit (KeplerElems_Elem E)
{
	SET keysum = 0, keys = 0;
	INTEGER X = 0, Y = 0;
	KeplerElems_Frame F = NIL;
	Viewers_Viewer V = NIL;
	keysum = 0x02;
	do {
		Input_Mouse(&keys, &X, &Y);
		keysum = keysum | keys;
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, X, Y);
	} while (!(keys == 0x0));
	if (keysum == 0x02) {
		Oberon_AllocateUserViewer(Oberon_Mouse.X, &X, &Y);
		__NEW(F, KeplerElems_FrameDesc);
		F->G = KeplerElems_Copy(E->G);
		F->G->notify = KeplerFrames_NotifyDisplay;
		F->handle = KeplerElems_FrameHandle;
		F->grid = E->grid;
		F->scale = 4;
		F->x0 = 0;
		F->y0 = 0;
		F->E = E;
		V = (Viewers_Viewer)MenuViewers_New((void*)TextFrames_NewMenu((CHAR*)"KeplerElem", (LONGINT)11, (CHAR*)"System.Close  System.Copy  System.Grow  KeplerElems.Update", (LONGINT)59), (void*)F, TextFrames_menuH, X, Y);
	}
}

static void KeplerElems_Load (Files_Rider *R, LONGINT *R__typ, KeplerElems_Elem E)
{
	KeplerGraphs_Object o = NIL;
	CHAR err[24];
	INTEGER version = 0;
	KeplerGraphs_Reset();
	KeplerGraphs_ReadObj(&*R, R__typ, &o);
	E->G = __GUARDP(o, KeplerGraphs_GraphDesc, 1);
	Files_ReadInt(&*R, R__typ, &E->dx);
	Files_ReadInt(&*R, R__typ, &E->dy);
	Files_ReadInt(&*R, R__typ, &E->w);
	Files_ReadInt(&*R, R__typ, &version);
	if (version >= 0) {
		E->h = version;
	} else if (version == -1) {
		Files_ReadInt(&*R, R__typ, &E->h);
		Files_ReadInt(&*R, R__typ, &E->grid);
	} else {
		__MOVE("version not supported", err, 22);
		__HALT(99);
	}
}

static void KeplerElems_Store (Files_Rider *R, LONGINT *R__typ, KeplerElems_Elem E)
{
	KeplerGraphs_Reset();
	KeplerGraphs_WriteObj(&*R, R__typ, (void*)E->G);
	Files_WriteInt(&*R, R__typ, E->dx);
	Files_WriteInt(&*R, R__typ, E->dy);
	Files_WriteInt(&*R, R__typ, E->w);
	Files_WriteInt(&*R, R__typ, -1);
	Files_WriteInt(&*R, R__typ, E->h);
	Files_WriteInt(&*R, R__typ, E->grid);
}

static void KeplerElems_Focus (KeplerElems_Elem E, BOOLEAN focus, KeplerFrames_Frame F)
{
	if (focus) {
		F->grid = E->grid;
	} else {
		F->grid = 0;
	}
	__KeplerFrames_Frame_Restore(F, F->X, F->Y, F->W, F->H);
}

static void KeplerElems_ElemHandle (Texts_Elem E, Texts_ElemMsg *M, LONGINT *M__typ)
{
	KeplerElems_Elem e = NIL;
	if (__ISP(E, KeplerElems_ElemDesc, 2)) {
		if (__IS(M__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *M__ = (void*)M;
			if ((*M__).prepare) {
				(*(KeplerElems_Elem*)&E)->W = __ASHR((LONGINT)(*(KeplerElems_Elem*)&E)->w * (LONGINT)TextFrames_Unit, 2);
				(*(KeplerElems_Elem*)&E)->H = __ASHR((LONGINT)(*(KeplerElems_Elem*)&E)->h * (LONGINT)TextFrames_Unit, 2);
			} else {
				KeplerElems_Draw((*(KeplerElems_Elem*)&E), (*M__).X0, (*M__).Y0, &(*M__).elemFrame);
			}
		} else if (__IS(M__typ, TextPrinter_PrintMsg, 1)) {
			TextPrinter_PrintMsg *M__ = (void*)M;
			if ((*M__).prepare) {
				(*(KeplerElems_Elem*)&E)->W = (LONGINT)(*(KeplerElems_Elem*)&E)->w * 3048;
				(*(KeplerElems_Elem*)&E)->H = (LONGINT)(*(KeplerElems_Elem*)&E)->h * 3048;
			} else {
				KeplerElems_Print((*(KeplerElems_Elem*)&E), (*M__).X0, (*M__).Y0);
			}
		} else if (__IS(M__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *M__ = (void*)M;
			__MOVE("KeplerElems", (*M__).mod, 12);
			__MOVE("Alloc", (*M__).proc, 6);
		} else if (__IS(M__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *M__ = (void*)M;
			if ((*M__).id == 0) {
				KeplerElems_Load(&(*M__).r, Files_Rider__typ, (*(KeplerElems_Elem*)&E));
			} else if ((*M__).id == 1) {
				KeplerElems_Store(&(*M__).r, Files_Rider__typ, (*(KeplerElems_Elem*)&E));
			}
		} else if (__IS(M__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *M__ = (void*)M;
			__NEW(e, KeplerElems_ElemDesc);
			Texts_CopyElem((void*)(*(KeplerElems_Elem*)&E), (void*)e);
			(*M__).e = (Texts_Elem)e;
			e->dx = (*(KeplerElems_Elem*)&E)->dx;
			e->dy = (*(KeplerElems_Elem*)&E)->dy;
			e->w = (*(KeplerElems_Elem*)&E)->w;
			e->h = (*(KeplerElems_Elem*)&E)->h;
			e->grid = (*(KeplerElems_Elem*)&E)->grid;
			e->G = KeplerElems_Copy((*(KeplerElems_Elem*)&E)->G);
		} else if (__IS(M__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *M__ = (void*)M;
			if ((*M__).keys == 0x02) {
				KeplerElems_Edit((*(KeplerElems_Elem*)&E));
			}
		} else if (__IS(M__typ, TextFrames_FocusMsg, 1)) {
			TextFrames_FocusMsg *M__ = (void*)M;
			KeplerElems_Focus((*(KeplerElems_Elem*)&E), (*M__).focus, __GUARDP((*M__).elemFrame, KeplerFrames_FrameDesc, 3));
		}
	} else __WITHCHK;
}

void KeplerElems_Alloc (void)
{
	KeplerElems_Elem e = NIL;
	__NEW(e, KeplerElems_ElemDesc);
	e->handle = KeplerElems_ElemHandle;
	Texts_new = (Texts_Elem)e;
}

void KeplerElems_Insert (void)
{
	KeplerElems_Elem e = NIL;
	TextFrames_InsertElemMsg M = {0};
	__NEW(e, KeplerElems_ElemDesc);
	e->w = 100;
	e->h = 100;
	e->grid = 5;
	e->handle = KeplerElems_ElemHandle;
	__NEW(e->G, KeplerGraphs_GraphDesc);
	M.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&M, TextFrames_InsertElemMsg__typ);
}

void KeplerElems_Update (void)
{
	KeplerGraphs_Graph G = NIL;
	KeplerElems_Frame F = NIL;
	KeplerElems_Elem E = NIL;
	KeplerPorts_BalloonPort B = NIL;
	Texts_Reader R = {0};
	Texts_Text T = NIL;
	if (__ISP(Oberon_Par->vwr->dsc->next, KeplerElems_FrameDesc, 4)) {
		F = __GUARDP(Oberon_Par->vwr->dsc->next, KeplerElems_FrameDesc, 4);
		G = F->G;
		E = F->E;
		__KeplerGraphs_Graph_All(G, 0);
		__NEW(B, KeplerPorts_BalloonPortDesc);
		KeplerPorts_InitBalloon(B);
		__KeplerGraphs_Object_Draw((void*)G, (void*)B);
		E->dx = B->X;
		E->dy = B->Y;
		E->w = B->W + 4;
		E->h = B->H + 4;
		E->G = KeplerElems_Copy(G);
		E->grid = F->grid;
		T = Texts_ElemBase((void*)E);
		if (E->G->cons == NIL) {
			E->dx = 0;
			E->dy = 0;
			E->w = 100;
			E->h = 100;
		}
		if (T != NIL) {
			Texts_OpenReader(&R, Texts_Reader__typ, T, 0);
			do {
				Texts_ReadElem(&R, Texts_Reader__typ);
			} while (!(R.elem == (void *) E));
			(*T->notify)(T, 0, Texts_Pos(&R, Texts_Reader__typ) - 1, Texts_Pos(&R, Texts_Reader__typ));
		}
	}
}

__TDESC(KeplerElems_ElemDesc, 1, 5) = {__TDFLDS("ElemDesc", 52), {0, 4, 12, 32, 36, -24}};
__TDESC(KeplerElems_FrameDesc, 21, 5) = {__TDFLDS("FrameDesc", 44), {0, 4, 28, 32, 40, -24}};

export void *KeplerElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Input);
	__IMPORT(KeplerFrames);
	__IMPORT(KeplerGraphs);
	__IMPORT(KeplerPorts);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(KeplerElems, 0);
	__REGCMD("Alloc", KeplerElems_Alloc);
	__REGCMD("Insert", KeplerElems_Insert);
	__REGCMD("Update", KeplerElems_Update);
	__INITYP(KeplerElems_ElemDesc, Texts_ElemDesc, 2);
	__INITYP(KeplerElems_FrameDesc, KeplerFrames_FrameDesc, 4);
/* BEGIN */
	__ENDMOD;
}
