/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "Input.h"
#include "KeplerGraphs.h"
#include "KeplerPorts.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct KeplerFrames_ButtonDesc *KeplerFrames_Button;

typedef
	struct KeplerFrames_ButtonDesc { /* KeplerGraphs_ConsDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
		CHAR cmd[32], par[32];
	} KeplerFrames_ButtonDesc;

export void KeplerFrames_Button_Execute (KeplerFrames_Button B, SET keys);
typedef
	struct KeplerFrames_FrameDesc *KeplerFrames_Frame;

export void KeplerFrames_Button_HandleMouse (KeplerFrames_Button B, KeplerFrames_Frame F, INTEGER x, INTEGER y, SET keys);
export void KeplerFrames_Button_Read (KeplerFrames_Button B, Files_Rider *R, LONGINT *R__typ);
export void KeplerFrames_Button_Write (KeplerFrames_Button B, Files_Rider *R, LONGINT *R__typ);
#define __KeplerFrames_Button_Execute(B, keys) __SEND(__TYPEOF(B), 4, void(*)(KeplerFrames_Button, SET), (B, keys))
#define __KeplerFrames_Button_HandleMouse(B, F, x, y, keys) __SEND(__TYPEOF(B), 5, void(*)(KeplerFrames_Button, KeplerFrames_Frame, INTEGER, INTEGER, SET), (B, F, x, y, keys))

typedef
	struct KeplerFrames_CaptionDesc *KeplerFrames_Caption;

typedef
	struct KeplerFrames_CaptionDesc { /* KeplerGraphs_ConsDesc */
		INTEGER nofpts;
		KeplerGraphs_Star p[4];
		KeplerGraphs_Constellation next;
		CHAR s[128];
		Fonts_Font fnt;
		SHORTINT align;
	} KeplerFrames_CaptionDesc;

export void KeplerFrames_Caption_Draw (KeplerFrames_Caption C, KeplerPorts_Port F);
export void KeplerFrames_Caption_Read (KeplerFrames_Caption C, Files_Rider *R, LONGINT *R__typ);
export void KeplerFrames_Caption_Write (KeplerFrames_Caption C, Files_Rider *R, LONGINT *R__typ);

typedef
	struct KeplerFrames_FocusPointDesc *KeplerFrames_FocusPoint;

typedef
	struct KeplerFrames_FocusPointDesc {
		KeplerFrames_FocusPoint next;
		KeplerGraphs_Star p;
	} KeplerFrames_FocusPointDesc;

typedef
	struct KeplerFrames_FrameDesc { /* KeplerPorts_DisplayPortDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		INTEGER x0, y0, scale;
		KeplerPorts_Port ext;
		KeplerGraphs_Graph G;
		INTEGER col, grid;
	} KeplerFrames_FrameDesc;

export void KeplerFrames_Frame_Consume (KeplerFrames_Frame F, CHAR ch);
export void KeplerFrames_Frame_EditFrame (KeplerFrames_Frame F, INTEGER x, INTEGER y, SET keys);
export void KeplerFrames_Frame_Extend (KeplerFrames_Frame F, INTEGER newY);
export void KeplerFrames_Frame_Invert (KeplerFrames_Frame F, KeplerGraphs_Star p);
export void KeplerFrames_Frame_Neutralize (KeplerFrames_Frame F);
export void KeplerFrames_Frame_Reduce (KeplerFrames_Frame F, INTEGER newY);
export void KeplerFrames_Frame_Restore (KeplerFrames_Frame F, INTEGER X, INTEGER Y, INTEGER W, INTEGER H);
export void KeplerFrames_Frame_TrackMouse (KeplerFrames_Frame F, INTEGER x, INTEGER y, SET keys);
#define __KeplerFrames_Frame_Consume(F, ch) __SEND(__TYPEOF(F), 12, void(*)(KeplerFrames_Frame, CHAR), (F, ch))
#define __KeplerFrames_Frame_EditFrame(F, x, y, keys) __SEND(__TYPEOF(F), 13, void(*)(KeplerFrames_Frame, INTEGER, INTEGER, SET), (F, x, y, keys))
#define __KeplerFrames_Frame_Extend(F, newY) __SEND(__TYPEOF(F), 14, void(*)(KeplerFrames_Frame, INTEGER), (F, newY))
#define __KeplerFrames_Frame_Invert(F, p) __SEND(__TYPEOF(F), 15, void(*)(KeplerFrames_Frame, KeplerGraphs_Star), (F, p))
#define __KeplerFrames_Frame_Neutralize(F) __SEND(__TYPEOF(F), 16, void(*)(KeplerFrames_Frame), (F))
#define __KeplerFrames_Frame_Reduce(F, newY) __SEND(__TYPEOF(F), 17, void(*)(KeplerFrames_Frame, INTEGER), (F, newY))
#define __KeplerFrames_Frame_Restore(F, X, Y, W, H) __SEND(__TYPEOF(F), 18, void(*)(KeplerFrames_Frame, INTEGER, INTEGER, INTEGER, INTEGER), (F, X, Y, W, H))
#define __KeplerFrames_Frame_TrackMouse(F, x, y, keys) __SEND(__TYPEOF(F), 19, void(*)(KeplerFrames_Frame, INTEGER, INTEGER, SET), (F, x, y, keys))

typedef
	void (*KeplerFrames_Notifier)(INTEGER, KeplerGraphs_Graph, KeplerGraphs_Object, KeplerPorts_Port);

typedef
	struct KeplerFrames_SelMsg { /* Display_FrameMsg */
		LONGINT time;
		KeplerGraphs_Graph G;
	} KeplerFrames_SelMsg;

typedef
	struct KeplerFrames_UpdateMsg { /* Display_FrameMsg */
		INTEGER id;
		KeplerGraphs_Graph G;
		KeplerGraphs_Object O;
		KeplerPorts_Port P;
	} KeplerFrames_UpdateMsg;


export KeplerGraphs_Graph KeplerFrames_Focus;
export KeplerFrames_FocusPoint KeplerFrames_first, KeplerFrames_last;
export INTEGER KeplerFrames_nofpts;
export KeplerFrames_Caption KeplerFrames_focus;
export INTEGER KeplerFrames_carpos;
static KeplerFrames_Frame KeplerFrames_upd;

export LONGINT *KeplerFrames_FocusPointDesc__typ;
export LONGINT *KeplerFrames_ButtonDesc__typ;
export LONGINT *KeplerFrames_CaptionDesc__typ;
export LONGINT *KeplerFrames_FrameDesc__typ;
export LONGINT *KeplerFrames_UpdateMsg__typ;
export LONGINT *KeplerFrames_SelMsg__typ;

export void KeplerFrames_AlignToGrid (KeplerFrames_Frame F, INTEGER *X, INTEGER *Y);
export void KeplerFrames_AppendFocusPoint (KeplerGraphs_Star p);
static INTEGER KeplerFrames_CarPos (CHAR *s, LONGINT s__len, Fonts_Font fnt, INTEGER carpos);
export void KeplerFrames_ConsumePoint (KeplerGraphs_Star *p);
static void KeplerFrames_CopyOver (Texts_Text T, LONGINT beg, LONGINT end);
static void KeplerFrames_DeFocus (void);
static void KeplerFrames_Defocus (void);
export void KeplerFrames_DeleteFocusPoint (KeplerFrames_Frame F);
static void KeplerFrames_Drag (KeplerFrames_Frame F, KeplerGraphs_Star p);
static void KeplerFrames_DrawFrame (KeplerFrames_Frame F, INTEGER x1, INTEGER y1, INTEGER x2, INTEGER y2);
static void KeplerFrames_DrawGrid (KeplerFrames_Frame F);
static void KeplerFrames_FlipCaret (KeplerPorts_Port p, INTEGER x, INTEGER y, INTEGER h);
export void KeplerFrames_GetMouse (KeplerFrames_Frame F, INTEGER *x, INTEGER *y, SET *keys);
export void KeplerFrames_GetPoint (KeplerGraphs_Star *p);
export void KeplerFrames_GetSelection (KeplerGraphs_Graph *sel);
export void KeplerFrames_Handle (Display_Frame F, Display_FrameMsg *M, LONGINT *M__typ);
static BOOLEAN KeplerFrames_Intersect (KeplerFrames_Frame F, INTEGER *X, INTEGER *Y, INTEGER *W, INTEGER *H);
static void KeplerFrames_InvFocus (KeplerFrames_Frame F);
export BOOLEAN KeplerFrames_IsFocusPoint (KeplerGraphs_Star p);
export KeplerFrames_Button KeplerFrames_MarkedButton (void);
static INTEGER KeplerFrames_Max (INTEGER x, INTEGER y);
static INTEGER KeplerFrames_Min (INTEGER x, INTEGER y);
static void KeplerFrames_Modify (Display_Frame F, INTEGER id, INTEGER dY, INTEGER Y, INTEGER H);
static void KeplerFrames_Move (KeplerFrames_Frame F, INTEGER x1, INTEGER y1);
export void KeplerFrames_MoveOrigin (KeplerFrames_Frame F, INTEGER x0, INTEGER y0);
export KeplerFrames_Frame KeplerFrames_New (KeplerGraphs_Graph G);
static void KeplerFrames_NewCaption (CHAR *s, LONGINT s__len, Fonts_Font fnt, INTEGER align, INTEGER carp);
export void KeplerFrames_NotifyDisplay (INTEGER op, KeplerGraphs_Graph G, KeplerGraphs_Object O, KeplerPorts_Port P);
export void KeplerFrames_Open (KeplerFrames_Frame F, KeplerGraphs_Graph G, INTEGER grid, INTEGER scale, KeplerGraphs_Notifier notify, Display_Handler handle);
static void KeplerFrames_PassFocus (KeplerGraphs_Graph G);
static void KeplerFrames_Point (KeplerFrames_Frame F, INTEGER x, INTEGER y, SET keys);
static void KeplerFrames_Select (KeplerFrames_Frame F, INTEGER x, INTEGER y);
static void KeplerFrames_SelectObjects (KeplerGraphs_Graph G, INTEGER x, INTEGER y);
static void KeplerFrames_SelectPoints (KeplerGraphs_Graph G, INTEGER x0, INTEGER y0, INTEGER x1, INTEGER y1);
static void KeplerFrames_SetCaret (KeplerFrames_Frame F, KeplerFrames_Caption c, INTEGER x);
static Texts_Text KeplerFrames_TextSelection (KeplerGraphs_Graph G);
export KeplerFrames_Button KeplerFrames_ThisButton (KeplerGraphs_Graph G, INTEGER x, INTEGER y);
export KeplerFrames_Caption KeplerFrames_ThisCaption (KeplerGraphs_Graph G, INTEGER x, INTEGER y);
static KeplerGraphs_Star KeplerFrames_ThisPoint (KeplerGraphs_Graph G, INTEGER x, INTEGER y);


static INTEGER KeplerFrames_Min (INTEGER x, INTEGER y)
{
	if (x < y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static INTEGER KeplerFrames_Max (INTEGER x, INTEGER y)
{
	if (x > y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

void KeplerFrames_NotifyDisplay (INTEGER op, KeplerGraphs_Graph G, KeplerGraphs_Object O, KeplerPorts_Port P)
{
	KeplerFrames_UpdateMsg M = {0};
	M.id = op;
	M.G = G;
	M.O = O;
	M.P = P;
	Viewers_Broadcast((void*)&M, KeplerFrames_UpdateMsg__typ);
}

void KeplerFrames_AppendFocusPoint (KeplerGraphs_Star p)
{
	KeplerFrames_FocusPoint fp = NIL;
	__NEW(fp, KeplerFrames_FocusPointDesc);
	fp->p = p;
	fp->next = NIL;
	if (KeplerFrames_last == NIL) {
		KeplerFrames_first = fp;
	} else {
		KeplerFrames_last->next = fp;
	}
	KeplerFrames_last = fp;
	KeplerFrames_nofpts += 1;
	KeplerFrames_NotifyDisplay(2, KeplerFrames_Focus, (void*)p, NIL);
}

void KeplerFrames_DeleteFocusPoint (KeplerFrames_Frame F)
{
	KeplerFrames_FocusPoint p = NIL;
	if (KeplerFrames_last != NIL) {
		KeplerFrames_NotifyDisplay(2, KeplerFrames_Focus, (void*)KeplerFrames_last->p, NIL);
		if (KeplerFrames_nofpts == 1) {
			KeplerFrames_first = NIL;
			KeplerFrames_last = NIL;
			KeplerFrames_nofpts = 0;
		} else if (KeplerFrames_nofpts > 1) {
			p = KeplerFrames_first;
			while (p->next != KeplerFrames_last) {
				p = p->next;
			}
			p->next = NIL;
			KeplerFrames_nofpts -= 1;
			KeplerFrames_last = p;
		}
	}
}

BOOLEAN KeplerFrames_IsFocusPoint (KeplerGraphs_Star p)
{
	KeplerFrames_FocusPoint fp = NIL;
	fp = KeplerFrames_first;
	while (fp != NIL && fp->p != p) {
		fp = fp->next;
	}
	return fp != NIL;
}

KeplerFrames_Button KeplerFrames_ThisButton (KeplerGraphs_Graph G, INTEGER x, INTEGER y)
{
	KeplerFrames_Button b = NIL;
	KeplerGraphs_Constellation c = NIL;
	KeplerGraphs_Star p0 = NIL, p1 = NIL;
	c = G->cons;
	b = NIL;
	while (c != NIL) {
		if (__ISP(c, KeplerFrames_ButtonDesc, 2)) {
			p0 = c->p[0];
			p1 = c->p[1];
			if (x > p0->x == x < p1->x && y > p0->y == y < p1->y) {
				b = __GUARDP(c, KeplerFrames_ButtonDesc, 2);
			}
		}
		c = c->next;
	}
	return b;
}

KeplerFrames_Button KeplerFrames_MarkedButton (void)
{
	Viewers_Viewer V = NIL;
	KeplerFrames_Frame F = NIL;
	V = Oberon_MarkedViewer();
	if ((V->dsc != NIL && V->dsc->next != NIL) && __ISP(V->dsc->next, KeplerFrames_FrameDesc, 3)) {
		F = __GUARDP(V->dsc->next, KeplerFrames_FrameDesc, 3);
		return KeplerFrames_ThisButton(F->G, __KeplerPorts_Port_Cx((void*)F, Oberon_Pointer.X), __KeplerPorts_Port_Cy((void*)F, Oberon_Pointer.Y));
	} else {
		return NIL;
	}
	__RETCHK;
}

static KeplerGraphs_Star KeplerFrames_ThisPoint (KeplerGraphs_Graph G, INTEGER x, INTEGER y)
{
	KeplerFrames_FocusPoint fp = NIL;
	KeplerGraphs_Star p = NIL;
	fp = KeplerFrames_first;
	while (fp != NIL && (__ABS(fp->p->x - x) > 16 || __ABS(fp->p->y - y) > 16)) {
		fp = fp->next;
	}
	if (((fp == NIL || fp->p->refcnt == 0) || __ISP(fp->p, KeplerGraphs_PlanetDesc, 2)) || G != KeplerFrames_Focus) {
		p = G->stars;
		while (p != NIL && (__ABS(p->x - x) > 16 || __ABS(p->y - y) > 16)) {
			p = p->next;
		}
	} else {
		p = fp->p;
	}
	return p;
}

KeplerFrames_Caption KeplerFrames_ThisCaption (KeplerGraphs_Graph G, INTEGER x, INTEGER y)
{
	KeplerFrames_Caption s = NIL;
	KeplerGraphs_Constellation c = NIL;
	KeplerPorts_BalloonPort p = NIL;
	if (KeplerFrames_ThisPoint(G, x, y) != NIL) {
		return NIL;
	}
	c = G->cons;
	s = NIL;
	__NEW(p, KeplerPorts_BalloonPortDesc);
	while (c != NIL) {
		if (__ISP(c, KeplerFrames_CaptionDesc, 2)) {
			KeplerPorts_InitBalloon(p);
			__KeplerGraphs_Object_Draw((void*)c, (void*)p);
			if (((x > p->X && x <= p->X + p->W) && y > p->Y) && y < p->Y + p->H) {
				s = __GUARDP(c, KeplerFrames_CaptionDesc, 2);
			}
		}
		c = c->next;
	}
	return s;
}

void KeplerFrames_GetPoint (KeplerGraphs_Star *p)
{
	KeplerFrames_FocusPoint fp = NIL;
	fp = KeplerFrames_first;
	*p = fp->p;
	KeplerFrames_first = fp->next;
	if (KeplerFrames_first == NIL) {
		KeplerFrames_last = NIL;
	}
	KeplerFrames_NotifyDisplay(2, KeplerFrames_Focus, (void*)*p, NIL);
	KeplerFrames_nofpts -= 1;
}

void KeplerFrames_ConsumePoint (KeplerGraphs_Star *p)
{
	KeplerFrames_GetPoint(&*p);
	if ((*p)->refcnt == 0 && !__ISP(*p, KeplerGraphs_PlanetDesc, 2)) {
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)*p);
	}
	(*p)->refcnt += 1;
}

static void KeplerFrames_SelectObjects (KeplerGraphs_Graph G, INTEGER x, INTEGER y)
{
	KeplerGraphs_Constellation c = NIL;
	KeplerPorts_BalloonPort B = NIL;
	INTEGER i = 0, _for__49 = 0;
	c = G->cons;
	__NEW(B, KeplerPorts_BalloonPortDesc);
	while (c != NIL) {
		KeplerPorts_InitBalloon(B);
		__KeplerGraphs_Object_Draw((void*)c, (void*)B);
		if (((B->X <= x && B->X + B->W >= x) && B->Y <= y) && B->Y + B->H >= y) {
			_for__49 = c->nofpts - 1;
			i = 0;
			while (i <= _for__49) {
				if (!c->p[__X(i, 4)]->sel) {
					__KeplerGraphs_Graph_FlipSelection(G, c->p[__X(i, 4)]);
				}
				i += 1;
			}
		}
		c = c->next;
	}
}

static void KeplerFrames_SelectPoints (KeplerGraphs_Graph G, INTEGER x0, INTEGER y0, INTEGER x1, INTEGER y1)
{
	KeplerGraphs_Star p = NIL;
	p = G->stars;
	if (x0 == x1 && y0 == y1) {
		while (p != NIL) {
			if (((p->x >= x0 - 12 && p->x <= x0 + 12) && p->y >= y0 - 12) && p->y <= y0 + 12) {
				__KeplerGraphs_Graph_FlipSelection(G, p);
				return;
			}
			p = p->next;
		}
		KeplerFrames_SelectObjects(G, x0, y0);
	} else {
		while (p != NIL) {
			if (!p->sel) {
				if (((p->x >= x0 && p->x <= x1) && p->y >= y0) && p->y <= y1) {
					__KeplerGraphs_Graph_FlipSelection(G, p);
				}
			}
			p = p->next;
		}
	}
}

void KeplerFrames_AlignToGrid (KeplerFrames_Frame F, INTEGER *X, INTEGER *Y)
{
	INTEGER dX = 0, dY = 0;
	if (F->grid > 0) {
		dX = (*X - __KeplerPorts_Port_CX((void*)F, 0)) + __ASHR(F->grid, 1);
		dY = (*Y - __KeplerPorts_Port_CY((void*)F, 0)) + __ASHR(F->grid, 1);
		*X = (__KeplerPorts_Port_CX((void*)F, 0) + dX) - (int)__MOD(dX, F->grid);
		*Y = (__KeplerPorts_Port_CY((void*)F, 0) + dY) - (int)__MOD(dY, F->grid);
	}
}

void KeplerFrames_GetMouse (KeplerFrames_Frame F, INTEGER *x, INTEGER *y, SET *keys)
{
	INTEGER X = 0, Y = 0;
	Input_Mouse(&*keys, &X, &Y);
	KeplerFrames_AlignToGrid(F, &X, &Y);
	*x = __KeplerPorts_Port_Cx((void*)F, X);
	*y = __KeplerPorts_Port_Cy((void*)F, Y);
}

static void KeplerFrames_DrawGrid (KeplerFrames_Frame F)
{
	INTEGER grid = 0, i = 0, j = 0;
	if (F->grid < 20) {
		grid = (__DIV(19, F->grid) + 1) * F->grid;
	} else {
		grid = F->grid;
	}
	i = F->X + (int)__MOD(__DIV(F->x0, F->scale), grid);
	while (i < F->X + F->W) {
		j = F->Y + (int)__MOD(F->H + __DIV(F->y0, F->scale), grid);
		while (j < F->Y + F->H) {
			Display_ReplConst(15, i, j, 1, 1, 0);
			j += grid;
		}
		i += grid;
	}
}

void KeplerFrames_Button_Execute (KeplerFrames_Button B, SET keys)
{
	INTEGER res = 0;
	Oberon_ParList par = NIL;
	Texts_Writer W = {0};
	CHAR cmd[32];
	if (keys == 0x02) {
		__NEW(par, Oberon_ParRec);
		par->vwr = Viewers_This(Display_Width - 1, Display_Height - 1);
		par->frame = par->vwr->dsc->next;
		par->text = TextFrames_Text((CHAR*)"", (LONGINT)1);
		par->pos = 0;
		Texts_OpenWriter(&W, Texts_Writer__typ);
		Texts_WriteString(&W, Texts_Writer__typ, B->par, 32);
		Texts_Append(par->text, W.buf);
		__COPY(B->cmd, cmd, 32);
		Oberon_Call(cmd, 32, par, 0, &res);
	} else if (keys == 0x03) {
		Texts_OpenWriter(&W, Texts_Writer__typ);
		Texts_WriteString(&W, Texts_Writer__typ, B->cmd, 32);
		Texts_Write(&W, Texts_Writer__typ, ' ');
		Texts_WriteString(&W, Texts_Writer__typ, B->par, 32);
		Texts_WriteLn(&W, Texts_Writer__typ);
		Texts_Append(Oberon_Log, W.buf);
	}
}

void KeplerFrames_Button_HandleMouse (KeplerFrames_Button B, KeplerFrames_Frame F, INTEGER x, INTEGER y, SET keys)
{
	SET keySum = 0;
	INTEGER x0 = 0, y0 = 0, w = 0, h = 0;
	if (__IN(1, keys)) {
		keySum = keys;
		x0 = KeplerFrames_Min(B->p[0]->x, B->p[1]->x);
		y0 = KeplerFrames_Min(B->p[0]->y, B->p[1]->y);
		w = __ABS(B->p[0]->x - B->p[1]->x);
		h = __ABS(B->p[0]->y - B->p[1]->y);
		__KeplerPorts_Port_DrawRect((void*)F, x0 - 4, y0 - 4, w + 8, h + 8, 5, 2);
		do {
			__KeplerFrames_Frame_TrackMouse(F, x, y, keys);
			KeplerFrames_GetMouse(F, &x, &y, &keys);
			keySum = keySum | keys;
		} while (!(keys == 0x0));
		__KeplerPorts_Port_DrawRect((void*)F, x0 - 4, y0 - 4, w + 8, h + 8, 5, 2);
		__KeplerFrames_Button_Execute(B, keySum);
	}
}

void KeplerFrames_Button_Write (KeplerFrames_Button B, Files_Rider *R, LONGINT *R__typ)
{
	Files_WriteString(&*R, R__typ, B->cmd, 32);
	Files_WriteString(&*R, R__typ, B->par, 32);
	KeplerGraphs_Constellation_Write((void*)B, &*R, R__typ);
}

void KeplerFrames_Button_Read (KeplerFrames_Button B, Files_Rider *R, LONGINT *R__typ)
{
	Files_ReadString(&*R, R__typ, (void*)B->cmd, 32);
	Files_ReadString(&*R, R__typ, (void*)B->par, 32);
	KeplerGraphs_Constellation_Read((void*)B, &*R, R__typ);
}

static void KeplerFrames_FlipCaret (KeplerPorts_Port p, INTEGER x, INTEGER y, INTEGER h)
{
	__KeplerPorts_Port_FillRect(p, x, y - 4, 4, h + 8, 15, 5, 2);
}

static INTEGER KeplerFrames_CarPos (CHAR *s, LONGINT s__len, Fonts_Font fnt, INTEGER carpos)
{
	SHORTINT fno = 0;
	CHAR ch = 0;
	INTEGER dx = 0, w = 0, i = 0, sdx = 0, sx = 0, sy = 0, sw = 0, sh = 0;
	LONGINT p = 0;
	fno = TextPrinter_FontNo(fnt);
	w = 0;
	i = 0;
	ch = s[0];
	while (i < carpos) {
		dx = (int)__DIVF(TextPrinter_DX(fno, ch), 3048);
		w += dx;
		i += 1;
		ch = s[__X(i, s__len)];
	}
	return w;
}

void KeplerFrames_Caption_Draw (KeplerFrames_Caption C, KeplerPorts_Port F)
{
	INTEGER x = 0, y = 0, w = 0;
	KeplerPorts_BalloonPort p = NIL;
	x = C->p[0]->x;
	y = C->p[0]->y;
	if (C->align != 0) {
		w = KeplerPorts_StringWidth((void*)C->s, 128, C->fnt);
		if (C->align == 1) {
			x -= __ASHR(w, 1);
		} else if (C->align == 2) {
			x -= w;
		} else if (C->align == 3) {
			x -= __ASHR(w, 1);
			y -= __ASHL(__ASHR(C->fnt->height, 1) + C->fnt->minY, 2);
		} else {
			y -= __ASHL(C->fnt->maxY, 2);
			if (C->align == 5) {
				x -= __ASHR(w, 1);
			} else if (C->align == 6) {
				x -= w;
			}
		}
	}
	__KeplerPorts_Port_DrawString(F, x, y, C->s, 128, C->fnt, 15, 1);
	if (__ISP(F, KeplerFrames_FrameDesc, 3) && KeplerFrames_focus == C) {
		w = KeplerFrames_CarPos((void*)C->s, 128, C->fnt, KeplerFrames_carpos);
		__NEW(p, KeplerPorts_BalloonPortDesc);
		KeplerPorts_InitBalloon(p);
		__KeplerGraphs_Object_Draw((void*)C, (void*)p);
		KeplerFrames_FlipCaret(F, p->X + w, p->Y, p->H);
	}
}

void KeplerFrames_Caption_Write (KeplerFrames_Caption C, Files_Rider *R, LONGINT *R__typ)
{
	if (C->align != 0) {
		Files_Write(&*R, R__typ, C->align);
	}
	Files_WriteString(&*R, R__typ, C->s, 128);
	Files_WriteString(&*R, R__typ, C->fnt->name, 32);
	KeplerGraphs_Constellation_Write((void*)C, &*R, R__typ);
}

void KeplerFrames_Caption_Read (KeplerFrames_Caption C, Files_Rider *R, LONGINT *R__typ)
{
	CHAR fntname[32];
	Files_Read(&*R, R__typ, (void*)&C->align);
	if (C->align <= 0 || C->align > 6) {
		C->align = 0;
		Files_Set(&*R, R__typ, Files_Base(&*R, R__typ), Files_Pos(&*R, R__typ) - 1);
	}
	Files_ReadString(&*R, R__typ, (void*)C->s, 128);
	Files_ReadString(&*R, R__typ, (void*)fntname, 32);
	C->fnt = Fonts_This(fntname, 32);
	KeplerGraphs_Constellation_Read((void*)C, &*R, R__typ);
}

void KeplerFrames_Frame_TrackMouse (KeplerFrames_Frame F, INTEGER x, INTEGER y, SET keys)
{
	Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, KeplerFrames_Max(__KeplerPorts_Port_CX((void*)F, x), 0), KeplerFrames_Min(__KeplerPorts_Port_CY((void*)F, y), Display_Height));
}

void KeplerFrames_Frame_Reduce (KeplerFrames_Frame F, INTEGER newY)
{
	F->H = (F->H + F->Y) - newY;
	F->Y = newY;
}

void KeplerFrames_Frame_Invert (KeplerFrames_Frame F, KeplerGraphs_Star p)
{
	if (__ISP(p, KeplerGraphs_PlanetDesc, 2) || p->refcnt > 0) {
		__KeplerPorts_Port_DrawLine((void*)F, (p->x - 12) - 4, p->y, (p->x + 12) + 4, p->y, 15, 2);
		__KeplerPorts_Port_DrawLine((void*)F, p->x, (p->y + 12) + 4, p->x, (p->y - 12) - 4, 15, 2);
	} else {
		__KeplerPorts_Port_DrawLine((void*)F, p->x - 12, p->y - 12, p->x + 12, p->y + 12, 15, 2);
		__KeplerPorts_Port_DrawLine((void*)F, p->x - 12, p->y + 12, p->x + 12, p->y - 12, 15, 2);
	}
}

static BOOLEAN KeplerFrames_Intersect (KeplerFrames_Frame F, INTEGER *X, INTEGER *Y, INTEGER *W, INTEGER *H)
{
	INTEGER t = 0;
	t = *X + *W;
	if (F->X > *X) {
		*X = F->X;
	}
	if (F->X + F->W < t) {
		*W = (F->X + F->W) - *X;
	} else {
		*W = t - *X;
	}
	if (*W <= 0) {
		return 0;
	}
	t = *Y + *H;
	if (F->Y > *Y) {
		*Y = F->Y;
	}
	if (F->Y + F->H < t) {
		*H = (F->Y + F->H) - *Y;
	} else {
		*H = t - *Y;
	}
	return *H > 0;
}

static void KeplerFrames_InvFocus (KeplerFrames_Frame F)
{
	KeplerFrames_FocusPoint fp = NIL;
	if (KeplerFrames_Focus == F->G) {
		fp = KeplerFrames_first;
		while (fp != NIL) {
			__KeplerFrames_Frame_Invert(F, fp->p);
			fp = fp->next;
		}
	}
}

void KeplerFrames_Frame_Extend (KeplerFrames_Frame F, INTEGER newY)
{
	INTEGER dY = 0, newH = 0;
	dY = F->Y - newY;
	Display_ReplConst(F->col, F->X, newY, F->W, F->Y - newY, 0);
	F->H = (F->H + F->Y) - newY;
	F->Y = newY;
	newH = F->H;
	F->y0 += (newH - dY) * F->scale;
	F->H = dY;
	if (F->grid > 0) {
		KeplerFrames_DrawGrid(F);
	}
	__KeplerGraphs_Object_Draw((void*)F->G, (void*)F);
	KeplerFrames_InvFocus(F);
	F->H = newH;
	F->y0 -= (newH - dY) * F->scale;
}

void KeplerFrames_Frame_Restore (KeplerFrames_Frame F, INTEGER X, INTEGER Y, INTEGER W, INTEGER H)
{
	if (W > 0 && H > 0) {
		KeplerFrames_upd->col = F->col;
		KeplerFrames_upd->G = F->G;
		KeplerFrames_upd->grid = F->grid;
		KeplerFrames_upd->scale = F->scale;
		KeplerFrames_upd->X = X;
		KeplerFrames_upd->Y = Y;
		KeplerFrames_upd->W = W;
		KeplerFrames_upd->H = H;
		if (KeplerFrames_Intersect(F, &KeplerFrames_upd->X, &KeplerFrames_upd->Y, &KeplerFrames_upd->W, &KeplerFrames_upd->H)) {
			H = KeplerFrames_upd->H;
			KeplerFrames_upd->x0 = F->x0 + (F->X - KeplerFrames_upd->X) * F->scale;
			KeplerFrames_upd->y0 = F->y0 + (((F->Y + F->H) - KeplerFrames_upd->Y) - KeplerFrames_upd->H) * F->scale;
			Oberon_RemoveMarks(KeplerFrames_upd->X, KeplerFrames_upd->Y, KeplerFrames_upd->W, KeplerFrames_upd->H);
			if (KeplerFrames_upd->Y >= 0 && KeplerFrames_upd->X < Display_Width) {
				KeplerFrames_upd->Y += Display_UBottom;
				__KeplerFrames_Frame_Reduce(KeplerFrames_upd, KeplerFrames_upd->Y + KeplerFrames_upd->H);
				__KeplerFrames_Frame_Extend(KeplerFrames_upd, KeplerFrames_upd->Y - H);
				Display_CopyBlock(KeplerFrames_upd->X, KeplerFrames_upd->Y, KeplerFrames_upd->W, KeplerFrames_upd->H, KeplerFrames_upd->X, KeplerFrames_upd->Y - Display_UBottom, 0);
			} else {
				__KeplerFrames_Frame_Reduce(KeplerFrames_upd, KeplerFrames_upd->Y + KeplerFrames_upd->H);
				__KeplerFrames_Frame_Extend(KeplerFrames_upd, KeplerFrames_upd->Y - H);
			}
		}
	}
}

void KeplerFrames_MoveOrigin (KeplerFrames_Frame F, INTEGER x0, INTEGER y0)
{
	INTEGER X = 0, Y = 0, W = 0, H = 0, dX = 0, dY = 0;
	dX = __DIV(x0 - F->x0, F->scale);
	dY = __DIV(y0 - F->y0, F->scale);
	if (dX != 0 || dY != 0) {
		F->x0 = x0;
		F->y0 = y0;
		Oberon_RemoveMarks(F->X, F->Y, F->W, F->H);
		X = F->X + dX;
		Y = F->Y + dY;
		W = F->W;
		H = F->H;
		if (KeplerFrames_Intersect(F, &X, &Y, &W, &H)) {
			Display_CopyBlock(X - dX, Y - dY, W, H, X, Y, 0);
		}
		if (dY > 0) {
			__KeplerFrames_Frame_Restore(F, F->X, F->Y, F->W, dY);
			Y = F->Y + dY;
		} else if (dY < 0) {
			__KeplerFrames_Frame_Restore(F, F->X, (F->Y + F->H) + dY, F->W, -dY);
			Y = F->Y;
		}
		if (dX > 0) {
			__KeplerFrames_Frame_Restore(F, F->X, Y, dX, F->H - __ABS(dY));
		} else if (dX < 0) {
			__KeplerFrames_Frame_Restore(F, (F->X + F->W) + dX, Y, -dX, F->H - __ABS(dY));
		}
	}
}

static void KeplerFrames_Move (KeplerFrames_Frame F, INTEGER x1, INTEGER y1)
{
	SET keySum = 0, keys = 0;
	INTEGER x0 = 0, y0 = 0, x10 = 0, y10 = 0, x2 = 0, y2 = 0;
	BOOLEAN dragSel = 0, dragOrg = 0;
	x0 = F->x0;
	y0 = F->y0;
	x10 = x1;
	y10 = y1;
	keySum = 0x02;
	dragSel = 0;
	dragOrg = 0;
	do {
		KeplerFrames_GetMouse(F, &x2, &y2, &keys);
		__KeplerFrames_Frame_TrackMouse(F, x2, y2, keys);
		keySum = keySum | keys;
		if (keySum == 0x07) {
			if (dragSel) {
				__KeplerGraphs_Graph_MoveSelection(F->G, x10 - x1, y10 - y1);
				dragSel = 0;
			} else if (dragOrg) {
				KeplerFrames_MoveOrigin(F, x0, y0);
				dragOrg = 0;
			}
		} else if (keySum == 0x06) {
			if (x1 != x2 || y1 != y2) {
				__KeplerGraphs_Graph_MoveSelection(F->G, x2 - x1, y2 - y1);
				x1 = x2;
				y1 = y2;
				dragSel = 1;
			}
		} else if (keySum == 0x03) {
			dragOrg = 1;
			KeplerFrames_MoveOrigin(F, (F->x0 + x2) - x1, (F->y0 + y2) - y1);
		}
	} while (!(keys == 0x0));
	if (keySum == 0x02) {
		__KeplerGraphs_Graph_MoveSelection(F->G, x2 - x1, y2 - y1);
	}
}

static void KeplerFrames_DrawFrame (KeplerFrames_Frame F, INTEGER x1, INTEGER y1, INTEGER x2, INTEGER y2)
{
	INTEGER t = 0;
	if (x1 > x2) {
		t = x1;
		x1 = x2;
		x2 = t;
	}
	if (y1 > y2) {
		t = y1;
		y1 = y2;
		y2 = t;
	}
	t = F->scale;
	__KeplerPorts_Port_FillRect((void*)F, x1, y1, x2 - x1, t, 15, 5, 2);
	__KeplerPorts_Port_FillRect((void*)F, x1, y2, x2 - x1, t, 15, 5, 2);
	__KeplerPorts_Port_FillRect((void*)F, x1, y1, t, y2 - y1, 15, 5, 2);
	__KeplerPorts_Port_FillRect((void*)F, x2, y1, t, y2 - y1, 15, 5, 2);
}

static void KeplerFrames_Select (KeplerFrames_Frame F, INTEGER x, INTEGER y)
{
	INTEGER x1 = 0, y1 = 0, x2 = 0, y2 = 0;
	SET keySum = 0, keys = 0;
	KeplerGraphs_Star p0 = NIL, p1 = NIL;
	keySum = 0x01;
	x1 = x;
	y1 = y;
	keys = 0x0;
	KeplerFrames_DrawFrame(F, x, y, x1, y1);
	for (;;) {
		__KeplerFrames_Frame_TrackMouse(F, x1, y1, keys);
		KeplerFrames_GetMouse(F, &x2, &y2, &keys);
		keySum = keySum | keys;
		if (keys == 0x0) {
			break;
		}
		if (x2 != x1) {
			KeplerFrames_DrawFrame(F, x1, y, x2, y1);
			x1 = x2;
		}
		if (y2 != y1) {
			KeplerFrames_DrawFrame(F, x, y1, x1, y2);
			y1 = y2;
		}
	}
	KeplerFrames_DrawFrame(F, x, y, x1, y1);
	if (keySum != 0x07) {
		KeplerFrames_SelectPoints(F->G, KeplerFrames_Min(x, x1), KeplerFrames_Min(y, y1), KeplerFrames_Max(x, x1), KeplerFrames_Max(y, y1));
		if (keySum == 0x05) {
			__KeplerGraphs_Graph_DeleteSelection(F->G, 2);
		} else if (keySum == 0x03 && KeplerFrames_nofpts >= 2) {
			KeplerFrames_GetPoint(&p0);
			KeplerFrames_GetPoint(&p1);
			__KeplerGraphs_Graph_CopySelection(KeplerFrames_Focus, F->G, p1->x - p0->x, p1->y - p0->y);
		}
	}
}

void KeplerFrames_GetSelection (KeplerGraphs_Graph *sel)
{
	KeplerFrames_SelMsg M = {0};
	M.time = -1;
	M.G = NIL;
	Viewers_Broadcast((void*)&M, KeplerFrames_SelMsg__typ);
	*sel = M.G;
}

static void KeplerFrames_Defocus (void)
{
	KeplerPorts_BalloonPort p = NIL;
	if (KeplerFrames_focus != NIL) {
		__NEW(p, KeplerPorts_BalloonPortDesc);
		KeplerPorts_InitBalloon(p);
		__KeplerGraphs_Object_Draw((void*)KeplerFrames_focus, (void*)p);
		KeplerFrames_focus = NIL;
		(*KeplerFrames_Focus->notify)(1, KeplerFrames_Focus, NIL, (void*)p);
	}
}

static void KeplerFrames_DeFocus (void)
{
	KeplerGraphs_Star s = NIL;
	while (KeplerFrames_nofpts > 0) {
		KeplerFrames_GetPoint(&s);
	}
}

static void KeplerFrames_PassFocus (KeplerGraphs_Graph G)
{
	KeplerFrames_Defocus();
	KeplerFrames_DeFocus();
	KeplerFrames_Focus = G;
}

static void KeplerFrames_Modify (Display_Frame F, INTEGER id, INTEGER dY, INTEGER Y, INTEGER H)
{
	if (__ISP(F, KeplerFrames_FrameDesc, 3)) {
		Oberon_RemoveMarks((*(KeplerFrames_Frame*)&F)->X, (*(KeplerFrames_Frame*)&F)->Y, (*(KeplerFrames_Frame*)&F)->W, (*(KeplerFrames_Frame*)&F)->H);
		if (id == 0) {
			if (dY > 0) {
				Display_CopyBlock((*(KeplerFrames_Frame*)&F)->X, (*(KeplerFrames_Frame*)&F)->Y, (*(KeplerFrames_Frame*)&F)->W, (*(KeplerFrames_Frame*)&F)->H, (*(KeplerFrames_Frame*)&F)->X, (*(KeplerFrames_Frame*)&F)->Y + dY, 0);
				(*(KeplerFrames_Frame*)&F)->Y += dY;
			}
			__KeplerFrames_Frame_Extend((*(KeplerFrames_Frame*)&F), Y);
		} else if (id == 1) {
			__KeplerFrames_Frame_Reduce((*(KeplerFrames_Frame*)&F), Y + dY);
			if (dY > 0) {
				Display_CopyBlock((*(KeplerFrames_Frame*)&F)->X, (*(KeplerFrames_Frame*)&F)->Y, (*(KeplerFrames_Frame*)&F)->W, (*(KeplerFrames_Frame*)&F)->H, (*(KeplerFrames_Frame*)&F)->X, Y, 0);
				(*(KeplerFrames_Frame*)&F)->Y = Y;
			}
		}
	} else __WITHCHK;
}

static void KeplerFrames_Drag (KeplerFrames_Frame F, KeplerGraphs_Star p)
{
	SET keySum = 0, keys = 0;
	INTEGER x = 0, y = 0, x0 = 0, y0 = 0;
	KeplerFrames_PassFocus(KeplerFrames_Focus);
	x0 = p->x;
	y0 = p->y;
	keys = 0x05;
	keySum = 0x0;
	while (keys != 0x0) {
		KeplerFrames_GetMouse(F, &x, &y, &keys);
		__KeplerFrames_Frame_TrackMouse(F, x, y, keys);
		keySum = keySum | keys;
		if (x != p->x || y != p->y) {
			__KeplerGraphs_Graph_Move(KeplerFrames_Focus, p, x - p->x, y - p->y);
		}
	}
	if (keySum == 0x07) {
		__KeplerGraphs_Graph_Move(KeplerFrames_Focus, p, x0 - p->x, y0 - p->y);
	}
}

static void KeplerFrames_Point (KeplerFrames_Frame F, INTEGER x, INTEGER y, SET keys)
{
	SET keySum = 0;
	KeplerGraphs_Star p = NIL;
	BOOLEAN new = 0;
	KeplerGraphs_Graph sel = NIL;
	KeplerFrames_Button b = NIL;
	keySum = keys;
	p = KeplerFrames_ThisPoint(F->G, x, y);
	if (p == NIL) {
		new = 1;
		__NEW(p, KeplerGraphs_StarDesc);
		p->x = x;
		p->y = y;
		p->refcnt = 0;
	} else {
		new = 0;
	}
	__KeplerFrames_Frame_Invert(F, p);
	while (keys != 0x0) {
		__KeplerFrames_Frame_TrackMouse(F, x, y, keys);
		KeplerFrames_GetMouse(F, &x, &y, &keys);
		keySum = keySum | keys;
		if ((new && keySum != 0x05) && (x != p->x || y != p->y)) {
			__KeplerFrames_Frame_Invert(F, p);
			p->x = x;
			p->y = y;
			__KeplerFrames_Frame_Invert(F, p);
		} else if (keySum == 0x05 && !__ISP(p, KeplerGraphs_PlanetDesc, 2)) {
			__KeplerFrames_Frame_Invert(F, p);
			if (KeplerFrames_Focus != F->G) {
				KeplerFrames_PassFocus(F->G);
			}
			if (new) {
				p->x = x;
				p->y = y;
				KeplerFrames_AppendFocusPoint(p);
				b = KeplerFrames_MarkedButton();
				if (b != NIL) {
					__KeplerFrames_Button_Execute(b, 0x02);
					Oberon_DrawCursor(&Oberon_Pointer, Oberon_Cursor__typ, &Oberon_Star, Oberon_Marker__typ, Oberon_Pointer.X, Oberon_Pointer.Y);
				}
			}
			KeplerFrames_Drag(F, p);
			return;
		}
	}
	__KeplerFrames_Frame_Invert(F, p);
	if (keySum == 0x06) {
		if (KeplerFrames_nofpts >= 1) {
			KeplerFrames_GetSelection(&sel);
			__KeplerGraphs_Graph_CopySelection(F->G, sel, x - KeplerFrames_first->p->x, y - KeplerFrames_first->p->y);
		}
	} else if (keySum != 0x07) {
		if (KeplerFrames_Focus != F->G) {
			KeplerFrames_PassFocus(F->G);
		}
		if (new) {
			p->x = x;
			p->y = y;
			KeplerFrames_AppendFocusPoint(p);
		} else if (KeplerFrames_IsFocusPoint(p) && !__ISP(p, KeplerGraphs_PlanetDesc, 2)) {
			KeplerFrames_PassFocus(KeplerFrames_Focus);
			__KeplerGraphs_Graph_Move(KeplerFrames_Focus, p, x - p->x, y - p->y);
			KeplerFrames_AppendFocusPoint(p);
		} else {
			KeplerFrames_AppendFocusPoint(p);
		}
	}
}

static void KeplerFrames_SetCaret (KeplerFrames_Frame F, KeplerFrames_Caption c, INTEGER x)
{
	INTEGER y = 0, i = 0, dx = 0, w = 0, oldw = 0;
	SET keys = 0;
	CHAR ch = 0;
	SHORTINT fno = 0;
	KeplerPorts_BalloonPort p = NIL;
	__NEW(p, KeplerPorts_BalloonPortDesc);
	KeplerPorts_InitBalloon(p);
	__KeplerGraphs_Object_Draw((void*)c, (void*)p);
	oldw = -1;
	do {
		i = 0;
		w = 0;
		ch = c->s[__X(i, 128)];
		fno = TextPrinter_FontNo(c->fnt);
		dx = (int)__DIVF(TextPrinter_DX(fno, ch), 3048);
		while (ch != 0x00 && (p->X + w) + __ASHR(dx, 1) < x) {
			w += dx;
			i += 1;
			ch = c->s[__X(i, 128)];
			dx = (int)__DIVF(TextPrinter_DX(fno, ch), 3048);
		}
		if (w != oldw) {
			if (oldw != -1) {
				KeplerFrames_FlipCaret((void*)F, p->X + oldw, p->Y, p->H);
			}
			KeplerFrames_FlipCaret((void*)F, p->X + w, p->Y, p->H);
		}
		Input_Mouse(&keys, &x, &y);
		x = __KeplerPorts_Port_Cx((void*)F, x);
		y = __KeplerPorts_Port_Cy((void*)F, y);
		__KeplerFrames_Frame_TrackMouse(F, x, y, keys);
		oldw = w;
	} while (!(keys == 0x0));
	if (KeplerFrames_Focus != F->G) {
		KeplerFrames_PassFocus(F->G);
	}
	KeplerFrames_focus = c;
	KeplerFrames_carpos = i;
}

void KeplerFrames_Frame_EditFrame (KeplerFrames_Frame F, INTEGER x, INTEGER y, SET keys)
{
	KeplerFrames_Button b = NIL;
	KeplerFrames_Caption c = NIL;
	KeplerFrames_GetMouse(F, &x, &y, &keys);
	if (keys == 0x02) {
		b = KeplerFrames_ThisButton(F->G, x, y);
		if (b != NIL) {
			__KeplerFrames_Button_HandleMouse(b, F, x, y, keys);
		} else {
			KeplerFrames_Move(F, x, y);
		}
	} else if (keys == 0x04) {
		if (KeplerFrames_focus == NIL && KeplerFrames_first == NIL || KeplerFrames_Focus != F->G) {
			Oberon_PassFocus(Viewers_This(F->X, F->Y));
			KeplerFrames_PassFocus(F->G);
		}
		c = KeplerFrames_ThisCaption(F->G, x, y);
		KeplerFrames_Defocus();
		if (c != NIL) {
			KeplerFrames_SetCaret(F, c, x);
		} else {
			KeplerFrames_Point(F, x, y, keys);
		}
	} else if (keys == 0x01) {
		KeplerFrames_Select(F, x, y);
	}
}

static void KeplerFrames_NewCaption (CHAR *s, LONGINT s__len, Fonts_Font fnt, INTEGER align, INTEGER carp)
{
	KeplerFrames_Caption o = NIL;
	__DUP(s, s__len, CHAR);
	if (KeplerFrames_nofpts > 0) {
		KeplerFrames_Defocus();
		__NEW(o, KeplerFrames_CaptionDesc);
		o->nofpts = 1;
		o->align = (int)align;
		__COPY(s, o->s, 128);
		o->fnt = fnt;
		KeplerFrames_focus = o;
		KeplerFrames_carpos = carp;
		KeplerFrames_ConsumePoint(&o->p[0]);
		__KeplerGraphs_Graph_Append(KeplerFrames_Focus, (void*)o);
	}
	__DEL(s);
}

void KeplerFrames_Frame_Consume (KeplerFrames_Frame F, CHAR ch)
{
	INTEGER i = 0;
	KeplerPorts_BalloonPort p = NIL;
	KeplerFrames_Caption o = NIL;
	CHAR s[2];
	if (KeplerFrames_focus != NIL) {
		__NEW(p, KeplerPorts_BalloonPortDesc);
		KeplerPorts_InitBalloon(p);
		__KeplerGraphs_Object_Draw((void*)KeplerFrames_focus, (void*)p);
		for (;;) {
			if (ch == 0x7f || ch == 0x08) {
				if (KeplerFrames_carpos > 0) {
					i = KeplerFrames_carpos;
					do {
						KeplerFrames_focus->s[__X(i - 1, 128)] = KeplerFrames_focus->s[__X(i, 128)];
						i += 1;
					} while (!(KeplerFrames_focus->s[__X(i - 1, 128)] == 0x00));
					KeplerFrames_carpos -= 1;
				}
			} else if ((ch == 0x09 || ch == 0x0d) || ch == 0x0a) {
				KeplerFrames_NewCaption((CHAR*)"", (LONGINT)1, KeplerFrames_focus->fnt, KeplerFrames_focus->align, 0);
				return;
			} else if (ch != 0x7f) {
				i = KeplerFrames_carpos;
				while (KeplerFrames_focus->s[__X(i, 128)] != 0x00) {
					i += 1;
				}
				if (i + 1 < 128) {
					do {
						KeplerFrames_focus->s[__X(i + 1, 128)] = KeplerFrames_focus->s[__X(i, 128)];
						i -= 1;
					} while (!(i + 1 == KeplerFrames_carpos));
					KeplerFrames_focus->s[__X(i + 1, 128)] = ch;
					KeplerFrames_carpos += 1;
				}
			}
			if (ch >= ' ' && Input_Available() > 0) {
				Input_Read(&ch);
			} else {
				break;
			}
		}
		__KeplerGraphs_Object_Draw((void*)KeplerFrames_focus, (void*)p);
		(*F->G->notify)(1, F->G, NIL, (void*)p);
	} else {
		if (ch == 0x7f) {
			__KeplerGraphs_Graph_DeleteSelection(F->G, 1);
		} else if (ch == 0x08) {
			KeplerFrames_DeleteFocusPoint(F);
		} else if (ch == 0xc1) {
			__KeplerGraphs_Graph_MoveSelection(F->G, 0, F->scale);
		} else if (ch == 0xc2) {
			__KeplerGraphs_Graph_MoveSelection(F->G, 0, -F->scale);
		} else if (ch == 0xc3) {
			__KeplerGraphs_Graph_MoveSelection(F->G, F->scale, 0);
		} else if (ch == 0xc4) {
			__KeplerGraphs_Graph_MoveSelection(F->G, -F->scale, 0);
		} else if ((int)ch == 145) {
			__KeplerFrames_Frame_Restore(F, F->X, F->Y, F->W, F->H);
		} else {
			s[0] = ch;
			s[1] = 0x00;
			KeplerFrames_NewCaption(s, 2, Oberon_CurFnt, 0, 1);
		}
		while (Input_Available() > 0) {
			Input_Read(&ch);
		}
	}
}

void KeplerFrames_Frame_Neutralize (KeplerFrames_Frame F)
{
	__KeplerGraphs_Graph_All(F->G, 0);
	KeplerFrames_Defocus();
	KeplerFrames_DeFocus();
}

static void KeplerFrames_CopyOver (Texts_Text T, LONGINT beg, LONGINT end)
{
	Texts_Reader R = {0};
	CHAR s[128], t[128];
	Fonts_Font fnt = NIL;
	CHAR ch = 0;
	INTEGER i = 0, j = 0;
	KeplerPorts_BalloonPort p = NIL;
	Texts_OpenReader(&R, Texts_Reader__typ, T, beg);
	Texts_Read(&R, Texts_Reader__typ, &ch);
	fnt = R.fnt;
	i = 0;
	while ((i < 127 && Texts_Pos(&R, Texts_Reader__typ) <= end) && ch != 0x0d) {
		s[__X(i, 128)] = ch;
		i += 1;
		Texts_Read(&R, Texts_Reader__typ, &ch);
	}
	s[__X(i, 128)] = 0x00;
	if (KeplerFrames_focus == NIL) {
		KeplerFrames_NewCaption(s, 128, fnt, 0, i);
	} else {
		__COPY(KeplerFrames_focus->s, t, 128);
		i = 0;
		j = KeplerFrames_carpos;
		while (s[__X(i, 128)] != 0x00) {
			KeplerFrames_focus->s[__X(j, 128)] = s[__X(i, 128)];
			i += 1;
			j += 1;
		}
		i = KeplerFrames_carpos - 1;
		KeplerFrames_carpos = j;
		do {
			i += 1;
			KeplerFrames_focus->s[__X(j, 128)] = t[__X(i, 128)];
			j += 1;
		} while (!(t[__X(i, 128)] == 0x00));
		__NEW(p, KeplerPorts_BalloonPortDesc);
		KeplerPorts_InitBalloon(p);
		__KeplerGraphs_Object_Draw((void*)KeplerFrames_focus, (void*)p);
		(*KeplerFrames_Focus->notify)(1, KeplerFrames_Focus, NIL, (void*)p);
	}
}

static Texts_Text KeplerFrames_TextSelection (KeplerGraphs_Graph G)
{
	Texts_Writer W = {0};
	Texts_Text T = NIL;
	KeplerGraphs_Constellation c = NIL;
	INTEGER i = 0;
	T = TextFrames_Text((CHAR*)"", (LONGINT)1);
	c = G->cons;
	Texts_OpenWriter(&W, Texts_Writer__typ);
	while (c != NIL) {
		if (__ISP(c, KeplerFrames_CaptionDesc, 2)) {
			if (__KeplerGraphs_Constellation_State((void*)(*(KeplerFrames_Caption*)&c)) == 2) {
				Texts_SetFont(&W, Texts_Writer__typ, (*(KeplerFrames_Caption*)&c)->fnt);
				i = 0;
				while ((*(KeplerFrames_Caption*)&c)->s[__X(i, 128)] != 0x00) {
					Texts_Write(&W, Texts_Writer__typ, (*(KeplerFrames_Caption*)&c)->s[__X(i, 128)]);
					i += 1;
				}
				Texts_WriteLn(&W, Texts_Writer__typ);
			}
		}
		c = c->next;
	}
	Texts_Append(T, W.buf);
	return T;
}

void KeplerFrames_Handle (Display_Frame F, Display_FrameMsg *M, LONGINT *M__typ)
{
	KeplerFrames_Frame F1 = NIL;
	if (__ISP(F, KeplerFrames_FrameDesc, 3)) {
		if (__IS(M__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *M__ = (void*)M;
			if ((*M__).id == 1 && (*M__).keys != 0x0) {
				__KeplerFrames_Frame_EditFrame((*(KeplerFrames_Frame*)&F), ((*M__).X - (*(KeplerFrames_Frame*)&F)->X) - (*(KeplerFrames_Frame*)&F)->x0, (((*M__).Y - (*(KeplerFrames_Frame*)&F)->Y) - (*(KeplerFrames_Frame*)&F)->H) - (*(KeplerFrames_Frame*)&F)->y0, (*M__).keys);
			} else if ((*M__).id == 1) {
				__KeplerFrames_Frame_TrackMouse((*(KeplerFrames_Frame*)&F), __KeplerPorts_Port_Cx((void*)(*(KeplerFrames_Frame*)&F), (*M__).X), __KeplerPorts_Port_Cy((void*)(*(KeplerFrames_Frame*)&F), (*M__).Y), (*M__).keys);
			} else if ((*M__).id == 0) {
				__KeplerFrames_Frame_Consume((*(KeplerFrames_Frame*)&F), (*M__).ch);
			}
		} else if (__IS(M__typ, Oberon_ControlMsg, 1)) {
			Oberon_ControlMsg *M__ = (void*)M;
			if ((*M__).id == 1) {
				__KeplerFrames_Frame_Neutralize((*(KeplerFrames_Frame*)&F));
			} else if ((*M__).id == 0) {
				KeplerFrames_Defocus();
				KeplerFrames_DeFocus();
			}
		} else if (__IS(M__typ, MenuViewers_ModifyMsg, 1)) {
			MenuViewers_ModifyMsg *M__ = (void*)M;
			KeplerFrames_Modify((void*)(*(KeplerFrames_Frame*)&F), (*M__).id, (*M__).dY, (*M__).Y, (*M__).H);
		} else if (__IS(M__typ, KeplerFrames_UpdateMsg, 1)) {
			KeplerFrames_UpdateMsg *M__ = (void*)M;
			if ((*M__).G == (*(KeplerFrames_Frame*)&F)->G) {
				if ((*M__).id == 0) {
					Oberon_RemoveMarks((*(KeplerFrames_Frame*)&F)->X, (*(KeplerFrames_Frame*)&F)->Y, (*(KeplerFrames_Frame*)&F)->W, (*(KeplerFrames_Frame*)&F)->H);
					KeplerFrames_InvFocus((*(KeplerFrames_Frame*)&F));
					__KeplerGraphs_Object_Draw((*M__).O, (void*)(*(KeplerFrames_Frame*)&F));
					KeplerFrames_InvFocus((*(KeplerFrames_Frame*)&F));
				} else if ((*M__).id == 1) {
					__KeplerFrames_Frame_Restore((*(KeplerFrames_Frame*)&F), __KeplerPorts_Port_CX((void*)(*(KeplerFrames_Frame*)&F), (*M__).P->X) - 1, __KeplerPorts_Port_CY((void*)(*(KeplerFrames_Frame*)&F), (*M__).P->Y) - 1, __DIV((*M__).P->W, (*(KeplerFrames_Frame*)&F)->scale) + 3, __DIV((*M__).P->H, (*(KeplerFrames_Frame*)&F)->scale) + 3);
				} else if ((*M__).id == 2 && KeplerFrames_Focus == (*(KeplerFrames_Frame*)&F)->G) {
					__KeplerFrames_Frame_Invert((*(KeplerFrames_Frame*)&F), __GUARDP((*M__).O, KeplerGraphs_StarDesc, 1));
				}
			}
		} else if (__IS(M__typ, KeplerFrames_SelMsg, 1)) {
			KeplerFrames_SelMsg *M__ = (void*)M;
			if ((*(KeplerFrames_Frame*)&F)->G->seltime > (*M__).time) {
				(*M__).G = (*(KeplerFrames_Frame*)&F)->G;
				(*M__).time = (*(KeplerFrames_Frame*)&F)->G->seltime;
			}
		} else if (__IS(M__typ, Oberon_SelectionMsg, 1)) {
			Oberon_SelectionMsg *M__ = (void*)M;
			if ((*(KeplerFrames_Frame*)&F)->G->seltime > (*M__).time) {
				(*M__).text = KeplerFrames_TextSelection((*(KeplerFrames_Frame*)&F)->G);
				(*M__).time = (*(KeplerFrames_Frame*)&F)->G->seltime;
				(*M__).beg = 0;
				(*M__).end = (*M__).text->len;
			}
		} else if (__IS(M__typ, Oberon_CopyMsg, 1)) {
			Oberon_CopyMsg *M__ = (void*)M;
			__NEW(F1, KeplerFrames_FrameDesc);
			(*M__).F = (Display_Frame)F1;
			__GUARDEQP(F1, KeplerFrames_FrameDesc) = *(*(KeplerFrames_Frame*)&F);
		} else if (__IS(M__typ, Oberon_CopyOverMsg, 1)) {
			Oberon_CopyOverMsg *M__ = (void*)M;
			KeplerFrames_CopyOver((*M__).text, (*M__).beg, (*M__).end);
		}
	} else __WITHCHK;
}

void KeplerFrames_Open (KeplerFrames_Frame F, KeplerGraphs_Graph G, INTEGER grid, INTEGER scale, KeplerGraphs_Notifier notify, Display_Handler handle)
{
	F->G = G;
	F->grid = grid;
	F->scale = scale;
	G->notify = notify;
	F->handle = handle;
}

KeplerFrames_Frame KeplerFrames_New (KeplerGraphs_Graph G)
{
	KeplerFrames_Frame F = NIL;
	__NEW(F, KeplerFrames_FrameDesc);
	KeplerFrames_Open(F, G, 0, 4, KeplerFrames_NotifyDisplay, KeplerFrames_Handle);
	return F;
}

static void EnumPtrs(void (*P)(void*))
{
	P(KeplerFrames_Focus);
	P(KeplerFrames_first);
	P(KeplerFrames_last);
	P(KeplerFrames_focus);
	P(KeplerFrames_upd);
}

__TDESC(KeplerFrames_FocusPointDesc, 1, 2) = {__TDFLDS("FocusPointDesc", 8), {0, 4, -12}};
__TDESC(KeplerFrames_ButtonDesc, 7, 5) = {__TDFLDS("ButtonDesc", 88), {4, 8, 12, 16, 20, -24}};
__TDESC(KeplerFrames_CaptionDesc, 5, 6) = {__TDFLDS("CaptionDesc", 160), {4, 8, 12, 16, 20, 152, -28}};
__TDESC(KeplerFrames_FrameDesc, 21, 4) = {__TDFLDS("FrameDesc", 40), {0, 4, 28, 32, -20}};
__TDESC(KeplerFrames_UpdateMsg, 1, 3) = {__TDFLDS("UpdateMsg", 16), {4, 8, 12, -16}};
__TDESC(KeplerFrames_SelMsg, 1, 1) = {__TDFLDS("SelMsg", 8), {4, -8}};

export void *KeplerFrames__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(Input);
	__IMPORT(KeplerGraphs);
	__IMPORT(KeplerPorts);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(KeplerFrames, EnumPtrs);
	__INITYP(KeplerFrames_FocusPointDesc, KeplerFrames_FocusPointDesc, 0);
	__INITYP(KeplerFrames_ButtonDesc, KeplerGraphs_ConsDesc, 2);
	__INITBP(KeplerFrames_ButtonDesc, KeplerFrames_Button_Execute, 4);
	__INITBP(KeplerFrames_ButtonDesc, KeplerFrames_Button_HandleMouse, 5);
	__INITBP(KeplerFrames_ButtonDesc, KeplerFrames_Button_Read, 1);
	__INITBP(KeplerFrames_ButtonDesc, KeplerFrames_Button_Write, 2);
	__INITYP(KeplerFrames_CaptionDesc, KeplerGraphs_ConsDesc, 2);
	__INITBP(KeplerFrames_CaptionDesc, KeplerFrames_Caption_Draw, 0);
	__INITBP(KeplerFrames_CaptionDesc, KeplerFrames_Caption_Read, 1);
	__INITBP(KeplerFrames_CaptionDesc, KeplerFrames_Caption_Write, 2);
	__INITYP(KeplerFrames_FrameDesc, KeplerPorts_DisplayPortDesc, 3);
	__INITBP(KeplerFrames_FrameDesc, KeplerFrames_Frame_Consume, 12);
	__INITBP(KeplerFrames_FrameDesc, KeplerFrames_Frame_EditFrame, 13);
	__INITBP(KeplerFrames_FrameDesc, KeplerFrames_Frame_Extend, 14);
	__INITBP(KeplerFrames_FrameDesc, KeplerFrames_Frame_Invert, 15);
	__INITBP(KeplerFrames_FrameDesc, KeplerFrames_Frame_Neutralize, 16);
	__INITBP(KeplerFrames_FrameDesc, KeplerFrames_Frame_Reduce, 17);
	__INITBP(KeplerFrames_FrameDesc, KeplerFrames_Frame_Restore, 18);
	__INITBP(KeplerFrames_FrameDesc, KeplerFrames_Frame_TrackMouse, 19);
	__INITYP(KeplerFrames_UpdateMsg, Display_FrameMsg, 1);
	__INITYP(KeplerFrames_SelMsg, Display_FrameMsg, 1);
/* BEGIN */
	__NEW(KeplerFrames_upd, KeplerFrames_FrameDesc);
	__NEW(KeplerFrames_Focus, KeplerGraphs_GraphDesc);
	__ENDMOD;
}
