/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Args.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "In.h"
#include "Kernel.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Unix.h"

typedef
	struct Mailer_FrameDesc *Mailer_Frame;

typedef
	struct Mailer_MailDesc *Mailer_Mail;

typedef
	struct Mailer_FrameDesc { /* TextFrames_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		Texts_Text text;
		LONGINT org;
		INTEGER col, left, right, top, bot, markH, barW;
		LONGINT time;
		BOOLEAN hasCar, hasSel, showsParcs;
		TextFrames_Location carloc, selbeg, selend;
		Display_Frame focus;
		char _prvt0[4];
		Texts_Text mailText;
		CHAR mailFileName[110];
		LONGINT mailFileLen;
		Mailer_Mail mails;
	} Mailer_FrameDesc;

typedef
	struct Mailer_MailDesc {
		Mailer_Mail next;
		LONGINT start, len, nr;
		BOOLEAN del;
	} Mailer_MailDesc;


export CHAR Mailer_MAIL[110], Mailer_MBOX[110];
static CHAR Mailer_nextch;

export LONGINT *Mailer_MailDesc__typ;
export LONGINT *Mailer_FrameDesc__typ;

export void Mailer_Append (void);
export void Mailer_CutLines (void);
export void Mailer_Delete (void);
static void Mailer_Forward (void);
static void Mailer_GetField (Texts_Text t, LONGINT pos, CHAR *entry, LONGINT entry__len, CHAR *line, LONGINT line__len);
static void Mailer_GetNewsSubject (Texts_Text t, LONGINT pos, CHAR *line, LONGINT line__len);
static void Mailer_GetWord (Texts_Reader *R, LONGINT *R__typ, CHAR *word, LONGINT word__len);
static void Mailer_Init (void);
static void Mailer_MailBoxText (Texts_Text T, LONGINT newMailPos, Texts_Text *MB, Mailer_Mail *mails);
export void Mailer_Mailbox (void);
static TextFrames_Frame Mailer_Menu (CHAR *title, LONGINT title__len, CHAR *menufile, LONGINT menufile__len, CHAR *default_, LONGINT default___len);
export void Mailer_Mono (void);
export void Mailer_Post (void);
export void Mailer_Quote (void);
static void Mailer_QuoteText (Texts_Text text, LONGINT beg, LONGINT end);
export void Mailer_Reply (void);
static TextFrames_Frame Mailer_ReplyMenu (Display_Frame parFrame);
export void Mailer_Send (void);
export void Mailer_Show (void);
static TextFrames_Frame Mailer_ShowMenu (LONGINT i);
static void Mailer_SkipMail (Texts_Reader *R, LONGINT *R__typ, Mailer_Mail mail);
export void Mailer_Store (void);
static void Mailer_StripFrom (CHAR *line, LONGINT line__len);

#define Mailer_system(cmd, cmd__len)	system(cmd)

static void Mailer_GetWord (Texts_Reader *R, LONGINT *R__typ, CHAR *word, LONGINT word__len)
{
	INTEGER i = 0;
	Texts_Read(&*R, R__typ, &Mailer_nextch);
	i = 0;
	while (i < 5 && Mailer_nextch >= ' ') {
		word[__X(i, word__len)] = Mailer_nextch;
		i += 1;
		Texts_Read(&*R, R__typ, &Mailer_nextch);
	}
	word[__X(i, word__len)] = 0x00;
}

static void Mailer_GetField (Texts_Text t, LONGINT pos, CHAR *entry, LONGINT entry__len, CHAR *line, LONGINT line__len)
{
	INTEGER i = 0;
	CHAR ch = 0;
	CHAR tag[32];
	Texts_Reader R = {0};
	__DUP(entry, entry__len, CHAR);
	Texts_OpenReader(&R, Texts_Reader__typ, t, pos);
	line[0] = 0x00;
	for (;;) {
		i = 0;
		Texts_Read(&R, Texts_Reader__typ, &ch);
		while (ch > ' ' && i < 31) {
			if ('a' <= ch && ch <= 'z') {
				ch = __CAP(ch);
			}
			tag[__X(i, 32)] = ch;
			i += 1;
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		tag[__X(i, 32)] = 0x00;
		if (__STRCMP(tag, entry) == 0) {
			i = -1;
			do {
				Texts_Read(&R, Texts_Reader__typ, &ch);
				if (ch == 0x0d) {
					Texts_Read(&R, Texts_Reader__typ, &ch);
					if (ch != ' ' && ch != 0x09) {
						ch = 0x0d;
					}
				}
				if (ch == 0x09) {
					ch = ' ';
				}
				if ((LONGINT)(i + 1) < line__len) {
					i += 1;
				}
				line[__X(i, line__len)] = ch;
			} while (!(R.eot || ch == 0x0d));
			line[__X(i, line__len)] = 0x00;
			break;
		} else if (R.eot || ch == 0x0d) {
			break;
		}
		do {
			Texts_Read(&R, Texts_Reader__typ, &ch);
		} while (!(R.eot || ch == 0x0d));
	}
	__DEL(entry);
}

static void Mailer_SkipMail (Texts_Reader *R, LONGINT *R__typ, Mailer_Mail mail)
{
	INTEGER i = 0;
	CHAR word[6];
	do {
		while (Mailer_nextch != 0x0d && Mailer_nextch != 0x00) {
			Texts_Read(&*R, R__typ, &Mailer_nextch);
		}
		mail->len = Texts_Pos(&*R, R__typ) - mail->start;
		Mailer_GetWord(&*R, R__typ, (void*)word, 6);
	} while (!(__STRCMP(word, "From ") == 0 || (*R).eot));
}

static void Mailer_StripFrom (CHAR *line, LONGINT line__len)
{
	INTEGER i = 0, j = 0;
	CHAR ch = 0;
	i = 0;
	ch = line[0];
	while (ch != 0x00) {
		if (ch == '(' || ch == '\"') {
			i += 1;
			ch = line[__X(i, line__len)];
			j = 0;
			while ((ch != ')' && ch != '\"') && ch != 0x00) {
				line[__X(j, line__len)] = line[__X(i, line__len)];
				i += 1;
				j += 1;
				ch = line[__X(i, line__len)];
			}
			line[__X(j, line__len)] = 0x00;
			return;
		} else if (ch == '<') {
			if (i > 2 && line[__X(i - 1, line__len)] == ' ') {
				line[__X(i - 1, line__len)] = 0x00;
				return;
			} else {
				i += 1;
				ch = line[__X(i, line__len)];
				j = 0;
				while (ch != '>' && ch != 0x00) {
					line[__X(j, line__len)] = line[__X(i, line__len)];
					i += 1;
					j += 1;
					ch = line[__X(i, line__len)];
				}
				line[__X(j, line__len)] = 0x00;
				return;
			}
		}
		i += 1;
		ch = line[__X(i, line__len)];
	}
}

static void Mailer_GetNewsSubject (Texts_Text t, LONGINT pos, CHAR *line, LONGINT line__len)
{
	CHAR ch0 = 0, ch1 = 0;
	Texts_Reader R = {0};
	Texts_OpenReader(&R, Texts_Reader__typ, t, pos);
	Texts_Read(&R, Texts_Reader__typ, &ch0);
	Texts_Read(&R, Texts_Reader__typ, &ch1);
	while (!R.eot && ch0 != 0x0d || ch1 != 0x0d) {
		ch0 = ch1;
		Texts_Read(&R, Texts_Reader__typ, &ch1);
	}
	Mailer_GetField(t, Texts_Pos(&R, Texts_Reader__typ), (CHAR*)"SUBJECT:", (LONGINT)9, (void*)line, line__len);
}

static void Mailer_MailBoxText (Texts_Text T, LONGINT newMailPos, Texts_Text *MB, Mailer_Mail *mails)
{
	Texts_Writer W = {0};
	Texts_Reader R = {0}, R1 = {0};
	Mailer_Mail mail = NIL;
	LONGINT nofmails = 0;
	CHAR word[6];
	CHAR line[1024];
	Texts_OpenWriter(&W, Texts_Writer__typ);
	nofmails = 0;
	Texts_OpenReader(&R, Texts_Reader__typ, T, 0);
	Mailer_GetWord(&R, Texts_Reader__typ, (void*)word, 6);
	*MB = TextFrames_Text((CHAR*)"", (LONGINT)1);
	while (!R.eot) {
		__NEW(mail, Mailer_MailDesc);
		mail->start = Texts_Pos(&R, Texts_Reader__typ) - 6;
		mail->del = 0;
		mail->nr = nofmails;
		Texts_WriteInt(&W, Texts_Writer__typ, nofmails, 2);
		if (mail->start < newMailPos) {
			Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)"  ", (LONGINT)3);
		} else {
			Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)" + ", (LONGINT)4);
		}
		Mailer_GetField(T, mail->start, (CHAR*)"FROM:", (LONGINT)6, (void*)line, 1024);
		if (line[0] == 0x00) {
			Mailer_GetField(T, mail->start, (CHAR*)"FROM", (LONGINT)5, (void*)line, 1024);
		}
		Mailer_StripFrom((void*)line, 1024);
		Texts_WriteString(&W, Texts_Writer__typ, line, 1024);
		Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)"    ", (LONGINT)5);
		Mailer_GetField(T, mail->start, (CHAR*)"SUBJECT:", (LONGINT)9, (void*)line, 1024);
		Texts_WriteString(&W, Texts_Writer__typ, line, 1024);
		Mailer_SkipMail(&R, Texts_Reader__typ, mail);
		mail->next = (*mails)->next;
		(*mails)->next = mail;
		Texts_WriteInt(&W, Texts_Writer__typ, mail->len, 8);
		Texts_WriteLn(&W, Texts_Writer__typ);
		Texts_Insert(*MB, 0, W.buf);
		nofmails += 1;
	}
}

static void Mailer_Init (void)
{
	INTEGER i = 0, j = 0;
	CHAR ch = 0;
	__MOVE("/var/spool/mail/", Mailer_MAIL, 17);
	i = 16;
	j = 0;
	do {
		ch = Oberon_User[__X(j, 12)];
		Mailer_MAIL[__X(i, 110)] = ch;
		i += 1;
		j += 1;
	} while (!(ch == 0x00));
	Args_GetEnv((CHAR*)"MAIL", (LONGINT)5, (void*)Mailer_MAIL, 110);
	Mailer_MBOX[0] = '.';
	Mailer_MBOX[1] = 0x00;
	Args_GetEnv((CHAR*)"HOME", (LONGINT)5, (void*)Mailer_MBOX, 110);
	i = 0;
	while (Mailer_MBOX[__X(i, 110)] != 0x00) {
		i += 1;
	}
	Mailer_MBOX[__X(i, 110)] = '/';
	Mailer_MBOX[__X(i + 1, 110)] = 'm';
	Mailer_MBOX[__X(i + 2, 110)] = 'b';
	Mailer_MBOX[__X(i + 3, 110)] = 'o';
	Mailer_MBOX[__X(i + 4, 110)] = 'x';
	Mailer_MBOX[__X(i + 5, 110)] = 0x00;
	Args_GetEnv((CHAR*)"MBOX", (LONGINT)5, (void*)Mailer_MBOX, 110);
}

static TextFrames_Frame Mailer_Menu (CHAR *title, LONGINT title__len, CHAR *menufile, LONGINT menufile__len, CHAR *default_, LONGINT default___len)
{
	TextFrames_Frame M = NIL;
	Texts_Text T = NIL;
	Texts_Buffer buf = NIL;
	__DUP(title, title__len, CHAR);
	__DUP(menufile, menufile__len, CHAR);
	__DUP(default_, default___len, CHAR);
	if (Files_Old(menufile, menufile__len) != NIL) {
		M = TextFrames_NewMenu(title, title__len, (CHAR*)"", (LONGINT)1);
		__NEW(T, Texts_TextDesc);
		Texts_Open(T, menufile, menufile__len);
		__NEW(buf, Texts_BufDesc);
		Texts_OpenBuf(buf);
		Texts_Save(T, 0, T->len, buf);
		Texts_Append(M->text, buf);
	} else {
		M = TextFrames_NewMenu(title, title__len, default_, default___len);
	}
	__DEL(title);
	__DEL(menufile);
	__DEL(default_);
	return M;
}

void Mailer_Mailbox (void)
{
	INTEGER X = 0, Y = 0;
	CHAR ch = 0;
	MenuViewers_Viewer V = NIL;
	Files_File mail = NIL, mbox = NIL;
	Files_Rider mailR = {0}, mboxR = {0};
	CHAR mailfile[64];
	Mailer_Frame F = NIL;
	LONGINT newMailPos = 0, res = 0;
	In_Open();
	In_Name((void*)mailfile, 64);
	newMailPos = 2147483647;
	if (!In_Done) {
		mail = Files_Old(Mailer_MAIL, 110);
		if (mail == NIL) {
			return;
		}
		mbox = Files_Old(Mailer_MBOX, 110);
		if (mbox == NIL) {
			mbox = Files_New(Mailer_MBOX, 110);
			Files_Register(mbox);
		}
		if (mail != NIL && Files_Length(mail) != 0) {
			newMailPos = Files_Length(mbox);
			Files_Set(&mboxR, Files_Rider__typ, mbox, Files_Length(mbox));
			Files_Set(&mailR, Files_Rider__typ, mail, 0);
			res = Unix_Flock(mail->fd, 8);
			res = Unix_Flock(mail->fd, 2);
			Files_Read(&mailR, Files_Rider__typ, (void*)&ch);
			while (!mailR.eof) {
				Files_Write(&mboxR, Files_Rider__typ, ch);
				Files_Read(&mailR, Files_Rider__typ, (void*)&ch);
			}
			Files_Close(mbox);
			Files_Purge(mail);
			res = Unix_Flock(mail->fd, 8);
		}
		__COPY(Mailer_MBOX, mailfile, 64);
	}
	__NEW(F, Mailer_FrameDesc);
	F->mailText = TextFrames_Text(mailfile, 64);
	if (F->mailText != NIL) {
		F->mailFileLen = F->mailText->len;
		__NEW(F->mails, Mailer_MailDesc);
		Mailer_MailBoxText(F->mailText, newMailPos, &F->text, &F->mails);
		TextFrames_Open((void*)F, F->text, 0);
		Oberon_AllocateSystemViewer(Oberon_Mouse.X, &X, &Y);
		V = MenuViewers_New((void*)Mailer_Menu(mailfile, 64, (CHAR*)"Mailer.MailboxMenu.Text", (LONGINT)24, (CHAR*)"System.Close Mailer.Show  Mailer.Delete  Mailer.Store ", (LONGINT)55), (void*)F, TextFrames_menuH, X, Y);
	}
}

static TextFrames_Frame Mailer_ShowMenu (LONGINT i)
{
	TextFrames_Frame menu = NIL;
	Texts_Writer W = {0};
	menu = Mailer_Menu((CHAR*)"", (LONGINT)1, (CHAR*)"Mailer.ShowMenu.Text", (LONGINT)21, (CHAR*)"System.Close System.Copy System.Grow Edit.Search Mailer.Reply Mailer.Mono Edit.Store ", (LONGINT)86);
	Texts_OpenWriter(&W, Texts_Writer__typ);
	Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)"Message", (LONGINT)8);
	Texts_WriteInt(&W, Texts_Writer__typ, i, 0);
	Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)".Text", (LONGINT)6);
	Texts_Insert(menu->text, 0, W.buf);
	return menu;
}

void Mailer_Show (void)
{
	INTEGER X = 0, Y = 0;
	Mailer_Mail mail = NIL;
	Texts_Scanner S = {0};
	Display_Frame F = NIL;
	Texts_Buffer B = NIL;
	MenuViewers_Viewer V = NIL;
	Texts_Text T = NIL;
	F = Oberon_Par->vwr->dsc->next;
	if (__ISP(F, Mailer_FrameDesc, 2) && __GUARDP(F, Mailer_FrameDesc, 2)->hasSel) {
		if (__ISP(F, Mailer_FrameDesc, 2)) {
			Oberon_AllocateUserViewer(Oberon_Mouse.X, &X, &Y);
			Texts_OpenScanner(&S, Texts_Scanner__typ, (*(Mailer_Frame*)&F)->text, (*(Mailer_Frame*)&F)->selbeg.org);
			Texts_Scan(&S, Texts_Scanner__typ);
			if (S.class == 3) {
				mail = (*(Mailer_Frame*)&F)->mails->next;
				while (mail != NIL && mail->nr != S.i) {
					mail = mail->next;
				}
				if (mail != NIL) {
					T = TextFrames_Text((CHAR*)"", (LONGINT)1);
					__NEW(B, Texts_BufDesc);
					Texts_OpenBuf(B);
					Texts_Save((*(Mailer_Frame*)&F)->mailText, mail->start, mail->start + mail->len, B);
					Texts_Append(T, B);
					V = MenuViewers_New((void*)Mailer_ShowMenu(S.i), (void*)TextFrames_NewText(T, 0), TextFrames_menuH, X, Y);
				}
			}
		} else __WITHCHK;
	}
}

void Mailer_Delete (void)
{
	Mailer_Mail mail = NIL, m = NIL;
	Texts_Scanner S = {0};
	Display_Frame F = NIL;
	INTEGER n = 0;
	Texts_Reader R = {0};
	CHAR ch = 0;
	Texts_Text T = NIL;
	F = Oberon_Par->vwr->dsc->next;
	if (__ISP(F, Mailer_FrameDesc, 2) && __GUARDP(F, Mailer_FrameDesc, 2)->hasSel) {
		if (__ISP(F, Mailer_FrameDesc, 2)) {
			Texts_OpenScanner(&S, Texts_Scanner__typ, (*(Mailer_Frame*)&F)->text, (*(Mailer_Frame*)&F)->selbeg.org);
			Texts_Scan(&S, Texts_Scanner__typ);
			if (S.class == 3) {
				Texts_OpenReader(&R, Texts_Reader__typ, (*(Mailer_Frame*)&F)->text, (*(Mailer_Frame*)&F)->selbeg.pos);
				n = 1;
				Texts_Read(&R, Texts_Reader__typ, &ch);
				while (Texts_Pos(&R, Texts_Reader__typ) < (*(Mailer_Frame*)&F)->selend.pos - 1) {
					if (ch == 0x0d) {
						n += 1;
					}
					Texts_Read(&R, Texts_Reader__typ, &ch);
				}
				mail = (*(Mailer_Frame*)&F)->mails->next;
				while (mail != NIL && mail->nr != S.i) {
					mail = mail->next;
				}
				if (mail != NIL) {
					while (mail != NIL && n > 0) {
						m = (*(Mailer_Frame*)&F)->mails;
						Texts_Delete((*(Mailer_Frame*)&F)->mailText, mail->start, mail->start + mail->len);
						while (m->next != mail) {
							m = m->next;
							m->start -= mail->len;
						}
						m->next = mail->next;
						mail = mail->next;
						n -= 1;
					}
					while (ch >= ' ' || ch == 0x09) {
						Texts_Read(&R, Texts_Reader__typ, &ch);
					}
					Texts_Delete((*(Mailer_Frame*)&F)->text, (*(Mailer_Frame*)&F)->selbeg.org, Texts_Pos(&R, Texts_Reader__typ));
				}
			}
		} else __WITHCHK;
	}
}

void Mailer_Store (void)
{
	Mailer_Mail mail = NIL, m = NIL;
	Display_Frame F = NIL;
	Texts_Scanner S = {0};
	Texts_Reader R = {0};
	CHAR ch = 0;
	Files_File mbox = NIL;
	Files_Rider mboxR = {0};
	Texts_Writer W = {0};
	Texts_Text T = NIL;
	LONGINT res = 0;
	F = Oberon_Par->vwr->dsc;
	if (F == Oberon_Par->frame && __ISP(F->next, Mailer_FrameDesc, 2)) {
		Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, 0);
		Texts_Scan(&S, Texts_Scanner__typ);
		mbox = Files_New(S.s, 256);
		Files_Set(&mboxR, Files_Rider__typ, mbox, 0);
		Texts_OpenWriter(&W, Texts_Writer__typ);
		Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)"Mailer.Store ", (LONGINT)14);
		Texts_WriteString(&W, Texts_Writer__typ, S.s, 256);
		Texts_WriteLn(&W, Texts_Writer__typ);
		Texts_Append(Oberon_Log, W.buf);
		Texts_OpenReader(&R, Texts_Reader__typ, __GUARDP(F->next, Mailer_FrameDesc, 2)->mailText, 0);
		Texts_Read(&R, Texts_Reader__typ, &ch);
		while (!R.eot) {
			if (ch == 0x0d) {
				ch = 0x0a;
			}
			Files_Write(&mboxR, Files_Rider__typ, ch);
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		Files_Register(mbox);
		res = Unix_Chmod(S.s, 256, 384);
		if (__ISP(F, TextFrames_FrameDesc, 1)) {
			T = __GUARDP(F, TextFrames_FrameDesc, 1)->text;
			Texts_OpenReader(&R, Texts_Reader__typ, T, T->len - 1);
			Texts_Read(&R, Texts_Reader__typ, &ch);
			if (ch == '!') {
				Texts_Delete(T, T->len - 1, T->len);
			}
		}
	}
}

void Mailer_Send (void)
{
	Display_Frame V = NIL;
	Files_File temp = NIL;
	Texts_Scanner S = {0};
	Texts_Reader R = {0};
	Files_Rider mR = {0};
	CHAR ch = 0;
	INTEGER res = 0;
	Texts_Writer W = {0};
	if (Oberon_Par->frame == Oberon_Par->vwr->dsc) {
		V = (Display_Frame)Oberon_Par->vwr;
	} else {
		V = (Display_Frame)Oberon_MarkedViewer();
	}
	if ((V != NIL && __ISP(V, MenuViewers_ViewerDesc, 2)) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
		Texts_OpenWriter(&W, Texts_Writer__typ);
		Texts_OpenScanner(&S, Texts_Scanner__typ, __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text, 0);
		Texts_Scan(&S, Texts_Scanner__typ);
		Texts_OpenReader(&R, Texts_Reader__typ, __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1)->text, 0);
		temp = Files_New((CHAR*)"/tmp/Mailer.Send", (LONGINT)17);
		Files_Set(&mR, Files_Rider__typ, temp, 0);
		Texts_Read(&R, Texts_Reader__typ, &ch);
		while (!R.eot) {
			if (ch == 0x0d) {
				ch = 0x0a;
			}
			Files_Write(&mR, Files_Rider__typ, ch);
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		Texts_WriteString(&W, Texts_Writer__typ, S.s, 256);
		Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)" mailing", (LONGINT)9);
		Texts_WriteLn(&W, Texts_Writer__typ);
		Texts_Append(Oberon_Log, W.buf);
		Files_Register(temp);
		Mailer_system((CHAR*)"(/usr/lib/sendmail -oi -t < /tmp/Mailer.Send; rm /tmp/Mailer.Send) &", (LONGINT)69);
	}
}

void Mailer_Post (void)
{
	Display_Frame V = NIL;
	Files_File temp = NIL;
	Texts_Scanner S = {0};
	Texts_Reader R = {0};
	Files_Rider mR = {0};
	CHAR ch = 0;
	INTEGER res = 0;
	Texts_Writer W = {0};
	V = (Display_Frame)Oberon_MarkedViewer();
	if (V != NIL && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
		Texts_OpenWriter(&W, Texts_Writer__typ);
		Texts_OpenScanner(&S, Texts_Scanner__typ, __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text, 0);
		Texts_Scan(&S, Texts_Scanner__typ);
		Texts_OpenReader(&R, Texts_Reader__typ, __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1)->text, 0);
		temp = Files_New((CHAR*)"/tmp/Mailer.Post", (LONGINT)17);
		Files_Set(&mR, Files_Rider__typ, temp, 0);
		Texts_Read(&R, Texts_Reader__typ, &ch);
		while (!R.eot) {
			if (ch == 0x0d) {
				ch = 0x0a;
			}
			Files_Write(&mR, Files_Rider__typ, ch);
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		Texts_WriteString(&W, Texts_Writer__typ, S.s, 256);
		Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)" posting", (LONGINT)9);
		Texts_WriteLn(&W, Texts_Writer__typ);
		Texts_Append(Oberon_Log, W.buf);
		Files_Register(temp);
		Mailer_system((CHAR*)"/usr/lib/news/inews -h < /tmp/Mailer.Post", (LONGINT)42);
		Files_Delete((CHAR*)"/tmp/Mailer.Post", (LONGINT)17, &res);
	}
}

static void Mailer_QuoteText (Texts_Text text, LONGINT beg, LONGINT end)
{
	Texts_Writer W = {0};
	Texts_Reader R = {0};
	CHAR ch = 0;
	Texts_OpenWriter(&W, Texts_Writer__typ);
	do {
		Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)"> ", (LONGINT)3);
		Texts_Insert(text, beg, W.buf);
		end += 2;
		Texts_OpenReader(&R, Texts_Reader__typ, text, beg);
		do {
			Texts_Read(&R, Texts_Reader__typ, &ch);
			beg += 1;
		} while (!(ch == 0x0d || beg >= end));
	} while (!(beg >= end));
}

void Mailer_Quote (void)
{
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Oberon_GetSelection(&text, &beg, &end, &time);
	if (time >= 0) {
		Mailer_QuoteText(text, beg, end);
	}
}

static TextFrames_Frame Mailer_ReplyMenu (Display_Frame parFrame)
{
	TextFrames_Frame menu = NIL;
	Texts_Writer W = {0};
	Texts_Scanner S = {0};
	menu = Mailer_Menu((CHAR*)"", (LONGINT)1, (CHAR*)"Mailer.ReplyMenu.Text", (LONGINT)22, (CHAR*)"System.Close System.Copy System.Grow Edit.Search !Mailer.Send Edit.Store ", (LONGINT)74);
	Texts_OpenScanner(&S, Texts_Scanner__typ, __GUARDP(parFrame, TextFrames_FrameDesc, 1)->text, 0);
	Texts_Scan(&S, Texts_Scanner__typ);
	Texts_OpenWriter(&W, Texts_Writer__typ);
	Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)"Reply.", (LONGINT)7);
	if (S.class == 1) {
		Texts_WriteString(&W, Texts_Writer__typ, S.s, 256);
	} else {
		Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)"Text", (LONGINT)5);
	}
	Texts_Insert(menu->text, 0, W.buf);
	return menu;
}

void Mailer_Reply (void)
{
	INTEGER X = 0, Y = 0;
	CHAR ch = 0;
	LONGINT beg = 0, i = 0;
	Texts_Text T = NIL;
	Texts_Writer W = {0};
	MenuViewers_Viewer V = NIL;
	TextFrames_Frame F = NIL;
	Texts_Buffer B = NIL;
	CHAR line[1024];
	Oberon_AllocateUserViewer(Oberon_Mouse.X, &X, &Y);
	if (Oberon_Par->vwr->dsc == Oberon_Par->frame) {
		F = __GUARDP(Oberon_Par->frame->next, TextFrames_FrameDesc, 1);
		Texts_OpenWriter(&W, Texts_Writer__typ);
		Mailer_GetField(F->text, 0, (CHAR*)"REPLY-TO:", (LONGINT)10, (void*)line, 1024);
		if (line[0] == 0x00) {
			Mailer_GetField(F->text, 0, (CHAR*)"FROM:", (LONGINT)6, (void*)line, 1024);
		}
		Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)"To: ", (LONGINT)5);
		Texts_WriteString(&W, Texts_Writer__typ, line, 1024);
		Texts_WriteLn(&W, Texts_Writer__typ);
		Mailer_GetField(F->text, 0, (CHAR*)"SUBJECT:", (LONGINT)9, (void*)line, 1024);
		if (line[0] != 0x00) {
			Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)"Subject: Re: ", (LONGINT)14);
			Texts_WriteString(&W, Texts_Writer__typ, line, 1024);
			Texts_WriteLn(&W, Texts_Writer__typ);
		}
		Texts_WriteLn(&W, Texts_Writer__typ);
		T = TextFrames_Text((CHAR*)"", (LONGINT)1);
		Texts_Append(T, W.buf);
		if (F->hasSel) {
			beg = T->len;
			__NEW(B, Texts_BufDesc);
			Texts_OpenBuf(B);
			Texts_Save(F->text, F->selbeg.pos, F->selend.pos, B);
			Texts_Append(T, B);
			Mailer_QuoteText(T, beg, T->len);
			Texts_WriteLn(&W, Texts_Writer__typ);
			Texts_Append(T, W.buf);
		}
		V = MenuViewers_New((void*)Mailer_ReplyMenu(Oberon_Par->frame), (void*)TextFrames_NewText(T, 0), TextFrames_menuH, X, Y);
		Oberon_PassFocus((void*)V);
		TextFrames_SetCaret(__GUARDP(V->dsc->next, TextFrames_FrameDesc, 1), T->len);
	}
}

void Mailer_Append (void)
{
	Files_File f = NIL;
	Display_Frame V = NIL;
	Texts_Reader R0 = {0};
	Files_Rider R1 = {0};
	CHAR ch = 0;
	CHAR to[64];
	Texts_Writer W = {0};
	In_Open();
	In_Name((void*)to, 64);
	V = (Display_Frame)Oberon_MarkedViewer();
	if ((In_Done && __ISP(V, MenuViewers_ViewerDesc, 2)) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
		Texts_OpenWriter(&W, Texts_Writer__typ);
		Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)" appending * to ", (LONGINT)17);
		Texts_WriteString(&W, Texts_Writer__typ, to, 64);
		Texts_WriteLn(&W, Texts_Writer__typ);
		Texts_Append(Oberon_Log, W.buf);
		f = Files_Old(to, 64);
		if (f == NIL) {
			f = Files_New(to, 64);
			Files_Register(f);
		}
		Files_Set(&R1, Files_Rider__typ, f, Files_Length(f));
		Texts_OpenReader(&R0, Texts_Reader__typ, __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1)->text, 0);
		Texts_Read(&R0, Texts_Reader__typ, &ch);
		while (!R0.eot) {
			if (ch == 0x0d) {
				ch = 0x0a;
			}
			Files_Write(&R1, Files_Rider__typ, ch);
			Texts_Read(&R0, Texts_Reader__typ, &ch);
		}
		Files_Close(f);
	}
}

void Mailer_CutLines (void)
{
	LONGINT lim = 0, beg = 0, end = 0, pos = 0;
	CHAR ch = 0;
	Texts_Scanner S = {0};
	Display_Frame V = NIL;
	Texts_Text T = NIL;
	Texts_Reader R = {0};
	Texts_Writer W = {0};
	Texts_OpenWriter(&W, Texts_Writer__typ);
	Texts_OpenScanner(&S, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if ((S.line == 0 && S.class == 3) && S.i > 1) {
		lim = S.i;
		Texts_Scan(&S, Texts_Scanner__typ);
	} else {
		lim = 80;
	}
	if ((S.line == 0 && S.class == 6) && S.c == '*') {
		V = (Display_Frame)Oberon_MarkedViewer();
	} else {
		V = (Display_Frame)Oberon_Par->vwr;
	}
	if (((V != NIL && V->dsc != NIL) && V->dsc->next != NIL) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
		T = __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1)->text;
		pos = 0;
		beg = 0;
		end = lim - 1;
		Texts_OpenReader(&R, Texts_Reader__typ, T, 0);
		for (;;) {
			Texts_Read(&R, Texts_Reader__typ, &ch);
			pos += 1;
			if (R.eot) {
				break;
			} else if (ch == 0x0d) {
				beg = pos;
				end = (beg + lim) - 1;
			} else if (pos - beg == lim) {
				Texts_Write(&W, Texts_Writer__typ, 0x0d);
				Texts_Insert(T, end, W.buf);
				pos = end;
				Texts_OpenReader(&R, Texts_Reader__typ, T, pos);
			} else if (ch <= ' ' || ch == '-') {
				end = pos;
			} else if (0x80 <= ch && ch <= 0x85) {
				switch (ch) {
					case 0x80: 
						ch = 'A';
						break;
					case 0x81: 
						ch = 'O';
						break;
					case 0x82: 
						ch = 'U';
						break;
					case 0x83: 
						ch = 'a';
						break;
					case 0x84: 
						ch = 'o';
						break;
					case 0x85: 
						ch = 'u';
						break;
					default: __CASECHK;
				}
				pos -= 1;
				Texts_Delete(T, pos, pos + 1);
				Texts_Write(&W, Texts_Writer__typ, ch);
				Texts_Write(&W, Texts_Writer__typ, 'e');
				Texts_Insert(T, pos, W.buf);
				Texts_OpenReader(&R, Texts_Reader__typ, T, pos);
			}
		}
	}
}

void Mailer_Mono (void)
{
	Display_Frame V = NIL;
	Texts_Text T = NIL;
	if (Oberon_Par->frame == Oberon_Par->vwr->dsc) {
		V = (Display_Frame)Oberon_Par->vwr;
	} else {
		V = (Display_Frame)Oberon_MarkedViewer();
	}
	if ((V != NIL && __ISP(V, MenuViewers_ViewerDesc, 2)) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
		T = __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1)->text;
		Texts_ChangeLooks(T, 0, T->len, 0x01, Fonts_This((CHAR*)"Courier10.Scn.Fnt", (LONGINT)18), 0, 0);
	}
}

static void Mailer_Forward (void)
{
	Display_Frame V = NIL;
	Texts_Text T = NIL;
	Texts_Writer W = {0};
	CHAR line[1024];
	if (Oberon_Par->frame == Oberon_Par->vwr->dsc) {
		V = (Display_Frame)Oberon_Par->vwr;
	} else {
		V = (Display_Frame)Oberon_MarkedViewer();
	}
	if ((V != NIL && __ISP(V, MenuViewers_ViewerDesc, 2)) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
		T = __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1)->text;
		Mailer_GetField(T, 0, (CHAR*)"SUBJECT:", (LONGINT)9, (void*)line, 1024);
		Mailer_QuoteText(T, 0, T->len);
		Texts_OpenWriter(&W, Texts_Writer__typ);
		Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)"To: ", (LONGINT)5);
		Texts_WriteLn(&W, Texts_Writer__typ);
		Texts_WriteString(&W, Texts_Writer__typ, (CHAR*)"Subject: FWD>", (LONGINT)14);
		Texts_WriteString(&W, Texts_Writer__typ, line, 1024);
		Texts_WriteLn(&W, Texts_Writer__typ);
		Texts_WriteLn(&W, Texts_Writer__typ);
		Texts_Insert(T, 0, W.buf);
	}
}

__TDESC(Mailer_MailDesc, 1, 1) = {__TDFLDS("MailDesc", 20), {0, -8}};
__TDESC(Mailer_FrameDesc, 1, 10) = {__TDFLDS("FrameDesc", 244), {0, 4, 20, 68, 88, 108, 112, 116, 120, 240, -44}};

export void *Mailer__init(void)
{
	__DEFMOD;
	__IMPORT(Args);
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(In);
	__IMPORT(Kernel);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Unix);
	__REGMOD(Mailer, 0);
	__REGCMD("Append", Mailer_Append);
	__REGCMD("CutLines", Mailer_CutLines);
	__REGCMD("Delete", Mailer_Delete);
	__REGCMD("Mailbox", Mailer_Mailbox);
	__REGCMD("Mono", Mailer_Mono);
	__REGCMD("Post", Mailer_Post);
	__REGCMD("Quote", Mailer_Quote);
	__REGCMD("Reply", Mailer_Reply);
	__REGCMD("Send", Mailer_Send);
	__REGCMD("Show", Mailer_Show);
	__REGCMD("Store", Mailer_Store);
	__INITYP(Mailer_MailDesc, Mailer_MailDesc, 0);
	__INITYP(Mailer_FrameDesc, TextFrames_FrameDesc, 2);
/* BEGIN */
	Mailer_Init();
	__ENDMOD;
}
