/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "Input.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct MenuElems_EditFrameDesc *MenuElems_EditFrame;

typedef
	struct MenuElems_MenuDesc *MenuElems_Menu;

typedef
	struct MenuElems_EditFrameDesc { /* TextFrames_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		Texts_Text text;
		LONGINT org;
		INTEGER col, left, right, top, bot, markH, barW;
		LONGINT time;
		BOOLEAN hasCar, hasSel, showsParcs;
		TextFrames_Location carloc, selbeg, selend;
		Display_Frame focus;
		char _prvt0[4];
		MenuElems_Menu menu;
	} MenuElems_EditFrameDesc;

typedef
	struct MenuElems_MenuDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		Texts_Text text;
		INTEGER nofcom, lastcom, mpos, mw, mh, lsp, dsc;
	} MenuElems_MenuDesc;


static Texts_Buffer MenuElems_buf;
static INTEGER MenuElems_YBottom;

export LONGINT *MenuElems_MenuDesc__typ;
export LONGINT *MenuElems_EditFrameDesc__typ;

export void MenuElems_Alloc (void);
static void MenuElems_DrawMenu (MenuElems_Menu M, INTEGER col, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER off);
static void MenuElems_Edit (MenuElems_Menu M);
static void MenuElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void MenuElems_HandleEdit (Display_Frame F, Display_FrameMsg *M, LONGINT *M__typ);
export void MenuElems_Insert (void);
static void MenuElems_Load (Files_Rider *R, LONGINT *R__typ, MenuElems_Menu M);
static void MenuElems_Popup (MenuElems_Menu M, INTEGER col, INTEGER x, INTEGER y);
static void MenuElems_Store (Files_Rider *R, LONGINT *R__typ, MenuElems_Menu M);
static void MenuElems_TrackMenu (MenuElems_Menu M, INTEGER x, INTEGER y, INTEGER *cmd);
export void MenuElems_Update (void);
static void MenuElems_WriteTitle (MenuElems_Menu M, INTEGER x, INTEGER y);


static void MenuElems_WriteTitle (MenuElems_Menu M, INTEGER x, INTEGER y)
{
	INTEGER dx = 0, x1 = 0, y1 = 0, w = 0, h = 0;
	CHAR ch = 0;
	LONGINT pat = 0;
	Texts_Reader R = {0};
	Texts_OpenReader(&R, Texts_Reader__typ, M->text, 0);
	Texts_Read(&R, Texts_Reader__typ, &ch);
	if (R.eot) {
		ch = 0x1c;
		R.fnt = Fonts_This((CHAR*)"Syntax10.Scn.Fnt", (LONGINT)17);
	}
	y -= R.fnt->minY;
	do {
		Display_GetChar(R.fnt->raster, ch, &dx, &x1, &y1, &w, &h, &pat);
		Display_CopyPattern(R.col, pat, x + x1, y + y1, 2);
		x += dx;
		Texts_Read(&R, Texts_Reader__typ, &ch);
	} while (!(R.eot || ch < ' '));
}

static void MenuElems_DrawMenu (MenuElems_Menu M, INTEGER col, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER off)
{
	INTEGER x0 = 0, y0 = 0, x1 = 0, y1 = 0, dx = 0;
	CHAR ch = 0;
	LONGINT pat = 0;
	Texts_Reader R = {0};
	Display_ReplConst(0, x, y, w, h, 0);
	Display_ReplConst(col, x, y, w, 1, 0);
	Display_ReplConst(col, (x + w) - 1, y, 1, h, 0);
	Display_ReplConst(col, x, (y + h) - 1, w, 1, 0);
	Display_ReplConst(col, x, y, 1, h, 0);
	Texts_OpenReader(&R, Texts_Reader__typ, M->text, M->mpos);
	Texts_Read(&R, Texts_Reader__typ, &ch);
	x0 = x + 4;
	x = x0;
	y0 = y;
	y = ((((y + h) - M->lsp) - M->dsc) - 4) - off;
	while (!R.eot) {
		if (ch == 0x0d) {
			y -= M->lsp;
			x = x0;
			if (y < y0) {
				y = y + M->nofcom * M->lsp;
			}
		} else {
			Display_GetChar(R.fnt->raster, ch, &dx, &x1, &y1, &w, &h, &pat);
			Display_CopyPattern(R.col, pat, x + x1, y + y1, 0);
			x += dx;
		}
		Texts_Read(&R, Texts_Reader__typ, &ch);
	}
}

static void MenuElems_HandleEdit (Display_Frame F, Display_FrameMsg *M, LONGINT *M__typ)
{
	MenuElems_EditFrame F1 = NIL;
	TextFrames_Handle(F, &*M, M__typ);
	if (__ISP(F, MenuElems_EditFrameDesc, 2)) {
		if (__IS(M__typ, Oberon_CopyMsg, 1)) {
			__NEW(F1, MenuElems_EditFrameDesc);
			TextFrames_Open((void*)F1, (*(MenuElems_EditFrame*)&F)->text, (*(MenuElems_EditFrame*)&F)->org);
			F1->handle = (*(MenuElems_EditFrame*)&F)->handle;
			F1->menu = (*(MenuElems_EditFrame*)&F)->menu;
			__GUARDR(M, Oberon_CopyMsg, 1).F = (Display_Frame)F1;
		}
	} else __WITHCHK;
}

static void MenuElems_Edit (MenuElems_Menu M)
{
	Viewers_Viewer V = NIL;
	MenuElems_EditFrame F = NIL;
	Texts_Text T = NIL;
	INTEGER x = 0, y = 0;
	T = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_Save(M->text, 0, M->text->len, MenuElems_buf);
	Texts_Append(T, MenuElems_buf);
	Oberon_AllocateUserViewer(Oberon_Par->vwr->X, &x, &y);
	__NEW(F, MenuElems_EditFrameDesc);
	F->menu = M;
	TextFrames_Open((void*)F, T, 0);
	F->handle = MenuElems_HandleEdit;
	V = (Viewers_Viewer)MenuViewers_New((void*)TextFrames_NewMenu((CHAR*)"Menu", (LONGINT)5, (CHAR*)"System.Close  MenuElems.Update ", (LONGINT)32), (void*)F, TextFrames_menuH, x, y);
}

static void MenuElems_TrackMenu (MenuElems_Menu M, INTEGER x, INTEGER y, INTEGER *cmd)
{
	INTEGER mx = 0, my = 0, xbar = 0, wbar = 0, lsp = 0, top = 0, com = 0, old = 0;
	SET keys = 0, keysum = 0;
	lsp = M->lsp;
	xbar = x + 4;
	wbar = M->mw - 8;
	top = (y + M->mh) - 4;
	keysum = 0x02;
	old = -1;
	do {
		Input_Mouse(&keys, &mx, &my);
		if (((x < mx && mx < x + M->mw) && y + 4 < my) && my < top) {
			com = __DIV(top - my, lsp);
		} else {
			com = -1;
		}
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, mx, my);
		if (com != old) {
			if (old >= 0) {
				Display_ReplConst(15, xbar, top - (old + 1) * lsp, wbar, lsp, 2);
			}
			if (com >= 0) {
				Display_ReplConst(15, xbar, top - (com + 1) * lsp, wbar, lsp, 2);
			}
			old = com;
		}
		keysum = keysum | keys;
	} while (!(keys == 0x0));
	if (keysum == 0x07) {
		com = -1;
	} else if (keysum == 0x06) {
		com = -2;
	}
	*cmd = com;
}

static void MenuElems_Popup (MenuElems_Menu M, INTEGER col, INTEGER x, INTEGER y)
{
	INTEGER top = 0, bot = 0, off = 0, i = 0, j = 0, cmd = 0, res = 0;
	CHAR ch = 0;
	SET keys = 0;
	CHAR cmdStr[32];
	Texts_Reader R = {0};
	cmd = M->lastcom;
	Oberon_Par->vwr = Viewers_This(x, y);
	if (x + M->mw > Display_Width) {
		x = Display_Width - M->mw;
	}
	top = ((y + (M->lastcom + 1) * M->lsp) + M->dsc) + 4;
	if (top > Display_Height) {
		top = Display_Height;
	}
	bot = top - M->mh;
	if (bot < 0) {
		bot = 0;
		top = M->mh;
	}
	if (M->nofcom > 0) {
		off = (int)__MOD(__DIV((top - 4) - y, M->lsp) - M->lastcom, M->nofcom) * M->lsp;
	} else {
		off = 0;
	}
	Oberon_RemoveMarks(x, bot, M->mw, M->mh);
	Display_CopyBlock(x, bot, M->mw, M->mh, 0, MenuElems_YBottom, 0);
	MenuElems_DrawMenu(M, col, x, bot, M->mw, M->mh, off);
	MenuElems_TrackMenu(M, x, bot, &cmd);
	Oberon_RemoveMarks(x, bot, M->mw, M->mh);
	Display_CopyBlock(0, MenuElems_YBottom, M->mw, M->mh, x, bot, 0);
	if (cmd == -2) {
		MenuElems_Edit(M);
	}
	if (cmd >= 0) {
		cmd = (int)__MOD(cmd - __DIV(off, M->lsp), M->nofcom);
		M->lastcom = cmd;
		j = 0;
		Texts_OpenReader(&R, Texts_Reader__typ, M->text, M->mpos);
		Texts_Read(&R, Texts_Reader__typ, &ch);
		while (j < cmd) {
			if (ch == 0x0d) {
				j += 1;
			}
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		i = 0;
		while (ch > ' ' && i < 31) {
			cmdStr[__X(i, 32)] = ch;
			i += 1;
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		cmdStr[__X(i, 32)] = 0x00;
		Oberon_Par->frame = Oberon_Par->vwr->dsc;
		Oberon_Par->text = M->text;
		Oberon_Par->pos = Texts_Pos(&R, Texts_Reader__typ);
		Oberon_Call(cmdStr, 32, Oberon_Par, 0, &res);
	}
}

static void MenuElems_Load (Files_Rider *R, LONGINT *R__typ, MenuElems_Menu M)
{
	LONGINT n = 0;
	Files_ReadNum(&*R, R__typ, &n);
	M->nofcom = (int)n;
	M->lastcom = 0;
	Files_ReadNum(&*R, R__typ, &n);
	M->mpos = (int)n;
	Files_ReadNum(&*R, R__typ, &n);
	M->mw = (int)n;
	Files_ReadNum(&*R, R__typ, &n);
	M->mh = (int)n;
	Files_ReadNum(&*R, R__typ, &n);
	M->lsp = (int)n;
	Files_ReadNum(&*R, R__typ, &n);
	M->dsc = (int)n;
	M->text = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_Load(&*R, R__typ, M->text);
}

static void MenuElems_Store (Files_Rider *R, LONGINT *R__typ, MenuElems_Menu M)
{
	Files_WriteNum(&*R, R__typ, M->nofcom);
	Files_WriteNum(&*R, R__typ, M->mpos);
	Files_WriteNum(&*R, R__typ, M->mw);
	Files_WriteNum(&*R, R__typ, M->mh);
	Files_WriteNum(&*R, R__typ, M->lsp);
	Files_WriteNum(&*R, R__typ, M->dsc);
	Texts_Store(&*R, R__typ, M->text);
}

static void MenuElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	MenuElems_Menu M = NIL;
	if (__ISP(E, MenuElems_MenuDesc, 2)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
				TextFrames_DisplayMsg *msg__ = (void*)msg;
				if (!(*msg__).prepare) {
					MenuElems_WriteTitle((*(MenuElems_Menu*)&E), (*msg__).X0, (*msg__).Y0);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			if (__IS(msg__typ, Texts_CopyMsg, 1)) {
				Texts_CopyMsg *msg__ = (void*)msg;
				__NEW(M, MenuElems_MenuDesc);
				Texts_CopyElem((void*)(*(MenuElems_Menu*)&E), (void*)M);
				M->nofcom = (*(MenuElems_Menu*)&E)->nofcom;
				M->lastcom = (*(MenuElems_Menu*)&E)->lastcom;
				M->mpos = (*(MenuElems_Menu*)&E)->mpos;
				M->mw = (*(MenuElems_Menu*)&E)->mw;
				M->mh = (*(MenuElems_Menu*)&E)->mh;
				M->lsp = (*(MenuElems_Menu*)&E)->lsp;
				M->dsc = (*(MenuElems_Menu*)&E)->dsc;
				M->text = TextFrames_Text((CHAR*)"", (LONGINT)1);
				Texts_Save((*(MenuElems_Menu*)&E)->text, 0, (*(MenuElems_Menu*)&E)->text->len, MenuElems_buf);
				Texts_Append(M->text, MenuElems_buf);
				(*msg__).e = (Texts_Elem)M;
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
				Texts_IdentifyMsg *msg__ = (void*)msg;
				__MOVE("MenuElems", (*msg__).mod, 10);
				__MOVE("Alloc", (*msg__).proc, 6);
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			if (__IS(msg__typ, Texts_FileMsg, 1)) {
				Texts_FileMsg *msg__ = (void*)msg;
				if ((*msg__).id == 0) {
					MenuElems_Load(&(*msg__).r, Files_Rider__typ, (*(MenuElems_Menu*)&E));
				} else if ((*msg__).id == 1) {
					MenuElems_Store(&(*msg__).r, Files_Rider__typ, (*(MenuElems_Menu*)&E));
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
				TextFrames_TrackMsg *msg__ = (void*)msg;
				if ((*msg__).keys == 0x02) {
					MenuElems_Popup((*(MenuElems_Menu*)&E), (*msg__).col, (*msg__).X0, (*msg__).Y0 - (*msg__).fnt->minY);
				}
			} else __WITHCHK;
		}
	} else __WITHCHK;
}

void MenuElems_Alloc (void)
{
	MenuElems_Menu M = NIL;
	__NEW(M, MenuElems_MenuDesc);
	M->handle = MenuElems_Handle;
	Texts_new = (Texts_Elem)M;
}

void MenuElems_Update (void)
{
	MenuElems_Menu M = NIL;
	LONGINT pos = 0;
	INTEGER len = 0, dx = 0, x1 = 0, y1 = 0, w = 0, w1 = 0, h = 0, h1 = 0;
	CHAR ch = 0;
	LONGINT pat = 0;
	MenuElems_EditFrame F = NIL;
	Texts_Text T = NIL;
	Texts_Reader R = {0};
	if (Oberon_Par->frame == Oberon_Par->vwr->dsc) {
		F = __GUARDP(Oberon_Par->frame->next, MenuElems_EditFrameDesc, 2);
		M = F->menu;
		T = F->text;
		Texts_OpenReader(&R, Texts_Reader__typ, T, 0);
		len = 1;
		w = 0;
		h = 0;
		Texts_Read(&R, Texts_Reader__typ, &ch);
		while (!R.eot && ch >= ' ') {
			Display_GetChar(R.fnt->raster, ch, &dx, &x1, &y1, &w1, &h1, &pat);
			w += dx;
			len += 1;
			if (h < R.fnt->height) {
				h = R.fnt->height;
			}
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		Texts_Read(&R, Texts_Reader__typ, &ch);
		M->W = (LONGINT)w * (LONGINT)TextFrames_Unit;
		M->H = (LONGINT)h * Display_Unit;
		M->mpos = len;
		M->nofcom = 0;
		M->lastcom = 0;
		M->mw = 0;
		M->lsp = 0;
		M->dsc = 0;
		w = 0;
		while (!R.eot) {
			if (ch == 0x0d) {
				if (M->mw < w) {
					M->mw = w;
				}
				w = 0;
				M->nofcom += 1;
			} else {
				if (M->lsp < R.fnt->height) {
					M->lsp = R.fnt->height;
				}
				if (M->dsc > R.fnt->minY) {
					M->dsc = R.fnt->minY;
				}
				Display_GetChar(R.fnt->raster, ch, &dx, &x1, &y1, &w1, &h1, &pat);
				w += dx;
			}
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		if (w > 0) {
			M->nofcom += 1;
			if (M->mw < w) {
				M->mw = w;
			}
		}
		M->mh = M->lsp * M->nofcom + 8;
		M->mw += 8;
		M->text = T;
		T = Texts_ElemBase((void*)M);
		pos = Texts_ElemPos((void*)M);
		(*T->notify)(T, 0, pos, pos + 1);
		T = __GUARDP(Oberon_Par->frame, TextFrames_FrameDesc, 1)->text;
		Texts_OpenReader(&R, Texts_Reader__typ, T, T->len - 1);
		Texts_Read(&R, Texts_Reader__typ, &ch);
		if (ch == '!') {
			Texts_Delete(T, T->len - 1, T->len);
		}
	}
}

void MenuElems_Insert (void)
{
	MenuElems_Menu M = NIL;
	TextFrames_InsertElemMsg insert = {0};
	__NEW(M, MenuElems_MenuDesc);
	M->W = __ASHL(Display_Unit, 3);
	M->H = M->W;
	M->lsp = 8;
	M->mw = 8;
	M->mh = 8;
	M->text = TextFrames_Text((CHAR*)"", (LONGINT)1);
	M->handle = MenuElems_Handle;
	insert.e = (Texts_Elem)M;
	(*Oberon_FocusViewer->handle)((void*)Oberon_FocusViewer, (void*)&insert, TextFrames_InsertElemMsg__typ);
}

static void EnumPtrs(void (*P)(void*))
{
	P(MenuElems_buf);
}

__TDESC(MenuElems_MenuDesc, 1, 5) = {__TDFLDS("MenuDesc", 56), {0, 4, 12, 32, 36, -24}};
__TDESC(MenuElems_EditFrameDesc, 1, 9) = {__TDFLDS("EditFrameDesc", 124), {0, 4, 20, 68, 88, 108, 112, 116, 120, -40}};

export void *MenuElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(Input);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(MenuElems, EnumPtrs);
	__REGCMD("Alloc", MenuElems_Alloc);
	__REGCMD("Insert", MenuElems_Insert);
	__REGCMD("Update", MenuElems_Update);
	__INITYP(MenuElems_MenuDesc, Texts_ElemDesc, 2);
	__INITYP(MenuElems_EditFrameDesc, TextFrames_FrameDesc, 2);
/* BEGIN */
	__NEW(MenuElems_buf, Texts_BufDesc);
	Texts_OpenBuf(MenuElems_buf);
	MenuElems_YBottom = Display_UBottom;
	__ENDMOD;
}
