/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"
#include "X11.h"

typedef
	struct Miscellaneous_FileHandle *Miscellaneous_File;

typedef
	struct Miscellaneous_FileDesc {
		CHAR name[22];
		INTEGER time, date, head;
		LONGINT size;
	} Miscellaneous_FileDesc;

typedef
	struct Miscellaneous_FileHandle {
		Miscellaneous_File prev, next;
		Miscellaneous_FileDesc file;
	} Miscellaneous_FileHandle;


static Texts_Scanner Miscellaneous_S;
static Texts_Text Miscellaneous_T;
static Texts_Writer Miscellaneous_W;
static Miscellaneous_File Miscellaneous_dir;
static Miscellaneous_FileDesc Miscellaneous_trailer;
static INTEGER Miscellaneous_i;
static Texts_Text Miscellaneous_scrap;
static Texts_Buffer Miscellaneous_B;
static struct {
	LONGINT len[1];
	CHAR data[1];
} *Miscellaneous_selectionData;
static BOOLEAN Miscellaneous_ownSelection;
static LONGINT Miscellaneous_myProperty;

export LONGINT *Miscellaneous_FileDesc__typ;
export LONGINT *Miscellaneous_FileHandle__typ;

export void Miscellaneous_Cleanup (void);
static void Miscellaneous_ClearSelection (void);
export void Miscellaneous_ConvertBlanks (void);
export void Miscellaneous_ConvertTabs (void);
export void Miscellaneous_Copy (void);
static void Miscellaneous_CopyOverSelection (void);
export void Miscellaneous_CountLines (void);
export void Miscellaneous_Cut (void);
export void Miscellaneous_Paste (void);
static void Miscellaneous_ReceiveSelection (X11_SelectionEvent *event, LONGINT *event__typ);
static void Miscellaneous_RequestSelection (void);
static void Miscellaneous_SendSelection (X11_SelectionRequestEvent *event, LONGINT *event__typ);
static void Miscellaneous_TakeSelection (void);


void Miscellaneous_CountLines (void)
{
	Oberon_ParList par = NIL;
	Texts_Reader R = {0};
	Texts_Scanner S = {0};
	Texts_Text T = NIL, source = NIL;
	Viewers_Viewer V = NIL;
	LONGINT nofLines = 0, totalLines = 0, i = 0;
	INTEGER X = 0, Y = 0;
	CHAR ch = 0;
	Oberon_AllocateSystemViewer(Oberon_Par->frame->X, &X, &Y);
	T = TextFrames_Text((CHAR*)"", (LONGINT)1);
	V = (Viewers_Viewer)MenuViewers_New((void*)TextFrames_NewMenu((CHAR*)"Miscellaneous.CountLines", (LONGINT)25, (CHAR*)"System.Close System.Copy System.Grow Edit.Search Edit.Store", (LONGINT)60), (void*)TextFrames_NewText(T, 0), TextFrames_menuH, X, Y);
	totalLines = 0;
	par = Oberon_Par;
	Texts_OpenScanner(&S, Texts_Scanner__typ, par->text, par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	while (S.class == 1) {
		Texts_WriteString(&Miscellaneous_W, Texts_Writer__typ, S.s, 256);
		Texts_Append(T, Miscellaneous_W.buf);
		__NEW(source, Texts_TextDesc);
		Texts_Open(source, S.s, 256);
		Texts_WriteString(&Miscellaneous_W, Texts_Writer__typ, (CHAR*)" counting", (LONGINT)10);
		Texts_Append(T, Miscellaneous_W.buf);
		Texts_OpenReader(&R, Texts_Reader__typ, source, 0);
		nofLines = 0;
		i = 0;
		while (i < source->len) {
			Texts_Read(&R, Texts_Reader__typ, &ch);
			i += 1;
			if (ch == 0x0d) {
				for (;;) {
					Texts_Read(&R, Texts_Reader__typ, &ch);
					i += 1;
					if (ch != 0x0d) {
						break;
					}
				}
				nofLines += 1;
			}
		}
		Texts_Write(&Miscellaneous_W, Texts_Writer__typ, ' ');
		Texts_WriteInt(&Miscellaneous_W, Texts_Writer__typ, nofLines, 1);
		Texts_WriteLn(&Miscellaneous_W, Texts_Writer__typ);
		Texts_Append(T, Miscellaneous_W.buf);
		totalLines = totalLines + nofLines;
		Texts_Scan(&S, Texts_Scanner__typ);
	}
	Texts_WriteInt(&Miscellaneous_W, Texts_Writer__typ, totalLines, 1);
	Texts_WriteLn(&Miscellaneous_W, Texts_Writer__typ);
	Texts_Append(T, Miscellaneous_W.buf);
}

void Miscellaneous_Cleanup (void)
{
	Oberon_ParList par = NIL;
	Texts_Reader R = {0};
	Texts_Scanner S = {0};
	Texts_Text source = NIL;
	Files_File g = NIL;
	Files_Rider Wg = {0};
	CHAR ch = 0;
	par = Oberon_Par;
	Texts_WriteString(&Miscellaneous_W, Texts_Writer__typ, (CHAR*)"Miscellaneous.Cleanup", (LONGINT)22);
	Texts_WriteLn(&Miscellaneous_W, Texts_Writer__typ);
	Texts_Append(Oberon_Log, Miscellaneous_W.buf);
	Texts_OpenScanner(&S, Texts_Scanner__typ, par->text, par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	while (S.class == 1) {
		Texts_WriteString(&Miscellaneous_W, Texts_Writer__typ, S.s, 256);
		Texts_Append(Oberon_Log, Miscellaneous_W.buf);
		__NEW(source, Texts_TextDesc);
		Texts_Open(source, S.s, 256);
		Texts_WriteString(&Miscellaneous_W, Texts_Writer__typ, (CHAR*)" cleaning up", (LONGINT)13);
		Texts_Append(Oberon_Log, Miscellaneous_W.buf);
		g = Files_New(S.s, 256);
		Files_Set(&Wg, Files_Rider__typ, g, 0);
		Texts_OpenReader(&R, Texts_Reader__typ, source, 0);
		Texts_Read(&R, Texts_Reader__typ, &ch);
		while (ch != 0x00) {
			if ((ch >= ' ' && ch < 0x7f || ch == 0x09) || ch == 0x0d) {
				if (ch == 0x0d) {
					Files_Write(&Wg, Files_Rider__typ, 0x0a);
				} else {
					Files_Write(&Wg, Files_Rider__typ, ch);
				}
			}
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		Files_Register(g);
		Texts_WriteLn(&Miscellaneous_W, Texts_Writer__typ);
		Texts_Append(Oberon_Log, Miscellaneous_W.buf);
		Texts_Scan(&S, Texts_Scanner__typ);
	}
}

void Miscellaneous_ConvertBlanks (void)
{
	Oberon_ParList par = NIL;
	Texts_Reader R = {0};
	Texts_Scanner S = {0};
	Texts_Text source = NIL;
	Files_File g = NIL;
	Files_Rider Wg = {0};
	CHAR ch = 0;
	par = Oberon_Par;
	Texts_WriteString(&Miscellaneous_W, Texts_Writer__typ, (CHAR*)"Miscellaneous.ConvertBlanks", (LONGINT)28);
	Texts_WriteLn(&Miscellaneous_W, Texts_Writer__typ);
	Texts_Append(Oberon_Log, Miscellaneous_W.buf);
	Texts_OpenScanner(&S, Texts_Scanner__typ, par->text, par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	while (S.class == 1) {
		Texts_WriteString(&Miscellaneous_W, Texts_Writer__typ, S.s, 256);
		Texts_Append(Oberon_Log, Miscellaneous_W.buf);
		__NEW(source, Texts_TextDesc);
		Texts_Open(source, S.s, 256);
		if (source->len != 0) {
			Texts_WriteString(&Miscellaneous_W, Texts_Writer__typ, (CHAR*)" converting", (LONGINT)12);
			Texts_Append(Oberon_Log, Miscellaneous_W.buf);
			g = Files_New(S.s, 256);
			Texts_OpenReader(&R, Texts_Reader__typ, source, 0);
			Files_Set(&Wg, Files_Rider__typ, g, 0);
			for (;;) {
				for (;;) {
					Texts_Read(&R, Texts_Reader__typ, &ch);
					if (ch != ' ') {
						break;
					}
					Texts_Read(&R, Texts_Reader__typ, &ch);
					if (ch != ' ') {
						Files_Write(&Wg, Files_Rider__typ, ' ');
						break;
					}
					Files_Write(&Wg, Files_Rider__typ, 0x09);
				}
				while (ch != 0x00 && ch != 0x0d) {
					Files_Write(&Wg, Files_Rider__typ, ch);
					Texts_Read(&R, Texts_Reader__typ, &ch);
				}
				if (ch == 0x00) {
					break;
				}
				Files_Write(&Wg, Files_Rider__typ, 0x0a);
			}
			Files_Register(g);
		} else {
			Texts_WriteString(&Miscellaneous_W, Texts_Writer__typ, (CHAR*)" not found", (LONGINT)11);
		}
		Texts_WriteLn(&Miscellaneous_W, Texts_Writer__typ);
		Texts_Append(Oberon_Log, Miscellaneous_W.buf);
		Texts_Scan(&S, Texts_Scanner__typ);
	}
}

void Miscellaneous_ConvertTabs (void)
{
	Oberon_ParList par = NIL;
	Texts_Reader R = {0};
	Texts_Scanner S = {0};
	Texts_Text source = NIL;
	Files_File g = NIL;
	Files_Rider Wg = {0};
	CHAR ch = 0;
	par = Oberon_Par;
	Texts_WriteString(&Miscellaneous_W, Texts_Writer__typ, (CHAR*)"Miscellaneous.ConvertTabs", (LONGINT)26);
	Texts_WriteLn(&Miscellaneous_W, Texts_Writer__typ);
	Texts_Append(Oberon_Log, Miscellaneous_W.buf);
	Texts_OpenScanner(&S, Texts_Scanner__typ, par->text, par->pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	while (S.class == 1) {
		Texts_WriteString(&Miscellaneous_W, Texts_Writer__typ, S.s, 256);
		Texts_Append(Oberon_Log, Miscellaneous_W.buf);
		__NEW(source, Texts_TextDesc);
		Texts_Open(source, S.s, 256);
		if (source->len != 0) {
			Texts_WriteString(&Miscellaneous_W, Texts_Writer__typ, (CHAR*)" reconverting", (LONGINT)14);
			Texts_Append(Oberon_Log, Miscellaneous_W.buf);
			g = Files_New(S.s, 256);
			Texts_OpenReader(&R, Texts_Reader__typ, source, 0);
			Files_Set(&Wg, Files_Rider__typ, g, 0);
			for (;;) {
				for (;;) {
					Texts_Read(&R, Texts_Reader__typ, &ch);
					if (ch != 0x09) {
						break;
					}
					Files_Write(&Wg, Files_Rider__typ, ' ');
					Files_Write(&Wg, Files_Rider__typ, ' ');
				}
				while (ch != 0x00 && ch != 0x0d) {
					Files_Write(&Wg, Files_Rider__typ, ch);
					Texts_Read(&R, Texts_Reader__typ, &ch);
				}
				if (ch == 0x00) {
					break;
				}
				Files_Write(&Wg, Files_Rider__typ, 0x0a);
			}
			Files_Register(g);
		} else {
			Texts_WriteString(&Miscellaneous_W, Texts_Writer__typ, (CHAR*)" not found", (LONGINT)11);
		}
		Texts_WriteLn(&Miscellaneous_W, Texts_Writer__typ);
		Texts_Append(Oberon_Log, Miscellaneous_W.buf);
		Texts_Scan(&S, Texts_Scanner__typ);
	}
}

static void Miscellaneous_ClearSelection (void)
{
	Miscellaneous_ownSelection = 0;
}

static void Miscellaneous_CopyOverSelection (void)
{
	Oberon_CopyOverMsg M = {0};
	if (Miscellaneous_scrap->len > 0) {
		M.text = Miscellaneous_scrap;
		M.beg = 0;
		M.end = Miscellaneous_scrap->len;
		(*Oberon_FocusViewer->handle)((void*)Oberon_FocusViewer, (void*)&M, Oberon_CopyOverMsg__typ);
	}
}

static void Miscellaneous_TakeSelection (void)
{
	Miscellaneous_ownSelection = 1;
	X11_SetSelectionOwner(X11_display, 1, X11_primary, X11_lastEventTime);
	if (X11_GetSelectionOwner(X11_display, 1) != X11_primary) {
		Miscellaneous_ClearSelection();
	}
}

static void Miscellaneous_RequestSelection (void)
{
	X11_ConvertSelection(X11_display, 1, 31, Miscellaneous_myProperty, X11_primary, X11_lastEventTime);
}

static void Miscellaneous_SendSelection (X11_SelectionRequestEvent *event, LONGINT *event__typ)
{
	X11_SelectionEvent ev = {0};
	Texts_Reader R = {0};
	LONGINT i = 0;
	CHAR ch = 0;
	ev.type = 31;
	ev.requestor = (*event).requestor;
	ev.selection = (*event).selection;
	ev.target = (*event).target;
	ev.time = (*event).time;
	if ((*event).selection == 1 && (*event).target == 31) {
		ev.property = (*event).property;
		Miscellaneous_selectionData = __NEWARR(NIL, 1, 1, 1, 1, (LONGINT)(Miscellaneous_scrap->len + 1));
		Texts_OpenReader(&R, Texts_Reader__typ, Miscellaneous_scrap, 0);
		Texts_Read(&R, Texts_Reader__typ, &ch);
		i = 0;
		while (!R.eot) {
			if (ch == 0x0d) {
				ch = 0x0a;
			}
			(Miscellaneous_selectionData->data)[__X(i, Miscellaneous_selectionData->len[0])] = ch;
			i += 1;
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		(Miscellaneous_selectionData->data)[__X(i, Miscellaneous_selectionData->len[0])] = 0x00;
		X11_ChangeProperty(X11_display, ev.requestor, ev.property, ev.target, 8, 0, (LONGINT)&(Miscellaneous_selectionData->data)[0], i);
	} else {
		ev.property = 0;
	}
	X11_SendEvent(X11_display, ev.requestor, 0, 0, (LONGINT)&ev);
}

static void Miscellaneous_ReceiveSelection (X11_SelectionEvent *event, LONGINT *event__typ)
{
	LONGINT type = 0, format = 0, len = 0, after = 0, prop = 0, adr = 0;
	CHAR ch = 0;
	Texts_Delete(Miscellaneous_scrap, 0, Miscellaneous_scrap->len);
	if ((*event).selection == 1 && (*event).property == Miscellaneous_myProperty) {
		X11_GetWindowProperty(X11_display, (*event).requestor, (*event).property, 0, 8192, 0, (*event).target, &type, &format, &len, &after, &prop);
		adr = prop;
		if (len > 0) {
			while (len > 0) {
				__GET(adr, ch, CHAR);
				adr += 1;
				len -= 1;
				if (ch == 0x0a) {
					ch = 0x0d;
				}
				if (ch != 0x00) {
					Texts_Write(&Miscellaneous_W, Texts_Writer__typ, ch);
				}
			}
			Texts_Append(Miscellaneous_scrap, Miscellaneous_W.buf);
			X11_Free(prop);
			X11_DeleteProperty(X11_display, (*event).requestor, (*event).property);
		}
		Miscellaneous_CopyOverSelection();
	}
}

void Miscellaneous_Cut (void)
{
	Texts_Text t = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_Delete(Miscellaneous_scrap, 0, Miscellaneous_scrap->len);
	Oberon_GetSelection(&t, &beg, &end, &time);
	if (time >= 0) {
		Texts_Save(t, beg, end, Miscellaneous_B);
		Texts_Delete(t, beg, end);
		Texts_Append(Miscellaneous_scrap, Miscellaneous_B);
	}
	Miscellaneous_TakeSelection();
}

void Miscellaneous_Copy (void)
{
	Texts_Text t = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_Delete(Miscellaneous_scrap, 0, Miscellaneous_scrap->len);
	Oberon_GetSelection(&t, &beg, &end, &time);
	if (time >= 0) {
		Texts_Save(t, beg, end, Miscellaneous_B);
		Texts_Append(Miscellaneous_scrap, Miscellaneous_B);
	}
	Miscellaneous_TakeSelection();
}

void Miscellaneous_Paste (void)
{
	if (Miscellaneous_ownSelection) {
		Miscellaneous_CopyOverSelection();
	} else {
		Miscellaneous_RequestSelection();
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&Miscellaneous_S, Texts_Scanner__typ, 336, 1, P);
	P(Miscellaneous_T);
	__ENUMR(&Miscellaneous_W, Texts_Writer__typ, 36, 1, P);
	P(Miscellaneous_dir);
	P(Miscellaneous_scrap);
	P(Miscellaneous_B);
	P(Miscellaneous_selectionData);
}

__TDESC(Miscellaneous_FileDesc, 1, 0) = {__TDFLDS("FileDesc", 32), {-4}};
__TDESC(Miscellaneous_FileHandle, 1, 2) = {__TDFLDS("FileHandle", 40), {0, 4, -12}};

export void *Miscellaneous__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__IMPORT(X11);
	__REGMOD(Miscellaneous, EnumPtrs);
	__REGCMD("Cleanup", Miscellaneous_Cleanup);
	__REGCMD("ConvertBlanks", Miscellaneous_ConvertBlanks);
	__REGCMD("ConvertTabs", Miscellaneous_ConvertTabs);
	__REGCMD("Copy", Miscellaneous_Copy);
	__REGCMD("CountLines", Miscellaneous_CountLines);
	__REGCMD("Cut", Miscellaneous_Cut);
	__REGCMD("Paste", Miscellaneous_Paste);
	__INITYP(Miscellaneous_FileDesc, Miscellaneous_FileDesc, 0);
	__INITYP(Miscellaneous_FileHandle, Miscellaneous_FileHandle, 0);
/* BEGIN */
	Texts_OpenWriter(&Miscellaneous_W, Texts_Writer__typ);
	__NEW(Miscellaneous_B, Texts_BufDesc);
	Texts_OpenBuf(Miscellaneous_B);
	__NEW(Miscellaneous_scrap, Texts_TextDesc);
	Miscellaneous_scrap->notify = TextFrames_NotifyDisplay;
	Texts_Open(Miscellaneous_scrap, (CHAR*)"", (LONGINT)1);
	X11_SendSelection = Miscellaneous_SendSelection;
	X11_ReceiveSelection = Miscellaneous_ReceiveSelection;
	X11_ClearSelection = Miscellaneous_ClearSelection;
	Miscellaneous_ClearSelection();
	Miscellaneous_myProperty = X11_InternAtom(X11_display, (LONGINT)"OberonProperty", 0);
	__ENDMOD;
}
