/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "DialogCheckBoxes.h"
#include "DialogComboBoxes.h"
#include "DialogRadioButtons.h"
#include "DialogStaticTexts.h"
#include "DialogTexts.h"
#include "Dialogs.h"
#include "Display.h"
#include "Files.h"
#include "In.h"
#include "MathL.h"
#include "MenuViewers.h"
#include "MoreMathL.h"
#include "Oberon.h"
#include "Out.h"
#include "ParcElems.h"
#include "StyleElems.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Types.h"
#include "Viewers.h"
#include "XIn.h"

typedef
	CHAR MyUI_Operation[10];

typedef
	struct MyUI_StyleElemDesc *MyUI_StyleElem;

typedef
	struct MyUI_StyleElemDesc {
		StyleElems_Parc styleElem;
		MyUI_StyleElem next;
	} MyUI_StyleElemDesc;

typedef
	struct MyUI_VarDesc *MyUI_Var;

typedef
	struct MyUI_VarDesc {
		CHAR name[32];
		LONGREAL value;
		MyUI_Var next;
	} MyUI_VarDesc;


static Viewers_Viewer MyUI_vwr;
static TextFrames_Location MyUI_selbeg, MyUI_selend;
static MyUI_StyleElem MyUI_styleElems;
static Dialogs_Panel MyUI_p;
static Dialogs_Object MyUI_o;
static CHAR MyUI_command[32];
static Oberon_ParList MyUI_par;
static Texts_Text MyUI_oldLog, MyUI_newLog;
static Texts_Writer MyUI_w;
export INTEGER MyUI_res;
static BOOLEAN MyUI_doSearch;
static LONGREAL MyUI_oldValue, MyUI_value, MyUI_commaPos;
static MyUI_Operation MyUI_oldOp, MyUI_op;
static BOOLEAN MyUI_newNumber;
static MyUI_Var MyUI_vars;

export LONGINT *MyUI_StyleElemDesc__typ;
export LONGINT *MyUI_VarDesc__typ;

export void MyUI_AddVar (CHAR *n, LONGINT n__len, LONGREAL value);
export void MyUI_Adjust (void);
export void MyUI_Break (void);
static void MyUI_Call (CHAR *s, LONGINT s__len);
static void MyUI_ChangeValue (CHAR *s, LONGINT s__len, BOOLEAN on);
export void MyUI_Clear (void);
export void MyUI_Columns (void);
export void MyUI_Comma (void);
static void MyUI_Comp (void);
export void MyUI_Compile (void);
static void MyUI_Delete (CHAR *s, LONGINT s__len, Texts_Text *txt);
export void MyUI_DoHALT (void);
export void MyUI_First (void);
export void MyUI_FirstReset (void);
export void MyUI_FoldsCompile (void);
export void MyUI_GetAdjust (void);
export void MyUI_GetAll (void);
export void MyUI_GetBreak (void);
export void MyUI_GetColumns (void);
export void MyUI_GetFirst (void);
export void MyUI_GetGrid (void);
export void MyUI_GetLead (void);
export void MyUI_GetLeft (void);
export void MyUI_GetLine (void);
export void MyUI_GetRight (void);
export void MyUI_GetStyles (void);
export void MyUI_GetTabs (void);
export void MyUI_GetType (void);
export void MyUI_GetWidth (void);
export void MyUI_Grid (void);
export void MyUI_InitCalc (void);
static void MyUI_InitPar (void);
export void MyUI_InitPrintDlg (void);
export void MyUI_Lead (void);
export void MyUI_LeadReset (void);
export void MyUI_Left (void);
export void MyUI_LeftReset (void);
export void MyUI_Line (void);
export void MyUI_LineReset (void);
export void MyUI_Num (void);
static BOOLEAN MyUI_On (CHAR *s, LONGINT s__len);
export void MyUI_Op (void);
export void MyUI_Print (void);
export void MyUI_Replace (void);
export void MyUI_Reset (void);
export void MyUI_Right (void);
export void MyUI_RightReset (void);
static void MyUI_Save (CHAR *s, LONGINT s__len);
export void MyUI_SaveOptions (void);
static void MyUI_Scan (Texts_Scanner *s, LONGINT *s__typ, CHAR *st, LONGINT st__len);
export void MyUI_Search (void);
export void MyUI_SearchReset (void);
export void MyUI_SetDefaultOptions (void);
export void MyUI_SetVar (void);
export void MyUI_ShowNumber (void);
static void MyUI_StoreLog (void);
export void MyUI_Style (void);
export void MyUI_Tabs (void);
export void MyUI_TabsReset1 (void);
export void MyUI_TabsReset2 (void);
static StyleElems_Parc MyUI_ThisStyleElem (CHAR *n, LONGINT n__len);
export void MyUI_Variable (void);
export void MyUI_Width (void);
export void MyUI_WidthReset (void);
static void MyUI_Write (CHAR *s, LONGINT s__len);
static void MyUI_WriteDefault (CHAR *s, LONGINT s__len);


void MyUI_DoHALT (void)
{
	MyUI_StyleElem elem = NIL;
	elem = MyUI_styleElems;
	while (elem != NIL) {
		Out_Ln();
		Out_String(elem->styleElem->name, 32);
		elem = elem->next;
	}
	__HALT(90);
}

static void MyUI_InitPar (void)
{
	MyUI_p = Dialogs_cmdPanel;
	__NEW(MyUI_par, Oberon_ParRec);
	MyUI_par->text = TextFrames_Text((CHAR*)"", (LONGINT)1);
}

static void MyUI_Call (CHAR *s, LONGINT s__len)
{
	__DUP(s, s__len, CHAR);
	Texts_Append(MyUI_par->text, MyUI_w.buf);
	MyUI_par->frame = Oberon_Par->frame;
	MyUI_par->vwr = Oberon_Par->vwr;
	Oberon_Call(s, s__len, MyUI_par, 0, &MyUI_res);
	__DEL(s);
}

static void MyUI_StoreLog (void)
{
	MyUI_newLog = TextFrames_Text((CHAR*)"", (LONGINT)1);
	MyUI_oldLog = Oberon_Log;
	Oberon_Log = MyUI_newLog;
}

static BOOLEAN MyUI_On (CHAR *s, LONGINT s__len)
{
	Dialogs_Object o = NIL;
	__DUP(s, s__len, CHAR);
	o = __Dialogs_Panel_NamedObject(MyUI_p, s, s__len);
	if (__ISP(o, DialogRadioButtons_ItemDesc, 1)) {
		__DEL(s);
		return (*(DialogRadioButtons_Item*)&o)->on;
	} else if (__ISP(o, DialogCheckBoxes_ItemDesc, 1)) {
		__DEL(s);
		return (*(DialogCheckBoxes_Item*)&o)->on;
	} else {
		__DEL(s);
		return 0;
	}
	__RETCHK;
}

static void MyUI_ChangeValue (CHAR *s, LONGINT s__len, BOOLEAN on)
{
	Dialogs_Object o = NIL;
	__DUP(s, s__len, CHAR);
	o = __Dialogs_Panel_NamedObject(MyUI_p, s, s__len);
	if (o != NIL) {
		if (__ISP(o, DialogRadioButtons_ItemDesc, 1)) {
			__DialogRadioButtons_Item_ChangeValue((*(DialogRadioButtons_Item*)&o), on);
		} else if (__ISP(o, DialogCheckBoxes_ItemDesc, 1)) {
			__DialogCheckBoxes_Item_ChangeValue((*(DialogCheckBoxes_Item*)&o), on);
		} else {
			__HALT(99);
		}
	}
	__DEL(s);
}

static void MyUI_Write (CHAR *s, LONGINT s__len)
{
	__DUP(s, s__len, CHAR);
	if (MyUI_On(s, s__len)) {
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, s, s__len);
	}
	__DEL(s);
}

static void MyUI_WriteDefault (CHAR *s, LONGINT s__len)
{
	__DUP(s, s__len, CHAR);
	if (MyUI_On(s, s__len)) {
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"default", (LONGINT)8);
	}
	__DEL(s);
}

static void MyUI_Scan (Texts_Scanner *s, LONGINT *s__typ, CHAR *st, LONGINT st__len)
{
	__DUP(st, st__len, CHAR);
	Texts_OpenScanner(&*s, s__typ, MyUI_newLog, 0);
	Texts_Scan(&*s, s__typ);
	if (__STRCMP(st, "int") == 0) {
		while ((*s).class != 3 && !(*s).eot) {
			Texts_Scan(&*s, s__typ);
		}
	} else {
		while ((!(*s).eot && (*s).class != 1) && __STRCMP((*s).s, st) != 0) {
			Texts_Scan(&*s, s__typ);
		}
	}
	__DEL(st);
}

static void MyUI_Delete (CHAR *s, LONGINT s__len, Texts_Text *txt)
{
	Dialogs_Object o = NIL;
	__DUP(s, s__len, CHAR);
	o = __Dialogs_Panel_NamedObject(MyUI_p, s, s__len);
	*txt = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
	Texts_Delete(*txt, 0, (*txt)->len);
	__DEL(s);
}

static void MyUI_Save (CHAR *s, LONGINT s__len)
{
	Texts_Text txt = NIL;
	Dialogs_Object o = NIL;
	__DUP(s, s__len, CHAR);
	o = __Dialogs_Panel_NamedObject(MyUI_p, s, s__len);
	txt = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
	Texts_Save(txt, 0, txt->len, MyUI_w.buf);
	__DEL(s);
}

static struct Comp__9 {
	Texts_Text *t;
	CHAR (*opt)[20];
	INTEGER *res;
	LONGINT *beg, *end;
	BOOLEAN *findPC;
	INTEGER *i, *j;
	struct Comp__9 *lnk;
} *Comp__9_s;

static void Do__10 (void);

static void Do__10 (void)
{
	CHAR ch = 0;
	BOOLEAN error = 0;
	LONGINT fbeg = 0, fend = 0, ftime = 0, breakpc = 0;
	Texts_Scanner scanner = {0}, fs = {0};
	Texts_Reader sourceR = {0};
	INTEGER line = 0;
	Texts_Text ft = NIL;
	Texts_Writer fw = {0};
	error = 0;
	Texts_OpenScanner(&scanner, Texts_Scanner__typ, *Comp__9_s->t, *Comp__9_s->beg);
	Texts_Scan(&scanner, Texts_Scanner__typ);
	while ((__IN(scanner.class, 0x06) && Texts_Pos((void*)&scanner, Texts_Scanner__typ) - (LONGINT)scanner.len <= *Comp__9_s->end) && !error) {
		Texts_OpenWriter(&MyUI_w, Texts_Writer__typ);
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, scanner.s, 256);
		line = scanner.line;
		(*Comp__9_s->opt)[__X(*Comp__9_s->j, 20)] = 0x00;
		*Comp__9_s->i = *Comp__9_s->j;
		Texts_Scan(&scanner, Texts_Scanner__typ);
		if ((scanner.line == line && scanner.class == 6) && scanner.c == '/') {
			ch = scanner.nextCh;
			while ((ch >= '0' && ch <= '9' || ch >= 'a' && ch <= 'z') && *Comp__9_s->i < 19) {
				(*Comp__9_s->opt)[__X(*Comp__9_s->i, 20)] = ch;
				*Comp__9_s->i += 1;
				if (ch == 'f') {
					*Comp__9_s->findPC = !*Comp__9_s->findPC;
				}
				Texts_Read((void*)&scanner, Texts_Scanner__typ, &ch);
			}
			scanner.nextCh = ch;
			Texts_Scan(&scanner, Texts_Scanner__typ);
		}
		(*Comp__9_s->opt)[__X(*Comp__9_s->i, 20)] = 0x00;
		MyUI_par->frame = Oberon_Par->frame;
		MyUI_par->vwr = Oberon_Par->vwr;
		if (*Comp__9_s->findPC) {
			for (;;) {
				Oberon_GetSelection(&ft, &fbeg, &fend, &ftime);
				if (ftime >= 0) {
					Texts_OpenScanner(&fs, Texts_Scanner__typ, ft, fbeg);
					Texts_Scan(&fs, Texts_Scanner__typ);
					if (fs.class == 3) {
						breakpc = fs.i;
						break;
					}
				}
				Texts_WriteString(&fw, Texts_Writer__typ, (CHAR*)"  pc not selected", (LONGINT)18);
				Texts_WriteLn(&fw, Texts_Writer__typ);
				Texts_Append(Oberon_Log, fw.buf);
				error = 1;
				return;
			}
			Texts_OpenReader(&sourceR, Texts_Reader__typ, *Comp__9_s->t, *Comp__9_s->beg);
		} else {
			Texts_Write(&MyUI_w, Texts_Writer__typ, '/');
			Texts_WriteString(&MyUI_w, Texts_Writer__typ, *Comp__9_s->opt, 20);
			Texts_Append(MyUI_par->text, MyUI_w.buf);
			Oberon_Call(MyUI_command, 32, MyUI_par, 0, &*Comp__9_s->res);
		}
	}
}

static void MyUI_Comp (void)
{
	Texts_Text t = NIL;
	CHAR opt[20];
	INTEGER res = 0;
	LONGINT beg = 0, end = 0, time = 0;
	BOOLEAN findPC = 0;
	INTEGER i = 0, j = 0;
	struct Comp__9 _s;
	_s.t = &t;
	_s.opt = (void*)opt;
	_s.res = &res;
	_s.beg = &beg;
	_s.end = &end;
	_s.findPC = &findPC;
	_s.i = &i;
	_s.j = &j;
	_s.lnk = Comp__9_s;
	Comp__9_s = &_s;
	MyUI_InitPar();
	i = 0;
	if (MyUI_On((CHAR*)"idx", (LONGINT)4)) {
		opt[__X(i, 20)] = 'x';
		i += 1;
	}
	if (MyUI_On((CHAR*)"type", (LONGINT)5)) {
		opt[__X(i, 20)] = 't';
		i += 1;
	}
	if (MyUI_On((CHAR*)"nil", (LONGINT)4)) {
		opt[__X(i, 20)] = 'n';
		i += 1;
	}
	if (MyUI_On((CHAR*)"init", (LONGINT)5)) {
		opt[__X(i, 20)] = 'p';
		i += 1;
	}
	if (MyUI_On((CHAR*)"assert", (LONGINT)7)) {
		opt[__X(i, 20)] = 's';
		i += 1;
	}
	if (MyUI_On((CHAR*)"pc", (LONGINT)3)) {
		findPC = 1;
		opt[__X(i, 20)] = 'f';
		i += 1;
	} else {
		findPC = 0;
	}
	opt[__X(i, 20)] = 0x00;
	j = i;
	if (MyUI_On((CHAR*)"mrs", (LONGINT)4)) {
		Oberon_GetSelection(&t, &beg, &end, &time);
		if (findPC) {
			MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"tpc", (LONGINT)4);
			t = __DialogTexts_Item_GetText(__GUARDP(MyUI_o, DialogTexts_ItemDesc, 1));
			__DialogTexts_Item_SetSelection(__GUARDP(MyUI_o, DialogTexts_ItemDesc, 1), 0, t->len);
		}
		if (time >= 0) {
			Do__10();
		}
	}
	if (findPC) {
		MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"tpc", (LONGINT)4);
		t = __DialogTexts_Item_GetText(__GUARDP(MyUI_o, DialogTexts_ItemDesc, 1));
		__DialogTexts_Item_SetSelection(__GUARDP(MyUI_o, DialogTexts_ItemDesc, 1), 0, t->len);
	}
	if (MyUI_On((CHAR*)"marked", (LONGINT)7)) {
		Texts_Write(&MyUI_w, Texts_Writer__typ, '*');
		Texts_Write(&MyUI_w, Texts_Writer__typ, '/');
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, opt, 20);
		Texts_Append(MyUI_par->text, MyUI_w.buf);
		MyUI_par->vwr = Oberon_MarkedViewer();
		if ((MyUI_par->vwr != NIL && MyUI_par->vwr->dsc != NIL) && __ISP(MyUI_par->vwr->dsc->next, TextFrames_FrameDesc, 1)) {
			MyUI_par->frame = (Display_Frame)__GUARDP(MyUI_par->vwr->dsc->next, TextFrames_FrameDesc, 1);
		} else {
			MyUI_par->frame = NIL;
		}
		Oberon_Call(MyUI_command, 32, MyUI_par, 0, &res);
	}
	if (MyUI_On((CHAR*)"list", (LONGINT)5)) {
		MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"files", (LONGINT)6);
		t = __DialogTexts_Item_GetText(__GUARDP(MyUI_o, DialogTexts_ItemDesc, 1));
		if (t->len > 0) {
			beg = 0;
			end = t->len;
			Do__10();
		}
	}
	if (findPC) {
		MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"tpc", (LONGINT)4);
		__DialogTexts_Item_RemoveSelection(__GUARDP(MyUI_o, DialogTexts_ItemDesc, 1));
	}
	Comp__9_s = _s.lnk;
}

void MyUI_Compile (void)
{
	__MOVE("Ofront.Translate", MyUI_command, 17);
	MyUI_Comp();
}

void MyUI_FoldsCompile (void)
{
	__MOVE("Folds.Compile", MyUI_command, 14);
	MyUI_Comp();
}

void MyUI_Adjust (void)
{
	MyUI_InitPar();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"adjust ", (LONGINT)8);
	MyUI_Write((CHAR*)"block", (LONGINT)6);
	MyUI_Write((CHAR*)"center", (LONGINT)7);
	MyUI_Write((CHAR*)"left", (LONGINT)5);
	MyUI_Write((CHAR*)"right", (LONGINT)6);
	MyUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
}

void MyUI_GetAdjust (void)
{
	Texts_Scanner s = {0};
	MyUI_InitPar();
	MyUI_StoreLog();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"adjust", (LONGINT)7);
	MyUI_Call((CHAR*)"Edit.Get", (LONGINT)9);
	if (MyUI_res == 0) {
		MyUI_Scan(&s, Texts_Scanner__typ, (CHAR*)"adjust", (LONGINT)7);
		Texts_Scan(&s, Texts_Scanner__typ);
		Texts_Scan(&s, Texts_Scanner__typ);
		MyUI_ChangeValue(s.s, 256, 1);
	}
	Oberon_Log = MyUI_oldLog;
}

void MyUI_Break (void)
{
	MyUI_InitPar();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"break ", (LONGINT)7);
	MyUI_Write((CHAR*)"before", (LONGINT)7);
	MyUI_Write((CHAR*)"normal", (LONGINT)7);
	MyUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
}

void MyUI_GetBreak (void)
{
	Texts_Scanner s = {0};
	MyUI_InitPar();
	MyUI_StoreLog();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"break", (LONGINT)6);
	MyUI_Call((CHAR*)"Edit.Get", (LONGINT)9);
	if (MyUI_res == 0) {
		MyUI_Scan(&s, Texts_Scanner__typ, (CHAR*)"break", (LONGINT)6);
		Texts_Scan(&s, Texts_Scanner__typ);
		Texts_Scan(&s, Texts_Scanner__typ);
		MyUI_ChangeValue(s.s, 256, 1);
	}
	Oberon_Log = MyUI_oldLog;
}

void MyUI_Columns (void)
{
	MyUI_InitPar();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"columns ", (LONGINT)9);
	if (MyUI_On((CHAR*)"one", (LONGINT)4)) {
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"1", (LONGINT)2);
	} else if (MyUI_On((CHAR*)"two", (LONGINT)4)) {
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"2", (LONGINT)2);
	}
	MyUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
}

void MyUI_GetColumns (void)
{
	Texts_Scanner s = {0};
	MyUI_InitPar();
	MyUI_StoreLog();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"columns", (LONGINT)8);
	MyUI_Call((CHAR*)"Edit.Get", (LONGINT)9);
	if (MyUI_res == 0) {
		Texts_OpenScanner(&s, Texts_Scanner__typ, MyUI_newLog, 0);
		Texts_Scan(&s, Texts_Scanner__typ);
		while (!s.eot && s.class != 3) {
			Texts_Scan(&s, Texts_Scanner__typ);
		}
		if (s.i == 1) {
			MyUI_ChangeValue((CHAR*)"one", (LONGINT)4, 1);
		} else if (s.i == 2) {
			MyUI_ChangeValue((CHAR*)"two", (LONGINT)4, 1);
		}
	}
	Oberon_Log = MyUI_oldLog;
}

void MyUI_First (void)
{
	INTEGER number = 0;
	MyUI_InitPar();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"first ", (LONGINT)7);
	MyUI_WriteDefault((CHAR*)"firstdefault", (LONGINT)13);
	if (MyUI_On((CHAR*)"firstnumber", (LONGINT)12)) {
		In_Open();
		In_Int(&number);
		Texts_WriteInt(&MyUI_w, Texts_Writer__typ, number, 0);
	}
	MyUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
}

void MyUI_GetFirst (void)
{
	Texts_Scanner s = {0};
	Texts_Text txt = NIL;
	MyUI_InitPar();
	MyUI_StoreLog();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"first", (LONGINT)6);
	MyUI_Call((CHAR*)"Edit.Get", (LONGINT)9);
	if (MyUI_res == 0) {
		MyUI_Scan(&s, Texts_Scanner__typ, (CHAR*)"int", (LONGINT)4);
		MyUI_Delete((CHAR*)"tfirstnumber", (LONGINT)13, &txt);
		if (s.class == 3) {
			Texts_WriteInt(&MyUI_w, Texts_Writer__typ, s.i, 0);
			Texts_Append(txt, MyUI_w.buf);
			MyUI_ChangeValue((CHAR*)"firstnumber", (LONGINT)12, 1);
		} else {
			MyUI_ChangeValue((CHAR*)"firstnumber", (LONGINT)12, 0);
			MyUI_ChangeValue((CHAR*)"firstdefault", (LONGINT)13, 0);
		}
	}
	Oberon_Log = MyUI_oldLog;
}

void MyUI_FirstReset (void)
{
	MyUI_p = Dialogs_cmdPanel;
	MyUI_ChangeValue((CHAR*)"firstnumber", (LONGINT)12, 0);
}

void MyUI_Grid (void)
{
	MyUI_InitPar();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"grid ", (LONGINT)6);
	if (MyUI_On((CHAR*)"grid", (LONGINT)5)) {
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"on", (LONGINT)3);
	} else {
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"off", (LONGINT)4);
	}
	MyUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
}

void MyUI_GetGrid (void)
{
	Texts_Scanner s = {0};
	MyUI_InitPar();
	MyUI_StoreLog();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"grid", (LONGINT)5);
	MyUI_Call((CHAR*)"Edit.Get", (LONGINT)9);
	if (MyUI_res == 0) {
		Texts_OpenScanner(&s, Texts_Scanner__typ, MyUI_newLog, 0);
		Texts_Scan(&s, Texts_Scanner__typ);
		while ((!s.eot && __STRCMP(s.s, "on") != 0) && __STRCMP(s.s, "off") != 0) {
			Texts_Scan(&s, Texts_Scanner__typ);
		}
		if (__STRCMP(s.s, "on") == 0) {
			MyUI_ChangeValue((CHAR*)"grid", (LONGINT)5, 1);
		} else {
			MyUI_ChangeValue((CHAR*)"grid", (LONGINT)5, 0);
		}
	}
	Oberon_Log = MyUI_oldLog;
}

void MyUI_Lead (void)
{
	MyUI_InitPar();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"lead ", (LONGINT)6);
	MyUI_WriteDefault((CHAR*)"leaddef", (LONGINT)8);
	if (MyUI_On((CHAR*)"leadnumber", (LONGINT)11)) {
		MyUI_Save((CHAR*)"tleadnumber", (LONGINT)12);
	}
	MyUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
}

void MyUI_GetLead (void)
{
	Texts_Scanner s = {0};
	Texts_Text txt = NIL;
	MyUI_InitPar();
	MyUI_StoreLog();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"lead", (LONGINT)5);
	MyUI_Call((CHAR*)"Edit.Get", (LONGINT)9);
	if (MyUI_res == 0) {
		MyUI_Scan(&s, Texts_Scanner__typ, (CHAR*)"int", (LONGINT)4);
		MyUI_Delete((CHAR*)"tleadnumber", (LONGINT)12, &txt);
		if (s.class == 3) {
			Texts_WriteInt(&MyUI_w, Texts_Writer__typ, s.i, 0);
			Texts_Append(txt, MyUI_w.buf);
			MyUI_ChangeValue((CHAR*)"leadnumber", (LONGINT)11, 1);
		} else {
			MyUI_ChangeValue((CHAR*)"leadnumber", (LONGINT)11, 0);
			MyUI_ChangeValue((CHAR*)"leaddef", (LONGINT)8, 0);
		}
	}
	Oberon_Log = MyUI_oldLog;
}

void MyUI_LeadReset (void)
{
	MyUI_p = Dialogs_cmdPanel;
	MyUI_ChangeValue((CHAR*)"leadnumber", (LONGINT)11, 0);
}

void MyUI_Left (void)
{
	INTEGER number = 0;
	MyUI_InitPar();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"left ", (LONGINT)6);
	MyUI_WriteDefault((CHAR*)"leftmargindef", (LONGINT)14);
	if (MyUI_On((CHAR*)"leftmargin", (LONGINT)11)) {
		In_Open();
		In_Int(&number);
		Texts_WriteInt(&MyUI_w, Texts_Writer__typ, number, 0);
	}
	MyUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
}

void MyUI_GetLeft (void)
{
	Texts_Text txt = NIL;
	Texts_Scanner s = {0};
	MyUI_InitPar();
	MyUI_StoreLog();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"left", (LONGINT)5);
	MyUI_Call((CHAR*)"Edit.Get", (LONGINT)9);
	if (MyUI_res == 0) {
		MyUI_Scan(&s, Texts_Scanner__typ, (CHAR*)"int", (LONGINT)4);
		MyUI_Delete((CHAR*)"tleftmargin", (LONGINT)12, &txt);
		if (s.class == 3) {
			Texts_WriteInt(&MyUI_w, Texts_Writer__typ, s.i, 0);
			Texts_Append(txt, MyUI_w.buf);
			MyUI_ChangeValue((CHAR*)"leftmargin", (LONGINT)11, 1);
		} else {
			MyUI_ChangeValue((CHAR*)"leftmargin", (LONGINT)11, 0);
			MyUI_ChangeValue((CHAR*)"leftmargindef", (LONGINT)14, 0);
		}
	}
	Oberon_Log = MyUI_oldLog;
}

void MyUI_LeftReset (void)
{
	MyUI_p = Dialogs_cmdPanel;
	MyUI_ChangeValue((CHAR*)"leftmargin", (LONGINT)11, 0);
}

void MyUI_Right (void)
{
	INTEGER number = 0;
	MyUI_InitPar();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"right ", (LONGINT)7);
	MyUI_WriteDefault((CHAR*)"rightmargindef", (LONGINT)15);
	if (MyUI_On((CHAR*)"rightmargin", (LONGINT)12)) {
		In_Open();
		In_Int(&number);
		Texts_WriteInt(&MyUI_w, Texts_Writer__typ, number, 0);
	}
	MyUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
}

void MyUI_GetRight (void)
{
	Texts_Text txt = NIL;
	Texts_Scanner s = {0};
	MyUI_InitPar();
	MyUI_StoreLog();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"right", (LONGINT)6);
	MyUI_Call((CHAR*)"Edit.Get", (LONGINT)9);
	if (MyUI_res == 0) {
		MyUI_Scan(&s, Texts_Scanner__typ, (CHAR*)"int", (LONGINT)4);
		MyUI_Delete((CHAR*)"trightmargin", (LONGINT)13, &txt);
		if (s.class == 3) {
			Texts_WriteInt(&MyUI_w, Texts_Writer__typ, s.i, 0);
			Texts_Append(txt, MyUI_w.buf);
			MyUI_ChangeValue((CHAR*)"rightmargin", (LONGINT)12, 1);
		} else {
			MyUI_ChangeValue((CHAR*)"rightmargin", (LONGINT)12, 0);
			MyUI_ChangeValue((CHAR*)"rightmargindef", (LONGINT)15, 0);
		}
	}
	Oberon_Log = MyUI_oldLog;
}

void MyUI_RightReset (void)
{
	MyUI_p = Dialogs_cmdPanel;
	MyUI_ChangeValue((CHAR*)"rightmargin", (LONGINT)12, 0);
}

void MyUI_Line (void)
{
	MyUI_InitPar();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"line ", (LONGINT)6);
	MyUI_WriteDefault((CHAR*)"linedef", (LONGINT)8);
	if (MyUI_On((CHAR*)"linenumber", (LONGINT)11)) {
		MyUI_Save((CHAR*)"tlinenumber", (LONGINT)12);
	}
	MyUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
}

void MyUI_GetLine (void)
{
	Texts_Text txt = NIL;
	Texts_Scanner s = {0};
	MyUI_InitPar();
	MyUI_StoreLog();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"line ", (LONGINT)6);
	MyUI_Call((CHAR*)"Edit.Get", (LONGINT)9);
	if (MyUI_res == 0) {
		MyUI_Scan(&s, Texts_Scanner__typ, (CHAR*)"int", (LONGINT)4);
		MyUI_Delete((CHAR*)"tlinenumber", (LONGINT)12, &txt);
		if (s.class == 3) {
			Texts_WriteInt(&MyUI_w, Texts_Writer__typ, s.i, 0);
			Texts_Append(txt, MyUI_w.buf);
			MyUI_ChangeValue((CHAR*)"linenumber", (LONGINT)11, 1);
		} else {
			MyUI_ChangeValue((CHAR*)"linenumber", (LONGINT)11, 0);
			MyUI_ChangeValue((CHAR*)"linedef", (LONGINT)8, 0);
		}
	}
	Oberon_Log = MyUI_oldLog;
}

void MyUI_LineReset (void)
{
	MyUI_p = Dialogs_cmdPanel;
	MyUI_ChangeValue((CHAR*)"linenumber", (LONGINT)11, 0);
}

void MyUI_Tabs (void)
{
	INTEGER number = 0;
	MyUI_InitPar();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"tabs ", (LONGINT)6);
	if (MyUI_On((CHAR*)"every", (LONGINT)6)) {
		In_Open();
		In_Int(&number);
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"* ", (LONGINT)3);
		Texts_WriteInt(&MyUI_w, Texts_Writer__typ, number, 0);
	} else {
		if (MyUI_On((CHAR*)"enum", (LONGINT)5)) {
			In_Open();
			In_Int(&number);
			do {
				Texts_WriteInt(&MyUI_w, Texts_Writer__typ, number, 0);
				Texts_Write(&MyUI_w, Texts_Writer__typ, ' ');
				In_Int(&number);
			} while (!(!In_Done));
			Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)" ~", (LONGINT)3);
		}
	}
	MyUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
}

void MyUI_GetTabs (void)
{
	Texts_Text txt = NIL;
	Texts_Scanner s = {0};
	CHAR ch = 0;
	BOOLEAN Star = 0;
	MyUI_InitPar();
	MyUI_StoreLog();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"tabs", (LONGINT)5);
	MyUI_Call((CHAR*)"Edit.Get", (LONGINT)9);
	if (MyUI_res == 0) {
		Texts_OpenReader((void*)&s, Texts_Scanner__typ, MyUI_newLog, 0);
		Texts_Read((void*)&s, Texts_Scanner__typ, &ch);
		while (!s.eot && ch != '*') {
			Texts_Read((void*)&s, Texts_Scanner__typ, &ch);
		}
		Star = ch == '*';
		MyUI_Scan(&s, Texts_Scanner__typ, (CHAR*)"int", (LONGINT)4);
		if (Star) {
			MyUI_Delete((CHAR*)"tevery", (LONGINT)7, &txt);
		} else {
			MyUI_Delete((CHAR*)"tenum", (LONGINT)6, &txt);
		}
		do {
			if (s.class == 3) {
				Texts_WriteInt(&MyUI_w, Texts_Writer__typ, s.i, 0);
				Texts_Write(&MyUI_w, Texts_Writer__typ, ' ');
			}
			Texts_Scan(&s, Texts_Scanner__typ);
		} while (!(s.eot || s.class != 3));
		Texts_Append(txt, MyUI_w.buf);
		if (Star) {
			MyUI_ChangeValue((CHAR*)"every", (LONGINT)6, 1);
		} else {
			MyUI_ChangeValue((CHAR*)"enum", (LONGINT)5, 1);
		}
	}
	Oberon_Log = MyUI_oldLog;
}

void MyUI_TabsReset1 (void)
{
	MyUI_p = Dialogs_cmdPanel;
	MyUI_ChangeValue((CHAR*)"every", (LONGINT)6, 0);
}

void MyUI_TabsReset2 (void)
{
	MyUI_p = Dialogs_cmdPanel;
	MyUI_ChangeValue((CHAR*)"enum", (LONGINT)5, 0);
}

void MyUI_Width (void)
{
	INTEGER number = 0;
	MyUI_InitPar();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"width  ", (LONGINT)8);
	if (MyUI_On((CHAR*)"widthdef", (LONGINT)9)) {
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"default", (LONGINT)8);
	}
	if (MyUI_On((CHAR*)"width", (LONGINT)6)) {
		In_Open();
		In_Int(&number);
		Texts_WriteInt(&MyUI_w, Texts_Writer__typ, number, 0);
	}
	MyUI_Call((CHAR*)"Edit.Set", (LONGINT)9);
}

void MyUI_GetWidth (void)
{
	Texts_Text txt = NIL;
	Texts_Scanner s = {0};
	MyUI_InitPar();
	MyUI_StoreLog();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"width", (LONGINT)6);
	MyUI_Call((CHAR*)"Edit.Get", (LONGINT)9);
	if (MyUI_res == 0) {
		MyUI_Scan(&s, Texts_Scanner__typ, (CHAR*)"int", (LONGINT)4);
		MyUI_Delete((CHAR*)"twidth", (LONGINT)7, &txt);
		if (s.class == 3) {
			Texts_WriteInt(&MyUI_w, Texts_Writer__typ, s.i, 0);
			Texts_Append(txt, MyUI_w.buf);
			MyUI_ChangeValue((CHAR*)"width", (LONGINT)6, 1);
		} else {
			MyUI_ChangeValue((CHAR*)"width", (LONGINT)6, 0);
			MyUI_ChangeValue((CHAR*)"widthdef", (LONGINT)9, 0);
		}
	}
	Oberon_Log = MyUI_oldLog;
}

void MyUI_WidthReset (void)
{
	MyUI_p = Dialogs_cmdPanel;
	MyUI_ChangeValue((CHAR*)"width", (LONGINT)6, 0);
}

static StyleElems_Parc MyUI_ThisStyleElem (CHAR *n, LONGINT n__len)
{
	MyUI_StyleElem prev = NIL, next = NIL;
	StyleElems_Parc new = NIL;
	next = MyUI_styleElems;
	prev = MyUI_styleElems;
	while (next != NIL && __STRCMP(next->styleElem->name, n) != 0) {
		prev = next;
		next = next->next;
	}
	if (next != NIL) {
		__NEW(new, StyleElems_ParcDesc);
		StyleElems_Copy(next->styleElem, new);
	}
	return new;
}

static struct Style__91 {
	struct Style__91 *lnk;
} *Style__91_s;

static void Replace__92 (Texts_Text *t, Texts_Reader *r, LONGINT *r__typ, StyleElems_Parc styleElem);

static void Replace__92 (Texts_Text *t, Texts_Reader *r, LONGINT *r__typ, StyleElems_Parc styleElem)
{
	Texts_Delete(*t, Texts_Pos(&*r, r__typ) - 1, Texts_Pos(&*r, r__typ));
	Texts_WriteElem(&MyUI_w, Texts_Writer__typ, (void*)styleElem);
	Texts_Insert(*t, Texts_Pos(&*r, r__typ) - 1, MyUI_w.buf);
}

void MyUI_Style (void)
{
	Texts_Text t = NIL, title = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_Reader r = {0};
	Texts_Elem elem = NIL;
	Texts_Scanner s = {0};
	StyleElems_Parc styleElem = NIL, newElem = NIL;
	TextFrames_Frame f = NIL;
	struct Style__91 _s;
	_s.lnk = Style__91_s;
	Style__91_s = &_s;
	Oberon_GetSelection(&t, &beg, &end, &time);
	f = XIn_FocusFrame(1);
	MyUI_InitPar();
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"styles", (LONGINT)7);
	title = __DialogComboBoxes_Item_GetTitle(__GUARDP(MyUI_o, DialogComboBoxes_ItemDesc, 1));
	Texts_OpenScanner(&s, Texts_Scanner__typ, title, 0);
	Texts_Scan(&s, Texts_Scanner__typ);
	if (time >= 0) {
		Texts_OpenReader(&r, Texts_Reader__typ, t, beg);
		Texts_ReadElem(&r, Texts_Reader__typ);
		if (__IN(s.class, 0x06) && !r.eot) {
			elem = r.elem;
			if (__ISP(elem, StyleElems_ParcDesc, 3)) {
				styleElem = MyUI_ThisStyleElem((void*)s.s, 256);
				if (styleElem == NIL) {
					Texts_WriteString(&MyUI_w, Texts_Writer__typ, s.s, 256);
					MyUI_Call((CHAR*)"StyleElems.Rename", (LONGINT)18);
				} else {
					Replace__92(&t, &r, Texts_Reader__typ, styleElem);
				}
			} else if (__ISP(elem, TextFrames_ParcDesc, 2)) {
				styleElem = MyUI_ThisStyleElem((void*)s.s, 256);
				if (styleElem == NIL) {
					__NEW(styleElem, StyleElems_ParcDesc);
					ParcElems_CopyParc((*(TextFrames_Parc*)&elem), (void*)styleElem);
					styleElem->handle = StyleElems_Handle;
					__COPY(s.s, styleElem->name, 32);
				}
				Replace__92(&t, &r, Texts_Reader__typ, styleElem);
			}
		}
	} else {
		if (__IN(s.class, 0x06) && f != NIL) {
			styleElem = MyUI_ThisStyleElem((void*)s.s, 256);
			__NEW(newElem, StyleElems_ParcDesc);
			StyleElems_Copy(styleElem, newElem);
			Texts_WriteElem(&MyUI_w, Texts_Writer__typ, (void*)newElem);
			Texts_Insert(f->text, f->carloc.pos, MyUI_w.buf);
		}
	}
	Style__91_s = _s.lnk;
}

static struct GetStyles__28 {
	Texts_Reader *r;
	struct GetStyles__28 *lnk;
} *GetStyles__28_s;

static void AddStyles__29 (Texts_Text t);

static void AddStyles__29 (Texts_Text t)
{
	MyUI_StyleElem elem = NIL, next = NIL;
	Texts_OpenReader(&*GetStyles__28_s->r, Texts_Reader__typ, t, 0);
	Texts_ReadElem(&*GetStyles__28_s->r, Texts_Reader__typ);
	while (!(*GetStyles__28_s->r).eot) {
		if (__ISP((*GetStyles__28_s->r).elem, StyleElems_ParcDesc, 3)) {
			next = MyUI_styleElems;
			while (next != NIL && __STRCMP(next->styleElem->name, __GUARDP((*GetStyles__28_s->r).elem, StyleElems_ParcDesc, 3)->name) != 0) {
				next = next->next;
			}
			if (next == NIL) {
				Texts_WriteString(&MyUI_w, Texts_Writer__typ, __GUARDP((*GetStyles__28_s->r).elem, StyleElems_ParcDesc, 3)->name, 32);
				Texts_Write(&MyUI_w, Texts_Writer__typ, 0x0d);
				__NEW(elem, MyUI_StyleElemDesc);
				elem->styleElem = __GUARDP((*GetStyles__28_s->r).elem, StyleElems_ParcDesc, 3);
				elem->next = MyUI_styleElems;
				MyUI_styleElems = elem;
			}
		}
		Texts_ReadElem(&*GetStyles__28_s->r, Texts_Reader__typ);
	}
}

void MyUI_GetStyles (void)
{
	Texts_Text t = NIL, t2 = NIL, t3 = NIL, menu = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_Reader r = {0};
	struct GetStyles__28 _s;
	_s.r = &r;
	_s.lnk = GetStyles__28_s;
	GetStyles__28_s = &_s;
	Oberon_GetSelection(&t, &beg, &end, &time);
	if (time >= 0) {
		MyUI_p = Dialogs_cmdPanel;
		MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"styles", (LONGINT)7);
		menu = __GUARDP(MyUI_o, DialogComboBoxes_ItemDesc, 1)->menu;
		Texts_Delete(menu, 0, menu->len);
		Texts_OpenReader(&r, Texts_Reader__typ, t, beg);
		Texts_ReadElem(&r, Texts_Reader__typ);
		if (!r.eot && Texts_Pos(&r, Texts_Reader__typ) <= end) {
			if (__ISP(r.elem, StyleElems_ParcDesc, 3)) {
				t2 = __DialogComboBoxes_Item_GetTitle(__GUARDP(MyUI_o, DialogComboBoxes_ItemDesc, 1));
				Texts_Delete(t2, 0, t2->len);
				Texts_WriteString(&MyUI_w, Texts_Writer__typ, __GUARDP(r.elem, StyleElems_ParcDesc, 3)->name, 32);
				Texts_Append(t2, MyUI_w.buf);
				Out_Ln();
				Out_String((CHAR*)"Setting title to: ", (LONGINT)19);
				Out_String(__GUARDP(r.elem, StyleElems_ParcDesc, 3)->name, 32);
			}
		}
		MyUI_styleElems = NIL;
		AddStyles__29(t);
		t = TextFrames_Text((CHAR*)"", (LONGINT)1);
		Texts_Open(t, (CHAR*)"Styles.Text", (LONGINT)12);
		AddStyles__29(t);
		Texts_Append(menu, MyUI_w.buf);
	}
	GetStyles__28_s = _s.lnk;
}

void MyUI_GetAll (void)
{
	MyUI_GetAdjust();
	MyUI_GetBreak();
	MyUI_GetColumns();
	MyUI_GetFirst();
	MyUI_GetGrid();
	MyUI_GetLeft();
	MyUI_GetRight();
	MyUI_GetWidth();
	MyUI_GetTabs();
	MyUI_GetLead();
	MyUI_GetLine();
	MyUI_GetStyles();
}

static struct SetDefaultOptions__69 {
	struct SetDefaultOptions__69 *lnk;
} *SetDefaultOptions__69_s;

static void WriteName__70 (Dialogs_Object o, CHAR *s, LONGINT s__len);
static void WriteNumber__72 (Dialogs_Object o, LONGINT l);

static void WriteNumber__72 (Dialogs_Object o, LONGINT l)
{
	Texts_Text t = NIL;
	t = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
	Texts_Delete(t, 0, t->len);
	Texts_WriteInt(&MyUI_w, Texts_Writer__typ, l, 0);
	Texts_Append(t, MyUI_w.buf);
}

static void WriteName__70 (Dialogs_Object o, CHAR *s, LONGINT s__len)
{
	Texts_Text t = NIL;
	INTEGER i = 0;
	__DUP(s, s__len, CHAR);
	t = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
	Texts_Delete(t, 0, t->len);
	i = 0;
	while (s[__X(i, s__len)] != 0x00) {
		Texts_Write(&MyUI_w, Texts_Writer__typ, s[__X(i, s__len)]);
		i += 1;
	}
	Texts_Append(t, MyUI_w.buf);
	__DEL(s);
}

void MyUI_SetDefaultOptions (void)
{
	Dialogs_Object o = NIL;
	struct SetDefaultOptions__69 _s;
	_s.lnk = SetDefaultOptions__69_s;
	SetDefaultOptions__69_s = &_s;
	MyUI_p = Dialogs_cmdPanel;
	MyUI_ChangeValue((CHAR*)"alternate", (LONGINT)10, 0);
	MyUI_ChangeValue((CHAR*)"nopagenr", (LONGINT)9, 0);
	MyUI_ChangeValue((CHAR*)"nopagenr1", (LONGINT)10, 0);
	MyUI_ChangeValue((CHAR*)"Romannum", (LONGINT)9, 0);
	MyUI_ChangeValue((CHAR*)"draft", (LONGINT)6, 0);
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"tfirstpage", (LONGINT)11);
	WriteNumber__72(o, 0);
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"tfirstpage", (LONGINT)11);
	WriteNumber__72(o, 0);
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"copies", (LONGINT)7);
	WriteNumber__72(o, 1);
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"font", (LONGINT)5);
	WriteName__70(o, (CHAR*)"", (LONGINT)1);
	MyUI_ChangeValue((CHAR*)"nohdr", (LONGINT)6, 0);
	MyUI_ChangeValue((CHAR*)"defhdr", (LONGINT)7, 1);
	MyUI_ChangeValue((CHAR*)"header", (LONGINT)7, 0);
	MyUI_ChangeValue((CHAR*)"custom1", (LONGINT)8, 0);
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"thdr", (LONGINT)5);
	WriteName__70(o, (CHAR*)"", (LONGINT)1);
	MyUI_ChangeValue((CHAR*)"default1", (LONGINT)9, 1);
	MyUI_ChangeValue((CHAR*)"custom2", (LONGINT)8, 0);
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"postxtleft", (LONGINT)11);
	WriteNumber__72(o, 150);
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"postxtbottom", (LONGINT)13);
	WriteNumber__72(o, 150);
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"txtwidth", (LONGINT)9);
	WriteNumber__72(o, 1650);
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"txtheight", (LONGINT)10);
	WriteNumber__72(o, 2600);
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"poshdrleft", (LONGINT)11);
	WriteNumber__72(o, 150);
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"poshdrbottom", (LONGINT)13);
	WriteNumber__72(o, 2800);
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"hdrwidth", (LONGINT)9);
	WriteNumber__72(o, 1650);
	MyUI_ChangeValue((CHAR*)"default2", (LONGINT)9, 1);
	MyUI_ChangeValue((CHAR*)"fromto", (LONGINT)7, 0);
	MyUI_ChangeValue((CHAR*)"all", (LONGINT)4, 1);
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"from", (LONGINT)5);
	WriteNumber__72(o, 0);
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"to", (LONGINT)3);
	WriteName__70(o, (CHAR*)"", (LONGINT)1);
	SetDefaultOptions__69_s = _s.lnk;
}

static struct InitPrintDlg__37 {
	Files_Rider *r;
	struct InitPrintDlg__37 *lnk;
} *InitPrintDlg__37_s;

static void WriteName__38 (Dialogs_Object o);
static void WriteNumber__40 (Dialogs_Object o);

static void WriteNumber__40 (Dialogs_Object o)
{
	Texts_Text t = NIL;
	LONGINT l = 0;
	Files_ReadLInt(&*InitPrintDlg__37_s->r, Files_Rider__typ, &l);
	t = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
	Texts_Delete(t, 0, t->len);
	Texts_WriteInt(&MyUI_w, Texts_Writer__typ, l, 0);
	Texts_Append(t, MyUI_w.buf);
}

static void WriteName__38 (Dialogs_Object o)
{
	Texts_Text t = NIL;
	CHAR ch = 0;
	t = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
	Texts_Delete(t, 0, t->len);
	Files_Read(&*InitPrintDlg__37_s->r, Files_Rider__typ, (void*)&ch);
	while (ch != 0x00) {
		Texts_Write(&MyUI_w, Texts_Writer__typ, ch);
		Files_Read(&*InitPrintDlg__37_s->r, Files_Rider__typ, (void*)&ch);
	}
	Texts_Append(t, MyUI_w.buf);
}

void MyUI_InitPrintDlg (void)
{
	Files_Rider r = {0};
	Files_File f = NIL;
	BOOLEAN b = 0;
	Dialogs_Object o = NIL;
	struct InitPrintDlg__37 _s;
	_s.r = &r;
	_s.lnk = InitPrintDlg__37_s;
	InitPrintDlg__37_s = &_s;
	f = Files_Old((CHAR*)"PrintOptions", (LONGINT)13);
	if (f != NIL) {
		MyUI_p = Dialogs_cmdPanel;
		Files_Set(&r, Files_Rider__typ, f, 0);
		Files_ReadBool(&r, Files_Rider__typ, &b);
		MyUI_ChangeValue((CHAR*)"alternate", (LONGINT)10, b);
		Files_ReadBool(&r, Files_Rider__typ, &b);
		MyUI_ChangeValue((CHAR*)"nopagenr", (LONGINT)9, b);
		Files_ReadBool(&r, Files_Rider__typ, &b);
		MyUI_ChangeValue((CHAR*)"nopagenr1", (LONGINT)10, b);
		Files_ReadBool(&r, Files_Rider__typ, &b);
		MyUI_ChangeValue((CHAR*)"Romanum", (LONGINT)8, b);
		Files_ReadBool(&r, Files_Rider__typ, &b);
		MyUI_ChangeValue((CHAR*)"draft", (LONGINT)6, b);
		o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"tfirstpage", (LONGINT)11);
		WriteNumber__40(o);
		o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"copies", (LONGINT)7);
		WriteNumber__40(o);
		o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"font", (LONGINT)5);
		WriteName__38(o);
		Files_ReadBool(&r, Files_Rider__typ, &b);
		MyUI_ChangeValue((CHAR*)"nohdr", (LONGINT)6, b);
		Files_ReadBool(&r, Files_Rider__typ, &b);
		MyUI_ChangeValue((CHAR*)"defhdr", (LONGINT)7, b);
		Files_ReadBool(&r, Files_Rider__typ, &b);
		MyUI_ChangeValue((CHAR*)"header", (LONGINT)7, b);
		o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"thdr", (LONGINT)5);
		WriteName__38(o);
		Files_ReadBool(&r, Files_Rider__typ, &b);
		MyUI_ChangeValue((CHAR*)"custom1", (LONGINT)8, b);
		Files_ReadBool(&r, Files_Rider__typ, &b);
		MyUI_ChangeValue((CHAR*)"default1", (LONGINT)9, b);
		o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"postxtleft", (LONGINT)11);
		WriteNumber__40(o);
		o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"postxtbottom", (LONGINT)13);
		WriteNumber__40(o);
		o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"txtwidth", (LONGINT)9);
		WriteNumber__40(o);
		o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"txtheight", (LONGINT)10);
		WriteNumber__40(o);
		Files_ReadBool(&r, Files_Rider__typ, &b);
		MyUI_ChangeValue((CHAR*)"custom2", (LONGINT)8, b);
		Files_ReadBool(&r, Files_Rider__typ, &b);
		MyUI_ChangeValue((CHAR*)"default2", (LONGINT)9, b);
		o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"poshdrleft", (LONGINT)11);
		WriteNumber__40(o);
		o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"poshdrbottom", (LONGINT)13);
		WriteNumber__40(o);
		o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"hdrwidth", (LONGINT)9);
		WriteNumber__40(o);
		Files_ReadBool(&r, Files_Rider__typ, &b);
		MyUI_ChangeValue((CHAR*)"fromto", (LONGINT)7, b);
		Files_ReadBool(&r, Files_Rider__typ, &b);
		MyUI_ChangeValue((CHAR*)"all", (LONGINT)4, b);
		o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"from", (LONGINT)5);
		WriteNumber__40(o);
		o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"to", (LONGINT)3);
		WriteNumber__40(o);
	} else {
		MyUI_SetDefaultOptions();
	}
	InitPrintDlg__37_s = _s.lnk;
}

static struct SaveOptions__61 {
	Files_Rider *r;
	struct SaveOptions__61 *lnk;
} *SaveOptions__61_s;

static void WriteName__62 (Dialogs_Object o);
static void WriteNumber__64 (Dialogs_Object o);

static void WriteNumber__64 (Dialogs_Object o)
{
	Texts_Scanner s = {0};
	Texts_Text t = NIL;
	LONGINT l = 0;
	t = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
	l = 0;
	if (t->len > 0) {
		Texts_OpenScanner(&s, Texts_Scanner__typ, t, 0);
		Texts_Scan(&s, Texts_Scanner__typ);
		if (s.class == 3) {
			l = s.i;
		}
	}
	Files_WriteLInt(&*SaveOptions__61_s->r, Files_Rider__typ, l);
}

static void WriteName__62 (Dialogs_Object o)
{
	Texts_Reader rt = {0};
	Texts_Text t = NIL;
	CHAR ch = 0;
	t = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
	Texts_OpenReader(&rt, Texts_Reader__typ, t, 0);
	Texts_Read(&rt, Texts_Reader__typ, &ch);
	while (!rt.eot) {
		Files_Write(&*SaveOptions__61_s->r, Files_Rider__typ, ch);
		Texts_Read(&rt, Texts_Reader__typ, &ch);
	}
	Files_Write(&*SaveOptions__61_s->r, Files_Rider__typ, 0x00);
}

void MyUI_SaveOptions (void)
{
	Files_Rider r = {0};
	Files_File f = NIL;
	struct SaveOptions__61 _s;
	_s.r = &r;
	_s.lnk = SaveOptions__61_s;
	SaveOptions__61_s = &_s;
	f = Files_New((CHAR*)"PrintOptions", (LONGINT)13);
	Files_Set(&r, Files_Rider__typ, f, 0);
	MyUI_p = Dialogs_cmdPanel;
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"alternate", (LONGINT)10);
	Files_WriteBool(&r, Files_Rider__typ, __GUARDP(MyUI_o, DialogCheckBoxes_ItemDesc, 1)->on);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"nopagenr", (LONGINT)9);
	Files_WriteBool(&r, Files_Rider__typ, __GUARDP(MyUI_o, DialogCheckBoxes_ItemDesc, 1)->on);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"nopagenr1", (LONGINT)10);
	Files_WriteBool(&r, Files_Rider__typ, __GUARDP(MyUI_o, DialogCheckBoxes_ItemDesc, 1)->on);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"Romannum", (LONGINT)9);
	Files_WriteBool(&r, Files_Rider__typ, __GUARDP(MyUI_o, DialogCheckBoxes_ItemDesc, 1)->on);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"draft", (LONGINT)6);
	Files_WriteBool(&r, Files_Rider__typ, __GUARDP(MyUI_o, DialogCheckBoxes_ItemDesc, 1)->on);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"tfirstpage", (LONGINT)11);
	WriteNumber__64(MyUI_o);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"copies", (LONGINT)7);
	WriteNumber__64(MyUI_o);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"font", (LONGINT)5);
	WriteName__62(MyUI_o);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"nohdr", (LONGINT)6);
	Files_WriteBool(&r, Files_Rider__typ, __GUARDP(MyUI_o, DialogRadioButtons_ItemDesc, 1)->on);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"defhdr", (LONGINT)7);
	Files_WriteBool(&r, Files_Rider__typ, __GUARDP(MyUI_o, DialogRadioButtons_ItemDesc, 1)->on);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"header", (LONGINT)7);
	Files_WriteBool(&r, Files_Rider__typ, __GUARDP(MyUI_o, DialogRadioButtons_ItemDesc, 1)->on);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"thdr", (LONGINT)5);
	WriteName__62(MyUI_o);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"custom1", (LONGINT)8);
	Files_WriteBool(&r, Files_Rider__typ, __GUARDP(MyUI_o, DialogRadioButtons_ItemDesc, 1)->on);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"default1", (LONGINT)9);
	Files_WriteBool(&r, Files_Rider__typ, __GUARDP(MyUI_o, DialogRadioButtons_ItemDesc, 1)->on);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"postxtleft", (LONGINT)11);
	WriteNumber__64(MyUI_o);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"postxtbottom", (LONGINT)13);
	WriteNumber__64(MyUI_o);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"txtwidth", (LONGINT)9);
	WriteNumber__64(MyUI_o);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"txtheight", (LONGINT)10);
	WriteNumber__64(MyUI_o);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"custom2", (LONGINT)8);
	Files_WriteBool(&r, Files_Rider__typ, __GUARDP(MyUI_o, DialogRadioButtons_ItemDesc, 1)->on);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"default2", (LONGINT)9);
	Files_WriteBool(&r, Files_Rider__typ, __GUARDP(MyUI_o, DialogRadioButtons_ItemDesc, 1)->on);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"poshdrleft", (LONGINT)11);
	WriteNumber__64(MyUI_o);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"poshdrbottom", (LONGINT)13);
	WriteNumber__64(MyUI_o);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"hdrwidth", (LONGINT)9);
	WriteNumber__64(MyUI_o);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"fromto", (LONGINT)7);
	Files_WriteBool(&r, Files_Rider__typ, __GUARDP(MyUI_o, DialogRadioButtons_ItemDesc, 1)->on);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"all", (LONGINT)4);
	Files_WriteBool(&r, Files_Rider__typ, __GUARDP(MyUI_o, DialogRadioButtons_ItemDesc, 1)->on);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"from", (LONGINT)5);
	WriteNumber__64(MyUI_o);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"to", (LONGINT)3);
	WriteNumber__64(MyUI_o);
	Files_Register(f);
	SaveOptions__61_s = _s.lnk;
}

void MyUI_Print (void)
{
	Texts_Text t = NIL;
	Dialogs_Object o = NIL;
	Texts_OpenWriter(&MyUI_w, Texts_Writer__typ);
	MyUI_InitPar();
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"QuickDraw * ", (LONGINT)13);
	if (MyUI_On((CHAR*)"draft", (LONGINT)6)) {
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"% ", (LONGINT)3);
	}
	if (MyUI_On((CHAR*)"alternate", (LONGINT)10)) {
		Texts_Write(&MyUI_w, Texts_Writer__typ, '/');
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"a ", (LONGINT)3);
	}
	if (MyUI_On((CHAR*)"nopagenr", (LONGINT)9)) {
		Texts_Write(&MyUI_w, Texts_Writer__typ, '/');
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"p n ", (LONGINT)5);
	}
	if (MyUI_On((CHAR*)"nopagenr1", (LONGINT)10)) {
		Texts_Write(&MyUI_w, Texts_Writer__typ, '/');
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"p f ", (LONGINT)5);
	}
	if (MyUI_On((CHAR*)"Romannum", (LONGINT)9)) {
		Texts_Write(&MyUI_w, Texts_Writer__typ, '/');
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"p r ", (LONGINT)5);
	}
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"tfirstpage", (LONGINT)11);
	t = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
	if (t->len > 0) {
		Texts_Write(&MyUI_w, Texts_Writer__typ, '/');
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"p ", (LONGINT)3);
		Texts_Save(t, 0, t->len, MyUI_w.buf);
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)" ", (LONGINT)2);
	}
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"font", (LONGINT)5);
	t = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
	if (t->len > 0) {
		Texts_Write(&MyUI_w, Texts_Writer__typ, '/');
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"f ", (LONGINT)3);
		Texts_Save(t, 0, t->len, MyUI_w.buf);
		Texts_Write(&MyUI_w, Texts_Writer__typ, ' ');
	}
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"copies", (LONGINT)7);
	t = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
	if (t->len > 0) {
		Texts_Write(&MyUI_w, Texts_Writer__typ, '/');
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"c ", (LONGINT)3);
		Texts_Save(t, 0, t->len, MyUI_w.buf);
		Texts_Write(&MyUI_w, Texts_Writer__typ, ' ');
	}
	if (MyUI_On((CHAR*)"defhdr", (LONGINT)7)) {
		Texts_Write(&MyUI_w, Texts_Writer__typ, '/');
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"h ", (LONGINT)3);
	}
	if (MyUI_On((CHAR*)"header", (LONGINT)7)) {
		Texts_Write(&MyUI_w, Texts_Writer__typ, '/');
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"h ", (LONGINT)3);
		MyUI_Save((CHAR*)"thdr", (LONGINT)5);
		Texts_Write(&MyUI_w, Texts_Writer__typ, ' ');
	}
	if (MyUI_On((CHAR*)"custom1", (LONGINT)8)) {
		Texts_Write(&MyUI_w, Texts_Writer__typ, '/');
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"m b ", (LONGINT)5);
		MyUI_Save((CHAR*)"postxtleft", (LONGINT)11);
		Texts_Write(&MyUI_w, Texts_Writer__typ, ' ');
		MyUI_Save((CHAR*)"postxtbottom", (LONGINT)13);
		Texts_Write(&MyUI_w, Texts_Writer__typ, ' ');
		MyUI_Save((CHAR*)"txtwidth", (LONGINT)9);
		Texts_Write(&MyUI_w, Texts_Writer__typ, ' ');
		MyUI_Save((CHAR*)"txtheight", (LONGINT)10);
		Texts_Write(&MyUI_w, Texts_Writer__typ, ' ');
	}
	if (MyUI_On((CHAR*)"custom2", (LONGINT)8)) {
		Texts_Write(&MyUI_w, Texts_Writer__typ, '/');
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"m h ", (LONGINT)5);
		MyUI_Save((CHAR*)"poshdrleft", (LONGINT)11);
		Texts_Write(&MyUI_w, Texts_Writer__typ, ' ');
		MyUI_Save((CHAR*)"poshdrbottom", (LONGINT)13);
		Texts_Write(&MyUI_w, Texts_Writer__typ, ' ');
		MyUI_Save((CHAR*)"hdrwidth", (LONGINT)9);
		Texts_Write(&MyUI_w, Texts_Writer__typ, ' ');
	}
	if (MyUI_On((CHAR*)"fromto", (LONGINT)7)) {
		Texts_Write(&MyUI_w, Texts_Writer__typ, '/');
		Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"s ", (LONGINT)3);
		o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"from", (LONGINT)5);
		t = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
		if (t->len > 0) {
			Texts_Save(t, 0, t->len, MyUI_w.buf);
		}
		Texts_Write(&MyUI_w, Texts_Writer__typ, ' ');
		o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"to", (LONGINT)3);
		t = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
		if (t->len > 0) {
			Texts_Save(t, 0, t->len, MyUI_w.buf);
		}
	}
	MyUI_Call((CHAR*)"Edit.Print", (LONGINT)11);
}

void MyUI_Search (void)
{
	INTEGER res = 0;
	Texts_Text t = NIL;
	Dialogs_Object o = NIL;
	MyUI_p = Dialogs_cmdPanel;
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"search", (LONGINT)7);
	t = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
	__DialogTexts_Item_SetSelection(__GUARDP(o, DialogTexts_ItemDesc, 1), 0, t->len);
	if (MyUI_On((CHAR*)"folds", (LONGINT)6)) {
		Oberon_Call((CHAR*)"FoldElems.Search", (LONGINT)17, Oberon_Par, 0, &res);
	} else {
		Oberon_Call((CHAR*)"Edit.Search", (LONGINT)12, Oberon_Par, 0, &res);
	}
	__DialogTexts_Item_RemoveSelection(__GUARDP(o, DialogTexts_ItemDesc, 1));
	MyUI_doSearch = 0;
}

void MyUI_Replace (void)
{
	INTEGER res = 0;
	Texts_Text t = NIL;
	Dialogs_Object o = NIL;
	TextFrames_Frame f = NIL;
	f = XIn_FocusFrame(1);
	if (f != NIL) {
		MyUI_p = Dialogs_cmdPanel;
		if (MyUI_doSearch) {
			MyUI_doSearch = 0;
			o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"search", (LONGINT)7);
			t = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
			__DialogTexts_Item_SetSelection(__GUARDP(o, DialogTexts_ItemDesc, 1), 0, t->len);
			if (MyUI_On((CHAR*)"folds", (LONGINT)6)) {
				Oberon_Call((CHAR*)"FoldElems.Search", (LONGINT)17, Oberon_Par, 0, &res);
			} else {
				Oberon_Call((CHAR*)"Edit.Search", (LONGINT)12, Oberon_Par, 0, &res);
			}
			__DialogTexts_Item_RemoveSelection(__GUARDP(o, DialogTexts_ItemDesc, 1));
		}
		o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"repl", (LONGINT)5);
		t = __DialogTexts_Item_GetText(__GUARDP(o, DialogTexts_ItemDesc, 1));
		if (t->len == 0) {
			Oberon_Call((CHAR*)"Edit.ClearReplaceBuffer", (LONGINT)24, Oberon_Par, 0, &res);
		} else {
			__DialogTexts_Item_SetSelection(__GUARDP(o, DialogTexts_ItemDesc, 1), 0, t->len);
		}
		if (MyUI_On((CHAR*)"all", (LONGINT)4)) {
			Oberon_Call((CHAR*)"Edit.ReplaceAll", (LONGINT)16, Oberon_Par, 0, &res);
		} else {
			Oberon_Call((CHAR*)"Edit.Replace", (LONGINT)13, Oberon_Par, 0, &res);
		}
		__DialogTexts_Item_RemoveSelection(__GUARDP(o, DialogTexts_ItemDesc, 1));
	}
}

void MyUI_SearchReset (void)
{
	MyUI_doSearch = 1;
}

void MyUI_GetType (void)
{
	Texts_Text t = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_Reader r = {0};
	Types_Type type = NIL;
	CHAR s[64];
	INTEGER i = 0, j = 0;
	Oberon_GetSelection(&t, &beg, &end, &time);
	if (time >= 0) {
		Texts_OpenReader(&r, Texts_Reader__typ, t, beg);
		Texts_ReadElem(&r, Texts_Reader__typ);
		if (!r.eot) {
			type = Types_TypeOf((void*)r.elem);
			MyUI_p = Dialogs_cmdPanel;
			MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"type", (LONGINT)5);
			i = 0;
			while (type->module->name[__X(i, 20)] != 0x00) {
				s[__X(i, 64)] = type->module->name[__X(i, 20)];
				i += 1;
			}
			s[__X(i, 64)] = '.';
			i += 1;
			j = i;
			while (type->name[__X(j - i, 24)] != 0x00) {
				s[__X(j, 64)] = type->name[__X(j - i, 24)];
				j += 1;
			}
			s[__X(j, 64)] = 0x00;
			__DialogStaticTexts_Item_SetString(__GUARDP(MyUI_o, DialogStaticTexts_ItemDesc, 1), s, 64);
		}
	}
}

void MyUI_AddVar (CHAR *n, LONGINT n__len, LONGREAL value)
{
	MyUI_Var var = NIL;
	Texts_Text txt = NIL;
	__DUP(n, n__len, CHAR);
	__NEW(var, MyUI_VarDesc);
	var->next = MyUI_vars;
	MyUI_vars = var;
	__COPY(n, var->name, 32);
	var->value = value;
	MyUI_p = Dialogs_cmdPanel;
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"gset", (LONGINT)5);
	txt = __GUARDP(MyUI_o, DialogComboBoxes_ItemDesc, 1)->menu;
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, n, n__len);
	Texts_Write(&MyUI_w, Texts_Writer__typ, 0x0d);
	Texts_Append(txt, MyUI_w.buf);
	__DEL(n);
}

static struct ShowNumber__75 {
	struct ShowNumber__75 *lnk;
} *ShowNumber__75_s;

static void WrBin__76 (LONGREAL n);
static void WrChar__78 (LONGREAL n);
static void WrHex__82 (LONGREAL n);
static void WrInt__84 (LONGREAL n);
static void WrOct__86 (LONGREAL n);
static void WrReal__88 (LONGREAL n);

static void WrHex__82 (LONGREAL n)
{
	LONGINT x = 0, y = 0;
	INTEGER i = 0;
	CHAR a[10];
	x = __ENTIER(n +   5.00000000000000e-010);
	i = 0;
	Texts_Write(&MyUI_w, Texts_Writer__typ, ' ');
	do {
		y = __MASK(x, -16);
		if (y < 10) {
			a[__X(i, 10)] = (CHAR)(y + 48);
		} else {
			a[__X(i, 10)] = (CHAR)(y + 55);
		}
		x = __ASHR(x, 4);
		i += 1;
	} while (!(i == 8));
	do {
		i -= 1;
	} while (!(i == 0 || a[__X(i, 10)] != '0'));
	if (a[__X(i, 10)] >= 'A') {
		Texts_Write(&MyUI_w, Texts_Writer__typ, '0');
	}
	while (i >= 0) {
		Texts_Write(&MyUI_w, Texts_Writer__typ, a[__X(i, 10)]);
		i -= 1;
	}
	Texts_Write(&MyUI_w, Texts_Writer__typ, 'H');
}

static void WrBin__76 (LONGREAL n)
{
	LONGINT x = 0;
	INTEGER i = 0;
	CHAR a[30];
	x = __ENTIER(n +   5.00000000000000e-010);
	i = 0;
	Texts_Write(&MyUI_w, Texts_Writer__typ, ' ');
	do {
		a[__X(i, 30)] = (CHAR)(48 + __MASK(x, -2));
		x = __ASHR(x, 1);
		i += 1;
	} while (!(i == 28));
	do {
		i -= 1;
	} while (!(i == 0 || a[__X(i, 30)] != '0'));
	while (i >= 0) {
		Texts_Write(&MyUI_w, Texts_Writer__typ, a[__X(i, 30)]);
		i -= 1;
	}
	Texts_Write(&MyUI_w, Texts_Writer__typ, 'B');
}

static void WrOct__86 (LONGREAL n)
{
	LONGINT x = 0, y = 0;
	INTEGER i = 0;
	CHAR a[16];
	x = __ENTIER(n +   5.00000000000000e-010);
	i = 0;
	Texts_Write(&MyUI_w, Texts_Writer__typ, ' ');
	do {
		y = __MASK(x, -8);
		a[__X(i, 16)] = (CHAR)(y + 48);
		x = __ASHR(x, 3);
		i += 1;
	} while (!(i == 14));
	do {
		i -= 1;
	} while (!(i == 0 || a[__X(i, 16)] != '0'));
	while (i >= 0) {
		Texts_Write(&MyUI_w, Texts_Writer__typ, a[__X(i, 16)]);
		i -= 1;
	}
	Texts_Write(&MyUI_w, Texts_Writer__typ, 'C');
}

static void WrInt__84 (LONGREAL n)
{
	Texts_Write(&MyUI_w, Texts_Writer__typ, ' ');
	Texts_WriteInt(&MyUI_w, Texts_Writer__typ, __ENTIER(n +   5.00000000000000e-010), 0);
}

static struct WrChar__78__79 {
	struct WrChar__78__79 *lnk;
} *WrChar__78__79_s;

static void Ch__80 (CHAR ch);

static void Ch__80 (CHAR ch)
{
	Texts_Write(&MyUI_w, Texts_Writer__typ, ch);
}

static void WrChar__78 (LONGREAL n)
{
	CHAR ch = 0;
	struct WrChar__78__79 _s;
	_s.lnk = WrChar__78__79_s;
	WrChar__78__79_s = &_s;
	ch = (CHAR)__ENTIER(n +   5.00000000000000e-010);
	if (' ' <= ch && ch < 0x7f || 0x80 <= ch && ch < 0xa0) {
		Ch__80(' ');
		Ch__80('\"');
		Ch__80(ch);
		Ch__80('\"');
	} else {
		WrHex__82((int)ch);
	}
	WrChar__78__79_s = _s.lnk;
}

static void WrReal__88 (LONGREAL n)
{
	LONGREAL x = 0;
	if ( -2.14748364800000e+009 <= n && n <=   2.14748364700000e+009) {
		x = __ABS(n - (__ENTIER(n)));
		if (x <   1.00000000000000e-009) {
			WrInt__84(n);
			return;
		}
	}
	if ( -3.40282346000000e+038 <= n && n <=   3.40282346000000e+038) {
		x = __ABS(n - (n));
		if (x <   1.00000000000000e-009) {
			if ((LONGREAL)-10000 < n && n < (LONGREAL)10000) {
				Texts_WriteRealFix(&MyUI_w, Texts_Writer__typ, (n +   5.00000000000000e-010), 0, 6);
			} else {
				Texts_WriteReal(&MyUI_w, Texts_Writer__typ, (n +   5.00000000000000e-010), 14);
			}
			return;
		}
	}
	Texts_WriteLongReal(&MyUI_w, Texts_Writer__typ, n, 23);
}

void MyUI_ShowNumber (void)
{
	Texts_Reader r = {0};
	Texts_Text txt = NIL;
	INTEGER i = 0;
	CHAR str[32];
	Texts_Scanner s = {0};
	struct ShowNumber__75 _s;
	_s.lnk = ShowNumber__75_s;
	ShowNumber__75_s = &_s;
	MyUI_p = Dialogs_cmdPanel;
	if (MyUI_p == NIL) {
		ShowNumber__75_s = _s.lnk;
		return;
	}
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"mode", (LONGINT)5);
	if (MyUI_o == NIL) {
		ShowNumber__75_s = _s.lnk;
		return;
	}
	txt = __DialogComboBoxes_Item_GetTitle(__GUARDP(MyUI_o, DialogComboBoxes_ItemDesc, 1));
	Texts_OpenScanner(&s, Texts_Scanner__typ, txt, 0);
	Texts_Scan(&s, Texts_Scanner__typ);
	if (__STRCMP(s.s, "hex") == 0) {
		WrHex__82(MyUI_value);
	} else if (__STRCMP(s.s, "bin") == 0) {
		WrBin__76(MyUI_value);
	} else if (__STRCMP(s.s, "oct") == 0) {
		WrOct__86(MyUI_value);
	} else if (__STRCMP(s.s, "dec") == 0) {
		WrInt__84(MyUI_value);
	} else if (__STRCMP(s.s, "char") == 0) {
		WrChar__78(MyUI_value);
	} else {
		WrReal__88(MyUI_value);
	}
	txt = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_Append(txt, MyUI_w.buf);
	Texts_OpenReader(&r, Texts_Reader__typ, txt, 0);
	i = 0;
	do {
		Texts_Read(&r, Texts_Reader__typ, &str[__X(i, 32)]);
		i += 1;
	} while (!r.eot);
	str[__X(i - 1, 32)] = 0x00;
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"t1", (LONGINT)3);
	__DialogStaticTexts_Item_SetString(__GUARDP(MyUI_o, DialogStaticTexts_ItemDesc, 1), str, 32);
	ShowNumber__75_s = _s.lnk;
}

void MyUI_Clear (void)
{
	MyUI_oldValue = (LONGREAL)0;
	MyUI_value = (LONGREAL)0;
	MyUI_commaPos = (LONGREAL)10;
	__MOVE("add", MyUI_oldOp, 4);
	MyUI_newNumber = 1;
	MyUI_ShowNumber();
}

void MyUI_Reset (void)
{
	Texts_Text txt = NIL;
	MyUI_Clear();
	MyUI_p = Dialogs_cmdPanel;
	if (MyUI_p == NIL) {
		return;
	}
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"gset", (LONGINT)5);
	if (MyUI_o == NIL) {
		return;
	}
	txt = __GUARDP(MyUI_o, DialogComboBoxes_ItemDesc, 1)->menu;
	Texts_Delete(txt, 0, txt->len);
	MyUI_vars = NIL;
	MyUI_AddVar((CHAR*)"pi", (LONGINT)3,   3.14159265358979e+000);
	MyUI_AddVar((CHAR*)"e", (LONGINT)2,   2.71828182845904e+000);
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"gset", (LONGINT)5);
	txt = TextFrames_Text((CHAR*)"", (LONGINT)1);
	__DialogComboBoxes_Item_SetTitle(__GUARDP(MyUI_o, DialogComboBoxes_ItemDesc, 1), txt);
}

void MyUI_Num (void)
{
	INTEGER i = 0, base = 0;
	Texts_Text txt = NIL;
	Texts_Scanner s = {0};
	In_Open();
	In_Int(&i);
	MyUI_p = Dialogs_cmdPanel;
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"mode", (LONGINT)5);
	txt = __DialogComboBoxes_Item_GetTitle(__GUARDP(MyUI_o, DialogComboBoxes_ItemDesc, 1));
	Texts_OpenScanner(&s, Texts_Scanner__typ, txt, 0);
	Texts_Scan(&s, Texts_Scanner__typ);
	if (__STRCMP(s.s, "hex") == 0) {
		base = 16;
	} else if (__STRCMP(s.s, "bin") == 0) {
		base = 2;
	} else if (__STRCMP(s.s, "oct") == 0) {
		base = 8;
	} else {
		base = 10;
	}
	if (MyUI_newNumber) {
		MyUI_newNumber = 0;
		MyUI_value = i;
	} else if (MyUI_commaPos > (LONGREAL)1) {
		MyUI_value = base * MyUI_value + i;
	} else {
		MyUI_commaPos = MyUI_commaPos / (LONGREAL)base;
		MyUI_value = MyUI_value + MyUI_commaPos * i;
	}
	MyUI_ShowNumber();
}

void MyUI_Comma (void)
{
	MyUI_commaPos = (LONGREAL)1;
}

static struct Op__50 {
	struct Op__50 *lnk;
} *Op__50_s;

static BOOLEAN Invers__51 (void);
static void OpLocal__53 (MyUI_Operation op);

static BOOLEAN Invers__51 (void)
{
	Dialogs_Object o = NIL;
	o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"inv", (LONGINT)4);
	return __GUARDP(o, DialogCheckBoxes_ItemDesc, 1)->on;
}

static void OpLocal__53 (MyUI_Operation op)
{
	MyUI_Operation op__copy;
	__DUPARR(op, MyUI_Operation);
	if (__STRCMP(op, "add") == 0) {
		MyUI_value = MyUI_oldValue + MyUI_value;
		MyUI_oldValue = MyUI_value;
	} else if (__STRCMP(op, "sub") == 0) {
		MyUI_value = MyUI_oldValue - MyUI_value;
		MyUI_oldValue = MyUI_value;
	} else if (__STRCMP(op, "mult") == 0) {
		MyUI_value = MyUI_oldValue * MyUI_value;
		MyUI_oldValue = MyUI_value;
	} else if (__STRCMP(op, "div") == 0) {
		MyUI_value = MyUI_oldValue / MyUI_value;
		MyUI_oldValue = MyUI_value;
	} else if (__STRCMP(op, "sign") == 0) {
		MyUI_value = -MyUI_value;
	} else if (__STRCMP(op, "oneDivX") == 0) {
		MyUI_value = (LONGREAL)1 / MyUI_value;
	} else if (__STRCMP(op, "sqr") == 0) {
		if (!Invers__51()) {
			MyUI_value = MyUI_value * MyUI_value;
		} else {
			MyUI_value = MathL_sqrt(MyUI_value);
		}
	} else if (__STRCMP(op, "sin") == 0) {
		if (!Invers__51()) {
			MyUI_value = MathL_sin(MyUI_value);
		} else {
			MyUI_value = MoreMathL_arcsin(MyUI_value);
		}
	} else if (__STRCMP(op, "cos") == 0) {
		if (!Invers__51()) {
			MyUI_value = MathL_cos(MyUI_value);
		} else {
			MyUI_value = MoreMathL_arccos(MyUI_value);
		}
	} else if (__STRCMP(op, "tan") == 0) {
		if (!Invers__51()) {
			MyUI_value = MoreMathL_tan(MyUI_value);
		} else {
			MyUI_value = MathL_arctan(MyUI_value);
		}
	} else if (__STRCMP(op, "exp") == 0) {
		if (!Invers__51()) {
			MyUI_value = MathL_exp(MyUI_value);
		} else {
			MyUI_value = MathL_ln(MyUI_value);
		}
	} else {
		Out_Ln();
		Out_String((CHAR*)"unexpected operator: ", (LONGINT)22);
		Out_String(op, 10);
	}
}

void MyUI_Op (void)
{
	struct Op__50 _s;
	_s.lnk = Op__50_s;
	Op__50_s = &_s;
	In_Open();
	In_Name((void*)MyUI_op, 10);
	if ((((__STRCMP(MyUI_op, "add") == 0 || __STRCMP(MyUI_op, "sub") == 0) || __STRCMP(MyUI_op, "mult") == 0) || __STRCMP(MyUI_op, "div") == 0) || __STRCMP(MyUI_op, "res") == 0) {
		OpLocal__53(MyUI_oldOp);
		if (__STRCMP(MyUI_op, "=") != 0) {
			__MOVE(MyUI_op, MyUI_oldOp, 10);
		}
	} else {
		OpLocal__53(MyUI_op);
	}
	MyUI_commaPos = (LONGREAL)10;
	MyUI_newNumber = 1;
	MyUI_ShowNumber();
	Op__50_s = _s.lnk;
}

void MyUI_SetVar (void)
{
	Texts_Text txt = NIL;
	Texts_Reader r = {0};
	INTEGER i = 0;
	MyUI_Var var = NIL;
	MyUI_p = Dialogs_cmdPanel;
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"set", (LONGINT)4);
	txt = __DialogTexts_Item_GetText(__GUARDP(MyUI_o, DialogTexts_ItemDesc, 1));
	__NEW(var, MyUI_VarDesc);
	var->next = NIL;
	var->value = MyUI_value;
	Texts_OpenReader(&r, Texts_Reader__typ, txt, 0);
	i = 0;
	Texts_Read(&r, Texts_Reader__typ, &var->name[__X(i, 32)]);
	while (!r.eot) {
		i += 1;
		Texts_Read(&r, Texts_Reader__typ, &var->name[__X(i, 32)]);
	}
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"gset", (LONGINT)5);
	txt = __GUARDP(MyUI_o, DialogComboBoxes_ItemDesc, 1)->menu;
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, var->name, 32);
	Texts_Write(&MyUI_w, Texts_Writer__typ, 0x0d);
	Texts_Append(txt, MyUI_w.buf);
	var->next = MyUI_vars;
	MyUI_vars = var;
}

void MyUI_Variable (void)
{
	Texts_Text txt = NIL;
	MyUI_Var cur = NIL;
	CHAR s[32];
	Texts_Reader r = {0};
	INTEGER i = 0;
	MyUI_p = Dialogs_cmdPanel;
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"gset", (LONGINT)5);
	txt = __DialogComboBoxes_Item_GetTitle(__GUARDP(MyUI_o, DialogComboBoxes_ItemDesc, 1));
	Texts_OpenReader(&r, Texts_Reader__typ, txt, 0);
	i = 0;
	Texts_Read(&r, Texts_Reader__typ, &s[__X(i, 32)]);
	while (!r.eot && s[__X(i, 32)] != 0x0d) {
		i += 1;
		Texts_Read(&r, Texts_Reader__typ, &s[__X(i, 32)]);
	}
	s[__X(i, 32)] = 0x00;
	cur = MyUI_vars;
	while (cur != NIL && __STRCMP(cur->name, s) != 0) {
		cur = cur->next;
	}
	if (cur != NIL && __STRCMP(cur->name, s) == 0) {
		MyUI_value = cur->value;
		MyUI_ShowNumber();
	}
}

void MyUI_InitCalc (void)
{
	Texts_Text menu = NIL, title = NIL;
	MyUI_Reset();
	MyUI_p = Dialogs_cmdPanel;
	MyUI_o = __Dialogs_Panel_NamedObject(MyUI_p, (CHAR*)"mode", (LONGINT)5);
	menu = __GUARDP(MyUI_o, DialogComboBoxes_ItemDesc, 1)->menu;
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"dec", (LONGINT)4);
	Texts_Write(&MyUI_w, Texts_Writer__typ, 0x0d);
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"bin", (LONGINT)4);
	Texts_Write(&MyUI_w, Texts_Writer__typ, 0x0d);
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"oct", (LONGINT)4);
	Texts_Write(&MyUI_w, Texts_Writer__typ, 0x0d);
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"hex", (LONGINT)4);
	Texts_Write(&MyUI_w, Texts_Writer__typ, 0x0d);
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"real", (LONGINT)5);
	Texts_Write(&MyUI_w, Texts_Writer__typ, 0x0d);
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"char", (LONGINT)5);
	Texts_Write(&MyUI_w, Texts_Writer__typ, 0x0d);
	Texts_Append(menu, MyUI_w.buf);
	title = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_WriteString(&MyUI_w, Texts_Writer__typ, (CHAR*)"dec", (LONGINT)4);
	Texts_Append(title, MyUI_w.buf);
	__DialogComboBoxes_Item_SetTitle(__GUARDP(MyUI_o, DialogComboBoxes_ItemDesc, 1), title);
}

static void EnumPtrs(void (*P)(void*))
{
	P(MyUI_vwr);
	__ENUMR(&MyUI_selbeg, TextFrames_Location__typ, 20, 1, P);
	__ENUMR(&MyUI_selend, TextFrames_Location__typ, 20, 1, P);
	P(MyUI_styleElems);
	P(MyUI_p);
	P(MyUI_o);
	P(MyUI_par);
	P(MyUI_oldLog);
	P(MyUI_newLog);
	__ENUMR(&MyUI_w, Texts_Writer__typ, 36, 1, P);
	P(MyUI_vars);
}

__TDESC(MyUI_StyleElemDesc, 1, 2) = {__TDFLDS("StyleElemDesc", 8), {0, 4, -12}};
__TDESC(MyUI_VarDesc, 1, 1) = {__TDFLDS("VarDesc", 48), {40, -8}};

export void *MyUI__init(void)
{
	__DEFMOD;
	__IMPORT(DialogCheckBoxes);
	__IMPORT(DialogComboBoxes);
	__IMPORT(DialogRadioButtons);
	__IMPORT(DialogStaticTexts);
	__IMPORT(DialogTexts);
	__IMPORT(Dialogs);
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(In);
	__IMPORT(MathL);
	__IMPORT(MenuViewers);
	__IMPORT(MoreMathL);
	__IMPORT(Oberon);
	__IMPORT(Out);
	__IMPORT(ParcElems);
	__IMPORT(StyleElems);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Types);
	__IMPORT(Viewers);
	__IMPORT(XIn);
	__REGMOD(MyUI, EnumPtrs);
	__REGCMD("Adjust", MyUI_Adjust);
	__REGCMD("Break", MyUI_Break);
	__REGCMD("Clear", MyUI_Clear);
	__REGCMD("Columns", MyUI_Columns);
	__REGCMD("Comma", MyUI_Comma);
	__REGCMD("Compile", MyUI_Compile);
	__REGCMD("DoHALT", MyUI_DoHALT);
	__REGCMD("First", MyUI_First);
	__REGCMD("FirstReset", MyUI_FirstReset);
	__REGCMD("FoldsCompile", MyUI_FoldsCompile);
	__REGCMD("GetAdjust", MyUI_GetAdjust);
	__REGCMD("GetAll", MyUI_GetAll);
	__REGCMD("GetBreak", MyUI_GetBreak);
	__REGCMD("GetColumns", MyUI_GetColumns);
	__REGCMD("GetFirst", MyUI_GetFirst);
	__REGCMD("GetGrid", MyUI_GetGrid);
	__REGCMD("GetLead", MyUI_GetLead);
	__REGCMD("GetLeft", MyUI_GetLeft);
	__REGCMD("GetLine", MyUI_GetLine);
	__REGCMD("GetRight", MyUI_GetRight);
	__REGCMD("GetStyles", MyUI_GetStyles);
	__REGCMD("GetTabs", MyUI_GetTabs);
	__REGCMD("GetType", MyUI_GetType);
	__REGCMD("GetWidth", MyUI_GetWidth);
	__REGCMD("Grid", MyUI_Grid);
	__REGCMD("InitCalc", MyUI_InitCalc);
	__REGCMD("InitPrintDlg", MyUI_InitPrintDlg);
	__REGCMD("Lead", MyUI_Lead);
	__REGCMD("LeadReset", MyUI_LeadReset);
	__REGCMD("Left", MyUI_Left);
	__REGCMD("LeftReset", MyUI_LeftReset);
	__REGCMD("Line", MyUI_Line);
	__REGCMD("LineReset", MyUI_LineReset);
	__REGCMD("Num", MyUI_Num);
	__REGCMD("Op", MyUI_Op);
	__REGCMD("Print", MyUI_Print);
	__REGCMD("Replace", MyUI_Replace);
	__REGCMD("Reset", MyUI_Reset);
	__REGCMD("Right", MyUI_Right);
	__REGCMD("RightReset", MyUI_RightReset);
	__REGCMD("SaveOptions", MyUI_SaveOptions);
	__REGCMD("Search", MyUI_Search);
	__REGCMD("SearchReset", MyUI_SearchReset);
	__REGCMD("SetDefaultOptions", MyUI_SetDefaultOptions);
	__REGCMD("SetVar", MyUI_SetVar);
	__REGCMD("ShowNumber", MyUI_ShowNumber);
	__REGCMD("Style", MyUI_Style);
	__REGCMD("Tabs", MyUI_Tabs);
	__REGCMD("TabsReset1", MyUI_TabsReset1);
	__REGCMD("TabsReset2", MyUI_TabsReset2);
	__REGCMD("Variable", MyUI_Variable);
	__REGCMD("Width", MyUI_Width);
	__REGCMD("WidthReset", MyUI_WidthReset);
	__INITYP(MyUI_StyleElemDesc, MyUI_StyleElemDesc, 0);
	__INITYP(MyUI_VarDesc, MyUI_VarDesc, 0);
/* BEGIN */
	MyUI_doSearch = 1;
	Texts_OpenWriter(&MyUI_w, Texts_Writer__typ);
	MyUI_Reset();
	__ENDMOD;
}
