/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Kernel.h"
#include "OfrontOPB.h"
#include "OfrontOPC.h"
#include "OfrontOPM.h"
#include "OfrontOPP.h"
#include "OfrontOPT.h"
#include "OfrontOPV.h"




export void Ofront_Module (BOOLEAN *done);
export void Ofront_Translate (void);


void Ofront_Module (BOOLEAN *done)
{
	BOOLEAN ext = 0, new = 0;
	OfrontOPT_Node p = NIL;
	OfrontOPP_Module(&p, OfrontOPM_opt);
	if (OfrontOPM_noerr) {
		OfrontOPV_Init();
		OfrontOPV_AdrAndSize(OfrontOPT_topScope);
		OfrontOPT_Export(&ext, &new);
		if (OfrontOPM_noerr) {
			OfrontOPM_OpenFiles((void*)OfrontOPT_SelfName, 32);
			OfrontOPC_Init();
			OfrontOPV_Module(p);
			if (OfrontOPM_noerr) {
				if (__IN(10, OfrontOPM_opt) && __STRCMP(OfrontOPM_modName, "SYSTEM") != 0) {
					OfrontOPM_DeleteNewSym();
					OfrontOPM_LogWStr((CHAR*)"  main program", (LONGINT)15);
				} else {
					if (new) {
						OfrontOPM_LogWStr((CHAR*)"  new symbol file", (LONGINT)18);
						OfrontOPM_RegisterNewSym();
					} else if (ext) {
						OfrontOPM_LogWStr((CHAR*)"  extended symbol file", (LONGINT)23);
						OfrontOPM_RegisterNewSym();
					}
				}
			} else {
				OfrontOPM_DeleteNewSym();
			}
		}
	}
	OfrontOPM_CloseFiles();
	OfrontOPT_Close();
	OfrontOPM_LogWLn();
	*done = OfrontOPM_noerr;
}

void Ofront_Translate (void)
{
	BOOLEAN done = 0;
	OfrontOPM_OpenPar();
	OfrontOPT_bytetyp->size = OfrontOPM_ByteSize;
	OfrontOPT_sysptrtyp->size = OfrontOPM_PointerSize;
	OfrontOPT_chartyp->size = OfrontOPM_CharSize;
	OfrontOPT_settyp->size = OfrontOPM_SetSize;
	OfrontOPT_realtyp->size = OfrontOPM_RealSize;
	OfrontOPT_inttyp->size = OfrontOPM_IntSize;
	OfrontOPT_linttyp->size = OfrontOPM_LIntSize;
	OfrontOPT_lrltyp->size = OfrontOPM_LRealSize;
	OfrontOPT_sinttyp->size = OfrontOPM_SIntSize;
	OfrontOPT_booltyp->size = OfrontOPM_BoolSize;
	for (;;) {
		OfrontOPM_Init((CHAR*)"translating", (LONGINT)12, &done);
		if (!done) {
			break;
		}
		OfrontOPM_InitOptions();
		Ofront_Module(&done);
		Kernel_GC(1);
		if (!done) {
			break;
		}
	}
}


export void *Ofront__init(void)
{
	__DEFMOD;
	__IMPORT(Kernel);
	__IMPORT(OfrontOPB);
	__IMPORT(OfrontOPC);
	__IMPORT(OfrontOPM);
	__IMPORT(OfrontOPP);
	__IMPORT(OfrontOPT);
	__IMPORT(OfrontOPV);
	__REGMOD(Ofront, 0);
	__REGCMD("Translate", Ofront_Translate);
/* BEGIN */
	OfrontOPB_typSize = OfrontOPV_TypSize;
	OfrontOPT_typSize = OfrontOPV_TypSize;
	__ENDMOD;
}
