/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Kernel.h"
#include "OfrontOPB.h"
#include "OfrontOPC.h"
#include "OfrontOPM.h"
#include "OfrontOPP.h"
#include "OfrontOPT.h"
#include "OfrontOPV.h"
#include "Unix.h"




export void OfrontCmd_Module (BOOLEAN *done);
export void OfrontCmd_Translate (void);
static void OfrontCmd_Trap (LONGINT sig, LONGINT siginfo, LONGINT sigctx);

#define OfrontCmd_fin()	SYSTEM_FINALL()
#define OfrontCmd_halt()	SYSTEM_halt

static void OfrontCmd_Trap (LONGINT sig, LONGINT siginfo, LONGINT sigctx)
{
	OfrontCmd_fin();
	if (sig == 3) {
		Unix_Exit(1);
	} else {
		if (sig == 4 && OfrontCmd_halt() == -15) {
			OfrontOPM_LogWStr((CHAR*)" --- ofront: internal error", (LONGINT)28);
			OfrontOPM_LogWLn();
		}
		Unix_Exit(2);
	}
}

void OfrontCmd_Module (BOOLEAN *done)
{
	BOOLEAN ext = 0, new = 0;
	OfrontOPT_Node p = NIL;
	OfrontOPP_Module(&p, OfrontOPM_opt);
	if (OfrontOPM_noerr) {
		OfrontOPV_Init();
		OfrontOPV_AdrAndSize(OfrontOPT_topScope);
		OfrontOPT_Export(&ext, &new);
		if (OfrontOPM_noerr) {
			OfrontOPM_OpenFiles((void*)OfrontOPT_SelfName, 32);
			OfrontOPC_Init();
			OfrontOPV_Module(p);
			if (OfrontOPM_noerr) {
				if (__IN(10, OfrontOPM_opt) && __STRCMP(OfrontOPM_modName, "SYSTEM") != 0) {
					OfrontOPM_DeleteNewSym();
					OfrontOPM_LogWStr((CHAR*)"  main program", (LONGINT)15);
				} else {
					if (new) {
						OfrontOPM_LogWStr((CHAR*)"  new symbol file", (LONGINT)18);
						OfrontOPM_RegisterNewSym();
					} else if (ext) {
						OfrontOPM_LogWStr((CHAR*)"  extended symbol file", (LONGINT)23);
						OfrontOPM_RegisterNewSym();
					}
				}
			} else {
				OfrontOPM_DeleteNewSym();
			}
		}
	}
	OfrontOPM_CloseFiles();
	OfrontOPT_Close();
	OfrontOPM_LogWLn();
	*done = OfrontOPM_noerr;
}

void OfrontCmd_Translate (void)
{
	BOOLEAN done = 0;
	OfrontOPM_OpenPar((CHAR*)"Ofront (TM) - Oberon-2 to C Translator V1.4", (LONGINT)44, (CHAR*)"ofront", (LONGINT)7);
	OfrontOPT_bytetyp->size = OfrontOPM_ByteSize;
	OfrontOPT_sysptrtyp->size = OfrontOPM_PointerSize;
	OfrontOPT_chartyp->size = OfrontOPM_CharSize;
	OfrontOPT_settyp->size = OfrontOPM_SetSize;
	OfrontOPT_realtyp->size = OfrontOPM_RealSize;
	OfrontOPT_inttyp->size = OfrontOPM_IntSize;
	OfrontOPT_linttyp->size = OfrontOPM_LIntSize;
	OfrontOPT_lrltyp->size = OfrontOPM_LRealSize;
	OfrontOPT_sinttyp->size = OfrontOPM_SIntSize;
	OfrontOPT_booltyp->size = OfrontOPM_BoolSize;
	for (;;) {
		OfrontOPM_Init((CHAR*)"translating", (LONGINT)12, &done);
		if (!done) {
			if (!OfrontOPM_noerr) {
				OfrontCmd_fin();
				Unix_Exit(1);
			}
			break;
		}
		OfrontOPM_InitOptions();
		Kernel_GC(0);
		OfrontCmd_Module(&done);
		if (!done) {
			OfrontCmd_fin();
			Unix_Exit(1);
		}
	}
}


int main(int argc, char **argv)
{
	__INIT(argc, argv);
	__IMPORT(Kernel);
	__IMPORT(OfrontOPB);
	__IMPORT(OfrontOPC);
	__IMPORT(OfrontOPM);
	__IMPORT(OfrontOPP);
	__IMPORT(OfrontOPT);
	__IMPORT(OfrontOPV);
	__IMPORT(Unix);
	__REGMAIN(OfrontCmd, 0);
	__REGCMD("Translate", OfrontCmd_Translate);
/* BEGIN */
	Unix_SigSetHandler(2, OfrontCmd_Trap);
	Unix_SigSetHandler(3, OfrontCmd_Trap);
	Unix_SigSetHandler(4, OfrontCmd_Trap);
	OfrontOPB_typSize = OfrontOPV_TypSize;
	OfrontOPT_typSize = OfrontOPV_TypSize;
	OfrontCmd_Translate();
	__FINI;
}
