/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Directories.h"
#include "Display.h"
#include "Oberon.h"
#include "PopupElems.h"
#include "Strings.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct OpenElems_AutoDirElemDesc *OpenElems_AutoDirElem;

typedef
	struct OpenElems_OpenElemDesc { /* PopupElems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		CHAR name[32];
		Texts_Text menu;
		BOOLEAN small;
		INTEGER n, default_;
		char _prvt2[4];
		SET options;
	} OpenElems_OpenElemDesc;

typedef
	struct OpenElems_AutoDirElemDesc { /* OpenElems_OpenElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		CHAR name[32];
		Texts_Text menu;
		BOOLEAN small;
		INTEGER n, default_;
		char _prvt2[4];
		SET options;
	} OpenElems_AutoDirElemDesc;

typedef
	OpenElems_OpenElemDesc *OpenElems_OpenElem;


static Texts_Writer OpenElems_w;
static INTEGER OpenElems_cnt;
static OpenElems_OpenElem OpenElems_elem;
static CHAR OpenElems_pattern[32];

export LONGINT *OpenElems_OpenElemDesc__typ;
export LONGINT *OpenElems_AutoDirElemDesc__typ;

static void OpenElems_AddName (CHAR *name, LONGINT name__len);
export void OpenElems_Alloc (void);
export void OpenElems_AllocAutoDir (void);
static void OpenElems_CollectFiles (void);
static void OpenElems_Exec (OpenElems_OpenElem e, Display_Frame f, LONGINT pos);
export void OpenElems_Handle (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ);
export void OpenElems_HandleAutoDir (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ);
export void OpenElems_Insert (void);
export void OpenElems_InsertAutoDir (void);
export void OpenElems_InsertMenu (void);
static void OpenElems_ListProc (Directories_Directory d, CHAR *name, LONGINT name__len, BOOLEAN isDir, BOOLEAN *continue_);
static void OpenElems_ReadName (Texts_Text t, LONGINT pos, CHAR *name, LONGINT name__len);
static void OpenElems_WriteName (CHAR *name, LONGINT name__len);
static void OpenElems_insert (SET options);


static void OpenElems_ReadName (Texts_Text t, LONGINT pos, CHAR *name, LONGINT name__len)
{
	Texts_Reader r = {0};
	CHAR ch = 0;
	INTEGER i = 0;
	LONGINT beg = 0, end = 0, time = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, t, pos);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	i = 0;
	if (ch == '\"') {
		Texts_Read(&r, Texts_Reader__typ, &ch);
		while (!r.eot && ch != '\"') {
			name[__X(i, name__len)] = ch;
			i += 1;
			Texts_Read(&r, Texts_Reader__typ, &ch);
		}
	} else {
		while (!r.eot && ch > ' ') {
			name[__X(i, name__len)] = ch;
			i += 1;
			Texts_Read(&r, Texts_Reader__typ, &ch);
		}
	}
	name[__X(i, name__len)] = 0x00;
	if (__STRCMP(name, "^") == 0) {
		Oberon_GetSelection(&t, &beg, &end, &time);
		if (time >= 0) {
			OpenElems_ReadName(t, beg, name, name__len);
		}
	}
}

static void OpenElems_Exec (OpenElems_OpenElem e, Display_Frame f, LONGINT pos)
{
	TextFrames_UpdateMsg m = {0};
	INTEGER res = 0;
	CHAR name[256];
	Oberon_ParList par = NIL;
	Directories_Directory dir = NIL;
	OpenElems_ReadName(e->menu, pos, (void*)name, 256);
	dir = Directories_This(name, 256);
	if (dir != NIL) {
		Directories_Change(dir->path, 128);
	} else {
		__NEW(par, Oberon_ParRec);
		par->frame = f;
		par->text = e->menu;
		par->pos = pos;
		Oberon_Call((CHAR*)"Documents.Open", (LONGINT)15, par, 0, &res);
		if (res == 0) {
			m.id = 0;
			m.text = Texts_ElemBase((void*)e);
			m.beg = Texts_ElemPos((void*)e);
			m.end = m.beg + 1;
			Viewers_Broadcast((void*)&m, TextFrames_UpdateMsg__typ);
		} else {
			Texts_WriteString(&OpenElems_w, Texts_Writer__typ, (CHAR*)" -- failed", (LONGINT)11);
			Texts_WriteLn(&OpenElems_w, Texts_Writer__typ);
			Texts_Append(Oberon_Log, OpenElems_w.buf);
		}
	}
}

void OpenElems_Handle (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ)
{
	OpenElems_OpenElem e1 = NIL;
	if (__ISP(e, OpenElems_OpenElemDesc, 3)) {
		if (__IS(m__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *m__ = (void*)m;
			if ((*m__).e == NIL) {
				__NEW(e1, OpenElems_OpenElemDesc);
				(*m__).e = (Texts_Elem)e1;
			}
			PopupElems_Handle((void*)(*(OpenElems_OpenElem*)&e), (void*)&*m__, m__typ);
		} else if (__IS(m__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *m__ = (void*)m;
			__MOVE("OpenElems", (*m__).mod, 10);
			__MOVE("Alloc", (*m__).proc, 6);
		} else if (__IS(m__typ, PopupElems_ExecMsg, 1)) {
			PopupElems_ExecMsg *m__ = (void*)m;
			OpenElems_Exec((*(OpenElems_OpenElem*)&e), (*m__).frame, (*m__).pos);
		} else {
			PopupElems_Handle((void*)(*(OpenElems_OpenElem*)&e), &*m, m__typ);
		}
	} else __WITHCHK;
}

void OpenElems_Alloc (void)
{
	OpenElems_OpenElem e = NIL;
	__NEW(e, OpenElems_OpenElemDesc);
	e->handle = OpenElems_Handle;
	Texts_new = (Texts_Elem)e;
}

static void OpenElems_insert (SET options)
{
	OpenElems_OpenElem e = NIL;
	TextFrames_InsertElemMsg insert = {0};
	Texts_Scanner s = {0};
	__NEW(e, OpenElems_OpenElemDesc);
	e->handle = OpenElems_Handle;
	e->small = 1;
	e->options = options;
	Texts_OpenScanner(&s, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&s, Texts_Scanner__typ);
	if (!__IN(s.class, 0x06)) {
		__MOVE("OpenElem", s.s, 9);
	}
	__COPY(s.s, e->name, 32);
	e->menu = TextFrames_Text((CHAR*)"", (LONGINT)1);
	PopupElems_MeasureMenu((void*)e);
	insert.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&insert, TextFrames_InsertElemMsg__typ);
}

void OpenElems_Insert (void)
{
	OpenElems_insert(0x0);
}

void OpenElems_InsertMenu (void)
{
	OpenElems_insert(0x03);
}

static void OpenElems_WriteName (CHAR *name, LONGINT name__len)
{
	CHAR ch = 0;
	INTEGER i = 0;
	CHAR quote = 0;
	__DUP(name, name__len, CHAR);
	ch = name[0];
	i = 0;
	quote = '\"';
	while (ch != 0x00 && ((((('a' <= ch && ch <= 'z' || 'A' <= ch && ch <= 'Z') || ch == '.') || ch == '/') || ch == '$') || i > 0 && ('0' <= ch && ch <= '9' || ch == ':'))) {
		if (ch == '\"') {
			quote = '\'';
		} else if (ch == '\'') {
			quote = '\"';
		}
		i += 1;
		ch = name[__X(i, name__len)];
	}
	if (ch != 0x00) {
		Texts_Write(&OpenElems_w, Texts_Writer__typ, quote);
	}
	Texts_WriteString(&OpenElems_w, Texts_Writer__typ, name, name__len);
	if (ch != 0x00) {
		Texts_Write(&OpenElems_w, Texts_Writer__typ, quote);
	}
	__DEL(name);
}

static void OpenElems_AddName (CHAR *name, LONGINT name__len)
{
	Texts_Scanner s = {0};
	LONGINT pos = 0;
	Texts_OpenScanner(&s, Texts_Scanner__typ, OpenElems_elem->menu, 0);
	Texts_Scan(&s, Texts_Scanner__typ);
	pos = 0;
	while ((s.class == 2 || s.class == 1) && __STRCMP(s.s, name) < 0) {
		pos = Texts_Pos((void*)&s, Texts_Scanner__typ);
		Texts_Scan(&s, Texts_Scanner__typ);
	}
	Texts_Insert(OpenElems_elem->menu, pos, OpenElems_w.buf);
}

static void OpenElems_ListProc (Directories_Directory d, CHAR *name, LONGINT name__len, BOOLEAN isDir, BOOLEAN *continue_)
{
	SHORTINT col = 0;
	__DUP(name, name__len, CHAR);
	if (Strings_Match(name, name__len, OpenElems_pattern, 32) || isDir) {
		if (isDir) {
			col = 3;
		} else {
			col = 15;
		}
		Texts_SetColor(&OpenElems_w, Texts_Writer__typ, col);
		OpenElems_WriteName(name, name__len);
		Texts_WriteLn(&OpenElems_w, Texts_Writer__typ);
		OpenElems_AddName((void*)name, name__len);
		OpenElems_cnt += 1;
	}
	__DEL(name);
}

static void OpenElems_CollectFiles (void)
{
	OpenElems_elem->menu = TextFrames_Text((CHAR*)"", (LONGINT)1);
	OpenElems_cnt = 0;
	__COPY(OpenElems_elem->name, OpenElems_pattern, 32);
	Directories_Enumerate(Directories_Current(), OpenElems_ListProc);
	if (OpenElems_cnt == 1) {
		Texts_WriteLn(&OpenElems_w, Texts_Writer__typ);
	} else if (OpenElems_cnt == 0) {
		Texts_WriteString(&OpenElems_w, Texts_Writer__typ, (CHAR*)"no files found", (LONGINT)15);
		Texts_WriteLn(&OpenElems_w, Texts_Writer__typ);
		Texts_WriteLn(&OpenElems_w, Texts_Writer__typ);
	}
	Texts_Append(OpenElems_elem->menu, OpenElems_w.buf);
	PopupElems_MeasureMenu((void*)OpenElems_elem);
}

void OpenElems_HandleAutoDir (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ)
{
	OpenElems_AutoDirElem e1 = NIL;
	if (__ISP(e, OpenElems_AutoDirElemDesc, 4)) {
		if (__IS(m__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *m__ = (void*)m;
			if ((*m__).e == NIL) {
				__NEW(e1, OpenElems_AutoDirElemDesc);
				(*m__).e = (Texts_Elem)e1;
			}
			OpenElems_Handle((void*)(*(OpenElems_AutoDirElem*)&e), (void*)&*m__, m__typ);
		} else if (__IS(m__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *m__ = (void*)m;
			__MOVE("OpenElems", (*m__).mod, 10);
			__MOVE("AllocAutoDir", (*m__).proc, 13);
		} else if (__IS(m__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *m__ = (void*)m;
			if (__IN(1, (*m__).keys)) {
				OpenElems_elem = (OpenElems_OpenElem)(*(OpenElems_AutoDirElem*)&e);
				OpenElems_CollectFiles();
				OpenElems_Handle((void*)(*(OpenElems_AutoDirElem*)&e), (void*)&*m__, m__typ);
				OpenElems_elem = NIL;
			}
		} else {
			OpenElems_Handle((void*)(*(OpenElems_AutoDirElem*)&e), &*m, m__typ);
		}
	} else __WITHCHK;
}

void OpenElems_AllocAutoDir (void)
{
	OpenElems_AutoDirElem e = NIL;
	__NEW(e, OpenElems_AutoDirElemDesc);
	e->handle = OpenElems_HandleAutoDir;
	Texts_new = (Texts_Elem)e;
}

void OpenElems_InsertAutoDir (void)
{
	OpenElems_AutoDirElem e = NIL;
	TextFrames_InsertElemMsg insert = {0};
	__NEW(e, OpenElems_AutoDirElemDesc);
	e->handle = OpenElems_HandleAutoDir;
	e->small = 1;
	__MOVE("*", e->name, 2);
	e->menu = TextFrames_Text((CHAR*)"", (LONGINT)1);
	PopupElems_MeasureMenu((void*)e);
	insert.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&insert, TextFrames_InsertElemMsg__typ);
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&OpenElems_w, Texts_Writer__typ, 36, 1, P);
	P(OpenElems_elem);
}

__TDESC(OpenElems_OpenElemDesc, 1, 5) = {__TDFLDS("OpenElemDesc", 88), {0, 4, 12, 32, 68, -24}};
__TDESC(OpenElems_AutoDirElemDesc, 1, 5) = {__TDFLDS("AutoDirElemDesc", 88), {0, 4, 12, 32, 68, -24}};

export void *OpenElems__init(void)
{
	__DEFMOD;
	__IMPORT(Directories);
	__IMPORT(Display);
	__IMPORT(Oberon);
	__IMPORT(PopupElems);
	__IMPORT(Strings);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(OpenElems, EnumPtrs);
	__REGCMD("Alloc", OpenElems_Alloc);
	__REGCMD("AllocAutoDir", OpenElems_AllocAutoDir);
	__REGCMD("Insert", OpenElems_Insert);
	__REGCMD("InsertAutoDir", OpenElems_InsertAutoDir);
	__REGCMD("InsertMenu", OpenElems_InsertMenu);
	__INITYP(OpenElems_OpenElemDesc, PopupElems_ElemDesc, 3);
	__INITYP(OpenElems_AutoDirElemDesc, OpenElems_OpenElemDesc, 4);
/* BEGIN */
	Texts_OpenWriter(&OpenElems_w, Texts_Writer__typ);
	__ENDMOD;
}
