/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Oberon.h"
#include "Texts.h"


static Texts_Writer Out_W;


export void Out_Char (CHAR ch);
export void Out_F (CHAR *s, LONGINT s__len, LONGINT x);
static void Out_F0 (CHAR *s, LONGINT s__len, LONGINT *x, LONGINT x__len);
export void Out_F2 (CHAR *s, LONGINT s__len, LONGINT x, LONGINT y);
export void Out_F3 (CHAR *s, LONGINT s__len, LONGINT x, LONGINT y, LONGINT z);
export void Out_F4 (CHAR *s, LONGINT s__len, LONGINT x, LONGINT y, LONGINT z, LONGINT u);
export void Out_Int (LONGINT i, LONGINT n);
export void Out_Ln (void);
export void Out_LongReal (LONGREAL x, INTEGER n);
export void Out_Open (void);
export void Out_Real (REAL x, INTEGER n);
export void Out_String (CHAR *str, LONGINT str__len);


void Out_Ln (void)
{
	Texts_WriteLn(&Out_W, Texts_Writer__typ);
	Texts_Append(Oberon_Log, Out_W.buf);
}

void Out_Open (void)
{
	Texts_Reader R = {0};
	CHAR ch = 0;
	if (Oberon_Log->len > 0) {
		Texts_OpenReader(&R, Texts_Reader__typ, Oberon_Log, Oberon_Log->len - 1);
		Texts_Read(&R, Texts_Reader__typ, &ch);
		if (ch != 0x0d) {
			Out_Ln();
		}
	}
}

void Out_Char (CHAR ch)
{
	Texts_Write(&Out_W, Texts_Writer__typ, ch);
	Texts_Append(Oberon_Log, Out_W.buf);
}

void Out_String (CHAR *str, LONGINT str__len)
{
	__DUP(str, str__len, CHAR);
	Texts_WriteString(&Out_W, Texts_Writer__typ, str, str__len);
	Texts_Append(Oberon_Log, Out_W.buf);
	__DEL(str);
}

void Out_Int (LONGINT i, LONGINT n)
{
	Texts_WriteInt(&Out_W, Texts_Writer__typ, i, n);
	Texts_Append(Oberon_Log, Out_W.buf);
}

void Out_Real (REAL x, INTEGER n)
{
	Texts_WriteReal(&Out_W, Texts_Writer__typ, x, n);
	Texts_Append(Oberon_Log, Out_W.buf);
}

void Out_LongReal (LONGREAL x, INTEGER n)
{
	Texts_WriteLongReal(&Out_W, Texts_Writer__typ, x, n);
	Texts_Append(Oberon_Log, Out_W.buf);
}

static void Out_F0 (CHAR *s, LONGINT s__len, LONGINT *x, LONGINT x__len)
{
	INTEGER i = 0, j = 0;
	__DUP(s, s__len, CHAR);
	__DUP(x, x__len, LONGINT);
	i = 0;
	j = 0;
	while (s[__X(i, s__len)] != 0x00) {
		if (s[__X(i, s__len)] == '$') {
			Out_Ln();
		} else if (s[__X(i, s__len)] == '#') {
			Out_Int(x[__X(j, x__len)], 0);
			j += 1;
		} else {
			Texts_Write(&Out_W, Texts_Writer__typ, s[__X(i, s__len)]);
		}
		i += 1;
	}
	Texts_Append(Oberon_Log, Out_W.buf);
	__DEL(s);
	__DEL(x);
}

void Out_F (CHAR *s, LONGINT s__len, LONGINT x)
{
	LONGINT a[4];
	__DUP(s, s__len, CHAR);
	a[0] = x;
	a[1] = 0;
	a[2] = 0;
	a[3] = 0;
	Out_F0(s, s__len, a, 4);
	__DEL(s);
}

void Out_F2 (CHAR *s, LONGINT s__len, LONGINT x, LONGINT y)
{
	LONGINT a[4];
	__DUP(s, s__len, CHAR);
	a[0] = x;
	a[1] = y;
	a[2] = 0;
	a[3] = 0;
	Out_F0(s, s__len, a, 4);
	__DEL(s);
}

void Out_F3 (CHAR *s, LONGINT s__len, LONGINT x, LONGINT y, LONGINT z)
{
	LONGINT a[4];
	__DUP(s, s__len, CHAR);
	a[0] = x;
	a[1] = y;
	a[2] = z;
	a[3] = 0;
	Out_F0(s, s__len, a, 4);
	__DEL(s);
}

void Out_F4 (CHAR *s, LONGINT s__len, LONGINT x, LONGINT y, LONGINT z, LONGINT u)
{
	LONGINT a[4];
	__DUP(s, s__len, CHAR);
	a[0] = x;
	a[1] = y;
	a[2] = z;
	a[3] = u;
	Out_F0(s, s__len, a, 4);
	__DEL(s);
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&Out_W, Texts_Writer__typ, 36, 1, P);
}


export void *Out__init(void)
{
	__DEFMOD;
	__IMPORT(Oberon);
	__IMPORT(Texts);
	__REGMOD(Out, EnumPtrs);
	__REGCMD("Ln", Out_Ln);
	__REGCMD("Open", Out_Open);
/* BEGIN */
	Texts_OpenWriter(&Out_W, Texts_Writer__typ);
	__ENDMOD;
}
