/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Elems.h"
#include "Files.h"
#include "Fonts.h"
#include "GUtils.h"
#include "Input.h"
#include "MenuViewers.h"
#include "Oberon.h"
#include "Out.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct PanelElems_CaseDesc *PanelElems_Case;

typedef
	struct PanelElems_CaseDesc {
		INTEGER x, y;
		LONGINT oldW, oldH;
		SET state;
		Texts_Elem e;
		PanelElems_Case next, prev;
	} PanelElems_CaseDesc;

typedef
	struct PanelElems_PanelDesc *PanelElems_Panel;

typedef
	struct PanelElems_SelectionDesc *PanelElems_Selection;

typedef
	struct PanelElems_CopyOverMsg { /* Oberon_CopyOverMsg */
		Texts_Text text;
		LONGINT beg, end;
		PanelElems_Panel p;
		PanelElems_Selection sel;
	} PanelElems_CopyOverMsg;

typedef
	struct PanelElems_FrameDesc *PanelElems_Frame;

typedef
	struct PanelElems_FrameDesc { /* Display_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		PanelElems_Panel p;
		INTEGER cx, cy;
		BOOLEAN hasCar;
		INTEGER oldY, x, y;
	} PanelElems_FrameDesc;

typedef
	struct PanelElems_NotifyMsg { /* Display_FrameMsg */
		PanelElems_Panel p;
		SET id;
		Texts_Elem elem;
		INTEGER x, y, w, h;
	} PanelElems_NotifyMsg;

typedef
	struct PanelElems_TextDesc *PanelElems_Text;

typedef
	struct PanelElems_PanelDesc { /* Elems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[8];
		BOOLEAN locked;
		PanelElems_Case contents, last;
		INTEGER border;
		PanelElems_Selection sel, lastSel;
		LONGINT selTime;
		PanelElems_Text elemTxt;
		BOOLEAN showTabs;
	} PanelElems_PanelDesc;

typedef
	struct PanelElems_SelElemDesc *PanelElems_SelElem;

typedef
	struct PanelElems_SelElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		Texts_Elem e;
	} PanelElems_SelElemDesc;

typedef
	struct PanelElems_SelectionDesc {
		PanelElems_Case c;
		PanelElems_Selection next;
	} PanelElems_SelectionDesc;

typedef
	struct PanelElems_SelectionMsg { /* Oberon_SelectionMsg */
		LONGINT time;
		Texts_Text text;
		LONGINT beg, end;
		PanelElems_Panel p;
		PanelElems_Selection sel;
	} PanelElems_SelectionMsg;

typedef
	struct PanelElems_TextDesc { /* Texts_TextDesc */
		LONGINT len;
		Texts_Notifier notify;
		char _prvt0[12];
		PanelElems_Panel base;
	} PanelElems_TextDesc;


static Texts_Writer PanelElems_W;
static TextFrames_Frame PanelElems_elemTxtFrame;
static INTEGER PanelElems_clp;

export LONGINT *PanelElems_CaseDesc__typ;
export LONGINT *PanelElems_SelectionDesc__typ;
export LONGINT *PanelElems_TextDesc__typ;
export LONGINT *PanelElems_FrameDesc__typ;
export LONGINT *PanelElems_PanelDesc__typ;
export LONGINT *PanelElems_SelElemDesc__typ;
export LONGINT *PanelElems_SelectionMsg__typ;
export LONGINT *PanelElems_CopyOverMsg__typ;
export LONGINT *PanelElems_NotifyMsg__typ;

export void PanelElems_AppendToSelection (PanelElems_Panel p, PanelElems_Case c);
static void PanelElems_ChangePos (PanelElems_Frame f, PanelElems_Case c, INTEGER dx, INTEGER dy);
static void PanelElems_ClearArea (PanelElems_Frame f, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static void PanelElems_CopyInto (PanelElems_Frame f);
static void PanelElems_CopyOver (PanelElems_Frame f, Oberon_CopyOverMsg *msg, LONGINT *msg__typ);
export void PanelElems_CopyPanel (PanelElems_Panel from, PanelElems_Panel to);
export void PanelElems_DeleteCase (PanelElems_Panel p, PanelElems_Case c);
static void PanelElems_DeleteElem (PanelElems_Panel p, Texts_Elem e);
export void PanelElems_DeleteSelection (PanelElems_Frame f);
export void PanelElems_DrawContents (PanelElems_Panel p, Display_Frame f, INTEGER x0, INTEGER y0);
export void PanelElems_DrawPanel (PanelElems_Panel p, INTEGER x, INTEGER y, INTEGER color, Display_Frame f);
export void PanelElems_DrawTextElem (PanelElems_Panel p, PanelElems_Case c, Display_Frame f, INTEGER x0, INTEGER y0);
export void PanelElems_FrameHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
static BOOLEAN PanelElems_FullyVisible (PanelElems_Frame f, PanelElems_Case c, INTEGER w, INTEGER h);
export void PanelElems_Handle (Texts_Elem p, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void PanelElems_HandleAttrMsg (PanelElems_Panel p, Elems_AttrMsg *msg, LONGINT *msg__typ);
static void PanelElems_HandleFileMsg (PanelElems_Panel p, Texts_FileMsg *msg, LONGINT *msg__typ);
static void PanelElems_HandleInput (PanelElems_Frame f, Oberon_InputMsg *msg, LONGINT *msg__typ);
export BOOLEAN PanelElems_InArea (INTEGER ax, INTEGER ay, INTEGER aw, INTEGER ah, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
export BOOLEAN PanelElems_InBorder (INTEGER mX, INTEGER mY, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
export void PanelElems_Init (PanelElems_Panel p);
export void PanelElems_Insert (void);
export void PanelElems_InsertElem (PanelElems_Panel p, Texts_Elem e, INTEGER x, INTEGER y, Fonts_Font fnt, SHORTINT col);
static void PanelElems_InvertCaret (PanelElems_Frame f);
static void PanelElems_InvertMoving (PanelElems_Frame f, PanelElems_Case c, INTEGER dx, INTEGER dy);
static void PanelElems_InvertSelected (PanelElems_Frame f, PanelElems_Case c);
static void PanelElems_MarkMenu (Display_Frame f);
static void PanelElems_Move (PanelElems_Frame f, PanelElems_Case c);
export PanelElems_Case PanelElems_MyCase (PanelElems_Panel p, Texts_Elem e);
export void PanelElems_New (void);
export PanelElems_Selection PanelElems_NextSel (PanelElems_Selection s);
static void PanelElems_NoNotify (Texts_Text t, INTEGER op, LONGINT beg, LONGINT end);
static void PanelElems_NotifySubFrames (PanelElems_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
export Display_Frame PanelElems_OpenFrame (PanelElems_Panel p, Display_Frame f, Display_Handler handle, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
export BOOLEAN PanelElems_OverlapsArea (INTEGER ax, INTEGER ay, INTEGER aw, INTEGER ah, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
export void PanelElems_PrintTextElem (PanelElems_Panel p, PanelElems_Case c, Display_Frame f, INTEGER x0, INTEGER y0);
static void PanelElems_RefreshArea (PanelElems_Frame f, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h);
export void PanelElems_RemoveCaret (PanelElems_Frame f);
export void PanelElems_RemoveFromSelection (PanelElems_Panel p, PanelElems_Case c);
export void PanelElems_RemoveSelection (PanelElems_Frame f);
static void PanelElems_RemoveSubFrames (PanelElems_Frame f, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static void PanelElems_SelElemHandle (Texts_Elem s, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void PanelElems_SelTextNotifier (Texts_Text t, INTEGER op, LONGINT beg, LONGINT end);
static void PanelElems_SelToPanel (PanelElems_Frame f, PanelElems_Selection sel);
static Texts_Text PanelElems_SelectionToText (PanelElems_Frame f);
static void PanelElems_SendSelection (PanelElems_Frame f);
export void PanelElems_SetCaret (PanelElems_Frame f, INTEGER X, INTEGER Y);
export void PanelElems_SetFrameCoords (PanelElems_Frame f, INTEGER X, INTEGER Y, INTEGER W, INTEGER H);
static void PanelElems_TextSelToPanel (PanelElems_Frame f, Texts_Text t, LONGINT beg, LONGINT end);
export PanelElems_Case PanelElems_ThisCase (PanelElems_Panel p, INTEGER x, INTEGER y, INTEGER x0, INTEGER y0);
static Texts_Elem PanelElems_ThisElem (Texts_Text t, LONGINT pos);
static Display_Frame PanelElems_ThisSubFrame (PanelElems_Frame f, INTEGER x, INTEGER y);
static void PanelElems_ToBottom (PanelElems_Panel p, PanelElems_Case c);
static void PanelElems_ToChilds (PanelElems_Panel p, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void PanelElems_ToTop (PanelElems_Panel p, PanelElems_Case c);
static void PanelElems_ToggleCaret (PanelElems_Frame f);
static void PanelElems_TrackRubberBand (PanelElems_Frame f, INTEGER ix, INTEGER iy, SET keys);
export void PanelElems_TruncateFrame (PanelElems_Frame f, INTEGER *X, INTEGER *Y, INTEGER *W, INTEGER *H);
export void PanelElems_UpdateArea (PanelElems_Panel p, INTEGER x, INTEGER y, INTEGER w, INTEGER h, SET id);


static void PanelElems_NoNotify (Texts_Text t, INTEGER op, LONGINT beg, LONGINT end)
{
}

static void PanelElems_MarkMenu (Display_Frame f)
{
	Texts_Reader r = {0};
	Viewers_Viewer v = NIL;
	Texts_Text t = NIL;
	CHAR ch = 0;
	v = Viewers_This(f->X, f->Y);
	if ((__ISP(v, MenuViewers_ViewerDesc, 2) && __ISP(v->dsc, TextFrames_FrameDesc, 1)) && f != v->dsc) {
		t = __GUARDP(v->dsc, TextFrames_FrameDesc, 1)->text;
		if (t->len > 0) {
			Texts_OpenReader(&r, Texts_Reader__typ, t, t->len - 1);
			Texts_Read(&r, Texts_Reader__typ, &ch);
		} else {
			ch = 0x00;
		}
		if (ch != '!') {
			Texts_SetFont(&PanelElems_W, Texts_Writer__typ, Fonts_Default);
			Texts_SetColor(&PanelElems_W, Texts_Writer__typ, 15);
			Texts_SetOffset(&PanelElems_W, Texts_Writer__typ, 0);
			Texts_Write(&PanelElems_W, Texts_Writer__typ, '!');
			Texts_Append(t, PanelElems_W.buf);
		}
	}
}

void PanelElems_TruncateFrame (PanelElems_Frame f, INTEGER *X, INTEGER *Y, INTEGER *W, INTEGER *H)
{
	INTEGER w = 0, h = 0, d = 0;
	if (f == NIL) {
		return;
	}
	w = (int)__DIV(f->p->W, (LONGINT)TextFrames_Unit);
	h = (int)__DIV(f->p->H, (LONGINT)TextFrames_Unit);
	*X = f->X;
	*Y = f->Y;
	*W = f->W;
	*H = f->H;
	d = (f->x + f->p->border) - f->X;
	if (d > 0) {
		f->X += d;
		f->W -= d;
	}
	d = (f->y + f->p->border) - f->Y;
	if (d > 0) {
		f->Y += d;
		f->H -= d;
	}
	d = (f->X + f->W) - ((f->x + w) - f->p->border);
	if (d > 0) {
		f->W -= d;
	}
	d = (f->Y + f->H) - ((f->y + h) - f->p->border);
	if (d > 0) {
		f->H -= d;
	}
}

void PanelElems_SetFrameCoords (PanelElems_Frame f, INTEGER X, INTEGER Y, INTEGER W, INTEGER H)
{
	if (f != NIL) {
		f->X = X;
		f->Y = Y;
		f->W = W;
		f->H = H;
	}
}

BOOLEAN PanelElems_InArea (INTEGER ax, INTEGER ay, INTEGER aw, INTEGER ah, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	return ((y >= ay && y + h <= ay + ah) && x >= ax) && x + w <= ax + aw;
}

BOOLEAN PanelElems_OverlapsArea (INTEGER ax, INTEGER ay, INTEGER aw, INTEGER ah, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	INTEGER ax2 = 0, ay2 = 0, x2 = 0, y2 = 0;
	ax2 = (ax + aw) - 1;
	ay2 = (ay + ah) - 1;
	x2 = (x + w) - 1;
	y2 = (y + h) - 1;
	return ((x <= ax && x2 >= ax || x >= ax && x2 <= ax2) || x <= ax2 && x2 >= ax2) && ((y <= ay && y2 >= ay || y >= ay && y2 <= ay2) || y <= ay2 && y2 >= ay2);
}

BOOLEAN PanelElems_InBorder (INTEGER mX, INTEGER mY, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	return ((mX < x + PanelElems_clp || mX > (x + w) - PanelElems_clp) || mY < y + PanelElems_clp) || mY > (y + h) - PanelElems_clp;
}

void PanelElems_InsertElem (PanelElems_Panel p, Texts_Elem e, INTEGER x, INTEGER y, Fonts_Font fnt, SHORTINT col)
{
	PanelElems_Case c = NIL;
	Elems_AttrMsg attr = {0};
	Texts_Notifier notifier = NIL;
	__NEW(c, PanelElems_CaseDesc);
	c->state = 0x0;
	c->oldH = -1;
	c->oldW = -1;
	c->prev = NIL;
	c->next = p->contents;
	if (p->contents != NIL) {
		p->contents->prev = c;
	} else {
		p->last = c;
	}
	p->contents = c;
	Elems_GetSet(e, (CHAR*)"!#cstate", (LONGINT)9, &c->state);
	attr.id = 1;
	__COPY("$#cstate", attr.name, 64);
	(*e->handle)(e, (void*)&attr, Elems_AttrMsg__typ);
	if (Elems_Done) {
		c->state = attr.set;
	}
	c->e = e;
	c->x = x;
	c->y = y;
	c->oldH = -1;
	notifier = p->elemTxt->notify;
	p->elemTxt->notify = PanelElems_NoNotify;
	Texts_SetFont(&PanelElems_W, Texts_Writer__typ, fnt);
	Texts_SetColor(&PanelElems_W, Texts_Writer__typ, col);
	Texts_WriteElem(&PanelElems_W, Texts_Writer__typ, e);
	Texts_Append((void*)p->elemTxt, PanelElems_W.buf);
	p->elemTxt->notify = notifier;
}

static void PanelElems_ToChilds (PanelElems_Panel p, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	PanelElems_Case c = NIL;
	c = p->contents;
	while (c != NIL) {
		(*c->e->handle)(c->e, &*msg, msg__typ);
		c = c->next;
	}
}

static void PanelElems_NotifySubFrames (PanelElems_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	Display_Frame sub = NIL;
	sub = f->dsc;
	while (sub != NIL) {
		(*sub->handle)(sub, &*msg, msg__typ);
		sub = sub->next;
	}
}

static Display_Frame PanelElems_ThisSubFrame (PanelElems_Frame f, INTEGER x, INTEGER y)
{
	Display_Frame sub = NIL;
	BOOLEAN done = 0;
	sub = f->dsc;
	done = 0;
	while (sub != NIL && !done) {
		done = ((sub->X <= x && sub->X + sub->W >= x) && sub->Y <= y) && sub->Y + sub->H >= y;
		if (!done) {
			sub = sub->next;
		}
	}
	return sub;
}

static struct RemoveSubFrames__47 {
	INTEGER *x, *y, *w, *h;
	Display_Frame *s;
	struct RemoveSubFrames__47 *lnk;
} *RemoveSubFrames__47_s;

static BOOLEAN Overlaps__48 (void);

static BOOLEAN Overlaps__48 (void)
{
	return PanelElems_OverlapsArea(*RemoveSubFrames__47_s->x, *RemoveSubFrames__47_s->y, *RemoveSubFrames__47_s->w, *RemoveSubFrames__47_s->h, (*RemoveSubFrames__47_s->s)->X, (*RemoveSubFrames__47_s->s)->Y, (*RemoveSubFrames__47_s->s)->W, (*RemoveSubFrames__47_s->s)->H);
}

static void PanelElems_RemoveSubFrames (PanelElems_Frame f, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	Display_Frame p = NIL, s = NIL;
	MenuViewers_ModifyMsg msg = {0};
	struct RemoveSubFrames__47 _s;
	_s.x = &x;
	_s.y = &y;
	_s.w = &w;
	_s.h = &h;
	_s.s = &s;
	_s.lnk = RemoveSubFrames__47_s;
	RemoveSubFrames__47_s = &_s;
	s = f->dsc;
	if (s != NIL) {
		p = s;
		s = p->next;
	}
	while (s != NIL) {
		if (Overlaps__48()) {
			p->next = s->next;
			msg.id = 1;
			msg.dY = 0;
			msg.Y = f->Y;
			msg.H = 0;
			(*s->handle)(s, (void*)&msg, MenuViewers_ModifyMsg__typ);
		} else {
			p = s;
		}
		s = p->next;
	}
	s = f->dsc;
	if (s != NIL && Overlaps__48()) {
		f->dsc = f->dsc->next;
		msg.id = 1;
		msg.dY = 0;
		msg.Y = f->Y;
		msg.H = 0;
		(*s->handle)(s, (void*)&msg, MenuViewers_ModifyMsg__typ);
	}
	RemoveSubFrames__47_s = _s.lnk;
}

static void PanelElems_ToBottom (PanelElems_Panel p, PanelElems_Case c)
{
	PanelElems_Case cc = NIL;
	if (p->contents->next == NIL || c->next == NIL) {
		return;
	}
	if (p->contents == c && p->contents->next != NIL) {
		p->contents = p->contents->next;
		p->contents->prev = NIL;
		cc = p->contents;
	} else {
		cc = p->contents;
		while (cc->next != c) {
			cc = cc->next;
		}
		cc->next = c->next;
		if (c->next != NIL) {
			c->next->prev = cc;
		}
	}
	while (cc->next != NIL) {
		cc = cc->next;
	}
	cc->next = c;
	c->next = NIL;
	c->prev = cc;
	p->last = c;
}

static void PanelElems_ToTop (PanelElems_Panel p, PanelElems_Case c)
{
	PanelElems_Case cc = NIL;
	if (__IN(2, c->state)) {
		PanelElems_ToBottom(p, c);
	} else {
		if (p->contents == c) {
			return;
		}
		cc = p->contents;
		while (cc->next != c) {
			cc = cc->next;
		}
		cc->next = c->next;
		if (c->next != NIL) {
			c->next->prev = cc;
		} else {
			p->last = c->prev;
		}
		c->next = p->contents;
		p->contents->prev = c;
		p->contents = c;
		c->prev = NIL;
	}
}

static void PanelElems_DeleteElem (PanelElems_Panel p, Texts_Elem e)
{
	LONGINT pos = 0;
	Texts_Notifier notifier = NIL;
	notifier = p->elemTxt->notify;
	p->elemTxt->notify = PanelElems_NoNotify;
	pos = Texts_ElemPos(e);
	Texts_Delete((void*)p->elemTxt, pos, pos + 1);
	p->elemTxt->notify = notifier;
}

void PanelElems_DeleteCase (PanelElems_Panel p, PanelElems_Case c)
{
	PanelElems_Case help = NIL;
	if (p->contents == c) {
		p->contents = p->contents->next;
		if (p->contents != NIL) {
			p->contents->prev = NIL;
		} else {
			p->last = NIL;
		}
		PanelElems_DeleteElem(p, c->e);
	} else {
		help = p->contents;
		while (help != NIL && help->next != c) {
			help = help->next;
		}
		if (help != NIL) {
			help->next = c->next;
			if (c->next != NIL) {
				c->next->prev = help;
			} else {
				p->last = c->prev;
			}
			PanelElems_DeleteElem(p, c->e);
		}
	}
}

PanelElems_Case PanelElems_MyCase (PanelElems_Panel p, Texts_Elem e)
{
	PanelElems_Case c = NIL;
	c = p->contents;
	while (c != NIL && c->e != e) {
		c = c->next;
	}
	return c;
}

PanelElems_Case PanelElems_ThisCase (PanelElems_Panel p, INTEGER x, INTEGER y, INTEGER x0, INTEGER y0)
{
	PanelElems_Case c = NIL;
	INTEGER rx = 0, ry = 0, h = 0;
	h = (int)__DIV(p->H, (LONGINT)TextFrames_Unit);
	rx = x - x0;
	ry = (y0 + h) - y;
	c = p->contents;
	while (c != NIL && !((rx >= c->x && rx <= c->x + (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit)) && (ry >= c->y - (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit) && ry <= c->y))) {
		c = c->next;
	}
	return c;
}

static Texts_Elem PanelElems_ThisElem (Texts_Text t, LONGINT pos)
{
	Texts_Reader r = {0};
	Texts_OpenReader(&r, Texts_Reader__typ, t, pos);
	Texts_ReadElem(&r, Texts_Reader__typ);
	return r.elem;
}

static void PanelElems_InvertSelected (PanelElems_Frame f, PanelElems_Case c)
{
	INTEGER w = 0, h = 0;
	w = (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit);
	h = (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit);
	GUtils_ReplConst((void*)f, 15, f->x + c->x, (f->y + (int)__DIV(f->p->H, (LONGINT)TextFrames_Unit)) - c->y, w, h, 2);
}

void PanelElems_AppendToSelection (PanelElems_Panel p, PanelElems_Case c)
{
	PanelElems_Selection s = NIL;
	__NEW(s, PanelElems_SelectionDesc);
	s->c = c;
	s->next = NIL;
	if (p->sel == NIL) {
		p->sel = s;
	} else {
		p->lastSel->next = s;
	}
	p->lastSel = s;
}

void PanelElems_RemoveFromSelection (PanelElems_Panel p, PanelElems_Case c)
{
	PanelElems_Selection s = NIL;
	if (p->sel == NIL) {
		return;
	}
	if (p->sel->c == c) {
		p->sel = p->sel->next;
		if (p->sel == NIL) {
			p->lastSel = NIL;
		}
	} else {
		s = p->sel;
		while (s->next != NIL && s->next->c != c) {
			s = s->next;
		}
		if (s->next != NIL) {
			s->next = s->next->next;
			if (s->next == NIL) {
				p->lastSel = s;
			}
		}
	}
}

void PanelElems_RemoveSelection (PanelElems_Frame f)
{
	PanelElems_Selection s = NIL;
	s = f->p->sel;
	while (s != NIL) {
		s->c->state &= ~__SETOF(1);
		Elems_UpdateElem(s->c->e);
		s = s->next;
	}
	f->p->sel = NIL;
	f->p->lastSel = NIL;
}

void PanelElems_DeleteSelection (PanelElems_Frame f)
{
	PanelElems_Selection s = NIL;
	INTEGER ew = 0, eh = 0;
	s = f->p->sel;
	while (s != NIL) {
		PanelElems_DeleteCase(f->p, s->c);
		ew = (int)__DIV(s->c->e->W, (LONGINT)TextFrames_Unit);
		eh = (int)__DIV(s->c->e->H, (LONGINT)TextFrames_Unit);
		PanelElems_UpdateArea(f->p, s->c->x, s->c->y, ew, eh, 0x0c);
		s = s->next;
	}
	f->p->sel = NIL;
	f->p->lastSel = NIL;
}

static void PanelElems_SelElemHandle (Texts_Elem s, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	(*__GUARDP(s, PanelElems_SelElemDesc, 2)->e->handle)(__GUARDP(s, PanelElems_SelElemDesc, 2)->e, &*msg, msg__typ);
}

static void PanelElems_SelTextNotifier (Texts_Text t, INTEGER op, LONGINT beg, LONGINT end)
{
	Texts_Reader r = {0};
	LONGINT pos = 0;
	TextFrames_UpdateMsg update = {0};
	if (__ISP(t, PanelElems_TextDesc, 1)) {
		if (op == 0) {
			Texts_OpenReader(&r, Texts_Reader__typ, (void*)(*(PanelElems_Text*)&t), 0);
			Texts_ReadElem(&r, Texts_Reader__typ);
			while (!r.eot) {
				pos = Texts_ElemPos(__GUARDP(r.elem, PanelElems_SelElemDesc, 2)->e);
				Texts_ChangeLooks((void*)(*(PanelElems_Text*)&t)->base->elemTxt, pos, pos + 1, 0x07, r.fnt, r.col, r.voff);
				Texts_ReadElem(&r, Texts_Reader__typ);
			}
		} else if (op == 2) {
			update.id = 2;
			update.text = (Texts_Text)(*(PanelElems_Text*)&t)->base->elemTxt;
			Viewers_Broadcast((void*)&update, TextFrames_UpdateMsg__typ);
		}
	} else __WITHCHK;
}

static Texts_Text PanelElems_SelectionToText (PanelElems_Frame f)
{
	PanelElems_Selection s = NIL;
	PanelElems_SelElem sel = NIL;
	SHORTINT col = 0;
	Fonts_Font fnt = NIL;
	PanelElems_Text t = NIL;
	__NEW(t, PanelElems_TextDesc);
	Texts_Open((void*)t, (CHAR*)"", (LONGINT)1);
	t->notify = PanelElems_SelTextNotifier;
	t->base = f->p;
	s = f->p->sel;
	while (s != NIL) {
		__NEW(sel, PanelElems_SelElemDesc);
		sel->handle = PanelElems_SelElemHandle;
		sel->e = s->c->e;
		Elems_GetLook(sel->e, &fnt, &col);
		Texts_SetFont(&PanelElems_W, Texts_Writer__typ, fnt);
		Texts_SetColor(&PanelElems_W, Texts_Writer__typ, col);
		Texts_WriteElem(&PanelElems_W, Texts_Writer__typ, (void*)sel);
		Texts_Append((void*)t, PanelElems_W.buf);
		s = s->next;
	}
	return (void*)t;
}

PanelElems_Selection PanelElems_NextSel (PanelElems_Selection s)
{
	return s->next;
}

static void PanelElems_SendSelection (PanelElems_Frame f)
{
	PanelElems_CopyOverMsg msg = {0};
	if (f->p->sel != NIL) {
		msg.text = PanelElems_SelectionToText(f);
		msg.beg = 0;
		msg.end = msg.text->len;
		msg.p = f->p;
		msg.sel = f->p->sel;
		Viewers_Broadcast((void*)&msg, PanelElems_CopyOverMsg__typ);
	}
}

static void PanelElems_InvertCaret (PanelElems_Frame f)
{
	INTEGER x = 0, y = 0;
	x = f->cx + f->X;
	y = (f->Y + f->H) - f->cy;
	GUtils_ReplConst((void*)f, 15, x - 5, y, 11, 1, 2);
	GUtils_ReplConst((void*)f, 15, x, y - 5, 1, 11, 2);
}

static void PanelElems_ToggleCaret (PanelElems_Frame f)
{
	if (f->hasCar) {
		PanelElems_InvertCaret(f);
	}
}

void PanelElems_SetCaret (PanelElems_Frame f, INTEGER X, INTEGER Y)
{
	Oberon_PassFocus(Viewers_This(f->X, f->Y));
	f->cx = X;
	f->cy = Y;
	f->hasCar = 1;
	PanelElems_InvertCaret(f);
}

void PanelElems_RemoveCaret (PanelElems_Frame f)
{
	if (f->hasCar) {
		PanelElems_InvertCaret(f);
		f->hasCar = 0;
	}
}

static void PanelElems_SelToPanel (PanelElems_Frame f, PanelElems_Selection sel)
{
	PanelElems_Selection s = NIL;
	Texts_CopyMsg copy = {0};
	Fonts_Font fnt = NIL;
	SHORTINT col = 0;
	INTEGER sx = 0, sy = 0, px = 0, py = 0;
	PanelElems_Case c = NIL;
	sx = 32767;
	sy = -32768;
	s = sel;
	while (s != NIL) {
		if (s->c->x < sx) {
			sx = s->c->x;
		}
		if (s->c->y > sy) {
			sy = s->c->y;
		}
		s = s->next;
	}
	px = f->cx;
	py = f->cy;
	s = sel;
	while (s != NIL) {
		Elems_GetLook(s->c->e, &fnt, &col);
		copy.e = NIL;
		(*s->c->e->handle)(s->c->e, (void*)&copy, Texts_CopyMsg__typ);
		PanelElems_InsertElem(f->p, copy.e, px + (s->c->x - sx), py - (sy - s->c->y), fnt, col);
		Elems_UpdateElem(copy.e);
		c = PanelElems_MyCase(f->p, copy.e);
		c->state = s->c->state;
		c->state &= ~__SETOF(1);
		s = s->next;
	}
	PanelElems_SetCaret(f, f->cx, f->cy);
}

static void PanelElems_TextSelToPanel (PanelElems_Frame f, Texts_Text t, LONGINT beg, LONGINT end)
{
	Texts_Reader r = {0};
	Texts_CopyMsg copy = {0};
	Fonts_Font fnt = NIL;
	SHORTINT col = 0;
	INTEGER x = 0, y = 0;
	x = f->cx;
	y = f->cy;
	PanelElems_RemoveCaret(f);
	Texts_OpenReader(&r, Texts_Reader__typ, t, beg);
	Texts_ReadElem(&r, Texts_Reader__typ);
	while (Texts_Pos(&r, Texts_Reader__typ) <= end && r.elem != NIL) {
		Elems_GetLook(r.elem, &fnt, &col);
		copy.e = NIL;
		(*r.elem->handle)(r.elem, (void*)&copy, Texts_CopyMsg__typ);
		PanelElems_InsertElem(f->p, copy.e, x, y, fnt, col);
		x += (int)__DIV(copy.e->W, (LONGINT)TextFrames_Unit) + 2;
		Elems_UpdateElem(copy.e);
		Texts_ReadElem(&r, Texts_Reader__typ);
	}
	PanelElems_SetCaret(f, x, y);
}

static void PanelElems_CopyOver (PanelElems_Frame f, Oberon_CopyOverMsg *msg, LONGINT *msg__typ)
{
	if (__IS(msg__typ, PanelElems_CopyOverMsg, 2)) {
		PanelElems_SelToPanel(f, __GUARDR(msg, PanelElems_CopyOverMsg, 2).sel);
	} else {
		PanelElems_TextSelToPanel(f, (*msg).text, (*msg).beg, (*msg).end);
	}
}

static void PanelElems_CopyInto (PanelElems_Frame f)
{
	PanelElems_SelectionMsg msg = {0};
	msg.p = NIL;
	msg.sel = NIL;
	msg.text = NIL;
	msg.time = 0;
	Viewers_Broadcast((void*)&msg, PanelElems_SelectionMsg__typ);
	if (msg.sel == NIL && msg.text != NIL) {
		PanelElems_TextSelToPanel(f, msg.text, msg.beg, msg.end);
	} else if (msg.sel != NIL) {
		PanelElems_SelToPanel(f, msg.sel);
	}
}

static BOOLEAN PanelElems_FullyVisible (PanelElems_Frame f, PanelElems_Case c, INTEGER w, INTEGER h)
{
	return ((c->x >= f->X - f->x && c->x + w <= (f->X + f->W) - f->x) && GUtils_Unit(f->p->H, 1) - c->y >= f->Y - f->y) && c->y - h >= (f->y + GUtils_Unit(f->p->H, 1)) - (f->Y + f->H);
}

static void PanelElems_RefreshArea (PanelElems_Frame f, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h)
{
	PanelElems_Case c = NIL;
	BOOLEAN done = 0, overlaps = 0;
	INTEGER ew = 0, eh = 0, X = 0, Y = 0, W = 0, H = 0;
	Elems_OverlapMsg msg = {0};
	done = 0;
	while (!done) {
		done = 1;
		c = f->p->contents;
		while (c != NIL && done) {
			ew = (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit);
			eh = (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit);
			if (__IN(3, c->state)) {
				msg.x = *x;
				msg.y = f->Y - *y;
				msg.w = *w;
				msg.h = *h;
				msg.ex = c->x;
				msg.ey = f->Y - c->y;
				msg.ew = ew;
				msg.eh = eh;
				(*c->e->handle)(c->e, (void*)&msg, Elems_OverlapMsg__typ);
				overlaps = msg.overlaps;
			} else {
				overlaps = PanelElems_OverlapsArea(*x, f->Y - *y, *w, *h, c->x, f->Y - c->y, ew, eh);
			}
			if (!PanelElems_InArea(*x, f->Y - *y, *w, *h, c->x, f->Y - c->y, ew, eh) && overlaps) {
				done = 0;
				if (c->x < *x) {
					*w = (*w + *x) - c->x;
					*x = c->x;
				}
				if (c->x + ew > *x + *w) {
					*w = ((*w + c->x) + ew) - (*x + *w);
				}
				if (c->y > *y) {
					*h = (*h + c->y) - *y;
					*y = c->y;
				}
				if (c->y - eh < *y - *h) {
					*h = *h + ((*y - *h) - (c->y - eh));
				}
			}
			c = c->next;
		}
	}
	PanelElems_ToggleCaret(f);
	Oberon_RemoveMarks(f->x + *x, (f->Y + f->H) - *y, *w, *h);
	PanelElems_RemoveSubFrames(f, f->x + *x, (f->Y + f->H) - *y, *w, *h);
	PanelElems_TruncateFrame(f, &X, &Y, &W, &H);
	c = f->p->last;
	while (c != NIL) {
		ew = (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit);
		eh = (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit);
		if (PanelElems_InArea(*x, f->Y - *y, *w, *h, c->x, f->Y - c->y, ew, eh)) {
			PanelElems_DrawTextElem(f->p, c, (void*)f, f->x, f->y);
		}
		c = c->prev;
	}
	PanelElems_SetFrameCoords(f, X, Y, W, H);
	PanelElems_ToggleCaret(f);
}

static void PanelElems_ClearArea (PanelElems_Frame f, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	Fonts_Font fnt = NIL;
	SHORTINT color = 0;
	INTEGER X = 0, Y = 0, W = 0, H = 0;
	PanelElems_ToggleCaret(f);
	x = x + f->x;
	y = (f->y + (int)__DIV(f->p->H, (LONGINT)TextFrames_Unit)) - y;
	Oberon_RemoveMarks(x, y, w, h);
	Elems_GetLook((void*)f->p, &fnt, &color);
	PanelElems_TruncateFrame(f, &X, &Y, &W, &H);
	GUtils_ReplConst((void*)f, color, x, y, w, h, 1);
	PanelElems_SetFrameCoords(f, X, Y, W, H);
	PanelElems_ToggleCaret(f);
}

void PanelElems_UpdateArea (PanelElems_Panel p, INTEGER x, INTEGER y, INTEGER w, INTEGER h, SET id)
{
	PanelElems_NotifyMsg u = {0};
	u.id = id;
	u.p = p;
	u.x = x;
	u.y = y;
	u.w = w;
	u.h = h;
	Viewers_Broadcast((void*)&u, PanelElems_NotifyMsg__typ);
}

static struct DrawTextElem__14 {
	PanelElems_Panel *p;
	PanelElems_Case *c;
	Display_Frame *f;
	INTEGER *x0, *y0;
	INTEGER *w, *h, *hp;
	struct DrawTextElem__14 *lnk;
} *DrawTextElem__14_s;

static void ShowTabNo__15 (void);
static INTEGER TabNo__17 (void);

static INTEGER TabNo__17 (void)
{
	Texts_Reader r = {0};
	INTEGER i = 0;
	Elems_TabStopMsg tab = {0};
	(*(*DrawTextElem__14_s->c)->e->handle)((*DrawTextElem__14_s->c)->e, (void*)&tab, Elems_TabStopMsg__typ);
	if (!tab.accepted) {
		return 0;
	}
	i = 1;
	Texts_OpenReader(&r, Texts_Reader__typ, (void*)(*DrawTextElem__14_s->p)->elemTxt, 0);
	Texts_ReadElem(&r, Texts_Reader__typ);
	while (r.elem != (*DrawTextElem__14_s->c)->e) {
		tab.accepted = 0;
		(*r.elem->handle)(r.elem, (void*)&tab, Elems_TabStopMsg__typ);
		if (tab.accepted) {
			i += 1;
		}
		Texts_ReadElem(&r, Texts_Reader__typ);
	}
	return i;
}

static void ShowTabNo__15 (void)
{
	INTEGER i = 0;
	CHAR s[4];
	s[0] = 0x00;
	i = TabNo__17();
	if (i > 0) {
		Elems_IntToString(i, (void*)s, 4);
		GUtils_ReplConst(*DrawTextElem__14_s->f, 15, *DrawTextElem__14_s->x0 + (*DrawTextElem__14_s->c)->x, (*DrawTextElem__14_s->y0 + *DrawTextElem__14_s->hp) - (*DrawTextElem__14_s->c)->y, *DrawTextElem__14_s->w, *DrawTextElem__14_s->h, 1);
		GUtils_String(*DrawTextElem__14_s->f, s, 4, (*DrawTextElem__14_s->x0 + (*DrawTextElem__14_s->c)->x) + 1, ((*DrawTextElem__14_s->y0 + *DrawTextElem__14_s->hp) - (*DrawTextElem__14_s->c)->y) + 1, *DrawTextElem__14_s->w - 1, Fonts_Default, 0, 1, 0);
	}
}

void PanelElems_DrawTextElem (PanelElems_Panel p, PanelElems_Case c, Display_Frame f, INTEGER x0, INTEGER y0)
{
	TextFrames_DisplayMsg msg = {0};
	INTEGER w = 0, h = 0, wp = 0, hp = 0;
	struct DrawTextElem__14 _s;
	_s.p = &p;
	_s.c = &c;
	_s.f = &f;
	_s.x0 = &x0;
	_s.y0 = &y0;
	_s.w = &w;
	_s.h = &h;
	_s.hp = &hp;
	_s.lnk = DrawTextElem__14_s;
	DrawTextElem__14_s = &_s;
	wp = GUtils_Unit(p->W, 1);
	hp = GUtils_Unit(p->H, 1);
	Elems_GetLook(c->e, &msg.fnt, &msg.col);
	msg.X0 = c->x + x0;
	msg.pos = Texts_ElemPos(c->e);
	msg.prepare = 1;
	(*c->e->handle)(c->e, (void*)&msg, TextFrames_DisplayMsg__typ);
	if (c->oldH > -1 && c->oldH != c->e->H) {
		c->y = c->y + (int)__DIV(c->e->H - c->oldH, (LONGINT)TextFrames_Unit);
	}
	c->oldW = c->e->W;
	c->oldH = c->e->H;
	w = (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit);
	h = (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit);
	if (((c->x + w < 0 || c->x > wp) || c->y < 0) || c->y - h > hp) {
		DrawTextElem__14_s = _s.lnk;
		return;
	}
	if (!__ISP(c->e, Elems_ElemDesc, 2) && !PanelElems_FullyVisible(__GUARDP(f, PanelElems_FrameDesc, 1), c, w, h)) {
		GUtils_ReplPattern(f, 15, Display_grey1, x0 + c->x, (y0 + hp) - c->y, w, h, 0, 0, 1);
		DrawTextElem__14_s = _s.lnk;
		return;
	}
	if (__ISP(c->e, Elems_ElemDesc, 2)) {
		msg.frame = f;
	} else {
		msg.frame = (Display_Frame)PanelElems_elemTxtFrame;
		msg.frame->X = x0;
		msg.frame->Y = y0;
		msg.frame->W = wp;
		msg.frame->H = hp;
	}
	msg.prepare = 0;
	msg.elemFrame = NIL;
	msg.Y0 = (y0 + hp) - c->y;
	if (TabNo__17() == 0 || !p->showTabs) {
		(*c->e->handle)(c->e, (void*)&msg, TextFrames_DisplayMsg__typ);
	}
	if (p->showTabs) {
		ShowTabNo__15();
	}
	if (__IN(1, c->state)) {
		PanelElems_InvertSelected(__GUARDP(f, PanelElems_FrameDesc, 1), c);
	}
	if (msg.elemFrame != NIL) {
		msg.elemFrame->next = f->dsc;
		f->dsc = msg.elemFrame;
	}
	DrawTextElem__14_s = _s.lnk;
}

void PanelElems_PrintTextElem (PanelElems_Panel p, PanelElems_Case c, Display_Frame f, INTEGER x0, INTEGER y0)
{
	TextPrinter_PrintMsg msg = {0};
	INTEGER w = 0, h = 0, hp = 0;
	GUtils_SetDevice(1);
	hp = GUtils_Unit(p->H, 1);
	Elems_GetLook(c->e, &msg.fnt, &msg.col);
	msg.X0 = GUtils_Unit(c->x, 0) + x0;
	msg.prepare = 1;
	(*c->e->handle)(c->e, (void*)&msg, TextPrinter_PrintMsg__typ);
	w = GUtils_Unit(c->e->W, 1);
	h = GUtils_Unit(c->e->H, 1);
	if (((GUtils_Unit(c->x, 0) >= GUtils_Unit(p->border, 0) && GUtils_Unit(c->x, 0) + w <= GUtils_Unit(p->W, 1) - GUtils_Unit(p->border, 0)) && GUtils_Unit(c->y, 0) <= GUtils_Unit(p->H, 1) - GUtils_Unit(p->border, 0)) && GUtils_Unit(c->y, 0) - h >= GUtils_Unit(p->border, 0)) {
		msg.prepare = 0;
		msg.Y0 = (y0 + hp) - GUtils_Unit(c->y, 0);
		(*c->e->handle)(c->e, (void*)&msg, TextPrinter_PrintMsg__typ);
	}
}

void PanelElems_DrawContents (PanelElems_Panel p, Display_Frame f, INTEGER x0, INTEGER y0)
{
	void (*dr)(PanelElems_Panel, PanelElems_Case, Display_Frame, INTEGER, INTEGER) = NIL;
	PanelElems_Case c = NIL;
	if (GUtils_device == 1) {
		dr = PanelElems_PrintTextElem;
	} else {
		dr = PanelElems_DrawTextElem;
	}
	c = p->last;
	while (c != NIL) {
		c->state &= ~__SETOF(1);
		(*dr)(p, c, f, x0, y0);
		c = c->prev;
	}
}

Display_Frame PanelElems_OpenFrame (PanelElems_Panel p, Display_Frame f, Display_Handler handle, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	PanelElems_Frame ef = NIL;
	__NEW(ef, PanelElems_FrameDesc);
	ef->p = p;
	ef->X = x;
	ef->Y = y;
	ef->W = w;
	ef->H = h;
	ef->x = x;
	ef->y = y;
	ef->handle = handle;
	Elems_AdjustSubFrame(f, (void*)ef);
	ef->oldY = ef->Y;
	return (void*)ef;
}

void PanelElems_DrawPanel (PanelElems_Panel p, INTEGER x, INTEGER y, INTEGER color, Display_Frame f)
{
	INTEGER h = 0, w = 0, X = 0, Y = 0, W = 0, H = 0;
	h = GUtils_Unit(p->H, 1);
	w = GUtils_Unit(p->W, 1);
	GUtils_Area(f, color, 12, x, y, w, h, GUtils_Unit(p->border, 0), 1, 0);
	if (f != NIL) {
		PanelElems_TruncateFrame(__GUARDP(f, PanelElems_FrameDesc, 1), &X, &Y, &W, &H);
	}
	PanelElems_DrawContents(p, f, x, y);
	if (f != NIL) {
		PanelElems_SetFrameCoords(__GUARDP(f, PanelElems_FrameDesc, 1), X, Y, W, H);
	}
}

static struct CopyPanel__6 {
	struct CopyPanel__6 *lnk;
} *CopyPanel__6_s;

static Texts_Elem RefElem__7 (Texts_Elem e, Texts_Text src, Texts_Text dest);

static Texts_Elem RefElem__7 (Texts_Elem e, Texts_Text src, Texts_Text dest)
{
	Texts_Reader rs = {0}, rd = {0};
	Texts_OpenReader(&rs, Texts_Reader__typ, src, 0);
	Texts_OpenReader(&rd, Texts_Reader__typ, dest, 0);
	Texts_ReadElem(&rs, Texts_Reader__typ);
	Texts_ReadElem(&rd, Texts_Reader__typ);
	while (rs.elem != e) {
		Texts_ReadElem(&rs, Texts_Reader__typ);
		Texts_ReadElem(&rd, Texts_Reader__typ);
	}
	return rd.elem;
}

void PanelElems_CopyPanel (PanelElems_Panel from, PanelElems_Panel to)
{
	PanelElems_Case newC = NIL, c = NIL;
	Texts_Notifier notifier = NIL;
	Texts_Buffer B = NIL;
	struct CopyPanel__6 _s;
	_s.lnk = CopyPanel__6_s;
	CopyPanel__6_s = &_s;
	__NEW(B, Texts_BufDesc);
	Texts_OpenBuf(B);
	PanelElems_Init(to);
	Elems_CopyElem((void*)from, (void*)to);
	to->border = from->border;
	to->showTabs = from->showTabs;
	notifier = to->elemTxt->notify;
	to->elemTxt->notify = PanelElems_NoNotify;
	Texts_Save((void*)from->elemTxt, 0, from->elemTxt->len, B);
	Texts_Append((void*)to->elemTxt, B);
	to->elemTxt->notify = notifier;
	c = from->contents;
	while (c != NIL) {
		__NEW(newC, PanelElems_CaseDesc);
		__GUARDEQP(newC, PanelElems_CaseDesc) = *c;
		newC->e = RefElem__7(c->e, (void*)from->elemTxt, (void*)to->elemTxt);
		if (to->contents == NIL) {
			to->contents = newC;
		} else {
			to->last->next = newC;
			newC->prev = to->last;
		}
		to->last = newC;
		c = c->next;
	}
	CopyPanel__6_s = _s.lnk;
}

static void PanelElems_HandleFileMsg (PanelElems_Panel p, Texts_FileMsg *msg, LONGINT *msg__typ)
{
	PanelElems_Case c = NIL;
	LONGINT cnt = 0, pos = 0;
	CHAR ch = 0;
	Texts_Notifier notifier = NIL;
	if ((*msg).id == 0) {
		notifier = p->elemTxt->notify;
		p->elemTxt->notify = PanelElems_NoNotify;
		Files_Read(&(*msg).r, Files_Rider__typ, (void*)&ch);
		Texts_Load(&(*msg).r, Files_Rider__typ, (void*)p->elemTxt);
		Files_ReadLInt(&(*msg).r, Files_Rider__typ, &cnt);
		while (cnt > 0) {
			__NEW(c, PanelElems_CaseDesc);
			Files_ReadInt(&(*msg).r, Files_Rider__typ, &c->x);
			Files_ReadInt(&(*msg).r, Files_Rider__typ, &c->y);
			Files_ReadSet(&(*msg).r, Files_Rider__typ, &c->state);
			c->x = (int)__DIV((LONGINT)c->x * 10000, (LONGINT)TextFrames_Unit);
			c->y = (int)__DIV((LONGINT)c->y * 10000, (LONGINT)TextFrames_Unit);
			c->state &= ~__SETOF(1);
			Files_ReadLInt(&(*msg).r, Files_Rider__typ, &pos);
			c->e = PanelElems_ThisElem((void*)p->elemTxt, pos);
			c->oldW = c->e->W;
			c->oldH = c->e->H;
			if (p->contents == NIL) {
				p->contents = c;
			} else {
				p->last->next = c;
				c->prev = p->last;
			}
			p->last = c;
			cnt -= 1;
		}
		p->elemTxt->notify = notifier;
	} else if ((*msg).id == 1) {
		Files_Write(&(*msg).r, Files_Rider__typ, 0x00);
		Texts_Store(&(*msg).r, Files_Rider__typ, (void*)p->elemTxt);
		cnt = 0;
		c = p->contents;
		while (c != NIL) {
			cnt += 1;
			c = c->next;
		}
		Files_WriteLInt(&(*msg).r, Files_Rider__typ, cnt);
		c = p->contents;
		while (c != NIL) {
			Files_WriteInt(&(*msg).r, Files_Rider__typ, (int)__DIV((LONGINT)c->x * (LONGINT)TextFrames_Unit, 10000));
			Files_WriteInt(&(*msg).r, Files_Rider__typ, (int)__DIV((LONGINT)c->y * (LONGINT)TextFrames_Unit, 10000));
			Files_WriteSet(&(*msg).r, Files_Rider__typ, c->state);
			Files_WriteLInt(&(*msg).r, Files_Rider__typ, Texts_ElemPos(c->e));
			c = c->next;
		}
	}
}

static void PanelElems_HandleAttrMsg (PanelElems_Panel p, Elems_AttrMsg *msg, LONGINT *msg__typ)
{
	Elems_Done = 1;
	if ((*msg).id == 2) {
		if (__STRCMP((*msg).name, "Locked") == 0) {
			if ((*msg).class == 7) {
				PanelElems_ToChilds(p, (void*)&*msg, msg__typ);
			}
			Elems_Handle((void*)p, (void*)&*msg, msg__typ);
		} else if (__STRCMP((*msg).name, "Border") == 0) {
			if ((*msg).class == 3) {
				p->border = (int)(*msg).i;
			}
		} else {
			Elems_Handle((void*)p, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 1) {
		if (__STRCMP((*msg).name, "Border") == 0) {
			(*msg).class = 3;
			(*msg).i = p->border;
		} else {
			Elems_Handle((void*)p, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 3) {
		Elems_Handle((void*)p, (void*)&*msg, msg__typ);
		(*(*msg).enum_)((CHAR*)"Border", (LONGINT)7, 3);
	} else {
		Elems_Handle((void*)p, (void*)&*msg, msg__typ);
	}
}

void PanelElems_Handle (Texts_Elem p, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	PanelElems_Panel copy = NIL;
	Elems_ExecMsg exec = {0};
	CHAR cmd[256];
	if (__ISP(p, PanelElems_PanelDesc, 3)) {
		if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *msg__ = (void*)msg;
			Elems_ToFrame((void*)(*(PanelElems_Panel*)&p), *msg__);
		} else if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				(*(PanelElems_Panel*)&p)->sel = NIL;
				(*msg__).elemFrame = PanelElems_OpenFrame((*(PanelElems_Panel*)&p), (*msg__).frame, PanelElems_FrameHandle, (*msg__).X0, (*msg__).Y0, (int)__DIV((*(PanelElems_Panel*)&p)->W, (LONGINT)TextFrames_Unit), (int)__DIV((*(PanelElems_Panel*)&p)->H, (LONGINT)TextFrames_Unit));
				PanelElems_DrawPanel((*(PanelElems_Panel*)&p), (*msg__).X0, (*msg__).Y0, (*msg__).col, (*msg__).elemFrame);
			}
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			TextPrinter_PrintMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(1);
				PanelElems_DrawPanel((*(PanelElems_Panel*)&p), (*msg__).X0, (*msg__).Y0, (*msg__).col, NIL);
				GUtils_SetDevice(2);
			}
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *msg__ = (void*)msg;
			if ((*msg__).e == NIL) {
				__NEW(copy, PanelElems_PanelDesc);
				(*msg__).e = (Texts_Elem)copy;
			} else {
				copy = __GUARDP((*msg__).e, PanelElems_PanelDesc, 3);
			}
			PanelElems_CopyPanel((*(PanelElems_Panel*)&p), copy);
		} else if (__IS(msg__typ, Elems_ExecMsg, 1)) {
			Elems_ExecMsg *msg__ = (void*)msg;
			Elems_GetString((void*)(*(PanelElems_Panel*)&p), (CHAR*)"Cmd", (LONGINT)4, (void*)cmd, 256);
			if (cmd[0] != 0x00) {
				Elems_CmdContext = (Texts_Text)(*(PanelElems_Panel*)&p)->elemTxt;
				Elems_CmdElem = NIL;
				Elems_DoCall(cmd, 256, NIL, NIL, NIL, 0, 0);
			}
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *msg__ = (void*)msg;
			Elems_Handle((void*)(*(PanelElems_Panel*)&p), (void*)&*msg__, msg__typ);
			PanelElems_HandleFileMsg((*(PanelElems_Panel*)&p), &*msg__, msg__typ);
			if ((*msg__).id == 0) {
				exec.e = (Elems_Elem)(*(PanelElems_Panel*)&p);
				exec.x = -1;
				exec.y = -1;
				exec.f = NIL;
				exec.unload = 0;
				exec.context = (Texts_Text)(*(PanelElems_Panel*)&p)->elemTxt;
				(*(*(PanelElems_Panel*)&p)->handle)((void*)(*(PanelElems_Panel*)&p), (void*)&exec, Elems_ExecMsg__typ);
			}
		} else if (__IS(msg__typ, TextFrames_FocusMsg, 1)) {
			TextFrames_FocusMsg *msg__ = (void*)msg;
			Elems_Focusing(*msg__);
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *msg__ = (void*)msg;
			__MOVE("PanelElems", (*msg__).mod, 11);
			__MOVE("New", (*msg__).proc, 4);
		} else if (__IS(msg__typ, Elems_AttrMsg, 1)) {
			Elems_AttrMsg *msg__ = (void*)msg;
			PanelElems_HandleAttrMsg((*(PanelElems_Panel*)&p), &*msg__, msg__typ);
		} else {
			Elems_Handle((void*)(*(PanelElems_Panel*)&p), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

void PanelElems_Init (PanelElems_Panel p)
{
	Elems_Init((void*)p);
	p->handle = PanelElems_Handle;
	p->border = 2;
	p->W = 200 * TextFrames_Unit;
	p->H = 100 * TextFrames_Unit;
	p->contents = NIL;
	p->last = NIL;
	p->showTabs = 0;
	__NEW(p->elemTxt, PanelElems_TextDesc);
	Texts_Open((void*)p->elemTxt, (CHAR*)"", (LONGINT)1);
	p->elemTxt->notify = TextFrames_NotifyDisplay;
	p->elemTxt->base = p;
}

void PanelElems_New (void)
{
	PanelElems_Panel p = NIL;
	__NEW(p, PanelElems_PanelDesc);
	PanelElems_Init(p);
	Texts_new = (Texts_Elem)p;
}

void PanelElems_Insert (void)
{
	PanelElems_Panel p = NIL;
	TextFrames_InsertElemMsg m = {0};
	LONGINT pos = 0;
	Texts_Text t = NIL;
	Texts_Scanner s = {0};
	__NEW(p, PanelElems_PanelDesc);
	PanelElems_Init(p);
	Elems_GetPar((void*)p, &s, Texts_Scanner__typ);
	m.e = (Texts_Elem)p;
	Viewers_Broadcast((void*)&m, TextFrames_InsertElemMsg__typ);
	t = Texts_ElemBase((void*)p);
	if (t != NIL) {
		pos = Texts_ElemPos((void*)p);
		Texts_ChangeLooks(t, pos, pos + 1, 0x02, Fonts_Default, 13, 0);
	}
}

static void PanelElems_ChangePos (PanelElems_Frame f, PanelElems_Case c, INTEGER dx, INTEGER dy)
{
	PanelElems_Selection s = NIL;
	INTEGER x = 0, y = 0, h = 0, w = 0;
	if (c == NIL) {
		s = f->p->sel;
		while (s != NIL) {
			PanelElems_ChangePos(f, s->c, dx, dy);
			s = s->next;
		}
	} else {
		h = (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit);
		w = (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit);
		x = c->x;
		y = c->y;
		PanelElems_ToTop(f->p, c);
		c->x = c->x + dx;
		c->y = c->y + dy;
		PanelElems_UpdateArea(f->p, x, y, w, h, 0x0c);
		if (!PanelElems_OverlapsArea(x, y, w, h, c->x, c->y, w, h)) {
			Elems_UpdateElem(c->e);
		}
	}
}

static void PanelElems_InvertMoving (PanelElems_Frame f, PanelElems_Case c, INTEGER dx, INTEGER dy)
{
	PanelElems_Selection s = NIL;
	if (c == NIL) {
		s = f->p->sel;
		while (s != NIL) {
			PanelElems_InvertMoving(f, s->c, dx, dy);
			s = s->next;
		}
	} else {
		GUtils_Frame(NIL, 15, (f->x + c->x) + dx, ((f->y + (int)__DIV(f->p->H, (LONGINT)TextFrames_Unit)) - c->y) - dy, (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit), (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit), 1, 2);
	}
}

static void PanelElems_Move (PanelElems_Frame f, PanelElems_Case c)
{
	SET keys = 0, keysum = 0;
	INTEGER begX = 0, begY = 0, dx = 0, dy = 0, X = 0, Y = 0, ox = 0, oy = 0;
	Input_Mouse(&keys, &begX, &begY);
	keysum = 0x0;
	dx = 0;
	dy = 0;
	ox = -1;
	oy = -1;
	PanelElems_InvertMoving(f, c, dx, dy);
	do {
		Input_Mouse(&keys, &X, &Y);
		keysum = keysum | keys;
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, X, Y);
		if (ox != X || oy != Y) {
			PanelElems_InvertMoving(f, c, dx, dy);
			dx = X - begX;
			dy = begY - Y;
			ox = X;
			oy = Y;
			PanelElems_InvertMoving(f, c, dx, dy);
		}
	} while (!(keys == 0x0 || __IN(0, keysum)));
	PanelElems_InvertMoving(f, c, dx, dy);
	while (keys != 0x0) {
		Input_Mouse(&keys, &X, &Y);
	}
	if (!__IN(0, keysum)) {
		PanelElems_ChangePos(f, c, dx, dy);
	}
}

static struct TrackRubberBand__65 {
	PanelElems_Frame *f;
	INTEGER *x, *y, *w, *h, *ph;
	PanelElems_Case *c;
	struct TrackRubberBand__65 *lnk;
} *TrackRubberBand__65_s;

static void CheckSelection__66 (void);
static void CorrectCoords__68 (INTEGER *coord, INTEGER *exp);

static void CorrectCoords__68 (INTEGER *coord, INTEGER *exp)
{
	if (*exp < 0) {
		*coord += *exp;
		*exp = __ABS(*exp);
	}
}

static void CheckSelection__66 (void)
{
	CorrectCoords__68(&*TrackRubberBand__65_s->x, &*TrackRubberBand__65_s->w);
	CorrectCoords__68(&*TrackRubberBand__65_s->y, &*TrackRubberBand__65_s->h);
	*TrackRubberBand__65_s->c = (*TrackRubberBand__65_s->f)->p->contents;
	while (*TrackRubberBand__65_s->c != NIL) {
		if (PanelElems_InArea(*TrackRubberBand__65_s->x, *TrackRubberBand__65_s->y, *TrackRubberBand__65_s->w, *TrackRubberBand__65_s->h, (*TrackRubberBand__65_s->f)->x + (*TrackRubberBand__65_s->c)->x, ((*TrackRubberBand__65_s->f)->y + *TrackRubberBand__65_s->ph) - (*TrackRubberBand__65_s->c)->y, (int)__DIV((*TrackRubberBand__65_s->c)->e->W, (LONGINT)TextFrames_Unit), (int)__DIV((*TrackRubberBand__65_s->c)->e->H, (LONGINT)TextFrames_Unit))) {
			if (!__IN(1, (*TrackRubberBand__65_s->c)->state)) {
				(*TrackRubberBand__65_s->c)->state |= __SETOF(1);
				PanelElems_AppendToSelection((*TrackRubberBand__65_s->f)->p, *TrackRubberBand__65_s->c);
				PanelElems_InvertSelected(*TrackRubberBand__65_s->f, *TrackRubberBand__65_s->c);
			}
		} else {
			if (__IN(1, (*TrackRubberBand__65_s->c)->state)) {
				(*TrackRubberBand__65_s->c)->state &= ~__SETOF(1);
				PanelElems_RemoveFromSelection((*TrackRubberBand__65_s->f)->p, *TrackRubberBand__65_s->c);
				PanelElems_InvertSelected(*TrackRubberBand__65_s->f, *TrackRubberBand__65_s->c);
			}
		}
		*TrackRubberBand__65_s->c = (*TrackRubberBand__65_s->c)->next;
	}
}

static void PanelElems_TrackRubberBand (PanelElems_Frame f, INTEGER ix, INTEGER iy, SET keys)
{
	INTEGER x = 0, y = 0, w = 0, h = 0, ox = 0, oy = 0, mx = 0, my = 0, ph = 0;
	SET keysum = 0;
	PanelElems_Case c = NIL;
	struct TrackRubberBand__65 _s;
	_s.f = &f;
	_s.x = &x;
	_s.y = &y;
	_s.w = &w;
	_s.h = &h;
	_s.ph = &ph;
	_s.c = &c;
	_s.lnk = TrackRubberBand__65_s;
	TrackRubberBand__65_s = &_s;
	ph = (int)__DIV(f->p->H, (LONGINT)TextFrames_Unit);
	keysum = keys;
	ox = -1;
	oy = -1;
	do {
		Input_Mouse(&keys, &mx, &my);
		keysum = keysum | keys;
		if (ox != mx || oy != my) {
			GUtils_Frame((void*)f, 0, x, y, w, h, 1, 2);
			x = ix;
			y = iy;
			w = mx - ix;
			h = my - iy;
			ox = mx;
			oy = my;
			CheckSelection__66();
			GUtils_Frame((void*)f, 0, x, y, w, h, 1, 2);
		}
	} while (!(keys == 0x0));
	GUtils_Frame((void*)f, 0, x, y, w, h, 1, 2);
	if (keysum == 0x05) {
		PanelElems_DeleteSelection(f);
	} else if (keysum == 0x03) {
		PanelElems_SendSelection(f);
	} else if (keysum == 0x07) {
		PanelElems_RemoveSelection(f);
	}
	TrackRubberBand__65_s = _s.lnk;
}

static void PanelElems_HandleInput (PanelElems_Frame f, Oberon_InputMsg *msg, LONGINT *msg__typ)
{
	INTEGER X = 0, Y = 0, w = 0, h = 0, ph = 0, fx = 0, fy = 0, fw = 0, fh = 0;
	TextFrames_TrackMsg track = {0};
	SET keysum = 0;
	PanelElems_Case c = NIL;
	BOOLEAN done = 0;
	Display_Frame sub = NIL;
	keysum = (*msg).keys;
	if ((*msg).id == 1) {
		if ((*msg).keys == 0x04) {
			sub = PanelElems_ThisSubFrame(f, (*msg).X, (*msg).Y);
			if (sub != NIL) {
				(*sub->handle)(sub, (void*)&*msg, msg__typ);
			} else if (!f->p->locked) {
				PanelElems_SetCaret(f, (*msg).X - f->X, (f->Y + f->H) - (*msg).Y);
				do {
					Input_Mouse(&(*msg).keys, &(*msg).X, &(*msg).Y);
					keysum = keysum | (*msg).keys;
					Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, (*msg).X, (*msg).Y);
				} while (!((*msg).keys == 0x0));
				if (keysum == 0x06) {
					PanelElems_CopyInto(f);
				}
			}
		} else if ((*msg).keys == 0x01) {
			sub = PanelElems_ThisSubFrame(f, (*msg).X, (*msg).Y);
			c = PanelElems_ThisCase(f->p, (*msg).X, (*msg).Y, f->x, f->y);
			if (c == NIL && !f->p->locked) {
				PanelElems_RemoveSelection(f);
				f->p->selTime = Oberon_Time();
				PanelElems_TrackRubberBand(f, (*msg).X, (*msg).Y, (*msg).keys);
			} else if (!f->p->locked && (sub == NIL || PanelElems_InBorder((*msg).X, (*msg).Y, sub->X, sub->Y, sub->W, sub->H))) {
				f->p->selTime = Oberon_Time();
				if (__IN(1, c->state)) {
					c->state &= ~__SETOF(1);
				} else {
					c->state |= __SETOF(1);
				}
				Elems_UpdateElem(c->e);
				if (__IN(1, c->state)) {
					PanelElems_AppendToSelection(f->p, c);
				} else {
					PanelElems_RemoveFromSelection(f->p, c);
				}
				do {
					Input_Mouse(&(*msg).keys, &X, &Y);
					keysum = keysum | (*msg).keys;
					Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, X, Y);
				} while (!((*msg).keys == 0x0));
				if (keysum == 0x05) {
					PanelElems_DeleteSelection(f);
				} else if (keysum == 0x03) {
					PanelElems_SendSelection(f);
				}
			} else if (sub != NIL) {
				(*sub->handle)(sub, (void*)&*msg, msg__typ);
			}
		} else if ((*msg).keys == 0x02) {
			PanelElems_RemoveCaret(f);
			done = 0;
			track.X0 = f->x;
			track.Y0 = f->Y;
			track.X = (*msg).X;
			track.Y = (*msg).Y;
			track.keys = (*msg).keys;
			track.frame = (Display_Frame)f;
			if (!f->p->locked) {
				Elems_Track((void*)f->p, (void*)&track, TextFrames_TrackMsg__typ, &done);
				if (done) {
					Elems_UpdateElem((void*)f->p);
				}
			}
			if (!done) {
				c = PanelElems_ThisCase(f->p, (*msg).X, (*msg).Y, f->x, f->y);
				if (c == NIL && f->p->sel != NIL) {
					PanelElems_Move(f, NIL);
				} else if (c != NIL) {
					w = (int)__DIV(c->e->W, (LONGINT)TextFrames_Unit);
					h = (int)__DIV(c->e->H, (LONGINT)TextFrames_Unit);
					ph = (int)__DIV(f->p->H, (LONGINT)TextFrames_Unit);
					if ((!f->p->locked && (__IN(1, c->state) || PanelElems_InBorder((*msg).X, (*msg).Y, f->x + c->x, (f->y - c->y) + ph, w, h))) && !Elems_InCorner((*msg).X, (*msg).Y, f->x + c->x, (f->y - c->y) + ph, w, c->e)) {
						PanelElems_Move(f, c);
					} else if (Elems_InCorner((*msg).X, (*msg).Y, f->x + c->x, (f->y - c->y) + ph, w, c->e) || !__IN(1, c->state)) {
						if (__ISP(c->e, Elems_ElemDesc, 2) || PanelElems_FullyVisible(f, c, w, h)) {
							Elems_GetLook(c->e, &track.fnt, &track.col);
							track.X0 = c->x + f->x;
							track.Y0 = (f->y + ph) - c->y;
							track.frame = (Display_Frame)f;
							PanelElems_TruncateFrame(f, &fx, &fy, &fw, &fh);
							PanelElems_ToTop(f->p, c);
							(*c->e->handle)(c->e, (void*)&track, TextFrames_TrackMsg__typ);
							PanelElems_SetFrameCoords(f, fx, fy, fw, fh);
						}
					}
				}
			}
		} else {
			sub = PanelElems_ThisSubFrame(f, (*msg).X, (*msg).Y);
			if (sub != NIL) {
				(*sub->handle)(sub, (void*)&*msg, msg__typ);
			}
		}
	} else if ((*msg).id == 0 && f->hasCar) {
		if ((*msg).ch == 0xc4) {
			PanelElems_ChangePos(f, NIL, -1, 0);
		} else if ((*msg).ch == 0xc3) {
			PanelElems_ChangePos(f, NIL, 1, 0);
		} else if ((*msg).ch == 0xc2) {
			PanelElems_ChangePos(f, NIL, 0, 1);
		} else if ((*msg).ch == 0xc1) {
			PanelElems_ChangePos(f, NIL, 0, -1);
		}
	} else {
		PanelElems_NotifySubFrames(f, (void*)&*msg, msg__typ);
	}
}

void PanelElems_FrameHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	Display_Frame sub = NIL;
	Texts_Reader r = {0};
	PanelElems_Case c = NIL;
	INTEGER X = 0, Y = 0, W = 0, H = 0;
	if (__ISP(f, PanelElems_FrameDesc, 1)) {
		if (__IS(msg__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *msg__ = (void*)msg;
			PanelElems_HandleInput((*(PanelElems_Frame*)&f), &*msg__, msg__typ);
		} else if (__IS(msg__typ, Oberon_ControlMsg, 1)) {
			Oberon_ControlMsg *msg__ = (void*)msg;
			PanelElems_NotifySubFrames((*(PanelElems_Frame*)&f), (void*)&*msg__, msg__typ);
			if ((*(PanelElems_Frame*)&f)->hasCar && __IN((*msg__).id, 0x03)) {
				PanelElems_RemoveCaret((*(PanelElems_Frame*)&f));
			}
			if ((*msg__).id == 1) {
				PanelElems_RemoveSelection((*(PanelElems_Frame*)&f));
			}
		} else if (__IS(msg__typ, TextFrames_InsertElemMsg, 1)) {
			TextFrames_InsertElemMsg *msg__ = (void*)msg;
			if ((*(PanelElems_Frame*)&f)->hasCar) {
				PanelElems_InsertElem((*(PanelElems_Frame*)&f)->p, (*msg__).e, (*(PanelElems_Frame*)&f)->cx, (*(PanelElems_Frame*)&f)->cy, Fonts_Default, 15);
				PanelElems_RemoveCaret((*(PanelElems_Frame*)&f));
				PanelElems_TruncateFrame((*(PanelElems_Frame*)&f), &X, &Y, &W, &H);
				PanelElems_DrawTextElem((*(PanelElems_Frame*)&f)->p, PanelElems_MyCase((*(PanelElems_Frame*)&f)->p, (*msg__).e), (void*)(*(PanelElems_Frame*)&f), (*(PanelElems_Frame*)&f)->x, (*(PanelElems_Frame*)&f)->y);
				PanelElems_SetFrameCoords((*(PanelElems_Frame*)&f), X, Y, W, H);
				PanelElems_SetCaret((*(PanelElems_Frame*)&f), ((*(PanelElems_Frame*)&f)->cx + (int)__DIV((*msg__).e->W, (LONGINT)TextFrames_Unit)) + 2, (*(PanelElems_Frame*)&f)->cy);
			} else {
				PanelElems_NotifySubFrames((*(PanelElems_Frame*)&f), (void*)&*msg__, msg__typ);
			}
		} else if (__IS(msg__typ, Oberon_CopyOverMsg, 1)) {
			Oberon_CopyOverMsg *msg__ = (void*)msg;
			if ((*(PanelElems_Frame*)&f)->hasCar) {
				PanelElems_CopyOver((*(PanelElems_Frame*)&f), &*msg__, msg__typ);
			} else {
				PanelElems_NotifySubFrames((*(PanelElems_Frame*)&f), (void*)&*msg__, msg__typ);
			}
		} else if (__IS(msg__typ, Oberon_SelectionMsg, 1)) {
			Oberon_SelectionMsg *msg__ = (void*)msg;
			PanelElems_NotifySubFrames((*(PanelElems_Frame*)&f), (void*)&*msg__, msg__typ);
			if ((*(PanelElems_Frame*)&f)->p->sel != NIL && (*(PanelElems_Frame*)&f)->p->selTime > (*msg__).time) {
				if (__IS(msg__typ, PanelElems_SelectionMsg, 2)) {
					__GUARDR(msg, PanelElems_SelectionMsg, 2).p = (*(PanelElems_Frame*)&f)->p;
					__GUARDR(msg, PanelElems_SelectionMsg, 2).sel = (*(PanelElems_Frame*)&f)->p->sel;
				} else {
					(*msg__).text = PanelElems_SelectionToText((*(PanelElems_Frame*)&f));
					(*msg__).beg = 0;
					(*msg__).end = (*msg__).text->len;
				}
				(*msg__).time = (*(PanelElems_Frame*)&f)->p->selTime;
			}
		} else if (__IS(msg__typ, MenuViewers_ModifyMsg, 1)) {
			MenuViewers_ModifyMsg *msg__ = (void*)msg;
			if ((*(PanelElems_Frame*)&f)->oldY != (*(PanelElems_Frame*)&f)->Y && (*msg__).H != 0) {
				sub = (*(PanelElems_Frame*)&f)->dsc;
				while (sub != NIL) {
					sub->Y += (*(PanelElems_Frame*)&f)->Y - (*(PanelElems_Frame*)&f)->oldY;
					(*msg__).Y = sub->Y;
					(*msg__).H = sub->H;
					(*sub->handle)(sub, (void*)&*msg__, msg__typ);
					sub = sub->next;
				}
				(*(PanelElems_Frame*)&f)->y += (*(PanelElems_Frame*)&f)->Y - (*(PanelElems_Frame*)&f)->oldY;
				(*(PanelElems_Frame*)&f)->oldY = (*(PanelElems_Frame*)&f)->Y;
			}
		} else if (__IS(msg__typ, Elems_GetContextMsg, 1)) {
			Elems_GetContextMsg *msg__ = (void*)msg;
			if ((*msg__).p == (void *) (*(PanelElems_Frame*)&f)->p && ((((*msg__).fx >= (*(PanelElems_Frame*)&f)->X && (*msg__).fx <= (*(PanelElems_Frame*)&f)->X + (*(PanelElems_Frame*)&f)->W) && (*msg__).fy >= (*(PanelElems_Frame*)&f)->Y) && (*msg__).fy <= (*(PanelElems_Frame*)&f)->Y + (*(PanelElems_Frame*)&f)->H || (*msg__).fx < 0 && (*msg__).fy < 0)) {
				(*msg__).context = (Display_Frame)(*(PanelElems_Frame*)&f);
				(*msg__).p = NIL;
			} else {
				PanelElems_NotifySubFrames((*(PanelElems_Frame*)&f), (void*)&*msg__, msg__typ);
			}
		} else if (__IS(msg__typ, PanelElems_NotifyMsg, 1)) {
			PanelElems_NotifyMsg *msg__ = (void*)msg;
			if ((*msg__).p == (*(PanelElems_Frame*)&f)->p) {
				PanelElems_MarkMenu((void*)(*(PanelElems_Frame*)&f));
				if (__IN(3, (*msg__).id)) {
					PanelElems_ClearArea((*(PanelElems_Frame*)&f), (*msg__).x, (*msg__).y, (*msg__).w, (*msg__).h);
				}
				if (__IN(2, (*msg__).id)) {
					PanelElems_RefreshArea((*(PanelElems_Frame*)&f), &(*msg__).x, &(*msg__).y, &(*msg__).w, &(*msg__).h);
				}
			} else {
				PanelElems_NotifySubFrames((*(PanelElems_Frame*)&f), (void*)&*msg__, msg__typ);
			}
		} else if (__IS(msg__typ, TextFrames_UpdateMsg, 1)) {
			TextFrames_UpdateMsg *msg__ = (void*)msg;
			if ((*msg__).text == (void *) (*(PanelElems_Frame*)&f)->p->elemTxt) {
				if ((*msg__).id == 2) {
					PanelElems_DeleteSelection((*(PanelElems_Frame*)&f));
				} else {
					Texts_OpenReader(&r, Texts_Reader__typ, (*msg__).text, (*msg__).beg);
					Texts_ReadElem(&r, Texts_Reader__typ);
					c = PanelElems_MyCase((*(PanelElems_Frame*)&f)->p, r.elem);
					PanelElems_UpdateArea((*(PanelElems_Frame*)&f)->p, c->x, c->y, (int)__DIV(c->oldW, (LONGINT)TextFrames_Unit), (int)__DIV(c->oldH, (LONGINT)TextFrames_Unit), 0x0c);
				}
			} else {
				PanelElems_NotifySubFrames((*(PanelElems_Frame*)&f), (void*)&*msg__, msg__typ);
			}
		} else {
			PanelElems_NotifySubFrames((*(PanelElems_Frame*)&f), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&PanelElems_W, Texts_Writer__typ, 36, 1, P);
	P(PanelElems_elemTxtFrame);
}

__TDESC(PanelElems_CaseDesc, 1, 3) = {__TDFLDS("CaseDesc", 28), {16, 20, 24, -16}};
__TDESC(PanelElems_SelectionDesc, 1, 2) = {__TDFLDS("SelectionDesc", 8), {0, 4, -12}};
__TDESC(PanelElems_TextDesc, 1, 3) = {__TDFLDS("TextDesc", 24), {8, 12, 20, -16}};
__TDESC(PanelElems_FrameDesc, 1, 3) = {__TDFLDS("FrameDesc", 36), {0, 4, 20, -16}};
__TDESC(PanelElems_PanelDesc, 1, 10) = {__TDFLDS("PanelDesc", 76), {0, 4, 12, 32, 36, 44, 48, 56, 60, 68, -44}};
__TDESC(PanelElems_SelElemDesc, 1, 5) = {__TDFLDS("SelElemDesc", 40), {0, 4, 12, 32, 36, -24}};
__TDESC(PanelElems_SelectionMsg, 1, 3) = {__TDFLDS("SelectionMsg", 24), {4, 16, 20, -16}};
__TDESC(PanelElems_CopyOverMsg, 1, 3) = {__TDFLDS("CopyOverMsg", 20), {0, 12, 16, -16}};
__TDESC(PanelElems_NotifyMsg, 1, 2) = {__TDFLDS("NotifyMsg", 20), {0, 8, -12}};

export void *PanelElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Elems);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(GUtils);
	__IMPORT(Input);
	__IMPORT(MenuViewers);
	__IMPORT(Oberon);
	__IMPORT(Out);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(PanelElems, EnumPtrs);
	__REGCMD("Insert", PanelElems_Insert);
	__REGCMD("New", PanelElems_New);
	__INITYP(PanelElems_CaseDesc, PanelElems_CaseDesc, 0);
	__INITYP(PanelElems_SelectionDesc, PanelElems_SelectionDesc, 0);
	__INITYP(PanelElems_TextDesc, Texts_TextDesc, 1);
	__INITYP(PanelElems_FrameDesc, Display_FrameDesc, 1);
	__INITYP(PanelElems_PanelDesc, Elems_ElemDesc, 3);
	__INITYP(PanelElems_SelElemDesc, Texts_ElemDesc, 2);
	__INITYP(PanelElems_SelectionMsg, Oberon_SelectionMsg, 2);
	__INITYP(PanelElems_CopyOverMsg, Oberon_CopyOverMsg, 2);
	__INITYP(PanelElems_NotifyMsg, Display_FrameMsg, 1);
/* BEGIN */
	PanelElems_clp = Elems_clp;
	Texts_OpenWriter(&PanelElems_W, Texts_Writer__typ);
	__NEW(PanelElems_elemTxtFrame, TextFrames_FrameDesc);
	PanelElems_elemTxtFrame->text = TextFrames_Text((CHAR*)"", (LONGINT)1);
	__ENDMOD;
}
