/* Ofront 1.4 -xtspkaG */

#ifndef PanelElems__h
#define PanelElems__h

#include "SYSTEM.h"
#include "Display.h"
#include "Elems.h"
#include "Fonts.h"
#include "Oberon.h"
#include "Texts.h"

typedef
	struct PanelElems_CaseDesc *PanelElems_Case;

typedef
	struct PanelElems_CaseDesc {
		INTEGER x, y;
		LONGINT oldW, oldH;
		SET state;
		Texts_Elem e;
		PanelElems_Case next, prev;
	} PanelElems_CaseDesc;

typedef
	struct PanelElems_PanelDesc *PanelElems_Panel;

typedef
	struct PanelElems_SelectionDesc *PanelElems_Selection;

typedef
	struct PanelElems_CopyOverMsg { /* Oberon_CopyOverMsg */
		Texts_Text text;
		LONGINT beg, end;
		PanelElems_Panel p;
		PanelElems_Selection sel;
	} PanelElems_CopyOverMsg;

typedef
	struct PanelElems_FrameDesc *PanelElems_Frame;

typedef
	struct PanelElems_FrameDesc { /* Display_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		PanelElems_Panel p;
		INTEGER cx, cy;
		BOOLEAN hasCar;
		INTEGER oldY, x, y;
	} PanelElems_FrameDesc;

typedef
	struct PanelElems_NotifyMsg { /* Display_FrameMsg */
		PanelElems_Panel p;
		SET id;
		Texts_Elem elem;
		INTEGER x, y, w, h;
	} PanelElems_NotifyMsg;

typedef
	struct PanelElems_TextDesc *PanelElems_Text;

typedef
	struct PanelElems_PanelDesc { /* Elems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[8];
		BOOLEAN locked;
		char _prvt2[10];
		INTEGER border;
		PanelElems_Selection sel;
		char _prvt3[4];
		LONGINT selTime;
		PanelElems_Text elemTxt;
		BOOLEAN showTabs;
	} PanelElems_PanelDesc;

typedef
	struct PanelElems_SelectionDesc {
		PanelElems_Case c;
		char _prvt0[4];
	} PanelElems_SelectionDesc;

typedef
	struct PanelElems_SelectionMsg { /* Oberon_SelectionMsg */
		LONGINT time;
		Texts_Text text;
		LONGINT beg, end;
		PanelElems_Panel p;
		PanelElems_Selection sel;
	} PanelElems_SelectionMsg;

typedef
	struct PanelElems_TextDesc { /* Texts_TextDesc */
		LONGINT len;
		Texts_Notifier notify;
		char _prvt0[12];
		PanelElems_Panel base;
	} PanelElems_TextDesc;



import LONGINT *PanelElems_CaseDesc__typ;
import LONGINT *PanelElems_SelectionDesc__typ;
import LONGINT *PanelElems_TextDesc__typ;
import LONGINT *PanelElems_FrameDesc__typ;
import LONGINT *PanelElems_PanelDesc__typ;
import LONGINT *PanelElems_SelectionMsg__typ;
import LONGINT *PanelElems_CopyOverMsg__typ;
import LONGINT *PanelElems_NotifyMsg__typ;

import void PanelElems_AppendToSelection (PanelElems_Panel p, PanelElems_Case c);
import void PanelElems_CopyPanel (PanelElems_Panel from, PanelElems_Panel to);
import void PanelElems_DeleteCase (PanelElems_Panel p, PanelElems_Case c);
import void PanelElems_DeleteSelection (PanelElems_Frame f);
import void PanelElems_DrawContents (PanelElems_Panel p, Display_Frame f, INTEGER x0, INTEGER y0);
import void PanelElems_DrawPanel (PanelElems_Panel p, INTEGER x, INTEGER y, INTEGER color, Display_Frame f);
import void PanelElems_DrawTextElem (PanelElems_Panel p, PanelElems_Case c, Display_Frame f, INTEGER x0, INTEGER y0);
import void PanelElems_FrameHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
import void PanelElems_Handle (Texts_Elem p, Texts_ElemMsg *msg, LONGINT *msg__typ);
import BOOLEAN PanelElems_InArea (INTEGER ax, INTEGER ay, INTEGER aw, INTEGER ah, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
import BOOLEAN PanelElems_InBorder (INTEGER mX, INTEGER mY, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
import void PanelElems_Init (PanelElems_Panel p);
import void PanelElems_Insert (void);
import void PanelElems_InsertElem (PanelElems_Panel p, Texts_Elem e, INTEGER x, INTEGER y, Fonts_Font fnt, SHORTINT col);
import PanelElems_Case PanelElems_MyCase (PanelElems_Panel p, Texts_Elem e);
import void PanelElems_New (void);
import PanelElems_Selection PanelElems_NextSel (PanelElems_Selection s);
import Display_Frame PanelElems_OpenFrame (PanelElems_Panel p, Display_Frame f, Display_Handler handle, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
import BOOLEAN PanelElems_OverlapsArea (INTEGER ax, INTEGER ay, INTEGER aw, INTEGER ah, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
import void PanelElems_PrintTextElem (PanelElems_Panel p, PanelElems_Case c, Display_Frame f, INTEGER x0, INTEGER y0);
import void PanelElems_RemoveCaret (PanelElems_Frame f);
import void PanelElems_RemoveFromSelection (PanelElems_Panel p, PanelElems_Case c);
import void PanelElems_RemoveSelection (PanelElems_Frame f);
import void PanelElems_SetCaret (PanelElems_Frame f, INTEGER X, INTEGER Y);
import void PanelElems_SetFrameCoords (PanelElems_Frame f, INTEGER X, INTEGER Y, INTEGER W, INTEGER H);
import PanelElems_Case PanelElems_ThisCase (PanelElems_Panel p, INTEGER x, INTEGER y, INTEGER x0, INTEGER y0);
import void PanelElems_TruncateFrame (PanelElems_Frame f, INTEGER *X, INTEGER *Y, INTEGER *W, INTEGER *H);
import void PanelElems_UpdateArea (PanelElems_Panel p, INTEGER x, INTEGER y, INTEGER w, INTEGER h, SET id);
import void *PanelElems__init(void);


#endif
