/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "Input.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"

typedef
	struct ParcElems_StateMsg { /* Texts_ElemMsg */
		INTEGER id;
		LONGINT pos;
		TextFrames_Frame frame;
		Texts_Scanner par;
		Texts_Text log;
	} ParcElems_StateMsg;


static Texts_Writer ParcElems_W;
static SET ParcElems_TabMarkImage[6];
static LONGINT ParcElems_TabPat;
static INTEGER ParcElems_unit;

export LONGINT *ParcElems_StateMsg__typ;

export void ParcElems_Alloc (void);
export void ParcElems_ChangedParc (TextFrames_Parc P, LONGINT beg);
export void ParcElems_CopyParc (TextFrames_Parc SP, TextFrames_Parc DP);
export void ParcElems_Draw (TextFrames_Parc P, Display_Frame F, SHORTINT col, INTEGER x0, INTEGER y0);
static void ParcElems_DrawCursor (INTEGER x, INTEGER y);
export void ParcElems_Edit (TextFrames_Parc P, TextFrames_Frame F, LONGINT pos, INTEGER x0, INTEGER y0, INTEGER x, INTEGER y, SET keysum);
static void ParcElems_FirstMark (SHORTINT col, INTEGER x, INTEGER y0);
static SET ParcElems_FlipBits (SET s);
static void ParcElems_FlipFirst (TextFrames_Parc P, INTEGER x0, INTEGER y0);
static void ParcElems_FlipLeft (TextFrames_Parc P, INTEGER x0, INTEGER y0);
static void ParcElems_FlipRight (TextFrames_Parc P, INTEGER x0, INTEGER y0);
static void ParcElems_FlipTab (TextFrames_Parc P, INTEGER i, INTEGER x0, INTEGER y0);
export void ParcElems_GetAttr (TextFrames_Parc P, TextFrames_Frame F, Texts_Scanner *S, LONGINT *S__typ, Texts_Text log);
static void ParcElems_GetNextInt (Texts_Scanner *S, LONGINT *S__typ, LONGINT *units, LONGINT lo, LONGINT hi, LONGINT def);
static void ParcElems_GrabTab (TextFrames_Parc P, INTEGER x0, INTEGER y0, INTEGER dw, INTEGER *i, BOOLEAN *new);
static LONGINT ParcElems_Grid (LONGINT x);
export void ParcElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void ParcElems_InitDefParc (TextFrames_Parc *def);
static void ParcElems_InitPatterns (void);
static void ParcElems_Int (LONGINT n);
static void ParcElems_Ln (void);
export void ParcElems_LoadParc (TextFrames_Parc P, Files_Rider *r, LONGINT *r__typ);
static BOOLEAN ParcElems_Matches (Texts_Scanner *S, LONGINT *S__typ, CHAR *key, LONGINT key__len);
static LONGINT ParcElems_Max (LONGINT x, LONGINT y);
static LONGINT ParcElems_Min (LONGINT x, LONGINT y);
static void ParcElems_MoveFirst (TextFrames_Parc P, INTEGER x0, INTEGER y0, INTEGER dw);
static void ParcElems_MoveLeft (TextFrames_Parc P, LONGINT rm, INTEGER x0, INTEGER y0, INTEGER dw);
static void ParcElems_MoveRight (TextFrames_Parc P, LONGINT rm, INTEGER x0, INTEGER y0, INTEGER dw);
static void ParcElems_MoveTab (TextFrames_Parc P, LONGINT rm, INTEGER i, INTEGER x0, INTEGER y0, INTEGER dw);
export void ParcElems_ParcExtent (Texts_Text T, LONGINT beg, LONGINT *end);
export void ParcElems_Prepare (TextFrames_Parc P, LONGINT indent, LONGINT unit);
static void ParcElems_RdSet (Files_Rider *r, LONGINT *r__typ, SET *s);
static void ParcElems_RemoveTab (TextFrames_Parc P, INTEGER i);
export void ParcElems_SetAttr (TextFrames_Parc P, TextFrames_Frame F, LONGINT pos, Texts_Scanner *S, LONGINT *S__typ, Texts_Text log);
export void ParcElems_StoreParc (TextFrames_Parc P, Files_Rider *r, LONGINT *r__typ);
static void ParcElems_Str (CHAR *s, LONGINT s__len);
static void ParcElems_TabMark (SHORTINT col, INTEGER x, INTEGER y);
static void ParcElems_TrackMouse (INTEGER *x, INTEGER *y, SET *keys, SET *keysum);
static void ParcElems_WrtSet (Files_Rider *r, LONGINT *r__typ, SET s);


static SET ParcElems_FlipBits (SET s)
{
	SET d = 0;
	INTEGER i = 0;
	d = 0x0;
	i = 0;
	while (i < 32) {
		if (__IN(i, s)) {
			d |= __SETOF(31 - i);
		}
		i += 1;
	}
	return d;
}

static void ParcElems_RdSet (Files_Rider *r, LONGINT *r__typ, SET *s)
{
	Files_ReadNum(&*r, r__typ, (LONGINT*)&*s);
}

static void ParcElems_WrtSet (Files_Rider *r, LONGINT *r__typ, SET s)
{
	Files_WriteNum(&*r, r__typ, (LONGINT)s);
}

static void ParcElems_Str (CHAR *s, LONGINT s__len)
{
	__DUP(s, s__len, CHAR);
	Texts_WriteString(&ParcElems_W, Texts_Writer__typ, s, s__len);
	__DEL(s);
}

static void ParcElems_Int (LONGINT n)
{
	Texts_Write(&ParcElems_W, Texts_Writer__typ, ' ');
	Texts_WriteInt(&ParcElems_W, Texts_Writer__typ, n, 0);
}

static void ParcElems_Ln (void)
{
	Texts_WriteLn(&ParcElems_W, Texts_Writer__typ);
}

static LONGINT ParcElems_Min (LONGINT x, LONGINT y)
{
	if (x < y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static LONGINT ParcElems_Max (LONGINT x, LONGINT y)
{
	if (x > y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static BOOLEAN ParcElems_Matches (Texts_Scanner *S, LONGINT *S__typ, CHAR *key, LONGINT key__len)
{
	INTEGER i = 0;
	__DUP(key, key__len, CHAR);
	i = 0;
	while ((*S).s[__X(i, 256)] != 0x00 && __CAP((*S).s[__X(i, 256)]) == key[__X(i, key__len)]) {
		i += 1;
	}
	__DEL(key);
	return ((*S).class == 1 && (key[__X(i, key__len)] == 0x00 || i >= 3)) && (*S).s[__X(i, 256)] == 0x00;
}

static void ParcElems_GetNextInt (Texts_Scanner *S, LONGINT *S__typ, LONGINT *units, LONGINT lo, LONGINT hi, LONGINT def)
{
	Texts_Scan(&*S, S__typ);
	if (ParcElems_Matches(&*S, S__typ, (CHAR*)"DEFAULT", (LONGINT)8)) {
		(*S).class = 3;
		(*S).i = def;
		*units = (*S).i * 3600;
	} else if ((*S).class == 3) {
		if ((*S).i < lo || (*S).i >= hi) {
			(*S).i = def;
		}
		*units = (*S).i * 3600;
	}
}

static LONGINT ParcElems_Grid (LONGINT x)
{
	return x + __MOD(-x, 36000);
}

static void ParcElems_DrawCursor (INTEGER x, INTEGER y)
{
	Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
}

static void ParcElems_TrackMouse (INTEGER *x, INTEGER *y, SET *keys, SET *keysum)
{
	Input_Mouse(&*keys, &*x, &*y);
	ParcElems_DrawCursor(*x, *y);
	*keysum = *keysum | *keys;
}

static void ParcElems_FirstMark (SHORTINT col, INTEGER x, INTEGER y0)
{
	Display_ReplConst(col, x, (y0 + 5) + 1, 2, 5, 1);
}

static void ParcElems_FlipFirst (TextFrames_Parc P, INTEGER x0, INTEGER y0)
{
	Display_ReplConst(15, x0 + (int)__DIV(P->left + P->first, (LONGINT)ParcElems_unit), (y0 + 5) + 1, 2, 5, 2);
}

static void ParcElems_MoveFirst (TextFrames_Parc P, INTEGER x0, INTEGER y0, INTEGER dw)
{
	LONGINT px = 0;
	px = ParcElems_Grid((LONGINT)dw * (LONGINT)ParcElems_unit);
	px = ParcElems_Max(px, -P->left);
	px = ParcElems_Min(px, (P->W - P->left) - 72000);
	if (px != P->first) {
		ParcElems_FlipFirst(P, x0, y0);
		P->first = px;
		ParcElems_FlipFirst(P, x0, y0);
	}
}

static void ParcElems_FlipLeft (TextFrames_Parc P, INTEGER x0, INTEGER y0)
{
	Display_ReplConst(15, x0 + (int)__DIV(P->left, (LONGINT)ParcElems_unit), ((y0 + 5) - 5) + 1, 5, 5, 2);
}

static void ParcElems_MoveLeft (TextFrames_Parc P, LONGINT rm, INTEGER x0, INTEGER y0, INTEGER dw)
{
	LONGINT px = 0;
	px = ParcElems_Grid((LONGINT)dw * (LONGINT)ParcElems_unit);
	px = ParcElems_Max(px, 0);
	px = ParcElems_Min(px, rm);
	if (px != P->left) {
		ParcElems_FlipLeft(P, x0, y0);
		P->left = px;
		ParcElems_FlipLeft(P, x0, y0);
	}
}

static void ParcElems_FlipRight (TextFrames_Parc P, INTEGER x0, INTEGER y0)
{
	Display_ReplConst(15, (x0 + (int)__DIV(P->left + P->width, (LONGINT)ParcElems_unit)) - 5, ((y0 + 5) - 5) + 1, 5, 5, 2);
}

static void ParcElems_MoveRight (TextFrames_Parc P, LONGINT rm, INTEGER x0, INTEGER y0, INTEGER dw)
{
	LONGINT px = 0;
	px = ParcElems_Grid((LONGINT)dw * (LONGINT)ParcElems_unit);
	px = ParcElems_Max(px, P->left + 360000);
	px = ParcElems_Min(px, rm);
	if (px != P->left + P->width) {
		ParcElems_FlipRight(P, x0, y0);
		P->width = px - P->left;
		ParcElems_FlipRight(P, x0, y0);
	}
}

static void ParcElems_TabMark (SHORTINT col, INTEGER x, INTEGER y)
{
	Display_CopyPattern(col, ParcElems_TabPat, x, y, 0);
}

static void ParcElems_FlipTab (TextFrames_Parc P, INTEGER i, INTEGER x0, INTEGER y0)
{
	Display_CopyPattern(15, ParcElems_TabPat, x0 + (int)__DIV(P->tab[__X(i, 32)], (LONGINT)ParcElems_unit), y0, 2);
}

static void ParcElems_GrabTab (TextFrames_Parc P, INTEGER x0, INTEGER y0, INTEGER dw, INTEGER *i, BOOLEAN *new)
{
	INTEGER j = 0;
	LONGINT lx = 0, px = 0, rx = 0;
	*i = 0;
	j = P->nofTabs;
	*new = 0;
	px = ParcElems_Grid((LONGINT)dw * (LONGINT)ParcElems_unit);
	while (*i < j && P->tab[__X(*i, 32)] < px - 72000) {
		*i += 1;
	}
	if (*i < 32) {
		if (*i == j || P->tab[__X(*i, 32)] >= px + 72000) {
			if (*i == 0) {
				lx = 72000;
			} else {
				lx = P->tab[__X(*i - 1, 32)] + 72000;
			}
			if (*i == P->nofTabs) {
				rx = P->width;
			} else {
				rx = P->tab[__X(*i, 32)] - 72000;
			}
			if (px < lx) {
				px = lx;
			}
			if (px < rx) {
				P->nofTabs += 1;
				*new = 1;
				while (j > *i) {
					P->tab[__X(j, 32)] = P->tab[__X(j - 1, 32)];
					j -= 1;
				}
			}
		} else {
			px = P->tab[__X(*i, 32)];
		}
	} else {
		*i -= 1;
		px = P->tab[__X(*i, 32)];
	}
	if (!*new) {
		ParcElems_FlipTab(P, *i, x0, y0);
	}
	P->tab[__X(*i, 32)] = px;
	ParcElems_FlipTab(P, *i, x0, y0);
}

static void ParcElems_MoveTab (TextFrames_Parc P, LONGINT rm, INTEGER i, INTEGER x0, INTEGER y0, INTEGER dw)
{
	LONGINT lx = 0, px = 0, rx = 0;
	px = ParcElems_Grid((LONGINT)dw * (LONGINT)ParcElems_unit);
	if (i == 0) {
		lx = 72000;
	} else {
		lx = P->tab[__X(i - 1, 32)] + 72000;
	}
	if (i == P->nofTabs - 1) {
		rx = P->width;
	} else {
		rx = P->tab[__X(i + 1, 32)] - 72000;
	}
	px = ParcElems_Max(px, lx);
	px = ParcElems_Min(px, rx);
	px = ParcElems_Min(px, rm);
	if (px != P->tab[__X(i, 32)]) {
		ParcElems_FlipTab(P, i, x0, y0);
		P->tab[__X(i, 32)] = px;
		ParcElems_FlipTab(P, i, x0, y0);
	}
}

static void ParcElems_RemoveTab (TextFrames_Parc P, INTEGER i)
{
	while (i < P->nofTabs - 1) {
		P->tab[__X(i, 32)] = P->tab[__X(i + 1, 32)];
		i += 1;
	}
	P->nofTabs -= 1;
}

void ParcElems_ParcExtent (Texts_Text T, LONGINT beg, LONGINT *end)
{
	Texts_Reader R = {0};
	Texts_OpenReader(&R, Texts_Reader__typ, T, beg + 1);
	do {
		Texts_ReadElem(&R, Texts_Reader__typ);
	} while (!(R.eot || __ISP(R.elem, TextFrames_ParcDesc, 2)));
	if (R.eot) {
		*end = T->len;
	} else {
		*end = Texts_Pos(&R, Texts_Reader__typ) - 1;
	}
}

void ParcElems_ChangedParc (TextFrames_Parc P, LONGINT beg)
{
	Texts_Text T = NIL;
	LONGINT end = 0;
	T = Texts_ElemBase((void*)P);
	ParcElems_ParcExtent(T, beg, &end);
	Texts_ChangeLooks(T, beg, end, 0x0, NIL, 0, 0);
}

void ParcElems_LoadParc (TextFrames_Parc P, Files_Rider *r, LONGINT *r__typ)
{
	LONGINT version = 0, i = 0, j = 0, k = 0;
	Files_ReadNum(&*r, r__typ, &version);
	Files_ReadNum(&*r, r__typ, &P->first);
	Files_ReadNum(&*r, r__typ, &P->left);
	Files_ReadNum(&*r, r__typ, &P->width);
	Files_ReadNum(&*r, r__typ, &P->lead);
	Files_ReadNum(&*r, r__typ, &P->lsp);
	Files_ReadNum(&*r, r__typ, &P->dsr);
	ParcElems_RdSet(&*r, r__typ, &P->opts);
	Files_ReadNum(&*r, r__typ, &i);
	if (i <= 32) {
		P->nofTabs = (int)i;
	} else {
		P->nofTabs = 32;
	}
	j = 0;
	while (j < (LONGINT)P->nofTabs) {
		Files_ReadNum(&*r, r__typ, &P->tab[__X(j, 32)]);
		j += 1;
	}
	while (j < i) {
		Files_ReadNum(&*r, r__typ, &k);
		j += 1;
	}
}

void ParcElems_StoreParc (TextFrames_Parc P, Files_Rider *r, LONGINT *r__typ)
{
	INTEGER i = 0;
	Files_WriteNum(&*r, r__typ, 1);
	Files_WriteNum(&*r, r__typ, P->first);
	Files_WriteNum(&*r, r__typ, P->left);
	Files_WriteNum(&*r, r__typ, P->width);
	Files_WriteNum(&*r, r__typ, P->lead);
	Files_WriteNum(&*r, r__typ, P->lsp);
	Files_WriteNum(&*r, r__typ, P->dsr);
	ParcElems_WrtSet(&*r, r__typ, P->opts);
	Files_WriteNum(&*r, r__typ, P->nofTabs);
	i = 0;
	while (i < P->nofTabs) {
		Files_WriteNum(&*r, r__typ, P->tab[__X(i, 32)]);
		i += 1;
	}
}

void ParcElems_CopyParc (TextFrames_Parc SP, TextFrames_Parc DP)
{
	INTEGER i = 0;
	Texts_CopyElem((void*)SP, (void*)DP);
	DP->first = SP->first;
	DP->left = SP->left;
	DP->width = SP->width;
	DP->lead = SP->lead;
	DP->lsp = SP->lsp;
	DP->dsr = SP->dsr;
	DP->opts = SP->opts;
	DP->nofTabs = SP->nofTabs;
	i = SP->nofTabs;
	while (i > 0) {
		i -= 1;
		DP->tab[__X(i, 32)] = SP->tab[__X(i, 32)];
	}
}

void ParcElems_Prepare (TextFrames_Parc P, LONGINT indent, LONGINT unit)
{
	P->W = 9999 * unit;
	P->H = 108000 + P->lead;
	if (__IN(0, P->opts)) {
		P->H += __MOD(-P->lead, P->lsp);
	}
}

void ParcElems_Draw (TextFrames_Parc P, Display_Frame F, SHORTINT col, INTEGER x0, INTEGER y0)
{
	INTEGER i = 0, x1 = 0, px = 0, w = 0, w0 = 0, n = 0;
	x1 = x0 + (int)__DIV(P->left, (LONGINT)ParcElems_unit);
	w = (int)__DIV(P->width, (LONGINT)ParcElems_unit);
	w0 = (int)__DIV(P->W - P->left, (LONGINT)ParcElems_unit);
	if (__IN(4, P->opts)) {
		n = 2;
	} else {
		n = 1;
	}
	while (n > 0) {
		n -= 1;
		if (w > 20) {
			i = 0;
			for (;;) {
				if (i == P->nofTabs) {
					break;
				}
				px = (int)((LONGINT)x1 + __DIV(P->tab[__X(i, 32)], (LONGINT)ParcElems_unit));
				if (px > x1 + w) {
					break;
				}
				ParcElems_TabMark(col, px, y0);
				i += 1;
			}
			if (__IN(3, P->opts)) {
				Display_ReplConst(col, x1, y0 + 5, w0, 1, 0);
			} else {
				Display_ReplPatternC(F, col, Display_grey1, x1, y0 + 5, w0, 1, x1, y0 + 5, 0);
			}
			Display_ReplPatternC(F, col, Display_grey1, x1, ((y0 + 5) - 5) + 1, 5, 5, x1, ((y0 + 5) - 5) + 1, 0);
			Display_ReplPatternC(F, col, Display_grey1, (x1 + w) - 5, ((y0 + 5) - 5) + 1, 5, 5, (x1 + w) - 5, ((y0 + 5) - 5) + 1, 0);
			if (!__IN(1, P->opts)) {
				Display_ReplConstC(F, 0, x1 + 1, ((y0 + 5) - 5) + 2, 3, 3, 0);
			}
			if (!__IN(2, P->opts)) {
				Display_ReplConstC(F, 0, ((x1 + w) - 5) + 1, ((y0 + 5) - 5) + 2, 3, 3, 0);
			}
			ParcElems_FirstMark(col, x0 + (int)__DIV(P->left + P->first, (LONGINT)ParcElems_unit), y0);
			if (__ISP(F, TextFrames_FrameDesc, 1)) {
				x0 = (int)ParcElems_Max((LONGINT)(x1 + w) + __DIV(252000, (LONGINT)ParcElems_unit), (LONGINT)x0 + __ASHR((LONGINT)(((*(TextFrames_Frame*)&F)->W - (*(TextFrames_Frame*)&F)->left) - (*(TextFrames_Frame*)&F)->right) + __DIV(252000, (LONGINT)ParcElems_unit), 1));
				x1 = x0 + (int)__DIV(P->left, (LONGINT)ParcElems_unit);
				w = (int)ParcElems_Min((((*(TextFrames_Frame*)&F)->X + (*(TextFrames_Frame*)&F)->W) - (*(TextFrames_Frame*)&F)->right) - x1, __DIV(P->W - P->left, (LONGINT)ParcElems_unit));
			} else __WITHCHK;
		}
	}
}

void ParcElems_Edit (TextFrames_Parc P, TextFrames_Frame F, LONGINT pos, INTEGER x0, INTEGER y0, INTEGER x, INTEGER y, SET keysum)
{
	SET keys = 0;
	LONGINT old = 0, rx = 0;
	INTEGER i = 0, x1 = 0, dw = 0, dh = 0, dx = 0, w = 0, w0 = 0;
	BOOLEAN changed = 0, new = 0;
	if (__IN(1, keysum) && F->showsParcs) {
		changed = 0;
		x1 = x0 + (int)__DIV(P->left, (LONGINT)ParcElems_unit);
		w = (int)__DIV(P->width, (LONGINT)ParcElems_unit);
		w0 = (int)__DIV(P->W - P->left, (LONGINT)ParcElems_unit);
		dh = y - y0;
		dw = x - x1;
		Oberon_RemoveMarks(x0, y0, (int)__DIV(P->W, (LONGINT)ParcElems_unit), (int)__DIV(P->H, (LONGINT)ParcElems_unit));
		if ((dh <= 5 && dw >= -3) && dw <= 8) {
			old = P->left;
			rx = (P->left + (LONGINT)w0 * (LONGINT)ParcElems_unit) - 360000;
			do {
				ParcElems_TrackMouse(&x, &y, &keys, &keysum);
				ParcElems_MoveLeft(P, rx, x0, y0, (x - x0) - dw);
			} while (!(keys == 0x0));
			if (keysum == 0x02) {
				P->width -= P->left - old;
				changed = 1;
			} else {
				ParcElems_FlipLeft(P, x0, y0);
				P->left = old;
				ParcElems_FlipLeft(P, x0, y0);
			}
		} else if ((dh <= 5 && dw >= (w - 5) - 3) && dw <= w + 3) {
			old = P->width;
			rx = (LONGINT)((F->W - F->left) - F->right) * (LONGINT)ParcElems_unit;
			dx = dw - (int)__DIV(P->width, (LONGINT)ParcElems_unit);
			do {
				ParcElems_TrackMouse(&x, &y, &keys, &keysum);
				ParcElems_MoveRight(P, rx, x0, y0, (x - x0) - dx);
			} while (!(keys == 0x0));
			if (keysum == 0x02) {
				changed = 1;
			} else {
				ParcElems_FlipRight(P, x0, y0);
				P->width = old;
				ParcElems_FlipRight(P, x0, y0);
			}
		} else if (dw >= 0 && dh <= 5) {
			if (dw > 0) {
				changed = 1;
				ParcElems_GrabTab(P, x1, y0, x - x1, &i, &new);
				old = P->tab[__X(i, 32)];
				rx = (P->left + (LONGINT)w0 * (LONGINT)ParcElems_unit) - 72000;
				do {
					ParcElems_TrackMouse(&x, &y, &keys, &keysum);
					ParcElems_MoveTab(P, rx, i, x1, y0, x - x1);
				} while (!(keys == 0x0));
				if (keysum == 0x02) {
					ParcElems_FlipTab(P, i, x1, y0);
				} else if (keysum == 0x03) {
					ParcElems_FlipTab(P, i, x1, y0);
					rx = P->tab[__X(i, 32)] - old;
					while (i < P->nofTabs - 1) {
						i += 1;
						P->tab[__X(i, 32)] += rx;
					}
				} else if (new || keysum == 0x06) {
					ParcElems_RemoveTab(P, i);
				} else {
					changed = 0;
					ParcElems_FlipTab(P, i, x1, y0);
					P->tab[__X(i, 32)] = old;
					ParcElems_FlipTab(P, i, x1, y0);
				}
			}
		} else if (dh > 5) {
			if (__DIV(P->first, (LONGINT)ParcElems_unit) <= (LONGINT)dw && (LONGINT)dw < __DIV(P->first, (LONGINT)ParcElems_unit) + 5) {
				old = P->first;
				do {
					ParcElems_TrackMouse(&x, &y, &keys, &keysum);
					ParcElems_MoveFirst(P, x0, y0, (x - x1) - 4);
				} while (!(keys == 0x0));
				if (keysum != 0x07) {
					changed = 1;
				} else {
					ParcElems_FlipFirst(P, x0, y0);
					P->first = old;
					ParcElems_FlipFirst(P, x0, y0);
				}
			} else {
				if (dw < __ASHR(w0, 1)) {
					Display_ReplConst(15, x1, (y0 + 5) + 1, __ASHR(w0, 1), 4, 2);
				} else {
					Display_ReplConst(15, x1 + __ASHR(w0, 1), (y0 + 5) + 1, __ASHR(w0, 1), 4, 2);
				}
				do {
					ParcElems_TrackMouse(&x, &y, &keys, &keysum);
				} while (!(keys == 0x0));
				if (dw < __ASHR(w0, 1)) {
					Display_ReplConst(15, x1, (y0 + 5) + 1, __ASHR(w0, 1), 4, 2);
				} else {
					Display_ReplConst(15, x1 + __ASHR(w0, 1), (y0 + 5) + 1, __ASHR(w0, 1), 4, 2);
				}
				if (keysum == 0x02) {
					if (dw < __ASHR(w0, 1)) {
						P->opts = P->opts ^ 0x02;
						changed = 1;
					} else {
						P->opts = P->opts ^ 0x04;
						changed = 1;
					}
				}
			}
		}
		if (P->left + P->first < 0) {
			P->first = -P->left;
			changed = 1;
		} else if (P->first > P->width - 72000) {
			P->first = P->width - 72000;
			changed = 1;
		}
		if (changed) {
			ParcElems_ChangedParc(P, pos);
		}
	}
}

static struct SetAttr__36 {
	TextFrames_Parc *P;
	LONGINT *pos;
	struct SetAttr__36 *lnk;
} *SetAttr__36_s;

static void Err__37 (CHAR *s, LONGINT s__len, INTEGER n);
static void SetMeasure__39 (LONGINT new, LONGINT *old);
static void SetOpts__41 (SET opts);

static void SetMeasure__39 (LONGINT new, LONGINT *old)
{
	if (new != *old) {
		*old = new;
		ParcElems_ChangedParc(*SetAttr__36_s->P, *SetAttr__36_s->pos);
	}
}

static void SetOpts__41 (SET opts)
{
	if ((*SetAttr__36_s->P)->opts != opts) {
		(*SetAttr__36_s->P)->opts = opts;
		ParcElems_ChangedParc(*SetAttr__36_s->P, *SetAttr__36_s->pos);
	}
}

static void Err__37 (CHAR *s, LONGINT s__len, INTEGER n)
{
	__DUP(s, s__len, CHAR);
	ParcElems_Str((CHAR*)"Set ", (LONGINT)5);
	ParcElems_Str(s, s__len);
	ParcElems_Str((CHAR*)" failed (bad ", (LONGINT)14);
	switch (n) {
		case 0: 
			ParcElems_Str((CHAR*)"number)", (LONGINT)8);
			break;
		case 1: 
			ParcElems_Str((CHAR*)"indentation)", (LONGINT)13);
			break;
		case 2: 
			ParcElems_Str((CHAR*)"option)", (LONGINT)8);
			break;
		case 3: 
			ParcElems_Str((CHAR*)"selector)", (LONGINT)10);
			break;
		default: __CASECHK;
	}
	ParcElems_Ln();
	__DEL(s);
}

void ParcElems_SetAttr (TextFrames_Parc P, TextFrames_Frame F, LONGINT pos, Texts_Scanner *S, LONGINT *S__typ, Texts_Text log)
{
	Fonts_Font fnt = NIL;
	LONGINT def = 0, pt = 0, lsp = 0, dsr = 0, new = 0;
	BOOLEAN changed = 0;
	struct SetAttr__36 _s;
	_s.P = &P;
	_s.pos = &pos;
	_s.lnk = SetAttr__36_s;
	SetAttr__36_s = &_s;
	changed = 0;
	if (ParcElems_Matches(&*S, S__typ, (CHAR*)"LEAD", (LONGINT)5)) {
		def = __DIV(TextFrames_defParc->lead, 3600);
		ParcElems_GetNextInt(&*S, S__typ, &new, 0, 10000, def);
		if ((*S).class == 3) {
			SetMeasure__39(new, &P->lead);
		} else if ((*S).class == 1) {
			fnt = Fonts_This((*S).s, 256);
			lsp = ParcElems_Max(fnt->height, fnt->maxY - fnt->minY) * (LONGINT)ParcElems_unit;
			lsp += __MOD(-lsp, 3600);
			SetMeasure__39(lsp, &P->lead);
		} else {
			Err__37((CHAR*)"lead", (LONGINT)5, 0);
		}
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"LINE", (LONGINT)5)) {
		def = __DIV(TextFrames_defParc->lsp, 3600);
		ParcElems_GetNextInt(&*S, S__typ, &new, 10, 10000, def);
		if ((*S).class == 3) {
			lsp = new;
			dsr = __ASHR(lsp, 2);
			dsr += __MOD(-dsr, 3600);
		} else if ((*S).class == 1) {
			fnt = Fonts_This((*S).s, 256);
			lsp = ParcElems_Max(fnt->height, fnt->maxY - fnt->minY) * (LONGINT)ParcElems_unit;
			lsp += __MOD(-lsp, 3600);
			dsr = (LONGINT)(-fnt->minY) * (LONGINT)ParcElems_unit;
			dsr += __MOD(-dsr, 3600);
		} else {
			Err__37((CHAR*)"line", (LONGINT)5, 0);
			lsp = P->lsp;
			dsr = P->dsr;
		}
		if (P->lsp != lsp || P->dsr != dsr) {
			P->lsp = lsp;
			P->dsr = dsr;
			changed = 1;
		}
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"FIRST", (LONGINT)6)) {
		def = __DIV(TextFrames_defParc->first, 3600);
		ParcElems_GetNextInt(&*S, S__typ, &new, -10000, 10000, def);
		if ((*S).class == 3) {
			if (0 <= P->left + new && new <= P->width - 72000) {
				SetMeasure__39(new, &P->first);
			} else {
				Err__37((CHAR*)"first", (LONGINT)6, 1);
			}
		} else {
			Err__37((CHAR*)"first", (LONGINT)6, 0);
		}
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"LEFT", (LONGINT)5)) {
		def = __DIV(TextFrames_defParc->left, 3600);
		ParcElems_GetNextInt(&*S, S__typ, &new, 0, 10000, def);
		if ((*S).class == 3) {
			if (0 <= new && new <= (P->left + P->width) - 360000) {
				if (new != P->left) {
					P->width += P->left - new;
					P->left = new;
					if (P->left + P->first < 0) {
						P->first = -P->left;
					}
					changed = 1;
				}
			} else {
				Err__37((CHAR*)"left", (LONGINT)5, 0);
			}
		} else {
			Err__37((CHAR*)"left", (LONGINT)5, 0);
		}
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"RIGHT", (LONGINT)6)) {
		def = __DIV(TextFrames_defParc->left + TextFrames_defParc->width, 3600);
		ParcElems_GetNextInt(&*S, S__typ, &new, 0, 10000, def);
		if ((*S).class == 3) {
			if (P->left + 360000 <= new) {
				if (new - P->left != P->width) {
					P->width = new - P->left;
					if (P->first > P->width - 72000) {
						P->first = P->width - 72000;
					}
					changed = 1;
				}
			} else {
				Err__37((CHAR*)"right", (LONGINT)6, 0);
			}
		} else {
			Err__37((CHAR*)"right", (LONGINT)6, 0);
		}
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"WIDTH", (LONGINT)6)) {
		def = __DIV(TextFrames_defParc->width, 3600);
		ParcElems_GetNextInt(&*S, S__typ, &new, 100, 10000, def);
		if ((*S).class == 3) {
			if (new != P->width) {
				P->width = new;
				if (P->first > P->width - 72000) {
					P->first = P->width - 72000;
				}
				changed = 1;
			}
		} else {
			Err__37((CHAR*)"width", (LONGINT)6, 0);
		}
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"GRID", (LONGINT)5)) {
		Texts_Scan(&*S, S__typ);
		if (ParcElems_Matches(&*S, S__typ, (CHAR*)"ON", (LONGINT)3)) {
			SetOpts__41(P->opts | 0x01);
		} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"OFF", (LONGINT)4)) {
			SetOpts__41(P->opts & ~0x01);
		} else {
			Err__37((CHAR*)"grid", (LONGINT)5, 2);
		}
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"ADJUST", (LONGINT)7)) {
		Texts_Scan(&*S, S__typ);
		if (ParcElems_Matches(&*S, S__typ, (CHAR*)"LEFT", (LONGINT)5)) {
			SetOpts__41(P->opts & ~0x06 | 0x02);
		} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"RIGHT", (LONGINT)6)) {
			SetOpts__41(P->opts & ~0x06 | 0x04);
		} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"CENTER", (LONGINT)7)) {
			SetOpts__41(P->opts & ~0x06);
		} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"BLOCK", (LONGINT)6)) {
			SetOpts__41(P->opts | 0x06);
		} else {
			Err__37((CHAR*)"adjust", (LONGINT)7, 2);
		}
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"BREAK", (LONGINT)6)) {
		Texts_Scan(&*S, S__typ);
		if (ParcElems_Matches(&*S, S__typ, (CHAR*)"BEFORE", (LONGINT)7)) {
			SetOpts__41(P->opts | 0x08);
		} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"NORMAL", (LONGINT)7)) {
			SetOpts__41(P->opts & ~0x08);
		} else {
			Err__37((CHAR*)"break", (LONGINT)6, 2);
		}
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"COLUMNS", (LONGINT)8)) {
		ParcElems_GetNextInt(&*S, S__typ, &new, 1, 3, 1);
		if ((*S).class == 3) {
			if ((*S).i == 1) {
				if (__IN(4, P->opts)) {
					P->opts = P->opts & ~0x10;
					P->width = __ASHL(P->width, 1) + 252000;
					ParcElems_ChangedParc(P, pos);
				}
			} else {
				if (!__IN(4, P->opts)) {
					P->opts = P->opts | 0x10;
					P->width = __ASHR(P->width - 252000, 1);
					ParcElems_ChangedParc(P, pos);
				}
			}
		} else {
			Err__37((CHAR*)"left", (LONGINT)5, 0);
		}
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"TABS", (LONGINT)5)) {
		if (P->nofTabs != 0) {
			changed = 1;
		}
		Texts_Scan(&*S, S__typ);
		P->nofTabs = 0;
		pt = 0;
		if ((*S).class == 6 && (*S).c == '*') {
			Texts_Scan(&*S, S__typ);
			if ((*S).class == 3 && (*S).i * 3600 >= 72000) {
				changed = 1;
				while (P->nofTabs < 32 && pt < 3000) {
					pt += (*S).i;
					P->tab[__X(P->nofTabs, 32)] = pt * 3600;
					P->nofTabs += 1;
				}
			}
		} else {
			while (((*S).class == 3 && (*S).i * 3600 >= pt * 3600 + 72000) && P->nofTabs < 32) {
				changed = 1;
				pt = (*S).i;
				P->tab[__X(P->nofTabs, 32)] = pt * 3600;
				P->nofTabs += 1;
				Texts_Scan(&*S, S__typ);
			}
		}
	} else {
		ParcElems_Str((*S).s, 256);
		ParcElems_Int((*S).i);
		Err__37((CHAR*)"", (LONGINT)1, 3);
	}
	if (changed) {
		ParcElems_ChangedParc(P, pos);
	}
	if (ParcElems_W.buf->len != 0) {
		Texts_Append(log, ParcElems_W.buf);
	}
	SetAttr__36_s = _s.lnk;
}

static struct GetAttr__13 {
	TextFrames_Parc *P;
	struct GetAttr__13 *lnk;
} *GetAttr__13_s;

static void Out__14 (INTEGER n);

static void Out__14 (INTEGER n)
{
	INTEGER i = 0;
	LONGINT d = 0;
	switch (n) {
		case 0: 
			ParcElems_Str((CHAR*)"lead", (LONGINT)5);
			ParcElems_Int(__DIV((*GetAttr__13_s->P)->lead, 3600));
			break;
		case 1: 
			ParcElems_Str((CHAR*)"line", (LONGINT)5);
			ParcElems_Int(__DIV((*GetAttr__13_s->P)->lsp, 3600));
			break;
		case 2: 
			ParcElems_Str((CHAR*)"left", (LONGINT)5);
			ParcElems_Int(__DIV((*GetAttr__13_s->P)->left, 3600));
			break;
		case 3: 
			ParcElems_Str((CHAR*)"first", (LONGINT)6);
			ParcElems_Int(__DIV((*GetAttr__13_s->P)->first, 3600));
			break;
		case 4: 
			ParcElems_Str((CHAR*)"width", (LONGINT)6);
			ParcElems_Int(__DIV((*GetAttr__13_s->P)->width, 3600));
			break;
		case 5: 
			ParcElems_Str((CHAR*)"right", (LONGINT)6);
			ParcElems_Int(__DIV((*GetAttr__13_s->P)->left + (*GetAttr__13_s->P)->width, 3600));
			break;
		case 6: 
			if (__IN(0, (*GetAttr__13_s->P)->opts)) {
				ParcElems_Str((CHAR*)"grid on", (LONGINT)8);
			} else {
				ParcElems_Str((CHAR*)"grid off", (LONGINT)9);
			}
			break;
		case 7: 
			if (__IN(1, (*GetAttr__13_s->P)->opts)) {
				if (__IN(2, (*GetAttr__13_s->P)->opts)) {
					ParcElems_Str((CHAR*)"adjust block", (LONGINT)13);
				} else {
					ParcElems_Str((CHAR*)"adjust left", (LONGINT)12);
				}
			} else if (__IN(2, (*GetAttr__13_s->P)->opts)) {
				ParcElems_Str((CHAR*)"adjust right", (LONGINT)13);
			} else {
				ParcElems_Str((CHAR*)"adjust center", (LONGINT)14);
			}
			break;
		case 8: 
			if (__IN(3, (*GetAttr__13_s->P)->opts)) {
				ParcElems_Str((CHAR*)"break before", (LONGINT)13);
			} else {
				ParcElems_Str((CHAR*)"break normal", (LONGINT)13);
			}
			break;
		case 9: 
			if (__IN(4, (*GetAttr__13_s->P)->opts)) {
				ParcElems_Str((CHAR*)"columns 2", (LONGINT)10);
			} else {
				ParcElems_Str((CHAR*)"columns 1", (LONGINT)10);
			}
			break;
		case 10: 
			ParcElems_Str((CHAR*)"tabs", (LONGINT)5);
			i = 0;
			if ((*GetAttr__13_s->P)->nofTabs > 0) {
				d = (*GetAttr__13_s->P)->tab[0];
				i = 1;
				while (i < (*GetAttr__13_s->P)->nofTabs && (*GetAttr__13_s->P)->tab[__X(i, 32)] - (*GetAttr__13_s->P)->tab[__X(i - 1, 32)] == d) {
					i += 1;
				}
			}
			if (((*GetAttr__13_s->P)->nofTabs > 1 && i == (*GetAttr__13_s->P)->nofTabs) && (*GetAttr__13_s->P)->tab[__X(i - 1, 32)] + 72000 > (*GetAttr__13_s->P)->width) {
				ParcElems_Str((CHAR*)" *", (LONGINT)3);
				ParcElems_Int(__DIV(d, 3600));
			} else {
				i = 0;
				while (i < (*GetAttr__13_s->P)->nofTabs) {
					ParcElems_Int(__DIV((*GetAttr__13_s->P)->tab[__X(i, 32)], 3600));
					i += 1;
				}
				ParcElems_Str((CHAR*)" ~", (LONGINT)3);
			}
			break;
		default: __CASECHK;
	}
}

void ParcElems_GetAttr (TextFrames_Parc P, TextFrames_Frame F, Texts_Scanner *S, LONGINT *S__typ, Texts_Text log)
{
	INTEGER n = 0;
	struct GetAttr__13 _s;
	_s.P = &P;
	_s.lnk = GetAttr__13_s;
	GetAttr__13_s = &_s;
	if ((*S).class != 1) {
		Out__14(0);
		n = 1;
		do {
			ParcElems_Ln();
			Out__14(n);
			n += 1;
		} while (!(n == 11));
		ParcElems_Ln();
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"LEAD", (LONGINT)5)) {
		Out__14(0);
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"LINE", (LONGINT)5)) {
		Out__14(1);
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"LEFT", (LONGINT)5)) {
		Out__14(2);
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"FIRST", (LONGINT)6)) {
		Out__14(3);
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"WIDTH", (LONGINT)6)) {
		Out__14(4);
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"RIGHT", (LONGINT)6)) {
		Out__14(5);
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"GRID", (LONGINT)5)) {
		Out__14(6);
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"ADJUST", (LONGINT)7)) {
		Out__14(7);
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"BREAK", (LONGINT)6)) {
		Out__14(8);
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"COLUMNS", (LONGINT)8)) {
		Out__14(9);
	} else if (ParcElems_Matches(&*S, S__typ, (CHAR*)"TABS", (LONGINT)5)) {
		Out__14(10);
	} else {
		ParcElems_Str((CHAR*)"failed (bad selector)", (LONGINT)22);
	}
	Texts_Append(log, ParcElems_W.buf);
	GetAttr__13_s = _s.lnk;
}

void ParcElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	TextFrames_Parc e = NIL;
	if (__ISP(E, TextFrames_ParcDesc, 2)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
				TextFrames_DisplayMsg *msg__ = (void*)msg;
				if ((*msg__).prepare) {
					ParcElems_Prepare((*(TextFrames_Parc*)&E), (*msg__).indent, ParcElems_unit);
				} else {
					ParcElems_Draw((*(TextFrames_Parc*)&E), (*msg__).frame, (*msg__).col, (*msg__).X0, (*msg__).Y0);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
				TextPrinter_PrintMsg *msg__ = (void*)msg;
				if ((*msg__).prepare) {
					ParcElems_Prepare((*(TextFrames_Parc*)&E), (*msg__).indent, 3048);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			__NEW(e, TextFrames_ParcDesc);
			ParcElems_CopyParc((*(TextFrames_Parc*)&E), e);
			__GUARDR(msg, Texts_CopyMsg, 1).e = (Texts_Elem)e;
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
				TextFrames_TrackMsg *msg__ = (void*)msg;
				ParcElems_Edit((*(TextFrames_Parc*)&E), __GUARDP((*msg__).frame, TextFrames_FrameDesc, 1), (*msg__).pos, (*msg__).X0, (*msg__).Y0, (*msg__).X, (*msg__).Y, (*msg__).keys);
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
				Texts_IdentifyMsg *msg__ = (void*)msg;
				__MOVE("ParcElems", (*msg__).mod, 10);
				__MOVE("Alloc", (*msg__).proc, 6);
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			if (__IS(msg__typ, Texts_FileMsg, 1)) {
				Texts_FileMsg *msg__ = (void*)msg;
				if ((*msg__).id == 0) {
					ParcElems_LoadParc((*(TextFrames_Parc*)&E), &(*msg__).r, Files_Rider__typ);
				} else if ((*msg__).id == 1) {
					ParcElems_StoreParc((*(TextFrames_Parc*)&E), &(*msg__).r, Files_Rider__typ);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, ParcElems_StateMsg, 1)) {
			if (__IS(msg__typ, ParcElems_StateMsg, 1)) {
				ParcElems_StateMsg *msg__ = (void*)msg;
				if ((*msg__).id == 0) {
					ParcElems_SetAttr((*(TextFrames_Parc*)&E), (*msg__).frame, (*msg__).pos, &(*msg__).par, Texts_Scanner__typ, (*msg__).log);
				} else if ((*msg__).id == 1) {
					ParcElems_GetAttr((*(TextFrames_Parc*)&E), (*msg__).frame, &(*msg__).par, Texts_Scanner__typ, (*msg__).log);
				}
			} else __WITHCHK;
		}
	} else __WITHCHK;
}

void ParcElems_Alloc (void)
{
	TextFrames_Parc e = NIL;
	__NEW(e, TextFrames_ParcDesc);
	e->handle = ParcElems_Handle;
	Texts_new = (Texts_Elem)e;
}

static void ParcElems_InitDefParc (TextFrames_Parc *def)
{
	LONGINT h = 0, lsp = 0, dsr = 0;
	INTEGER i = 0;
	lsp = ParcElems_Max(Fonts_Default->height, Fonts_Default->maxY - Fonts_Default->minY) * (LONGINT)ParcElems_unit;
	dsr = (LONGINT)(-Fonts_Default->minY) * (LONGINT)ParcElems_unit;
	__NEW(*def, TextFrames_ParcDesc);
	(*def)->W = 99;
	(*def)->H = 108000;
	(*def)->handle = ParcElems_Handle;
	(*def)->first = 0;
	(*def)->left = 0;
	(*def)->width = 5940000;
	(*def)->lead = 0;
	(*def)->lsp = lsp + __MOD(-lsp, 3600);
	(*def)->dsr = dsr + __MOD(-dsr, 3600);
	(*def)->opts = 0x02;
	(*def)->nofTabs = 0;
}

static void ParcElems_InitPatterns (void)
{
	ParcElems_TabMarkImage[1] = 0x1f;
	ParcElems_TabMarkImage[2] = 0x0f;
	ParcElems_TabMarkImage[3] = 0x07;
	ParcElems_TabMarkImage[4] = 0x03;
	ParcElems_TabMarkImage[5] = 0x01;
	ParcElems_TabPat = Display_NewPattern((void*)ParcElems_TabMarkImage, 6, 32, 5);
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&ParcElems_W, Texts_Writer__typ, 36, 1, P);
}

__TDESC(ParcElems_StateMsg, 1, 6) = {__TDFLDS("StateMsg", 360), {8, 20, 28, 40, 52, 352, -28}};

export void *ParcElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__REGMOD(ParcElems, EnumPtrs);
	__REGCMD("Alloc", ParcElems_Alloc);
	__INITYP(ParcElems_StateMsg, Texts_ElemMsg, 1);
/* BEGIN */
	ParcElems_unit = TextFrames_Unit;
	Texts_OpenWriter(&ParcElems_W, Texts_Writer__typ);
	ParcElems_InitDefParc(&TextFrames_defParc);
	ParcElems_InitPatterns();
	__ENDMOD;
}
