/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Elems.h"
#include "Files.h"
#include "Fonts.h"
#include "GUtils.h"
#include "Input.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct RadioButtonElems_ElemDesc *RadioButtonElems_Elem;

typedef
	struct RadioButtonElems_ElemDesc { /* Elems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[8];
		BOOLEAN locked;
		CHAR value[64], myval[64];
	} RadioButtonElems_ElemDesc;

typedef
	struct RadioButtonElems_UpdateMsg { /* Texts_ElemMsg */
		RadioButtonElems_Elem e;
	} RadioButtonElems_UpdateMsg;



export LONGINT *RadioButtonElems_ElemDesc__typ;
export LONGINT *RadioButtonElems_UpdateMsg__typ;

static void RadioButtonElems_Draw (RadioButtonElems_Elem e, INTEGER x, INTEGER y, Display_Frame f);
export void RadioButtonElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
static void RadioButtonElems_HandleAttrMsg (RadioButtonElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ);
export void RadioButtonElems_Init (RadioButtonElems_Elem e);
export void RadioButtonElems_Insert (void);
export void RadioButtonElems_New (void);
static void RadioButtonElems_Track (RadioButtonElems_Elem e, TextFrames_TrackMsg msg);
static void RadioButtonElems_Update (RadioButtonElems_Elem e, RadioButtonElems_UpdateMsg update);
export void RadioButtonElems_UpdateAll (RadioButtonElems_Elem e);


static void RadioButtonElems_Draw (RadioButtonElems_Elem e, INTEGER x, INTEGER y, Display_Frame f)
{
	INTEGER h = 0, w = 0, one = 0;
	h = GUtils_Unit(e->H, 1);
	w = GUtils_Unit(e->W, 1);
	one = GUtils_Unit(1, 0);
	GUtils_Area(f, 12, 0, x, y, w, h, GUtils_Unit(1, 0), 1, 1);
	if (__STRCMP(e->value, e->myval) == 0) {
		GUtils_Area(f, 13, 0, x + 3 * one, y + 3 * one, w - 6 * one, h - 6 * one, GUtils_Unit(1, 0), 1, 0);
	}
}

void RadioButtonElems_UpdateAll (RadioButtonElems_Elem e)
{
	Texts_Reader r = {0};
	RadioButtonElems_UpdateMsg update = {0};
	if (Texts_ElemBase((void*)e) != NIL) {
		update.e = e;
		Texts_OpenReader(&r, Texts_Reader__typ, Texts_ElemBase((void*)e), 0);
		Texts_ReadElem(&r, Texts_Reader__typ);
		while (!r.eot && r.elem != NIL) {
			(*r.elem->handle)(r.elem, (void*)&update, RadioButtonElems_UpdateMsg__typ);
			Texts_ReadElem(&r, Texts_Reader__typ);
		}
	}
}

static void RadioButtonElems_Update (RadioButtonElems_Elem e, RadioButtonElems_UpdateMsg update)
{
	CHAR name1[256], name2[256];
	Elems_GetString((void*)e, (CHAR*)"Name", (LONGINT)5, (void*)name1, 256);
	Elems_GetString((void*)update.e, (CHAR*)"Name", (LONGINT)5, (void*)name2, 256);
	if (name1[0] == 0x00 || name2[0] == 0x00) {
		return;
	}
	if (__STRCMP(name1, name2) == 0) {
		__COPY(update.e->value, e->value, 64);
		Elems_UpdateElem((void*)e);
	}
}

static void RadioButtonElems_HandleAttrMsg (RadioButtonElems_Elem e, Elems_AttrMsg *msg, LONGINT *msg__typ)
{
	Elems_Done = 1;
	if ((*msg).id == 1) {
		if (__STRCMP((*msg).name, "Value") == 0) {
			(*msg).class = 2;
			__COPY(e->value, (*msg).s, 256);
		} else if (__STRCMP((*msg).name, "MyValue") == 0) {
			(*msg).class = 2;
			__COPY(e->myval, (*msg).s, 256);
		} else {
			Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 2) {
		if (__STRCMP((*msg).name, "Value") == 0) {
			if ((*msg).class == 2) {
				__COPY((*msg).s, e->value, 64);
				RadioButtonElems_UpdateAll(e);
			}
		} else if (__STRCMP((*msg).name, "MyValue") == 0) {
			if ((*msg).class == 2) {
				__COPY((*msg).s, e->myval, 64);
				RadioButtonElems_UpdateAll(e);
			}
		} else {
			Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		}
	} else if ((*msg).id == 3) {
		Elems_Handle((void*)e, (void*)&*msg, msg__typ);
		(*(*msg).enum_)((CHAR*)"Value", (LONGINT)6, 3);
		(*(*msg).enum_)((CHAR*)"MyValue", (LONGINT)8, 3);
	} else {
		Elems_Handle((void*)e, (void*)&*msg, msg__typ);
	}
}

static void RadioButtonElems_Track (RadioButtonElems_Elem e, TextFrames_TrackMsg msg)
{
	INTEGER X = 0, Y = 0, w = 0, h = 0;
	SET keysum = 0;
	BOOLEAN isin = 0;
	Elems_ExecMsg exec = {0};
	keysum = 0x0;
	w = (int)__DIV(e->W, (LONGINT)TextFrames_Unit);
	h = (int)__DIV(e->H, (LONGINT)TextFrames_Unit);
	isin = 1;
	do {
		Input_Mouse(&msg.keys, &X, &Y);
		keysum = keysum | msg.keys;
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, X, Y);
		isin = ((X >= msg.X0 && X <= msg.X0 + w) && Y >= msg.Y0) && Y <= msg.Y0 + h;
	} while (!(msg.keys == 0x0 || __IN(0, msg.keys)));
	if (isin && msg.keys == 0x0) {
		__COPY(e->myval, e->value, 64);
		RadioButtonElems_UpdateAll(e);
		exec.e = (Elems_Elem)e;
		exec.x = msg.X0;
		exec.y = msg.Y0;
		exec.f = msg.frame;
		exec.unload = __IN(2, keysum);
		(*e->handle)((void*)e, (void*)&exec, Elems_ExecMsg__typ);
	}
}

void RadioButtonElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	RadioButtonElems_Elem copy = NIL;
	CHAR ch = 0;
	if (__ISP(e, RadioButtonElems_ElemDesc, 3)) {
		if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(2);
				RadioButtonElems_Draw((*(RadioButtonElems_Elem*)&e), (*msg__).X0, (*msg__).Y0, (*msg__).frame);
			}
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			TextPrinter_PrintMsg *msg__ = (void*)msg;
			if (!(*msg__).prepare) {
				GUtils_SetDevice(1);
				RadioButtonElems_Draw((*(RadioButtonElems_Elem*)&e), (*msg__).X0, (*msg__).Y0, NIL);
				GUtils_SetDevice(2);
			}
		} else if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *msg__ = (void*)msg;
			if ((*msg__).e == NIL) {
				__NEW(copy, RadioButtonElems_ElemDesc);
				(*msg__).e = (Texts_Elem)copy;
			} else {
				copy = __GUARDP((*msg__).e, RadioButtonElems_ElemDesc, 3);
			}
			Elems_CopyElem((void*)(*(RadioButtonElems_Elem*)&e), (void*)copy);
			__MOVE((*(RadioButtonElems_Elem*)&e)->value, copy->value, 64);
			__MOVE((*(RadioButtonElems_Elem*)&e)->myval, copy->myval, 64);
			(*msg__).e = (Texts_Elem)copy;
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *msg__ = (void*)msg;
			__MOVE("RadioButtonElems", (*msg__).mod, 17);
			__MOVE("New", (*msg__).proc, 4);
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *msg__ = (void*)msg;
			Elems_Handle((void*)(*(RadioButtonElems_Elem*)&e), (void*)&*msg__, msg__typ);
			if ((*msg__).id == 0) {
				Files_Read(&(*msg__).r, Files_Rider__typ, (void*)&ch);
				Files_ReadString(&(*msg__).r, Files_Rider__typ, (void*)(*(RadioButtonElems_Elem*)&e)->value, 64);
				Files_ReadString(&(*msg__).r, Files_Rider__typ, (void*)(*(RadioButtonElems_Elem*)&e)->myval, 64);
			} else if ((*msg__).id == 1) {
				Files_Write(&(*msg__).r, Files_Rider__typ, 0x00);
				Files_WriteString(&(*msg__).r, Files_Rider__typ, (*(RadioButtonElems_Elem*)&e)->value, 64);
				Files_WriteString(&(*msg__).r, Files_Rider__typ, (*(RadioButtonElems_Elem*)&e)->myval, 64);
			}
		} else if (__IS(msg__typ, Elems_AttrMsg, 1)) {
			Elems_AttrMsg *msg__ = (void*)msg;
			RadioButtonElems_HandleAttrMsg((*(RadioButtonElems_Elem*)&e), &*msg__, msg__typ);
		} else if (__IS(msg__typ, RadioButtonElems_UpdateMsg, 1)) {
			RadioButtonElems_UpdateMsg *msg__ = (void*)msg;
			RadioButtonElems_Update((*(RadioButtonElems_Elem*)&e), *msg__);
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *msg__ = (void*)msg;
			Elems_Handle((void*)(*(RadioButtonElems_Elem*)&e), (void*)&*msg__, msg__typ);
			if ((*msg__).keys == 0x02) {
				RadioButtonElems_Track((*(RadioButtonElems_Elem*)&e), *msg__);
			}
		} else {
			Elems_Handle((void*)(*(RadioButtonElems_Elem*)&e), &*msg, msg__typ);
		}
	} else __WITHCHK;
}

void RadioButtonElems_Init (RadioButtonElems_Elem e)
{
	Elems_Init((void*)e);
	e->handle = RadioButtonElems_Handle;
	e->value[0] = 0x00;
	e->myval[0] = 0x00;
	e->H = (LONGINT)(Fonts_Default->maxY - Fonts_Default->minY) * (LONGINT)TextFrames_Unit;
	e->W = e->H;
}

void RadioButtonElems_New (void)
{
	RadioButtonElems_Elem e = NIL;
	__NEW(e, RadioButtonElems_ElemDesc);
	RadioButtonElems_Init(e);
	Texts_new = (Texts_Elem)e;
}

void RadioButtonElems_Insert (void)
{
	RadioButtonElems_Elem e = NIL;
	TextFrames_InsertElemMsg m = {0};
	Texts_Scanner s = {0};
	__NEW(e, RadioButtonElems_ElemDesc);
	RadioButtonElems_Init(e);
	Elems_GetPar((void*)e, &s, Texts_Scanner__typ);
	if (!s.eot && __IN(s.class, 0x06)) {
		__COPY(s.s, e->myval, 64);
	}
	Texts_Scan(&s, Texts_Scanner__typ);
	if (!s.eot && __IN(s.class, 0x06)) {
		__COPY(s.s, e->value, 64);
	}
	m.e = (Texts_Elem)e;
	Viewers_Broadcast((void*)&m, TextFrames_InsertElemMsg__typ);
}

__TDESC(RadioButtonElems_ElemDesc, 1, 5) = {__TDFLDS("ElemDesc", 172), {0, 4, 12, 32, 36, -24}};
__TDESC(RadioButtonElems_UpdateMsg, 1, 1) = {__TDFLDS("UpdateMsg", 4), {0, -8}};

export void *RadioButtonElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Elems);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(GUtils);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(RadioButtonElems, 0);
	__REGCMD("Insert", RadioButtonElems_Insert);
	__REGCMD("New", RadioButtonElems_New);
	__INITYP(RadioButtonElems_ElemDesc, Elems_ElemDesc, 3);
	__INITYP(RadioButtonElems_UpdateMsg, Texts_ElemMsg, 1);
/* BEGIN */
	__ENDMOD;
}
