/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "Input.h"
#include "Oberon.h"
#include "Printer.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"

typedef
	struct StampElems_ElemDesc *StampElems_Elem;

typedef
	struct StampElems_ElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		CHAR s[32];
	} StampElems_ElemDesc;


static Texts_Writer StampElems_W;
static CHAR StampElems_month[37];

export LONGINT *StampElems_ElemDesc__typ;

export void StampElems_Alloc (void);
static void StampElems_Copy (StampElems_Elem se, StampElems_Elem de);
static void StampElems_DispStr (Fonts_Font fnt, CHAR *s, LONGINT s__len, INTEGER col, INTEGER x0, INTEGER y0);
static void StampElems_Draw (StampElems_Elem e, LONGINT pos, Fonts_Font fnt, INTEGER col, INTEGER x0, INTEGER y0);
static void StampElems_Format (LONGINT date, CHAR *s, LONGINT s__len);
static void StampElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
export void StampElems_Insert (void);
static void StampElems_Load (StampElems_Elem e, Files_Rider *r, LONGINT *r__typ);
static void StampElems_Open (StampElems_Elem e);
static void StampElems_PrepDraw (StampElems_Elem e, Fonts_Font fnt, INTEGER *dy);
static void StampElems_PrepPrint (StampElems_Elem e, Fonts_Font fnt, INTEGER *dy);
static void StampElems_Print (StampElems_Elem e, LONGINT pos, Fonts_Font fnt, INTEGER x0, INTEGER y0);
static void StampElems_PrntStr (Fonts_Font fnt, CHAR *s, LONGINT s__len, INTEGER x0, INTEGER y0);
static void StampElems_Store (StampElems_Elem e, LONGINT pos, Files_Rider *r, LONGINT *r__typ);
static LONGINT StampElems_StrDispWidth (Fonts_Font fnt, CHAR *s, LONGINT s__len);
static LONGINT StampElems_StrPrntWidth (Fonts_Font fnt, CHAR *s, LONGINT s__len);
static void StampElems_Track (StampElems_Elem e, LONGINT pos, INTEGER x, INTEGER y, SET keys);


static LONGINT StampElems_StrDispWidth (Fonts_Font fnt, CHAR *s, LONGINT s__len)
{
	LONGINT pat = 0;
	INTEGER width = 0, i = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	CHAR ch = 0;
	__DUP(s, s__len, CHAR);
	width = 0;
	i = 0;
	ch = s[__X(i, s__len)];
	while (ch != 0x00) {
		Display_GetChar(fnt->raster, ch, &dx, &x, &y, &w, &h, &pat);
		width += dx;
		i += 1;
		ch = s[__X(i, s__len)];
	}
	__DEL(s);
	return (LONGINT)width * (LONGINT)TextFrames_Unit;
}

static void StampElems_DispStr (Fonts_Font fnt, CHAR *s, LONGINT s__len, INTEGER col, INTEGER x0, INTEGER y0)
{
	LONGINT pat = 0;
	INTEGER i = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	CHAR ch = 0;
	__DUP(s, s__len, CHAR);
	i = 0;
	ch = s[__X(i, s__len)];
	while (ch != 0x00) {
		Display_GetChar(fnt->raster, ch, &dx, &x, &y, &w, &h, &pat);
		Display_CopyPattern(col, pat, x0 + x, y0 + y, 0);
		i += 1;
		ch = s[__X(i, s__len)];
		x0 += dx;
	}
	__DEL(s);
}

static LONGINT StampElems_StrPrntWidth (Fonts_Font fnt, CHAR *s, LONGINT s__len)
{
	LONGINT width = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	INTEGER i = 0;
	SHORTINT fno = 0;
	CHAR ch = 0;
	__DUP(s, s__len, CHAR);
	width = 0;
	fno = TextPrinter_FontNo(fnt);
	i = 0;
	ch = s[__X(i, s__len)];
	while (ch != 0x00) {
		TextPrinter_Get(fno, ch, &dx, &x, &y, &w, &h);
		width += dx;
		i += 1;
		ch = s[__X(i, s__len)];
	}
	__DEL(s);
	return width;
}

static void StampElems_PrntStr (Fonts_Font fnt, CHAR *s, LONGINT s__len, INTEGER x0, INTEGER y0)
{
	__DUP(s, s__len, CHAR);
	Printer_String(x0, y0, (void*)s, s__len, (void*)fnt->name, 32);
	__DEL(s);
}

static struct Format__5 {
	CHAR *s;
	LONGINT s__len;
	INTEGER *i;
	struct Format__5 *lnk;
} *Format__5_s;

static void Label__6 (LONGINT m);
static void Pair__8 (LONGINT x);

static void Pair__8 (LONGINT x)
{
	if (x >= 10) {
		Format__5_s->s[__X(*Format__5_s->i, Format__5_s->s__len)] = (CHAR)(__DIV(x, 10) + 48);
		*Format__5_s->i += 1;
	}
	Format__5_s->s[__X(*Format__5_s->i, Format__5_s->s__len)] = (CHAR)(__MOD(x, 10) + 48);
	*Format__5_s->i += 1;
}

static void Label__6 (LONGINT m)
{
	m = (m - 1) * 3;
	Format__5_s->s[__X(*Format__5_s->i, Format__5_s->s__len)] = StampElems_month[__X(m, 37)];
	Format__5_s->s[__X(*Format__5_s->i + 1, Format__5_s->s__len)] = StampElems_month[__X(m + 1, 37)];
	Format__5_s->s[__X(*Format__5_s->i + 2, Format__5_s->s__len)] = StampElems_month[__X(m + 2, 37)];
	*Format__5_s->i += 3;
}

static void StampElems_Format (LONGINT date, CHAR *s, LONGINT s__len)
{
	INTEGER i = 0;
	struct Format__5 _s;
	_s.s = (void*)s; _s.s__len = s__len;
	_s.i = &i;
	_s.lnk = Format__5_s;
	Format__5_s = &_s;
	i = 0;
	Pair__8(__MASK(date, -32));
	s[__X(i, s__len)] = ' ';
	i += 1;
	Label__6(__MASK(__ASHR(date, 5), -16));
	s[__X(i, s__len)] = ' ';
	i += 1;
	Pair__8(__MASK(__ASHR(date, 9), -128));
	s[__X(i, s__len)] = 0x00;
	Format__5_s = _s.lnk;
}

static void StampElems_Copy (StampElems_Elem se, StampElems_Elem de)
{
	LONGINT t = 0, d = 0;
	Texts_CopyElem((void*)se, (void*)de);
	__MOVE(se->s, de->s, 32);
}

static void StampElems_Load (StampElems_Elem e, Files_Rider *r, LONGINT *r__typ)
{
	INTEGER i = 0;
	CHAR vers = 0, ch = 0;
	Files_Read(&*r, r__typ, (void*)&vers);
	i = 0;
	do {
		Files_Read(&*r, r__typ, (void*)&ch);
		e->s[__X(i, 32)] = ch;
		i += 1;
	} while (!(ch == 0x00));
}

static void StampElems_Store (StampElems_Elem e, LONGINT pos, Files_Rider *r, LONGINT *r__typ)
{
	LONGINT t = 0, d = 0;
	INTEGER i = 0;
	CHAR ch = 0;
	CHAR s[32];
	__COPY(e->s, s, 32);
	Oberon_GetClock(&t, &d);
	StampElems_Format(d, (void*)e->s, 32);
	Files_Write(&*r, r__typ, 0x01);
	i = 0;
	do {
		ch = e->s[__X(i, 32)];
		Files_Write(&*r, r__typ, ch);
		i += 1;
	} while (!(ch == 0x00));
	if (__STRCMP(s, e->s) != 0) {
		Texts_ChangeLooks(Texts_ElemBase((void*)e), pos, pos + 1, 0x0, NIL, 0, 0);
	}
}

static void StampElems_PrepDraw (StampElems_Elem e, Fonts_Font fnt, INTEGER *dy)
{
	e->W = StampElems_StrDispWidth(fnt, e->s, 32);
	e->H = (LONGINT)fnt->height * (LONGINT)TextFrames_Unit;
	*dy = fnt->minY;
	if (*dy > -2) {
		*dy = -2;
	}
}

static void StampElems_Draw (StampElems_Elem e, LONGINT pos, Fonts_Font fnt, INTEGER col, INTEGER x0, INTEGER y0)
{
	TextFrames_Parc p = NIL;
	LONGINT beg = 0;
	INTEGER w = 0;
	w = (int)__DIV(e->W, (LONGINT)TextFrames_Unit);
	TextFrames_ParcBefore(Texts_ElemBase((void*)e), pos, &p, &beg);
	y0 += (int)__DIV(p->dsr, (LONGINT)TextFrames_Unit);
	StampElems_DispStr(fnt, e->s, 32, col, x0, y0);
	Display_ReplPattern(col, Display_grey1, x0, y0 - 1, w, 1, 0);
}

static void StampElems_PrepPrint (StampElems_Elem e, Fonts_Font fnt, INTEGER *dy)
{
	e->W = StampElems_StrPrntWidth(fnt, e->s, 32);
	e->H = (LONGINT)fnt->height * (LONGINT)TextFrames_Unit;
	*dy = (int)__DIV((LONGINT)fnt->minY * (LONGINT)TextFrames_Unit, 3048);
	if (*dy > -2) {
		*dy = -2;
	}
}

static void StampElems_Print (StampElems_Elem e, LONGINT pos, Fonts_Font fnt, INTEGER x0, INTEGER y0)
{
	TextFrames_Parc p = NIL;
	LONGINT beg = 0;
	TextFrames_ParcBefore(Texts_ElemBase((void*)e), pos, &p, &beg);
	y0 += (int)__DIV(p->dsr, 3048);
	StampElems_PrntStr(fnt, e->s, 32, x0, y0);
	e->W = StampElems_StrDispWidth(fnt, e->s, 32);
}

static void StampElems_Track (StampElems_Elem e, LONGINT pos, INTEGER x, INTEGER y, SET keys)
{
	do {
		Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
		Input_Mouse(&keys, &x, &y);
	} while (!(keys == 0x0));
}

static void StampElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ)
{
	StampElems_Elem copy = NIL;
	if (__ISP(e, StampElems_ElemDesc, 2)) {
		if (__IS(msg__typ, Texts_CopyMsg, 1)) {
			__NEW(copy, StampElems_ElemDesc);
			StampElems_Copy((*(StampElems_Elem*)&e), copy);
			__GUARDR(msg, Texts_CopyMsg, 1).e = (Texts_Elem)copy;
		} else if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
			if (__IS(msg__typ, Texts_IdentifyMsg, 1)) {
				Texts_IdentifyMsg *msg__ = (void*)msg;
				__MOVE("StampElems", (*msg__).mod, 11);
				__MOVE("Alloc", (*msg__).proc, 6);
			} else __WITHCHK;
		} else if (__IS(msg__typ, Texts_FileMsg, 1)) {
			if (__IS(msg__typ, Texts_FileMsg, 1)) {
				Texts_FileMsg *msg__ = (void*)msg;
				if ((*msg__).id == 0) {
					StampElems_Load((*(StampElems_Elem*)&e), &(*msg__).r, Files_Rider__typ);
				} else if ((*msg__).id == 1) {
					StampElems_Store((*(StampElems_Elem*)&e), (*msg__).pos, &(*msg__).r, Files_Rider__typ);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
			if (__IS(msg__typ, TextFrames_TrackMsg, 1)) {
				TextFrames_TrackMsg *msg__ = (void*)msg;
				if ((*msg__).keys == 0x02) {
					StampElems_Track((*(StampElems_Elem*)&e), (*msg__).pos, (*msg__).X, (*msg__).Y, (*msg__).keys);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
			if (__IS(msg__typ, TextFrames_DisplayMsg, 1)) {
				TextFrames_DisplayMsg *msg__ = (void*)msg;
				if ((*msg__).prepare) {
					StampElems_PrepDraw((*(StampElems_Elem*)&e), (*msg__).fnt, &(*msg__).Y0);
				} else {
					StampElems_Draw((*(StampElems_Elem*)&e), (*msg__).pos, (*msg__).fnt, (*msg__).col, (*msg__).X0, (*msg__).Y0);
				}
			} else __WITHCHK;
		} else if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
			if (__IS(msg__typ, TextPrinter_PrintMsg, 1)) {
				TextPrinter_PrintMsg *msg__ = (void*)msg;
				if ((*msg__).prepare) {
					StampElems_PrepPrint((*(StampElems_Elem*)&e), (*msg__).fnt, &(*msg__).Y0);
				} else {
					StampElems_Print((*(StampElems_Elem*)&e), (*msg__).pos, (*msg__).fnt, (*msg__).X0, (*msg__).Y0);
				}
			} else __WITHCHK;
		}
	} else __WITHCHK;
}

void StampElems_Alloc (void)
{
	StampElems_Elem e = NIL;
	__NEW(e, StampElems_ElemDesc);
	e->handle = StampElems_Handle;
	Texts_new = (Texts_Elem)e;
}

static void StampElems_Open (StampElems_Elem e)
{
	LONGINT t = 0, d = 0;
	e->W = 180000;
	e->H = e->W;
	e->handle = StampElems_Handle;
	Oberon_GetClock(&t, &d);
	StampElems_Format(d, (void*)e->s, 32);
}

void StampElems_Insert (void)
{
	Texts_Scanner s = {0};
	Texts_Text T = NIL;
	StampElems_Elem e = NIL;
	Fonts_Font fnt = NIL;
	Oberon_CopyOverMsg copyover = {0};
	Texts_OpenScanner(&s, Texts_Scanner__typ, Oberon_Par->text, Oberon_Par->pos);
	Texts_Scan(&s, Texts_Scanner__typ);
	if (s.line == 0 && s.class == 1) {
		fnt = Fonts_This(s.s, 256);
	} else {
		fnt = Oberon_CurFnt;
	}
	__NEW(e, StampElems_ElemDesc);
	StampElems_Open(e);
	T = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_WriteElem(&StampElems_W, Texts_Writer__typ, (void*)e);
	Texts_Append(T, StampElems_W.buf);
	Texts_ChangeLooks(T, 0, 1, 0x01, fnt, 0, 0);
	copyover.text = T;
	copyover.beg = 0;
	copyover.end = 1;
	(*Oberon_FocusViewer->handle)((void*)Oberon_FocusViewer, (void*)&copyover, Oberon_CopyOverMsg__typ);
	Texts_Delete(T, 0, T->len);
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&StampElems_W, Texts_Writer__typ, 36, 1, P);
}

__TDESC(StampElems_ElemDesc, 1, 4) = {__TDFLDS("ElemDesc", 68), {0, 4, 12, 32, -20}};

export void *StampElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(Printer);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__REGMOD(StampElems, EnumPtrs);
	__REGCMD("Alloc", StampElems_Alloc);
	__REGCMD("Insert", StampElems_Insert);
	__INITYP(StampElems_ElemDesc, Texts_ElemDesc, 2);
/* BEGIN */
	Texts_OpenWriter(&StampElems_W, Texts_Writer__typ);
	__MOVE("JanFebMarAprMayJunJulAugSepOctNovDec", StampElems_month, 37);
	__ENDMOD;
}
