/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"
#include "Input.h"
#include "MenuViewers.h"
#include "Modules.h"
#include "Oberon.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	struct TextFrames_DisplayMsg { /* Texts_ElemMsg */
		BOOLEAN prepare;
		Fonts_Font fnt;
		SHORTINT col;
		LONGINT pos;
		Display_Frame frame;
		INTEGER X0, Y0;
		LONGINT indent;
		Display_Frame elemFrame;
	} TextFrames_DisplayMsg;

typedef
	struct TextFrames_FocusMsg { /* Texts_ElemMsg */
		BOOLEAN focus;
		Display_Frame elemFrame, frame;
	} TextFrames_FocusMsg;

typedef
	struct TextFrames_FrameDesc *TextFrames_Frame;

typedef
	struct TextFrames_TextLineDesc *TextFrames_TextLine;

typedef
	struct TextFrames_Location {
		LONGINT org, pos;
		INTEGER x, y, dx, dy;
		TextFrames_TextLine line;
	} TextFrames_Location;

typedef
	struct TextFrames_FrameDesc { /* Display_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		Texts_Text text;
		LONGINT org;
		INTEGER col, left, right, top, bot, markH, barW;
		LONGINT time;
		BOOLEAN hasCar, hasSel, showsParcs;
		TextFrames_Location carloc, selbeg, selend;
		Display_Frame focus;
		TextFrames_TextLine trailer;
	} TextFrames_FrameDesc;

typedef
	struct TextFrames_InsertElemMsg { /* Display_FrameMsg */
		Texts_Elem e;
	} TextFrames_InsertElemMsg;

typedef
	struct TextFrames_NotifyMsg { /* Display_FrameMsg */
		Display_Frame frame;
	} TextFrames_NotifyMsg;

typedef
	struct TextFrames_ParcDesc *TextFrames_Parc;

typedef
	struct TextFrames_ParcDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		LONGINT left, first, width, lead, lsp, dsr;
		SET opts;
		INTEGER nofTabs;
		LONGINT tab[32];
	} TextFrames_ParcDesc;

typedef
	struct TextFrames_SelectMsg { /* Display_FrameMsg */
		Texts_Text text;
		LONGINT beg, end, time;
	} TextFrames_SelectMsg;

typedef
	struct TextFrames_TextLineDesc {
		TextFrames_TextLine next;
		BOOLEAN eot;
		LONGINT indent;
		INTEGER w, h, dsr, w0, nob;
		LONGINT org, len, span;
		TextFrames_Parc P;
		LONGINT pbeg;
	} TextFrames_TextLineDesc;

typedef
	struct TextFrames_TrackMsg { /* Texts_ElemMsg */
		INTEGER X, Y;
		SET keys;
		Fonts_Font fnt;
		SHORTINT col;
		LONGINT pos;
		Display_Frame frame;
		INTEGER X0, Y0;
	} TextFrames_TrackMsg;

typedef
	struct TextFrames_UpdateMsg { /* Display_FrameMsg */
		INTEGER id;
		Texts_Text text;
		LONGINT beg, end;
	} TextFrames_UpdateMsg;


export INTEGER TextFrames_Unit, TextFrames_menuH, TextFrames_barW, TextFrames_left, TextFrames_right, TextFrames_top, TextFrames_bot;
export TextFrames_Parc TextFrames_defParc;
static Oberon_ControlMsg TextFrames_neutralize;
static Oberon_ParList TextFrames_par;
static Texts_Buffer TextFrames_B;
static Texts_Writer TextFrames_W, TextFrames_W0;

export LONGINT *TextFrames_ParcDesc__typ;
export LONGINT *TextFrames_Location__typ;
export LONGINT *TextFrames_TextLineDesc__typ;
export LONGINT *TextFrames_FrameDesc__typ;
export LONGINT *TextFrames_DisplayMsg__typ;
export LONGINT *TextFrames_TrackMsg__typ;
export LONGINT *TextFrames_FocusMsg__typ;
export LONGINT *TextFrames_NotifyMsg__typ;
export LONGINT *TextFrames_UpdateMsg__typ;
export LONGINT *TextFrames_InsertElemMsg__typ;
export LONGINT *TextFrames_SelectMsg__typ;

static void TextFrames_AdjustMetrics (TextFrames_Frame F, TextFrames_TextLine t, INTEGER *pw, INTEGER *tw, INTEGER *ddx, INTEGER *cn, TextFrames_Parc *P, LONGINT *pbeg);
static void TextFrames_Back (TextFrames_Frame F, INTEGER dY, LONGINT *org);
static void TextFrames_BegOfLine (Texts_Reader *R, LONGINT *R__typ, Texts_Text T, LONGINT *pos, BOOLEAN adjust, CHAR *nextCh);
static void TextFrames_Call (TextFrames_Frame F, LONGINT pos, SET keysum);
static void TextFrames_Complete (TextFrames_Frame F, TextFrames_TextLine trailer, TextFrames_TextLine s, LONGINT org, INTEGER ph, CHAR *nextCh, TextFrames_Parc P, LONGINT pbeg);
static LONGINT TextFrames_CoordToPos (TextFrames_Frame F, INTEGER mh);
static void TextFrames_Copy (TextFrames_Frame SF, TextFrames_Frame DF);
static void TextFrames_DrawCursor (INTEGER x, INTEGER y);
static void TextFrames_DrawSpecial (Texts_Reader *R, LONGINT *R__typ, TextFrames_Frame F, CHAR nextCh, INTEGER px, INTEGER py, INTEGER x, INTEGER y);
static void TextFrames_Edit (TextFrames_Frame F, INTEGER x, INTEGER y, SET keysum);
static void TextFrames_Erase (TextFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static void TextFrames_EraseRect (TextFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static void TextFrames_GetSpecial (Texts_Reader *R, LONGINT *R__typ, CHAR nextCh, TextFrames_Parc P, TextFrames_Frame F, INTEGER *n, INTEGER cn, INTEGER ddx, INTEGER dw, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h);
export void TextFrames_Handle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
static void TextFrames_InitDefParc (void);
static void TextFrames_InvalSubFrames (TextFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static void TextFrames_InvertBorder (Display_Frame F);
static void TextFrames_InvertCaret (TextFrames_Frame F);
static void TextFrames_InvertRect (TextFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static void TextFrames_InvertSelection (TextFrames_Frame F, TextFrames_Location beg, TextFrames_Location end);
export void TextFrames_LocateChar (TextFrames_Frame F, INTEGER x, INTEGER y, TextFrames_Location *loc, LONGINT *loc__typ);
export void TextFrames_LocateLine (TextFrames_Frame F, INTEGER y, TextFrames_Location *loc, LONGINT *loc__typ);
static void TextFrames_LocateLineTop (TextFrames_Frame F, TextFrames_TextLine trailer, LONGINT org, TextFrames_Location *loc, LONGINT *loc__typ);
export void TextFrames_LocatePos (TextFrames_Frame F, LONGINT pos, TextFrames_Location *loc, LONGINT *loc__typ);
export void TextFrames_LocateWord (TextFrames_Frame F, INTEGER x, INTEGER y, TextFrames_Location *loc, LONGINT *loc__typ);
export void TextFrames_Mark (TextFrames_Frame F, INTEGER mark);
static void TextFrames_MarkMenu (TextFrames_Frame F);
static INTEGER TextFrames_Max (INTEGER x, INTEGER y);
static void TextFrames_MeasureLine (Texts_Reader *R, LONGINT *R__typ, TextFrames_Frame F, INTEGER maxW, TextFrames_TextLine t, CHAR *nextCh, TextFrames_Parc *P, LONGINT *pbeg);
static void TextFrames_MeasureLines (TextFrames_Frame F, LONGINT org, TextFrames_TextLine *trailer, CHAR *nextCh, TextFrames_Parc *P, LONGINT *pbeg);
static void TextFrames_MeasureSpecial (Texts_Reader *R, LONGINT *R__typ, CHAR nextCh, TextFrames_Parc P, INTEGER dw, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h);
static INTEGER TextFrames_Min (INTEGER x, INTEGER y);
export TextFrames_Frame TextFrames_NewMenu (CHAR *name, LONGINT name__len, CHAR *commands, LONGINT commands__len);
export TextFrames_Frame TextFrames_NewText (Texts_Text T, LONGINT pos);
static void TextFrames_NextLine (Texts_Reader *R, LONGINT *R__typ, Texts_Text T, LONGINT *org, CHAR *nextCh);
export void TextFrames_NotifyDisplay (Texts_Text T, INTEGER op, LONGINT beg, LONGINT end);
static void TextFrames_NotifySubFrames (TextFrames_Frame F, Display_FrameMsg *msg, LONGINT *msg__typ);
export void TextFrames_Open (TextFrames_Frame F, Texts_Text T, LONGINT pos);
export void TextFrames_ParcBefore (Texts_Text T, LONGINT pos, TextFrames_Parc *P, LONGINT *beg);
static void TextFrames_PassSubFocus (TextFrames_Frame F, Display_Frame f);
static void TextFrames_PickAttributes (Texts_Writer *W, LONGINT *W__typ, Texts_Text T, LONGINT pos);
export LONGINT TextFrames_Pos (TextFrames_Frame F, INTEGER x, INTEGER y);
export void TextFrames_RemoveCaret (TextFrames_Frame F);
export void TextFrames_RemoveSelection (TextFrames_Frame F);
static void TextFrames_Resize (TextFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h, CHAR *nextCh);
export void TextFrames_SetCaret (TextFrames_Frame F, LONGINT pos);
export void TextFrames_SetSelection (TextFrames_Frame F, LONGINT beg, LONGINT end);
static void TextFrames_Shift (TextFrames_Frame F, INTEGER oldY, INTEGER newY, INTEGER h);
static void TextFrames_ShiftBlock (TextFrames_Frame F, INTEGER delta);
static void TextFrames_ShiftSubFrames (TextFrames_Frame F, INTEGER oldY, INTEGER newY, INTEGER h);
export void TextFrames_Show (TextFrames_Frame F, LONGINT pos);
static void TextFrames_ShowBar (TextFrames_Frame F, INTEGER botH, INTEGER topH);
static void TextFrames_ShowFrom (TextFrames_Frame F, LONGINT pos, CHAR *nextCh, TextFrames_Parc *P, LONGINT *pbeg);
static void TextFrames_ShowInternal (TextFrames_Frame F, LONGINT pos, TextFrames_Parc *P, LONGINT *pbeg);
static void TextFrames_ShowLine (TextFrames_Frame F, TextFrames_TextLine t, INTEGER left, INTEGER right, INTEGER py, CHAR *nextCh);
static void TextFrames_ShowLines (TextFrames_Frame F, INTEGER botH, INTEGER topH, BOOLEAN erase, CHAR *nextCh);
static void TextFrames_ShowTick (TextFrames_Frame F);
static void TextFrames_Tab (TextFrames_Parc P, INTEGER dw, INTEGER *dx);
export Texts_Text TextFrames_Text (CHAR *name, LONGINT name__len);
static Display_Frame TextFrames_ThisSubFrame (TextFrames_Frame F, INTEGER x, INTEGER y);
static void TextFrames_Tick (TextFrames_Frame F);
static void TextFrames_TouchElem (TextFrames_Frame F, INTEGER *x, INTEGER *y, SET *keysum);
export void TextFrames_TrackCaret (TextFrames_Frame F, INTEGER *x, INTEGER *y, SET *keysum);
export void TextFrames_TrackLine (TextFrames_Frame F, INTEGER *x, INTEGER *y, LONGINT *org, SET *keysum);
static void TextFrames_TrackMouse (INTEGER *x, INTEGER *y, SET *keys, SET *keysum);
export void TextFrames_TrackSelection (TextFrames_Frame F, INTEGER *x, INTEGER *y, SET *keysum);
export void TextFrames_TrackWord (TextFrames_Frame F, INTEGER *x, INTEGER *y, LONGINT *pos, SET *keysum);
static void TextFrames_Update (TextFrames_Frame F, TextFrames_UpdateMsg *msg, LONGINT *msg__typ);
static void TextFrames_Width (TextFrames_Frame F, TextFrames_TextLine t, LONGINT pos, INTEGER *pw, INTEGER *dx, INTEGER *dy, CHAR *nextCh);
static void TextFrames_Write (TextFrames_Frame F, CHAR ch, Fonts_Font fnt, SHORTINT col, SHORTINT voff);


static INTEGER TextFrames_Min (INTEGER x, INTEGER y)
{
	if (x < y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static INTEGER TextFrames_Max (INTEGER x, INTEGER y)
{
	if (x > y) {
		return x;
	} else {
		return y;
	}
	__RETCHK;
}

static void TextFrames_MarkMenu (TextFrames_Frame F)
{
	Texts_Reader R = {0};
	Viewers_Viewer V = NIL;
	Texts_Text T = NIL;
	CHAR ch = 0;
	V = Viewers_This(F->X, F->Y);
	if ((__ISP(V, MenuViewers_ViewerDesc, 2) && __ISP(V->dsc, TextFrames_FrameDesc, 1)) && F != (void *) V->dsc) {
		T = __GUARDP(V->dsc, TextFrames_FrameDesc, 1)->text;
		if (T->len > 0) {
			Texts_OpenReader(&R, Texts_Reader__typ, T, T->len - 1);
			Texts_Read(&R, Texts_Reader__typ, &ch);
		} else {
			ch = 0x00;
		}
		if (ch != '!') {
			Texts_Write(&TextFrames_W0, Texts_Writer__typ, '!');
			Texts_Append(T, TextFrames_W0.buf);
		}
	}
}

static void TextFrames_InvertBorder (Display_Frame F)
{
	Display_ReplPattern(15, Display_grey1, F->X - 1, F->Y - 1, F->W + 2, 1, 2);
	Display_ReplPattern(15, Display_grey1, F->X - 1, F->Y + F->H, F->W + 2, 1, 2);
	Display_ReplPattern(15, Display_grey1, F->X - 1, F->Y, 1, F->H, 2);
	Display_ReplPattern(15, Display_grey1, F->X + F->W, F->Y, 1, F->H, 2);
}

static void TextFrames_InvalSubFrames (TextFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	Display_Frame p = NIL, f = NIL;
	MenuViewers_ModifyMsg msg = {0};
	if (w > 0 && h > 0) {
		f = F->dsc;
		if (f != NIL) {
			p = f;
			f = p->next;
		}
		while (f != NIL) {
			if (((f->X < x + w && f->X + f->W > x) && f->Y < y + h) && f->Y + f->H > y) {
				p->next = f->next;
				msg.id = 1;
				msg.dY = 0;
				msg.Y = f->Y;
				msg.H = 0;
				(*f->handle)(f, (void*)&msg, MenuViewers_ModifyMsg__typ);
			} else {
				p = f;
			}
			f = p->next;
		}
		f = F->dsc;
		if ((((f != NIL && f->X < x + w) && f->X + f->W > x) && f->Y < y + h) && f->Y + f->H > y) {
			F->dsc = F->dsc->next;
			msg.id = 1;
			msg.dY = 0;
			msg.Y = f->Y;
			msg.H = 0;
			(*f->handle)(f, (void*)&msg, MenuViewers_ModifyMsg__typ);
		}
	}
}

static void TextFrames_ShiftSubFrames (TextFrames_Frame F, INTEGER oldY, INTEGER newY, INTEGER h)
{
	Display_Frame f = NIL;
	MenuViewers_ModifyMsg msg = {0};
	if (oldY > newY) {
		TextFrames_InvalSubFrames(F, F->X, newY, F->W, oldY - newY);
	} else {
		TextFrames_InvalSubFrames(F, F->X, oldY + h, F->W, newY - oldY);
	}
	f = F->dsc;
	while (f != NIL) {
		if (f->Y < oldY + h && f->Y + f->H > oldY) {
			f->Y += newY - oldY;
			msg.id = 1;
			msg.dY = 0;
			msg.Y = f->Y;
			msg.H = f->H;
			(*f->handle)(f, (void*)&msg, MenuViewers_ModifyMsg__typ);
		}
		f = f->next;
	}
}

static void TextFrames_NotifySubFrames (TextFrames_Frame F, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	Display_Frame p = NIL, f = NIL;
	f = F->dsc;
	if (__IS(msg__typ, TextFrames_NotifyMsg, 1)) {
		__GUARDR(msg, TextFrames_NotifyMsg, 1).frame = (Display_Frame)F;
	}
	while (f != NIL) {
		p = f;
		f = f->next;
		(*p->handle)(p, &*msg, msg__typ);
	}
}

static void TextFrames_DrawCursor (INTEGER x, INTEGER y)
{
	Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
}

static void TextFrames_TrackMouse (INTEGER *x, INTEGER *y, SET *keys, SET *keysum)
{
	Input_Mouse(&*keys, &*x, &*y);
	*keysum = *keysum | *keys;
	TextFrames_DrawCursor(*x, *y);
}

static void TextFrames_EraseRect (TextFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	Display_ReplConst(F->col, x, y, w, h, 0);
	TextFrames_InvalSubFrames(F, x, y, w, h);
}

static void TextFrames_Erase (TextFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	if (h > 0) {
		Oberon_RemoveMarks(x, y, w, h);
		TextFrames_EraseRect(F, x, y, w, h);
	}
}

static void TextFrames_Shift (TextFrames_Frame F, INTEGER oldY, INTEGER newY, INTEGER h)
{
	if (oldY != newY && h > 0) {
		Oberon_RemoveMarks(F->X + F->left, TextFrames_Min(oldY, newY), F->W - F->left, TextFrames_Max(oldY, newY) + h);
		Display_CopyBlock(F->X + F->left, oldY, F->W - F->left, h, F->X + F->left, newY, 0);
		TextFrames_ShiftSubFrames(F, oldY, newY, h);
	}
}

static void TextFrames_InvertCaret (TextFrames_Frame F)
{
	TextFrames_Location loc = {0};
	INTEGER bot = 0;
	loc = F->carloc;
	bot = (loc.y + loc.line->dsr) - 6;
	Display_CopyPatternC((void*)F, 15, Display_hook, loc.x, bot, 2);
}

static void TextFrames_InvertRect (TextFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	if (x + w > (F->X + F->W) - F->right) {
		w = ((F->X + F->W) - F->right) - x;
	}
	if (y >= F->Y + F->bot) {
		Display_ReplConst(15, x, y, w, h, 2);
	}
}

static void TextFrames_InvertSelection (TextFrames_Frame F, TextFrames_Location beg, TextFrames_Location end)
{
	TextFrames_TextLine t = NIL;
	INTEGER ex = 0, rx = 0, w = 0, py = 0;
	rx = (F->X + F->W) - F->right;
	t = end.line;
	if (t->eot || end.pos <= t->org + t->len) {
		ex = end.x;
	} else {
		ex = rx;
	}
	if (beg.line == end.line) {
		TextFrames_InvertRect(F, beg.x, beg.y, ex - beg.x, beg.line->h);
	} else {
		t = beg.line;
		py = beg.y;
		w = (F->W - F->left) - F->right;
		TextFrames_InvertRect(F, beg.x, py, rx - beg.x, t->h);
		t = t->next;
		py -= t->h;
		while (t != end.line) {
			TextFrames_InvertRect(F, F->X + F->left, py, w, t->h);
			t = t->next;
			py -= t->h;
		}
		TextFrames_InvertRect(F, F->X + F->left, py, ex - (F->X + F->left), t->h);
	}
}

static LONGINT TextFrames_CoordToPos (TextFrames_Frame F, INTEGER mh)
{
	INTEGER h = 0;
	h = F->H - 1;
	if (h > 0) {
		return __ENTIER((F->text->len / (REAL)h) * (h - mh));
	} else {
		return 0;
	}
	__RETCHK;
}

static void TextFrames_ShowBar (TextFrames_Frame F, INTEGER botH, INTEGER topH)
{
	if (F->left > F->barW && F->barW > 0) {
		Display_ReplConst(15, (F->X + F->barW) - 1, F->Y + botH, 1, topH - botH, 0);
	}
}

static void TextFrames_Tick (TextFrames_Frame F)
{
	if ((((0 <= F->markH && F->markH < F->H) && F->left > F->barW) && F->barW > 6) && F->H > 2) {
		Display_ReplConst(15, F->X + 1, F->Y + F->markH, F->barW - 6, 2, 2);
	}
}

static void TextFrames_ShowTick (TextFrames_Frame F)
{
	INTEGER h = 0, mh = 0;
	LONGINT len = 0;
	h = F->H - 2;
	len = F->text->len;
	if (len > 0) {
		mh = (int)__ENTIER(h - (F->org / (REAL)len) * h);
	} else {
		mh = h;
	}
	if (F->markH != mh) {
		Oberon_RemoveMarks(F->X, F->Y, F->barW, F->H);
		TextFrames_Tick(F);
		F->markH = mh;
		TextFrames_Tick(F);
	}
}

void TextFrames_Mark (TextFrames_Frame F, INTEGER mark)
{
	TextFrames_Erase(F, F->X, F->Y, F->barW - 1, F->H);
	F->markH = -1;
	if (mark < 0 && F->H >= 16) {
		Display_CopyPattern(15, Display_downArrow, F->X, F->Y, 2);
	} else if (mark > 0) {
		TextFrames_ShowTick(F);
	}
}

void TextFrames_ParcBefore (Texts_Text T, LONGINT pos, TextFrames_Parc *P, LONGINT *beg)
{
	Texts_Reader R = {0};
	Texts_OpenReader(&R, Texts_Reader__typ, T, pos + 1);
	do {
		Texts_ReadPrevElem(&R, Texts_Reader__typ);
	} while (!(R.eot || __ISP(R.elem, TextFrames_ParcDesc, 2)));
	if (R.eot) {
		*P = TextFrames_defParc;
		*beg = -1;
	} else {
		*P = __GUARDP(R.elem, TextFrames_ParcDesc, 2);
		*beg = Texts_Pos(&R, Texts_Reader__typ);
	}
}

static void TextFrames_InitDefParc (void)
{
	if (Modules_ThisMod((CHAR*)"ParcElems", (LONGINT)10) == NIL) {
		__HALT(99);
	}
}

static void TextFrames_Tab (TextFrames_Parc P, INTEGER dw, INTEGER *dx)
{
	INTEGER i = 0, n = 0;
	LONGINT w = 0;
	i = 0;
	n = P->nofTabs;
	w = (LONGINT)dw * (LONGINT)TextFrames_Unit + 36000;
	if (dw < 0) {
		*dx = -dw;
	} else {
		while (i < n && P->tab[__X(i, 32)] < w) {
			i += 1;
		}
		if (i < n) {
			*dx = (int)__DIV(P->tab[__X(i, 32)] - (LONGINT)dw * (LONGINT)TextFrames_Unit, (LONGINT)TextFrames_Unit);
		} else {
			*dx = (int)__DIV(144000, (LONGINT)TextFrames_Unit);
		}
	}
}

static void TextFrames_MeasureSpecial (Texts_Reader *R, LONGINT *R__typ, CHAR nextCh, TextFrames_Parc P, INTEGER dw, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h)
{
	Texts_Elem e = NIL;
	LONGINT pat = 0;
	TextFrames_DisplayMsg msg = {0};
	if (nextCh == ' ') {
		Display_GetChar((*R).fnt->raster, nextCh, &*dx, &*x, &*y, &*w, &*h, &pat);
		*x = 0;
		*y = 0;
		*w = *dx;
		*h = 0;
	} else if (nextCh == 0x09) {
		TextFrames_Tab(P, dw, &*dx);
		*x = 0;
		*y = 0;
		*w = *dx;
		*h = 0;
	} else if ((*R).elem != NIL) {
		e = (*R).elem;
		msg.prepare = 1;
		msg.indent = (LONGINT)dw * (LONGINT)TextFrames_Unit;
		msg.fnt = (*R).fnt;
		msg.col = (*R).col;
		msg.pos = Texts_Pos(&*R, R__typ) - 1;
		msg.Y0 = -((int)__DIV(P->dsr, (LONGINT)TextFrames_Unit));
		(*e->handle)(e, (void*)&msg, TextFrames_DisplayMsg__typ);
		*w = (int)__DIV(e->W, (LONGINT)TextFrames_Unit);
		*dx = *w;
		*x = 0;
		*y = msg.Y0;
		*h = (int)__DIV(e->H, (LONGINT)TextFrames_Unit);
	} else {
		Display_GetChar((*R).fnt->raster, nextCh, &*dx, &*x, &*y, &*w, &*h, &pat);
	}
}

static void TextFrames_GetSpecial (Texts_Reader *R, LONGINT *R__typ, CHAR nextCh, TextFrames_Parc P, TextFrames_Frame F, INTEGER *n, INTEGER cn, INTEGER ddx, INTEGER dw, INTEGER *dx, INTEGER *x, INTEGER *y, INTEGER *w, INTEGER *h)
{
	Texts_Elem e = NIL;
	LONGINT pat = 0;
	if (nextCh == ' ') {
		Display_GetChar((*R).fnt->raster, nextCh, &*dx, &*x, &*y, &*w, &*h, &pat);
		*x = 0;
		*y = 0;
		*dx += ddx;
		*n += 1;
		if (*n <= cn) {
			*dx += 1;
		}
		*w = *dx;
		*h = 0;
	} else if (nextCh == 0x09) {
		TextFrames_Tab(P, dw, &*dx);
		*x = 0;
		*y = 0;
		*w = *dx;
		*h = 0;
	} else if ((*R).elem != NIL) {
		e = (*R).elem;
		if (__ISP(e, TextFrames_ParcDesc, 2) && P->W == (LONGINT)(9999 * TextFrames_Unit)) {
			*w = TextFrames_Min((int)__DIV(P->width + P->left, (LONGINT)TextFrames_Unit), (F->W - F->right) - F->left);
			e->W = (LONGINT)*w * (LONGINT)TextFrames_Unit;
		} else {
			*w = (int)__DIV(e->W, (LONGINT)TextFrames_Unit);
		}
		*dx = *w;
		*x = 0;
		*y = -((int)__DIV(P->dsr, (LONGINT)TextFrames_Unit));
		*h = (int)__DIV(e->H, (LONGINT)TextFrames_Unit);
	} else {
		Display_GetChar((*R).fnt->raster, nextCh, &*dx, &*x, &*y, &*w, &*h, &pat);
	}
}

static void TextFrames_NextLine (Texts_Reader *R, LONGINT *R__typ, Texts_Text T, LONGINT *org, CHAR *nextCh)
{
	LONGINT pat = 0, pos = 0, bk = 0, d = 0;
	INTEGER width = 0, tw = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	Texts_Reader R1 = {0};
	CHAR peekCh = 0;
	INTEGER indent = 0;
	TextFrames_Parc P = NIL;
	LONGINT pbeg = 0;
	tw = 0;
	dx = 0;
	w = 0;
	bk = -999;
	pos = *org;
	TextFrames_ParcBefore(T, pos, &P, &pbeg);
	width = (int)__DIV(P->width, (LONGINT)TextFrames_Unit);
	indent = 0;
	if (*org > 0) {
		Texts_OpenReader(&R1, Texts_Reader__typ, T, *org - 1);
		Texts_Read(&R1, Texts_Reader__typ, &peekCh);
		if (peekCh == 0x0d || R1.elem != NIL && __ISP(R1.elem, TextFrames_ParcDesc, 2)) {
			indent = (int)__DIV(P->first, (LONGINT)TextFrames_Unit);
		}
	}
	tw += indent;
	for (;;) {
		pos += 1;
		if ((*R).eot || *nextCh == 0x0d) {
			break;
		}
		tw += dx;
		if (*nextCh <= ' ') {
			TextFrames_MeasureSpecial(&*R, R__typ, *nextCh, P, tw, &dx, &x, &y, &w, &h);
		} else {
			Display_GetChar((*R).fnt->raster, *nextCh, &dx, &x, &y, &w, &h, &pat);
		}
		if ((tw + x) + w > width) {
			d = pos - bk;
			if (d < 30 && *nextCh > ' ') {
				pos = bk;
			} else if ((*nextCh > ' ' || *nextCh == 0x1c) && pos > *org + 1) {
				pos -= 1;
			}
			Texts_OpenReader(&*R, R__typ, T, pos);
			Texts_Read(&*R, R__typ, &*nextCh);
			break;
		}
		if (*nextCh <= ' ' && *nextCh != 0x1c) {
			bk = pos;
		}
		Texts_Read(&*R, R__typ, &*nextCh);
	}
	*org = pos;
}

static void TextFrames_BegOfLine (Texts_Reader *R, LONGINT *R__typ, Texts_Text T, LONGINT *pos, BOOLEAN adjust, CHAR *nextCh)
{
	LONGINT p = 0, org = 0;
	if (*pos <= 0) {
		*pos = 0;
	} else {
		if (*pos <= T->len) {
			org = *pos;
		} else {
			org = T->len;
		}
		for (;;) {
			if (org == 0) {
				break;
			}
			Texts_OpenReader(&*R, R__typ, T, org - 1);
			Texts_Read(&*R, R__typ, &*nextCh);
			if (*nextCh == 0x0d) {
				break;
			}
			org -= 1;
		}
		if (adjust) {
			Texts_OpenReader(&*R, R__typ, T, org);
			Texts_Read(&*R, R__typ, &*nextCh);
			p = org;
			do {
				org = p;
				TextFrames_NextLine(&*R, R__typ, T, &p, &*nextCh);
			} while (!(p > *pos || (*R).eot));
		}
		*pos = org;
	}
}

static void TextFrames_AdjustMetrics (TextFrames_Frame F, TextFrames_TextLine t, INTEGER *pw, INTEGER *tw, INTEGER *ddx, INTEGER *cn, TextFrames_Parc *P, LONGINT *pbeg)
{
	*P = t->P;
	*pbeg = t->pbeg;
	*pw = F->left;
	*tw = t->w;
	*ddx = 0;
	*cn = 0;
	if (t->pbeg != t->org) {
		*pw += (int)__DIV((*P)->left + t->indent, (LONGINT)TextFrames_Unit);
		if (__IN(1, (*P)->opts)) {
			if (__IN(2, (*P)->opts) && t->nob > 0) {
				*tw = (int)__DIV((*P)->width, (LONGINT)TextFrames_Unit);
				*ddx = __DIV(*tw - t->w0, t->nob);
				*cn = (int)__MOD(*tw - t->w0, t->nob);
			}
		} else if (__IN(2, (*P)->opts)) {
			*pw += (int)__DIV((*P)->width, (LONGINT)TextFrames_Unit) - t->w0;
		} else {
			*pw += __ASHR((int)__DIV((*P)->width, (LONGINT)TextFrames_Unit) - t->w0, 1);
		}
		*tw -= (int)__DIV(t->indent, (LONGINT)TextFrames_Unit);
	}
}

static void TextFrames_DrawSpecial (Texts_Reader *R, LONGINT *R__typ, TextFrames_Frame F, CHAR nextCh, INTEGER px, INTEGER py, INTEGER x, INTEGER y)
{
	Texts_Elem e = NIL;
	LONGINT pat = 0;
	INTEGER dx = 0, w = 0, h = 0;
	TextFrames_DisplayMsg msg = {0};
	if (nextCh == 0x09 || nextCh == 0x0d) {
	} else if ((*R).elem != NIL) {
		e = (*R).elem;
		if (!__ISP(e, TextFrames_ParcDesc, 2) || F->showsParcs) {
			msg.prepare = 0;
			msg.fnt = (*R).fnt;
			msg.col = (*R).col;
			msg.pos = Texts_Pos(&*R, R__typ) - 1;
			msg.frame = (Display_Frame)F;
			msg.X0 = px + x;
			msg.Y0 = py + y;
			msg.elemFrame = NIL;
			(*e->handle)(e, (void*)&msg, TextFrames_DisplayMsg__typ);
			if (msg.elemFrame != NIL) {
				msg.elemFrame->next = F->dsc;
				F->dsc = msg.elemFrame;
			}
		} else if (__IN(3, __GUARDP(e, TextFrames_ParcDesc, 2)->opts)) {
			Display_ReplPattern(15, Display_grey1, px + x, py, (int)__DIV(e->W, (LONGINT)TextFrames_Unit), 1, 0);
		}
	} else {
		Display_GetChar((*R).fnt->raster, nextCh, &dx, &x, &y, &w, &h, &pat);
		Display_CopyPattern((*R).col, pat, px + x, py + y, 2);
	}
}

static void TextFrames_ShowLine (TextFrames_Frame F, TextFrames_TextLine t, INTEGER left, INTEGER right, INTEGER py, CHAR *nextCh)
{
	LONGINT pat = 0, i = 0;
	INTEGER n = 0, cn = 0, lm = 0, px = 0, pw = 0, tw = 0, ddx = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	Texts_Reader R = {0};
	TextFrames_Parc p = NIL;
	LONGINT beg = 0;
	Texts_OpenReader(&R, Texts_Reader__typ, F->text, t->org);
	TextFrames_AdjustMetrics(F, t, &pw, &tw, &ddx, &cn, &p, &beg);
	lm = (F->X + F->left) + (int)__DIV(p->left, (LONGINT)TextFrames_Unit);
	px = F->X + pw;
	py += t->dsr;
	i = 0;
	n = 0;
	while (i < t->len) {
		Texts_Read(&R, Texts_Reader__typ, &*nextCh);
		if (*nextCh <= ' ') {
			TextFrames_GetSpecial(&R, Texts_Reader__typ, *nextCh, p, F, &n, cn, ddx, px - lm, &dx, &x, &y, &w, &h);
		} else {
			Display_GetChar(R.fnt->raster, *nextCh, &dx, &x, &y, &w, &h, &pat);
		}
		y += __ASHR(R.fnt->height * (int)R.voff, 6);
		if ((px + x) + w <= right) {
			if (px + x >= left) {
				if (*nextCh <= ' ') {
					TextFrames_DrawSpecial(&R, Texts_Reader__typ, F, *nextCh, px, py, x, y);
				} else {
					Display_CopyPattern(R.col, pat, px + x, py + y, 2);
				}
			}
			px += dx;
			i += 1;
		} else {
			i = t->len;
		}
	}
}

static void TextFrames_ShowLines (TextFrames_Frame F, INTEGER botH, INTEGER topH, BOOLEAN erase, CHAR *nextCh)
{
	TextFrames_TextLine t = NIL;
	INTEGER ph = 0;
	t = F->trailer->next;
	ph = F->H - F->top;
	while (t != F->trailer && ph - t->h >= topH) {
		ph -= t->h;
		t = t->next;
	}
	while (t != F->trailer && ph - t->h >= botH) {
		ph -= t->h;
		if (erase) {
			TextFrames_Erase(F, F->X + F->left, F->Y + ph, (F->W - F->right) - F->left, t->h);
		}
		TextFrames_ShowLine(F, t, F->X + F->left, (F->X + F->W) - F->right, F->Y + ph, &*nextCh);
		t = t->next;
	}
}

static void TextFrames_MeasureLine (Texts_Reader *R, LONGINT *R__typ, TextFrames_Frame F, INTEGER maxW, TextFrames_TextLine t, CHAR *nextCh, TextFrames_Parc *P, LONGINT *pbeg)
{
	LONGINT pat = 0, len = 0, bklen = 0, d = 0;
	BOOLEAN eol = 0;
	INTEGER nob = 0, bknob = 0, width = 0, minY = 0, bkminY = 0, maxY = 0, bkmaxY = 0, tw = 0, bktw = 0, lsp = 0, dsr = 0, dx = 0, x = 0, y = 0, w = 0, h = 0;
	Texts_Reader R1 = {0};
	CHAR peekCh = 0;
	len = 0;
	nob = 0;
	bklen = -999;
	tw = 0;
	dx = 0;
	minY = 0;
	maxY = 0;
	TextFrames_ParcBefore(F->text, t->org, &*P, &*pbeg);
	lsp = (int)__DIV((*P)->lsp, (LONGINT)TextFrames_Unit);
	dsr = (int)__DIV((*P)->dsr, (LONGINT)TextFrames_Unit);
	width = (int)__DIV((*P)->width, (LONGINT)TextFrames_Unit);
	t->indent = 0;
	if (t->org > 0) {
		Texts_OpenReader(&R1, Texts_Reader__typ, F->text, t->org - 1);
		Texts_Read(&R1, Texts_Reader__typ, &peekCh);
		if (peekCh == 0x0d || R1.elem != NIL && __ISP(R1.elem, TextFrames_ParcDesc, 2)) {
			t->indent = (*P)->first;
		}
	}
	tw += (int)__DIV(t->indent, (LONGINT)TextFrames_Unit);
	for (;;) {
		if ((*R).eot || *nextCh == 0x0d) {
			nob = 0;
			eol = !(*R).eot;
			break;
		}
		if (*nextCh <= ' ') {
			TextFrames_MeasureSpecial(&*R, R__typ, *nextCh, *P, tw, &dx, &x, &y, &w, &h);
		} else {
			Display_GetChar((*R).fnt->raster, *nextCh, &dx, &x, &y, &w, &h, &pat);
		}
		if ((tw + x) + w > width) {
			d = len - bklen;
			if (d < 30 && *nextCh > ' ') {
				eol = 1;
				Texts_OpenReader(&*R, R__typ, F->text, Texts_Pos(&*R, R__typ) - d);
				nob = bknob;
				len = bklen;
				tw = bktw;
				minY = bkminY;
				maxY = bkmaxY;
			} else if (len == 0) {
				len += 1;
				y += __ASHR((*R).fnt->height * (int)(*R).voff, 6);
				minY = TextFrames_Min(minY, y);
				maxY = TextFrames_Max(maxY, y + h);
				Texts_Read(&*R, R__typ, &*nextCh);
				eol = 0;
				tw = maxW;
			} else {
				eol = *nextCh <= ' ' && *nextCh != 0x1c;
			}
			break;
		}
		if (*nextCh <= ' ' && *nextCh != 0x1c) {
			bknob = nob;
			bklen = len;
			bktw = tw;
			bkminY = minY;
			bkmaxY = maxY;
			if (*nextCh == ' ') {
				nob += 1;
			}
		}
		len += 1;
		tw += dx;
		y += __ASHR((*R).fnt->height * (int)(*R).voff, 6);
		if (y < minY) {
			minY = y;
		}
		if (y + h > maxY) {
			maxY = y + h;
		}
		Texts_Read(&*R, R__typ, &*nextCh);
	}
	if (!F->showsParcs && *pbeg == t->org) {
		dsr = 0;
		t->h = (int)__DIV((*P)->lead, (LONGINT)TextFrames_Unit) + 1;
	} else if (__IN(0, (*P)->opts)) {
		while (dsr < -minY) {
			dsr += lsp;
		}
		t->h = TextFrames_Max(lsp, dsr + maxY);
		t->h += (int)__MOD(-t->h, lsp);
	} else {
		dsr = TextFrames_Max(dsr, -minY);
		t->h = TextFrames_Max(lsp, dsr + maxY);
	}
	t->len = len;
	t->w0 = tw;
	t->w = TextFrames_Min(tw, maxW);
	t->dsr = dsr;
	t->nob = nob;
	t->eot = (*R).eot;
	t->P = *P;
	t->pbeg = *pbeg;
	if (eol) {
		Texts_Read(&*R, R__typ, &*nextCh);
		t->span = len + 1;
	} else {
		t->span = len;
	}
}

static void TextFrames_MeasureLines (TextFrames_Frame F, LONGINT org, TextFrames_TextLine *trailer, CHAR *nextCh, TextFrames_Parc *P, LONGINT *pbeg)
{
	TextFrames_TextLine s = NIL, t = NIL;
	INTEGER ph = 0;
	Texts_Reader R = {0};
	__NEW(*trailer, TextFrames_TextLineDesc);
	s = *trailer;
	Texts_OpenReader(&R, Texts_Reader__typ, F->text, org);
	Texts_Read(&R, Texts_Reader__typ, &*nextCh);
	ph = F->H - F->top;
	for (;;) {
		__NEW(t, TextFrames_TextLineDesc);
		t->org = org;
		TextFrames_MeasureLine(&R, Texts_Reader__typ, F, (F->W - F->left) - F->right, t, &*nextCh, &*P, &*pbeg);
		if (ph - t->h < F->bot) {
			break;
		}
		s->next = t;
		s = t;
		org += s->span;
		ph -= s->h;
		if (R.eot) {
			break;
		}
	}
	s->next = *trailer;
	(*trailer)->eot = 1;
	(*trailer)->org = org;
	(*trailer)->len = 0;
	(*trailer)->w = 0;
	(*trailer)->h = (int)__DIV(TextFrames_defParc->lsp, (LONGINT)TextFrames_Unit);
	(*trailer)->P = *P;
	(*trailer)->pbeg = *pbeg;
}

static void TextFrames_LocateLineTop (TextFrames_Frame F, TextFrames_TextLine trailer, LONGINT org, TextFrames_Location *loc, LONGINT *loc__typ)
{
	TextFrames_TextLine t = NIL;
	INTEGER ph = 0;
	ph = F->H - F->top;
	t = trailer->next;
	while (t != trailer && t->org != org) {
		ph -= t->h;
		t = t->next;
	}
	(*loc).org = org;
	(*loc).line = t;
	(*loc).y = F->Y + ph;
}

static void TextFrames_Width (TextFrames_Frame F, TextFrames_TextLine t, LONGINT pos, INTEGER *pw, INTEGER *dx, INTEGER *dy, CHAR *nextCh)
{
	LONGINT pat = 0, i = 0;
	INTEGER n = 0, mw = 0, lm = 0, tw = 0, ddx = 0, cn = 0, x = 0, y = 0, w = 0, h = 0;
	Texts_Reader R = {0};
	TextFrames_Parc P = NIL;
	LONGINT pbeg = 0;
	TextFrames_AdjustMetrics(F, t, &*pw, &tw, &ddx, &cn, &P, &pbeg);
	*dy = 0;
	lm = F->left + (int)__DIV(P->left, (LONGINT)TextFrames_Unit);
	if (t != F->trailer) {
		Texts_OpenReader(&R, Texts_Reader__typ, F->text, t->org);
		Texts_Read(&R, Texts_Reader__typ, &*nextCh);
		i = 0;
		n = 0;
		pos -= t->org;
		*dx = 0;
		mw = F->W - F->right;
		while (((!R.eot && i < t->len) && i <= pos) && *pw + *dx <= mw) {
			i += 1;
			*pw += *dx;
			if (*nextCh <= ' ') {
				TextFrames_GetSpecial(&R, Texts_Reader__typ, *nextCh, P, F, &n, cn, ddx, *pw - lm, &*dx, &x, &y, &w, &h);
			} else {
				Display_GetChar(R.fnt->raster, *nextCh, &*dx, &x, &y, &w, &h, &pat);
			}
			*dy = __ASHR(R.fnt->height * (int)R.voff, 6);
			Texts_Read(&R, Texts_Reader__typ, &*nextCh);
		}
		if (i <= pos && *pw + *dx <= mw) {
			i += 1;
			*pw += *dx;
		}
	} else {
		*dx = 4;
	}
}

void TextFrames_LocatePos (TextFrames_Frame F, LONGINT pos, TextFrames_Location *loc, LONGINT *loc__typ)
{
	TextFrames_TextLine t = NIL;
	INTEGER pw = 0, dx = 0, dy = 0;
	CHAR ch = 0;
	if (pos < F->org) {
		pos = F->org;
		t = F->trailer->next;
	} else if (pos < F->trailer->org) {
		t = F->trailer;
		while (t->next != F->trailer && t->next->org <= pos) {
			t = t->next;
		}
	} else {
		pos = F->trailer->org;
		t = F->trailer->next;
		while (!t->eot) {
			t = t->next;
		}
	}
	TextFrames_Width(F, t, pos, &pw, &dx, &dy, &ch);
	TextFrames_LocateLineTop(F, F->trailer, t->org, &*loc, loc__typ);
	(*loc).y -= (*loc).line->h;
	(*loc).org = t->org;
	(*loc).pos = pos;
	(*loc).x = F->X + pw;
	(*loc).dx = dx;
	(*loc).dy = dy;
	(*loc).line = t;
}

void TextFrames_LocateLine (TextFrames_Frame F, INTEGER y, TextFrames_Location *loc, LONGINT *loc__typ)
{
	TextFrames_TextLine t = NIL;
	INTEGER h = 0, ph = 0, pw = 0, tw = 0, ddx = 0, cn = 0;
	TextFrames_Parc P = NIL;
	LONGINT pbeg = 0;
	t = F->trailer->next;
	h = y - F->Y;
	ph = (F->H - F->top) - t->h;
	while ((!t->eot && ph - t->next->h >= F->bot) && ph > h) {
		t = t->next;
		ph -= t->h;
	}
	TextFrames_AdjustMetrics(F, t, &pw, &tw, &ddx, &cn, &P, &pbeg);
	if (pw >= F->W - F->right) {
		pw = (F->W - F->right) - 4;
	}
	(*loc).org = t->org;
	(*loc).pos = (*loc).org;
	(*loc).x = F->X + pw;
	(*loc).y = F->Y + ph;
	(*loc).dx = tw;
	(*loc).dy = 0;
	(*loc).line = t;
}

void TextFrames_LocateChar (TextFrames_Frame F, INTEGER x, INTEGER y, TextFrames_Location *loc, LONGINT *loc__typ)
{
	TextFrames_TextLine t = NIL;
	LONGINT pat = 0, i = 0;
	INTEGER n = 0, w = 0, lm = 0, pw = 0, tw = 0, ddx = 0, cn = 0, dx = 0, xc = 0, yc = 0, wc = 0, hc = 0;
	CHAR nextCh = 0;
	Texts_Reader R = {0};
	TextFrames_Parc P = NIL;
	LONGINT pbeg = 0;
	TextFrames_LocateLine(F, y, &*loc, loc__typ);
	t = (*loc).line;
	w = x - F->X;
	TextFrames_AdjustMetrics(F, t, &pw, &tw, &ddx, &cn, &P, &pbeg);
	lm = F->left + (int)__DIV(P->left, (LONGINT)TextFrames_Unit);
	if (t != F->trailer && w > pw) {
		Texts_OpenReader(&R, Texts_Reader__typ, F->text, t->org);
		i = 0;
		n = 0;
		dx = 0;
		nextCh = 0x00;
		while (i < t->len && pw + dx < w) {
			Texts_Read(&R, Texts_Reader__typ, &nextCh);
			i += 1;
			pw += dx;
			if (nextCh <= ' ') {
				TextFrames_GetSpecial(&R, Texts_Reader__typ, nextCh, P, F, &n, cn, ddx, pw - lm, &dx, &xc, &yc, &wc, &hc);
			} else {
				Display_GetChar(R.fnt->raster, nextCh, &dx, &xc, &yc, &wc, &hc, &pat);
			}
		}
		if (pw + dx < w) {
			i += 1;
			pw += dx;
			R.elem = NIL;
		}
		(*loc).pos += i - 1;
		(*loc).x = F->X + pw;
		if (i < t->len) {
			(*loc).dx = dx;
			(*loc).dy = __ASHR(R.fnt->height * (int)R.voff, 6);
		} else {
			(*loc).dx = 4;
		}
	} else {
		(*loc).dx = 4;
		R.elem = NIL;
	}
}

void TextFrames_LocateWord (TextFrames_Frame F, INTEGER x, INTEGER y, TextFrames_Location *loc, LONGINT *loc__typ)
{
	TextFrames_TextLine t = NIL;
	LONGINT pos = 0, i = 0;
	INTEGER px = 0, rx = 0;
	LONGINT pat = 0;
	INTEGER dx = 0, xc = 0, yc = 0, wc = 0, hc = 0;
	CHAR nextCh = 0;
	Texts_Reader R = {0};
	TextFrames_LocateChar(F, x, y, &*loc, loc__typ);
	pos = (*loc).pos + 1;
	do {
		pos -= 1;
		Texts_OpenReader(&R, Texts_Reader__typ, F->text, pos);
		Texts_Read(&R, Texts_Reader__typ, &nextCh);
	} while (!(pos < (*loc).org || nextCh > ' '));
	pos += 1;
	do {
		pos -= 1;
		Texts_OpenReader(&R, Texts_Reader__typ, F->text, pos);
		Texts_Read(&R, Texts_Reader__typ, &nextCh);
	} while (!(pos < (*loc).org || nextCh <= ' '));
	TextFrames_LocatePos(F, pos + 1, &*loc, loc__typ);
	t = (*loc).line;
	i = (*loc).pos - (*loc).org;
	if (i < t->len) {
		px = (*loc).x;
		rx = (F->X + F->W) - F->right;
		Texts_OpenReader(&R, Texts_Reader__typ, F->text, (*loc).pos);
		dx = 0;
		wc = 0;
		nextCh = 'x';
		while ((i < t->len && nextCh > ' ') && px + dx < rx) {
			Texts_Read(&R, Texts_Reader__typ, &nextCh);
			i += 1;
			px += dx;
			Display_GetChar(R.fnt->raster, nextCh, &dx, &xc, &yc, &wc, &hc, &pat);
		}
		if (nextCh > ' ' && px + dx < rx) {
			i += 1;
			px += dx;
		}
		(*loc).dx = px - (*loc).x;
	} else {
		(*loc).dx = 0;
	}
}

LONGINT TextFrames_Pos (TextFrames_Frame F, INTEGER x, INTEGER y)
{
	TextFrames_Location loc = {0};
	TextFrames_LocateChar(F, x, y, &loc, TextFrames_Location__typ);
	return loc.pos;
}

static Display_Frame TextFrames_ThisSubFrame (TextFrames_Frame F, INTEGER x, INTEGER y)
{
	Display_Frame f = NIL;
	f = F->dsc;
	while (f != NIL && (((x < f->X || x >= f->X + f->W) || y < f->Y) || y >= f->Y + f->H)) {
		f = f->next;
	}
	return f;
}

static void TextFrames_PassSubFocus (TextFrames_Frame F, Display_Frame f)
{
	TextFrames_Location loc = {0};
	Display_Frame f1 = NIL;
	Oberon_ControlMsg ctrl = {0};
	TextFrames_FocusMsg focus = {0};
	Texts_Reader R = {0};
	Texts_Elem elem = NIL;
	CHAR ch = 0;
	if (F->focus != NIL) {
		f1 = F->focus;
		ctrl.id = 0;
		(*f1->handle)(f1, (void*)&ctrl, Oberon_ControlMsg__typ);
		TextFrames_LocateChar(F, f1->X + 1, f1->Y + 1, &loc, TextFrames_Location__typ);
		TextFrames_InvertBorder(f1);
		F->focus = NIL;
		Texts_OpenReader(&R, Texts_Reader__typ, F->text, loc.pos);
		Texts_Read(&R, Texts_Reader__typ, &ch);
		elem = R.elem;
		if (elem != NIL) {
			focus.focus = 0;
			focus.elemFrame = f1;
			focus.frame = (Display_Frame)F;
			(*elem->handle)(elem, (void*)&focus, TextFrames_FocusMsg__typ);
		}
	}
	if (f != NIL) {
		TextFrames_LocateChar(F, f->X + 1, f->Y + 1, &loc, TextFrames_Location__typ);
		Texts_OpenReader(&R, Texts_Reader__typ, F->text, loc.pos);
		Texts_Read(&R, Texts_Reader__typ, &ch);
		elem = R.elem;
		focus.focus = 1;
		focus.elemFrame = f;
		focus.frame = (Display_Frame)F;
		(*elem->handle)(elem, (void*)&focus, TextFrames_FocusMsg__typ);
		TextFrames_InvertBorder(f);
	}
	F->focus = f;
}

void TextFrames_RemoveSelection (TextFrames_Frame F)
{
	if (F->hasSel) {
		TextFrames_InvertSelection(F, F->selbeg, F->selend);
		F->hasSel = 0;
	}
}

void TextFrames_SetSelection (TextFrames_Frame F, LONGINT beg, LONGINT end)
{
	TextFrames_Location loc = {0};
	if (end > F->text->len) {
		end = F->text->len;
	}
	if (end > beg) {
		if (F->hasSel && F->selbeg.pos == beg) {
			if (F->selend.pos < end && F->selend.pos < F->trailer->org) {
				TextFrames_LocatePos(F, F->selend.pos, &loc, TextFrames_Location__typ);
				TextFrames_LocatePos(F, end, &F->selend, TextFrames_Location__typ);
				TextFrames_InvertSelection(F, loc, F->selend);
			} else if (end < F->selend.pos) {
				TextFrames_LocatePos(F, end, &loc, TextFrames_Location__typ);
				TextFrames_InvertSelection(F, loc, F->selend);
				TextFrames_LocatePos(F, end, &F->selend, TextFrames_Location__typ);
			}
		} else {
			TextFrames_RemoveSelection(F);
			TextFrames_PassSubFocus(F, NIL);
			TextFrames_LocatePos(F, beg, &F->selbeg, TextFrames_Location__typ);
			TextFrames_LocatePos(F, end, &F->selend, TextFrames_Location__typ);
			TextFrames_InvertSelection(F, F->selbeg, F->selend);
		}
		F->hasSel = 1;
		F->time = Oberon_Time();
	}
}

void TextFrames_RemoveCaret (TextFrames_Frame F)
{
	Oberon_ControlMsg msg = {0};
	if (F->focus != NIL) {
		msg.id = 0;
		(*F->focus->handle)(F->focus, (void*)&msg, Oberon_ControlMsg__typ);
	}
	if (F->hasCar) {
		TextFrames_InvertCaret(F);
		F->hasCar = 0;
	}
}

void TextFrames_SetCaret (TextFrames_Frame F, LONGINT pos)
{
	if (!F->hasCar || F->carloc.pos != pos) {
		TextFrames_RemoveCaret(F);
		TextFrames_PassSubFocus(F, NIL);
		TextFrames_LocatePos(F, pos, &F->carloc, TextFrames_Location__typ);
		if (F->carloc.x <= (F->X + F->W) - F->right && F->carloc.y >= F->Y + F->bot) {
			TextFrames_InvertCaret(F);
			F->hasCar = 1;
		}
	}
}

static void TextFrames_Complete (TextFrames_Frame F, TextFrames_TextLine trailer, TextFrames_TextLine s, LONGINT org, INTEGER ph, CHAR *nextCh, TextFrames_Parc P, LONGINT pbeg)
{
	TextFrames_TextLine u = NIL;
	Texts_Reader R = {0};
	TextFrames_Parc p = NIL;
	LONGINT beg = 0;
	p = P;
	beg = pbeg;
	if (ph > F->bot) {
		Texts_OpenReader(&R, Texts_Reader__typ, F->text, org);
		Texts_Read(&R, Texts_Reader__typ, &*nextCh);
		for (;;) {
			if (R.eot) {
				break;
			}
			__NEW(u, TextFrames_TextLineDesc);
			u->org = org;
			TextFrames_MeasureLine(&R, Texts_Reader__typ, F, (F->W - F->left) - F->right, u, &*nextCh, &p, &beg);
			if (ph - u->h < F->bot) {
				break;
			}
			s->next = u;
			s = s->next;
			ph -= s->h;
			org += s->span;
		}
	}
	TextFrames_ParcBefore(F->text, org, &p, &beg);
	s->next = trailer;
	trailer->eot = 1;
	trailer->org = org;
	trailer->len = 0;
	trailer->w = 0;
	trailer->h = (int)__DIV(TextFrames_defParc->lsp, (LONGINT)TextFrames_Unit);
	trailer->P = p;
	trailer->pbeg = beg;
}

static void TextFrames_ShowFrom (TextFrames_Frame F, LONGINT pos, CHAR *nextCh, TextFrames_Parc *P, LONGINT *pbeg)
{
	TextFrames_TextLine new = NIL, s = NIL;
	TextFrames_Location beg = {0}, end = {0};
	LONGINT org = 0;
	INTEGER ph = 0, y0 = 0, dy = 0;
	(*F->handle)((void*)F, (void*)&TextFrames_neutralize, Oberon_ControlMsg__typ);
	if ((F->trailer != NIL && F->org < pos) && pos < F->trailer->org) {
		TextFrames_LocateLineTop(F, F->trailer, pos, &beg, TextFrames_Location__typ);
		TextFrames_LocateLineTop(F, F->trailer, F->trailer->org, &end, TextFrames_Location__typ);
		dy = ((F->Y + F->H) - F->top) - beg.y;
		TextFrames_Shift(F, end.y, end.y + dy, beg.y - end.y);
		TextFrames_Erase(F, F->X + F->left, end.y, F->W - F->left, dy);
		s = F->trailer->next;
		while (s->org != pos) {
			s = s->next;
		}
		F->trailer->next = s;
		org = s->org + s->span;
		ph = (F->H - F->top) - s->h;
		while (s->next != F->trailer) {
			s = s->next;
			org = org + s->span;
			ph = ph - s->h;
		}
		TextFrames_Complete(F, F->trailer, s, org, ph, &*nextCh, *P, *pbeg);
		F->org = pos;
		TextFrames_ShowLines(F, F->bot, (end.y + dy) - F->Y, 0, &*nextCh);
	} else if (F->trailer == NIL || pos != F->org) {
		TextFrames_MeasureLines(F, pos, &new, &*nextCh, &*P, &*pbeg);
		if ((F->trailer != NIL && pos < F->org) && F->org <= new->org) {
			TextFrames_LocateLineTop(F, new, F->org, &beg, TextFrames_Location__typ);
			TextFrames_LocateLineTop(F, new, new->org, &end, TextFrames_Location__typ);
			y0 = (F->Y + F->H) - F->top;
			TextFrames_Shift(F, y0 - (beg.y - end.y), end.y, beg.y - end.y);
			TextFrames_Erase(F, F->X + F->left, beg.y, F->W - F->left, y0 - beg.y);
			TextFrames_Erase(F, F->X + F->left, F->Y + F->bot, F->W - F->left, end.y - (F->Y + F->bot));
			F->org = pos;
			F->trailer = new;
			TextFrames_ShowLines(F, beg.y - F->Y, F->H - F->top, 0, &*nextCh);
		} else {
			if (F->trailer == NIL) {
				TextFrames_Erase(F, F->X, F->Y, F->W, F->H);
				TextFrames_ShowBar(F, 0, F->H);
				F->markH = -1;
			} else {
				TextFrames_Erase(F, F->X + F->left, F->Y + F->bot, F->W - F->left, (F->H - F->bot) - F->top);
			}
			F->org = pos;
			F->trailer = new;
			TextFrames_ShowLines(F, F->bot, F->H - F->top, 0, &*nextCh);
		}
	}
	TextFrames_ShowTick(F);
}

static void TextFrames_ShowInternal (TextFrames_Frame F, LONGINT pos, TextFrames_Parc *P, LONGINT *pbeg)
{
	CHAR nextCh = 0;
	Texts_Reader R = {0};
	TextFrames_BegOfLine(&R, Texts_Reader__typ, F->text, &pos, 1, &nextCh);
	TextFrames_ShowFrom(F, pos, &nextCh, &*P, &*pbeg);
}

void TextFrames_Show (TextFrames_Frame F, LONGINT pos)
{
	CHAR nextCh = 0;
	Texts_Reader R = {0};
	TextFrames_Parc P = NIL;
	LONGINT pbeg = 0;
	TextFrames_BegOfLine(&R, Texts_Reader__typ, F->text, &pos, 1, &nextCh);
	TextFrames_ParcBefore(F->text, pos, &P, &pbeg);
	TextFrames_ShowFrom(F, pos, &nextCh, &P, &pbeg);
}

static void TextFrames_Resize (TextFrames_Frame F, INTEGER x, INTEGER y, INTEGER w, INTEGER h, CHAR *nextCh)
{
	INTEGER oldY = 0, oldH = 0, dh = 0, ph = 0;
	TextFrames_TextLine t = NIL;
	TextFrames_Parc P = NIL;
	LONGINT pbeg = 0;
	P = TextFrames_defParc;
	pbeg = -1;
	if (w == 0 || h == 0) {
		TextFrames_InvalSubFrames(F, F->X, F->Y, F->W, F->H);
		F->X = x;
		F->Y = y;
		F->W = w;
		F->H = h;
		F->trailer = NIL;
	} else if ((F->trailer != NIL && x == F->X) && w == F->W) {
		oldY = F->Y;
		oldH = F->H;
		TextFrames_Tick(F);
		F->markH = -1;
		F->Y = y;
		F->H = h;
		if (h > oldH) {
			dh = h - oldH;
			if (y + h != oldY + oldH) {
				Display_CopyBlock(x, oldY, w, oldH, x, y + dh, 0);
				TextFrames_ShiftSubFrames(F, oldY, y + dh, oldH);
			}
			TextFrames_EraseRect(F, x, y, w, dh);
			TextFrames_ShowBar(F, 0, dh);
			t = F->trailer;
			ph = F->H - F->top;
			while (t->next != F->trailer) {
				t = t->next;
				ph = ph - t->h;
			}
			TextFrames_Complete(F, F->trailer, t, F->trailer->org, ph, &*nextCh, P, pbeg);
			TextFrames_ShowLines(F, F->bot, ph, 0, &*nextCh);
		} else {
			dh = oldH - h;
			if (y + h != oldY + oldH) {
				Display_CopyBlock(x, oldY + dh, w, h, x, y, 0);
				TextFrames_ShiftSubFrames(F, oldY + dh, y, h);
			}
			t = F->trailer;
			ph = F->H - F->top;
			while (t->next != F->trailer && ph - t->next->h >= F->bot) {
				t = t->next;
				ph -= t->h;
			}
			if (t == F->trailer) {
				t->org = F->org;
				t->span = 0;
			}
			TextFrames_Complete(F, F->trailer, t, t->org + t->span, ph, &*nextCh, P, pbeg);
			TextFrames_EraseRect(F, x + F->left, y, w - F->left, ph);
			TextFrames_InvalSubFrames(F, x, oldY, w, y - oldY);
			TextFrames_InvalSubFrames(F, x, y + h, w, dh - (y - oldY));
		}
		TextFrames_ShowTick(F);
	} else {
		F->X = x;
		F->Y = y;
		F->W = w;
		F->H = h;
		F->trailer = NIL;
		TextFrames_ShowInternal(F, F->org, &P, &pbeg);
	}
}

static struct Update__72 {
	TextFrames_Frame *F;
	TextFrames_UpdateMsg *msg;
	LONGINT *msg__typ;
	CHAR *nextCh;
	TextFrames_Parc *P;
	LONGINT *pbeg;
	Texts_Reader *R;
	struct Update__72 *lnk;
} *Update__72_s;

static void Adjust__73 (LONGINT end, LONGINT delta);
static void Begin__75 (LONGINT *beg, LONGINT *org0, TextFrames_TextLine *q);

static void Begin__75 (LONGINT *beg, LONGINT *org0, TextFrames_TextLine *q)
{
	TextFrames_TextLine trailer = NIL, t = NIL;
	trailer = (*Update__72_s->F)->trailer;
	t = trailer;
	while ((t->next != trailer && *beg >= t->next->org + t->next->span) && !t->next->eot) {
		t = t->next;
	}
	*q = t->next;
	if ((t != trailer && *q != trailer) && *beg <= (*q)->org + (*q)->span) {
		Texts_OpenReader(&*Update__72_s->R, Texts_Reader__typ, (*Update__72_s->F)->text, t->org);
		Texts_Read(&*Update__72_s->R, Texts_Reader__typ, &*Update__72_s->nextCh);
		*org0 = t->org;
		TextFrames_NextLine(&*Update__72_s->R, Texts_Reader__typ, (*Update__72_s->F)->text, &*org0, &*Update__72_s->nextCh);
	} else {
		*org0 = *beg;
		TextFrames_BegOfLine(&*Update__72_s->R, Texts_Reader__typ, (*Update__72_s->F)->text, &*org0, 1, &*Update__72_s->nextCh);
	}
	if (*org0 != (*q)->org) {
		if (t == trailer) {
			*org0 = (*q)->org;
		} else {
			*org0 = t->org;
		}
		*beg = *org0;
		*q = NIL;
	}
}

static void Adjust__73 (LONGINT end, LONGINT delta)
{
	TextFrames_TextLine new = NIL, old = NIL, s = NIL, t = NIL, u = NIL, p = NIL, q = NIL;
	TextFrames_Location bot = {0};
	LONGINT org = 0, org0 = 0, beg = 0;
	INTEGER ph = 0, h0 = 0, h1 = 0, H1 = 0, h2 = 0, lm = 0, dx = 0, dy = 0;
	q = NIL;
	TextFrames_LocateLineTop(*Update__72_s->F, (*Update__72_s->F)->trailer, (*Update__72_s->F)->trailer->org, &bot, TextFrames_Location__typ);
	if ((*Update__72_s->msg).beg < (*Update__72_s->F)->org) {
		org0 = (*Update__72_s->F)->org;
		beg = org0;
	} else {
		beg = (*Update__72_s->msg).beg;
		Begin__75(&beg, &org0, &q);
	}
	__NEW(new, TextFrames_TextLineDesc);
	s = new;
	old = (*Update__72_s->F)->trailer;
	t = old;
	org = (*Update__72_s->F)->org;
	ph = (*Update__72_s->F)->H - (*Update__72_s->F)->top;
	while (t->next != old && t->next->org != org0) {
		t = t->next;
		s->next = t;
		s = t;
		ph -= s->h;
		org += s->span;
	}
	h0 = ph;
	H1 = h0;
	t = t->next;
	p = s;
	Texts_OpenReader(&*Update__72_s->R, Texts_Reader__typ, (*Update__72_s->F)->text, org);
	Texts_Read(&*Update__72_s->R, Texts_Reader__typ, &*Update__72_s->nextCh);
	for (;;) {
		__NEW(u, TextFrames_TextLineDesc);
		u->org = org;
		TextFrames_MeasureLine(&*Update__72_s->R, Texts_Reader__typ, *Update__72_s->F, ((*Update__72_s->F)->W - (*Update__72_s->F)->left) - (*Update__72_s->F)->right, u, &*Update__72_s->nextCh, &*Update__72_s->P, &*Update__72_s->pbeg);
		if (ph - u->h < (*Update__72_s->F)->bot) {
			h1 = ph;
			h2 = h1;
			break;
		}
		s->next = u;
		s = s->next;
		ph -= s->h;
		org += s->span;
		if ((*Update__72_s->R).eot) {
			h1 = ph;
			h2 = h1;
			break;
		}
		if (org > end) {
			while (t != old && org > t->org + delta) {
				H1 -= t->h;
				t = t->next;
			}
			if (org == t->org + delta && *Update__72_s->P == t->P) {
				h1 = ph;
				while (t != old && ph - t->h >= (*Update__72_s->F)->bot) {
					s->next = t;
					s = t;
					s->org = org;
					TextFrames_ParcBefore((*Update__72_s->F)->text, s->org, &s->P, &s->pbeg);
					ph -= s->h;
					org += s->span;
					t = t->next;
				}
				h2 = ph;
				break;
			}
		}
	}
	TextFrames_Shift(*Update__72_s->F, ((*Update__72_s->F)->Y + H1) - (h1 - h2), (*Update__72_s->F)->Y + h2, h1 - h2);
	TextFrames_Complete(*Update__72_s->F, new, s, org, ph, &*Update__72_s->nextCh, *Update__72_s->P, *Update__72_s->pbeg);
	(*Update__72_s->F)->trailer = new;
	t = p->next;
	if ((((((q != NIL && t != (*Update__72_s->F)->trailer) && q->h == t->h) && q->dsr == t->dsr) && q->org == t->org) && q->P == t->P) && end <= t->org + t->span) {
		*Update__72_s->P = t->P;
		*Update__72_s->pbeg = t->pbeg;
		if (((*Update__72_s->P)->opts & 0x06) == 0x02 || (((*Update__72_s->P)->opts & 0x06) == 0x06 && q->nob == 0) && t->nob == 0) {
			TextFrames_Width(*Update__72_s->F, t, beg, &lm, &dx, &dy, &*Update__72_s->nextCh);
			h0 -= t->h;
			TextFrames_Erase(*Update__72_s->F, (*Update__72_s->F)->X + lm, (*Update__72_s->F)->Y + h0, (*Update__72_s->F)->W - lm, t->h);
			TextFrames_ShowLine(*Update__72_s->F, t, (*Update__72_s->F)->X + lm, ((*Update__72_s->F)->X + (*Update__72_s->F)->W) - (*Update__72_s->F)->right, (*Update__72_s->F)->Y + h0, &*Update__72_s->nextCh);
		}
	}
	TextFrames_ShowLines(*Update__72_s->F, h1, h0, 1, &*Update__72_s->nextCh);
	TextFrames_Erase(*Update__72_s->F, (*Update__72_s->F)->X + (*Update__72_s->F)->left, bot.y, (*Update__72_s->F)->W - (*Update__72_s->F)->left, h2 - (bot.y - (*Update__72_s->F)->Y));
	TextFrames_ShowLines(*Update__72_s->F, (*Update__72_s->F)->bot, h2, 0, &*Update__72_s->nextCh);
}

static void TextFrames_Update (TextFrames_Frame F, TextFrames_UpdateMsg *msg, LONGINT *msg__typ)
{
	TextFrames_TextLine t = NIL;
	LONGINT org = 0, d = 0, Fbeg = 0, Fend = 0;
	CHAR nextCh = 0;
	Display_Frame foc = NIL;
	LONGINT beg = 0, end = 0;
	CHAR ch = 0;
	Texts_Reader r = {0};
	TextFrames_Location loc = {0};
	TextFrames_Parc P = NIL;
	LONGINT pbeg = 0;
	Texts_Reader R = {0};
	struct Update__72 _s;
	_s.F = &F;
	_s.msg = msg; _s.msg__typ = msg__typ;
	_s.nextCh = &nextCh;
	_s.P = &P;
	_s.pbeg = &pbeg;
	_s.R = &R;
	_s.lnk = Update__72_s;
	Update__72_s = &_s;
	foc = F->focus;
	beg = (*msg).beg;
	end = (*msg).end;
	(*F->handle)((void*)F, (void*)&TextFrames_neutralize, Oberon_ControlMsg__typ);
	TextFrames_MarkMenu(F);
	Fbeg = F->org;
	Fend = F->trailer->org;
	if ((*msg).id == 1 && (*msg).beg < F->org) {
		t = F->trailer;
		d = (*msg).end - (*msg).beg;
		F->org += d;
		do {
			t->org += d;
			t = t->next;
		} while (!(t == F->trailer));
	} else if ((*msg).id == 2) {
		if ((*msg).end <= F->org) {
			t = F->trailer;
			d = (*msg).end - (*msg).beg;
			F->org -= d;
			do {
				t->org -= d;
				t = t->next;
			} while (!(t == F->trailer));
		} else if ((*msg).beg < F->org) {
			F->org = (*msg).beg;
		}
	}
	org = F->org;
	if ((*msg).beg <= Fbeg + 30) {
		TextFrames_BegOfLine(&R, Texts_Reader__typ, F->text, &org, 1, &nextCh);
	}
	TextFrames_ParcBefore(F->text, org, &P, &d);
	if (org != F->org || P != F->trailer->next->P) {
		F->trailer = NIL;
		TextFrames_Show(F, F->org);
	} else if ((*msg).end > Fbeg && (*msg).beg < Fend + 30) {
		if ((*msg).id == 0) {
			Adjust__73((*msg).end, 0);
			if (foc != NIL && end - beg == 1) {
				Texts_OpenReader(&r, Texts_Reader__typ, F->text, beg);
				Texts_Read(&r, Texts_Reader__typ, &ch);
				if (r.elem != NIL) {
					TextFrames_LocatePos(F, beg, &loc, TextFrames_Location__typ);
					foc = TextFrames_ThisSubFrame(F, loc.x, loc.y);
					TextFrames_PassSubFocus(F, foc);
				}
			}
		} else if ((*msg).id == 1) {
			Adjust__73((*msg).end, (*msg).end - (*msg).beg);
		} else if ((*msg).id == 2) {
			Adjust__73((*msg).beg, (*msg).beg - (*msg).end);
		}
	}
	TextFrames_ShowTick(F);
	Update__72_s = _s.lnk;
}

static struct Back__2 {
	TextFrames_Frame *F;
	LONGINT *org;
	CHAR *nextCh;
	Texts_Reader *R;
	TextFrames_Parc *p;
	LONGINT *beg;
	struct Back__2 *lnk;
} *Back__2_s;

static void Forward__3 (INTEGER h);
static INTEGER TotalHeight__5 (LONGINT org1, LONGINT org2);

static INTEGER TotalHeight__5 (LONGINT org1, LONGINT org2)
{
	INTEGER h = 0;
	TextFrames_TextLine line = NIL;
	Texts_OpenReader(&*Back__2_s->R, Texts_Reader__typ, (*Back__2_s->F)->text, org1);
	Texts_Read(&*Back__2_s->R, Texts_Reader__typ, &*Back__2_s->nextCh);
	__NEW(line, TextFrames_TextLineDesc);
	h = 0;
	for (;;) {
		line->org = org1;
		TextFrames_MeasureLine(&*Back__2_s->R, Texts_Reader__typ, *Back__2_s->F, ((*Back__2_s->F)->W - (*Back__2_s->F)->left) - (*Back__2_s->F)->right, line, &*Back__2_s->nextCh, &*Back__2_s->p, &*Back__2_s->beg);
		org1 += line->span;
		if (Texts_Pos(&*Back__2_s->R, Texts_Reader__typ) - 1 > org2) {
			break;
		}
		h += line->h;
		if ((*Back__2_s->R).eot) {
			break;
		}
	}
	return h;
}

static void Forward__3 (INTEGER h)
{
	TextFrames_TextLine line = NIL;
	Texts_OpenReader(&*Back__2_s->R, Texts_Reader__typ, (*Back__2_s->F)->text, *Back__2_s->org);
	Texts_Read(&*Back__2_s->R, Texts_Reader__typ, &*Back__2_s->nextCh);
	__NEW(line, TextFrames_TextLineDesc);
	while (h > 0) {
		line->org = *Back__2_s->org;
		TextFrames_MeasureLine(&*Back__2_s->R, Texts_Reader__typ, *Back__2_s->F, ((*Back__2_s->F)->W - (*Back__2_s->F)->left) - (*Back__2_s->F)->right, line, &*Back__2_s->nextCh, &*Back__2_s->p, &*Back__2_s->beg);
		*Back__2_s->org += line->span;
		h -= line->h;
	}
	*Back__2_s->org = Texts_Pos(&*Back__2_s->R, Texts_Reader__typ) - 1;
}

static void TextFrames_Back (TextFrames_Frame F, INTEGER dY, LONGINT *org)
{
	INTEGER H = 0;
	LONGINT oldOrg = 0;
	CHAR nextCh = 0;
	Texts_Reader R = {0};
	TextFrames_Parc p = NIL;
	LONGINT beg = 0;
	struct Back__2 _s;
	_s.F = &F;
	_s.org = org;
	_s.nextCh = &nextCh;
	_s.R = &R;
	_s.p = &p;
	_s.beg = &beg;
	_s.lnk = Back__2_s;
	Back__2_s = &_s;
	H = 0;
	for (;;) {
		oldOrg = *org;
		if (*org == 0) {
			break;
		}
		*org -= 800;
		TextFrames_BegOfLine(&R, Texts_Reader__typ, F->text, &*org, 0, &nextCh);
		H += TotalHeight__5(*org, oldOrg);
		if (H > dY) {
			break;
		}
	}
	Forward__3(H - dY);
	Back__2_s = _s.lnk;
}

void TextFrames_TrackLine (TextFrames_Frame F, INTEGER *x, INTEGER *y, LONGINT *org, SET *keysum)
{
	SET keys = 0;
	TextFrames_Location new = {0}, old = {0};
	TextFrames_LocateLine(F, *y, &old, TextFrames_Location__typ);
	TextFrames_InvertRect(F, old.x, old.y, old.dx + 4, 2);
	*keysum = 0x0;
	do {
		TextFrames_TrackMouse(&*x, &*y, &keys, &*keysum);
		TextFrames_LocateLine(F, *y, &new, TextFrames_Location__typ);
		if (new.org != old.org) {
			TextFrames_InvertRect(F, new.x, new.y, new.dx + 4, 2);
			TextFrames_InvertRect(F, old.x, old.y, old.dx + 4, 2);
			old = new;
		}
	} while (!(keys == 0x0));
	TextFrames_InvertRect(F, new.x, new.y, new.dx + 4, 2);
	*org = new.org;
}

void TextFrames_TrackWord (TextFrames_Frame F, INTEGER *x, INTEGER *y, LONGINT *pos, SET *keysum)
{
	SET keys = 0;
	TextFrames_Location new = {0}, old = {0};
	TextFrames_LocateWord(F, *x, *y, &old, TextFrames_Location__typ);
	TextFrames_InvertRect(F, old.x, old.y, old.dx, 2);
	*keysum = 0x0;
	do {
		TextFrames_TrackMouse(&*x, &*y, &keys, &*keysum);
		TextFrames_LocateWord(F, *x, *y, &new, TextFrames_Location__typ);
		if (new.pos != old.pos) {
			TextFrames_InvertRect(F, new.x, new.y, new.dx, 2);
			TextFrames_InvertRect(F, old.x, old.y, old.dx, 2);
			old = new;
		}
	} while (!(keys == 0x0));
	TextFrames_InvertRect(F, new.x, new.y, new.dx, 2);
	*pos = new.pos;
}

void TextFrames_TrackCaret (TextFrames_Frame F, INTEGER *x, INTEGER *y, SET *keysum)
{
	SET keys = 0;
	*keysum = 0x0;
	do {
		TextFrames_TrackMouse(&*x, &*y, &keys, &*keysum);
		TextFrames_SetCaret(F, TextFrames_Pos(F, *x, *y));
	} while (!(keys == 0x0));
}

void TextFrames_TrackSelection (TextFrames_Frame F, INTEGER *x, INTEGER *y, SET *keysum)
{
	SET keys = 0;
	LONGINT pos = 0;
	Viewers_Viewer V = NIL;
	TextFrames_Frame f = NIL;
	V = Viewers_This(F->X, F->Y);
	V = __GUARDP(V->next, Viewers_ViewerDesc, 1);
	if ((V->dsc != NIL && V->dsc->next != NIL) && __ISP(V->dsc->next, TextFrames_FrameDesc, 1)) {
		f = __GUARDP(V->dsc->next, TextFrames_FrameDesc, 1);
		if (f->hasSel && f->text == F->text) {
			if ((f->selbeg.pos < f->trailer->org && f->org < f->selend.pos) && f->selbeg.pos <= TextFrames_Pos(F, *x, *y)) {
				TextFrames_SetSelection(F, f->selbeg.pos, TextFrames_Pos(F, *x, *y) + 1);
			} else {
				TextFrames_RemoveSelection(f);
				f = NIL;
			}
		} else {
			f = NIL;
		}
	} else {
		f = NIL;
	}
	if (f == NIL) {
		if ((F->hasSel && F->selbeg.pos + 1 == F->selend.pos) && TextFrames_Pos(F, *x, *y) == F->selbeg.pos) {
			TextFrames_SetSelection(F, F->selbeg.org, TextFrames_Pos(F, *x, *y) + 1);
		} else {
			TextFrames_SetSelection(F, TextFrames_Pos(F, *x, *y), TextFrames_Pos(F, *x, *y) + 1);
		}
	}
	*keysum = 0x0;
	do {
		TextFrames_TrackMouse(&*x, &*y, &keys, &*keysum);
		if (F->hasSel) {
			pos = TextFrames_Pos(F, *x, TextFrames_Min(*y, F->selbeg.y)) + 1;
			if (pos <= F->selbeg.pos) {
				pos = F->selbeg.pos + 1;
			}
			TextFrames_SetSelection(F, F->selbeg.pos, pos);
			if (f != NIL) {
				TextFrames_SetSelection(f, f->selbeg.pos, pos);
				f->selend.pos = F->selend.pos;
			}
		} else {
			TextFrames_SetSelection(F, TextFrames_Pos(F, *x, *y), TextFrames_Pos(F, *x, *y) + 1);
		}
	} while (!(keys == 0x0));
	if (f != NIL) {
		F->selbeg.pos = f->selbeg.pos;
	}
}

static void TextFrames_Call (TextFrames_Frame F, LONGINT pos, SET keysum)
{
	Texts_Scanner S = {0};
	INTEGER res = 0, i = 0, j = 0;
	Texts_OpenScanner(&S, Texts_Scanner__typ, F->text, pos);
	Texts_Scan(&S, Texts_Scanner__typ);
	if (S.class == 1 && S.line == 0) {
		i = 0;
		while (i < S.len && S.s[__X(i, 256)] != '.') {
			i += 1;
		}
		j = i + 1;
		while (j < S.len && S.s[__X(j, 256)] != '.') {
			j += 1;
		}
		if (j >= S.len && S.s[__X(i, 256)] == '.' || __IN(0, keysum)) {
			TextFrames_par->vwr = Viewers_This(F->X, F->Y);
			if (__IN(0, keysum)) {
				__MOVE("Edit.Open", S.s, 10);
				TextFrames_par->pos = pos;
			} else {
				TextFrames_par->pos = pos + (LONGINT)S.len;
			}
			TextFrames_par->frame = (Display_Frame)F;
			TextFrames_par->text = F->text;
			Oberon_Call(S.s, 256, TextFrames_par, keysum == 0x06, &res);
			if (res > 0) {
				Texts_WriteString(&TextFrames_W0, Texts_Writer__typ, (CHAR*)"Call error: ", (LONGINT)13);
				Texts_WriteString(&TextFrames_W0, Texts_Writer__typ, Modules_importing, 20);
				if (res == 1) {
					Texts_WriteString(&TextFrames_W0, Texts_Writer__typ, (CHAR*)" not found", (LONGINT)11);
				} else if (res == 2) {
					Texts_WriteString(&TextFrames_W0, Texts_Writer__typ, (CHAR*)" not a valid object file", (LONGINT)25);
				} else if (res == 3) {
					Texts_WriteString(&TextFrames_W0, Texts_Writer__typ, (CHAR*)" imports ", (LONGINT)10);
					Texts_WriteString(&TextFrames_W0, Texts_Writer__typ, Modules_imported, 20);
					Texts_WriteString(&TextFrames_W0, Texts_Writer__typ, (CHAR*)" with bad key", (LONGINT)14);
				} else if (res == 4) {
					Texts_WriteString(&TextFrames_W0, Texts_Writer__typ, (CHAR*)" corrupted obj file", (LONGINT)20);
				} else if (res == 6) {
					Texts_WriteString(&TextFrames_W0, Texts_Writer__typ, (CHAR*)" has too many imports", (LONGINT)22);
				} else if (res == 7) {
					Texts_WriteString(&TextFrames_W0, Texts_Writer__typ, (CHAR*)" not enough space", (LONGINT)18);
				}
			} else if (res < 0) {
				i += 1;
				while (i < S.len) {
					Texts_Write(&TextFrames_W0, Texts_Writer__typ, S.s[__X(i, 256)]);
					i += 1;
				}
				Texts_WriteString(&TextFrames_W0, Texts_Writer__typ, (CHAR*)" not found", (LONGINT)11);
			}
			if (res != 0) {
				Texts_WriteLn(&TextFrames_W0, Texts_Writer__typ);
				Texts_Append(Oberon_Log, TextFrames_W0.buf);
			}
		}
	}
}

static void TextFrames_PickAttributes (Texts_Writer *W, LONGINT *W__typ, Texts_Text T, LONGINT pos)
{
	Texts_Reader R = {0};
	CHAR ch = 0;
	if (T->len > 0) {
		if (pos > 0) {
			Texts_OpenReader(&R, Texts_Reader__typ, T, pos - 1);
			Texts_Read(&R, Texts_Reader__typ, &ch);
		} else {
			Texts_OpenReader(&R, Texts_Reader__typ, T, 0);
			Texts_Read(&R, Texts_Reader__typ, &ch);
		}
		Texts_SetFont(&*W, W__typ, R.fnt);
		Texts_SetColor(&*W, W__typ, R.col);
		Texts_SetOffset(&*W, W__typ, R.voff);
	} else {
		Texts_SetFont(&*W, W__typ, Oberon_CurFnt);
		Texts_SetColor(&*W, W__typ, Oberon_CurCol);
		Texts_SetOffset(&*W, W__typ, Oberon_CurOff);
	}
}

static void TextFrames_ShiftBlock (TextFrames_Frame F, INTEGER delta)
{
	Texts_Text text = NIL;
	LONGINT pos = 0, beg = 0, end = 0, time = 0;
	TextFrames_SelectMsg select = {0};
	CHAR ch = 0, dummy = 0;
	Texts_Reader R = {0};
	Texts_Writer W = {0};
	Oberon_GetSelection(&text, &beg, &end, &time);
	if (time >= 0 && text == F->text) {
		TextFrames_BegOfLine(&R, Texts_Reader__typ, F->text, &beg, 0, &dummy);
		pos = beg;
		while (pos < end) {
			Texts_OpenReader(&R, Texts_Reader__typ, F->text, pos);
			Texts_Read(&R, Texts_Reader__typ, &ch);
			while ((R.elem != NIL && __ISP(R.elem, TextFrames_ParcDesc, 2)) && pos < end) {
				Texts_Read(&R, Texts_Reader__typ, &ch);
				pos += 1;
			}
			if (pos < end) {
				if (delta < 0) {
					if ((ch <= ' ' && ch != 0x0d) && ch != 0x1c) {
						Texts_Delete(F->text, pos, pos + 1);
						end -= 1;
					}
				} else {
					Texts_OpenWriter(&W, Texts_Writer__typ);
					TextFrames_PickAttributes(&W, Texts_Writer__typ, text, pos);
					if ((ch <= ' ' && ch != 0x0d) && ch != 0x1c) {
						Texts_Write(&W, Texts_Writer__typ, ch);
					} else {
						Texts_Write(&W, Texts_Writer__typ, 0x09);
					}
					Texts_Insert(F->text, pos, W.buf);
					end += 1;
					pos += 1;
				}
				Texts_OpenReader(&R, Texts_Reader__typ, F->text, pos);
				do {
					Texts_Read(&R, Texts_Reader__typ, &ch);
				} while (!(R.eot || ch == 0x0d));
				pos = Texts_Pos(&R, Texts_Reader__typ);
			}
		}
		select.text = F->text;
		select.beg = beg;
		select.end = pos;
		select.time = Oberon_Time();
		Viewers_Broadcast((void*)&select, TextFrames_SelectMsg__typ);
	}
}

static struct Write__78 {
	TextFrames_Frame *F;
	LONGINT *pos;
	CHAR (*buf)[32];
	struct Write__78 *lnk;
} *Write__78_s;

static void Flush__79 (void);
static void InsertBuffer__81 (void);
static BOOLEAN Visible__83 (CHAR ch);

static BOOLEAN Visible__83 (CHAR ch)
{
	LONGINT pat = 0;
	INTEGER dx = 0, x = 0, y = 0, w = 0, h = 0;
	Display_GetChar(TextFrames_W.fnt->raster, ch, &dx, &x, &y, &w, &h, &pat);
	return dx > 0;
}

static void InsertBuffer__81 (void)
{
	INTEGER i = 0, j = 0;
	CHAR ch = 0;
	i = 0;
	j = 0;
	ch = (*Write__78_s->buf)[__X(i, 32)];
	while (ch != 0x00) {
		if (((ch == 0x09 || ch == 0x0d) || ch == ' ') || Visible__83(ch)) {
			Texts_Write(&TextFrames_W, Texts_Writer__typ, ch);
			j += 1;
		}
		i += 1;
		ch = (*Write__78_s->buf)[__X(i, 32)];
	}
	if (j > 0) {
		Texts_Insert((*Write__78_s->F)->text, *Write__78_s->pos, TextFrames_W.buf);
		*Write__78_s->pos += (LONGINT)j;
	}
}

static void Flush__79 (void)
{
	CHAR ch = 0;
	while (Input_Available() > 0) {
		Input_Read(&ch);
	}
}

static void TextFrames_Write (TextFrames_Frame F, CHAR ch, Fonts_Font fnt, SHORTINT col, SHORTINT voff)
{
	TextFrames_Location loc = {0};
	TextFrames_Parc parc = NIL;
	LONGINT org = 0, pos = 0, pbeg = 0;
	INTEGER i = 0;
	CHAR buf[32];
	CHAR dummy = 0;
	Texts_Reader r = {0};
	Texts_CopyMsg copy = {0};
	Oberon_InputMsg input = {0};
	TextFrames_Parc p = NIL;
	LONGINT beg = 0;
	struct Write__78 _s;
	_s.F = &F;
	_s.pos = &pos;
	_s.buf = (void*)buf;
	_s.lnk = Write__78_s;
	Write__78_s = &_s;
	if (F->hasSel && ch == 0xc4) {
		TextFrames_ShiftBlock(F, -1);
	} else if (F->hasSel && ch == 0xc3) {
		TextFrames_ShiftBlock(F, 1);
	} else if (F->hasCar) {
		pos = F->carloc.pos;
		if (ch == 0x7f) {
			if (pos > F->org) {
				pos -= 1;
				Texts_Delete(F->text, pos, pos + 1);
				Flush__79();
			}
		} else if (ch == 0xa1) {
			if (pos < F->text->len) {
				Texts_Delete(F->text, pos, pos + 1);
				Flush__79();
			}
		} else if (ch == 0xc8) {
			pos = TextFrames_Pos(F, F->X, F->carloc.y);
		} else if (ch == 0xc7) {
			pos = TextFrames_Pos(F, (F->X + F->W) - 1, F->carloc.y);
		} else if (ch == 0xc4 && pos > 0) {
			pos -= 1;
		} else if (ch == 0xc3 && pos < F->text->len) {
			pos += 1;
		} else if (ch == 0xc1) {
			if (pos > 0) {
				org = TextFrames_Pos(F, F->carloc.x + 1, F->carloc.y + F->carloc.line->h);
				if (org == pos) {
					TextFrames_Show(F, F->org - 1);
				}
				pos = TextFrames_Pos(F, F->carloc.x + 1, F->carloc.y + F->carloc.line->h);
			}
		} else if (ch == 0xc2) {
			if (pos < F->text->len) {
				org = TextFrames_Pos(F, F->carloc.x + 1, F->carloc.y - F->carloc.line->next->h);
				if (org == pos && F->trailer->org + F->trailer->len != F->text->len) {
					TextFrames_Show(F, F->trailer->next->next->org);
				}
				TextFrames_LocatePos(F, pos, &loc, TextFrames_Location__typ);
				pos = TextFrames_Pos(F, F->carloc.x + 1, loc.y - loc.line->next->h);
			}
		} else if (ch == 0xc5) {
			TextFrames_LocateLine(F, (F->Y + F->H) - 1, &loc, TextFrames_Location__typ);
			i = (loc.y - F->Y) - F->bot;
			TextFrames_Back(F, i, &pos);
			TextFrames_Show(F, pos);
			pos = F->org;
		} else if (ch == 0xc6) {
			if (F->trailer->org + F->trailer->len == F->text->len) {
				pos = F->trailer->org;
			} else {
				TextFrames_LocateLine(F, F->Y, &loc, TextFrames_Location__typ);
				TextFrames_Show(F, loc.org);
				pos = F->org;
			}
		} else if (ch == 0xac || ch == 0xad) {
			TextFrames_ParcBefore(F->text, pos, &p, &beg);
			(*p->handle)((void*)p, (void*)&copy, Texts_CopyMsg__typ);
			parc = __GUARDP(copy.e, TextFrames_ParcDesc, 2);
			if (ch == 0xac) {
				parc->opts &= ~__SETOF(3);
			} else {
				parc->opts |= __SETOF(3);
			}
			TextFrames_PickAttributes(&TextFrames_W, Texts_Writer__typ, F->text, pos);
			Texts_WriteElem(&TextFrames_W, Texts_Writer__typ, (void*)parc);
			Texts_Insert(F->text, pos, TextFrames_W.buf);
			pos += 1;
		} else if (((ch == 0x09 || ch == 0x0a) || ch == 0x0d) || ch >= ' ') {
			TextFrames_PickAttributes(&TextFrames_W, Texts_Writer__typ, F->text, pos);
			if (ch == 0x0d) {
				buf[0] = 0x0d;
				i = 1;
				org = F->carloc.org;
				TextFrames_BegOfLine(&r, Texts_Reader__typ, F->text, &org, 0, &dummy);
				Texts_OpenReader(&r, Texts_Reader__typ, F->text, org);
				do {
					Texts_Read(&r, Texts_Reader__typ, &ch);
				} while (!(r.elem == NIL || !__ISP(r.elem, TextFrames_ParcDesc, 2)));
				while (((Texts_Pos(&r, Texts_Reader__typ) <= pos && ch <= ' ') && ch != 0x1c) && i < 31) {
					buf[__X(i, 32)] = ch;
					i += 1;
					Texts_Read(&r, Texts_Reader__typ, &ch);
				}
			} else if (ch == 0x0a) {
				buf[0] = 0x0d;
				i = 1;
			} else {
				buf[0] = ch;
				i = 1;
			}
			while (((Input_Available() > 0 && i < 31) && ch >= ' ') && ch < 0x7f) {
				Input_Read(&buf[__X(i, 32)]);
				i += 1;
			}
			buf[__X(i, 32)] = 0x00;
			InsertBuffer__81();
		}
		if (pos < F->org) {
			TextFrames_Show(F, F->org - 1);
		}
		TextFrames_SetCaret(F, pos);
		while (F->carloc.y < F->Y + F->bot) {
			TextFrames_Show(F, F->trailer->next->next->org);
			Flush__79();
			TextFrames_SetCaret(F, pos);
		}
	} else if (F->focus != NIL) {
		input.id = 0;
		input.ch = ch;
		input.fnt = fnt;
		input.col = col;
		input.voff = voff;
		(*F->focus->handle)(F->focus, (void*)&input, Oberon_InputMsg__typ);
	}
	Write__78_s = _s.lnk;
}

static void TextFrames_TouchElem (TextFrames_Frame F, INTEGER *x, INTEGER *y, SET *keysum)
{
	TextFrames_Location loc = {0};
	Texts_Elem e = NIL;
	LONGINT pbeg = 0;
	INTEGER y0 = 0;
	Texts_Reader R = {0};
	CHAR ch = 0;
	TextFrames_TrackMsg track = {0};
	TextFrames_Parc P = NIL;
	TextFrames_LocateChar(F, *x, *y, &loc, TextFrames_Location__typ);
	Texts_OpenReader(&R, Texts_Reader__typ, F->text, loc.pos);
	Texts_Read(&R, Texts_Reader__typ, &ch);
	e = R.elem;
	if (e != NIL && (LONGINT)loc.x + __DIV(e->W, (LONGINT)TextFrames_Unit) <= (LONGINT)((F->X + F->W) - F->right)) {
		TextFrames_ParcBefore(F->text, loc.pos, &P, &pbeg);
		y0 = ((loc.y + loc.line->dsr) - (int)__DIV(P->dsr, (LONGINT)TextFrames_Unit)) + loc.dy;
		if ((loc.x <= *x && (LONGINT)*x < (LONGINT)loc.x + __DIV(e->W, (LONGINT)TextFrames_Unit)) && *keysum == 0x02) {
			track.X = *x;
			track.Y = *y;
			track.keys = *keysum;
			track.fnt = R.fnt;
			track.col = R.col;
			track.pos = Texts_Pos(&R, Texts_Reader__typ) - 1;
			track.frame = (Display_Frame)F;
			track.X0 = loc.x;
			track.Y0 = y0;
			(*e->handle)(e, (void*)&track, TextFrames_TrackMsg__typ);
			*keysum = 0x0;
		}
	}
}

static void TextFrames_Edit (TextFrames_Frame F, INTEGER x, INTEGER y, SET keysum)
{
	Display_Frame ef = NIL;
	Texts_Text text = NIL;
	LONGINT beg = 0, end = 0, time = 0, pos = 0;
	SET keys = 0;
	CHAR ch = 0;
	TextFrames_Location loc = {0};
	INTEGER delta = 0, res = 0;
	Oberon_CopyOverMsg copyover = {0};
	Oberon_InputMsg input = {0};
	CHAR dummy = 0;
	Texts_Reader R = {0};
	TextFrames_Parc P = NIL;
	LONGINT x0 = 0, y0 = 0, pos0 = 0, pbeg = 0;
	if (x < F->X + F->barW) {
		pos = F->org;
		if (__IN(2, keysum)) {
			TextFrames_TrackLine(F, &x, &y, &pos, &keysum);
		} else if (__IN(0, keysum)) {
			TextFrames_TrackLine(F, &x, &y, &pos, &keysum);
			TextFrames_LocateLine(F, y, &loc, TextFrames_Location__typ);
			pos = F->org;
			delta = loc.y - (F->Y + F->bot);
			TextFrames_Back(F, delta, &pos);
		} else if (__IN(1, keysum)) {
			x0 = x;
			y0 = y;
			pos0 = F->org;
			do {
				TextFrames_TrackMouse(&x, &y, &keys, &keysum);
			} while (!((LONGINT)y != y0 || keys == 0x0));
			for (;;) {
				if (keysum == 0x06) {
					pos = F->text->len;
					TextFrames_Back(F, ((F->H - F->bot) - F->top) - 30, &pos);
				} else if (keysum == 0x03) {
					pos = 0;
				} else if (keysum == 0x07) {
					pos = pos0;
				} else if (F->Y <= y && y <= F->Y + F->H) {
					pos = TextFrames_CoordToPos(F, y - F->Y);
					TextFrames_BegOfLine(&R, Texts_Reader__typ, F->text, &pos, 1, &dummy);
				}
				TextFrames_ShowFrom(F, pos, &dummy, &P, &beg);
				if (keys == 0x0) {
					break;
				}
				TextFrames_TrackMouse(&x, &y, &keys, &keysum);
			}
		} else {
			TextFrames_DrawCursor(x, y);
			keysum = 0x07;
		}
		if (keysum != 0x07) {
			TextFrames_ParcBefore(F->text, pos, &P, &pbeg);
			TextFrames_ShowFrom(F, pos, &dummy, &P, &pbeg);
		}
	} else {
		ef = TextFrames_ThisSubFrame(F, x, y);
		if (ef != NIL) {
			if (F->focus != ef && keysum == 0x04) {
				do {
					TextFrames_TrackMouse(&x, &y, &keys, &keysum);
				} while (!(keys == 0x0));
				if (keysum == 0x04) {
					TextFrames_RemoveSelection(F);
					TextFrames_RemoveCaret(F);
					TextFrames_PassSubFocus(F, ef);
					return;
				}
			} else if (F->focus == ef) {
				input.id = 1;
				input.keys = keysum;
				input.X = x;
				input.Y = y;
				(*ef->handle)(ef, (void*)&input, Oberon_InputMsg__typ);
				return;
			}
		}
		if (keysum != 0x0) {
			TextFrames_TouchElem(F, &x, &y, &keysum);
			if (keysum == 0x0) {
				return;
			}
		}
		if (__IN(2, keysum)) {
			Oberon_PassFocus(Viewers_This(F->X, F->Y));
			TextFrames_TrackCaret(F, &x, &y, &keysum);
			if (keysum == 0x06 && F->hasCar) {
				Oberon_GetSelection(&text, &beg, &end, &time);
				if (time >= 0) {
					Texts_Save(text, beg, end, TextFrames_B);
					Texts_Insert(F->text, F->carloc.pos, TextFrames_B);
					TextFrames_SetCaret(F, F->carloc.pos + (end - beg));
				}
			} else if ((keysum == 0x05 && F->hasCar) && F->carloc.pos < F->text->len) {
				Oberon_GetSelection(&text, &beg, &end, &time);
				if (time >= 0) {
					Texts_OpenReader(&R, Texts_Reader__typ, F->text, F->carloc.pos);
					Texts_Read(&R, Texts_Reader__typ, &ch);
					Texts_ChangeLooks(text, beg, end, 0x07, R.fnt, R.col, R.voff);
				}
			}
		} else if (__IN(1, keysum)) {
			TextFrames_TrackWord(F, &x, &y, &pos, &keysum);
			if (keysum != 0x07) {
				if (__IN(0, keysum) && Modules_ThisMod((CHAR*)"Documents", (LONGINT)10) != NIL) {
					TextFrames_par->vwr = Viewers_This(F->X, F->Y);
					TextFrames_par->frame = (Display_Frame)F;
					TextFrames_par->text = F->text;
					TextFrames_par->pos = pos;
					Oberon_Call((CHAR*)"Documents.Open", (LONGINT)15, TextFrames_par, 0, &res);
				} else {
					TextFrames_Call(F, pos, keysum);
				}
			}
		} else if (__IN(0, keysum)) {
			TextFrames_TrackSelection(F, &x, &y, &keysum);
			if (keysum == 0x03 && F->hasSel) {
				copyover.text = F->text;
				copyover.beg = F->selbeg.pos;
				copyover.end = F->selend.pos;
				(*Oberon_FocusViewer->handle)((void*)Oberon_FocusViewer, (void*)&copyover, Oberon_CopyOverMsg__typ);
			} else if (keysum == 0x05 && F->hasSel) {
				Oberon_PassFocus(Viewers_This(F->X, F->Y));
				Texts_Delete(F->text, F->selbeg.pos, F->selend.pos);
				TextFrames_SetCaret(F, F->selbeg.pos);
			}
		} else {
			TextFrames_DrawCursor(x, y);
		}
	}
}

static void TextFrames_Copy (TextFrames_Frame SF, TextFrames_Frame DF)
{
	DF->handle = SF->handle;
	DF->text = SF->text;
	DF->org = SF->org;
	DF->col = SF->col;
	DF->left = SF->left;
	DF->right = SF->right;
	DF->top = SF->top;
	DF->bot = SF->bot;
	DF->barW = SF->barW;
	DF->hasCar = 0;
	DF->hasSel = 0;
	DF->showsParcs = SF->showsParcs;
	DF->focus = NIL;
	DF->trailer = NIL;
}

void TextFrames_Handle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ)
{
	TextFrames_Frame F = NIL, F1 = NIL;
	LONGINT pos = 0;
	CHAR dummy = 0;
	F = __GUARDP(f, TextFrames_FrameDesc, 1);
	if (__IS(msg__typ, Oberon_InputMsg, 1)) {
		if (__IS(msg__typ, Oberon_InputMsg, 1)) {
			Oberon_InputMsg *msg__ = (void*)msg;
			if ((*msg__).id == 0) {
				TextFrames_Write(F, (*msg__).ch, (*msg__).fnt, (*msg__).col, (*msg__).voff);
			} else if ((*msg__).id == 1) {
				TextFrames_Edit(F, (*msg__).X, (*msg__).Y, (*msg__).keys);
			}
		} else __WITHCHK;
	} else if (__IS(msg__typ, Oberon_ControlMsg, 1)) {
		if (__IS(msg__typ, Oberon_ControlMsg, 1)) {
			Oberon_ControlMsg *msg__ = (void*)msg;
			if ((*msg__).id == 0) {
				TextFrames_RemoveCaret(F);
			} else if ((*msg__).id == 1) {
				TextFrames_RemoveCaret(F);
				TextFrames_RemoveSelection(F);
				TextFrames_PassSubFocus(F, NIL);
				TextFrames_NotifySubFrames(F, (void*)&*msg__, msg__typ);
			} else {
				TextFrames_NotifySubFrames(F, (void*)&*msg__, msg__typ);
			}
		} else __WITHCHK;
	} else if (__IS(msg__typ, Oberon_CopyMsg, 1)) {
		if (__IS(msg__typ, Oberon_CopyMsg, 1)) {
			Oberon_CopyMsg *msg__ = (void*)msg;
			if ((*msg__).F == NIL) {
				__NEW(F1, TextFrames_FrameDesc);
				(*msg__).F = (Display_Frame)F1;
			}
			TextFrames_Copy(F, __GUARDP((*msg__).F, TextFrames_FrameDesc, 1));
		} else __WITHCHK;
	} else if (__IS(msg__typ, TextFrames_UpdateMsg, 1)) {
		TextFrames_NotifySubFrames(F, &*msg, msg__typ);
		if (__IS(msg__typ, TextFrames_UpdateMsg, 1)) {
			TextFrames_UpdateMsg *msg__ = (void*)msg;
			if ((*msg__).text == F->text) {
				TextFrames_Update(F, &*msg__, msg__typ);
			}
		} else __WITHCHK;
	} else if (__IS(msg__typ, TextFrames_InsertElemMsg, 1)) {
		if (F->hasCar) {
			pos = F->carloc.pos;
			TextFrames_PickAttributes(&TextFrames_W, Texts_Writer__typ, F->text, pos);
			Texts_WriteElem(&TextFrames_W, Texts_Writer__typ, __GUARDR(msg, TextFrames_InsertElemMsg, 1).e);
			Texts_Insert(F->text, pos, TextFrames_W.buf);
			TextFrames_SetCaret(F, pos + 1);
		} else if (F->focus != NIL) {
			(*F->focus->handle)(F->focus, &*msg, msg__typ);
		}
	} else if (__IS(msg__typ, Oberon_SelectionMsg, 1)) {
		TextFrames_NotifySubFrames(F, &*msg, msg__typ);
		if (__IS(msg__typ, Oberon_SelectionMsg, 1)) {
			Oberon_SelectionMsg *msg__ = (void*)msg;
			if (F->hasSel && F->time > (*msg__).time) {
				(*msg__).text = F->text;
				(*msg__).beg = F->selbeg.pos;
				(*msg__).end = F->selend.pos;
				(*msg__).time = F->time;
			}
		} else __WITHCHK;
	} else if (__IS(msg__typ, Oberon_CopyOverMsg, 1)) {
		TextFrames_NotifySubFrames(F, &*msg, msg__typ);
		if (__IS(msg__typ, Oberon_CopyOverMsg, 1)) {
			Oberon_CopyOverMsg *msg__ = (void*)msg;
			if (F->hasCar) {
				Texts_Save((*msg__).text, (*msg__).beg, (*msg__).end, TextFrames_B);
				Texts_Insert(F->text, F->carloc.pos, TextFrames_B);
				TextFrames_SetCaret(F, F->carloc.pos + ((*msg__).end - (*msg__).beg));
			}
		} else __WITHCHK;
	} else if (__IS(msg__typ, MenuViewers_ModifyMsg, 1)) {
		if (__IS(msg__typ, MenuViewers_ModifyMsg, 1)) {
			MenuViewers_ModifyMsg *msg__ = (void*)msg;
			(*F->handle)((void*)F, (void*)&TextFrames_neutralize, Oberon_ControlMsg__typ);
			TextFrames_Resize(F, F->X, (*msg__).Y, F->W, (*msg__).H, &dummy);
		} else __WITHCHK;
	} else if (__IS(msg__typ, TextFrames_SelectMsg, 1)) {
		TextFrames_NotifySubFrames(F, &*msg, msg__typ);
		if (__IS(msg__typ, TextFrames_SelectMsg, 1)) {
			TextFrames_SelectMsg *msg__ = (void*)msg;
			if ((*msg__).text == F->text && !F->hasSel) {
				Oberon_RemoveMarks(F->X, F->Y, F->W, F->H);
				(*F->handle)((void*)F, (void*)&TextFrames_neutralize, Oberon_ControlMsg__typ);
				TextFrames_SetSelection(F, (*msg__).beg, (*msg__).end);
				F->time = (*msg__).time;
				if (F->hasSel) {
					F->selbeg.pos = (*msg__).beg;
					F->selend.pos = (*msg__).end;
				}
			}
		} else __WITHCHK;
	} else {
		TextFrames_NotifySubFrames(F, &*msg, msg__typ);
	}
}

void TextFrames_Open (TextFrames_Frame F, Texts_Text T, LONGINT pos)
{
	F->handle = TextFrames_Handle;
	F->text = T;
	F->org = pos;
	F->col = 0;
	F->left = TextFrames_left;
	F->right = TextFrames_right;
	F->top = TextFrames_top;
	F->bot = TextFrames_bot;
	F->barW = TextFrames_barW;
	F->hasCar = 0;
	F->hasSel = 0;
	F->showsParcs = 0;
	F->trailer = NIL;
}

void TextFrames_NotifyDisplay (Texts_Text T, INTEGER op, LONGINT beg, LONGINT end)
{
	TextFrames_UpdateMsg msg = {0};
	msg.text = T;
	msg.id = op;
	msg.beg = beg;
	msg.end = end;
	Viewers_Broadcast((void*)&msg, TextFrames_UpdateMsg__typ);
}

Texts_Text TextFrames_Text (CHAR *name, LONGINT name__len)
{
	Texts_Text text = NIL;
	__DUP(name, name__len, CHAR);
	__NEW(text, Texts_TextDesc);
	Texts_Open(text, name, name__len);
	text->notify = TextFrames_NotifyDisplay;
	__DEL(name);
	return text;
}

TextFrames_Frame TextFrames_NewText (Texts_Text T, LONGINT pos)
{
	TextFrames_Frame frame = NIL;
	__NEW(frame, TextFrames_FrameDesc);
	TextFrames_Open(frame, T, pos);
	return frame;
}

TextFrames_Frame TextFrames_NewMenu (CHAR *name, LONGINT name__len, CHAR *commands, LONGINT commands__len)
{
	Texts_Text T = NIL, T1 = NIL;
	Texts_Buffer buf = NIL;
	TextFrames_Frame frame = NIL;
	CHAR fn[256];
	INTEGER i = 0;
	__DUP(name, name__len, CHAR);
	__DUP(commands, commands__len, CHAR);
	T = TextFrames_Text((CHAR*)"", (LONGINT)1);
	Texts_WriteString(&TextFrames_W0, Texts_Writer__typ, name, name__len);
	Texts_WriteString(&TextFrames_W0, Texts_Writer__typ, (CHAR*)" | ", (LONGINT)4);
	Texts_Append(T, TextFrames_W0.buf);
	if (commands[0] == '^') {
		i = 0;
		do {
			i += 1;
			fn[__X(i - 1, 256)] = commands[__X(i, commands__len)];
		} while (!(commands[__X(i, commands__len)] <= ' '));
		fn[__X(i - 1, 256)] = 0x00;
		if (Files_Old(fn, 256) == NIL) {
			Texts_WriteString(&TextFrames_W0, Texts_Writer__typ, (CHAR*)"System.Close  System.Grow  System.Copy Edit.Store ", (LONGINT)51);
			Texts_Append(T, TextFrames_W0.buf);
		} else {
			__NEW(T1, Texts_TextDesc);
			Texts_Open(T1, fn, 256);
			__NEW(buf, Texts_BufDesc);
			Texts_OpenBuf(buf);
			Texts_Save(T1, 0, T1->len, buf);
			Texts_Append(T, buf);
		}
	} else {
		Texts_WriteString(&TextFrames_W0, Texts_Writer__typ, commands, commands__len);
		Texts_Append(T, TextFrames_W0.buf);
	}
	__NEW(frame, TextFrames_FrameDesc);
	TextFrames_Open(frame, T, 0);
	frame->col = 15;
	frame->left = 6;
	frame->top = 0;
	frame->bot = 0;
	frame->barW = 0;
	__DEL(name);
	__DEL(commands);
	return frame;
}

static void EnumPtrs(void (*P)(void*))
{
	P(TextFrames_defParc);
	P(TextFrames_par);
	P(TextFrames_B);
	__ENUMR(&TextFrames_W, Texts_Writer__typ, 36, 1, P);
	__ENUMR(&TextFrames_W0, Texts_Writer__typ, 36, 1, P);
}

__TDESC(TextFrames_ParcDesc, 1, 4) = {__TDFLDS("ParcDesc", 196), {0, 4, 12, 32, -20}};
__TDESC(TextFrames_Location, 1, 1) = {__TDFLDS("Location", 20), {16, -8}};
__TDESC(TextFrames_TextLineDesc, 1, 2) = {__TDFLDS("TextLineDesc", 44), {0, 36, -12}};
__TDESC(TextFrames_FrameDesc, 1, 8) = {__TDFLDS("FrameDesc", 120), {0, 4, 20, 68, 88, 108, 112, 116, -36}};
__TDESC(TextFrames_DisplayMsg, 1, 3) = {__TDFLDS("DisplayMsg", 32), {4, 16, 28, -16}};
__TDESC(TextFrames_TrackMsg, 1, 2) = {__TDFLDS("TrackMsg", 28), {8, 20, -12}};
__TDESC(TextFrames_FocusMsg, 1, 2) = {__TDFLDS("FocusMsg", 12), {4, 8, -12}};
__TDESC(TextFrames_NotifyMsg, 1, 1) = {__TDFLDS("NotifyMsg", 4), {0, -8}};
__TDESC(TextFrames_UpdateMsg, 1, 1) = {__TDFLDS("UpdateMsg", 16), {4, -8}};
__TDESC(TextFrames_InsertElemMsg, 1, 1) = {__TDFLDS("InsertElemMsg", 4), {0, -8}};
__TDESC(TextFrames_SelectMsg, 1, 1) = {__TDFLDS("SelectMsg", 16), {0, -8}};

export void *TextFrames__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(Fonts);
	__IMPORT(Input);
	__IMPORT(MenuViewers);
	__IMPORT(Modules);
	__IMPORT(Oberon);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(TextFrames, EnumPtrs);
	__INITYP(TextFrames_ParcDesc, Texts_ElemDesc, 2);
	__INITYP(TextFrames_Location, TextFrames_Location, 0);
	__INITYP(TextFrames_TextLineDesc, TextFrames_TextLineDesc, 0);
	__INITYP(TextFrames_FrameDesc, Display_FrameDesc, 1);
	__INITYP(TextFrames_DisplayMsg, Texts_ElemMsg, 1);
	__INITYP(TextFrames_TrackMsg, Texts_ElemMsg, 1);
	__INITYP(TextFrames_FocusMsg, Texts_ElemMsg, 1);
	__INITYP(TextFrames_NotifyMsg, Display_FrameMsg, 1);
	__INITYP(TextFrames_UpdateMsg, Display_FrameMsg, 1);
	__INITYP(TextFrames_InsertElemMsg, Display_FrameMsg, 1);
	__INITYP(TextFrames_SelectMsg, Display_FrameMsg, 1);
/* BEGIN */
	TextFrames_Unit = Fonts_Unit;
	Texts_OpenWriter(&TextFrames_W, Texts_Writer__typ);
	Texts_OpenWriter(&TextFrames_W0, Texts_Writer__typ);
	Texts_SetFont(&TextFrames_W0, Texts_Writer__typ, Fonts_Default);
	Texts_SetColor(&TextFrames_W0, Texts_Writer__typ, 15);
	Texts_SetOffset(&TextFrames_W0, Texts_Writer__typ, 0);
	TextFrames_neutralize.id = 1;
	__NEW(TextFrames_par, Oberon_ParRec);
	__NEW(TextFrames_B, Texts_BufDesc);
	Texts_OpenBuf(TextFrames_B);
	TextFrames_menuH = Fonts_Default->height + 2;
	TextFrames_barW = (int)__DIV(144000, (LONGINT)TextFrames_Unit);
	TextFrames_left = TextFrames_barW + 6;
	TextFrames_right = 8;
	TextFrames_top = 6;
	TextFrames_bot = 6;
	Oberon_Log = TextFrames_Text((CHAR*)"", (LONGINT)1);
	TextFrames_InitDefParc();
	__ENDMOD;
}
