/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Files.h"
#include "FoldElems.h"
#include "In.h"
#include "Input.h"
#include "Oberon.h"
#include "Out.h"
#include "PopupElems.h"
#include "TextFrames.h"
#include "TextPrinter.h"
#include "Texts.h"
#include "Viewers.h"

typedef
	void (*VersionElems_ActionProc)(Texts_Text, CHAR*, LONGINT );

typedef
	struct VersionElems_BegDesc *VersionElems_Beg;

typedef
	struct VersionElems_BegDesc { /* PopupElems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		CHAR name[32];
		Texts_Text menu;
		BOOLEAN small;
		INTEGER n, default_;
		char _prvt2[4];
		SET options;
		CHAR cur[32];
		CHAR vers[4][32];
		Texts_Buffer buf[4];
	} VersionElems_BegDesc;

static void VersionElems_Beg_CheckMenu (VersionElems_Beg e);
static INTEGER VersionElems_Beg_IndexOf (VersionElems_Beg e, CHAR *version, LONGINT version__len);
static void VersionElems_Beg_SwitchTo (VersionElems_Beg e, CHAR *version, LONGINT version__len);
static LONGINT VersionElems_Beg_TwinPos (VersionElems_Beg e);
#define __VersionElems_Beg_CheckMenu(e) __SEND(__TYPEOF(e), 0, void(*)(VersionElems_Beg), (e))
#define __VersionElems_Beg_IndexOf(e, version, version__len) __SEND(__TYPEOF(e), 1, INTEGER(*)(VersionElems_Beg, CHAR*, LONGINT ), (e, version, version__len))
#define __VersionElems_Beg_SwitchTo(e, version, version__len) __SEND(__TYPEOF(e), 2, void(*)(VersionElems_Beg, CHAR*, LONGINT ), (e, version, version__len))
#define __VersionElems_Beg_TwinPos(e) __SEND(__TYPEOF(e), 3, LONGINT(*)(VersionElems_Beg), (e))

typedef
	struct VersionElems_EndDesc *VersionElems_End;

typedef
	struct VersionElems_EndDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
	} VersionElems_EndDesc;


static LONGINT VersionElems_begIcon, VersionElems_endIcon;
static Texts_Text VersionElems_scratch;
static CHAR VersionElems_curFileName[128];
static Texts_Writer VersionElems_w;

export LONGINT *VersionElems_BegDesc__typ;
export LONGINT *VersionElems_EndDesc__typ;

export void VersionElems_AllocBeg (void);
export void VersionElems_AllocEnd (void);
static void VersionElems_Del (Texts_Text t, CHAR *version, LONGINT version__len);
export void VersionElems_Delete (void);
static void VersionElems_Do (VersionElems_ActionProc P);
export void VersionElems_HandleBeg (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ);
export void VersionElems_HandleEnd (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ);
static void VersionElems_InitIcons (void);
export void VersionElems_Insert (void);
static void VersionElems_NoNotify (Texts_Text t, INTEGER op, LONGINT beg, LONGINT end);
static void VersionElems_Read (CHAR *s, LONGINT s__len);
static void VersionElems_ReadLine (Texts_Reader *r, LONGINT *r__typ, CHAR *line, LONGINT line__len);
export void VersionElems_Set (void);
export void VersionElems_SwitchAll (Texts_Text t, CHAR *version, LONGINT version__len);


static void VersionElems_InitIcons (void)
{
	SET line[10];
	line[1] = 0x10;
	line[2] = 0x08;
	line[3] = 0x04;
	line[4] = 0x02;
	line[5] = 0x01;
	line[6] = 0x02;
	line[7] = 0x04;
	line[8] = 0x08;
	line[9] = 0x10;
	VersionElems_begIcon = Display_NewPattern((void*)line, 10, 6, 9);
	line[1] = 0x02;
	line[2] = 0x04;
	line[3] = 0x08;
	line[4] = 0x10;
	line[5] = 0x20;
	line[6] = 0x10;
	line[7] = 0x08;
	line[8] = 0x04;
	line[9] = 0x02;
	VersionElems_endIcon = Display_NewPattern((void*)line, 10, 6, 9);
}

static void VersionElems_NoNotify (Texts_Text t, INTEGER op, LONGINT beg, LONGINT end)
{
}

static void VersionElems_Read (CHAR *s, LONGINT s__len)
{
	CHAR ch = 0;
	if (In_Next() == 1) {
		In_Name((void*)s, s__len);
	} else {
		In_String((void*)s, s__len);
	}
}

static void VersionElems_ReadLine (Texts_Reader *r, LONGINT *r__typ, CHAR *line, LONGINT line__len)
{
	INTEGER i = 0;
	CHAR ch = 0;
	i = 0;
	do {
		Texts_Read(&*r, r__typ, &ch);
		line[__X(i, line__len)] = ch;
		i += 1;
	} while (!((*r).eot || ch == 0x0d));
	line[__X(i - 1, line__len)] = 0x00;
}

static INTEGER VersionElems_Beg_IndexOf (VersionElems_Beg e, CHAR *version, LONGINT version__len)
{
	INTEGER i = 0;
	__DUP(version, version__len, CHAR);
	i = 0;
	while (i < 4 && e->vers[__X(i, 4)][0] != 0x00) {
		if (__STRCMP(e->vers[__X(i, 4)], version) == 0) {
			__DEL(version);
			return i;
		}
		i += 1;
	}
	__DEL(version);
	return -1;
}

static void VersionElems_Beg_CheckMenu (VersionElems_Beg e)
{
	Texts_Reader r = {0};
	CHAR vers[4][32];
	Texts_Buffer buf[4];
	INTEGER i = 0, j = 0;
	CHAR version[32];
	INTEGER _for__2 = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, e->menu, 0);
	i = 0;
	do {
		VersionElems_ReadLine(&r, Texts_Reader__typ, (void*)version, 32);
		if (i < 4 && version[0] != 0x00) {
			__COPY(version, vers[__X(i, 4)], 32);
			j = __VersionElems_Beg_IndexOf(e, version, 32);
			if (j >= 0) {
				buf[__X(i, 4)] = e->buf[__X(j, 4)];
			} else {
				__NEW(buf[__X(i, 4)], Texts_BufDesc);
				Texts_OpenBuf(buf[__X(i, 4)]);
			}
			i += 1;
		}
	} while (!r.eot);
	_for__2 = i - 1;
	j = 0;
	while (j <= _for__2) {
		__COPY(vers[__X(j, 4)], e->vers[__X(j, 4)], 32);
		e->buf[__X(j, 4)] = buf[__X(j, 4)];
		j += 1;
	}
	while (i < 4) {
		e->vers[__X(i, 4)][0] = 0x00;
		e->buf[__X(i, 4)] = NIL;
		i += 1;
	}
}

static LONGINT VersionElems_Beg_TwinPos (VersionElems_Beg e)
{
	Texts_Reader r = {0};
	INTEGER level = 0;
	Texts_OpenReader(&r, Texts_Reader__typ, Texts_ElemBase((void*)e), Texts_ElemPos((void*)e) + 1);
	level = 1;
	for (;;) {
		Texts_ReadElem(&r, Texts_Reader__typ);
		if (r.eot) {
			return -1;
		} else if (__ISP(r.elem, VersionElems_BegDesc, 3)) {
			level += 1;
		} else if (__ISP(r.elem, VersionElems_EndDesc, 2)) {
			level -= 1;
			if (level == 0) {
				return Texts_Pos(&r, Texts_Reader__typ) - 1;
			}
		}
	}
	__RETCHK;
}

static struct SwitchTo__4 {
	struct SwitchTo__4 *lnk;
} *SwitchTo__4_s;

static INTEGER NewVersion__5 (VersionElems_Beg e, CHAR *s, LONGINT s__len);

static INTEGER NewVersion__5 (VersionElems_Beg e, CHAR *s, LONGINT s__len)
{
	Texts_Reader r = {0};
	CHAR ch = 0;
	LONGINT pos = 0;
	INTEGER i = 0;
	__DUP(s, s__len, CHAR);
	Texts_WriteLn(&VersionElems_w, Texts_Writer__typ);
	Texts_WriteString(&VersionElems_w, Texts_Writer__typ, s, s__len);
	pos = e->menu->len - 1;
	Texts_OpenReader(&r, Texts_Reader__typ, e->menu, pos);
	Texts_Read(&r, Texts_Reader__typ, &ch);
	if (ch != 0x0d) {
		pos += 1;
	}
	Texts_Insert(e->menu, pos, VersionElems_w.buf);
	PopupElems_MeasureMenu((void*)e);
	i = 0;
	while (i < 4 && e->vers[__X(i, 4)][0] != 0x00) {
		i += 1;
	}
	if (i < 4) {
		__COPY(s, e->vers[__X(i, 4)], 32);
		__NEW(e->buf[__X(i, 4)], Texts_BufDesc);
		Texts_OpenBuf(e->buf[__X(i, 4)]);
	} else {
		i = -1;
	}
	__DEL(s);
	return i;
}

static void VersionElems_Beg_SwitchTo (VersionElems_Beg e, CHAR *version, LONGINT version__len)
{
	Texts_Text t = NIL;
	LONGINT beg = 0, end = 0;
	INTEGER i = 0, j = 0;
	struct SwitchTo__4 _s;
	__DUP(version, version__len, CHAR);
	_s.lnk = SwitchTo__4_s;
	SwitchTo__4_s = &_s;
	__VersionElems_Beg_CheckMenu(e);
	if (__STRCMP(version, e->cur) != 0) {
		i = __VersionElems_Beg_IndexOf(e, version, version__len);
		if (i < 0) {
			i = NewVersion__5(e, version, version__len);
		}
		j = __VersionElems_Beg_IndexOf(e, e->cur, 32);
		if (i >= 0) {
			t = Texts_ElemBase((void*)e);
			beg = Texts_ElemPos((void*)e) + 1;
			end = __VersionElems_Beg_TwinPos(e);
			if (end >= 0) {
				Texts_Delete(t, beg, end);
				Texts_Insert(t, beg, e->buf[__X(i, 4)]);
				if (j >= 0) {
					Texts_Recall(&e->buf[__X(j, 4)]);
				}
				__COPY(version, e->cur, 32);
			}
		} else {
			Out_F((CHAR*)"-- more than max. no. of versions at pos #$", (LONGINT)44, Texts_ElemPos((void*)e));
		}
	}
	SwitchTo__4_s = _s.lnk;
	__DEL(version);
}

static void VersionElems_Do (VersionElems_ActionProc P)
{
	CHAR version[32], s[32];
	CHAR ch = 0;
	Texts_Text t = NIL;
	Viewers_Viewer v = NIL;
	In_Open();
	VersionElems_Read((void*)version, 32);
	if (!In_Done) {
		Out_String((CHAR*)"-- argument syntax:  version [\'IN\' file {file}]", (LONGINT)48);
		Out_Ln();
		return;
	}
	In_Name((void*)s, 32);
	if (__STRCMP(s, "IN") == 0) {
		VersionElems_Read((void*)VersionElems_curFileName, 128);
		while (In_Done) {
			t = TextFrames_Text(VersionElems_curFileName, 128);
			if (t->len == 0) {
				Out_String((CHAR*)"-- file ", (LONGINT)9);
				Out_String(VersionElems_curFileName, 128);
				Out_String((CHAR*)" not found", (LONGINT)11);
				Out_Ln();
				return;
			}
			(*P)(t, version, 32);
			Texts_Close(t, VersionElems_curFileName, 128);
			VersionElems_Read((void*)VersionElems_curFileName, 128);
		}
	} else {
		__MOVE("*", VersionElems_curFileName, 2);
		v = Oberon_MarkedViewer();
		t = __GUARDP(v->dsc->next, TextFrames_FrameDesc, 1)->text;
		(*P)(t, version, 32);
	}
}

static struct Del__10 {
	struct Del__10 *lnk;
} *Del__10_s;

static void ReadEntry__11 (Texts_Reader *r, LONGINT *r__typ, CHAR *s, LONGINT s__len, LONGINT *beg, LONGINT *end);

static void ReadEntry__11 (Texts_Reader *r, LONGINT *r__typ, CHAR *s, LONGINT s__len, LONGINT *beg, LONGINT *end)
{
	CHAR ch = 0;
	INTEGER i = 0;
	*beg = Texts_Pos(&*r, r__typ);
	i = 0;
	do {
		Texts_Read(&*r, r__typ, &ch);
		s[__X(i, s__len)] = ch;
		i += 1;
	} while (!((*r).eot || ch == 0x0d));
	*end = Texts_Pos(&*r, r__typ);
	s[__X(i - 1, s__len)] = 0x00;
}

static void VersionElems_Del (Texts_Text t, CHAR *version, LONGINT version__len)
{
	Texts_Reader r = {0}, r1 = {0};
	VersionElems_Beg e = NIL;
	INTEGER i = 0;
	CHAR s[32];
	LONGINT beg = 0, end = 0;
	struct Del__10 _s;
	__DUP(version, version__len, CHAR);
	_s.lnk = Del__10_s;
	Del__10_s = &_s;
	Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
	Texts_ReadElem(&r, Texts_Reader__typ);
	while (!r.eot) {
		if (__ISP(r.elem, VersionElems_BegDesc, 3)) {
			e = __GUARDP(r.elem, VersionElems_BegDesc, 3);
			if (__STRCMP(e->cur, version) == 0) {
				Out_String((CHAR*)"-- cannot delete the current version ", (LONGINT)38);
				Out_String(version, version__len);
				Out_String((CHAR*)" in file ", (LONGINT)10);
				Out_String(VersionElems_curFileName, 128);
				Out_Ln();
				Del__10_s = _s.lnk;
				__DEL(version);
				return;
			}
			i = __VersionElems_Beg_IndexOf(e, version, version__len);
			if (i < 0) {
				Out_F((CHAR*)"-- pos # in ", (LONGINT)13, Texts_ElemPos((void*)e));
				Out_String(VersionElems_curFileName, 128);
				Out_String((CHAR*)": not allowed to delete the current version", (LONGINT)44);
				Out_Ln();
			} else {
				i = i;
				while (i <= 2) {
					__COPY(e->vers[__X(i + 1, 4)], e->vers[__X(i, 4)], 32);
					e->buf[__X(i, 4)] = e->buf[__X(i + 1, 4)];
					i += 1;
				}
				e->vers[3][0] = 0x00;
				e->buf[3] = NIL;
				Texts_OpenReader(&r1, Texts_Reader__typ, e->menu, 0);
				do {
					ReadEntry__11(&r1, Texts_Reader__typ, (void*)s, 32, &beg, &end);
				} while (!(s[0] == 0x00 || __STRCMP(s, version) == 0));
				if (__STRCMP(s, version) == 0) {
					Texts_Delete(e->menu, beg, end);
					PopupElems_MeasureMenu((void*)e);
				}
			}
		}
		Texts_ReadElem(&r, Texts_Reader__typ);
	}
	Del__10_s = _s.lnk;
	__DEL(version);
}

void VersionElems_SwitchAll (Texts_Text t, CHAR *version, LONGINT version__len)
{
	Texts_Reader r = {0};
	LONGINT pos = 0;
	VersionElems_Beg e = NIL;
	FoldElems_Elem fe = NIL;
	Texts_Text t1 = NIL;
	__DUP(version, version__len, CHAR);
	Texts_OpenReader(&r, Texts_Reader__typ, t, 0);
	for (;;) {
		Texts_ReadElem(&r, Texts_Reader__typ);
		if (r.eot) {
			break;
		} else if (__ISP(r.elem, VersionElems_BegDesc, 3)) {
			pos = Texts_Pos(&r, Texts_Reader__typ) + 1;
			e = __GUARDP(r.elem, VersionElems_BegDesc, 3);
			__VersionElems_Beg_SwitchTo(e, version, version__len);
			Texts_OpenReader(&r, Texts_Reader__typ, t, pos);
		} else if (__ISP(r.elem, FoldElems_ElemDesc, 2)) {
			fe = __GUARDP(r.elem, FoldElems_ElemDesc, 2);
			if (fe->mode == 0) {
				__NEW(t1, Texts_TextDesc);
				Texts_Open(t1, (CHAR*)"", (LONGINT)1);
				t1->notify = VersionElems_NoNotify;
				Texts_Append(t1, fe->hidden);
				VersionElems_SwitchAll(t1, version, version__len);
				Texts_Delete(t1, 0, t1->len);
				Texts_Recall(&fe->hidden);
			}
		}
	}
	__DEL(version);
}

void VersionElems_HandleBeg (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ)
{
	VersionElems_Beg e1 = NIL;
	INTEGER i = 0;
	CHAR version[32];
	Texts_Reader r = {0};
	if (__ISP(e, VersionElems_BegDesc, 3)) {
		if (__IS(m__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *m__ = (void*)m;
			(*(VersionElems_Beg*)&e)->W = 70000;
			if (!(*m__).prepare) {
				Display_CopyPattern(15, VersionElems_begIcon, (*m__).X0, (*m__).Y0 + 3, 1);
			}
		} else if (__IS(m__typ, TextPrinter_PrintMsg, 1)) {
			TextPrinter_PrintMsg *m__ = (void*)m;
			if ((*m__).prepare) {
				(*(VersionElems_Beg*)&e)->W = 1;
			} else {
				(*(VersionElems_Beg*)&e)->W = 70000;
			}
		} else if (__IS(m__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *m__ = (void*)m;
			if ((*m__).e == NIL) {
				__NEW(e1, VersionElems_BegDesc);
				(*m__).e = (Texts_Elem)e1;
			} else {
				e1 = __GUARDP((*m__).e, VersionElems_BegDesc, 3);
			}
			__COPY((*(VersionElems_Beg*)&e)->cur, e1->cur, 32);
			i = 0;
			while (i < 4 && (*(VersionElems_Beg*)&e)->vers[__X(i, 4)][0] != 0x00) {
				__COPY((*(VersionElems_Beg*)&e)->vers[__X(i, 4)], e1->vers[__X(i, 4)], 32);
				__NEW(e1->buf[__X(i, 4)], Texts_BufDesc);
				Texts_OpenBuf(e1->buf[__X(i, 4)]);
				Texts_Copy((*(VersionElems_Beg*)&e)->buf[__X(i, 4)], e1->buf[__X(i, 4)]);
				i += 1;
			}
			PopupElems_Handle((void*)(*(VersionElems_Beg*)&e), (void*)&*m__, m__typ);
		} else if (__IS(m__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *m__ = (void*)m;
			__MOVE("VersionElems", (*m__).mod, 13);
			__MOVE("AllocBeg", (*m__).proc, 9);
		} else if (__IS(m__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *m__ = (void*)m;
			if ((*m__).keys == 0x02) {
				__VersionElems_Beg_CheckMenu((*(VersionElems_Beg*)&e));
				i = 3;
				while (i >= 0 && __STRCMP((*(VersionElems_Beg*)&e)->vers[__X(i, 4)], (*(VersionElems_Beg*)&e)->cur) != 0) {
					i -= 1;
				}
				(*(VersionElems_Beg*)&e)->default_ = i;
			}
			PopupElems_Handle((void*)(*(VersionElems_Beg*)&e), (void*)&*m__, m__typ);
		} else if (__IS(m__typ, Texts_FileMsg, 1)) {
			Texts_FileMsg *m__ = (void*)m;
			PopupElems_Handle((void*)(*(VersionElems_Beg*)&e), (void*)&*m__, m__typ);
			if ((*m__).id == 0) {
				Files_ReadString(&(*m__).r, Files_Rider__typ, (void*)(*(VersionElems_Beg*)&e)->cur, 32);
				Files_ReadString(&(*m__).r, Files_Rider__typ, (void*)version, 32);
				i = 0;
				while (version[0] != 0x00) {
					__COPY(version, (*(VersionElems_Beg*)&e)->vers[__X(i, 4)], 32);
					Texts_Load(&(*m__).r, Files_Rider__typ, VersionElems_scratch);
					Texts_Delete(VersionElems_scratch, 0, VersionElems_scratch->len);
					__NEW((*(VersionElems_Beg*)&e)->buf[__X(i, 4)], Texts_BufDesc);
					Texts_Recall(&(*(VersionElems_Beg*)&e)->buf[__X(i, 4)]);
					i += 1;
					Files_ReadString(&(*m__).r, Files_Rider__typ, (void*)version, 32);
				}
				if (i < 4) {
					(*(VersionElems_Beg*)&e)->vers[__X(i, 4)][0] = 0x00;
				}
			} else {
				Files_WriteString(&(*m__).r, Files_Rider__typ, (*(VersionElems_Beg*)&e)->cur, 32);
				i = 0;
				while (i < 4 && (*(VersionElems_Beg*)&e)->vers[__X(i, 4)][0] != 0x00) {
					Files_WriteString(&(*m__).r, Files_Rider__typ, (*(VersionElems_Beg*)&e)->vers[__X(i, 4)], 32);
					Texts_Append(VersionElems_scratch, (*(VersionElems_Beg*)&e)->buf[__X(i, 4)]);
					Texts_Store(&(*m__).r, Files_Rider__typ, VersionElems_scratch);
					Texts_Delete(VersionElems_scratch, 0, VersionElems_scratch->len);
					Texts_Recall(&(*(VersionElems_Beg*)&e)->buf[__X(i, 4)]);
					i += 1;
				}
				Files_WriteString(&(*m__).r, Files_Rider__typ, (CHAR*)"", (LONGINT)1);
			}
		} else if (__IS(m__typ, PopupElems_ExecMsg, 1)) {
			PopupElems_ExecMsg *m__ = (void*)m;
			Texts_OpenReader(&r, Texts_Reader__typ, (*(VersionElems_Beg*)&e)->menu, (*m__).pos);
			VersionElems_ReadLine(&r, Texts_Reader__typ, (void*)version, 32);
			if (version[0] != 0x00) {
				VersionElems_SwitchAll(Texts_ElemBase((void*)(*(VersionElems_Beg*)&e)), version, 32);
			}
		} else {
			PopupElems_Handle((void*)(*(VersionElems_Beg*)&e), &*m, m__typ);
		}
	} else __WITHCHK;
}

void VersionElems_HandleEnd (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ)
{
	VersionElems_End e1 = NIL;
	SET keys = 0;
	INTEGER x = 0, y = 0;
	if (__ISP(e, VersionElems_EndDesc, 2)) {
		if (__IS(m__typ, TextFrames_DisplayMsg, 1)) {
			TextFrames_DisplayMsg *m__ = (void*)m;
			(*(VersionElems_End*)&e)->W = 70000;
			if (!(*m__).prepare) {
				Display_CopyPattern(15, VersionElems_endIcon, (*m__).X0, (*m__).Y0 + 3, 1);
			}
		} else if (__IS(m__typ, TextPrinter_PrintMsg, 1)) {
			TextPrinter_PrintMsg *m__ = (void*)m;
			(*(VersionElems_End*)&e)->W = 1;
		} else if (__IS(m__typ, Texts_CopyMsg, 1)) {
			Texts_CopyMsg *m__ = (void*)m;
			if ((*m__).e == NIL) {
				__NEW(e1, VersionElems_EndDesc);
				(*m__).e = (Texts_Elem)e1;
			} else {
				e1 = __GUARDP((*m__).e, VersionElems_EndDesc, 2);
			}
			Texts_CopyElem((void*)(*(VersionElems_End*)&e), (void*)e1);
		} else if (__IS(m__typ, Texts_IdentifyMsg, 1)) {
			Texts_IdentifyMsg *m__ = (void*)m;
			__MOVE("VersionElems", (*m__).mod, 13);
			__MOVE("AllocEnd", (*m__).proc, 9);
		} else if (__IS(m__typ, TextFrames_TrackMsg, 1)) {
			TextFrames_TrackMsg *m__ = (void*)m;
			if ((*m__).keys == 0x02) {
				do {
					Input_Mouse(&keys, &x, &y);
					Oberon_DrawCursor(&Oberon_Mouse, Oberon_Cursor__typ, &Oberon_Arrow, Oberon_Marker__typ, x, y);
				} while (!(keys == 0x0));
			}
		}
	} else __WITHCHK;
}

void VersionElems_AllocBeg (void)
{
	VersionElems_Beg e = NIL;
	__NEW(e, VersionElems_BegDesc);
	e->handle = VersionElems_HandleBeg;
	Texts_new = (Texts_Elem)e;
}

void VersionElems_AllocEnd (void)
{
	VersionElems_End e = NIL;
	__NEW(e, VersionElems_EndDesc);
	e->handle = VersionElems_HandleEnd;
	Texts_new = (Texts_Elem)e;
}

void VersionElems_Insert (void)
{
	VersionElems_Beg a = NIL;
	VersionElems_End b = NIL;
	Texts_Text t = NIL;
	LONGINT beg = 0, end = 0, time = 0;
	CHAR version[32];
	Oberon_GetSelection(&t, &beg, &end, &time);
	if (time >= 0) {
		In_Open();
		VersionElems_Read((void*)version, 32);
		if (In_Done) {
			__NEW(a, VersionElems_BegDesc);
			a->W = 70000;
			a->H = 110000;
			a->handle = VersionElems_HandleBeg;
			__COPY(version, a->cur, 32);
			a->vers[0][0] = 0x00;
			a->menu = TextFrames_Text((CHAR*)"", (LONGINT)1);
			Texts_WriteString(&VersionElems_w, Texts_Writer__typ, version, 32);
			Texts_Append(a->menu, VersionElems_w.buf);
			PopupElems_MeasureMenu((void*)a);
			Texts_WriteElem(&VersionElems_w, Texts_Writer__typ, (void*)a);
			Texts_Insert(t, beg, VersionElems_w.buf);
			__NEW(b, VersionElems_EndDesc);
			b->W = 70000;
			b->H = 110000;
			b->handle = VersionElems_HandleEnd;
			Texts_WriteElem(&VersionElems_w, Texts_Writer__typ, (void*)b);
			Texts_Insert(t, end + 1, VersionElems_w.buf);
			VersionElems_SwitchAll(t, version, 32);
		} else {
			Out_String((CHAR*)"-- invalid version name", (LONGINT)24);
			Out_Ln();
		}
	} else {
		Out_String((CHAR*)"-- no selection", (LONGINT)16);
		Out_Ln();
	}
}

void VersionElems_Set (void)
{
	VersionElems_Do(VersionElems_SwitchAll);
}

void VersionElems_Delete (void)
{
	VersionElems_Do(VersionElems_Del);
}

static void EnumPtrs(void (*P)(void*))
{
	P(VersionElems_scratch);
	__ENUMR(&VersionElems_w, Texts_Writer__typ, 36, 1, P);
}

__TDESC(VersionElems_BegDesc, 5, 9) = {__TDFLDS("BegDesc", 264), {0, 4, 12, 32, 68, 248, 252, 256, 260, -40}};
__TDESC(VersionElems_EndDesc, 1, 4) = {__TDFLDS("EndDesc", 36), {0, 4, 12, 32, -20}};

export void *VersionElems__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Files);
	__IMPORT(FoldElems);
	__IMPORT(In);
	__IMPORT(Input);
	__IMPORT(Oberon);
	__IMPORT(Out);
	__IMPORT(PopupElems);
	__IMPORT(TextFrames);
	__IMPORT(TextPrinter);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMOD(VersionElems, EnumPtrs);
	__REGCMD("AllocBeg", VersionElems_AllocBeg);
	__REGCMD("AllocEnd", VersionElems_AllocEnd);
	__REGCMD("Delete", VersionElems_Delete);
	__REGCMD("Insert", VersionElems_Insert);
	__REGCMD("Set", VersionElems_Set);
	__INITYP(VersionElems_BegDesc, PopupElems_ElemDesc, 3);
	__INITBP(VersionElems_BegDesc, VersionElems_Beg_CheckMenu, 0);
	__INITBP(VersionElems_BegDesc, VersionElems_Beg_IndexOf, 1);
	__INITBP(VersionElems_BegDesc, VersionElems_Beg_SwitchTo, 2);
	__INITBP(VersionElems_BegDesc, VersionElems_Beg_TwinPos, 3);
	__INITYP(VersionElems_EndDesc, Texts_ElemDesc, 2);
/* BEGIN */
	VersionElems_InitIcons();
	Texts_OpenWriter(&VersionElems_w, Texts_Writer__typ);
	__NEW(VersionElems_scratch, Texts_TextDesc);
	Texts_Open(VersionElems_scratch, (CHAR*)"", (LONGINT)1);
	VersionElems_scratch->notify = VersionElems_NoNotify;
	__ENDMOD;
}
