/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Unix.h"

typedef
	void (*WiringPi_InterruptHandler)(void);

typedef
	LONGINT (*WiringPi_ThreadHandler)(LONGINT);


export CHAR (*(*WiringPi_piModelNames)[16])[256], (*(*WiringPi_piRevisionNames)[16])[256], (*(*WiringPi_piMakerNames)[16])[256];
export LONGINT (*WiringPi_piMemorySize)[8];
export LONGINT WiringPi_errno;
static BOOLEAN WiringPi_setupDone;


export LONGINT WiringPi_AnalogRead (LONGINT pin);
export void WiringPi_AnalogWrite (LONGINT pin, LONGINT value);
export void WiringPi_Delay (LONGINT howLong);
export void WiringPi_DelayMicroseconds (LONGINT howLong);
export LONGINT WiringPi_DigitalRead (LONGINT pin);
export LONGINT WiringPi_DigitalReadByte (void);
export void WiringPi_DigitalWrite (LONGINT pin, LONGINT value);
export void WiringPi_DigitalWriteByte (LONGINT value);
export LONGINT WiringPi_GetAlt (LONGINT pin);
export void WiringPi_GpioClockSet (LONGINT pin, LONGINT freq);
export LONGINT WiringPi_I2CRead (LONGINT fd);
export LONGINT WiringPi_I2CReadReg16 (LONGINT fd, LONGINT reg);
export INTEGER WiringPi_I2CReadReg8 (LONGINT fd, LONGINT reg);
export INTEGER WiringPi_I2CSetup (LONGINT devId);
export LONGINT WiringPi_I2CSetupInterface (CHAR *device, LONGINT device__len, LONGINT devId);
export LONGINT WiringPi_I2CWrite (LONGINT fd, LONGINT data);
export LONGINT WiringPi_I2CWriteReg16 (LONGINT fd, LONGINT reg, LONGINT data);
export LONGINT WiringPi_I2CWriteReg8 (LONGINT fd, LONGINT reg, LONGINT data);
export LONGINT WiringPi_ISR (LONGINT pin, LONGINT mode, WiringPi_InterruptHandler function);
export LONGINT WiringPi_Micros (void);
export LONGINT WiringPi_Millis (void);
export LONGINT WiringPi_PhysPinToGpio (LONGINT physPin);
export void WiringPi_PiBoardId (LONGINT *model, LONGINT *rev, LONGINT *mem, LONGINT *maker, LONGINT *overVolted);
export LONGINT WiringPi_PiBoardRev (void);
export LONGINT WiringPi_PiHiPri (LONGINT pri);
export void WiringPi_PiLock (LONGINT key);
export LONGINT WiringPi_PiThreadCreate (WiringPi_ThreadHandler fn);
export void WiringPi_PiUnlock (LONGINT key);
export void WiringPi_PinMode (LONGINT pin, LONGINT mode);
export void WiringPi_PinModeAlt (LONGINT pin, LONGINT mode);
export LONGINT WiringPi_PinToGpio (LONGINT wpiPin);
export void WiringPi_PullUpDnControl (LONGINT pin, LONGINT pud);
export void WiringPi_PwmSetClock (LONGINT divisor);
export void WiringPi_PwmSetMode (LONGINT mode);
export void WiringPi_PwmSetRange (LONGINT range);
export void WiringPi_PwmToneWrite (LONGINT pin, LONGINT freq);
export void WiringPi_PwmWrite (LONGINT pin, LONGINT value);
export LONGINT WiringPi_SPIDataRW (LONGINT channel, CHAR *data, LONGINT data__len, LONGINT len);
export INTEGER WiringPi_SPIGetFd (LONGINT channel);
export INTEGER WiringPi_SPISetup (LONGINT channel, LONGINT speed);
export LONGINT WiringPi_SPISetupMode (LONGINT channel, LONGINT speed, LONGINT mode);
export void WiringPi_SerialClose (LONGINT fd);
export LONGINT WiringPi_SerialDataAvail (LONGINT fd);
export void WiringPi_SerialFlush (LONGINT fd);
export INTEGER WiringPi_SerialGetchar (LONGINT fd);
export INTEGER WiringPi_SerialOpen (CHAR *device, LONGINT device__len, LONGINT baud);
export void WiringPi_SerialPrintf (LONGINT fd, CHAR *message, LONGINT message__len, LONGINT p1, LONGINT p2, LONGINT p3);
export void WiringPi_SerialPutchar (LONGINT fd, CHAR c);
export void WiringPi_SerialPuts (LONGINT fd, CHAR *s, LONGINT s__len);
export void WiringPi_SetPadDrive (LONGINT group, LONGINT value);
export void WiringPi_Setup (void);
export void WiringPi_SetupGpio (void);
export void WiringPi_SetupPhys (void);
export void WiringPi_SetupSys (void);
export INTEGER WiringPi_ShiftIn (LONGINT dPin, LONGINT cPin, LONGINT order);
export void WiringPi_ShiftOut (LONGINT dPin, LONGINT cPin, LONGINT order, LONGINT val);
export void WiringPi_UseErrorCodesOff (void);
export void WiringPi_UseErrorCodesOn (void);
export LONGINT WiringPi_WaitForInterrupt (LONGINT pin, LONGINT mS);

#define WiringPi_analogRead(pin)	analogRead(pin)
#define WiringPi_analogWrite(pin, value)	analogWrite(pin, value)
#define WiringPi_delay(howLong)	delay(howLong)
#define WiringPi_delayMicroseconds(howLong)	delayMicroseconds(howLong)
#define WiringPi_digitalRead(pin)	digitalRead(pin)
#define WiringPi_digitalReadByte()	digitalReadByte()
#define WiringPi_digitalWrite(pin, value)	digitalWrite(pin, value)
#define WiringPi_digitalWriteByte(value)	digitalWriteByte(value)
#define WiringPi_getAlt(pin)	getAlt(pin)
#define WiringPi_gpioClockSet(pin, freq)	gpioClockSet(pin, freq)
#include <wiringPi.h>
#include <wiringPiI2C.h>
#include <wiringPiSPI.h>
#include <wiringSerial.h>
#include <wiringShift.h>
#define WiringPi_isr(pin, mode, function)	(LONGINT)wiringPiISR(pin, mode, function)
#define WiringPi_micros()	micros()
#define WiringPi_millis()	millis()
#define WiringPi_physPinToGpio(physPin)	physPinToGpio(physPin)
#define WiringPi_piBoardId(model, rev, mem, maker, overVolted)	piBoardId((int*)model, (int*)rev, (int*)mem, (int*)maker, (int*)overVolted)
#define WiringPi_piBoardRev()	piBoardRev()
#define WiringPi_piHiPri(pri)	(LONGINT)piHiPri(pri)
#define WiringPi_piLock(key)	piLock(key)
#define WiringPi_piThreadCreate(fn)	(LONGINT)piThreadCreate((void *(*)(void *))fn)
#define WiringPi_piUnlock(key)	piUnlock(key)
#define WiringPi_pinMode(pin, mode)	pinMode(pin, mode)
#define WiringPi_pinModeAlt(pin, mode)	pinModeAlt(pin, mode)
#define WiringPi_pullUpDnControl(pin, pud)	pullUpDnControl(pin, pud)
#define WiringPi_pwmSetClock(divisor)	pwmSetClock(divisor)
#define WiringPi_pwmSetMode(mode)	pwmSetMode(mode)
#define WiringPi_pwmSetRange(range)	pwmSetRange(range)
#define WiringPi_pwmToneWrite(pin, freq)	pwmToneWrite(pin, freq)
#define WiringPi_pwmWrite(pin, value)	pwmWrite(pin, value)
#define WiringPi_serialClose(fd)	serialClose((const int)fd)
#define WiringPi_serialDataAvail(fd)	(LONGINT)serialDataAvail((const int)fd)
#define WiringPi_serialFlush(fd)	serialFlush((const int)fd)
#define WiringPi_serialGetchar(fd)	(INTEGER)serialGetchar((const int)fd)
#define WiringPi_serialOpen(device, device__len, baud)	(INTEGER)serialOpen((const char *)device, (const int)baud)
#define WiringPi_serialPrintf(fd, message, message__len, p1, p2, p3)	serialPrintf((const int)fd, (const char *)message, p1, p2, p3)
#define WiringPi_serialPutchar(fd, c)	serialPutchar((const int)fd, (const unsigned char)c)
#define WiringPi_serialPuts(fd, s, s__len)	serialPuts((const int)fd, (const char *)s)
#define WiringPi_setPadDrive(group, value)	setPadDrive(group, value)
#define WiringPi_setenv(name, name__len, value, value__len, overwrite)	(LONGINT)setenv((const char*)name, (const char*)value, overwrite);
#define WiringPi_setupVars()	*(void**)&WiringPi_piModelNames = (void*)piModelNames; *(void**)&WiringPi_piRevisionNames = (void*)piRevisionNames; *(void**)&WiringPi_piMakerNames = (void*)piMakerNames; *(void**)&WiringPi_piMemorySize = (void*)piMemorySize
#define WiringPi_shiftIn(dPin, cPin, order)	(INTEGER)shiftIn((uint8_t)dPin, (uint8_t)cPin, (uint8_t)order)
#define WiringPi_shiftOut(dPin, cPin, order, val)	shiftOut((uint8_t)dPin, (uint8_t)cPin, (uint8_t)order, (uint8_t)val)
#define WiringPi_unsetenv(name, name__len)	(LONGINT)unsetenv((const char*)name);
#define WiringPi_waitForInterrupt(pin, mS)	waitForInterrupt(pin, mS)
#define WiringPi_wiringPiI2CRead(fd)	(LONGINT)wiringPiI2CRead(fd)
#define WiringPi_wiringPiI2CReadReg16(fd, reg)	(LONGINT)wiringPiI2CReadReg16(fd, reg)
#define WiringPi_wiringPiI2CReadReg8(fd, reg)	(INTEGER)wiringPiI2CReadReg8(fd, reg)
#define WiringPi_wiringPiI2CSetup(devId)	(INTEGER)wiringPiI2CSetup(devId)
#define WiringPi_wiringPiI2CSetupInterface(device, device__len, devId)	(INTEGER)wiringPiI2CSetupInterface((const char *)device, devId)
#define WiringPi_wiringPiI2CWrite(fd, data)	(LONGINT)wiringPiI2CWrite(fd, data)
#define WiringPi_wiringPiI2CWriteReg16(fd, reg, data)	(LONGINT)wiringPiI2CWriteReg16(fd, reg, data)
#define WiringPi_wiringPiI2CWriteReg8(fd, reg, data)	(LONGINT)wiringPiI2CWriteReg8(fd, reg, data)
#define WiringPi_wiringPiSPIDataRW(channel, data, data__len, len)	wiringPiSPIDataRW(channel, data, len)
#define WiringPi_wiringPiSPIGetFd(channel)	(INTEGER)wiringPiSPIGetFd(channel)
#define WiringPi_wiringPiSPISetup(channel, speed)	(INTEGER)wiringPiSPISetup(channel, speed)
#define WiringPi_wiringPiSPISetupMode(channel, speed, mode)	wiringPiSPISetupMode(channel, speed, mode)
#define WiringPi_wiringPiSetup()	(LONGINT)wiringPiSetup()
#define WiringPi_wiringPiSetupGpio()	(LONGINT)wiringPiSetupGpio()
#define WiringPi_wiringPiSetupPhys()	(LONGINT)wiringPiSetupPhys()
#define WiringPi_wiringPiSetupSys()	(LONGINT)wiringPiSetupSys()
#define WiringPi_wpiPinToGpio(wpiPin)	wpiPinToGpio(wpiPin)

void WiringPi_UseErrorCodesOn (void)
{
	LONGINT res = 0;
	res = WiringPi_setenv((CHAR*)"WIRINGPI_CODES", (LONGINT)15, (CHAR*)"1", (LONGINT)2, 1);
	if (res != 0) {
		__HALT(20);
	}
}

void WiringPi_UseErrorCodesOff (void)
{
	LONGINT res = 0;
	res = WiringPi_unsetenv((CHAR*)"WIRINGPI_CODES", (LONGINT)15);
	if (res != 0) {
		__HALT(20);
	}
}

void WiringPi_Setup (void)
{
	LONGINT res = 0;
	if (!WiringPi_setupDone) {
		res = WiringPi_wiringPiSetup();
		if (res == 0) {
			WiringPi_setupDone = 1;
		} else {
			WiringPi_errno = Unix_errno();
			__HALT(22);
		}
	} else {
		__HALT(21);
	}
}

void WiringPi_SetupGpio (void)
{
	LONGINT res = 0;
	if (!WiringPi_setupDone) {
		res = WiringPi_wiringPiSetupGpio();
		if (res == 0) {
			WiringPi_setupDone = 1;
		} else {
			WiringPi_errno = Unix_errno();
			__HALT(22);
		}
	} else {
		__HALT(21);
	}
}

void WiringPi_SetupPhys (void)
{
	LONGINT res = 0;
	if (!WiringPi_setupDone) {
		res = WiringPi_wiringPiSetupPhys();
		if (res == 0) {
			WiringPi_setupDone = 1;
		} else {
			WiringPi_errno = Unix_errno();
			__HALT(22);
		}
	} else {
		__HALT(21);
	}
}

void WiringPi_SetupSys (void)
{
	LONGINT res = 0;
	if (!WiringPi_setupDone) {
		res = WiringPi_wiringPiSetupSys();
		if (res == 0) {
			WiringPi_setupDone = 1;
		} else {
			WiringPi_errno = Unix_errno();
			__HALT(22);
		}
	} else {
		__HALT(21);
	}
}

void WiringPi_PinModeAlt (LONGINT pin, LONGINT mode)
{
	WiringPi_pinModeAlt(pin, mode);
}

void WiringPi_PinMode (LONGINT pin, LONGINT mode)
{
	WiringPi_pinMode(pin, mode);
}

void WiringPi_PullUpDnControl (LONGINT pin, LONGINT pud)
{
	WiringPi_pullUpDnControl(pin, pud);
}

LONGINT WiringPi_DigitalRead (LONGINT pin)
{
	return WiringPi_digitalRead(pin);
}

void WiringPi_DigitalWrite (LONGINT pin, LONGINT value)
{
	WiringPi_digitalWrite(pin, value);
}

void WiringPi_PwmWrite (LONGINT pin, LONGINT value)
{
	WiringPi_pwmWrite(pin, value);
}

LONGINT WiringPi_AnalogRead (LONGINT pin)
{
	return WiringPi_analogRead(pin);
}

void WiringPi_AnalogWrite (LONGINT pin, LONGINT value)
{
	WiringPi_analogWrite(pin, value);
}

LONGINT WiringPi_PiBoardRev (void)
{
	return WiringPi_piBoardRev();
}

void WiringPi_PiBoardId (LONGINT *model, LONGINT *rev, LONGINT *mem, LONGINT *maker, LONGINT *overVolted)
{
	WiringPi_piBoardId(&*model, &*rev, &*mem, &*maker, &*overVolted);
}

LONGINT WiringPi_PinToGpio (LONGINT wpiPin)
{
	return WiringPi_wpiPinToGpio(wpiPin);
}

LONGINT WiringPi_PhysPinToGpio (LONGINT physPin)
{
	return WiringPi_physPinToGpio(physPin);
}

void WiringPi_SetPadDrive (LONGINT group, LONGINT value)
{
	WiringPi_setPadDrive(group, value);
}

LONGINT WiringPi_GetAlt (LONGINT pin)
{
	return WiringPi_getAlt(pin);
}

void WiringPi_PwmToneWrite (LONGINT pin, LONGINT freq)
{
	WiringPi_pwmToneWrite(pin, freq);
}

void WiringPi_DigitalWriteByte (LONGINT value)
{
	WiringPi_digitalWriteByte(value);
}

LONGINT WiringPi_DigitalReadByte (void)
{
	return WiringPi_digitalReadByte();
}

void WiringPi_PwmSetMode (LONGINT mode)
{
	WiringPi_pwmSetMode(mode);
}

void WiringPi_PwmSetRange (LONGINT range)
{
	WiringPi_pwmSetRange(range);
}

void WiringPi_PwmSetClock (LONGINT divisor)
{
	WiringPi_pwmSetClock(divisor);
}

void WiringPi_GpioClockSet (LONGINT pin, LONGINT freq)
{
	WiringPi_gpioClockSet(pin, freq);
}

LONGINT WiringPi_WaitForInterrupt (LONGINT pin, LONGINT mS)
{
	return WiringPi_waitForInterrupt(pin, mS);
}

LONGINT WiringPi_ISR (LONGINT pin, LONGINT mode, WiringPi_InterruptHandler function)
{
	return WiringPi_isr(pin, mode, function);
}

LONGINT WiringPi_PiThreadCreate (WiringPi_ThreadHandler fn)
{
	return WiringPi_piThreadCreate(fn);
}

void WiringPi_PiLock (LONGINT key)
{
	WiringPi_piLock(key);
}

void WiringPi_PiUnlock (LONGINT key)
{
	WiringPi_PiUnlock(key);
}

LONGINT WiringPi_PiHiPri (LONGINT pri)
{
	return WiringPi_piHiPri(pri);
}

void WiringPi_Delay (LONGINT howLong)
{
	WiringPi_delay(howLong);
}

void WiringPi_DelayMicroseconds (LONGINT howLong)
{
	WiringPi_delayMicroseconds(howLong);
}

LONGINT WiringPi_Millis (void)
{
	return WiringPi_millis();
}

LONGINT WiringPi_Micros (void)
{
	return WiringPi_micros();
}

INTEGER WiringPi_SerialOpen (CHAR *device, LONGINT device__len, LONGINT baud)
{
	return WiringPi_serialOpen(device, device__len, baud);
}

void WiringPi_SerialClose (LONGINT fd)
{
	WiringPi_serialClose(fd);
}

void WiringPi_SerialFlush (LONGINT fd)
{
	WiringPi_serialFlush(fd);
}

void WiringPi_SerialPutchar (LONGINT fd, CHAR c)
{
	WiringPi_serialPutchar(fd, c);
}

void WiringPi_SerialPuts (LONGINT fd, CHAR *s, LONGINT s__len)
{
	WiringPi_serialPuts(fd, s, s__len);
}

void WiringPi_SerialPrintf (LONGINT fd, CHAR *message, LONGINT message__len, LONGINT p1, LONGINT p2, LONGINT p3)
{
	WiringPi_serialPrintf(fd, message, message__len, p1, p2, p3);
}

LONGINT WiringPi_SerialDataAvail (LONGINT fd)
{
	return WiringPi_serialDataAvail(fd);
}

INTEGER WiringPi_SerialGetchar (LONGINT fd)
{
	return WiringPi_serialGetchar(fd);
}

INTEGER WiringPi_SPIGetFd (LONGINT channel)
{
	return WiringPi_wiringPiSPIGetFd(channel);
}

LONGINT WiringPi_SPIDataRW (LONGINT channel, CHAR *data, LONGINT data__len, LONGINT len)
{
	return WiringPi_wiringPiSPIDataRW(channel, data, data__len, len);
}

LONGINT WiringPi_SPISetupMode (LONGINT channel, LONGINT speed, LONGINT mode)
{
	return WiringPi_wiringPiSPISetupMode(channel, speed, mode);
}

INTEGER WiringPi_SPISetup (LONGINT channel, LONGINT speed)
{
	return WiringPi_wiringPiSPISetup(channel, speed);
}

LONGINT WiringPi_I2CRead (LONGINT fd)
{
	return WiringPi_wiringPiI2CRead(fd);
}

INTEGER WiringPi_I2CReadReg8 (LONGINT fd, LONGINT reg)
{
	return WiringPi_wiringPiI2CReadReg8(fd, reg);
}

LONGINT WiringPi_I2CReadReg16 (LONGINT fd, LONGINT reg)
{
	return WiringPi_wiringPiI2CReadReg16(fd, reg);
}

LONGINT WiringPi_I2CWrite (LONGINT fd, LONGINT data)
{
	return WiringPi_wiringPiI2CWrite(fd, data);
}

LONGINT WiringPi_I2CWriteReg8 (LONGINT fd, LONGINT reg, LONGINT data)
{
	return WiringPi_wiringPiI2CWriteReg8(fd, reg, data);
}

LONGINT WiringPi_I2CWriteReg16 (LONGINT fd, LONGINT reg, LONGINT data)
{
	return WiringPi_wiringPiI2CWriteReg16(fd, reg, data);
}

LONGINT WiringPi_I2CSetupInterface (CHAR *device, LONGINT device__len, LONGINT devId)
{
	return WiringPi_wiringPiI2CSetupInterface(device, device__len, devId);
}

INTEGER WiringPi_I2CSetup (LONGINT devId)
{
	return WiringPi_wiringPiI2CSetup(devId);
}

INTEGER WiringPi_ShiftIn (LONGINT dPin, LONGINT cPin, LONGINT order)
{
	return WiringPi_shiftIn(dPin, cPin, order);
}

void WiringPi_ShiftOut (LONGINT dPin, LONGINT cPin, LONGINT order, LONGINT val)
{
	WiringPi_shiftOut(dPin, cPin, order, val);
}


export void *WiringPi__init(void)
{
	__DEFMOD;
	__IMPORT(Unix);
	__REGMOD(WiringPi, 0);
	__REGCMD("Setup", WiringPi_Setup);
	__REGCMD("SetupGpio", WiringPi_SetupGpio);
	__REGCMD("SetupPhys", WiringPi_SetupPhys);
	__REGCMD("SetupSys", WiringPi_SetupSys);
	__REGCMD("UseErrorCodesOff", WiringPi_UseErrorCodesOff);
	__REGCMD("UseErrorCodesOn", WiringPi_UseErrorCodesOn);
/* BEGIN */
	WiringPi_setupVars();
	__ENDMOD;
}
