/* Ofront 1.4 -xtspkaG */

#ifndef WiringPi__h
#define WiringPi__h

#include "SYSTEM.h"

typedef
	void (*WiringPi_InterruptHandler)(void);

typedef
	LONGINT (*WiringPi_ThreadHandler)(LONGINT);


import CHAR (*(*WiringPi_piModelNames)[16])[256], (*(*WiringPi_piRevisionNames)[16])[256], (*(*WiringPi_piMakerNames)[16])[256];
import LONGINT (*WiringPi_piMemorySize)[8];
import LONGINT WiringPi_errno;


import LONGINT WiringPi_AnalogRead (LONGINT pin);
import void WiringPi_AnalogWrite (LONGINT pin, LONGINT value);
import void WiringPi_Delay (LONGINT howLong);
import void WiringPi_DelayMicroseconds (LONGINT howLong);
import LONGINT WiringPi_DigitalRead (LONGINT pin);
import LONGINT WiringPi_DigitalReadByte (void);
import void WiringPi_DigitalWrite (LONGINT pin, LONGINT value);
import void WiringPi_DigitalWriteByte (LONGINT value);
import LONGINT WiringPi_GetAlt (LONGINT pin);
import void WiringPi_GpioClockSet (LONGINT pin, LONGINT freq);
import LONGINT WiringPi_I2CRead (LONGINT fd);
import LONGINT WiringPi_I2CReadReg16 (LONGINT fd, LONGINT reg);
import INTEGER WiringPi_I2CReadReg8 (LONGINT fd, LONGINT reg);
import INTEGER WiringPi_I2CSetup (LONGINT devId);
import LONGINT WiringPi_I2CSetupInterface (CHAR *device, LONGINT device__len, LONGINT devId);
import LONGINT WiringPi_I2CWrite (LONGINT fd, LONGINT data);
import LONGINT WiringPi_I2CWriteReg16 (LONGINT fd, LONGINT reg, LONGINT data);
import LONGINT WiringPi_I2CWriteReg8 (LONGINT fd, LONGINT reg, LONGINT data);
import LONGINT WiringPi_ISR (LONGINT pin, LONGINT mode, WiringPi_InterruptHandler function);
import LONGINT WiringPi_Micros (void);
import LONGINT WiringPi_Millis (void);
import LONGINT WiringPi_PhysPinToGpio (LONGINT physPin);
import void WiringPi_PiBoardId (LONGINT *model, LONGINT *rev, LONGINT *mem, LONGINT *maker, LONGINT *overVolted);
import LONGINT WiringPi_PiBoardRev (void);
import LONGINT WiringPi_PiHiPri (LONGINT pri);
import void WiringPi_PiLock (LONGINT key);
import LONGINT WiringPi_PiThreadCreate (WiringPi_ThreadHandler fn);
import void WiringPi_PiUnlock (LONGINT key);
import void WiringPi_PinMode (LONGINT pin, LONGINT mode);
import void WiringPi_PinModeAlt (LONGINT pin, LONGINT mode);
import LONGINT WiringPi_PinToGpio (LONGINT wpiPin);
import void WiringPi_PullUpDnControl (LONGINT pin, LONGINT pud);
import void WiringPi_PwmSetClock (LONGINT divisor);
import void WiringPi_PwmSetMode (LONGINT mode);
import void WiringPi_PwmSetRange (LONGINT range);
import void WiringPi_PwmToneWrite (LONGINT pin, LONGINT freq);
import void WiringPi_PwmWrite (LONGINT pin, LONGINT value);
import LONGINT WiringPi_SPIDataRW (LONGINT channel, CHAR *data, LONGINT data__len, LONGINT len);
import INTEGER WiringPi_SPIGetFd (LONGINT channel);
import INTEGER WiringPi_SPISetup (LONGINT channel, LONGINT speed);
import LONGINT WiringPi_SPISetupMode (LONGINT channel, LONGINT speed, LONGINT mode);
import void WiringPi_SerialClose (LONGINT fd);
import LONGINT WiringPi_SerialDataAvail (LONGINT fd);
import void WiringPi_SerialFlush (LONGINT fd);
import INTEGER WiringPi_SerialGetchar (LONGINT fd);
import INTEGER WiringPi_SerialOpen (CHAR *device, LONGINT device__len, LONGINT baud);
import void WiringPi_SerialPrintf (LONGINT fd, CHAR *message, LONGINT message__len, LONGINT p1, LONGINT p2, LONGINT p3);
import void WiringPi_SerialPutchar (LONGINT fd, CHAR c);
import void WiringPi_SerialPuts (LONGINT fd, CHAR *s, LONGINT s__len);
import void WiringPi_SetPadDrive (LONGINT group, LONGINT value);
import void WiringPi_Setup (void);
import void WiringPi_SetupGpio (void);
import void WiringPi_SetupPhys (void);
import void WiringPi_SetupSys (void);
import INTEGER WiringPi_ShiftIn (LONGINT dPin, LONGINT cPin, LONGINT order);
import void WiringPi_ShiftOut (LONGINT dPin, LONGINT cPin, LONGINT order, LONGINT val);
import void WiringPi_UseErrorCodesOff (void);
import void WiringPi_UseErrorCodesOn (void);
import LONGINT WiringPi_WaitForInterrupt (LONGINT pin, LONGINT mS);
import void *WiringPi__init(void);


#endif
