/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "FKeys.h"
#include "MenuViewers.h"
#include "Modules.h"
#include "Oberon.h"
#include "Out.h"
#include "System.h"
#include "TextFrames.h"
#include "Texts.h"
#include "Viewers.h"


static LONGINT oberon_pinPos;


static void oberon_HandleLog (Display_Frame F, Display_FrameMsg *M, LONGINT *M__typ);
export void oberon_Init (void);
export void oberon_PinLog (void);


void oberon_PinLog (void)
{
	oberon_pinPos = Oberon_Log->len;
}

static void oberon_HandleLog (Display_Frame F, Display_FrameMsg *M, LONGINT *M__typ)
{
	CHAR ch = 0;
	Texts_Reader R = {0};
	LONGINT org = 0;
	TextFrames_Handle(F, &*M, M__typ);
	if (__IS(M__typ, TextFrames_UpdateMsg, 1)) {
		if (__IS(M__typ, TextFrames_UpdateMsg, 1)) {
			TextFrames_UpdateMsg *M__ = (void*)M;
			if (((*M__).text == Oberon_Log && (*M__).id == 1) && (*M__).beg > 0) {
				Texts_OpenReader(&R, Texts_Reader__typ, Oberon_Log, (*M__).beg - 1);
				Texts_Read(&R, Texts_Reader__typ, &ch);
				if (ch == 0x0d) {
					if (__ISP(F, TextFrames_FrameDesc, 1)) {
						if ((*M__).beg > TextFrames_Pos((*(TextFrames_Frame*)&F), (*(TextFrames_Frame*)&F)->X + (*(TextFrames_Frame*)&F)->W, (*(TextFrames_Frame*)&F)->Y) + 1) {
							org = (*M__).beg - 200;
							if (org < 0) {
								org = 0;
							}
						} else {
							org = (*(TextFrames_Frame*)&F)->org;
						}
						while ((org < oberon_pinPos && org < (*M__).beg) && TextFrames_Pos((*(TextFrames_Frame*)&F), (*(TextFrames_Frame*)&F)->X + (*(TextFrames_Frame*)&F)->W, (*(TextFrames_Frame*)&F)->Y) < (*M__).end - 1) {
							Texts_OpenReader(&R, Texts_Reader__typ, (*(TextFrames_Frame*)&F)->text, org);
							do {
								Texts_Read(&R, Texts_Reader__typ, &ch);
							} while (!(R.eot || ch == 0x0d));
							org = Texts_Pos(&R, Texts_Reader__typ);
							TextFrames_Show((*(TextFrames_Frame*)&F), org);
						}
					} else __WITHCHK;
				}
			}
		} else __WITHCHK;
	}
}

void oberon_Init (void)
{
	Viewers_Viewer logV = NIL, toolV = NIL;
	INTEGER X = 0, Y = 0;
	Oberon_Task logger = NIL;
	Modules_Module startup = NIL;
	Oberon_OpenDisplay(__ASHR(Display_Width, 3) * 5, __ASHR(Display_Width, 3) * 3, Display_Height);
	Oberon_FocusViewer = Viewers_This(0, 0);
	Oberon_AllocateSystemViewer(0, &X, &Y);
	logV = (Viewers_Viewer)MenuViewers_New((void*)TextFrames_NewMenu((CHAR*)"System.Log", (LONGINT)11, (CHAR*)"^Log.Menu.Text", (LONGINT)15), (void*)TextFrames_NewText(Oberon_Log, 0), TextFrames_menuH, X, Y);
	logV->dsc->next->handle = oberon_HandleLog;
	Oberon_AllocateSystemViewer(0, &X, &Y);
	toolV = (Viewers_Viewer)MenuViewers_New((void*)TextFrames_NewMenu((CHAR*)"System.Tool", (LONGINT)12, (CHAR*)"^System.Menu.Text", (LONGINT)18), (void*)TextFrames_NewText(TextFrames_Text((CHAR*)"System.Tool", (LONGINT)12), 0), TextFrames_menuH, X, Y + 50);
	__NEW(logger, Oberon_TaskDesc);
	logger->safe = 0;
	logger->time = -1;
	logger->handle = oberon_PinLog;
	Oberon_Install(logger);
	FKeys_Set(12, FKeys_InternationalKey);
	FKeys_Set(10, FKeys_InternationalKey);
	Out_String((CHAR*)"Ofront 1.4, Oberon V4", (LONGINT)22);
	Out_Ln();
	startup = Modules_ThisMod((CHAR*)"OberonStartup", (LONGINT)14);
	Oberon_Loop();
}


int main(int argc, char **argv)
{
	__INIT(argc, argv);
	__IMPORT(Display);
	__IMPORT(FKeys);
	__IMPORT(MenuViewers);
	__IMPORT(Modules);
	__IMPORT(Oberon);
	__IMPORT(Out);
	__IMPORT(System);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__IMPORT(Viewers);
	__REGMAIN(oberon, 0);
	__REGCMD("Init", oberon_Init);
	__REGCMD("PinLog", oberon_PinLog);
/* BEGIN */
	oberon_Init();
	__FINI;
}
